local IM = CppEnums.EProcessorInputMode
local VCK = CppEnums.VirtualKeyCode
local UI_ANI_ADV = CppEnums.PAUI_ANIM_ADVANCE_TYPE

local isClickControlKey = 0		--	controlKey 관련

--  esc 눌렀을 경우 패널이 사라져야 하는 패널을 등록해 주는 부분
local panel_WindowList =
{
	Panel_Window_ServantInfo,
	Panel_PartyOption,			
	Panel_Alchemy,									
	Panel_Window_StableFunction,
	Panel_Window_StableList,			-- 5
	Panel_Window_StableInfo,
	Panel_Window_StableEquipInfo,
	Panel_Window_StableShop,						
	Panel_Window_StableMating,
	Panel_Window_StableRegister,		-- 10
	Panel_Servant_Market_Input,
	Panel_Window_WharfFunction,
	Panel_Window_WharfList,
	Panel_Window_WharfInfo,							
	Panel_Window_WharfRegister,			-- 15
	Panel_Window_Exchange_Number,
	Panel_Win_System,
	Panel_Window_Delivery_Request,
	Panel_Window_Delivery_Information,
	Panel_Window_Delivery_CarriageInformation,	-- 20
	Panel_Window_Guild,
	Panel_Mail_Detail,
	Panel_Mail_Send,
	Panel_CreateClan,
	Panel_IntroMovie,							-- 25
	Panel_Window_Repair,
	Panel_Scroll,
	Panel_SkillAwaken,
	Panel_Popup_MoveItem,
	Panel_LordMenu,								-- 30
	Panel_CarriageInfo,
	Panel_FixEquip,
	Panel_Dialogue_Itemtake,
	Panel_CreateGuild,
	Panel_EnableSkill,							-- 35
	Panel_HelpMessage,
	Panel_WebControl,								
	Panel_Window_Quest_New,							
	-- Panel_Dye,
	-- Panel_Npc_Quest_Reward,						-- 40
	Panel_ChatOption,
	Panel_Interaction_HouseRank,                   
	Panel_ColorBalance,								
	Panel_CheckedQuestInfo,
	Panel_ProductNote, 							-- 45
	Panel_Window_Quest_History,
	Panel_Tooltip_Common, 							
	Panel_ShipInfo,
	Panel_Window_PetListNew,
	Panel_Window_PetInfoNew,					-- 50
	Panel_AgreementGuild,
	Panel_AgreementGuild_Master,
	Panel_Housing_FarmInfo_New,
	Panel_Window_ItemMarket,
	Panel_Window_ItemMarket_ItemSet,			-- 55
	Panel_ClanList,
	Panel_CarveSeal,
	Panel_ResetSeal,
	Panel_ClearVested,
	Panel_Window_CharInfo_Status,				-- 60
	Panel_Chatting_Input,
	Panel_Window_GameTips,
	Panel_Window_SkillGuide,
	Panel_MovieTheater_320,
	Panel_MovieTheater_640,						-- 65
	Panel_MovieTheater_SkillGuide_640,
	Panel_Menu,
	Panel_QuestInfo,
	Panel_MovieGuide,
	Panel_Window_PetRegister,					-- 70
	Panel_FishEncyclopedia,
	Panel_Tooltip_Item_chattingLinkedItem,
	Panel_Window_ItemMarket_BuyConfirm,
	Panel_Tooltip_SimpleText,
	Panel_EventNotify,
}

if( false == UseNewWorldMap ) then
	panel_WindowList.Panel_Win_Worldmap = nil
end

local panel_SoundedWindowList =
{
	Panel_Window_Inventory,
	Panel_Equipment,
	Panel_Window_Skill,
	Panel_Window_Enchant,				-- 5
	-- Panel_Looting,
	Panel_Window_ServantInventory,	
	Panel_Window_Warehouse,
	--Panel_Inn,
	Panel_Mail_Main,					-- 9
	Panel_Window_Option,
	Panel_Manufacture,
	Panel_Window_Socket,
	Panel_FriendList,
	Panel_Housing_SettingVendingMachine,-- 14
	Panel_Housing_VendingMachineList,
	Panel_Housing_SettingConsignmentSale,
	Panel_Housing_RegisterConsignmentSale,
	Panel_Housing_ConsignmentSale,
	Panel_SkillAwaken,					-- 19
	Panel_MyVendor_List,
	Panel_Challenge_Reward,
}

local panel_MinigameList =
{
	Panel_Minigame_Gradient,
	Panel_SinGauge,
	Panel_Command,
	Panel_RhythmGame,
	Panel_BattleGauge,
	Panel_FillGauge,
	Panel_MiniGame_Gradient_Y,
	Panel_MiniGame_Timing,
	Panel_MiniGame_Drag,
	Panel_MiniGame_PowerControl,
	Panel_RhythmGame_ForAction,
	Panel_MiniGame_Steal,
	Panel_MiniGame_PowerControl,
	Panel_MiniGame_Jaksal,
	Panel_RhythmGame_Drum,
}

local panel_ExceptionWindowList =
{
	Panel_Npc_Quest_Reward,
}

local _panelCloseAni = UIAni.closeAni

function check_ShowWindow()	
	local panel = nil
	for idx = 1, #panel_WindowList do
		panel = panel_WindowList[idx]

		if (nil == panel) then
			_PA_ASSERT(false, "GlobalUIManager WindowList에서 "..tostring(idx).."번째 Panel이 nil 입니다. 지워주세요")
		else
			if panel:IsShow() then		
				return true
			end
		end
	end
	
	for idx = 1, #panel_SoundedWindowList do
		panel = panel_SoundedWindowList[idx]

		if (nil == panel) then
			_PA_ASSERT(false, "GlobalUIManager SoundedWindowList에서 "..tostring(idx).."번째 Panel이 nil 입니다. 지워주세요")
		else
			if panel:IsShow() then		
				audioPostEvent_SystemUi(01,01)				
				return true
			end
		end
	end
	
	for idx = 1, #panel_ExceptionWindowList do
		panel = panel_ExceptionWindowList[idx]

		if (nil == panel) then
			_PA_ASSERT(false, "GlobalUIManager SoundedWindowList에서 "..tostring(idx).."번째 Panel이 nil 입니다. 지워주세요")
		else
			if panel:IsShow() then		
				audioPostEvent_SystemUi(01,01)				
				return true
			end
		end
	end
	
	return false
end

local Panel_LowLevelGuide_Value_IsCheckMoviePlay = Panel_LowLevelGuide_Value_IsCheckMoviePlay
isComboMovieClosedCount = 0		-- 스킬 연계 가이드 영상 전용 조건
function close_WindowPanelList()
	------------------------------------------------------------------
	-- 스킬 연계 가이드 영상 전용 조건들!!! 		
	-- !! 문제될 시 채효석 에게 문의해주세요 !! ※※※ 절대 지우면 안됨!! ※※※
	if ( Panel_MovieTheater_320:IsShow() == false ) then
		value_Panel_MovieTheater_320_IsCheckedShow = false
	end
	
	if ( value_Panel_MovieTheater_320_IsCheckedShow == true ) then
		isComboMovieClosedCount = isComboMovieClosedCount + 1
		if ( isComboMovieClosedCount >= 3 ) then
			Panel_MovieTheater320_MessageBox()
			Panel_MovieTheater_MessageBox:SetShow( true )
		else
			Panel_MovieTheater320_ResetMessageBox()
		end
	end
	------------------------------------------------------------------
	
	Panel_Tooltip_Item_hideTooltip()
	Panel_SkillTooltip_Hide()
	
	if Panel_IngameCashShop_GoodsTooltip:IsShow() then
		Panel_IngameCashShop_GoodsTooltip:SetShow( false )
	end

	Panel_Knowledge_Hide()
	
	if Panel_Window_Skill:IsShow() then
		if isFlushedUI() and getSelfPlayer():get():getLevel() < 6 then
			Proc_ShowMessage_Ack( "튜토리얼 진행 중에는 스킬 창을 임의로 닫을 수 없습니다." )
			return
		end
		SkillWindow_Close();
	end

	if Panel_Window_Exchange:IsShow() then
		Panel_ExchangePC_BtnClose_Mouse_Click()
	end

	-- 인벤토리는 닫기 전에 필터를 클리어 해줘야 한다!
	if Panel_Window_Inventory:IsShow() then
		InventoryWindow_Close()
	end
	
	if Panel_Window_Exchange_Number:IsShow() then
		Panel_NumberPad_Show( false, Defines.s64_const.s64_0, 0, nil);
	end

	if Panel_Window_Option:IsShow() then
		GameOption_Cancel()
		TooltipSimple_Hide()
	end

	if Panel_CarveSeal:IsShow() then
		FromClient_SealWindowHide()
	end

	--MessageBox
	messageBox_CloseButtonUp()

	if Panel_Looting:IsShow() == true then
		
	end
	
	if Panel_FriendList:IsShow() then
		FriendList_hide()
	end

	if Panel_Window_Quest_New:GetShow() then
		Panel_Window_QuestNew_Show( false )
	end

	if Panel_CheckedQuestInfo:GetShow() then
		FGlobal_QuestInfoDetail_ResetInfo()
		FGlobal_QuestInfoDetail_Close()
	end

	if Panel_IntroMovie:IsShow() then
		CloseIntroMovie()
		return true
	end	
	
	if Panel_Window_Delivery_Request:GetShow() then
		DeliveryRequestWindow_Close()
	end

	if Panel_Window_Guild:GetShow() then
		if Panel_AgreementGuild:GetShow() then
			if ( AllowChangeInputMode() ) then
				UI.Set_ProcessorInputMode(IM.eProcessorInputMode_UiMode) 
			else
				SetFocusChatting()
			end
			FGlobal_AgreementGuild_Close()
			return
		elseif Panel_AgreementGuild_Master:GetShow() then
			agreementGuild_Master_Close()
			return
		elseif Panel_GuildIncentive:GetShow() then
			FGlobal_GuildIncentive_Close()
			return
		end
		audioPostEvent_SystemUi(01,31)
		GuildManager:Hide()
	end

	if Panel_Window_GameTips:IsShow() then
		FGlobal_GameTipsHide()
	end

	if Panel_Window_PetInfoNew:IsShow() then
		TooltipSimple_Hide()
	end
	
	for _,loopPanel in ipairs(panel_WindowList) do		
		loopPanel:SetShow(false, false)
		--_panelCloseAni(loopPanel)
	end

	for _,loopPanel in ipairs(panel_SoundedWindowList) do
		loopPanel:SetShow(false, false)
		--_panelCloseAni(loopPanel)
	end

	if not Panel_Npc_Dialog:GetShow() then	
		for _,loopPanel in ipairs(panel_ExceptionWindowList) do
			loopPanel:SetShow(false, false)
		end
	end
	
	AcquireDirecteReShowUpdate()
	
	if( isFocusInChatting() ) then
		Panel_Chatting_Input:SetShow(true, false );
	end
	
	if ( Panel_LowLevelGuide_Value_IsCheckMoviePlay == 1 ) then
		FGlobal_Panel_LowLevelGuide_MovePlay_FindWay()
	elseif ( Panel_LowLevelGuide_Value_IsCheckMoviePlay == 2 ) then
		FGlobal_Panel_LowLevelGuide_MovePlay_LearnSkill()
	elseif ( Panel_LowLevelGuide_Value_IsCheckMoviePlay == 3 ) then
		FGlobal_Panel_LowLevelGuide_MovePlay_FindTarget()
	elseif ( Panel_LowLevelGuide_Value_IsCheckMoviePlay == 4 ) then
		FGlobal_Panel_LowLevelGuide_MovePlay_AcceptQuest()
	elseif ( Panel_LowLevelGuide_Value_IsCheckMoviePlay == 99 ) then
		FGlobal_Panel_LowLevelGuide_MovePlay_BlackSpirit()
	end
end

function close_WindowMinigamePanelList()
	for _,loopPanel in ipairs(panel_MinigameList) do
		loopPanel:SetShow(false, false)
	end
end
