Defines = {}

Defines.UIGroup =
{
	PAGameUIGroup_ScreenEffect		= 0,
	PAGameUIGroup_Widget			= 50,
	PAGameUIGroup_MainUI			= 100,
	PAGameUIGroup_MapRegion			= 200,
	PAGameUIGroup_SkillAndBuff		= 300,
	PAGameUIGroup_ProgressBar		= 400,
	PAGameUIGroup_CrossHair			= 500,
	PAGameUIGroup_CharacterAction	= 600,
	PAGameUIGroup_Party				= 700,
	PAGameUIGroup_Chatting			= 800,
	PAGameUIGroup_Quest				= 900,
	PAGameUIGroup_Dialog			= 1000,
	PAGameUIGroup_QuestLog			= 1100,
	PAGameUIGroup_Housing			= 1150,
	PAGameUIGroup_Interaction		= 1180,
	PAGameUIGroup_Windows			= 1200,
	PAGameUIGroup_Window_Progress	= 1250,
	PAGameUIGroup_InstanceMission	= 1300,
	PAGameUIGroup_Siege				= 1400,
	PAGameUIGroup_HouseInfo			= 1460,
	PAGameUIGroup_EtcIcon			= 1500,
	PAGameUIGroup_Alert				= 1600,
	PAGameUIGroup_BattleAlert		= 1700,
	PAGameUIGroup_WorldMap			= 1800,
	PAGameUIGroup_WorldMap_Popups	= 1850,
	PAGameUIGroup_WorldMap_Contents	= 1880,
	PAGameUIGroup_GameMenu			= 1900,
	PAGameUIGroup_DeadMessage		= 2000,
	PAGameUIGroup_GameSystemMenu	= 2100,
	PAGameUIGroup_ModalDialog		= 2200,
	PAGameUIGroup_Movie				= 3000,
	PAGameUIGroup_FadeScreen		= 5000
}

Defines.UIMode =
{
	eUIMode_Default						= 0,
	eUIMode_Housing						= 1,
	eUIMode_Mental						= 2,
	eUIMode_MentalGame					= 3,
	eUIMode_NpcDialog					= 4,
	eUIMode_NpcDialog_Dummy				= 5,		-- '/' 키로 정령과 대화할때 Camera 전환 부분에서 모든 키 입력을 막으려는 용도.
	eUIMode_Trade						= 6,
	eUIMode_WorldMap					= 7,
	eUIMode_Stable						= 8,
	eUIMode_MiniGame					= 9,		-- ActionChart 를 통해 제어되는 Mini Game
	eUIMode_DeadMessage 				= 10,		-- 죽었을 경우 부활 선택할때는 모든 키입력을 막으려 한다.
	eUIMode_PreventMoveNSkill 			= 11,		-- 이동과 스킬 단축키 방지
	eUIMode_Movie 						= 12,		-- 영상 중 ESC 키를 제외한 모든 키입력을 막는다
	eUIMode_GameExit					= 13,
	eUIMode_Repair						= 14,		-- 수리시 다른 키들의 입력을 막는다.
	eUIMode_KeyCustom_Wait				= 15,
	eUIMode_KeyCustom_ActionKey			= 16,
	eUIMode_KeyCustom_ActionPad			= 17,
	eUIMode_KeyCustom_UiKey				= 18,
	eUIMode_KeyCustom_UiPad				= 19,
	eUIMode_KeyCustom_ActionPadFunc1	= 20,
	eUIMode_KeyCustom_ActionPadFunc2	= 21,
	eUIMode_PopupItem					= 22,
	eUIMode_Extraction					= 23,
	eUIMode_InGameCustomize             = 24,
	eUIMode_InGameCashShop              = 25,
	eUIMode_DyeNew						= 26,		-- 염색 모드.
	eUIMode_ItemMarket             		= 27,
	eUIMode_ProductNote					= 28,		-- 제작노트	
	eUIMode_QnAWebLink					= 29,
	eUIMode_TradeGame					= 30,		-- 무역 게임
	eUIMode_Cutscene					= 31,
	eUIMode_UiSetting					= 32,
	eUIMode_Gacha_Roulette				= 33,
	eUIMode_Count						= 34,

}

Defines.u64_const =
{
	u64_0 = toUint64(0, 0),
	u64_1 = toUint64(0, 1),
	u64_100 = toUint64(0, 100),
	u64_1000 = toUint64(0, 1000),
	u64_10000 = toUint64(0, 10000)
}
-- 계산해서 생성해놓는 값.
Defines.u64_const.u64_max = Defines.u64_const.u64_0 - Defines.u64_const.u64_1
Defines.u64_const.u64_max_m1 = Defines.u64_const.u64_max - Defines.u64_const.u64_1

Defines.s64_const =
{
	s64_m1 = toInt64(0, -1),
	s64_0 = toInt64(0, 0),
	s64_1 = toInt64(0, 1),
	s64_100 = toInt64(0, 100),
	s64_1000 = toInt64(0, 1000),
	s64_10000 = toInt64(0, 10000)
}
-- 계산해서 생성해놓는 값.
local u64_max_half = Defines.u64_const.u64_max / toUint64(0,2)
Defines.s64_const.s64_min = Defines.s64_const.s64_1 + u64_max_half
Defines.s64_const.s64_max = Defines.s64_const.s64_min - Defines.s64_const.s64_1

Defines.s64_max = function( ... )
	local argLength = #arg
	if 0 < argLength then
		local maxValue = arg[1]
		for ii = 2, argLength do
			local compValue = arg[ii]
			if maxValue < compValue then
				maxValue = compValue
			end
		end

		return maxValue
	end
end

Defines.s64_min = function( ... )
	local argLength = #arg
	if 0 < argLength then
		local minValue = arg[1]
		for ii = 2, argLength do
			local compValue = arg[ii]
			if compValue < minValue then
				minValue = compValue
			end
		end

		return minValue
	end
end


Defines.Color =
{
	C_00000000 = 0,					-- 흑색
	C_FF000000 = 4278190080,
	C_70FFFFFF = 1895825407,

	C_00FF0000 = 16711680,			-- 적색
	C_FFFF0000 = 4294901760,		-- Pure (or mostly pure) red.
	C_FFD20000 = 4291952640,		-- 짙은 빨강
	C_FFF26A6A = 4294077034,		-- 실패 메시지 밝은 빨강
	C_FF775555 = 4286010709,		-- 사용 못하는 가공 설명 어두운 빨강

	C_00FFD46D = 16766061,			-- 연한 주황(살색)
	C_FFFFD46D = 4294956141,
	C_FFFFF3AF = 4294964143,		-- 퀘스트 수락용 밝은 상아색
	C_FFEDE699 = 4293781145,		-- 퀘스트 수락용 밝은 상아색2
	C_FFEF9C7F = 4293690196,		-- 밝은 주황색 (파스텔 톤)
	C_FFEE7001 = 4293816321,		-- 주황색

	C_00FF4729 = 16729897,			-- 진한 주황색 (카운터 어택용)
	C_FFFF4729 = 4294919977,		-- 진한 주황색 (카운터 어택용)
	C_00FFFFFF = 16777215,			-- 흰색
	C_FFFFFFFF = 4293914607,
	C_FF858585 = 4286940549,
	C_FFDFDFDF = 4292861919,

	C_00B5FF6D = 11927405,			-- 연녹색
	C_FFB5FF6D = 4290117485,
	
	C_FFC8FFC8 = 4291362760,        -- 연녹색2 ( 친목 길드 용도 )

	C_006DC6FF = 7194367,			-- 하늘색
	C_FF6DC6FF = 4285384447,
	C_FF96D4FC = 4288075004,		-- 성공 메시지 하늘색
	C_FF002A56 = 4278200918,		-- 남색
	C_FF00C0D7 = 4278239447,		-- 키 튜토리얼의 빛나는 듯한 파란색

	C_00C4BEBE = 12893886,			-- 월드맵 버튼컬러(회색?)
	C_FFC4BEBE = 4291083966,

	C_00FFAB6D = 16755565,			-- 주황
	C_FFFFAB6D = 4294945645,

	C_00B75EDD = 12017373,			-- 보라색
	C_FFB75EDD = 4290207453,

	C_00FFCE22 = 16764450,    		-- 노란색
	C_FFFFCE22 = 4294954530,		-- Vivid yellow.
	C_FFFFEEA0 = 4294962848,		-- 상아색
	C_FFFAE696 = 4294633110,		-- 상아색2
	C_FFF0EF9D = 4293980061,		-- 체력바 폰트 누런색
	C_FFD8CABA = 4292397754,		-- 의뢰 목표 달성

	C_FFEEBA3E = 4293835326,		-- 잠재력 돌파/각성 버튼 누런색

	C_0088DF00 = 16764450,			-- 녹색
	C_FF88DF00 = 4287160064,

	C_FF888888 = 4287137928,		-- 회색
	C_FF515151 = 4283519313,		-- 회색

	C_00444444 = 4473924,			-- 진한회색
	C_FF444444 = 4282664004,		-- 진한회색
	C_00626262 = 6447714,			-- 중간 회색 (소켓 이미지 색)
	C_FF626262 = 4284637794,		-- 중간 회색 (소켓 이미지 색)
	C_00797979 = 7960953,			-- 연한 회색 (채팅창 버튼)
	C_FF797979 = 4291414473,		-- 연한 회색 (채팅창 버튼)

	C_FFC1FFC2 = 4290904002,		-- 연한 녹색

	C_00BBFF84 = 12320644,
	C_FFBBFF84 = 4290510724,

	C_008484FF = 8684799,
	C_FF8484FF = 4286874879,

	C_00FF8484 = 16745604,
	C_FFFF8484 = 4294935684,

	C_00FFFB84 = 16776068,
	C_FFFFFB84 = 4294966148,

	C_00FF973A = 16750394,
	C_FFFF973A = 4294940474,

	C_0084D2FF = 8704767,
	C_FF84D2FF = 4286894847,

	C_FF008AFF = 4278225663,		-- 진한파랑

	C_FF0054FF = 4278211839, 		-- pvp에서 사용하는 성향 max 파랑

	C_FF67FFA4 = 4285005732,		-- lime green
	C_FFFF7C67 = 4294933607,		-- Very light red

	C_00341A1B = 3414555,			-- 패스워드 입력창에서 쓰이는 알파없는 녹색 컬러

	C_FF76CAFF = 4285975295, 		-- Very light blue
	C_FFFF5F5F = 4294926175,		-- Light red
	C_FFFF3BF8 = 4294917112,		-- Light magenta

	C_FFFFBC3A = 4294949946,		-- 실버색

	C_FFB10000= 4289789952,			-- 퀘스트 위젯 흑정령 퀘스트 제목용
	
	C_FF7F7F7F= 4286545791,			-- 퀘스트 위젯 흑정령 퀘스트 제목용

	C_FF2478FF= 4280580351,			-- 길드 리스트 성향치 기여도(양수)
	
	C_FFEFEFEF= 4293914607,			-- 흰색

	C_FFF03838= 4293933112,			-- 빨강에서 좀 더 연한색.
	C_FFEF5378= 4293874552,			-- 연분홍색

	C_FFFF8957 = 4294936919,		-- 주황색(장비 내구도 20% 구간 표시색상)
	

-----------------------------------------------------------------------------------------
-- 							상점
-----------------------------------------------------------------------------------------
	C_FF3BD3FF=	4282110975,

-----------------------------------------------------------------------------------------
-- 							아이템 툴팁
-----------------------------------------------------------------------------------------
	C_FFC4A68A = 4291077770,		-- 금색?	-- 아이템 설명
	C_FF748CAB = 4285828267,		-- 어두운 푸른색  -- 긍정

-----------------------------------------------------------------------------------------
-- 							캐릭터 선택 창 레벨 표시용
-----------------------------------------------------------------------------------------
	C_FFA8FC00 = 4289264640,
	C_FFFBFF8A = 4294705034,
	C_FFFF8A8A = 4294937226,
	C_FFFF3636 = 4294915638,
	C_FF7800D5 = 4286054613,

-----------------------------------------------------------------------------------------
-- 							몬스터 게이지바 색 변경용
-----------------------------------------------------------------------------------------
	C_FFFFAE00 = 4294946304,		-- 100%
	C_FFD98F00 = 4292448000,		-- 80%
	C_FFD96100 = 4292436224,		-- 60%
	C_FFCE3A00 = 4291705344,		-- 40%
	C_FFC00000 = 4290772992,		-- 20%

-----------------------------------------------------------------------------------------
-- 							지식 CircularProgress용 칼라값
-----------------------------------------------------------------------------------------
	C_FFF4D35D = 4294234973,		-- 인물
	C_FF5578B4 = 4283791540,		-- 지형
	C_FF00C2EA = 4278239978,		-- 생태
	C_FF844BE3 = 4286860259,		-- 학문
	C_FFE37F4B = 4293099339,		-- 낚시
	C_FFDA0000 = 4292476928,		-- 생활
	C_FFBCF44B = 4290573387,		-- 모험일지
	C_FF4BF4B5 = 4283167925,		-- 중요지식

-------------------------------------------------------------------------------------------
--							영주 정보
-------------------------------------------------------------------------------------------
	C_FFFF4C4C = 4294921292,
	C_FFFF874C = 4294936396,
	C_FFAEFF9B = 4289658779,
	C_FF9B9BFF = 4288388095,
	C_FF8737FF = 4287051775,

-------------------------------------------------------------------------------------------
--							채팅
-------------------------------------------------------------------------------------------
	C_FFE7E7E7 = 4293388263,		-- 밝은 회색 - 거의 흰색(기본값)
	C_FFD2B4FF = 4291998975,		-- 옅은 보라색
	C_FFFF9BFE = 4294941694,		-- 옅은 핑크색
	C_FF6B6B6B = 4285229931,		-- 어두운 회색
	C_FF999999 = 4288256409,		-- 밝은 회색(시스템 메시지 기본  값)
	C_FFFFEF82 = 4294963074,		-- 옅은 노랑색
	C_FFFF4B4B = 4294921035,		-- 빨간색
	C_FF84FFF5 = 4286906357,		-- 하늘색

	C_FFAAAAAA = 4289374890,		-- 채팅창 기본 색
	C_FF926CFF = 4287786239,		-- 길드 채팅 색상(보라색, 최서원 지정, 2014.4.19 추가)
	C_FFF601FF = 4294312447,		-- 귓속말 색상(핑크색, 최서원 지정, 2014.4.19 추가)
	C_FF8EBD00 = 4287544576,		-- 거래 채팅 색상(녹색, 채효석씨 지정, 2014.8.1 추가)
	C_FFFFCF4C = 4294954828,

-------------------------------------------------------------------------------------------
--							그 외
-------------------------------------------------------------------------------------------
	C_FF804040 = 4286595136,        -- 레이더 길색깔
	C_FF40D7FD = 4282439677,        -- (월드맵)지식이 있으면 파란색으로 바꿔준다
	C_FFDCD489 = 4292662409,		-- 돈 색깔
	
	
-------------------------------------------------------------------------------------------
--							스태미너 양에 따라 색을 바꿔준다
-------------------------------------------------------------------------------------------	
	C_FFFFDD81 = 4294958465,		-- 100
	C_FFFFCE57 = 4294954583,		-- 80
	C_FFF4A72D = 4294223661,		-- 60
	C_FFE26A13 = 4293028371,		-- 40
	C_FFE03A0D = 4292885005,		-- 20
	
-------------------------------------------------------------------------------------------
--								길 찾기 미터 표시
-------------------------------------------------------------------------------------------	
	C_FFF68383 = 4294345603,		-- 1m
	C_FFECADAD = 4293701037,		-- 10m
	C_FFE5C6C6 = 4293248710,		-- 20m
	C_FFCECECE = 4291743438,		-- 100m

-------------------------------------------------------------------------------------------
--								빅 나크 메시지(전투지역/안전지역/보상선택 표시용)
-------------------------------------------------------------------------------------------	
	C_ffff8181 = 4294934913,		-- 전투지역
	C_ffdeff6d = 4292804461,		-- 안전지역


-------------------------------------------------------------------------------------------
--								지식창 컬러들
-------------------------------------------------------------------------------------------	
	C_FF387f14 = 4281892628,		--  지형
	C_FFf570a1 = 4294275233,		--	가이드
	C_FF25c28b = 4280664715,		--	공동 무역품
	C_FF3E5CFF = 4282277119,		--	대해

-------------------------------------------------------------------------------------------
--								NameTag MP 컬러들
-------------------------------------------------------------------------------------------	
	C_FFBE4A00 = 4290660864,
	C_FF00A1FF = 4278231551,
	C_FFA3EF00 = 4288933632,

}

-- stringTable 의 데이터 시트가 추가되면 여기에 추가로 define 한후에 사용하도록 하자
Defines.StringSheet_GAME = "GAME"
Defines.StringSheet_RESOURCE = "RESOURCE"



