-------------------------------
-- Panel Init
-------------------------------
Panel_ServerSelect:SetShow(true, false)
Panel_ServerSelect:SetSize( getScreenSizeX(), getScreenSizeY() )

--------------------------------
--	"getCurrentWolrdName",	
--  "getCurrentChannelIndex"
--------------------------------

-------------------------------
-- Control Regist & Init
-------------------------------
local	FRAME_SERVERLIST			= UI.getChildControl(Panel_ServerSelect,	"FrameServerList")
local	FRAMEContents_SERVERLIST	= UI.getChildControl(FRAME_SERVERLIST,		"Frame_1_Content")
local	FRAME_Scroll				= UI.getChildControl(FRAME_SERVERLIST,		"Frame_1_VerticalScroll")

local 	SELECT_SERVER_BG_TEXT		= UI.getChildControl(Panel_ServerSelect,	"StaticText_ServerSelect")

local 	WORLD_BG_BTN					= UI.getChildControl(Panel_ServerSelect,	"Button_Server")
local 	WORLD_NAME_TEXT 				= UI.getChildControl(Panel_ServerSelect,	"StaticText_ServerName")
local	WORLD_UNABLE_CREATE_CHARACTER	= UI.getChildControl(Panel_ServerSelect,	"Static_UnableCreate")
local 	WORLD_CHARACTERCOUNT_TEXT 		= UI.getChildControl(Panel_ServerSelect,	"StaticText_CharacterCount")
local 	WORLD_STATUS_TEXT				= UI.getChildControl(Panel_ServerSelect,	"Static_ServerStatus")

local 	CHANNEL_BG_STATIC			= UI.getChildControl(Panel_ServerSelect,	"Static_ChannelBG")
local 	CHANNEL_NAME_TEXT 			= UI.getChildControl(Panel_ServerSelect,	"StaticText_ChannelName")
local 	CHANNEL_MAINICON_STATIC		= UI.getChildControl(Panel_ServerSelect,	"Static_MainChannelIcon")
local 	CHANNEL_STATUS_TEXT 		= UI.getChildControl(Panel_ServerSelect,	"Static_ChannelStatus")
local 	CHANNEL_ENTER_BTN			= UI.getChildControl(Panel_ServerSelect,	"Button_Channel")


WORLD_BG_BTN:SetShow(false)
WORLD_NAME_TEXT:SetShow(false)
WORLD_UNABLE_CREATE_CHARACTER:SetShow( false )
WORLD_CHARACTERCOUNT_TEXT:SetShow(false)
WORLD_STATUS_TEXT:SetShow(false)

CHANNEL_BG_STATIC:SetShow(false)
CHANNEL_NAME_TEXT:SetShow(false)
CHANNEL_STATUS_TEXT:SetShow(false)
CHANNEL_ENTER_BTN:SetShow(false)

FRAME_SERVERLIST:SetShow(true)

local screenX = getScreenSizeX()
local screenY = getScreenSizeY()
Static_Back	= Array.new()

for ii = 1, 13 do
	targetControl = UI.getChildControl( Panel_ServerSelect, "Static_Back_"..ii )
	targetControl:SetSize(screenX, screenY)
	targetControl:SetPosX(0.0)
	targetControl:SetPosY(0.0)
	targetControl:SetAlpha(0.0)
	Static_Back[ii] = targetControl
end

-------------------------------
-- 변수
-------------------------------
local _selectWorldIndex = -1;
local _worldServerCount = 0;

local _channelCtrl =
{
	_bgStatic,
	_nameText,
	_statusText,
	_enterBtn
}

local _worldServerCtrl =
{
	_bgButton,
	_nameText,
	_countText,
	_statusText,
	_channelCount,
	_channelCtrls,
}
local _worldServerCtrls = {}


-------------------------------
-- 구현부
-------------------------------


------------------------------------------------------------------------------------
-- 		 			서버/채널 상태에 따른 텍스처 변경.
------------------------------------------------------------------------------------

local serverStatusTexture = {
	[0] = { 133, 27, 149, 43 },	-- 점 검
	{ 150, 27, 166, 43 },	-- 원 활
	{ 167, 27, 183, 43 },	-- 혼 잡
	{ 184, 27, 200, 43 },	-- 매우혼잡
	{ 184, 44, 200, 60 },	-- 만 원
}

function changeTexture_ByServerStatus( control, status )
	control:ChangeTextureInfoName( "new_ui_common_forlua/Default/Default_Etc_01.dds" )
	local x1, y1, x2, y2 = setTextureUV_Func( control, serverStatusTexture[status][1], serverStatusTexture[status][2], serverStatusTexture[status][3], serverStatusTexture[status][4] )
	control:getBaseTexture():setUV( x1, y1, x2, y2 )
	control:setRenderTexture(control:getBaseTexture())
end

local createStatusTexture = {
	[0] = { 139, 44, 166, 71 },		-- 가능
	{ 111, 44, 138, 71 },			-- 불가능
}
function changeTexture_ByCreateStatus( control, status )
	control:ChangeTextureInfoName( "new_ui_common_forlua/Default/Default_Etc_01.dds" )
	local x1, y1, x2, y2 = setTextureUV_Func( control, createStatusTexture[status][1], createStatusTexture[status][2], createStatusTexture[status][3], createStatusTexture[status][4] )
	control:getBaseTexture():setUV( x1, y1, x2, y2 )
	control:setRenderTexture(control:getBaseTexture())
end




------------------------------------------------------------------------------------
-- 									서버 리스트
------------------------------------------------------------------------------------
function StartUp_Panel_SelectServer()
	
	Panel_ServerSelect:SetSize(getScreenSizeX(), getScreenSizeY());
	
	_worldServerCount =  getGameWorldServerDataCount()

	-- _PA_LOG("Lua" , "StartUp_Panel_SelectServer: worldCount " ..tostring(_worldServerCount) );
	
	for idx = 0 , _worldServerCount-1 do
		local serverData = getGameWorldServerDataByIndex(idx)
		if ( nil == serverData ) then
			break
		end
		
		-- _PA_LOG("Lua" , "StartUp_Panel_SelectServer: idx " ..tostring(idx) );
		
		local worldCtrl = {}
		
		-- 버튼
		local tempBtn = UI.createControl( CppEnums.PA_UI_CONTROL_TYPE.PA_UI_CONTROL_BUTTON, FRAME_SERVERLIST:GetFrameContent(), "WorldButton_" .. tostring(idx) )
		CopyBaseProperty( WORLD_BG_BTN, tempBtn )	
		tempBtn:SetShow(true)
		tempBtn:ActiveMouseEventEffect( true )
		tempBtn:addInputEvent("Mouse_LUp", "Panel_Lobby_function_SelectWorldServer(" .. idx .. ")")
		tempBtn:SetPosX( 0 )
		tempBtn:SetPosY( idx * ( tempBtn:GetSizeY() + 25 ) )
		
		-- 이름
		local tempName = UI.createControl( CppEnums.PA_UI_CONTROL_TYPE.PA_UI_CONTROL_STATICTEXT, tempBtn, "WorldName_" .. tostring(idx) )
		CopyBaseProperty( WORLD_NAME_TEXT, tempName )	
		tempName:SetShow(true)
		tempName:ActiveMouseEventEffect( true )
		tempName:SetText( getWorldNameByWorldNo(serverData._worldNo) )
		tempName:SetPosX( 20 )
		tempName:SetPosY( 13 )

		-- 캐릭터 수
		local tempCount = UI.createControl( CppEnums.PA_UI_CONTROL_TYPE.PA_UI_CONTROL_STATICTEXT, tempBtn, "WorldCount_" .. tostring(idx) )
		CopyBaseProperty( WORLD_CHARACTERCOUNT_TEXT, tempCount )	
		tempCount:SetShow(true)
		tempCount:ActiveMouseEventEffect( true )
		
		local tempStr = ""
		if( 0 < serverData._characterCount ) then
			tempStr = '(' .. tostring( serverData._characterCount ) ..')'
		end
		
		if( 0 < serverData._deleteCount ) then
			tempStr	= tempStr..'(' ..tostring(serverData._deleteCount) ..')'
		end
		
		tempCount:SetText( tempStr );
		tempCount:SetPosX( 180 ) tempCount:SetPosY( 13 )

		-- if(serverData._doRestrictCharacterCreation) then
		-- 	tempUnableCreate:SetShow( true )
		-- end		
		
		-- 상태
		local tempStatus = UI.createControl( CppEnums.PA_UI_CONTROL_TYPE.PA_UI_CONTROL_STATICTEXT, tempBtn, "WorldStatus_" .. tostring(idx) )
		CopyBaseProperty( WORLD_STATUS_TEXT, tempStatus )	
		tempStatus:SetShow(true)
		tempStatus:ActiveMouseEventEffect( true )
		
		local busyState = getGameWorldServerBusyByIndex(idx)
		-- changeTexture_ByServerStatus( tempStatus, busyState )

		if( busyState == 0 ) then
			tempStr = "<PAColor0xff868686>점 검<PAOldColor>"
		elseif( busyState == 1 ) then
			tempStr = "<PAColor0xffd0ee68>원 활<PAOldColor>"
		elseif( busyState == 2 ) then
			tempStr = "<PAColor0xffeabf4c>혼 잡<PAOldColor>"
		elseif( busyState == 3 ) then
			tempStr = "<PAColor0xffed6363>매우혼잡<PAOldColor>"
		elseif( busyState == 4 ) then
			tempStr = "<PAColor0xffed6363>만 원<PAOldColor>"
		end

		-- 생성 제한.
		local tempUnableCreate = UI.createControl( CppEnums.PA_UI_CONTROL_TYPE.PA_UI_CONTROL_STATIC, tempBtn, "WorldUnableCreate_" .. tostring(idx) )
		CopyBaseProperty( WORLD_UNABLE_CREATE_CHARACTER, tempUnableCreate )	
		tempUnableCreate:SetShow( true )
		tempUnableCreate:SetPosX( tempStatus:GetPosX() - tempUnableCreate:GetSizeX() - 5 )
		tempUnableCreate:SetPosY( 10 )

		if ToClient_IsCreatableWorldServer( idx ) then
			-- tempStr = tempStr .. "<PAColor0xffd0ee68>(생성가능)<PAOldColor>"
			changeTexture_ByCreateStatus( tempUnableCreate, 0 )
		else
			-- tempStr = tempStr .. "<PAColor0xffed6363>(생성불가)<PAOldColor>"
			changeTexture_ByCreateStatus( tempUnableCreate, 1 )
		end

		tempStatus:SetText( tempStr )
		tempStatus:SetPosX( 290 ) 
		tempStatus:SetPosY( 13 )
		
		worldCtrl._bgButton 	= tempBtn;
		worldCtrl._nameText 	= tempName;
		worldCtrl._unableCreate = tempUnableCreate;
		worldCtrl._countText	= tempCount;
		worldCtrl._statusText	= tempStatus;
		
		_worldServerCtrls[idx] = worldCtrl
	end
		
	for idx = 0 , _worldServerCount-1 do
		Panel_SelectServer_ReCreateChannelCtrl(idx);	
	end
		
	_selectWorldIndex = -1;
	
	Panel_SelectServer_RePositioningCtrls();
end

------------------------------------------------------------------------------------
-- 									채널 리스트
------------------------------------------------------------------------------------
function Panel_SelectServer_ReCreateChannelCtrl(worldIndex)
	
	local worldServerData	    = getGameWorldServerDataByIndex(worldIndex)
	local restrictedServerNo	= worldServerData._restrictedServerNo;
	
	_worldServerCtrls[worldIndex]._channelCount = getGameChannelServerDataCount(worldServerData._worldNo);
	_worldServerCtrls[worldIndex]._channelCtrls = {}
		
	for idx = 0 , _worldServerCtrls[worldIndex]._channelCount -1  do
		local serverData = getGameChannelServerDataByIndex(worldIndex, idx)
		if ( nil == serverData ) then
			break
		end		
		
		local isAdmission = true;
		if( restrictedServerNo ~= 0 ) then
			if( restrictedServerNo == serverData._serverNo ) then
				isAdmission = true;
			else
				isAdmission = false;
			end		
		end
			
		local strTemp = "ChannelBG_" ..tostring(worldIndex).."_"..tostring(idx);
		
		-- _PA_LOG( "Lua", "  strTemp " .. strTemp )
	
		-- 채널 배경 	
		local tempBG = UI.createControl( CppEnums.PA_UI_CONTROL_TYPE.PA_UI_CONTROL_STATIC, FRAME_SERVERLIST:GetFrameContent(), "ChannelBG_" ..tostring(worldIndex).."_"..tostring(idx) )
		CopyBaseProperty( CHANNEL_BG_STATIC, tempBG )	
		tempBG:SetShow(false)
		tempBG:ActiveMouseEventEffect( true )
		tempBG:SetIgnore(false)
		-- tempBG:SetSize( tempBG:GetSizeX(), tempBG:GetSizeY( )
		
		-- 이름
		local tempName = UI.createControl( CppEnums.PA_UI_CONTROL_TYPE.PA_UI_CONTROL_STATICTEXT, tempBG, "ChannelName_" ..tostring(worldIndex).."_"..tostring(idx) )
		CopyBaseProperty( CHANNEL_NAME_TEXT, tempName )	
		tempName:SetShow(true)
		tempName:ActiveMouseEventEffect( true )
		
		-- 채널 아이콘
		local tempMainIcon = UI.createControl( CppEnums.PA_UI_CONTROL_TYPE.PA_UI_CONTROL_STATIC, tempBG, "ChannelMainIcon_" ..tostring(worldIndex).."_"..tostring(idx) )
		CopyBaseProperty( CHANNEL_MAINICON_STATIC, tempMainIcon )	
		tempMainIcon:SetShow(false)
		tempMainIcon:ActiveMouseEventEffect( true )

		local admissionDesc = ""
		if( false == isAdmission ) then
			admissionDesc = admissionDesc.."(제한됨)"
		else
			admissionDesc = admissionDesc -- .."(입장가능)"
		end
		
		local channelName = getChannelName(worldServerData._worldNo, serverData._serverNo )
		_PA_ASSERT( nil ~= channelName, '서버 이름은 존재해야합니다.')
		
		if true == isGameServiceTypeDev() then
			channelName = channelName .." " .. getDotIp(serverData) .. admissionDesc 
		else
			channelName = channelName.." "..admissionDesc 
		end
		
		tempName:SetText( channelName )

		tempName:SetPosX( 35 ) 
		tempName:SetPosY( 13 )

		if serverData._isMain == true then
			tempMainIcon:SetShow( true )
			tempMainIcon:SetPosX( 15 )
			tempMainIcon:SetPosY( 17 )
		end
					
		-- 상태
		local tempStatus = UI.createControl( CppEnums.PA_UI_CONTROL_TYPE.PA_UI_CONTROL_STATICTEXT, tempBG, "ChannelStatus_" ..tostring(worldIndex).."_"..tostring(idx) )
		CopyBaseProperty( CHANNEL_STATUS_TEXT, tempStatus )	
		tempStatus:SetShow(true)
		tempStatus:ActiveMouseEventEffect( true )
		
		local busyState = serverData._busyState
		if( busyState == 0 ) then
			tempStr = "<PAColor0xff868686>점 검<PAOldColor>"
		elseif( busyState == 1 ) then
			tempStr = "<PAColor0xffd0ee68>원 활<PAOldColor>"
		elseif( busyState == 2 ) then
			tempStr = "<PAColor0xffeabf4c>혼 잡<PAOldColor>"
		elseif( busyState == 3 ) then
			tempStr = "<PAColor0xffed6363>매우혼잡<PAOldColor>"
		elseif( busyState == 4 ) then
			tempStr = "<PAColor0xffed6363>만 원<PAOldColor>"
		end

		tempStatus:SetText( tempStr )
		-- changeTexture_ByServerStatus( tempStatus, busyState )

		tempStatus:SetPosX( 180 ) tempStatus:SetPosY( 14 )

		local tempUnableCreate = UI.createControl( CppEnums.PA_UI_CONTROL_TYPE.PA_UI_CONTROL_STATIC, tempBG, "ChannelCreateStatus_" .. tostring(idx) )
		CopyBaseProperty( WORLD_UNABLE_CREATE_CHARACTER, tempUnableCreate )	
		tempUnableCreate:SetShow( true )
		tempUnableCreate:SetPosX( 235 )
		tempUnableCreate:SetPosY( 11 )

		if serverData._isCreatable then
			changeTexture_ByCreateStatus( tempUnableCreate, 0 )
		else
			changeTexture_ByCreateStatus( tempUnableCreate, 1 )
		end


		
		
		
		-- 버튼
		local tempBtn = UI.createControl( CppEnums.PA_UI_CONTROL_TYPE.PA_UI_CONTROL_BUTTON, tempBG, "ChannelButton_" ..tostring(worldIndex).."_"..tostring(idx) )
		CopyBaseProperty( CHANNEL_ENTER_BTN, tempBtn )	
		tempBtn:SetIgnore(false)
		tempBtn:ActiveMouseEventEffect( true )
		tempBtn:SetPosX( 270 ) 
		tempBtn:SetPosY( 7 )
		tempBtn:addInputEvent("Mouse_LUp", "Panel_Lobby_function_EnterChannel(" .. idx .. ")")
		
		-- 개발에서는 제한됐을때만 입장버튼을 보여주고
		if true == isGameServiceTypeDev() then
			tempBtn:SetShow( isAdmission );
		else -- 서비스 버젼에서는 점검상태도 체크한 후 보여준다.
			tempBtn:SetShow( isAdmission and (busyState ~= 0)  );
		end
		
		_worldServerCtrls[worldIndex]._channelCtrls[idx] = {}
		_worldServerCtrls[worldIndex]._channelCtrls[idx]._bgStatic 		= tempBG
		_worldServerCtrls[worldIndex]._channelCtrls[idx]._nameText 		= tempName
		_worldServerCtrls[worldIndex]._channelCtrls[idx]._statusText 	= tempStatus
		_worldServerCtrls[worldIndex]._channelCtrls[idx]._enterBtn		= tempBtn

	end
end

function Panel_SelectServer_ShowChannelCtrls(worldIndex)

	local count = _worldServerCount
	for idx=0, count-1 do
			
		local isShow = false;
		if( idx == worldIndex ) then
			isShow = true;
		end
		
		for channelIdx = 0, _worldServerCtrls[idx]._channelCount-1 do	
		
			_worldServerCtrls[idx]._channelCtrls[channelIdx]._bgStatic:SetShow(isShow)
			
			-- _PA_LOG( "Lua", "Panel_SelectServer_ShowChannelCtrls world idx show "..tostring(idx).." "..tostring(channelIdx).." ".. tostring(isShow) )
		end		
	end

end

function 	Panel_SelectServer_RePositioningCtrls()
	local bgPosY 			= SELECT_SERVER_BG_TEXT:GetPosY() + 20
	local worldSizeY		= WORLD_BG_BTN:GetSizeY()

	local posX = SELECT_SERVER_BG_TEXT:GetPosX() + 20
	local posY = bgPosY + 30
	
	FRAME_SERVERLIST:SetPosX( posX )
	FRAME_SERVERLIST:SetPosY( posY )
		
	posX = 0
	posY = 0
	local count = _worldServerCount	
	for idx = 0, count-1 do 
		_worldServerCtrls[idx]._bgButton:SetPosX( posX )
		_worldServerCtrls[idx]._bgButton:SetPosY( posY + 5 )
	
		local varyY = Panel_SelectServer_GetVariableSizeY( posX + 5, posY, idx )
		posY = posY + varyY
		
		SELECT_SERVER_BG_TEXT:SetSize( SELECT_SERVER_BG_TEXT:GetSizeX(), getScreenSizeY() - 20 )
	end
	FRAME_SERVERLIST:SetSize( SELECT_SERVER_BG_TEXT:GetSizeX() - 40 , SELECT_SERVER_BG_TEXT:GetSizeY() - 60 )
	FRAME_Scroll	:SetSize( FRAME_Scroll:GetSizeX() , SELECT_SERVER_BG_TEXT:GetSizeY() - 60 )
	FRAME_SERVERLIST:UpdateContentPos()
	if FRAME_SERVERLIST:GetSizeY() < FRAMEContents_SERVERLIST:GetSizeY() then
		FRAME_Scroll:SetShow( true )
	else
		FRAME_Scroll:SetShow( false )
	end
end

function	Panel_SelectServer_GetVariableSizeY( posX, posY, worldIndex )
	local default = WORLD_BG_BTN:GetSizeY() + 10
		
	if ( _selectWorldIndex ~= worldIndex ) then
		return default;
	end
	
	-- _PA_LOG( "Lua", "Panel_SelectServer_GetVariableSizeY worldIndex show " ..tostring(worldIndex) )
		
	local channelSizeY = CHANNEL_BG_STATIC:GetSizeY() + 5
	local count = _worldServerCtrls[worldIndex]._channelCount
	
	for idx=0, count-1 do 
		local isShow = _worldServerCtrls[worldIndex]._channelCtrls[idx]._bgStatic:GetShow();
		local tempPosY = posY + default + ( channelSizeY * idx )
		local tempPosYGap = 5

		_worldServerCtrls[worldIndex]._channelCtrls[idx]._bgStatic:SetPosX( posX )
		_worldServerCtrls[worldIndex]._channelCtrls[idx]._bgStatic:SetPosY( tempPosY )
		
		-- _PA_LOG( "Lua", "Panel_SelectServer_GetVariableSizeY worldIndex idx tempPosY isShow "..tostring(worldIndex).." "..tostring(idx).." "..tostring(tempPosY).." "..tostring(isShow) )
	end
	
	return ( default + (channelSizeY * count) )
end

function Panel_Lobby_function_SelectWorldServer(index)
	_selectWorldIndex = index
	
	Panel_SelectServer_ShowChannelCtrls(index)
	Panel_SelectServer_RePositioningCtrls()
	
end

function Panel_Lobby_function_EnterChannel(index)

	selectServerGroup( _selectWorldIndex, index)

end

function EventUpdateServerInformation_SelectServer()

	_PA_LOG("유흥신", "EventUpdateServerInformation_SelectServer ")

	local isShow = Panel_ServerSelect:IsShow()	-- 서버 데이터를 업데이트했다.
	if( false == isShow ) then
		return;
	end

	_PA_LOG("유흥신", "EventUpdateServerInformation_SelectServer " .. _selectWorldIndex )
	
	local selectIndex = _selectWorldIndex;
	
	-- 데이터 설정
	StartUp_Panel_SelectServer()

	-- 선택한 서버가 있으면 세부 채널을 보여준다.
	if( -1  ~= selectIndex ) then
		Panel_Lobby_function_SelectWorldServer(selectIndex);
	end
	
end

function SelectServer_RequestInfo_ForTest()
	
	requestServerInformationForTest()
	
end

function PanelServerSelect_Resize()

	local count = getGameWorldServerDataCount() + 1
	Panel_ServerSelect:SetSize( getScreenSizeX(), getScreenSizeY() )

	SELECT_SERVER_BG_TEXT:SetSize( SELECT_SERVER_BG_TEXT:GetSizeX() + 21, ( count * 48 ) + 50 )
	SELECT_SERVER_BG_TEXT:SetHorizonRight()
	
	FRAME_SERVERLIST:SetSize( SELECT_SERVER_BG_TEXT:GetSizeX() - 40 , SELECT_SERVER_BG_TEXT:GetSizeY() - 60 )
	FRAME_Scroll	:SetSize( FRAME_Scroll:GetSizeX() , SELECT_SERVER_BG_TEXT:GetSizeY() - 60 )
	FRAME_SERVERLIST:SetHorizonRight()
	-- SELECT_SERVER_BG_TEXT:SetSize( SELECT_SERVER_BG_TEXT:GetSizeX(), (count * 48) + 50)
	-- SELECT_SERVER_BG_TEXT:SetSize( SELECT_SERVER_BG_TEXT:GetSizeX(), getScreenSizeY() - 30 )
	FRAME_SERVERLIST:UpdateContentPos()
	
	if FRAME_SERVERLIST:GetSizeY() < FRAMEContents_SERVERLIST:GetSizeY() then
		FRAME_Scroll:SetShow( true )
	else
		FRAME_Scroll:SetShow( false )
	end

	for ii = 1, 9 do
		Static_Back[ii]:SetSize( getScreenSizeX(), getScreenSizeY() )
	end
end

local currentBackIndex = getRandomValue(1, 5)
local nextBackIndex = currentBackIndex + 1
Static_Back[currentBackIndex]:SetShow(true)
Static_Back[currentBackIndex]:SetAlpha(1.0)

local updateTime = 0.0
local isScope = true
local startUV = 0.1
local endUV = startUV + 0.04
local startUV2 = 0.9
local endUV2 = startUV2 + 0.04

function Panel_ServerSelect_Update(deltaTime)
	updateTime = updateTime - deltaTime
	if updateTime <= 0.0 then
		updateTime = 15.0
		if isScope then
			isScope = false
			local FadeMaskAni = Static_Back[currentBackIndex]:addTextureUVAnimation (0.0, 15.0, 0 )
		
			FadeMaskAni:SetStartUV ( startUV, startUV, 0 )
			FadeMaskAni:SetEndUV ( endUV, startUV, 0 )

			FadeMaskAni:SetStartUV ( startUV2, startUV, 1 )
			FadeMaskAni:SetEndUV ( endUV2, startUV, 1 )

			FadeMaskAni:SetStartUV ( startUV, startUV2, 2 )
			FadeMaskAni:SetEndUV ( endUV, startUV2, 2 )

			FadeMaskAni:SetStartUV ( startUV2, startUV2, 3 )
			FadeMaskAni:SetEndUV ( endUV2, startUV2, 3 )
		else
			isScope = true
			local FadeMaskAni = Static_Back[currentBackIndex]:addTextureUVAnimation (0.0, 15.0, 0 )
		
			FadeMaskAni:SetEndUV ( startUV, startUV, 0 )
			FadeMaskAni:SetStartUV ( endUV, startUV, 0 )

			FadeMaskAni:SetEndUV ( startUV2, startUV, 1 )
			FadeMaskAni:SetStartUV ( endUV2, startUV, 1 )

			FadeMaskAni:SetEndUV ( startUV, startUV2, 2 )
			FadeMaskAni:SetStartUV ( endUV, startUV2, 2 )

			FadeMaskAni:SetEndUV ( startUV2, startUV2, 3 )
			FadeMaskAni:SetStartUV ( endUV2, startUV2, 3 )
			
			local fadeColor = Static_Back[currentBackIndex]:addColorAnimation( 14.0, 16.0, 0)
			fadeColor:SetStartColor( Defines.Color.C_FFFFFFFF )
			fadeColor:SetEndColor( Defines.Color.C_00FFFFFF )
			
			local baseTexture = Static_Back[nextBackIndex]:getBaseTexture()
			baseTexture:setUV(startUV, startUV, startUV2, startUV2)
			Static_Back[nextBackIndex]:setRenderTexture(baseTexture)
			local fadeColor2 = Static_Back[nextBackIndex]:addColorAnimation( 12.0, 15.0, 0)
			fadeColor2:SetStartColor( Defines.Color.C_00FFFFFF )
			fadeColor2:SetEndColor( Defines.Color.C_FFFFFFFF )
			
			currentBackIndex = nextBackIndex
			if 9 <= nextBackIndex then
				nextBackIndex = 1
			else
				nextBackIndex = nextBackIndex + 1
			end
		end
	end
	
	--[[
	if isKeyDown_Once( 0x74 ) then --CppEnums.VirtualKeyCode.KeyCode_F5 ) then
		if Panel_ServerSelect:GetShow() then
			SelectServer_RequestInfo_ForTest()
	 	end
	 end
	--]]
	
end

registerEvent("EventChangeLobbyStageToServerSelect", "StartUp_Panel_SelectServer")
registerEvent("EventUpdateServerInformationForServerSelect",		"EventUpdateServerInformation_SelectServer")
	
Panel_ServerSelect:RegisterUpdateFunc("Panel_ServerSelect_Update")
registerEvent( "onScreenResize", "PanelServerSelect_Resize" )
PanelServerSelect_Resize()