-----------------------------------------------------------
-- Local 변수 설정
-----------------------------------------------------------
local UI_PUCT		= CppEnums.PA_UI_CONTROL_TYPE
local UI_color		= Defines.Color
local UI_TM			= CppEnums.TextMode
local UI_PSFT		= CppEnums.PAUI_SHOW_FADE_TYPE
local UI_ANI_ADV	= CppEnums.PAUI_ANIM_ADVANCE_TYPE
local UI_CT			= CppEnums.ChatType
local UI_CNT		= CppEnums.EChatNoticeType
local UI_Group		= Defines.UIGroup

Panel_ChatOption:SetShow( false )
Panel_ChatOption:SetIgnore( true )
Panel_ChatOption:ActiveMouseEventEffect(true)
Panel_ChatOption:setGlassBackground(true)

Panel_ChatOption:RegisterShowEventFunc( true, 	'ChatOption_ShowAni()' )
Panel_ChatOption:RegisterShowEventFunc( false,	'ChatOption_HideAni()' )


local chanel_Notice 			= false
local chanel_System 			= false
local chanel_World 				= false
local chanel_World 				= false
local chanel_Public 			= false
local chanel_Private 			= false
local chanel_Party 				= false
local chanel_Guild 				= false
--local chanel_Market				= false
local _alphaPosX				= 0

local _ChatOption_Title			= UI.getChildControl( Panel_ChatOption, 	"StaticText_Title" )
-- local _chatPanelName			= UI.getChildControl( Panel_ChatOption, 	"InputText_TabName" ) -- 패널이 없다!

local _msgFilter_BG				= UI.getChildControl( Panel_ChatOption, 	"Static_FilterBG" )

local _msgFilter_Notice			= UI.getChildControl( Panel_ChatOption, 	"RadioButton_filter_Notice" )
local _msgFilter_System			= UI.getChildControl( Panel_ChatOption, 	"RadioButton_filter_System" )
local _msgFilter_World			= UI.getChildControl( Panel_ChatOption, 	"RadioButton_filter_World" )
local _msgFilter_Public			= UI.getChildControl( Panel_ChatOption, 	"RadioButton_filter_Normal" )
local _msgFilter_Private		= UI.getChildControl( Panel_ChatOption, 	"RadioButton_filter_Whisper" )
local _msgFilter_Party			= UI.getChildControl( Panel_ChatOption, 	"RadioButton_filter_Party" )
local _msgFilter_Guild			= UI.getChildControl( Panel_ChatOption, 	"RadioButton_filter_Guild" ) 
--local _msgFilter_Market			= UI.getChildControl( Panel_ChatOption,		"RadioButton_filter_Market" )

local _alpha_0					= UI.getChildControl( Panel_ChatOption, 	"StaticText_PanelTransparency_0" ) 
local _alpha_50					= UI.getChildControl( Panel_ChatOption, 	"StaticText_PanelTransparency_50" )
local _alpha_100				= UI.getChildControl( Panel_ChatOption, 	"StaticText_PanelTransparency_100" )
local _alphaSlider_Control		= UI.getChildControl( Panel_ChatOption, 	"Slider_PanelTransparencyControl" ) 
local _alphaSlider_ControlBTN	= UI.getChildControl( _alphaSlider_Control, "Slider_PanelTransparency_Button" ) 

local _button_Confirm			= UI.getChildControl( Panel_ChatOption, 	"Button_Confirm" )
local _button_Cancle			= UI.getChildControl( Panel_ChatOption, 	"Button_Cancle" )
local _button_Close				= UI.getChildControl( Panel_ChatOption, 	"Button_WinClose" )
local _button_blockList			= UI.getChildControl( Panel_ChatOption,		"Button_BlockList" )

local _buttonQuestion	= UI.getChildControl( Panel_ChatOption, "Button_Question" )								--물음표 버튼
_buttonQuestion			: addInputEvent( "Mouse_LUp", "Panel_WebHelper_ShowToggle( \"Chatting\" )" )			--물음표 좌클릭
_buttonQuestion			: addInputEvent( "Mouse_On", "HelpMessageQuestion_Show( \"Chatting\", \"true\")" )		--물음표 마우스오버
_buttonQuestion			: addInputEvent( "Mouse_Out", "HelpMessageQuestion_Show( \"Chatting\", \"false\")" )	--물음표 마우스아웃



function HandleClicked_ChattingTypeFilter_Notice( panelIdex )
	local check = _msgFilter_Notice:IsCheck()
	chanel_Notice = check
end
function HandleClicked_ChattingTypeFilter_System( panelIdex )
	local check = _msgFilter_System:IsCheck()
	chanel_System = check
end
function HandleClicked_ChattingTypeFilter_World( panelIdex )
	local check = _msgFilter_World:IsCheck()
	chanel_World = check
end
function HandleClicked_ChattingTypeFilter_Public( panelIdex )
	local check = _msgFilter_Public:IsCheck()
	chanel_Public = check
end
function HandleClicked_ChattingTypeFilter_Private( panelIdex )
	local check = _msgFilter_Private:IsCheck()
	chanel_Private = check
end
function HandleClicked_ChattingTypeFilter_Party( panelIdex )
	local check = _msgFilter_Party:IsCheck()
	chanel_Party = check
end
function HandleClicked_ChattingTypeFilter_Guild( panelIdex )
	local check = _msgFilter_Guild:IsCheck()
	chanel_Guild = check
end
function HandleClicked_ChattingTypeFilter_Market( panelIdex )
	local check = _msgFilter_Market:IsCheck()
	chanel_Market = check
end

function ChattingOption_Initialize( panelIdex, _transparency, isCombinedMainPanel )
	_ChatOption_Title:SetText( PAGetStringParam1( Defines.StringSheet_GAME, "LUA_CHATTING_OPTION_TITLE", "panel_Index", panelIdex+1  ) )
	_msgFilter_BG:SetAlpha( 0.5 )

	local chat = ToClient_getChattingPanel( panelIdex )
	_msgFilter_Notice:	SetCheck( chat:isShowChatType( UI_CT.Notice ) )
	_msgFilter_System:	SetCheck( chat:isShowChatType( UI_CT.System ) )
	_msgFilter_World:	SetCheck( chat:isShowChatType( UI_CT.World ) )
	_msgFilter_Public:	SetCheck( chat:isShowChatType( UI_CT.Public ) )
	_msgFilter_Private:	SetCheck( chat:isShowChatType( UI_CT.Private ) )
	_msgFilter_Party:	SetCheck( chat:isShowChatType( UI_CT.Party ) )
	_msgFilter_Guild:	SetCheck( chat:isShowChatType( UI_CT.Guild ) )
	--_msgFilter_Market:	SetCheck( chat:isShowChatType( UI_CT.Market) )

	-- _msgFilter_Notice:	SetFontColor( UI_color.C_FFFFEF82 )
	-- _msgFilter_System:	SetFontColor( UI_color.C_FFC4BEBE )
	-- _msgFilter_World:	SetFontColor( UI_color.C_FFFF973A )
	-- _msgFilter_Public:	SetFontColor( UI_color.C_FFE7E7E7 )
	-- _msgFilter_Private:	SetFontColor( UI_color.C_FFF601FF )
	-- _msgFilter_Party:	SetFontColor( UI_color.C_FF84D2FF )
	-- _msgFilter_Guild:	SetFontColor( UI_color.C_FF926CFF )

	chanel_Notice	= chat:isShowChatType( UI_CT.Notice )
	chanel_System	= chat:isShowChatType( UI_CT.System )
	chanel_World	= chat:isShowChatType( UI_CT.World )
	chanel_Public	= chat:isShowChatType( UI_CT.Public )
	chanel_Private	= chat:isShowChatType( UI_CT.Private )
	chanel_Party	= chat:isShowChatType( UI_CT.Party )
	chanel_Guild	= chat:isShowChatType( UI_CT.Guild )
	--chanel_Market	= chat:isShowChatType( UI_CT.Market )

	_msgFilter_Notice:	addInputEvent( "Mouse_LUp", "HandleClicked_ChattingTypeFilter_Notice( " .. panelIdex .. " )" )
	_msgFilter_System:	addInputEvent( "Mouse_LUp", "HandleClicked_ChattingTypeFilter_System( " .. panelIdex .. " )" )
	_msgFilter_World:	addInputEvent( "Mouse_LUp", "HandleClicked_ChattingTypeFilter_World( " .. panelIdex .. " )" )
	_msgFilter_Public:	addInputEvent( "Mouse_LUp", "HandleClicked_ChattingTypeFilter_Public( " .. panelIdex .. " )" )
	_msgFilter_Private:	addInputEvent( "Mouse_LUp", "HandleClicked_ChattingTypeFilter_Private( " .. panelIdex .. " )" )
	_msgFilter_Party:	addInputEvent( "Mouse_LUp", "HandleClicked_ChattingTypeFilter_Party( " .. panelIdex .. " )" )
	_msgFilter_Guild:	addInputEvent( "Mouse_LUp", "HandleClicked_ChattingTypeFilter_Guild( " .. panelIdex .. " )" )
	--_msgFilter_Market:	addInputEvent( "Mouse_LUp", "HandleClicked_ChattingTypeFilter_Market( " .. panelIdex .. " )" )

	_alphaSlider_ControlBTN:addInputEvent( "Mouse_LPress",  "HandleClicked_ChattingSetTransparency(" .. panelIdex .. ")" )
	_alphaSlider_ControlBTN:SetPosX( ( ( _alphaSlider_Control:GetSizeX() - _alphaSlider_ControlBTN:GetSizeX() ) / 100 ) * _transparency * 100 )
	
	-- 콤바인 패널인데, 0번이 아니면 투명도 조절 불가
	if true == isCombinedMainPanel and 0 ~= panelIdex then
		_alphaSlider_Control:SetEnable( false )
		_alphaSlider_Control:SetMonoTone( true )
		_alphaSlider_ControlBTN:SetEnable( false )
		_alphaSlider_ControlBTN:SetMonoTone( true )
		_alpha_0:SetShow( false )
		_alpha_50:SetText( PAGetString(Defines.StringSheet_GAME, "LUA_CHATTING_OPTION_SUBPANEL_TRANSPARENCY_NOTIFY") )
		_alpha_100:SetShow( false )
	else
		_alphaSlider_Control:SetEnable( true )
		_alphaSlider_Control:SetMonoTone( false )
		_alphaSlider_ControlBTN:SetEnable( true )
		_alphaSlider_ControlBTN:SetMonoTone( false )
		_alpha_0:SetShow( true )
		_alpha_50:SetText("50%")
		_alpha_100:SetShow( true )
	end

	_button_Confirm:	addInputEvent( "Mouse_LUp", "HandleClicked_ChattingOption_SetFilter( "  .. panelIdex .. " )" )
	_button_Cancle:		addInputEvent( "Mouse_LUp", "ChattingOption_Close()" )
	_button_Close:		addInputEvent( "Mouse_LUp", "ChattingOption_Close()" )
	_button_blockList:	addInputEvent( "Mouse_LUp", "ChattingOption_ShowBlockList()" )
end

function HandleClicked_ChattingSetTransparency( penelIdex )
	local _transparency = ( _alphaSlider_ControlBTN:GetPosX() / ( _alphaSlider_Control:GetSizeX() - _alphaSlider_ControlBTN:GetSizeX() ))
	FGlobal_Chatting_PanelTransparency( penelIdex, _transparency )
end

function HandleClicked_ChattingOption_SetFilter( panelIdex )
	local chat = ToClient_getChattingPanel( panelIdex )
	chat:setShowChatType( UI_CT.Notice, chanel_Notice )
	chat:setShowChatType( UI_CT.System, chanel_System )
	chat:setShowChatType( UI_CT.World, chanel_World )
	chat:setShowChatType( UI_CT.Public, chanel_Public )
	chat:setShowChatType( UI_CT.Private, chanel_Private )
	chat:setShowChatType( UI_CT.Party, chanel_Party )
	chat:setShowChatType( UI_CT.Guild, chanel_Guild )
	--chat:setShowChatType( UI_CT.Market, chanel_Market )
	ChattingOption_Close()
end

function ChattingOption_Open( penelIdex, drawPanelIndex, isCombinedMainPanel )
	if false == Panel_ChatOption:GetShow() then
		Panel_ChatOption:SetShow( true, true )
		Panel_ChatOption:SetIgnore( false )
	end
	local _transparency = FGlobal_Chatting_PanelTransparency_Chk( drawPanelIndex )
	ChattingOption_Initialize( penelIdex, _transparency, isCombinedMainPanel )
end

function ChattingOption_Close()
	Panel_ChatOption:SetShow( false, false )
	Panel_ChatOption:SetIgnore( true )
end

function ChatOption_ShowAni()
	UIAni.fadeInSCR_Left(Panel_ChatOption)
end

function ChattingOption_ShowBlockList()
	clickRequestShowBlockList()
end

function ChatOption_HideAni()
	Panel_ChatOption:SetShowWithFade(UI_PSFT.PAUI_ANI_TYPE_FADE_OUT)
	local mailHideAni = Panel_ChatOption:addColorAnimation( 0.0, 0.22, UI_ANI_ADV.PAUI_ANIM_ADVANCE_SIN_HALF_PI)
	mailHideAni:SetStartColor( UI_color.C_FFFFFFFF )
	mailHideAni:SetEndColor( UI_color.C_00FFFFFF )
	mailHideAni:SetStartIntensity( 3.0 )
	mailHideAni:SetEndIntensity( 1.0 )
	mailHideAni.IsChangeChild = true
	mailHideAni:SetHideAtEnd(true)
	mailHideAni:SetDisableWhileAni(true)
end

----------------------------------------------
-- 차단 리스트 (임시) 
----------------------------------------------
local BlockList = 
{
	_uiBlockList  			= UI.getChildControl( Panel_ChatOption, "Listbox_Block" ),
	_uiBackGround			= UI.getChildControl( Panel_ChatOption, "Static_OfferWindow" ),
	_uiClose				= UI.getChildControl( Panel_ChatOption, "Block_Close" ),	
	_uiDelete				= UI.getChildControl( Panel_ChatOption, "Button_Delete" ),
	_uiAllDelete				= UI.getChildControl( Panel_ChatOption, "Button_AllDelete" ),	
	_uiScroll 				= nil,
	_uiScrollCtrlButton 	= nil,
	_selectDeleteIndex,
	_slotRows 				= 12
}

function BlockList:SetShow(isShow)
	BlockList._uiBlockList:SetShow(isShow);
	BlockList._uiBackGround:SetShow(isShow);
	BlockList._uiClose:SetShow(isShow);
	BlockList._uiDelete:SetShow(isShow);
	BlockList._uiAllDelete:SetShow(isShow);
end

function BlockList:initialize()
	self._uiScroll = UI.getChildControl( self._uiBlockList, "Block_Scroll" )
	self._uiScroll:SetControlTop()
	self._uiBlockList:addInputEvent( "Mouse_LUp", "clickBlockList()" );
	self._uiClose:addInputEvent( "Mouse_LUp", "clickCloseBlockList()" )
	self._selectDeleteIndex = -1;
	self._uiDelete:addInputEvent( "Mouse_LUp", "clickDeleteBlock()" )
	self._uiAllDelete:addInputEvent( "Mouse_LUp", "clickAllDeleteBlock()" )
	self:SetShow(false);
end

function clickCloseBlockList()
	BlockList_hide();
end

function clickDeleteBlock()
	if( -1 ~= BlockList._selectDeleteIndex ) then
		local deleteName = BlockList._uiBlockList:GetItemText(BlockList._selectDeleteIndex)
		ToClient_RequestDeleteBlockName(deleteName);
	end
end

function clickAllDeleteBlock()
	BlockList._selectDeleteIndex = -1
	ToClient_RequestDeleteAllBlockList()
end

function clickBlockList()
	BlockList._selectDeleteIndex = BlockList._uiBlockList:GetSelectIndex()
end

function BlockList:updateList()	
	local listControl = self._uiBlockList
	listControl:DeleteAll() 

	local blockCount = ToClient_RequestBlockCount()	
	for i = 0, blockCount-1, 1 do
		local blockName = ToClient_RequestGetBlockName(i)
		listControl:AddItemWithLineFeed( blockName, UI_color.C_FFFFF3AF)
	end
	UIScroll.SetButtonSize( self._uiScroll, self._slotRows, blockCount )
end

BlockList:initialize();
registerEvent( "FromClient_UpdateBlockList",	"FromClient_UpdateBlockList")

function BlockList_show()
	self._selectDeleteIndex = -1
	BlockList:SetShow(true)	
	BlockList:updateList();
end

function BlockList_hide()
	BlockList:SetShow(false)
end

function FromClient_UpdateBlockList()
	BlockList:updateList();
end

function clickRequestShowBlockList()
	if BlockList._uiBackGround:GetShow() then
		BlockList_hide()
	else
		BlockList_show()
	end
end

