local UI_ANI_ADV 				= CppEnums.PAUI_ANIM_ADVANCE_TYPE
local UCT 						= CppEnums.PA_UI_CONTROL_TYPE
local _math_MulNumberToVector	= Util.Math.MulNumberToVector
local _math_AddVectorToVector	= Util.Math.AddVectorToVector
local OPT 						= CppEnums.OtherListType
local UI_color 					= Defines.Color

local constValue = {
	interestValueMax = 1000,
	slotCountMax = 10,
	buffTypeString = { [0] = PAGetString( Defines.StringSheet_GAME, "MENTALGAME_BUFFTYPE_FAVOR" ), 
							 PAGetString( Defines.StringSheet_GAME, "MENTALGAME_BUFFTYPE_INTERESTING" ), 
							 PAGetString( Defines.StringSheet_GAME, "MENTALGAME_BUFFTYPE_DEMANDINGINTERESTING" ), 
							 PAGetString( Defines.StringSheet_GAME, "MENTALGAME_BUFFTYPE_DEMANDINGFAVOR" ) },
	hideTime = 5,
	maxPlayCount = 3
}


local mgUI = { base = {}, select = {}, tooltip = {}, left={}, center={}, right={}, zodiac={}, }

local giftIcon = {}
-- index : 0 ~ count
	-- uiControl : giftIcon UI


local gameStep = 0
-- 0 화면만 떠있음(게임중이 아닐수도 있음)
-- 1 이야기 교류가 가능한 상황
-- 2 이야기 교류중
-- 3 이야기 교류 끝
-- 4 이야기 교류 나가기 버튼 눌렀을때

local mouseInputer = nil			-- MouseInput받는 Panel UI
local isRdown = false				-- R Button Down시에 true
local rMovePos = { x = 0 , y = 0 }	-- R Dwon 시에 이전 좌표

local addIntimacy = 0

local _bestPoint = 0			-- 최대 호감 점수
local hideDeltaTime = 0			-- gameStep == 4일때 지난 시간
local endTimechk = 0			-- 게임 나가기 화면에서 꺼지는 시간 카운트
local gamePlayCount = 0			-- 게임을 시작한 횟수

local centerUiList = {}
local animationUIList = {}
local informationUI = {}
local animationList = {}
local animationIndex = 0
local selectCardIndex = -1
local prevDragImageSizeX, prevDragImageSizeY = 20,20

local mentalGame_End = false	-- 자동 종료 체크용

local scrollPosition = -5
local scrollPositionResult = 0

local scrX = getScreenSizeX()
local scrY = getScreenSizeY()

-----------------------------------------------------------------------------
-----------------------------------------------------------------------------
-- 초기화
-----------------------------------------------------------------------------
-----------------------------------------------------------------------------

local uiInit = function()
	-- mentalGame Base
	local left = mgUI.left
	left.panel				= Panel_MentalGame_Left
	left.statusBG			= UI.getChildControl(Panel_MentalGame_Left, "Static_StatusBG")
	left.statusBG_1			= UI.getChildControl(Panel_MentalGame_Left, "Static_StatusBG_1")
	left.npc_Name			= UI.getChildControl(Panel_MentalGame_Left, "StaticText_NPC_Name")
	left.npc_Status			= UI.getChildControl(Panel_MentalGame_Left, "StaticText_NPCStatus")
	left.npcDV				= UI.getChildControl(Panel_MentalGame_Left, "StaticText_npcDV")
	left.npcPV				= UI.getChildControl(Panel_MentalGame_Left, "StaticText_npcPV")
	left.statusBG_2			= UI.getChildControl(Panel_MentalGame_Left, "Static_StatusBG_2")
	left.effect				= UI.getChildControl(Panel_MentalGame_Left, "StaticText_Effect")
	left.comboCount			= UI.getChildControl(Panel_MentalGame_Left, "StaticText_ComboCount")
	left.comboCount_1		= UI.getChildControl(Panel_MentalGame_Left, "StaticText_ComboCountValue")
	left.circle				= UI.getChildControl(Panel_MentalGame_Left, "Static_Circle")
	left.circle2			= UI.getChildControl(Panel_MentalGame_Left, "Static_Circle2")
	left.failCount			= UI.getChildControl(Panel_MentalGame_Left, "StaticText_FailCount")
	left.cumulativePoint	= UI.getChildControl(Panel_MentalGame_Left, "StaticText_CumulativePoint")
	left.bestPoint			= UI.getChildControl(Panel_MentalGame_Left, "StaticText_BestPoint")
	left.statusBG_3			= UI.getChildControl(Panel_MentalGame_Left, "Static_StatusBG_3")
	left.fruitage			= UI.getChildControl(Panel_MentalGame_Left, "StaticText_Fruitage")
	left.fruitage_Value		= UI.getChildControl(Panel_MentalGame_Left, "StaticText_Fruitage_Value")
	left.fruitage_Add		= UI.getChildControl(Panel_MentalGame_Left, "StaticText_Fruitage_Add")
	left.giftNotice			= UI.getChildControl(Panel_MentalGame_Left, "StaticText_GiftNotice")
	left.progressBG			= UI.getChildControl(Panel_MentalGame_Left, "Static_ProgressBG")
	left.prograss_Current	= UI.getChildControl(Panel_MentalGame_Left, "CircularProgress_Current")
	left.prograss_Success	= UI.getChildControl(Panel_MentalGame_Left, "CircularProgress_Success")
	left.giftIcon			= UI.getChildControl(Panel_MentalGame_Left, "Static_GiftIcon")

	local base = mgUI.base
	base.panel				= Panel_MentalGame_Base
	base.comment_1			= UI.getChildControl(Panel_MentalGame_Base, "StaticText_Comment_1")
	base.comment_Value		= UI.getChildControl(Panel_MentalGame_Base, "StaticText_Comment_Value")
	base.comment_2			= UI.getChildControl(Panel_MentalGame_Base, "StaticText_Comment_2")
	-- base.apply				= UI.getChildControl(Panel_MentalGame_Base, "Button_Apply")
	base.btnTryAgain		= UI.getChildControl(Panel_MentalGame_Base, "Button_TryAgain")
	base.tryAgain			= UI.getChildControl(Panel_MentalGame_Base, "StaticText_TryAgain")
	base.nextSuccess		= UI.getChildControl(Panel_MentalGame_Base, "StaticText_NextSuccess")
	base.nextFail			= UI.getChildControl(Panel_MentalGame_Base, "StaticText_NextFail")
	base.btnGameEnd			= UI.getChildControl(Panel_MentalGame_Base, "Button_GameEnd")
	base.gameEnd			= UI.getChildControl(Panel_MentalGame_Base, "StaticText_GameEnd")
	base.result				= UI.getChildControl(Panel_MentalGame_Base, "StaticText_Result")
	base.condition			= UI.getChildControl(Panel_MentalGame_Base, "StaticText_Condition")
	base.explain			= UI.getChildControl(Panel_MentalGame_Base, "StaticText_Explain")
	base.statusBG_4			= UI.getChildControl(Panel_MentalGame_Base, "Static_StatusBG_4")

	-- mentalGame Select
	local select = mgUI.select
	select.panel			= Panel_MentalGame_Select
	select.interest			= UI.getChildControl(Panel_MentalGame_Select, "StaticText_Interest")
	select.worth			= UI.getChildControl(Panel_MentalGame_Select, "StaticText_Worth")
	select.interestAdd		= UI.getChildControl(Panel_MentalGame_Select, "StaticText_InterestAdd")
	select.worthAdd			= UI.getChildControl(Panel_MentalGame_Select, "StaticText_WorthAdd")
	select.name				= UI.getChildControl(Panel_MentalGame_Select, "StaticText_Name")
	select.number			= UI.getChildControl(Panel_MentalGame_Select, "StaticText_Number")
	select.addInterest		= UI.getChildControl(Panel_MentalGame_Select, "StaticText_AddInterest")
	select.Combo			= UI.getChildControl(Panel_MentalGame_Select, "Static_Combo")
	select.CircularProgress	= UI.getChildControl(Panel_MentalGame_Select, "CircularProgress_Progress")
	select.SuccessIcon		= UI.getChildControl(Panel_MentalGame_Select, "Static_Success")
	select.FailedIcon		= UI.getChildControl(Panel_MentalGame_Select, "Static_Failed")
	
	-- mentalGame Tooltip
	local tooltip = mgUI.tooltip
	tooltip.panel			= Panel_MentalGame_Tooltip
	tooltip.background		= UI.getChildControl(Panel_MentalGame_Tooltip, "Static_Tooltip_BG")
	tooltip.statusBG		= UI.getChildControl(Panel_MentalGame_Tooltip, "Static_Tooltip_StatusBG")
	tooltip.CommentBG		= UI.getChildControl(Panel_MentalGame_Tooltip, "Static_Tooltip_CommentBG")
	tooltip.BonusBG			= UI.getChildControl(Panel_MentalGame_Tooltip, "Static_Tooltip_BonusBG")
	tooltip.npcName			= UI.getChildControl(Panel_MentalGame_Tooltip, "StaticText_NPC_Name")
	tooltip.background		= UI.getChildControl(Panel_MentalGame_Tooltip, "Static_Tooltip_BG")
	tooltip.hitBase			= UI.getChildControl(Panel_MentalGame_Tooltip, "StaticText_Hit_Base")
	tooltip.hitBonus		= UI.getChildControl(Panel_MentalGame_Tooltip, "StaticText_Hit_Bonus")
	tooltip.ddBase			= UI.getChildControl(Panel_MentalGame_Tooltip, "StaticText_DD_Base")
	tooltip.ddBonus			= UI.getChildControl(Panel_MentalGame_Tooltip, "StaticText_DD_Bonus")
	
	tooltip.comment_1		= UI.getChildControl(Panel_MentalGame_Tooltip, "StaticText_Comment_1")
	tooltip.comment_2		= UI.getChildControl(Panel_MentalGame_Tooltip, "StaticText_Comment_2")
	tooltip.nextBonus		= UI.getChildControl(Panel_MentalGame_Tooltip, "StaticText_Bonus")
	
	-- mentalGame Center
	local center = mgUI.center
	center.panel			= Panel_MentalGame_Center
	center.finishImage		= UI.getChildControl(Panel_MentalGame_Center, "Static_Finish")
	center.finishText		= UI.getChildControl(Panel_MentalGame_Center, "StaticText_Finish")
	center.finishImage	:SetPosX( 0 )
	center.finishText	:SetPosX( 0 )
	center.finishImage	:SetPosY( getScreenSizeY() / 2 - center.finishImage	:GetSizeY() / 2 )
	center.finishText	:SetPosY( getScreenSizeY() / 2 - center.finishText	:GetSizeY() / 2 )
	center.finishText	:SetSize( getScreenSizeX(), center.finishText:GetSizeY() )
	
	
	-- mentalGame RightBottom
	local right = mgUI.right
	right.panel				= Panel_MentalGame_Right
	right.cardIcon			= UI.getChildControl(Panel_MentalGame_Right, "Static_MentalIcon_C_0")
	right.cardText			= UI.getChildControl(Panel_MentalGame_Right, "StaticText_MentalTxt_C_0")
	right.cardLeftArrow		= UI.getChildControl(Panel_MentalGame_Right, "Button_LeftArrow")
	right.cardRightArrow	= UI.getChildControl(Panel_MentalGame_Right, "Button_RightArrow")
	right.apply				= UI.getChildControl(Panel_MentalGame_Right, "Button_Apply_New")
	right.interest			= UI.getChildControl(Panel_MentalGame_Right, "StaticText_Interest")
	
	-- mentalGame CenterZodiac
	local zodiac = mgUI.zodiac
	zodiac.panel			= UI.createOtherPanel( "ZodiacCenterPanel", OPT.OtherPanelType_TagName );
	zodiac.control			= UI.createControl( CppEnums.PA_UI_CONTROL_TYPE.PA_UI_CONTROL_STATIC, zodiac.panel, 'ZodiacCenterPanelImage')

	if ( nil ~= zodiac.panel ) then
		zodiac.panel:SetAlpha(0)
		zodiac.panel:SetSize(600, 600)
		zodiac.panel:Set3DRenderType(3)
		zodiac.panel:SetDepth(0)
		zodiac.panel:SetIgnore(true)
		zodiac.panel:SetShow(false, false)

		zodiac.control:SetPosX(0)
		zodiac.control:SetPosY(0)
		zodiac.control:SetSize(600, 600)
		zodiac.control:SetAlpha(1)
		zodiac.control:SetVerticalMiddle()
		zodiac.control:SetHorizonCenter()
		zodiac.control:SetIgnore(true)
		zodiac.control:SetShow(true)
	end
	
	select.addInterest:SetShow(false)
	left.giftIcon:SetShow(false)

	local UI_TM = CppEnums.TextMode
	tooltip.nextBonus:SetTextMode( UI_TM.eTextMode_AutoWrap )


	right.cardLeftArrow	:SetAutoDisableTime(0)
	right.cardRightArrow:SetAutoDisableTime(0)
end

local registEventInit = function()
	registerEvent("startMentalGame", "MentalGame_Show")
	registerEvent("onScreenResize", "MentalGame_ScreenResize")
	registerEvent("ResponseMentalGame_updateStage", "MentalGame_StateUpdate")
	registerEvent("ResponseMentalGame_tryCard", "MentalGame_tryCard")
	registerEvent("ResponseMentalGame_endStage", "MentalGame_endStage")
	registerEvent("MentalGame_updateMatrix", "MentalGame_updateMatrix")
	registerEvent("EventSelfPlayerDead", "MentalGame_HideByDead")
	registerEvent("progressEventCancelByAttacked", "MentalGame_HideByDamage")

	mgUI.left.panel:RegisterUpdateFunc("MentalKnowledge_UpdatePosition")
	mgUI.center.panel:RegisterUpdateFunc("MentalGame_UpdateHideTime")
	mgUI.right.panel:RegisterUpdateFunc("MentalGame_UpdateEndTimer")

	local base = mgUI.base
	-- base.apply:addInputEvent("Mouse_LDown",			"MentalKnowledge_Apply_LClick()")
	base.btnGameEnd:addInputEvent("Mouse_LDown",	"MentalKnowledge_GameEnd_LClick()")
	base.btnTryAgain:addInputEvent("Mouse_LDown",	"MentalKnowledge_TryAgain_LClick()")

	local right = mgUI.right
	right.cardLeftArrow		:addInputEvent("Mouse_LDown",	"MentalKnowledge_CardRotation_Left()")
	right.cardRightArrow	:addInputEvent("Mouse_LDown",	"MentalKnowledge_CardRotation_Right()")
	right.apply:addInputEvent("Mouse_LDown",			"MentalKnowledge_Apply_LClick()")
end

local mentalBaseInit = function()
	MentalKnowledgeBase.init()
end


local createCenterUI = function()
	local mentalObject = getMentalgameObject()
	if nil == mentalObject then
		return
	end
	local createUI = function( key, uiGroup )
		
		if ( nil ~= uiGroup.panel ) then
			return
		end

		local select = mgUI.select

		local panel = UI.createPanel( "Panel_MentalGame_Select_" .. tostring(key), Defines.UIGroup.PAGameUIGroup_QuestLog )
		panel:SetAlpha(1.0)
		panel:SetSize(10, 10)
		panel:addInputEvent("Mouse_On",				"MentalKnowledge_Over(" .. key .. ",true,true)")
		panel:addInputEvent("Mouse_Out",			"MentalKnowledge_Over(" .. key .. ",true,false)")
		--panel:addInputEvent("Mouse_LDown",			"MentalKnowledge_ClearCard(" .. key .. ")")
		panel:addInputEvent("Mouse_RUp",			"MentalKnowledge_UpdateCenterSlot(" .. key .. ")")
		uiGroup.panel = panel

		panel:SetAlpha(1.0)
		panel:SetPosX( 0 )
		panel:SetPosY( 0 )
		panel:SetIgnore(false)
		panel:SetShow(false, false)

		local circularProgress = UI.createControl( CppEnums.PA_UI_CONTROL_TYPE.PA_UI_CONTROL_CIRCULAR_PROGRESS, panel, "CircularProgres_" .. key )
		CopyBaseProperty( select.CircularProgress, circularProgress )
		uiGroup.circularProgress = circularProgress
		circularProgress:ComputePos()
		circularProgress:SetPosX(0)
		circularProgress:SetPosY(0)
		circularProgress:SetShow(true)
		circularProgress:SetCurrentControlPos(0)
		circularProgress:SetProgressRate(0)
		circularProgress:SetSmoothMode(true)
		circularProgress:SetAniSpeed( mentalObject:getMentalGameSpeed() / 2000)

		local SuccessIcon = UI.createControl( CppEnums.PA_UI_CONTROL_TYPE.PA_UI_CONTROL_STATIC, panel, "SuccessIcon_" .. key )
		CopyBaseProperty( select.SuccessIcon, SuccessIcon )
		uiGroup.SuccessIcon = SuccessIcon
		SuccessIcon:ComputePos()

		local FailedIcon = UI.createControl( CppEnums.PA_UI_CONTROL_TYPE.PA_UI_CONTROL_STATIC, panel, "FailedIcon_" .. key )
		CopyBaseProperty( select.FailedIcon, FailedIcon )
		uiGroup.FailedIcon = FailedIcon
		FailedIcon:ComputePos()
	end

	local slotCount = mentalObject:getSlotCount()
	for index = 0, slotCount -1 do
		if ( nil == centerUiList[index] ) then
			centerUiList[index] = {}
		end
		createUI( index, centerUiList[index] )
	end
end

local createAnimationUI = function()
	local select = mgUI.select
	local left = mgUI.left
	local otherPanelType = CppEnums.OtherListType.OtherPanelType_Wiki
	local otherControlTextType = CppEnums.PA_UI_CONTROL_TYPE.PA_UI_CONTROL_STATICTEXT
	for from = 0, 19 do
		if ( nil == animationUIList[from] ) then
			animationUIList[from] = {}
		end
		for to = from + 1, 19 do
			if ( nil == animationUIList[from][to] ) then
				animationUIList[from][to] = {}
			end
			local targetGroup = animationUIList[from][to]

			if ( nil == targetGroup.panel ) then
				local target = UI.createPanel( "MentalGame_Animation_" .. tostring(from) .."_".. tostring(to), Defines.UIGroup.PAGameUIGroup_QuestLog )
				--CopyBaseProperty( select.panel, target )
				target:SetIgnore(true)
				target:SetShow(false)
				target:SetSpanSize(0,0)
				target:SetAlpha(1)
				target:ComputePos()
				targetGroup.panel = target
			end

			if ( nil == targetGroup.pointImage ) then
				local target = UI.createControl( otherControlTextType, targetGroup.panel, 'PointImage')
				CopyBaseProperty( select.addInterest, target )
				target:SetIgnore(true)
				target:SetShow(true)
				target:SetAlpha(0.5)
				target:SetFontAlpha(0)
				target:SetSpanSize(0,0)
				target:ComputePos()
				target:SetHorizonCenter()
				target:SetVerticalMiddle()
				targetGroup.pointImage = target
			end

			if ( nil == targetGroup.nameTag ) then
				local nameTag = UI.createControl( otherControlTextType, targetGroup.pointImage, 'NameTag')
				nameTag:SetIgnore(true)
				nameTag:SetShow(true)
				nameTag:SetSpanSize(0,30)
				nameTag:SetHorizonCenter()
				nameTag:SetVerticalBottom()
				targetGroup.nameTag = nameTag
			end

			
		end
	end
end

local createInformationUI = function()
	local select = mgUI.select
	local left = mgUI.left
	local otherPanelType = CppEnums.OtherListType.OtherPanelType_Wiki
	local otherControlTextType = CppEnums.PA_UI_CONTROL_TYPE.PA_UI_CONTROL_STATICTEXT
	for from = 0, 19 do
		if ( nil == informationUI[from] ) then
			informationUI[from] = {}
		end
		for to = from + 1, 19 do
			if ( nil == informationUI[from][to] ) then
				informationUI[from][to] = {}
			end
			local targetGroup = informationUI[from][to]

			if ( nil == targetGroup.panel ) then
				local target = UI.createPanel( "MentalGame_Information_" .. tostring(from) .."_".. tostring(to), Defines.UIGroup.PAGameUIGroup_QuestLog )
				target:SetIgnore(true)
				target:SetShow(false)
				target:SetSpanSize(0,0)
				target:SetAlpha(1)
				target:ComputePos()
				targetGroup.panel = target
			end

			if ( nil == targetGroup.pointImage ) then
				local target = UI.createControl( otherControlTextType, targetGroup.panel, 'PointImage')
				CopyBaseProperty( select.addInterest, target )
				target:SetIgnore(false)
				target:SetShow(true)
				target:SetAlpha(1)
				target:SetSpanSize(0,0)
				target:SetFontAlpha(0)
				target:ComputePos()
				target:SetHorizonCenter()
				target:SetVerticalMiddle()
				target:addInputEvent("Mouse_On",			"MentalKnowledge_InformationUIFontAlpha(" .. from .. ", " .. to .. ", 1.0,true)")
				target:addInputEvent("Mouse_Out",			"MentalKnowledge_InformationUIFontAlpha(" .. from .. ", " .. to .. ", 0.0,true)")

				targetGroup.pointImage = target
			end

			if ( nil == targetGroup.nameTag ) then
				local nameTag = UI.createControl( otherControlTextType, targetGroup.pointImage, 'NameTag')
				nameTag:SetIgnore(true)
				nameTag:SetShow(true)
				nameTag:SetFontAlpha(0)
				nameTag:SetSpanSize(0,30)
				nameTag:SetHorizonCenter()
				nameTag:SetVerticalBottom()
				targetGroup.nameTag = nameTag
			end

			
		end
	end
end

local createMouseInputerAndSetting = function()
	mouseInputer = UI.createPanel("MentalGame_MouseInputer", Defines.UIGroup.PAGameUIGroup_ScreenEffect)
	mouseInputer:SetAlpha(0.0)
	mouseInputer:SetPosX(0)
	mouseInputer:SetPosY(0)
	mouseInputer:SetSize(getScreenSizeX(), getScreenSizeY())
	mouseInputer:addInputEvent("Mouse_LDown",		"MentalKnowledge_OnLDown()")
	mouseInputer:addInputEvent("Mouse_LUp",			"MentalKnowledge_OnLUp()")
	mouseInputer:addInputEvent("Mouse_RDown",		"MentalKnowledge_OnRDown()")
	mouseInputer:addInputEvent("Mouse_RUp",			"MentalKnowledge_OnRUp()")
	mouseInputer:addInputEvent("Mouse_UpScroll",	"MentalKnowledge_OnWheelUp()")
	mouseInputer:addInputEvent("Mouse_DownScroll",	"MentalKnowledge_OnWheelDown()")
	

	mouseInputer:SetShow(false, false)
end

local init = function()
	uiInit()
	registEventInit()
	mentalBaseInit()
	createCenterUI()
	createAnimationUI()
	createInformationUI()
	createMouseInputerAndSetting()
end


-----------------------------------------------------------------------------
-----------------------------------------------------------------------------
-- 
-----------------------------------------------------------------------------
-----------------------------------------------------------------------------

local posUpdateAnimation = function( key, value )
	local mentalObject = getMentalgameObject()
	if nil == mentalObject then
		return
	end
	
	local basePos = mentalObject:getCardPos()
	local pos = mentalObject:getLerpBySlot(value.startIndex, value.endIndex, (value.deltaTime - value.startTime) / ( value.endTime - value.startTime ) )
	local float3Pos = Util.Math.AddVectorToVector(basePos, pos)
	local transformData = getTransformRevers( float3Pos.x, float3Pos.y, float3Pos.z )
	value.ui:SetPosX( transformData.x - value.ui:GetSizeX() / 2 )
	value.ui:SetPosY( transformData.y - value.ui:GetSizeY() / 2 )
end

local fontalphaUpdateAnimation = function( key, value )
	local playTime = (value.endTime - value.startTime)
	local halfPlayTime = (value.endTime - value.startTime) / 2
	local inPlayDelta = value.deltaTime - value.startTime
	if ( value.startTime + halfPlayTime <= value.deltaTime ) then
		value.ui:SetFontAlpha( ( playTime - inPlayDelta ) / halfPlayTime)
		value.ui:SetAlpha(inPlayDelta / halfPlayTime)
	else
		value.ui:SetFontAlpha(inPlayDelta / halfPlayTime)
		value.ui:SetAlpha(inPlayDelta / halfPlayTime)
	end
end

local addAnimation = function( ui , startTime, endTime, startIndex, endIndex, animationFunc )
	if ( endTime <= startTime ) or ( nil == ui ) or ( endTime <= 0 ) or ( nil == animationFunc ) then
		return
	end
	animationList[animationIndex] = { ui = ui , startTime = startTime, endTime = endTime, startIndex = startIndex, endIndex = endIndex, deltaTime = 0, animationFunc = animationFunc }
	animationIndex = animationIndex + 1
end

local updateAnimationList = function (deltaTime)
	
	for key, value in pairs( animationList ) do
		value.deltaTime = value.deltaTime + deltaTime
		if ( value.endTime < value.deltaTime ) then
			value.ui:SetShow(false)
			animationList[key] = nil
		elseif ( value.startTime <= value.deltaTime ) then
			value.animationFunc(key, value)
			value.ui:SetShow(true)
		else
			value.ui:SetShow(false)
		end
	end
end

local clearAnimation = function()
	for key, value in pairs( animationList ) do
		value.ui:SetShow(false)
	end	
	animationList = {}
end


-----------------------------------------------------------------------------
-----------------------------------------------------------------------------
-- pick element
-----------------------------------------------------------------------------
-----------------------------------------------------------------------------


local createControl = function(panel, fromType, name, targetObject, key)
	local target = UI.createControl( fromType, panel, name .. tostring(key) )
	CopyBaseProperty( mgUI.select[name], target )
	target:SetIgnore(true)
	target:SetShow(true)
	target:ComputePos()
	return target
end

--별자리 그려주는 로직
local circleKeyList = {}
local insertCircleLineAndObject = function()
	MentalKnowledgeBase.init()

	MentalKnowledgeBase.circleSize = 25
	MentalKnowledgeBase.color = float4( 1, 1, 1, 1 )
	MentalKnowledgeBase.lineWidth = 1.5


	local mentalObject = getMentalgameObject()
	if nil == mentalObject then
		return
	end
	
	local basePos = mentalObject:getCardPos()
	local slotCount = mentalObject:getSlotCount()
	local pointCount = mentalObject:getPointCount()
	local orderCount = mentalObject:getOrderCount()

	--기본원
	for index = 0 , pointCount -1 do
		local starPos = mentalObject:getPoint(index)
		local float3Pos = Util.Math.AddVectorToVector(basePos, starPos)
		local circleKey = MentalKnowledgeBase.InsertCircle( float3Pos, 1 )
		circleKeyList[index] = circleKey
	end

	--별자리선
	local lineCount = mentalObject:getLineCount()
	for index = 0, lineCount - 1 do
		local firstIndex = mentalObject:getLineFirst(index)
		local secondIndex = mentalObject:getLineSecond(index)

		MentalKnowledgeBase.InsertLineByCircle( circleKeyList[firstIndex] , circleKeyList[secondIndex] )
	end

	--효과선 및 가운데 점.
	MentalKnowledgeBase.usingEndArrow = true
	MentalKnowledgeBase.arrowLineWidth	= 9
	MentalKnowledgeBase.lineWidth = 20
	MentalKnowledgeBase.color = float4( 30 / 255, 209 / 255, 253 / 255, 0.3 )
	MentalKnowledgeBase.arrowColor = float4( 30 / 255, 209 / 255, 253 / 255, 0.3 )
	for srcSlot = 0, orderCount - 2 do
		for dstSlot = srcSlot + 1, orderCount - 1 do
			local srcIndex = mentalObject:getOrder(srcSlot)
			local dstIndex = mentalObject:getOrder(dstSlot)
			if ( -1 ~= srcIndex ) and ( -1 ~= dstIndex ) then
				local isApplied = mentalObject:isAppliedEffect(srcSlot, dstSlot)
				local panel = informationUI[srcSlot][dstSlot].panel
				local nameTag = informationUI[srcSlot][dstSlot].nameTag
				local card = mentalObject:getCardBySlotIndex(srcIndex)
				if ( isApplied ) then
					MentalKnowledgeBase.InsertLineByCircle( circleKeyList[srcIndex] , circleKeyList[dstIndex] )
					
					local inputText = constValue.buffTypeString[card:getBuffType()] .. " : " .. card:getVariedValue()
	
					local pos = mentalObject:getLerpBySlot(srcSlot, dstSlot, 0.5 )
					local float3Pos = Util.Math.AddVectorToVector(basePos, pos)
					local transformData = getTransformRevers( float3Pos.x, float3Pos.y, float3Pos.z )
					nameTag:SetText( inputText )
					panel:SetPosX( transformData.x - panel:GetSizeX() / 2 )
					panel:SetPosY( transformData.y - panel:GetSizeY() / 2 )
					panel:SetShow(true)
				else
					panel:SetShow(false)
				end
			end
		end
	end

	--진행순서 선
	MentalKnowledgeBase.lineWidth = 4
	MentalKnowledgeBase.arrowLineWidth = 4
	MentalKnowledgeBase.color = float4( 0.83, 0.79, 0.54, 1.0 )
	MentalKnowledgeBase.arrowColor = float4( 0.83, 0.79, 0.54, 1.0 )
	local prevIndex = -1
	for srcIndex = 0, orderCount - 1 do
		if ( nil ~= mentalObject:getCardBySlotOrder(srcIndex) ) then
			local currIndex = srcIndex
			if ( -1 < prevIndex ) then
				local slotNumberSrc = mentalObject:getOrder(prevIndex)
				local slotNumberDst = mentalObject:getOrder(currIndex)
				MentalKnowledgeBase.InsertLineByCircle( circleKeyList[slotNumberSrc] , circleKeyList[slotNumberDst] )
			end
			prevIndex = currIndex
		end
	end


	MentalKnowledgeBase.UpdateLineAndCircle() --원과 선의 위치를 맞추어줌.
end

--별자리 지워주는 로직
local removeCircleLineAndObject = function()
	circleKeyList = {}
	MentalKnowledgeBase.ClearLineAndCircle()
end

local insertCircleLine_CardEffect = function()
	
end


local rightCardList = {  }
local createControlRight = function(panel, fromType, name, targetObject, key)
	local target = UI.createControl( fromType, panel, name .. tostring(key) )
	targetObject.ui[name] = target
	CopyBaseProperty( mgUI.right[name], target )
	target:SetShow(true)
	target:ComputePos()
	return target
end
local _aControlPos = 0
local _aTextControlPos = 0
	
local insertCardList = function()
	local right = mgUI.right

	local aControl = {}
	local aTextControl = {}
	local index = 0
	local PrePosY = 0
	
	local mentalObject = getMentalgameObject()
	if nil == mentalObject then
		return
	end
	
	local count = mentalObject:getCardCount()
	for index = 0, count - 1 do
		local cardWrapper = mentalObject:getCard(index)
		local gap = right.cardIcon:GetSizeY() * 13 / 10
		if ( nil == rightCardList[index] ) then
			rightCardList[index] = { ui = {} }
		end
		if ( nil == rightCardList[index].ui ) then
			rightCardList[index].ui = {}
		end

		if ( nil == rightCardList[index].ui.cardText ) then

			aTextControl[index] = createControlRight( right.panel, UCT.PA_UI_CONTROL_STATICTEXT, "cardText", rightCardList[index], index)
			aTextControl[index]:SetPosX( index * gap )
			aTextControl[index]:SetAutoResize( true )
			aTextControl[index]:SetTextMode( CppEnums.TextMode.eTextMode_AutoWrap )
			aTextControl[index]:SetText(cardWrapper:getName())
			aTextControl[index]:SetVerticalBottom();
			
			aControl[index] = createControlRight( aTextControl[index], UCT.PA_UI_CONTROL_STATIC, "cardIcon", rightCardList[index], index)
			aControl[index]:ChangeTextureInfoName(cardWrapper:getPicture())

			aControl[index]:SetVerticalTop()
			aControl[index]:SetSpanSize(0, 0 - aControl[index]:GetSizeY())
			aControl[index]:SetIgnore(false)
			aControl[index]:addInputEvent("Mouse_LDown",			"MentalKnowledge_OnLDown_Card(" .. index .. " )")
			--aControl[index]:addInputEvent("Mouse_LUp",				"MentalKnowledge_OnLUp(" .. index .. " )")
			aControl[index]:addInputEvent("Mouse_RDown",			"MentalKnowledge_OnRDown_Card(" .. index .. " )")
			aControl[index]:addInputEvent("Mouse_On",				"MentalKnowledge_Over(" .. index .. ",false,true)")
			aControl[index]:addInputEvent("Mouse_Out",				"MentalKnowledge_Over(" .. index .. ",false,false)")
			if ( mentalObject:isBanedCard(cardWrapper) or mentalObject:isSelectedCard(cardWrapper) ) then
				aControl[index]:SetColor(UI_color.C_FF626262)
			else
				aControl[index]:SetColor(UI_color.C_FFFFFFFF)
			end

			aControl[index]:SetHorizonCenter();
			_aControlPos = aControl[index]:GetPosY()
		else
			aControl[index] = rightCardList[index].ui.cardIcon
		end
		
		if ( PrePosY < aTextControl[index]:GetSizeY() ) then
			PrePosY = aTextControl[index]:GetSizeY()
		end

	end
	for  index = 0, count - 1 do
		aTextControl[index]:SetSize(aTextControl[index]:GetSizeX(), PrePosY)
		aTextControl[index]:ComputePos()
		aControl[index]:ComputePos()
	end
end

local updateCardColor = function()
	--rightCardList[index].ui.cardText
	local mentalObject = getMentalgameObject()
	if nil == mentalObject then
		return
	end
	
	local count = mentalObject:getCardCount()
	for index = 0, count - 1 do
		local cardWrapper = mentalObject:getCard(index)
		if ( nil ~= rightCardList[index] ) and ( nil ~= rightCardList[index].ui ) and ( nil ~= rightCardList[index].ui.cardIcon ) then
			local iconUI = rightCardList[index].ui.cardIcon
			if ( mentalObject:isBanedCard(cardWrapper) or mentalObject:isSelectedCard(cardWrapper) ) then
				iconUI:SetColor(UI_color.C_FF626262)
			else
				iconUI:SetColor(UI_color.C_FFFFFFFF)
			end
		end
	end
end

local clearCardList = function()
	local right = mgUI.right
	for _, value in pairs(rightCardList) do
		if ( nil ~= value.ui ) and ( nil ~= value.ui.cardText ) then
			right.panel:RemoveControl(value.ui.cardText)
		end
	end
	rightCardList = {}
end

local updateCenterBackground = function()
	local mentalObject = getMentalgameObject()
	if nil == mentalObject then
		return
	end
	
	local yawpitchroll = mentalObject:getYawPitchRoll()

	mgUI.zodiac.panel:Set3DRotationX(yawpitchroll.x)
	mgUI.zodiac.panel:Set3DRotationY(yawpitchroll.y)
	mgUI.zodiac.panel:Set3DRotationZ(yawpitchroll.z)
	mgUI.zodiac.panel:SetWorldPosX( mentalObject:getCardPos().x )
	mgUI.zodiac.panel:SetWorldPosY( mentalObject:getCardPos().y )
	mgUI.zodiac.panel:SetWorldPosZ( mentalObject:getCardPos().z )

	mgUI.zodiac.control:SetScale( mentalObject:getScale(), mentalObject:getScale() )
end


-----------------------------------------------------------------------------
-----------------------------------------------------------------------------
-- 
-----------------------------------------------------------------------------
-----------------------------------------------------------------------------

local updateStateUIShow = function()
	if ( false == mouseInputer:GetShow() ) then
		return
	end
	local base = mgUI.base
	local left = mgUI.left
	local center = mgUI.center
	local right = mgUI.right

	if ( 0 == gameStep ) then -- 0 화면만 떠있음(게임중이 아닐수도 있음)
		right.panel				:SetShow(true, false)
		left.fruitage_Add		:SetShow(true)
		base.comment_1			:SetShow(true)
		base.comment_Value		:SetShow(true)
		base.comment_2			:SetShow(true)
		right.apply				:SetShow(false)
		right.interest			:SetShow(true)
		base.btnTryAgain		:SetShow(false)
		base.tryAgain			:SetShow(false)
		base.nextSuccess		:SetShow(false)
		base.nextFail			:SetShow(false)
		base.btnGameEnd			:SetShow(false)
		base.gameEnd			:SetShow(false)
		base.result				:SetShow(false)
		center.finishText		:SetShow(false)
		center.finishImage		:SetShow(false)
		center.panel			:SetShow(false)
	elseif ( 1 == gameStep ) then -- 1 이야기 교류가 가능한 상황
		left.fruitage_Add		:SetShow(true)
		base.comment_1			:SetShow(true)
		base.comment_Value		:SetShow(false)
		base.comment_2			:SetShow(false)
		right.apply				:SetShow(true)
		right.apply				:SetIgnore(false)
		right.interest			:SetShow(false)
		base.btnTryAgain		:SetShow(false)
		base.tryAgain			:SetShow(false)
		base.nextSuccess		:SetShow(false)
		base.nextFail			:SetShow(false)
		base.btnGameEnd			:SetShow(false)
		base.gameEnd			:SetShow(false)
		base.result				:SetShow(false)
		center.finishText		:SetShow(false)
		center.finishImage		:SetShow(false)
		center.panel			:SetShow(false)
	elseif ( 2 == gameStep ) then -- 2 이야기 교류중
		left.fruitage_Add		:SetShow(true)
		base.comment_1			:SetShow(false)
		base.comment_Value		:SetShow(false)
		base.comment_2			:SetShow(false)
		right.apply				:SetShow(false)
		right.interest			:SetShow(true)
		base.btnTryAgain		:SetShow(false)
		base.tryAgain			:SetShow(false)
		base.nextSuccess		:SetShow(false)
		base.nextFail			:SetShow(false)
		base.btnGameEnd			:SetShow(false)
		base.gameEnd			:SetShow(false)
		base.result				:SetShow(false)
		center.finishText		:SetShow(false)
		center.finishImage		:SetShow(false)
		center.panel			:SetShow(false)
	elseif ( 3 == gameStep ) then -- 3 이야기 교류 끝
		local mentalStage = RequestMentalGame_getMentalStage();
		local playableNextGame = gamePlayCount < constValue.maxPlayCount

		left.fruitage_Add		:SetShow(true)
		base.comment_1			:SetShow(false)
		base.comment_Value		:SetShow(false)
		base.comment_2			:SetShow(false)
		right.apply				:SetShow(false)
		right.interest			:SetShow(true)
		base.btnTryAgain		:SetShow(mentalStage._isSuccess and playableNextGame)
		base.tryAgain			:SetShow(mentalStage._isSuccess and playableNextGame)
		base.nextSuccess		:SetShow(mentalStage._isSuccess and playableNextGame)
		base.nextFail			:SetShow(mentalStage._isSuccess and playableNextGame)
		base.btnGameEnd			:SetShow(true)
		base.gameEnd			:SetShow(true)
		base.result				:SetShow(true)
		center.finishText		:SetShow(false)
		center.finishImage		:SetShow(false)
		center.panel			:SetShow(false)
	elseif ( 4 == gameStep ) then
		left.panel				:SetShow(false)
		base.panel				:SetShow(false)
		center.panel			:SetShow(true)
		center.finishText		:SetShow(true)
		center.finishText		:SetTextHorizonCenter()
		center.finishText		:SetTextVerticalCenter()
		center.finishImage		:SetShow(true)

		local aniInfo1 = center.finishImage:addScaleAnimation( 0.0, 0.16, UI_ANI_ADV.PAUI_ANIM_ADVANCE_COS_HALF_PI)
		aniInfo1:SetStartScale(0.5)
		aniInfo1:SetEndScale(1.15)
		aniInfo1.AxisX = center.finishImage:GetSizeX() / 2
		aniInfo1.AxisY = center.finishImage:GetSizeY() / 2
		aniInfo1.ScaleType = 2
		aniInfo1.IsChangeChild = true
		
		local aniInfo2 = center.finishImage:addScaleAnimation( 0.16, 0.3, UI_ANI_ADV.PAUI_ANIM_ADVANCE_COS_HALF_PI)
		aniInfo2:SetStartScale(1.15)
		aniInfo2:SetEndScale(1.0)
		aniInfo2.AxisX = center.finishImage:GetSizeX() / 2
		aniInfo2.AxisY = center.finishImage:GetSizeY() / 2
		aniInfo2.ScaleType = 2
		aniInfo2.IsChangeChild = true

		local aniInfo3 = center.finishText:addScaleAnimation( 0.0, 0.16, UI_ANI_ADV.PAUI_ANIM_ADVANCE_COS_HALF_PI)
		aniInfo3:SetStartScale(0.5)
		aniInfo3:SetEndScale(1.15)
		aniInfo3.AxisX = center.finishText:GetSizeX() / 2
		aniInfo3.AxisY = center.finishText:GetSizeY() / 2
		aniInfo3.ScaleType = 2
		aniInfo3.IsChangeChild = true
		
		local aniInfo4 = center.finishText:addScaleAnimation( 0.16, 0.3, UI_ANI_ADV.PAUI_ANIM_ADVANCE_COS_HALF_PI)
		aniInfo4:SetStartScale(1.15)
		aniInfo4:SetEndScale(1.0)
		aniInfo4.AxisX = center.finishText:GetSizeX() / 2
		aniInfo4.AxisY = center.finishText:GetSizeY() / 2
		aniInfo4.ScaleType = 2
		aniInfo4.IsChangeChild = true
	end
end

local updateState = function()
	local left = mgUI.left
	local base = mgUI.base
	
	local mentalStage = RequestMentalGame_getMentalStage()
	local mentalObject = getMentalgameObject()
	if nil == mentalObject then
		return
	end
	
	local goaltype = mentalObject:getGoalType()
	local destGoalValue = mentalObject:getDestGoalValue()
	local currentDv = mentalObject:getCurrentDV()
	local currentPv = mentalObject:getCurrentPV()
	local comboCount = mentalObject:getCombo()
	local variedDv = mentalObject:getVariedDv()
	local variedPv = mentalObject:getVariedPv()
	

	local talker = dialog_getTalker()
	local talkerName = ""
	if ( nil ~= talker ) then
		talkerName = talker:getName()
		end
	left.npc_Name:SetText(tostring(talkerName))

	if (variedDv ~= 0 and variedPv ~= 0) then
		left.npcDV:SetText(constValue.buffTypeString[1] .. " : " .. tostring(currentDv) .." - "..variedDv)
		left.npcPV:SetText(constValue.buffTypeString[0] .. " : " .. tostring(currentPv) .." - "..variedPv)
	elseif (variedDv == 0 and variedPv ~= 0) then
		left.npcDV:SetText(constValue.buffTypeString[1] .. " : " .. tostring(currentDv) )
		left.npcPV:SetText(constValue.buffTypeString[0] .. " : " .. tostring(currentPv) .." - "..variedPv)
	elseif (variedDv ~= 0 and variedPv == 0) then
		left.npcDV:SetText(constValue.buffTypeString[1] .. " : " .. tostring(currentDv) .." - "..variedDv)
		left.npcPV:SetText(constValue.buffTypeString[0] .. " : " .. tostring(currentPv) )
	else
		left.npcDV:SetText(constValue.buffTypeString[1] .. " : " .. tostring(currentDv) )
		left.npcPV:SetText(constValue.buffTypeString[0] .. " : " .. tostring(currentPv) )
	end

	base.condition:SetShow(true)
	base.statusBG_4:SetShow(true)
	
	if( 3 == gameStep )	then 
		base.condition:SetShow(false)
		base.statusBG_4:SetShow(false)
		
	elseif(goaltype == 0)	then 
		local temp1 = PAGetStringParam1(  Defines.StringSheet_GAME,  "MENTALGAME_TALKING_FREE",  "target", tostring(talkerName) );
		base.condition:SetText(temp1)

	elseif(goaltype == 1)	then  -- 흥미 유발 횟수
		local temp1 = ""
		if ( 1 == destGoalValue ) then
			temp1 = PAGetStringParam1(  Defines.StringSheet_GAME,  "MENTALGAME_TALKING_INTERESTING",  "target", tostring(talkerName) );
		else
			temp1 = PAGetStringParam2(  Defines.StringSheet_GAME,  "MENTALGAME_TALKING_INTERESTING_COMBO",  "target", tostring(talkerName), "count", tostring(destGoalValue) );
		end
		base.condition:SetText(temp1)

	elseif(goaltype == 2)	then  -- 누적 호감도
		local temp1 = PAGetStringParam2(  Defines.StringSheet_GAME,  "MENTALGAME_TALKING_ACCUMULATE",  "target", tostring(talkerName), "count", tostring(destGoalValue) );
		base.condition:SetText(temp1)
	elseif(goaltype == 3)	then  -- 최대 호감도
		local temp1 = PAGetStringParam2(  Defines.StringSheet_GAME,  "MENTALGAME_TALKING_MOST",  "target", tostring(talkerName), "count", tostring(destGoalValue) );
		base.condition:SetText(temp1)
	elseif(goaltype == 4)	then -- 흥미 유발 실패
		local temp1 = PAGetStringParam2(  Defines.StringSheet_GAME,  "MENTALGAME_TALKING_FAILED",  "target", tostring(talkerName), "count", tostring(destGoalValue) );
		base.condition:SetText(temp1)
	end


	if ( base.condition:GetShow() ) then
		local leftPos = 0
		leftPos = base.condition:GetTextSizeX() + 5
		leftPos = (base.panel:GetSizeX() - leftPos) / 2
		-- base.condition:SetPosX( leftPos )
	end

	left.comboCount_1:SetPosX( ( left.comboCount:GetPosX() + left.comboCount:GetTextSizeX() + 3 )  )
	left.comboCount_1:SetText(tostring(comboCount))
	if ( 0 < comboCount and gameStep == 2) then
		left.comboCount_1:ResetVertexAni()
		left.comboCount_1:SetVertexAniRun( "Ani_Color_0", true )
		left.comboCount_1:SetVertexAniRun( "Ani_Color_1", true )

		-- left.circle:SetShow(true)
		left.circle:ResetVertexAni()
		left.circle:SetPosX(left.comboCount_1:GetPosX() - 3)
		left.circle:SetPosY(left.comboCount_1:GetPosY() - 3)
		-- left.circle:SetPosX(left.comboCount_1:GetPosX() + left.comboCount_1:GetTextSizeX() / 2 - left.circle:GetSizeX() / 2 + 3 )
		-- left.circle:SetPosY(left.comboCount_1:GetPosY() + left.comboCount_1:GetSizeY() / 2 - left.circle:GetSizeY() / 2 )
		-- left.circle:SetVertexAniRun( "Ani_Scale_Circle0", true )
		-- left.circle:SetVertexAniRun( "Ani_Scale_Circle1", true )
		-- left.circle:SetVertexAniRun( "Ani_Scale_Circle2", true )
		-- left.circle:SetVertexAniRun( "Ani_Color_Circle0", true )
		-- left.circle:SetVertexAniRun( "Ani_Color_Circle1", true )
		-- left.circle:SetVertexAniRun( "Ani_Color_Circle2", true )
		
		-- left.circle2:SetShow(true)
		left.circle2:ResetVertexAni()
		left.circle2:SetPosX(left.comboCount_1:GetPosX())
		left.circle2:SetPosY(left.comboCount_1:GetPosY())
		-- left.circle2:SetPosX(left.comboCount_1:GetPosX() + left.comboCount_1:GetTextSizeX() / 2 - left.circle2:GetSizeX() / 2 + 3 )
		-- left.circle2:SetPosY(left.comboCount_1:GetPosY() + left.comboCount_1:GetSizeY() / 2 - left.circle2:GetSizeY() / 2 )
		-- left.circle2:SetVertexAniRun( "Ani_Scale_Circle0", true )
		-- left.circle2:SetVertexAniRun( "Ani_Scale_Circle1", true )
		-- left.circle2:SetVertexAniRun( "Ani_Scale_Circle2", true )
		-- left.circle2:SetVertexAniRun( "Ani_Color_Circle0", true )
		-- left.circle2:SetVertexAniRun( "Ani_Color_Circle1", true )
		-- left.circle2:SetVertexAniRun( "Ani_Color_Circle2", true )
	end
	
	local temp1 = PAGetStringParam1( Defines.StringSheet_GAME,  "MENTALGAME_TALK_INTERESTING_FAILED",  "count", tostring(mentalObject:getFail()) );
	local temp2 = PAGetStringParam1( Defines.StringSheet_GAME,  "MENTALGAME_TALK_ACC_INTERESTING", "count", tostring(mentalObject:getTotalInterest())  )
	local temp3 = PAGetStringParam1( Defines.StringSheet_GAME,  "MENTALGAME_TALK_MOST_INTERESTING", "count", tostring(_bestPoint)  )
		

	left.failCount:SetText(temp1)
	left.cumulativePoint:SetText(temp2)
	left.bestPoint:SetText(temp3)

	if( 3 == gameStep )	then 
		base.explain:SetShow(false)
	elseif(goaltype == 0)	then 	-- 게임 방법 설명
		base.explain:SetShow(false)
	elseif(goaltype == 1)	then	-- 흥미 유발 횟수
		base.explain:SetText( PAGetString(  Defines.StringSheet_GAME, "MENTALGAME_TALK_TIP1" ) )
		base.explain:SetShow(true)
	elseif(goaltype == 2)	then	-- 누적 호감도	
		base.explain:SetText(PAGetString(  Defines.StringSheet_GAME, "MENTALGAME_TALK_TIP2" ))
		base.explain:SetShow(true)
	elseif(goaltype == 3)	then	-- 최대 호감도	
		base.explain:SetText(PAGetString(  Defines.StringSheet_GAME, "MENTALGAME_TALK_TIP3" ))
		base.explain:SetShow(true)
	elseif(goaltype == 4)	then	-- 흥미 유발 실패
		base.explain:SetText(PAGetString(  Defines.StringSheet_GAME, "MENTALGAME_TALK_TIP4" ))
		base.explain:SetShow(true)
	end	
	-- base.explain:SetPosX(base.condition:GetPosX() + 30)
	
	local talker = dialog_getTalker()
	local intimacy = 0
	if ( nil ~= talker ) then
		intimacy = talker:getIntimacy()
	end
	left.fruitage_Value:SetText(tostring(intimacy))

	local valuePercent = intimacy / constValue.interestValueMax * 100
	if ( 100 < valuePercent ) then
		valuePercent = 100
	end
	left.prograss_Success:SetProgressRate(valuePercent);

	valuePercent = ( intimacy + addIntimacy ) / constValue.interestValueMax * 100
	if ( 100 < valuePercent ) then
		valuePercent = 100
	end
	left.prograss_Current:SetProgressRate(valuePercent);
end

local updateTooltipContext = function(mentalCard, isInserted, slotIndex)
	local mentalObject = getMentalgameObject()
	if ( nil == mentalCard ) or ( nil == mentalObject ) then
		return false
	end

	local maxHitPercent = mentalCard:getHit() / mentalObject:getCurrentDV() * 100
	local minDamage = mentalCard:getMinDD() - mentalObject:getCurrentPV()
	local maxDamage = mentalCard:getMaxDD() - mentalObject:getCurrentPV()
	local _mentalCard = mentalCard:getStaticStatus()
	local objectHit = mentalCard:getHit()

	if ( maxHitPercent < 0 ) then
		maxHitPercent = 0
	elseif ( 100 < maxHitPercent ) then
		maxHitPercent = 100
	end

	if minDamage < 0 then
		minDamage = 0
	end
	if maxDamage < 0 then
		maxDamage = 0
	end
	
	local buffText = PAGetString(  Defines.StringSheet_GAME, "MENTALGAME_BUFF_EMPTY" )
	if (_mentalCard:isBuff() ) then
		if (_mentalCard:getApplyTurn() == 0) then
			if (_mentalCard:getBuffType() < 2) then
				buffText = PAGetStringParam3(  Defines.StringSheet_GAME, "MENTALGAME_BUFF_MESSAGE_1_UP", "buff", constValue.buffTypeString[_mentalCard:getBuffType()],"turn", tostring(_mentalCard:getValidTurn()), "value" , tostring(  _mentalCard:getVariedValue() ) );
			else 
				buffText = PAGetStringParam3(  Defines.StringSheet_GAME, "MENTALGAME_BUFF_MESSAGE_1_DOWN", "buff", constValue.buffTypeString[_mentalCard:getBuffType()],"turn", tostring(_mentalCard:getValidTurn()), "value" , tostring(  _mentalCard:getVariedValue() ) );
			end
		else
			if (_mentalCard:getBuffType() < 2) then
				buffText = PAGetStringParam4(  Defines.StringSheet_GAME, "MENTALGAME_BUFF_MESSAGE_ANY_UP", "count", tostring(_mentalCard:getApplyTurn()+1), "buff", constValue.buffTypeString[_mentalCard:getBuffType()],"turn", tostring(_mentalCard:getValidTurn()), "value" , tostring(  _mentalCard:getVariedValue() ) );
			else 
				buffText = PAGetStringParam4(  Defines.StringSheet_GAME, "MENTALGAME_BUFF_MESSAGE_ANY_DOWN", "count", tostring(_mentalCard:getApplyTurn()+1), "buff", constValue.buffTypeString[_mentalCard:getBuffType()],"turn", tostring(_mentalCard:getValidTurn()), "value" , tostring(  _mentalCard:getVariedValue() ) );
			end
		end
	end

	local overKey_StaticKey = _mentalCard:getKey()
	local overKeyIndex = -1

	for index = 0, constValue.slotCountMax - 1 do
		local mentalCardData = RequestMentalGame_getCardSlotAt(index)
		if mentalCardData ~= nil then
			if ( mentalCardData:getStaticStatus():getKey() == overKey_StaticKey ) then
				overKeyIndex = index
				break
			end
		else
			overKeyIndex = index
			break
		end
	end

	local tooltip = mgUI.tooltip
	
	tooltip.hitBase:SetText( constValue.buffTypeString[1] .. " : " .. mentalCard:getHit() )
	tooltip.ddBase:SetText( constValue.buffTypeString[0] .. " : " .. mentalCard:getMinDD() .. " ~ " .. mentalCard:getMaxDD() )
	tooltip.npcName:SetText( mentalCard:getName() )
	
	local temp1 = PAGetStringParam2(  Defines.StringSheet_GAME, "MENTALGAME_TOOLTIP_CAUSE_INTERESTING", "hit", tostring(objectHit), "percent" , string.format("%.0f", maxHitPercent) );
	local temp2 = PAGetStringParam2(  Defines.StringSheet_GAME, "MENTALGAME_TOOLTIP_FAVOR", "min", tostring(minDamage), "max" , tostring(  maxDamage ) );
		
	tooltip.comment_1:SetText( temp1 )
	tooltip.comment_2:SetText( temp2 )
	
	local hitBonusText = ""
	local ddBonusText = ""
	local valueText = ""

	if ( isInserted ) then
		local startIndex = mentalObject:getBuffStartIndex( slotIndex, 0 )
		for index = startIndex , slotIndex - 1 do
			local value = mentalObject:getBuffValue( index )
			if ( 0 < value ) then
				valueText = " +" .. tostring(value)
			elseif ( value < 0 ) then
				valueText = " " .. tostring(value)
			else
				valueText = ""
			end
			ddBonusText = ddBonusText .. valueText
		end

		local startIndex = mentalObject:getBuffStartIndex( slotIndex, 1 )
		for index = startIndex , slotIndex - 1 do
			local value = mentalObject:getBuffValue( index )
			if ( 0 < value ) then
				valueText = " +" .. tostring(value)
			elseif ( value < 0 ) then
				valueText = " " .. tostring(value)
			else
				valueText = ""
			end
			hitBonusText = hitBonusText .. valueText
		end
	end

	tooltip.nextBonus:SetText( buffText )
	tooltip.hitBonus:SetText( hitBonusText )
	tooltip.ddBonus:SetText( ddBonusText )

	tooltip.hitBonus:SetPosX( tooltip.hitBase:GetPosX() + tooltip.hitBase:GetSizeX() + tooltip.hitBase:GetTextSizeX() + 5 )
	tooltip.ddBonus:SetPosX( tooltip.ddBase:GetPosX() + tooltip.ddBase:GetSizeX() + tooltip.ddBase:GetTextSizeX() + 5 )

	return true
end

local updateCardScrollButton = function()
	local right = mgUI.right
	local mentalObject = getMentalgameObject()
	if nil == mentalObject then
		return
	end

	local maxValue = mentalObject:getCardCount() - 5
	local totalCard = mentalObject:getCardCount()

	if ( totalCard <= 4 ) then
		right.cardLeftArrow:SetShow( false )
		right.cardRightArrow:SetShow( false )
		return		
	end
	right.cardLeftArrow:SetShow( scrollPositionResult < maxValue )
	right.cardRightArrow:SetShow( 0 < scrollPositionResult )
end

local endUIProcessMentalOnly = function( isDead )
	if ( false == isShow_MentalGame() ) then
		return false
	end
	for key, value in pairs(centerUiList) do
		if ( nil ~= value.panel ) then
			value.panel:SetShow(false, false)
			value.panel:SetPosX(-1000)
			value.panel:SetPosY(-1000)
		end
	end
	for _, value in pairs(informationUI) do
		for _, value2 in pairs(value) do
			value2.panel:SetShow(false)
		end
	end
	clearCardList()
	clearAnimation()
	mentalBaseInit()
	removeCircleLineAndObject()

	hide_MentalGame(isDead)
	DragManager:setDragImageSize( prevDragImageSizeX, prevDragImageSizeY )
	DragManager:clearInfo()
	mouseInputer:SetShow(false, false)
	for _,value in pairs(mgUI) do
		value.panel:SetShow(false, false)
	end
	
	RequestMentalGame_endGame()
	--------------------------------------------
	return true
end

local endUIProcess = function()

	SetUIMode(Defines.UIMode.eUIMode_NpcDialog)

	local isClose = endUIProcessMentalOnly(false)
    if ( false == isClose ) then
		return
	end
	FromClient_ShowDialog(false)
end

function MentalGame_Hide()
	endUIProcess()
end

function MentalGame_HideByDamage()
	local isClose = endUIProcessMentalOnly(false)
	if ( false == isClose ) then
		return
	end
	SetUIMode( Defines.UIMode.eUIMode_Default )
	UI.restoreFlushedUI()
	UI.Set_ProcessorInputMode(CppEnums.EProcessorInputMode.eProcessorInputMode_GameMode)
	dialog_CloseNpcTalk(true)
	setShowNpcDialog(false)
	setShowLine(true)
	ToClient_PopDialogueFlush()

	mouseInputer:SetAlpha(0)
end
function MentalGame_HideByDead()
    local isClose = endUIProcessMentalOnly(true)
end

local gameStartInit = function()

	_bestPoint = 0
	scrollPositionResult = 0
	scrollPosition = -5
	nonSelectPlayAlpha = 0.3
	gamePlayCount = gamePlayCount +1
	mouseInputer:SetShow(true,false)
	mgUI.zodiac.panel:SetShow(true,false)
	prevDragImageSizeX, prevDragImageSizeY = DragManager:getDragImageSize()
	DragManager:setDragImageSize( 80, 80 )
	local mentalObject = getMentalgameObject()
	if nil == mentalObject then
		return
	end
	local zodiacStaticStatusWrapper = mentalObject:getZodiacStaticStatusWrapper()
	if ( nil ~= zodiacStaticStatusWrapper ) then
		mgUI.zodiac.control:ChangeTextureInfoName( zodiacStaticStatusWrapper:getZodiacImagePath() )
	end
	for key, value in pairs( centerUiList ) do
		value.circularProgress:SetCurrentControlPos(0)
		value.circularProgress:SetProgressRate(0)

		value.SuccessIcon:ResetVertexAni()
		value.SuccessIcon:SetShow(false)

		value.FailedIcon:ResetVertexAni()
		value.FailedIcon:SetShow(false)
	end
	
	updateCardScrollButton()
end

-- 이미지 UV 설정하는 곳
local uv = {
	[0] = { x1 = 1, y1 = 1,  x2 = 61, y2 = 61 },
	{ x1 = 62, y1 = 1,  x2 = 122, y2 = 61 },
	{ x1 = 62, y1 = 62,  x2 = 122, y2 = 122 },
	{ x1 = 1, y1 = 62,  x2 = 61, y2 = 122 },
	{ x1 = 62, y1 = 62,  x2 = 122, y2 = 122 },
}

local giftIconInit = function()
	local left = mgUI.left
	
	local talker = dialog_getTalker()
	if ( nil == talker ) then
		return
	end
	local characterKey = talker:getCharacterKey()
	local count = getIntimacyInformationCount( characterKey )
	local colorKey = float4(1,1,1,1)
	local startSize = 28
	local endSize = ( left.progressBG:GetSizeX() + left.giftIcon:GetSizeX() )/ 2 
	local centerPosition = float3(left.progressBG:GetPosX() + left.progressBG:GetSizeX() / 2 , left.progressBG:GetPosY() + left.progressBG:GetSizeY() / 2,0)

	for index, value in pairs(giftIcon) do
		UI.deleteControl( value )
	end
	giftIcon = {}

	for index = 0, count -1 do
		local intimacyInformationData = getIntimacyInformation( characterKey, index )
		local percent 	= intimacyInformationData:getIntimacy() / 1000.0
		local imageType = intimacyInformationData:getTypeIndex()
		local giftName 	= intimacyInformationData:getTypeName()
		local giftDesc 	= intimacyInformationData:getTypeDescription()
		local imageFileName = ""

		if ( percent <= 1 ) then
			local angle = math.pi * 2 * percent

			local lineStart = float3( math.sin(angle), -math.cos(angle),0 )
			local lineEnd = float3( math.sin(angle), -math.cos(angle),0 )

			lineStart = _math_AddVectorToVector( centerPosition ,_math_MulNumberToVector( lineStart, startSize ) )
			lineEnd = _math_AddVectorToVector( centerPosition ,_math_MulNumberToVector( lineEnd, endSize ) )



			local target = giftIcon[index] 
			if ( nil == target ) then
				target = UI.createControl( UCT.PA_UI_CONTROL_STATIC, left.panel, 'GiftIcon_' .. tostring(index))
				giftIcon[index] = target
				CopyBaseProperty(left.giftIcon, target)
			end
			target:SetShow(true)
			
			target:ChangeTextureInfoName("New_UI_Common_forLua/Widget/HumanRelations/Compensation_00.dds")

			local x1, y1, x2, y2 = setTextureUV_Func( target, uv[imageType].x1, uv[imageType].y1, uv[imageType].x2, uv[imageType].y2 )
			target:getBaseTexture():setUV(  x1, y1, x2, y2 )
			target:setRenderTexture(target:getBaseTexture())

			target:SetPosX( lineEnd.x - target:GetSizeX() / 2 )
			target:SetPosY( lineEnd.y - target:GetSizeY() / 2 )
			target:addInputEvent( "Mouse_On",	"FruitageGift_ShowTooltip(\""..giftName.."\", \""..giftDesc.."\", " .. target:GetPosX() .. ", " .. target:GetPosY() .. ")" )
			target:addInputEvent( "Mouse_Out",	"FruitageGift_HideTooltip()" )
		end
	end
end

function MentalGame_Show()
	if ( GetUIMode() ~= Defines.UIMode.eUIMode_NpcDialog )  then
		return
	end
	SetUIMode(Defines.UIMode.eUIMode_MentalGame)	-- 더 좋은 방법이 있기 전까지는 여기에서 UI Mode 를 변경해준다! - 성경

	mentalGame_End = false

	if ( mgUI.left.panel:GetShow() ) then
		return
	end
	mgUI.left.panel:SetShow(true, false)
	mgUI.base.panel:SetShow(true, false)
	mgUI.right.panel:SetShow(true, false)
	mgUI.zodiac.panel:SetShow(true, false)


	--다른 UI 꺼주기 ( 추가적인것들을 넣던지, 안넣어도 되게 하자 )
	Panel_Window_WorkerRandomSelect:SetShow(false, false)
	FGlobal_ShowRewardList(false);
	Panel_Npc_Dialog:SetShow(false, false);
	Panel_Dialogue_Itemtake:SetShow(false)
	SkillWindow_Close( true )		-- true 이면 ani 를 하지 않는다!
	NpcShop_WindowClose()
	------------------------

	mgUI.left.panel:SetShow(true, false)
	local isSuccess = show_MentalGame()
	if ( false == isSuccess ) then
		--Error 메세지 띄울것
	end

	local selfProxy			= getSelfPlayer():get();
	local selfPosition		= selfProxy:getCameraTargetPos()
	
	UI.flushAndClearUI()
	
	gameStep = 0
	gamePlayCount = 0
	addIntimacy = 0
	mgUI.left.fruitage_Add:SetText("+0")

	gameStartInit()
	insertCircleLineAndObject()
	insertCardList()
	giftIconInit()
	
	local mentalObject = getMentalgameObject()
	if nil == mentalObject then
		return
	end
	mentalObject:scaling(-0.2)
end

function MentalGame_ScreenResize()
	local sizeX = getScreenSizeX()
	local sizeY = getScreenSizeY()

	local leftPanel = mgUI.left.panel
	local centerPanel = mgUI.center.panel
	local basePanel = mgUI.base.panel

	local emptySize = sizeX - leftPanel:GetSizeX() - basePanel:GetSizeX()

	-- leftPanel:SetPosX( emptySize * 13 / 27 ) 캐릭터옆 정보 박스 원래 위치
	leftPanel:SetPosX( emptySize * 17 / 27 )
	basePanel:SetPosX( emptySize * 20 / 27 + leftPanel:GetSizeX() )
	
	centerPanel:SetPosX(0)
	centerPanel:SetPosY(0)
	centerPanel:SetSize(sizeX , sizeY)

	mgUI.center.finishImage:SetSize( sizeX, mgUI.center.finishImage:GetSizeY() )
	mgUI.center.finishText:SetSize( sizeX, mgUI.center.finishText:GetSizeY() )
	
	mgUI.center.finishImage:ComputePos()
	mgUI.center.finishText:ComputePos()

	--local fullwidth = mgUI.left.panel:GetPosX()
	--
	--getMentalgameObject():setCharacterCreatePosition( fullwidth / sizeX / 2, 0.5, fullwidth / sizeX )
end

local updateRotateProcess = function(deltaTime)
	if ( false == isRdown ) then
		return
	end

	local currPos = { x = getMousePosX() , y = getMousePosY() }
	if ( currPos.x == rMovePos.x ) and ( currPos.y == rMovePos.y ) then
		return
	end
	
	local mentalObject = getMentalgameObject()
	if nil == mentalObject then
		return
	end
	local diffPos = { x = ( currPos.x - rMovePos.x ) / getScreenSizeX() , y = ( currPos.y - rMovePos.y ) / getScreenSizeY() }
	mentalObject:rotate(diffPos.x * -3, diffPos.y * -3)

	updateCenterBackground()
	rMovePos = currPos
end

local updateCenterUIPos = function(deltaTime)
	local mentalObject = getMentalgameObject()
	if nil == mentalObject then
		return
	end
	local basePos = mentalObject:getCardPos()
	
	local count = mentalObject:getPointCount()
	for index = 0 , count -1 do
		local starPos = mentalObject:getPoint(index)
		local float3Pos = Util.Math.AddVectorToVector(basePos, starPos)
		
		local panel = centerUiList[index].panel
		local progress = centerUiList[index].circularProgress
		local transformData = getTransformRevers( float3Pos.x, float3Pos.y, float3Pos.z )
		if ( transformData.x > -1 ) and (transformData.y > -1 ) then
			local cameraDistance = distanceFromCamera( float3Pos.x, float3Pos.y, float3Pos.z )
			local scaleSize = 100000 / ( cameraDistance ) * 0.85
			panel:SetSize( scaleSize, scaleSize )
			progress:ComputePos()

			panel:SetPosX( transformData.x - panel:GetSizeX() /2 )
			panel:SetPosY( transformData.y - panel:GetSizeY() /2 )
			panel:SetAlpha( 1 )
			panel:SetDepth( cameraDistance )
			--panel:SetShow(true)
		end
	end
end

local updateRightUIPos = function(deltaTime, forceRun)
	local diff = scrollPositionResult - scrollPosition
	if ( 2 <= gameStep ) then
		return
	end
	if ( 0 == diff ) and ( false == forceRun ) then
		return
	end
	local mentalObject = getMentalgameObject()
	if nil == mentalObject then
		return
	end
	
	scrollPosition = scrollPosition + diff * math.min(deltaTime * 8, 1)
	if ( math.abs(scrollPositionResult - scrollPosition) < 0.05 ) then
		scrollPosition = scrollPositionResult
	end
	local right = mgUI.right
	local isIgnore = (scrollPosition ~= scrollPositionResult)	
	for index, value in pairs(rightCardList) do
		if ( nil ~= value.ui ) and ( nil ~= value.ui.cardText ) then
			value.ui.cardIcon:SetIgnore(isIgnore)
			local posIndex = index - scrollPosition
			local position = mentalObject:getCirclePosition( float2( (right.cardLeftArrow:GetPosX() + right.cardRightArrow:GetPosX() + (right.cardLeftArrow:GetSizeX() + right.cardRightArrow:GetSizeX()) / 2) / 2, right.cardLeftArrow:GetPosY() + right.cardLeftArrow:GetSizeY() / 2 +320 ), 400, posIndex - 2)
			value.ui.cardText:SetPosX( position.x - value.ui.cardText:GetSizeX() / 2)
			value.ui.cardText:SetPosY( position.y - value.ui.cardText:GetSizeY() / 2)
			if ( -0.25 <= posIndex ) and ( posIndex <= 4.25 ) then
				value.ui.cardText:SetShow(true)
				value.ui.cardText:SetAlphaExtraChild(1)
			elseif ( -0.75 <= posIndex ) and ( posIndex < -0.25 ) then
				value.ui.cardText:SetShow(true)
				value.ui.cardText:SetAlphaExtraChild( (posIndex + 0.75) * 2 )
			elseif ( 4.25 < posIndex ) and ( posIndex <= 4.75 ) then
				value.ui.cardText:SetShow(true)
				value.ui.cardText:SetAlphaExtraChild( (4.75 - posIndex) * 2 )
			else
				value.ui.cardText:SetShow(false)
			end
		end
	end
end

function MentalKnowledge_UpdatePosition( deltaTime )
	updateCenterUIPos(deltaTime)
	updateRotateProcess(deltaTime)
	updateAnimationList(deltaTime)
	updateCenterBackground(deltaTime)
	updateRightUIPos(deltaTime, false)
end

-----------------------------------------------------------------------------
-----------------------------------------------------------------------------
-- mouse Event
-----------------------------------------------------------------------------
-----------------------------------------------------------------------------

local selectCardReset = function()
	selectCardIndex = -1
	DragManager:clearInfo()
end

function MentalKnowledge_CardRotation_Left()
	local mentalObject = getMentalgameObject()
	if nil == mentalObject then
		return
	end
	local maxValue = mentalObject:getCardCount() - 5
	scrollPositionResult = math.min( scrollPositionResult + 5, maxValue )

	updateCardScrollButton()
end

function MentalKnowledge_CardRotation_Right()
	local right = mgUI.right
	local mentalObject = getMentalgameObject()
	if nil == mentalObject then
		return
	end
	local totalCard = mentalObject:getCardCount()
	scrollPositionResult = math.max( scrollPositionResult - 5, 0 )
	
	updateCardScrollButton()
end

function MentalKnowledge_OnLDown_Card( cardIndex )
	local mentalObject = getMentalgameObject()
	if nil == mentalObject then
		return
	end
	local cardWrapper = mentalObject:getCard(cardIndex)

	if ( true == mentalObject:isSelectedCard(cardWrapper) ) then
		return
	end

	selectCardIndex = cardIndex
	DragManager:setDragInfo(nil, nil, cardIndex, cardWrapper:getPicture(), nil, nil )
end

-- 아래 카드를 오른 버튼으로 누를 때
function MentalKnowledge_OnRDown_Card( cardIndex )
	local mentalObject = getMentalgameObject()
	if nil == mentalObject then
		return
	end
	if ( cardIndex < mentalObject:getCardCount() ) then
		if ( gameStep < 2 ) then
			local value = mentalObject:getCard(cardIndex)
			if ( nil ~= value ) then
				local staticKey = value:getStaticStatus():getKey()
				if ( false == mentalObject:isSelectedCard(value)) then
					RequestMentalGame_selectCardByKey(staticKey, 99)
					-- 우클릭으로 넣을때 나는 소리 
					audioPostEvent_SystemUi(00,02)
				end
			end
		end
		selectCardIndex = -1
		DragManager:clearInfo()
	end
end

function MentalKnowledge_OnLDown()
	selectCardReset()
end

function MentalKnowledge_OnLUp()
	selectCardReset()
end

function MentalKnowledge_OnRDown()
	isRdown = true
	rMovePos = { x = getMousePosX() , y = getMousePosY() }
	selectCardReset()
end

function MentalKnowledge_OnRUp()
	isRdown = false
	selectCardReset()
end

function MentalKnowledge_OnWheelUp()
	local mentalObject = getMentalgameObject()
	if nil == mentalObject then
		return
	end
	mentalObject:scaling(0.1)
end

function MentalKnowledge_OnWheelDown()
	local mentalObject = getMentalgameObject()
	if nil == mentalObject then
		return
	end
	mentalObject:scaling(-0.1)
end

local overKey = -1
function MentalKnowledge_Over(mouseOverKey, isInserted, isShow)
	local tooltip = mgUI.tooltip
	local mentalObject = getMentalgameObject()
	if nil == mentalObject then
		return
	end
	if ( gameStep < 2 ) then
		if ( mouseOverKey == overKey ) then
			if ( false == isShow ) then
				tooltip.panel:SetShow(false, false)
				overKey = -1
			end
		else
			if ( isShow ) then

				local targetUI = nil 
				local isSuccess = true
				if ( isInserted ) then
					isSuccess = updateTooltipContext(mentalObject:getCardBySlotIndex(mouseOverKey), isInserted, mouseOverKey)
					uiGroup = centerUiList[mouseOverKey]
					if ( nil ~= centerUiList[mouseOverKey] ) then
						targetUI = centerUiList[mouseOverKey].panel
					end
				else
					isSuccess = updateTooltipContext(mentalObject:getCard(mouseOverKey), isInserted, mouseOverKey)
					if ( nil ~= rightCardList[mouseOverKey] ) and ( nil ~= rightCardList[mouseOverKey].ui ) then
						targetUI = rightCardList[mouseOverKey].ui.cardIcon
					end
				end

				if ( isSuccess ) then
					tooltip.panel:SetShow(true, false)	-- 이야기 교류 툴팁 창을 보인다.
					overKey = mouseOverKey
					if ( nil ~= targetUI ) then

						-- local panelPos = targetUI:GetPosY() + targetUI:GetSizeY()
						-- if ( getScreenSizeY() < panelPos + tooltip.panel:GetSizeY() ) then
						-- 	panelPos = targetUI:GetParentPosY() - tooltip.panel:GetSizeY()
						-- end
						-- tooltip.panel:SetPosY( panelPos )
						-- tooltip.panel:SetPosY( aControl:GetPosY() -300 )

						-- 툴팁 위치는 부모 아이콘 왼쪽 위로 나온다.
						tooltip.panel:SetPosX( targetUI:GetParentPosX() - ( tooltip.panel:GetSizeX() - 40 ) )	-- 툴팁 위치는 하단 아이콘왼쪽으로 나온다.
						tooltip.panel:SetPosY( targetUI:GetParentPosY() - ( tooltip.panel:GetSizeY() - 50 )  )	-- 툴팁 위치는 하단 아이콘 위치에서 툴팁 세로 크기 - 50 만큼 뺀 값이다.
					end
				end
			end
		end
	end
end


-- 별자리 판이 등록이나 삭제로 업데이트 될 때.
function MentalKnowledge_UpdateCenterSlot( key )
	local mentalObject = getMentalgameObject()
	if nil == mentalObject then
		return
	end
	local value = mentalObject:getCard(selectCardIndex)

	if ( selectCardIndex < mentalObject:getCardCount() ) and (nil ~= value) then
		if ( false == mentalObject:isSelectedCard(value) ) then
			-- 들어갈때 나오는 소리
			audioPostEvent_SystemUi(00,02)
		end
		RequestMentalGame_clearSelectCard(key)	-- key 를 누르면 초기화 시킨다.
		local staticKey = value:getStaticStatus():getKey()
		RequestMentalGame_selectCardByKey(staticKey, key)
		selectCardIndex = -1
		DragManager:clearInfo()
	else
		RequestMentalGame_clearSelectCard(key)
		MentalKnowledge_Over(key,true,false)
	end

	-- 클릭한 지점에 카드가 nil 이 아니면, 빼는 사운드를 재생한다.
	if mentalObject:getCardBySlotIndex(key) ~= nil then
		-- 빼는 사운드 재생!
		audioPostEvent_SystemUi(00,02)
	end

end

function MentalKnowledge_InsertCard( key )
	local mentalObject = getMentalgameObject()
	if nil == mentalObject then
		return
	end
	if ( selectCardIndex < mentalObject:getCardCount() ) then
		if ( gameStep < 2 ) then
			local value = mentalObject:getCard(selectCardIndex)
			if ( nil ~= value ) then
				local staticKey = value:getStaticStatus():getKey()
				RequestMentalGame_selectCardByKey(staticKey, 99)
			end
		end
		selectCardIndex = -1
		DragManager:clearInfo()
	end
end

function MentalKnowledge_ClearCard( key )
	RequestMentalGame_clearSelectCard(key)
	MentalKnowledge_Over(key,true,false)
end

-- Apply Btn LClick
function MentalKnowledge_Apply_LClick()
	local mentalObject = getMentalgameObject()
	if nil == mentalObject then
		return
	end
	RequestMentalGame_startCard()
	DragManager:clearInfo()	

	centerUiList[mentalObject:getOrder(0)].circularProgress:SetProgressRate(100)

	local right = mgUI.right
	right.apply:SetShow(false)
end

-- GameEnd Btn LClick
function MentalKnowledge_GameEnd_LClick()
	RequestMentalGame_endGame()

	local mentalStage = RequestMentalGame_getMentalStage();
	if ( false == mentalStage._isSuccess ) then
		endUIProcess()
		return
	end

	gameStep = 4
	updateStateUIShow()
	hideDeltaTime = 0	-- 쓰는지 안쓰는지 모르겠음.
	endTimechk = 0

	local talker = dialog_getTalker()
	local intimacy = 0
	if ( nil ~= talker ) then
		intimacy = talker:getIntimacy()
	end
	local addIntimacyValue = addIntimacy
	local resultIntimacy = intimacy + addIntimacyValue
	local center = mgUI.center
		
	local tempString = PAGetStringParam2(  Defines.StringSheet_GAME, "MENTALGAME_AQUIRE_INTIMACY_POINT", "result", tostring(resultIntimacy), "point", tostring( addIntimacyValue ) );
	
	center.finishText:SetText(tempString)
	-- "종료~"
	audioPostEvent_SystemUi(04,03)

	-- 시간이 지나고 해야 함.
	mentalGame_End = true
end

-- TryAgiain Btn LClick
function MentalKnowledge_TryAgain_LClick()
	gameStep = 0
	gameStartInit()

	RequestMentalGame_restartCard()
end

function MentalKnowledge_InformationUIFontAlpha( srcKey, dstKey, alpha, isOver )
	if ( nil == informationUI[srcKey] ) or ( nil == informationUI[srcKey][dstKey] ) then
		return
	end
	if ( isOver ) and ( 1 < gameStep ) then
		return
	end
	informationUI[srcKey][dstKey].nameTag:SetFontAlpha(alpha)
end

-------------------------- 친밀도  --------------------
function FruitageGift_ShowTooltip( Name, Desc, X, Y )
	mgUI.left.giftNotice:SetText( Name.." : "..Desc )
	mgUI.left.giftNotice:SetSize( mgUI.left.giftNotice:GetTextSizeX() + 15, mgUI.left.giftNotice:GetSizeY() )
	mgUI.left.giftNotice:SetPosX( X )
	mgUI.left.giftNotice:SetPosY( Y - mgUI.left.giftNotice:GetSizeY() )
	mgUI.left.giftNotice:SetShow(true)
end

function FruitageGift_HideTooltip()
	mgUI.left.giftNotice:SetShow(false)
end

-----------------------------------------------------------------------------
-----------------------------------------------------------------------------
-- client Event
-----------------------------------------------------------------------------
-----------------------------------------------------------------------------


-- 이미지 UV 설정하는 곳
local uv = {
	[0] = { x1 = 0, y1 = 0,  x2 = 0, y2 = 0 },
	[1] = { x1 = 1, y1 = 258,  x2 = 245, y2 = 325 },
	[2] = { x1 = 246, y1 = 258,  x2 = 490, y2 = 325 },
	[3] = { x1 = 1, y1 = 326,  x2 = 245, y2 = 393 },
	[4] = { x1 = 246, y1 = 326,  x2 = 490, y2 = 393 },
	[5] = { x1 = 1, y1 = 394,  x2 = 245, y2 = 461 },
}

local updateNextTryEvent = function()
	local mentalObject = getMentalgameObject()
	if nil == mentalObject then
		return
	end
	local nextSlot = mentalObject:getNextSlot()
	if ( 0 < nextSlot ) then
		local prevSlot = nextSlot -1

		--이전 슬롯의 성공여부를 이펙트로 표시한다.
		local index = mentalObject:getOrder(prevSlot)
		--centerUiList[index].circularProgress:SetCurrentControlPos(0)
		--centerUiList[index].circularProgress:SetProgressRate(100)
		centerUiList[index].SuccessIcon:ResetVertexAni()
		centerUiList[index].FailedIcon:ResetVertexAni()
		centerUiList[index].SuccessIcon:SetShow(false)
		centerUiList[index].FailedIcon:SetShow(false)

		if ( mentalObject:isComboSuccess() ) then
			centerUiList[index].panel:AddEffect("fCO_MentalGameEffect", false, 0, 0)
			centerUiList[index].SuccessIcon:SetVertexAniRun("Ani_Color_New", true)
			centerUiList[index].SuccessIcon:SetVertexAniRun("Ani_Move_Pos_New", true)
			centerUiList[index].SuccessIcon:SetShow(true)
			-- "성공!"
			audioPostEvent_SystemUi(04,09)
		else
			centerUiList[index].FailedIcon:SetVertexAniRun("Ani_Color_New", true)
			centerUiList[index].FailedIcon:SetVertexAniRun("Ani_Move_Pos_New", true)
			centerUiList[index].FailedIcon:SetShow(true)
			-- "실패!"
			audioPostEvent_SystemUi(04,08)
		end

		local lastIndex = mentalObject:getOrderCount() -1
		local nextIndex = mentalObject:getOrder(nextSlot)

		--다음슬롯의 효과프로그래스바를 활성화 시킨다.
		if ( mentalObject:getHasNextSlot() ) then
			if ( nil ~= centerUiList[nextIndex] ) then
				centerUiList[nextIndex].circularProgress:SetCurrentControlPos(0)
				centerUiList[nextIndex].circularProgress:SetProgressRate(100)
			end
		end

		--다음슬롯의 효과를 포인트로 활성화 시킨다.
		local isFirst = true
		for index = nextSlot , lastIndex do
			local isApplied = mentalObject:isAppliedEffect(prevSlot, index)
			
			local isFirstAnimation = false
			if (isFirst) and ( nil ~= mentalObject:getCardBySlotOrder(index) ) then
				isFirst = false
				isFirstAnimation = true
			end
			if (isApplied) or (isFirstAnimation) then
				if ( isFirstAnimation ) then
					animationUIList[prevSlot][index].pointImage:SetColor(Defines.Color.C_FFEF9C7F)
				else
					animationUIList[prevSlot][index].pointImage:SetColor(Defines.Color.C_FFFFFFFF)
				end
				local playCount = index - prevSlot - mentalObject:getEmptyCount( prevSlot, index )
				addAnimation( animationUIList[prevSlot][index].panel , 0, mentalObject:getMentalGameSpeed() / 1000 * playCount, prevSlot, index, posUpdateAnimation )
				addAnimation( informationUI[prevSlot][index].nameTag , 0, mentalObject:getMentalGameSpeed() / 1000 * playCount, prevSlot, index, fontalphaUpdateAnimation )
			end
		end

	end
end

function MentalGame_updateMatrix()
	removeCircleLineAndObject()
	insertCircleLineAndObject()
	updateCenterUIPos(0)

end

function MentalGame_StateUpdate( isNext )
	local mentalObject = getMentalgameObject()
	if nil == mentalObject then
		return
	end
	local count = mentalObject:getSlotCount()
	for index = 0 , count - 1 do
		local cardWrapper = mentalObject:getCardBySlotIndex(index)
		if ( nil ~= centerUiList[index] and nil ~= centerUiList[index].panel ) then
			local target = centerUiList[index].panel
			if ( nil ~= cardWrapper ) then
				target:ChangeTextureInfoName(cardWrapper:getPicture())
			else
				target:ChangeTextureInfoName("")
			end
			target:SetShow(true, false)
		end
	end

	local minCardSlotCount = mentalObject:getMinCardSlotCount()
	local filledSlotCount = mentalObject:getFilledSlotCount()

	mgUI.base.comment_Value:SetText(tostring( minCardSlotCount - filledSlotCount ))
	if ( minCardSlotCount <= filledSlotCount ) then
		if ( 0 == gameStep ) then
			gameStep = 1
		end
	else
		if ( 1 == gameStep ) then
			gameStep = 0
		end
	end


	removeCircleLineAndObject()
	insertCircleLineAndObject()

	updateState()
	updateStateUIShow()
	updateCardColor()
	updateCardScrollButton()

	local right = mgUI.right
	local count = mentalObject:getCardCount()
	for index = 0, count - 1 do
		local cardWrapper = mentalObject:getCard(index)

		if (nil ~= rightCardList[index]) and (nil ~= rightCardList[index].ui) and ( nil ~= rightCardList[index].ui.cardIcon ) then
			rightCardList[index].ui.cardIcon:SetMonoTone(mentalObject:isBanedCard(cardWrapper))
		end
	end


	if ( isNext ) then
		updateNextTryEvent()
	end
	
	-- mentalObject:scaling(-0.2)	-- 지식 집어넣을 때 마다 크기가 줄어들어서 삭제함
end

local maxPointUpdate = function( )
	local mentalObject = getMentalgameObject()
	if nil == mentalObject then
		return
	end
	local currentPoint = mentalObject:getInterestValue()

	_bestPoint = math.max(_bestPoint, currentPoint)
end


function MentalGame_tryCard( slotIndex )
	gameStep = 2
	maxPointUpdate()
end

function MentalGame_endStage( addedIntimacy )
	gameStep = 3

	local mentalStage = RequestMentalGame_getMentalStage();
	maxPointUpdate()

	if ( mentalStage._isSuccess ) then
		addIntimacy = addIntimacy + addedIntimacy
	else
		addIntimacy = 0
	end

	local intimacyText = tostring(addIntimacy)
	if ( 0 <= (addedIntimacy) ) then
		intimacyText = "+" .. intimacyText
	end
	local base = mgUI.base
	local left = mgUI.left
	left.fruitage_Add		:SetText(intimacyText)
	if ( 0 == addIntimacy ) then
		base.result			:SetText( PAGetString( Defines.StringSheet_GAME, "MENTALGAME_INTIMACY_ACQUIRE_EMPTY" ) )
	else
		base.result			:SetText( PAGetStringParam1(  Defines.StringSheet_GAME,  "MENTALGAME_INTIMACY_ACQUIRE",  "count", intimacyText ) )
	end
	base.nextFail			:SetText( PAGetStringParam1(  Defines.StringSheet_GAME,  "MENTALGAME_INTIMACY_ACQUIRE",  "count", tostring(addIntimacy) ) )

	updateState()
	updateStateUIShow()
end

function MentalGame_UpdateEndTimer( deltaTime )
	endTimechk = endTimechk + deltaTime
	if 5 < endTimechk and true == mentalGame_End then
		MentalGame_Hide()
		mentalGame_End = false
	end

	if 6 < endTimechk then
		endTimechk = 0
	end
end

function MentalGame_UpdateHideTime( deltaTime ) 
	hideDeltaTime = hideDeltaTime + deltaTime
	if ( constValue.hideTime <= hideDeltaTime ) and ( gameStep == 4 ) then
		endUIProcess()
	end
end


init()
