local eWarningType = 
{
	eHarvestWarningType_BirdAttack  = 0,
	eHarvestWarningType_BugDetect   = 1,
	eHarvestWarningType_BugAttack   = 2,
	eHarvestWarningType_NeedLop     = 3,
	eHarvestWarningType_NeedWaterUp = 4,
}

local warningString = 
{
    [eWarningType.eHarvestWarningType_BirdAttack]    = "새들의 공격을 받아 작물이 피해를 입었습니다.",
    [eWarningType.eHarvestWarningType_BugDetect]     = "작물에서 벌레가 생겨나기 시작했습니다.",
    [eWarningType.eHarvestWarningType_BugAttack]     = "벌레가 작물을 먹어치우고 있습니다!",
    [eWarningType.eHarvestWarningType_NeedLop]       = "작물이 엉켰습니다. 가지치기를 해야 합니다.",
    [eWarningType.eHarvestWarningType_NeedWaterUp]   = "지하수량이 부족해 작물의 수분량이 감소하고 있습니다.",
}

local warningMessage =
{
    [eWarningType.eHarvestWarningType_BirdAttack]    = function(tentPosition, characterSSW, progressingInfo, addtionalValue1)
		Proc_ShowMessage_Ack( characterSSW:getName() .. " : " .. warningString[eWarningType.eHarvestWarningType_BirdAttack] )
	end,
    [eWarningType.eHarvestWarningType_BugDetect]     = function(tentPosition, characterSSW, progressingInfo, addtionalValue1)
		Proc_ShowMessage_Ack( characterSSW:getName() .. " : " .. warningString[eWarningType.eHarvestWarningType_BugDetect] )
	end,
    [eWarningType.eHarvestWarningType_BugAttack]     = function(tentPosition, characterSSW, progressingInfo, addtionalValue1)
		--Proc_ShowMessage_Ack( characterSSW:getName() .. " : " .. warningString[eWarningType.eHarvestWarningType_BugAttack] )
	end,
    [eWarningType.eHarvestWarningType_NeedLop]       = function(tentPosition, characterSSW, progressingInfo, addtionalValue1)
		Proc_ShowMessage_Ack( characterSSW:getName() .. " : " .. warningString[eWarningType.eHarvestWarningType_NeedLop] )
	end,
    [eWarningType.eHarvestWarningType_NeedWaterUp]   = function(tentPosition, characterSSW, progressingInfo, addtionalValue1)
		if ( math.floor(progressingInfo:getNeedWater() / 200000) == math.floor(addtionalValue1 / 200000) ) then
			return
		end
		if ( 500000 <= progressingInfo:getNeedWater() ) then
			Proc_ShowMessage_Ack( characterSSW:getName() .. " : 작물의 수분량이 절반 이하로 감소하였습니다. 작물의 수분량이 0이 되면 작물수확량이 감소합니다." )	
		else
			Proc_ShowMessage_Ack( characterSSW:getName() .. " : " .. warningString[eWarningType.eHarvestWarningType_NeedWaterUp] )
		end
	end,
}

function FromClient_InstallationInfoWarning( warningType, tentPosition, characterSSW, progressingInfo, addtionalValue1 )
	if ( nil == progressingInfo ) then
		return
	end

	warningMessage[warningType]( tentPosition, characterSSW, progressingInfo, addtionalValue1 )
end

registerEvent("FromClient_InstallationInfoWarning", "FromClient_InstallationInfoWarning");