-------------------------------
-- Panel Init
-------------------------------
local UI_color			= Defines.Color
local UI_TM 			= CppEnums.TextMode
local UI_PUCT 			= CppEnums.PA_UI_CONTROL_TYPE
local ePcWorkingType 	= CppEnums.PcWorkType
local UI_Class			= CppEnums.ClassType

local const_64			= Defines.s64_const

local UCT_BUTTON 		= CppEnums.PA_UI_CONTROL_TYPE.PA_UI_CONTROL_BUTTON
local UCT_RADIOBUTTON 	= CppEnums.PA_UI_CONTROL_TYPE.PA_UI_CONTROL_RADIOBUTTON
local UCT_STATICTEXT 	= CppEnums.PA_UI_CONTROL_TYPE.PA_UI_CONTROL_STATICTEXT
local UCT_STATIC 		= CppEnums.PA_UI_CONTROL_TYPE.PA_UI_CONTROL_STATIC

-------------------------------
-- Control Regist & Init
-------------------------------
local Panel_Lobby_UI = {

	--Select Character
	SC_CharacterSelectText			= UI.getChildControl( Panel_CharacterSelect, "StaticText_CharacterSelect"),
	SC_ChracterSelectButton			= UI.getChildControl( Panel_CharacterSelect, "Button_Character0"),
	SC_ChracterSelectButtonMain		= UI.getChildControl( Panel_CharacterSelect, "Button_StartCharacter"),
	SC_ChracterSelectButtonText		= UI.getChildControl( Panel_CharacterSelect, "StaticText_Character0"),
	SC_CharacterCreateButton		= UI.getChildControl( Panel_CharacterSelect, "Button_CharacterCreate"),
	SC_CharacterDeleteButton		= UI.getChildControl( Panel_CharacterSelect, "Button_CharacterDelete"),
	SC_CharacterDeleteCancelButton	= UI.getChildControl( Panel_CharacterSelect, "Button_CharacterDeleteCancel"),
	SC_StartGameButton				= UI.getChildControl( Panel_CharacterSelect, "Button_Start"),
	SC_CharacterSlotBG				= UI.getChildControl( Panel_CharacterSelect, "Static_BG"),
	SC_CharacterDeleteCancelTitle	= UI.getChildControl( Panel_CharacterSelect, "StaticText_DeleteTitle" ),
	SC_CharacterDeleteCancelDate	= UI.getChildControl( Panel_CharacterSelect, "StaticText_DeleteDate" ),
	SC_CreateCharacterBG			= UI.getChildControl( Panel_CharacterSelect, "Button_CreateSlot" ),
	SC_CharacterSelectBG			= UI.getChildControl( Panel_CharacterSelect, "Static_BG" ),
	SC_CharacterName				= UI.getChildControl( Panel_CharacterSelect, "StaticText_CharacterName" ),
	SC_CharacterLevel				= UI.getChildControl( Panel_CharacterSelect, "StaticText_CharLevel" ),
	SC_BackServerSelect				= UI.getChildControl( Panel_CharacterSelect, "Button_BackServerSelect" ),
	SC_GameEnd						= UI.getChildControl( Panel_CharacterSelect, "Button_EndGame" ),
	SC_CharacterUserCount			= UI.getChildControl( Panel_CharacterSelect, "StaticText_UserCount" ),
	SC_PartLine						= UI.getChildControl( Panel_CharacterSelect, "Static_PartLine" ),
	SC_DeleteFamilyName				= UI.getChildControl( Panel_CharacterSelect, "Button_DeleteFamilyName" ),
	SC_FamilyNameText				= UI.getChildControl( Panel_CharacterSelect, "FamilyName" ),
	
	--Create Character
	CC_CharacterCreateText			= UI.getChildControl( Panel_CharacterCreate, "StaticText_CharacterCreate"),
	CC_CharacterNameEdit			= UI.getChildControl( Panel_CharacterCreate, "Edit_CharacterName"),
	CC_CreateButton					= UI.getChildControl( Panel_CharacterCreate, "Button_CharacterCreateStart"),
	CC_BackButton					= UI.getChildControl( Panel_CharacterCreate, "Button_Back"),
	CC_DumiText1					= UI.getChildControl( Panel_CharacterCreate, "StaticText_1"),
	CC_characterCreateBG			= UI.getChildControl( Panel_CharacterCreate, "Static_BG"),
	CC_DumiText3					= UI.getChildControl( Panel_CharacterCreate, "StaticText_3"),
	CC_DumiText4					= UI.getChildControl( Panel_CharacterCreate, "StaticText_4"),

	CC_FrameHead					= UI.getChildControl( Panel_CharacterCreate, "Frame_Head"),
	CC_FrameHead_Content			= nil,
	CC_FrameHead_Content_Image		= nil,
	CC_FrameHead_Scroll				= nil,
	CC_FrameHair					= UI.getChildControl( Panel_CharacterCreate, "Frame_Hair"),
	CC_FrameHair_Content			= nil,
	CC_FrameHair_Content_Image		= nil,
	CC_FrameHair_Scroll				= nil,
	CC_SelectClassButton			= UI.getChildControl( Panel_CharacterCreate, "Button_SelectClass"),
	CC_BackgroundButton				= UI.getChildControl( Panel_CharacterCreate, "Button_Background"),
	CC_CBTText						= UI.getChildControl( Panel_CharacterCreate, "StaticText_CBT"),

	-- 클래스 선택창 (Create Character - Select Class)
	CCSC_CreateTitle				= UI.getChildControl( Panel_CharacterCreateSelectClass, "StaticText_Title"),
	CCSC_ClassName					= UI.getChildControl( Panel_CharacterCreateSelectClass, "StaticText_ClassName"),
	CCSC_PartLine					= UI.getChildControl( Panel_CharacterCreateSelectClass, "Static_PartLine"),
	CCSC_ClassDescBG				= UI.getChildControl( Panel_CharacterCreateSelectClass, "Static_Desc_BG"),
	CCSC_ClassDesc					= UI.getChildControl( Panel_CharacterCreateSelectClass, "StaticText_Description"),
	CCSC_CreateButton				= UI.getChildControl( Panel_CharacterCreateSelectClass, "Button_CharacterCreateStart"),
	CCSC_CreateBG					= UI.getChildControl( Panel_CharacterCreateSelectClass, "Static_BG"),
	-- CCSC_ClassMovie					= UI.getChildControl( Panel_CharacterCreateSelectClass, "Static_MovieSize"),
	CCSC_WarriorButton				= UI.getChildControl( Panel_CharacterCreateSelectClass, "RadioButton_Select_Warrior"),
	CCSC_RangerButton				= UI.getChildControl( Panel_CharacterCreateSelectClass, "RadioButton_Select_Ranger"),
	CCSC_SorcerButton				= UI.getChildControl( Panel_CharacterCreateSelectClass, "RadioButton_Select_Sorcer"),
	CCSC_GiantButton				= UI.getChildControl( Panel_CharacterCreateSelectClass, "RadioButton_Select_Giant"),
	--테이머 ~ 쿠노이치까지 임시로 막아둠! 14-11-13 이문종
	CCSC_TamerButton				= UI.getChildControl( Panel_CharacterCreateSelectClass, "RadioButton_Select_Tamer"),
	CCSC_BladeMasterButton			= UI.getChildControl( Panel_CharacterCreateSelectClass, "RadioButton_Select_BladeMaster"),
	CCSC_ValkyrieButton				= UI.getChildControl( Panel_CharacterCreateSelectClass, "RadioButton_Select_Valkyrie"),
	CCSC_WizardButton				= UI.getChildControl( Panel_CharacterCreateSelectClass, "RadioButton_Select_Wizard"),
	CCSC_KunoichiButton				= UI.getChildControl( Panel_CharacterCreateSelectClass, "RadioButton_Select_Kunoichi"),
	
	CCSC_WarriorName				= UI.getChildControl( Panel_CharacterCreateSelectClass, "StaticText_WarriorName"),
	CCSC_RangerName					= UI.getChildControl( Panel_CharacterCreateSelectClass, "StaticText_RangerName"),
	CCSC_SorcerName					= UI.getChildControl( Panel_CharacterCreateSelectClass, "StaticText_SorcerName"),
	CCSC_GiantName					= UI.getChildControl( Panel_CharacterCreateSelectClass, "StaticText_GiantName"),
	CCSC_TamerName					= UI.getChildControl( Panel_CharacterCreateSelectClass, "StaticText_TamerName"), -- 금수랑
	CCSC_BladeMasterName			= UI.getChildControl( Panel_CharacterCreateSelectClass, "StaticText_BladeMasterName"), -- 무사
	CCSC_ValkyrieName				= UI.getChildControl( Panel_CharacterCreateSelectClass, "StaticText_ValkyrieName"),
	CCSC_WizardName					= UI.getChildControl( Panel_CharacterCreateSelectClass, "StaticText_WizardName"),
	CCSC_KunoichiName				= UI.getChildControl( Panel_CharacterCreateSelectClass, "StaticText_KunoichiName"),

	CCSC_ClassMovie					= UI.createControl(CppEnums.PA_UI_CONTROL_TYPE.PA_UI_CONTROL_WEBCONTROL, Panel_CharacterCreateSelectClass, 'Static_ClassMovie'),
	
	CCSC_BackButton					= UI.getChildControl(Panel_CharacterCreateSelectClass, "Button_Back"),
	CCSC_SelectClassButton			= UI.getChildControl(Panel_CharacterCreateSelectClass, "Button_SelectClass"),
	
	-- 새 커스터 마이징 시 사용하는 edit text , 기존 name edit 와 해당 edit 둘 중 하나를 없애야 함.
	CM_StaticText_CharacterName		= UI.getChildControl(Panel_CustomizationMain, "StaticText_CharacterName"),
	CM_Edit_CharacterName		= UI.getChildControl(Panel_CustomizationMain, "Edit_CharacterName"),
}

local Character_Status = {
	_status_Warrior			= UI.getChildControl( Panel_CharacterCreateSelectClass, "Static_Stat_Warrior"),
	_status_Ranger			= UI.getChildControl( Panel_CharacterCreateSelectClass, "Static_Stat_Ranger"),
	_status_Sorcerer		= UI.getChildControl( Panel_CharacterCreateSelectClass, "Static_Stat_Sorcerer"),
	_status_Giant			= UI.getChildControl( Panel_CharacterCreateSelectClass, "Static_Stat_Giant"),
	_status_BeastMaster		= UI.getChildControl( Panel_CharacterCreateSelectClass, "Static_Stat_BeastMaster"),
	
	_stat_Ctrl				= UI.getChildControl( Panel_CharacterCreateSelectClass, "StaticText_Stat_Ctrl"),
	_stat_Att				= UI.getChildControl( Panel_CharacterCreateSelectClass, "StaticText_Stat_Att"),
	_stat_Def				= UI.getChildControl( Panel_CharacterCreateSelectClass, "StaticText_Stat_Def"),
	_stat_Evd				= UI.getChildControl( Panel_CharacterCreateSelectClass, "StaticText_Stat_Evd"),
	_stat_Cmb				= UI.getChildControl( Panel_CharacterCreateSelectClass, "StaticText_Stat_Cmb"),
}

local Panel_Lobby_Global_Variable = {
	UIList							= {},
	UiMaker							= nil,
	characterSelect					= -1,
	notClearValueCharacterSelect	= -1,
	characterSelectType				= -1,
	selectRegionInfo				= nil,
	isWaitLine						= false,
	selectCharacterLevel			= -1,
	--lastTicketNoByRegion = const_64.s64_0,		-- 자신이 선택한 캐릭터에 접속하기 위한 region(령) 내에서의 대기 순번
}

local Panel_Lobby_Enum = {
	--create character scene / View control
	eRotate_Left	= 0,
	eRotate_Right	= 1,
	eDistance_Far	= 2,
	eDistance_Near	= 3,
	eArrow_Up		= 4,
	eArrow_Down		= 5,
	eArrow_Left		= 6,
	eArrow_Right	= 7,

	--create character scene / Chracter Radio
	eClassType_Warrior		= 0,
	eClassType_Ranger		= 1,
	eClassType_Sorcerer		= 2,
	eClassType_Giant		= 3,
	eClassType_Tamer		= 4,
	eClassType_BladeMaster	= 5,
	eClassType_Kunoichi		= 6,

	--create character scene / Chracter Radio
	eCharacterCustomization_HeadMesh = 0,
	eCharacterCustomization_HairMesh = 1,
}

-- 하단부 현재 진행 상황
local _CharInfo_BG 		= UI.getChildControl ( Panel_CharacterSelect, "Static_CharInfo_BG" )
_CharInfo_BG:setGlassBackground( false )

local Panel_CharacterDoing =
{
	_CharInfo_Name 			= UI.getChildControl ( Panel_CharacterSelect, "StaticText_CharInfo_Name" ),
	_CharInfo_GaugeBG 		= UI.getChildControl ( Panel_CharacterSelect, "Static_CharInfo_GaugeBG" ),
	_CharInfo_Gauge 		= UI.getChildControl ( Panel_CharacterSelect, "Progress2_CharInfo_Gauge" ),
	_CharInfo_DoText 		= UI.getChildControl ( Panel_CharacterSelect, "StaticText_CharInfo_Do" ),
	_CharInfo_NowPos 		= UI.getChildControl ( Panel_CharacterSelect, "StaticText_CharInfo_NowPos" ),
	_CharInfo_WhereText 	= UI.getChildControl ( Panel_CharacterSelect, "StaticText_CharInfo_Where" ),
	_ticketNoByRegion		 = UI.getChildControl ( Panel_CharacterSelect, "StaticText_TicketNoByRegion" ),
}

-- 캐릭터 버튼에 있는 미니미한 애들
local characterSelect_DoWork =
{
	_doWork_BG 			= UI.getChildControl ( Panel_CharacterSelect, "Static_Work_BG" ),
	_doWork_GaugeBG 	= UI.getChildControl ( Panel_CharacterSelect, "Static_Work_GaugeBG" ),
	_doWork_Gauge 		= UI.getChildControl ( Panel_CharacterSelect, "Static_Work_Gauge" ),
	_doWork_Icon 		= UI.getChildControl ( Panel_CharacterSelect, "Static_Work_Icon" ),
}

local Panel_Customization = {
	group = {},
}
local Panel_Lobby_LDownCheck_ViewControl = {}
local _headContentImage = {}
local _hairContentImage = {}

local characterTicketAbleUI = {}

-------------------------------
-- 구현부
-------------------------------
local Panel_Lobby_Function_Initialize = function()
	UI.ASSERT(nil ~= Panel_CharacterSelect							,"selectCharacter					nil")
	UI.ASSERT(nil ~= Panel_Lobby_UI.SC_CharacterSelectText			,"SC_CharacterSelectText			nil")
	UI.ASSERT(nil ~= Panel_Lobby_UI.SC_ChracterSelectButton			,"SC_ChracterSelectButton			nil")
	UI.ASSERT(nil ~= Panel_Lobby_UI.SC_ChracterSelectButtonMain		,"SC_ChracterSelectButtonMain		nil")
	UI.ASSERT(nil ~= Panel_Lobby_UI.SC_ChracterSelectButtonText		,"SC_ChracterSelectButtonText		nil")
	
	UI.ASSERT(nil ~= Panel_Lobby_UI.SC_CharacterCreateButton		,"SC_CharacterCreateButton			nil")
	UI.ASSERT(nil ~= Panel_Lobby_UI.SC_CharacterDeleteButton		,"SC_CharacterDeleteButton			nil")
	UI.ASSERT(nil ~= Panel_Lobby_UI.SC_CharacterDeleteCancelButton	,"SC_CharacterDeleteCancelButton	nil")
	
	UI.ASSERT(nil ~= Panel_Lobby_UI.SC_CharacterDeleteCancelTitle	,"SC_CharacterDeleteCancelTitle	nil")
	UI.ASSERT(nil ~= Panel_Lobby_UI.SC_CharacterDeleteCancelDate	,"SC_CharacterDeleteCancelDate	nil")
	
	UI.ASSERT(nil ~= Panel_Lobby_UI.SC_StartGameButton				,"SC_StartGameButton		nil")
	UI.ASSERT(nil ~= Panel_Lobby_UI.SC_CreateCharacterBG			,"SC_CreateCharacterBG		nil")
	UI.ASSERT(nil ~= Panel_Lobby_UI.SC_CharacterSlotBG				,"SC_CharacterSlotBG		nil")
	UI.ASSERT(nil ~= Panel_Lobby_UI.SC_BackServerSelect				,"SC_BackServerSelect		nil")
	UI.ASSERT(nil ~= Panel_Lobby_UI.SC_GameEnd						,"SC_GameEnd				nil")
	UI.ASSERT(nil ~= Panel_Lobby_UI.SC_CharacterUserCount			,"SC_CharacterUserCount		nil")

	UI.ASSERT(nil ~= Panel_CharacterCreateSelectClass				,"createCharacter_SelectClass	nil")
	UI.ASSERT(nil ~= Panel_Lobby_UI.CCSC_ClassName					,"CCSC_ClassName				nil")
	UI.ASSERT(nil ~= Panel_Lobby_UI.CCSC_PartLine					,"CCSC_PartLine					nil")
	UI.ASSERT(nil ~= Panel_Lobby_UI.CCSC_ClassDescBG				,"CCSC_ClassDescBG				nil")
	UI.ASSERT(nil ~= Panel_Lobby_UI.CCSC_ClassDesc					,"CCSC_ClassDesc				nil")
	UI.ASSERT(nil ~= Panel_Lobby_UI.CCSC_CreateButton				,"CCSC_CreateButton				nil")
	UI.ASSERT(nil ~= Panel_Lobby_UI.CCSC_ClassMovie					,"CCSC_ClassMovie				nil")
	UI.ASSERT(nil ~= Panel_Lobby_UI.CCSC_BackButton					,"CCSC_BackButton				nil")
	UI.ASSERT(nil ~= Panel_Lobby_UI.CCSC_SelectClassButton			,"CCSC_SelectClassButton		nil")
	
	UI.ASSERT(nil ~= Panel_CharacterCreate							,"createCharacter			nil")
	UI.ASSERT(nil ~= Panel_Lobby_UI.CC_CharacterCreateText			,"CC_CharacterCreateText	nil")
	UI.ASSERT(nil ~= Panel_Lobby_UI.CC_CharacterNameEdit			,"CC_CharacterNameEdit		nil")
	UI.ASSERT(nil ~= Panel_Lobby_UI.CC_CreateButton					,"CC_CreateButton			nil")
	UI.ASSERT(nil ~= Panel_Lobby_UI.CC_BackButton					,"CC_BackButton				nil")

	UI.ASSERT(nil ~= Panel_Lobby_UI.CC_SelectClassButton			,"CC_SelectClassButton		nil")	
	UI.ASSERT(nil ~= Panel_Lobby_UI.CC_BackgroundButton				,"CC_BackgroundButton		nil")

	UI.ASSERT(nil ~= Panel_Lobby_UI.SC_FamilyNameText				,"SC_FamilyNameText			nil")
	
	if isGameServiceTypeKor() then
		Panel_Lobby_UI.CC_CharacterNameEdit:SetMaxInput( 15 )
	elseif isGameServiceTypeDev() then
		Panel_Lobby_UI.CC_CharacterNameEdit:SetMaxInput( 15 )
	else
		Panel_Lobby_UI.CC_CharacterNameEdit:SetMaxInput( 30 )
	end
	
	Panel_Lobby_UI.CC_FrameHead_Content 		= UI.getChildControl(Panel_Lobby_UI.CC_FrameHead, "Frame_Head_Content")
	Panel_Lobby_UI.CC_FrameHead_Content_Image 	= UI.getChildControl(Panel_Lobby_UI.CC_FrameHead_Content, "Frame_Head_Content_Image")
	Panel_Lobby_UI.CC_FrameHead_Scroll 			= UI.getChildControl(Panel_Lobby_UI.CC_FrameHead, "Frame_Head_Scroll")

	Panel_Lobby_UI.CC_FrameHair_Content 		= UI.getChildControl(Panel_Lobby_UI.CC_FrameHair, "Frame_Hair_Content")
	Panel_Lobby_UI.CC_FrameHair_Content_Image 	= UI.getChildControl(Panel_Lobby_UI.CC_FrameHair_Content, "Frame_Hair_Content_Image")
	Panel_Lobby_UI.CC_FrameHair_Scroll 			= UI.getChildControl(Panel_Lobby_UI.CC_FrameHair, "Frame_Hair_Scroll")

	--시작시 모두 하이드
	Panel_CharacterSelect				:SetShow(false,false)
	Panel_CharacterCreate				:SetShow(false,false)
	Panel_CharacterCreateSelectClass	:SetShow(false,false) -- 클래스 선택창

	Panel_Lobby_UI.SC_ChracterSelectButton			:SetShow(false)
	Panel_Lobby_UI.SC_ChracterSelectButtonMain		:SetShow(false)
	Panel_Lobby_UI.SC_ChracterSelectButtonText		:SetShow(false)
	Panel_Lobby_UI.SC_CharacterDeleteCancelButton	:SetShow(false)
	Panel_Lobby_UI.SC_CharacterDeleteCancelTitle	:SetShow(false)
	Panel_Lobby_UI.SC_CharacterDeleteCancelDate		:SetShow(false)
	Panel_Lobby_UI.SC_CreateCharacterBG				:SetShow(false)
	Panel_Lobby_UI.SC_CharacterDeleteButton			:SetShow(false)
	Panel_Lobby_UI.SC_CharacterCreateButton			:SetShow(false)
	Panel_Lobby_UI.SC_CharacterSlotBG				:SetShow(false)
	Panel_Lobby_UI.SC_CharacterSelectBG				:SetShow(false)
	Panel_Lobby_UI.SC_CharacterSelectBG:SetSize(430, getScreenSizeY())
	Panel_Lobby_UI.CCSC_CreateBG:SetSize(450, getScreenSizeY())
	Panel_Lobby_UI.SC_BackServerSelect				:SetShow(false)
	Panel_Lobby_UI.SC_GameEnd						:SetShow(false)
	Panel_Lobby_UI.SC_DeleteFamilyName				:SetShow(false)
	Panel_Lobby_UI.SC_CharacterUserCount			:SetShow(false)
	Panel_Lobby_UI.SC_CharacterUserCount:SetText( "" )
	
	Panel_Lobby_UI.SC_CharacterSlotBG:setGlassBackground(true)
	Panel_Lobby_UI.CC_characterCreateBG:setGlassBackground(true)
	Panel_Lobby_UI.CCSC_CreateBG:setGlassBackground(true)
	Panel_Lobby_UI.SC_CharacterSelectBG:setGlassBackground(true)
	

	--케릭터 선택화면
	Panel_Lobby_UI.SC_StartGameButton				:addInputEvent("Mouse_LUp", "Panel_Lobby_function_SelectCharacter()")
	Panel_Lobby_UI.SC_CreateCharacterBG				:addInputEvent("Mouse_LUp", "CreateCharacterSlot()")
	Panel_Lobby_UI.SC_CharacterCreateButton			:addInputEvent("Mouse_LUp", "changeCreateCharacterMode_SelectClass()") -- 클래스 선택창으로 이동
	Panel_Lobby_UI.SC_CharacterDeleteButton			:addInputEvent("Mouse_LUp", "Panel_Lobby_function_DeleteCharacter_MessageBox()")
	Panel_Lobby_UI.SC_CharacterDeleteCancelButton	:addInputEvent("Mouse_LUp", "Panel_Lobby_function_DeleteCancelCharacter()")
	Panel_Lobby_UI.SC_BackServerSelect				:addInputEvent("Mouse_LUp", "click_backServerSelect()")
	Panel_Lobby_UI.SC_GameEnd						:addInputEvent("Mouse_LUp", "lobby_GameEnd()")
	Panel_Lobby_UI.SC_DeleteFamilyName				:addInputEvent("Mouse_LUp", "")	-- 가문 삭제

	-- 캐릭터 생성_클래스 선택화면
	Panel_Lobby_UI.CCSC_ClassName				:addInputEvent("Mouse_LUp", "")
	Panel_Lobby_UI.CCSC_PartLine				:addInputEvent("Mouse_LUp", "")
	Panel_Lobby_UI.CCSC_ClassDescBG				:addInputEvent("Mouse_LUp", "")			
	Panel_Lobby_UI.CCSC_ClassDesc				:addInputEvent("Mouse_LUp", "")			
	Panel_Lobby_UI.CCSC_CreateButton			:addInputEvent("Mouse_LUp", "changeCreateCharacterMode()")
	Panel_Lobby_UI.CCSC_BackButton				:addInputEvent("Mouse_LUp", "Panel_CharacterCreateCancel()")
	Panel_Lobby_UI.CCSC_SelectClassButton		:addInputEvent("Mouse_LUp", "")
	Panel_Lobby_UI.CCSC_WarriorButton			:addInputEvent("Mouse_LUp", "Panel_Lobby_function_SelectClassType(0, true)")
	Panel_Lobby_UI.CCSC_WarriorButton			:addInputEvent("Mouse_On", "Panel_Lobby_SelectClass_MouseEvent(0, true)")
	Panel_Lobby_UI.CCSC_WarriorButton			:addInputEvent("Mouse_Out", "Panel_Lobby_SelectClass_MouseEvent(0, false)")
	Panel_Lobby_UI.CCSC_RangerButton			:addInputEvent("Mouse_LUp", "Panel_Lobby_function_SelectClassType(1, true)")
	Panel_Lobby_UI.CCSC_RangerButton			:addInputEvent("Mouse_On", "Panel_Lobby_SelectClass_MouseEvent(1, true)")
	Panel_Lobby_UI.CCSC_RangerButton			:addInputEvent("Mouse_Out", "Panel_Lobby_SelectClass_MouseEvent(1, false)")
	Panel_Lobby_UI.CCSC_SorcerButton			:addInputEvent("Mouse_LUp", "Panel_Lobby_function_SelectClassType(2, true)")
	Panel_Lobby_UI.CCSC_SorcerButton			:addInputEvent("Mouse_On", "Panel_Lobby_SelectClass_MouseEvent(2, true)")
	Panel_Lobby_UI.CCSC_SorcerButton			:addInputEvent("Mouse_Out", "Panel_Lobby_SelectClass_MouseEvent(2, false)")
	Panel_Lobby_UI.CCSC_GiantButton				:addInputEvent("Mouse_LUp", "Panel_Lobby_function_SelectClassType(3, true)")
	Panel_Lobby_UI.CCSC_GiantButton				:addInputEvent("Mouse_On", "Panel_Lobby_SelectClass_MouseEvent(3, true)")
	Panel_Lobby_UI.CCSC_GiantButton				:addInputEvent("Mouse_Out", "Panel_Lobby_SelectClass_MouseEvent(3, false)")
	Panel_Lobby_UI.CCSC_TamerButton				:addInputEvent("Mouse_LUp", "Panel_Lobby_function_SelectClassType(4, true)") -- Panel_Lobby_function_SelectClassType(4, true)
	Panel_Lobby_UI.CCSC_TamerButton				:addInputEvent("Mouse_On", "Panel_Lobby_SelectClass_MouseEvent(4, true)") -- Panel_Lobby_SelectClass_MouseEvent(4, true)
	Panel_Lobby_UI.CCSC_TamerButton				:addInputEvent("Mouse_Out", "Panel_Lobby_SelectClass_MouseEvent(4, false)") -- Panel_Lobby_SelectClass_MouseEvent(4, false)
	Panel_Lobby_UI.CCSC_BladeMasterButton		:addInputEvent("Mouse_LUp", "Panel_Lobby_function_SelectClassType(5, true)") -- Panel_Lobby_function_SelectClassType(5, true)
	Panel_Lobby_UI.CCSC_BladeMasterButton		:addInputEvent("Mouse_On", "Panel_Lobby_SelectClass_MouseEvent(5, true)") -- Panel_Lobby_SelectClass_MouseEvent(5, true)
	Panel_Lobby_UI.CCSC_BladeMasterButton		:addInputEvent("Mouse_Out", "Panel_Lobby_SelectClass_MouseEvent(5, false)") -- Panel_Lobby_SelectClass_MouseEvent(5, false)
	Panel_Lobby_UI.CCSC_ValkyrieButton			:addInputEvent("Mouse_LUp", "")
	Panel_Lobby_UI.CCSC_WizardButton			:addInputEvent("Mouse_LUp", "")
	
	Panel_Lobby_UI.CCSC_KunoichiButton			:addInputEvent("Mouse_LUp", "Panel_Lobby_function_SelectClassType(6, true)")
	Panel_Lobby_UI.CCSC_KunoichiButton			:addInputEvent("Mouse_On", "Panel_Lobby_SelectClass_MouseEvent(6, true)")
	Panel_Lobby_UI.CCSC_KunoichiButton			:addInputEvent("Mouse_Out", "Panel_Lobby_SelectClass_MouseEvent(6, false)")

	--케릭터 생성화면
	-- Panel_CharacterCreate:RegisterUpdateFunc("Panel_Lobby_function_UpdateButtonPush")
	Panel_Lobby_UI.CC_SelectClassButton			:addInputEvent("Mouse_LUp", "changeCreateCharacterMode_SelectClass()")
	Panel_Lobby_UI.CC_BackgroundButton			:addInputEvent("Mouse_LUp", "viewCharacterCreateMode_ChangeBackground()")

	Panel_Lobby_UI.CC_CreateButton				:addInputEvent("Mouse_LUp",		"Panel_CharacterCreateOk()")
	Panel_Lobby_UI.CC_BackButton				:addInputEvent("Mouse_LUp",		"Panel_CharacterCreateCancel()")
	
	Panel_Lobby_UI.SC_StartGameButton			:ActiveMouseEventEffect( true )
	Panel_Lobby_UI.SC_CharacterCreateButton		:ActiveMouseEventEffect( true )
	Panel_Lobby_UI.SC_BackServerSelect			:ActiveMouseEventEffect( true )
	Panel_Lobby_UI.SC_GameEnd					:ActiveMouseEventEffect( true )
	Panel_Lobby_UI.SC_DeleteFamilyName			:ActiveMouseEventEffect( true )
	Panel_Lobby_UI.SC_ChracterSelectButtonMain	:ActiveMouseEventEffect( true )
	
	-- 하단부 캐릭터 정보 초기화
	Panel_Lobby_CharacterInfo()
	
	-- 영상 임시 만들기
	local scrX = getScreenSizeX()
	local scrY = getScreenSizeY()
	
	Panel_Lobby_UI.CCSC_ClassMovie:SetPosX( scrX - 441 )
	Panel_Lobby_UI.CCSC_ClassMovie:SetPosY( scrY - 372 )
	Panel_Lobby_UI.CCSC_ClassMovie:SetUrl(422, 237, "coui://UI_Data/UI_Html/Class_Movie.html")
	Panel_Lobby_UI.CCSC_ClassMovie:SetSize(422, 237)
	Panel_Lobby_UI.CCSC_ClassMovie:SetSpanSize(-1,0)
	Panel_Lobby_UI.CCSC_ClassMovie:SetShow(true)
end

------------------------------------------------------------------------------------------------------------
------------------------------------------------------------------------------------------------------------
-- Processor별 Active 함수
------------------------------------------------------------------------------------------------------------
------------------------------------------------------------------------------------------------------------
--local Panel_Lobby_function_StartUp_SelectCharacter = function()
function Panel_Lobby_function_StartUp_SelectCharacter( characterIndex )
	Panel_Lobby_Global_Variable.UiMaker = Panel_CharacterSelect
	Panel_Lobby_Global_Variable.UiMaker:SetSize(getScreenSizeX(), getScreenSizeY())

	Panel_Lobby_UI.SC_CharacterSelectText:ComputePos()
	Panel_Lobby_UI.SC_ChracterSelectButton:ComputePos()
	Panel_Lobby_UI.SC_ChracterSelectButtonMain:ComputePos()
	Panel_Lobby_UI.SC_ChracterSelectButtonText:ComputePos()
	Panel_Lobby_UI.SC_CharacterCreateButton:ComputePos()
	Panel_Lobby_UI.SC_CharacterDeleteButton:ComputePos()
	Panel_Lobby_UI.SC_CharacterDeleteCancelButton:ComputePos()
	Panel_Lobby_UI.SC_CharacterDeleteCancelTitle:ComputePos()
	Panel_Lobby_UI.SC_CharacterDeleteCancelDate:ComputePos()
	Panel_Lobby_UI.SC_StartGameButton:ComputePos()
	Panel_Lobby_UI.SC_CreateCharacterBG:ComputePos()
	Panel_Lobby_UI.SC_CharacterSlotBG:ComputePos()
	Panel_Lobby_UI.SC_CharacterSelectBG:ComputePos()
	Panel_Lobby_UI.SC_CharacterSelectBG:SetShow(true)
	Panel_Lobby_UI.SC_BackServerSelect:ComputePos()
	Panel_Lobby_UI.SC_BackServerSelect:SetShow(true)
	Panel_Lobby_UI.SC_GameEnd:ComputePos()
	Panel_Lobby_UI.SC_GameEnd:SetShow(true)
	Panel_Lobby_UI.SC_DeleteFamilyName:ComputePos()
	-- Panel_Lobby_UI.SC_DeleteFamilyName:SetShow(true)
	Panel_Lobby_UI.SC_FamilyNameText:ComputePos()
	Panel_Lobby_UI.SC_CharacterUserCount:ComputePos()
	Panel_Lobby_UI.SC_PartLine:ComputePos()
	
	local firstTicketNo = getFirstTicketNoByAll()
	local currentTicketNo = getCurrentTicketNo()
	
	table.remove( characterTicketAbleUI )
	local count = getCharacterDataCount()
	local	aControl
	for idx = 0 , count - 1 do
		local characterData = getCharacterDataByIndex(idx)
		if ( nil == characterData ) then
			break
		end
		aControl = Panel_Lobby_function_CreateButton( "CharacterButton", UCT_RADIOBUTTON, idx, Panel_Lobby_UI.SC_ChracterSelectButton, idx * ( Panel_Lobby_UI.SC_ChracterSelectButton:GetSizeY() + 5 ) )
		local ChkLevel	= string.format( "Lv. %d", characterData._level )
		local characterName = getCharacterName(characterData)
		-- local	buttonText	= PAGetStringParam2( Defines.StringSheet_GAME, "CHARACTER_SELECT_LV", "character_level", ChkLevel, "character_name", getCharacterName(characterData) )		-- 일단 필요없음
		local	removeTime	= getCharacterDataRemoveTime(idx)
		
		if	nil ~= removeTime then
			characterName	= ( characterName .. " " .. PAGetString(Defines.StringSheet_GAME, "CHARACTER_DELETING") )
		end
		
		-------------------------------------------
		--			캐릭터 이름 복사하기
		local textControl = UI.createControl( UCT_STATICTEXT, aControl, "Static_CharacterName_Text"..idx)
		CopyBaseProperty( Panel_Lobby_UI.SC_CharacterName, textControl )
		textControl:SetTextMode( UI_TM.eTextMode_AutoWrap )
		textControl:SetText( characterName )
		textControl:ComputePos()
		textControl:SetShow(true)

		-------------------------------------------
		--			캐릭터 레벨 복사하기
		local levelTextControl = UI.createControl( UCT_STATICTEXT, aControl, "Static_CharacterLevel_Text"..idx)
		CopyBaseProperty( Panel_Lobby_UI.SC_CharacterLevel, levelTextControl )
		levelTextControl:ComputePos()
		levelTextControl:SetShow(true)
		levelTextControl:SetText( ChkLevel )
		
		-- local ChkLevel = tostring(ChkLevel)
		-- if ( 10 >= ChkLevel ) and ( ChkLevel >= 1 ) then
			-- levelTextControl:SetFontColor( UI_color.C_FFA8FC00 )
		-- elseif ( 20 >= ChkLevel ) and ( ChkLevel >= 11 ) then
			-- levelTextControl:SetFontColor( UI_color.C_FFFBFF8A )
		-- elseif ( 30 >= ChkLevel ) and ( ChkLevel >= 21 ) then
			-- levelTextControl:SetFontColor( UI_color.C_FFFF8A8A )
		-- elseif ( 40 >= ChkLevel ) and ( ChkLevel >= 31 ) then
			-- levelTextControl:SetFontColor( UI_color.C_FFFFFFFF )
		-- elseif ( 50 >= ChkLevel ) and ( ChkLevel >= 41 ) then
			-- levelTextControl:SetFontColor( UI_color.C_FFFF3636 )
		-- elseif ( ChkLevel >= 51 ) then
			-- levelTextControl:SetFontColor( UI_color.C_FF7800D5 )
		-- end

		-------------------------------------------
		--		현재 캐릭터 작업상황 복사하기		
		Panel_Lobby_function_SetPcWorkingInfo( characterData, aControl, idx )

		
		-------------------------------------------
		--		캐릭터 클래스 아이콘 복사
		local characterType = getCharacterClassType( characterData )
		if ( characterType == UI_Class.ClassType_Warrior ) then
			aControl:ChangeTextureInfoName("New_UI_Common_forLua/Window/Lobby/Lobby_ClassSelect_Btn_00.dds")
			local x1, y1, x2, y2 = setTextureUV_Func( aControl, 2, 1, 458, 61 )
			aControl:getBaseTexture():setUV(  x1, y1, x2, y2  )
			aControl:setRenderTexture(aControl:getBaseTexture())
			
			aControl:ChangeOnTextureInfoName ( "New_UI_Common_forLua/Window/Lobby/Lobby_ClassSelect_Btn_00.dds" )
			local x1, y1, x2, y2 = setTextureUV_Func( aControl, 2, 62, 458, 122 )
			aControl:getOnTexture():setUV(  x1, y1, x2, y2  )

			aControl:ChangeClickTextureInfoName ( "New_UI_Common_forLua/Window/Lobby/Lobby_ClassSelect_Btn_00.dds" )
			local x1, y1, x2, y2 = setTextureUV_Func( aControl, 2, 123, 458, 183 )
			aControl:getClickTexture():setUV(  x1, y1, x2, y2  )

		elseif ( characterType == UI_Class.ClassType_Ranger ) then
			aControl:ChangeTextureInfoName("New_UI_Common_forLua/Window/Lobby/Lobby_ClassSelect_Btn_00.dds")
			local x1, y1, x2, y2 = setTextureUV_Func( aControl, 2, 184, 458, 244 )
			aControl:getBaseTexture():setUV(  x1, y1, x2, y2  )
			aControl:setRenderTexture(aControl:getBaseTexture())

			aControl:ChangeOnTextureInfoName ( "New_UI_Common_forLua/Window/Lobby/Lobby_ClassSelect_Btn_00.dds" )
			local x1, y1, x2, y2 = setTextureUV_Func( aControl, 2, 245, 458, 305 )
			aControl:getOnTexture():setUV(  x1, y1, x2, y2  )

			aControl:ChangeClickTextureInfoName ( "New_UI_Common_forLua/Window/Lobby/Lobby_ClassSelect_Btn_00.dds" )
			local x1, y1, x2, y2 = setTextureUV_Func( aControl, 2, 306, 458, 366 )
			aControl:getClickTexture():setUV(  x1, y1, x2, y2  )

		elseif ( characterType == UI_Class.ClassType_Sorcerer ) then
			aControl:ChangeTextureInfoName("New_UI_Common_forLua/Window/Lobby/Lobby_ClassSelect_Btn_00.dds")
			local x1, y1, x2, y2 = setTextureUV_Func( aControl, 2, 367, 458, 427 )
			aControl:getBaseTexture():setUV(  x1, y1, x2, y2  )
			aControl:setRenderTexture(aControl:getBaseTexture())

			aControl:ChangeOnTextureInfoName ( "New_UI_Common_forLua/Window/Lobby/Lobby_ClassSelect_Btn_00.dds" )
			local x1, y1, x2, y2 = setTextureUV_Func( aControl, 2, 428, 458, 488 )
			aControl:getOnTexture():setUV(  x1, y1, x2, y2  )

			aControl:ChangeClickTextureInfoName ( "New_UI_Common_forLua/Window/Lobby/Lobby_ClassSelect_Btn_01.dds" )
			local x1, y1, x2, y2 = setTextureUV_Func( aControl, 2, 1, 458, 61 )
			aControl:getClickTexture():setUV(  x1, y1, x2, y2  )

		elseif ( characterType == UI_Class.ClassType_Giant ) then
			aControl:ChangeTextureInfoName("New_UI_Common_forLua/Window/Lobby/Lobby_ClassSelect_Btn_01.dds")
			local x1, y1, x2, y2 = setTextureUV_Func( aControl, 2, 62, 458, 122 )
			aControl:getBaseTexture():setUV(  x1, y1, x2, y2  )
			aControl:setRenderTexture(aControl:getBaseTexture())

			aControl:ChangeOnTextureInfoName ( "New_UI_Common_forLua/Window/Lobby/Lobby_ClassSelect_Btn_01.dds" )
			local x1, y1, x2, y2 = setTextureUV_Func( aControl, 2, 123, 458, 183 )
			aControl:getOnTexture():setUV(  x1, y1, x2, y2  )

			aControl:ChangeClickTextureInfoName ( "New_UI_Common_forLua/Window/Lobby/Lobby_ClassSelect_Btn_01.dds" )
			local x1, y1, x2, y2 = setTextureUV_Func( aControl, 2, 184, 458, 244 )
			aControl:getClickTexture():setUV(  x1, y1, x2, y2  )

		elseif ( characterType == UI_Class.ClassType_Tamer ) then
			aControl:ChangeTextureInfoName("New_UI_Common_forLua/Window/Lobby/Lobby_ClassSelect_Btn_02.dds")
			local x1, y1, x2, y2 = setTextureUV_Func( aControl, 2, 1, 458, 61 )
			aControl:getBaseTexture():setUV(  x1, y1, x2, y2  )
			aControl:setRenderTexture(aControl:getBaseTexture())

			aControl:ChangeOnTextureInfoName ( "New_UI_Common_forLua/Window/Lobby/Lobby_ClassSelect_Btn_02.dds" )
			local x1, y1, x2, y2 = setTextureUV_Func( aControl, 2, 62, 458, 122 )
			aControl:getOnTexture():setUV( x1, y1, x2, y2 )

			aControl:ChangeClickTextureInfoName ( "New_UI_Common_forLua/Window/Lobby/Lobby_ClassSelect_Btn_02.dds" )
			local x1, y1, x2, y2 = setTextureUV_Func( aControl, 2, 123, 458, 183 )
			aControl:getClickTexture():setUV( x1, y1, x2, y2 )

		elseif ( characterType == UI_Class.ClassType_BladeMaster ) then
			aControl:ChangeTextureInfoName("New_UI_Common_forLua/Window/Lobby/Lobby_ClassSelect_Btn_02.dds")
			local x1, y1, x2, y2 = setTextureUV_Func( aControl, 2, 184, 458, 244 )
			aControl:getBaseTexture():setUV(  x1, y1, x2, y2  )
			aControl:setRenderTexture(aControl:getBaseTexture())

			aControl:ChangeOnTextureInfoName ( "New_UI_Common_forLua/Window/Lobby/Lobby_ClassSelect_Btn_02.dds" )
			local x1, y1, x2, y2 = setTextureUV_Func( aControl, 2, 245, 458, 305 )
			aControl:getOnTexture():setUV( x1, y1, x2, y2 )

			aControl:ChangeClickTextureInfoName ( "New_UI_Common_forLua/Window/Lobby/Lobby_ClassSelect_Btn_02.dds" )
			local x1, y1, x2, y2 = setTextureUV_Func( aControl, 2, 306, 458, 366 )
			aControl:getClickTexture():setUV( x1, y1, x2, y2 )

		else
			aControl:ChangeTextureInfoName("New_UI_Common_forLua/Window/Lobby/Lobby_ClassSelect_Btn_01.dds")
			local x1, y1, x2, y2 = setTextureUV_Func( aControl, 2, 245, 458, 305 )
			aControl:getBaseTexture():setUV(  x1, y1, x2, y2  )
			aControl:setRenderTexture(aControl:getBaseTexture())
			aControl:ChangeOnTextureInfoName ( "New_UI_Common_forLua/Window/Lobby/Lobby_ClassSelect_Btn_01.dds" )
			local x1, y1, x2, y2 = setTextureUV_Func( aControl, 2, 306, 458, 366 )
			aControl:getOnTexture():setUV(  x1, y1, x2, y2  )
			aControl:ChangeClickTextureInfoName ( "New_UI_Common_forLua/Window/Lobby/Lobby_ClassSelect_Btn_01.dds" )
			local x1, y1, x2, y2 = setTextureUV_Func( aControl, 2, 367, 458, 427 )
			aControl:getClickTexture():setUV(  x1, y1, x2, y2  )
		end

		-- 	지역별 대기자 수
		local userCountControl = UI.createControl( UCT_STATICTEXT, aControl, "userCountText"..idx)
		CopyBaseProperty( Panel_Lobby_UI.SC_CharacterUserCount, userCountControl )
		userCountControl:SetTextMode( UI_TM.eTextMode_AutoWrap )
		userCountControl:SetShow(true)
		characterTicketAbleUI[ idx ] = userCountControl

		--if -2 ~= characterIndex or (-2 == characterIndex and Panel_Lobby_Global_Variable.notClearValueCharacterSelect ~= idx) then		-- 대기열을 받았을 때의 인덱스.. 표시하지 않는다...
			--UI.debugMessage( "characterData._lastTicketNoByRegion : " .. tostring( characterData._lastTicketNoByRegion ) .. " currentTicketNo : " .. tostring( currentTicketNo ) )
			local myTicketCount = currentTicketNo - characterData._lastTicketNoByRegion
			local serverPlayingCount = currentTicketNo - firstTicketNo
			if const_64.s64_m1 ~= firstTicketNo  or const_64.s64_m1 ~= characterData._lastTicketNoByRegion then
					characterTicketAbleUI[ idx ]:SetFontColor( Defines.Color.C_FFD20000 )
					characterTicketAbleUI[ idx ]:SetText( PAGetString(Defines.StringSheet_GAME, "LUA_GAMEEXIT_NOT_ENTER_TO_FIELD") )	-- 대기자 있음	.. " " .. tostring( firstTicketNo ) .. " " .. tostring( characterData._lastTicketNoByRegion ) .. " " .. tostring( myTicketCount )
			elseif nil ~= removeTime then
				characterTicketAbleUI[ idx ]:SetShow( false )
				characterTicketAbleUI[ idx ]:SetText( PAGetString(Defines.StringSheet_GAME, "LUA_CHARACTER_DELETE" ) )
			else
				characterTicketAbleUI[ idx ]:SetFontColor( Defines.Color.C_FF96D4FC )
				characterTicketAbleUI[ idx ]:SetText( PAGetString(Defines.StringSheet_GAME, "LUA_GAMEEXIT_ENTER_TO_FIELD") )	-- 바로 입장 가능	 .. " " .. tostring( firstTicketNo ) .. " " .. tostring( characterData._lastTicketNoByRegion ) .. " " .. tostring( myTicketCount )
			end
		--end
		
		if (-2 == characterIndex and Panel_Lobby_Global_Variable.notClearValueCharacterSelect == idx) then
			characterTicketAbleUI[ idx ]:SetShow( false )
		end

		-- local workingText = global_workTypeToString( characterData._pcWorkingType )
		-- workingTypeTextControl:SetText( characterData._pcWorkingType .. " " .. workingText )

		Panel_CharacterSelect:SetChildIndex( Panel_Lobby_UI.SC_CharacterDeleteButton:GetKey(), 9999 )
		Panel_CharacterSelect:SetChildIndex( Panel_Lobby_UI.SC_StartGameButton:GetKey(), 9999 )
		Panel_CharacterSelect:SetChildIndex( Panel_Lobby_UI.SC_CharacterName:GetKey(), 9999 )

		aControl:addInputEvent("Mouse_LUp", "Panel_Lobby_function_ViewCharacter(" .. idx .. ")")
		--aControl:addInputEvent("Mouse_LDClick", "Panel_Lobby_function_SelectCharacter(" .. idx .. ")") -- 더블클릭 시 바로 시작, 일단 주석
	end
	
	-- 최대 케릭터 개수가 필요하다 ㅠㅠ
	local maxCharacterCount = getCharacterSlotLimit()
	if count < maxCharacterCount then
		Panel_Lobby_UI.SC_CreateCharacterBG:SetShow( true )

		local startPosY = Panel_Lobby_UI.SC_ChracterSelectButton:GetPosY() + (Panel_Lobby_UI.SC_ChracterSelectButton:GetSizeY() + 5) * count 
		Panel_Lobby_UI.SC_CreateCharacterBG:SetPosY( startPosY + 0 )
	else 
		Panel_Lobby_UI.SC_CreateCharacterBG:SetShow( false )
	end
	-- 인덱스가 다를 경우 오류가 생겨서 임시로 두번 셋팅하게 하였음.
	setWeatherTime(8 ,9)
	setWeatherTime(8 ,9)
	
	-- 해당 값이 설정되었다면 캐릭터 교체로 대기열을 타게 되기때문에 선택된 캐릭터를 선택하게 해주자
	if -1 == characterIndex then
		characterIndex = 0
	elseif -2 == characterIndex then		-- 대기열 갱신시 들어오는 값이다. 선택된 캐릭터를 선택되게 한다.
		selectCharacter(Panel_Lobby_Global_Variable.characterSelect)
	else
		selectCharacter(characterIndex)
	end
	
	-- 하나라도 케릭터가 있으면, 기본으로 맨 위의 케릭터를 선택한다.
	if 0 < count then
		Panel_Lobby_function_ViewCharacter( characterIndex )
	else
		-- 케릭터 생성 버튼을 활성화 해야 한다!
		CreateCharacterSlot()
	end
	
	local familyName = getFamilyName()
	Panel_Lobby_UI.SC_FamilyNameText:SetText( familyName )
	Panel_Lobby_UI.SC_FamilyNameText:SetPosX( Panel_Lobby_UI.SC_CharacterSelectBG:GetPosX() +15 )
end

---------------------------------------------------------------------------------------------------------------------------------------------
-- pcworkingIndo
function global_workTypeToString( workingType )
	local workingText
	if ePcWorkingType.ePcWorkType_Empty == workingType then
		workingText = "none"
	elseif ePcWorkingType.ePcWorkType_Play == workingType then
		workingText = "user Play"
	elseif ePcWorkingType.ePcWorkType_RepairItem == workingType then
		workingText = "repairing"
	elseif ePcWorkingType.ePcWorkType_Delivery == workingType then
		workingText = "deliveryPlayer"
	elseif ePcWorkingType.ePcWorkType_Relex == workingType then
		workingText = "relax"
	elseif ePcWorkingType.ePcWorkType_ReadBook == workingType then
		workingText = "readBook"
	else
		_PA_ASSERT(false, "캐릭터 작업 타입이 추가 되었습니다. Lobby_New.lua 도 추가해 주어야 합니다.")
		workingText = "unKnown 캐릭터 작업하기 타입이 추가 되었습니다." .. workingType
	end
	
	return workingText
end

-- pc 일하는 중 표시
function Panel_Lobby_function_SetPcWorkingInfo( characterData, parentControl, idx )
	local charInfo_workBG = UI.createControl( UCT_STATIC, parentControl, "Static_CharInfo_WorkBG_"..idx )				-- 작업아이콘 배경
	CopyBaseProperty( characterSelect_DoWork._doWork_BG, charInfo_workBG )
	charInfo_workBG:ComputePos()
	charInfo_workBG:SetShow(false)
	
	local charInfo_work_GaugeBG = UI.createControl( UCT_STATIC, parentControl, "Static_CharInfo_Work_GaugeBG_"..idx )	-- 작업 게이지 배경
	CopyBaseProperty( characterSelect_DoWork._doWork_GaugeBG, charInfo_work_GaugeBG )
	charInfo_work_GaugeBG:ComputePos()
	charInfo_work_GaugeBG:SetShow(false)
	
	local charInfo_work_Gauge = UI.createControl( UCT_STATIC, parentControl, "Static_CharInfo_Work_Gauge_"..idx )		-- 작업 게이지
	CopyBaseProperty( characterSelect_DoWork._doWork_Gauge, charInfo_work_Gauge )
	charInfo_work_Gauge:ComputePos()
	charInfo_work_Gauge:SetShow(false)
	charInfo_work_Gauge:SetSize( 3, 0 )
	
	local charInfo_work_Icon = UI.createControl( UCT_STATIC, parentControl, "Static_CharInfo_Work_Icon_"..idx )			-- 작업 아이콘
	CopyBaseProperty( characterSelect_DoWork._doWork_Icon, charInfo_work_Icon )
	charInfo_work_Icon:ComputePos()
	charInfo_work_Icon:SetShow(false)

	-------------------------------------------
	--		작업중이면 아이콘을 표시해준다
	if ePcWorkingType.ePcWorkType_Empty == characterData._pcWorkingType then
	elseif ePcWorkingType.ePcWorkType_Play == characterData._pcWorkingType then
	elseif ePcWorkingType.ePcWorkType_RepairItem == characterData._pcWorkingType then
	elseif ePcWorkingType.ePcWorkType_Delivery == characterData._pcWorkingType then
	elseif ePcWorkingType.ePcWorkType_Relex == characterData._pcWorkingType then
	elseif ePcWorkingType.ePcWorkType_ReadBook == characterData._pcWorkingType then
		charInfo_workBG:ChangeTextureInfoName("New_UI_Common_forLua/Window/Lobby/Lobby_00.dds")
		local x1, y1, x2, y2 = setTextureUV_Func( charInfo_workBG, 1, 1, 30, 30 )
		charInfo_workBG:getBaseTexture():setUV(  x1, y1, x2, y2  )
		charInfo_workBG:setRenderTexture(charInfo_workBG:getBaseTexture())

		charInfo_work_Icon:ChangeTextureInfoName("New_UI_Common_forLua/Window/Lobby/Lobby_00.dds")
		--local x1, y1, x2, y2 = setTextureUV_Func( charInfo_work_Icon, 64, 1, 96, 30 )
		local x1, y1, x2, y2 = setTextureUV_Func( charInfo_work_Icon, 31, 1, 62, 30 )
		charInfo_work_Icon:getBaseTexture():setUV(  x1, y1, x2, y2  )
		charInfo_work_Icon:setRenderTexture(charInfo_work_Icon:getBaseTexture())
		
		charInfo_workBG:SetShow( true )
		charInfo_work_GaugeBG:SetShow( true )
		charInfo_work_Gauge:SetShow( true )
		charInfo_work_Icon:SetShow( true )
	else
		_PA_ASSERT(false, "캐릭터 작업 타입이 추가 되었습니다. Lobby_New.lua 도 추가해 주어야 합니다.")
	end
end

---------------------------------------------------------------------------------------------------------------------------------------------

--zezzeg : 커스터마이징 테스트 
local Panel_Lobby_function_StartUp_CustomizingTest = function()
	-- 초기화.
	--Panel_Lobby_UI.CC_CharacterNameEdit:SetEditText('')
	SetFocusEdit( Panel_Lobby_UI.CM_Edit_CharacterName )
	Panel_Lobby_UI.CM_Edit_CharacterName:SetEditText('')
	
	Panel_CharacterCreate:ResetRadiobutton()
	Panel_Lobby_UI.CCSC_CreateBG:ComputePos()
	
	Panel_Customization_Control:SetShow(true, false)
	Panel_Customization_Control:SetSize ( getScreenSizeX(), getScreenSizeY() ) 
	
	Panel_CustomizationTest:SetSize ( getScreenSizeX(), getScreenSizeY() ) 
	
	Panel_CustomizationMesh:SetShow( false, false )
	Panel_CustomizationMotion:SetShow( false, false )
	Panel_CustomizationExpression:SetShow( false, false )
	Panel_CustomizationCloth:SetShow( false, false )
	Panel_CustomizationMain:SetShow( false, false )
	--Panel_CustomizationMainSlide:SetShow( false, false )
	Panel_CustomizationStatic:SetShow( false, false )
	Panel_CustomizationMessage:SetShow( false, false )
	Panel_CustomizationFrame:SetShow( false, false )
--	Panel_CustomizationFacialHair:SetShow( false, false )
	
	for _, value in pairs ( Panel_Lobby_UI ) do
		value:ComputePos()
	end
	
	viewCharacterCreateMode( Panel_Lobby_Global_Variable.characterSelectType )
end

local Panel_Lobby_function_classTypeTocharacterIndex = function( index )
	if ( index == 0 ) then
		return Panel_Lobby_Enum.eClassType_Warrior
	elseif ( index == 4 ) then
		return Panel_Lobby_Enum.eClassType_Ranger
	elseif ( index == 8 ) then
		return Panel_Lobby_Enum.eClassType_Sorcerer
	elseif ( index == 12 ) then
		return Panel_Lobby_Enum.eClassType_Giant
	elseif ( index == 16 ) then
		return Panel_Lobby_Enum.eClassType_Tamer
	elseif ( index == 20 ) then
		return Panel_Lobby_Enum.eClassType_BladeMaster
	elseif ( index == 30 ) then
		return Panel_Lobby_Enum.eClassType_Kunoichi

	else
		return -1
	end
end

-- 클래스 선택창
local Panel_Lobby_function_StartUp_CreateCharacter_SelectClass = function()
	Panel_Lobby_function_SelectClassType(0)
	Panel_Lobby_Global_Variable.UiMaker = Panel_CharacterCreateSelectClass
	Panel_Lobby_Global_Variable.UiMaker:SetSize(getScreenSizeX(), getScreenSizeY())
	Panel_CharacterCreateSelectClass:SetShow(true, false)
	Panel_CharacterCreateSelectClass:SetSize ( getScreenSizeX(), getScreenSizeY() )
	
	-----------------------------------------------
	--			스테이터스 보여주기
	-----------------------------------------------
	Character_Status._status_Warrior:SetShow( true )
	Character_Status._status_Ranger:SetShow( false )
	Character_Status._status_Sorcerer:SetShow( false )
	Character_Status._status_Giant:SetShow( false )
	Character_Status._status_BeastMaster:SetShow( false )
	
	for _, v in pairs ( Character_Status ) do
		v:ComputePos()
	end
	
	for _, value in pairs ( Panel_Lobby_UI ) do
		value:ComputePos()
	end
	
	-- 캐릭터 선택 버튼이 추가되어 주석 처리
	-- local count = getClassDataCount() - 1
	-- for idx = 0 , count do
		-- classType = getClassType(idx)
		-- characterIndex = Panel_Lobby_function_classTypeTocharacterIndex( classType )
		-- aControl = Panel_Lobby_function_CreateButtonPosX( "SelectClassButton", characterIndex, Panel_Lobby_UI.CCSC_SelectClassButton, characterIndex * ( Panel_Lobby_UI.CCSC_SelectClassButton:GetSizeX() + 5 ) )
		-- aControl:addInputEvent("Mouse_LUp", "Panel_Lobby_function_SelectClassType(" .. characterIndex .. ")")
	-- end
	--클래스 이미지
	Panel_Lobby_UI.CCSC_WarriorButton		:SetShow( false )
	Panel_Lobby_UI.CCSC_RangerButton		:SetShow( false )
	Panel_Lobby_UI.CCSC_SorcerButton		:SetShow( false )
	Panel_Lobby_UI.CCSC_GiantButton			:SetShow( false )
	Panel_Lobby_UI.CCSC_TamerButton			:SetShow( false )
	Panel_Lobby_UI.CCSC_BladeMasterButton	:SetShow( false )
	Panel_Lobby_UI.CCSC_KunoichiButton		:SetShow( false )
	Panel_Lobby_UI.CCSC_ValkyrieButton		:SetShow( false )
	Panel_Lobby_UI.CCSC_WizardButton		:SetShow( false )
	
	--클래스 이름
	Panel_Lobby_UI.CCSC_WarriorName			:SetShow( false )
	Panel_Lobby_UI.CCSC_RangerName			:SetShow( false )
	Panel_Lobby_UI.CCSC_SorcerName			:SetShow( false )
	Panel_Lobby_UI.CCSC_GiantName			:SetShow( false )
	Panel_Lobby_UI.CCSC_TamerName			:SetShow( false )
	Panel_Lobby_UI.CCSC_BladeMasterName		:SetShow( false )
	Panel_Lobby_UI.CCSC_ValkyrieName		:SetShow( false )
	Panel_Lobby_UI.CCSC_WizardName			:SetShow( false )
	Panel_Lobby_UI.CCSC_KunoichiName		:SetShow( false )

	local ClassBtn_Show = function(characterIndex)
		if ( 0 == characterIndex ) then
			Panel_Lobby_UI.CCSC_WarriorButton		:SetShow( true )
			Panel_Lobby_UI.CCSC_WarriorName			:SetShow( true )
		elseif ( 4 == characterIndex ) then
			Panel_Lobby_UI.CCSC_RangerButton		:SetShow( true )
			Panel_Lobby_UI.CCSC_RangerName			:SetShow( true )
		elseif ( 8 == characterIndex ) then
			Panel_Lobby_UI.CCSC_SorcerButton		:SetShow( true )
			Panel_Lobby_UI.CCSC_SorcerName			:SetShow( true )
		elseif ( 12 == characterIndex ) then
			Panel_Lobby_UI.CCSC_GiantButton			:SetShow( true )
			Panel_Lobby_UI.CCSC_GiantName			:SetShow( true )
		elseif ( 16 == characterIndex ) then -- 금수랑
			Panel_Lobby_UI.CCSC_TamerButton			:SetShow( true )
			Panel_Lobby_UI.CCSC_TamerName			:SetShow( true )
		elseif ( 20 == characterIndex ) then -- 무사
			Panel_Lobby_UI.CCSC_BladeMasterButton	:SetShow( true )
			Panel_Lobby_UI.CCSC_BladeMasterName		:SetShow( true )
		elseif ( 24 == characterIndex ) then -- 발키리
			Panel_Lobby_UI.CCSC_ValkyrieButton		:SetShow( true )
			Panel_Lobby_UI.CCSC_ValkyrieName		:SetShow( true )
		elseif ( 28 == characterIndex ) then -- 위자드
			Panel_Lobby_UI.CCSC_WizardButton		:SetShow( true )
			Panel_Lobby_UI.CCSC_WizardName			:SetShow( true )
		elseif ( 30 == characterIndex ) then -- 쿠노이치
			Panel_Lobby_UI.CCSC_KunoichiButton		:SetShow( true )
			Panel_Lobby_UI.CCSC_KunoichiName		:SetShow( true )
		end
	end

	
	local count = getPossibleClassCount()
	for index = 0, count -1 do
		classType = getPossibleClassTypeFromIndex(index)
		ClassBtn_Show(classType)
	end
end


function Panel_Lobby_Function_showCharacterCreate_SelectClass()
	Panel_Lobby_function_DeleteButton()
	Panel_Lobby_function_ClearData()
	Panel_Lobby_function_StartUp_CreateCharacter_SelectClass()
	Panel_CharacterSelect:SetShow(false,false)
	Panel_CharacterCreate:SetShow(false,false)
	--Panel_CharacterCreate1:SetShow(false,false)
	Panel_Customization_Control:SetShow(false, false)
	
	Panel_CustomizationMotion:SetShow( false, false )
	Panel_CustomizationExpression:SetShow( false, false )
	Panel_CustomizationCloth:SetShow( false, false )
	Panel_CustomizationTest:SetShow(false, false)
	Panel_CharacterCreateSelectClass:SetShow(true,false)
	Panel_CustomizationMesh:SetShow( false, false )
--	Panel_CustomizationMakeup:SetShow( false, false )
	Panel_CustomizationMain:SetShow( false, false )
	--Panel_CustomizationMainSlide:SetShow( false, false )
	Panel_CustomizationStatic:SetShow( false, false )
	Panel_CustomizationMessage:SetShow( false, false )
	Panel_CustomizationFrame:SetShow( false, false )
--	Panel_CustomizationTatoo:SetShow( false, false )
--	Panel_CustomizationWrinkle:SetShow( false, false )
--	Panel_CustomizationFacialHair:SetShow( false, false )
	
	Panel_CharacterCreateSelectClass:SetSize( getScreenSizeY(), getScreenSizeX() )
end

function Panel_Lobby_Function_showCharacterSelect( characterIndex )
	Panel_Lobby_function_DeleteButton()
	Panel_Lobby_function_ClearData()
	Panel_Lobby_function_StartUp_SelectCharacter( characterIndex )
	Panel_CharacterSelect:SetShow(true,false)
	Panel_CharacterCreate:SetShow(false,false)
	--Panel_CharacterCreate1:SetShow(false,false)
	Panel_Customization_Control:SetShow(false, false)
	Panel_CustomizationTest:SetShow(false, false)
	Panel_CharacterCreateSelectClass:SetShow(false,false)
	Panel_CustomizationTransform:SetShow(false, false)
	Panel_CustomizationMesh:SetShow( false, false )
	Panel_CustomizationMain:SetShow( false, false )
	--Panel_CustomizationMainSlide:SetShow( false, false )
	Panel_CustomizationStatic:SetShow( false, false )
	Panel_CustomizationMessage:SetShow( false, false )
	Panel_CustomizationFrame:SetShow( false, false )
	Panel_CustomizationMotion:SetShow( false, false )
	Panel_CustomizationExpression:SetShow( false, false )
	Panel_CustomizationCloth:SetShow( false, false )
--	Panel_CustomizationMakeup:SetShow( false, false )
--	Panel_CustomizationTatoo:SetShow( false, false )
--	Panel_CustomizationWrinkle:SetShow( false, false )
--	Panel_CustomizationFacialHair:SetShow( false, false )

	Panel_CharacterSelect:SetSize( getScreenSizeY(), getScreenSizeX() )
end

function Panel_Lobby_Function_showCharacterCustomization( customizationData )
	--InitializeCustomizationData( customizationData, Panel_Lobby_Global_Variable.characterSelectType  )
	
	Panel_Lobby_function_DeleteButton()
	Panel_CharacterSelect:SetShow(false,false)
	Panel_CharacterCreateSelectClass:SetShow(false, false)
	Panel_Lobby_UI.CM_Edit_CharacterName:SetEditText('')
	--Panel_Lobby_function_ClearData() -- 초기화 하지 않고 클래스 선택창에서 선택한 클래스를 그대로 사용한다.
	--Panel_CharacterCreate1:SetShow(true,false) 
	--Panel_CustomizationMainSlide:SetShow( false, false )
	
--	Panel_Lobby_UI.CC_characterCreateBG:SetShow(true)
--	Panel_Lobby_UI.CC_characterCreateBG:SetSize(350, getScreenSizeY())
--	Panel_Lobby_UI.CC_characterCreateBG:SetHorizonRight()
--	Panel_Lobby_UI.CC_characterCreateBG:SetSpanSize(75,0)
--	Panel_Lobby_UI.CC_characterCreateBG:ComputePos()
--	Panel_CharacterCreateSelectClass:SetShow(false,false)
--	Panel_CharacterCreate:SetSize( getScreenSizeY(), getScreenSizeX() )
	
--	Panel_Lobby_UI.CC_FrameHead:UpdateContentPos()
--	Panel_Lobby_UI.CC_FrameHair:UpdateContentPos()

	resizeUIScale()
	ShowCharacterCustomization( customizationData, Panel_Lobby_Global_Variable.characterSelectType, false )
--	Panel_Lobby_function_StartUp_CustomizingTest()
	viewCharacterCreateMode( Panel_Lobby_Global_Variable.characterSelectType )
end
------------------------------------------------------------------------------------------------------------
------------------------------------------------------------------------------------------------------------
-- 케릭터 선택화면 관련 함수들
------------------------------------------------------------------------------------------------------------
------------------------------------------------------------------------------------------------------------
function Panel_Lobby_function_ClearData()
	Panel_Lobby_Global_Variable.characterSelect = -1
	Panel_Lobby_Global_Variable.characterSelectType = -1
	Panel_Lobby_Global_Variable.selectRegionInfo = nil
end

function CreateCharacterSlot()
	for ii = 0, #characterTicketAbleUI do
		if nil ~= characterTicketAbleUI[ii] then
			characterTicketAbleUI[ii]:SetShow(true)
		end
	end

	panel_lobby_CharacterInfoClear()
	
	local curServerData	= getCurrentWorldServerData()
	if(curServerData._doRestrictCharacterCreation) then
		Panel_Lobby_UI.SC_CharacterCreateButton:SetText(PAGetString(Defines.StringSheet_GAME, "LUA_CHARACTER_LIMIT_CREATION"))   
		Panel_Lobby_UI.SC_ChracterSelectButtonMain:SetText(PAGetString(Defines.StringSheet_GAME, "LUA_CHARACTER_LIMIT_CREATION"))
	else
		Panel_Lobby_UI.SC_CharacterCreateButton:SetText(PAGetString(Defines.StringSheet_GAME, "CHARACTER_SELECT_BTN_CREATE"))  
		Panel_Lobby_UI.SC_ChracterSelectButtonMain:SetText(PAGetString(Defines.StringSheet_GAME, "CHARACTER_SELECT_BTN_CREATE"))		
	end
	
	Panel_Lobby_UI.SC_CharacterCreateButton:SetShow(true)
	Panel_Lobby_UI.SC_CharacterDeleteButton:SetShow(false)
	Panel_Lobby_UI.SC_StartGameButton:SetShow(false)
	Panel_Lobby_UI.SC_CharacterCreateButton:SetPosY( Panel_Lobby_UI.SC_CreateCharacterBG:GetPosY() + 5 )
	
	Panel_Lobby_UI.SC_ChracterSelectButtonMain	:addInputEvent("Mouse_LUp", "changeCreateCharacterMode_SelectClass()")
end

function Panel_Lobby_function_ViewCharacter( index )
	local characterData = getCharacterDataByIndex(index)
	Panel_Lobby_UI.SC_CharacterCreateButton:SetShow(false)
	if ( nil == characterData ) then
		return
	end

	for ii = 0, #characterTicketAbleUI do
		characterTicketAbleUI[ii]:SetShow(true)
	end

	-- 선택된 정보를 저장해야 한다.
	Panel_Lobby_CharacterInfo_UpdateFunc( characterData )
	
	local	removeTime	= getCharacterDataRemoveTime(index)
	if	nil == removeTime	then
		Panel_Lobby_UI.SC_StartGameButton:SetShow(true)
		Panel_Lobby_UI.SC_ChracterSelectButtonMain:SetShow(true)
		Panel_Lobby_UI.SC_CharacterDeleteButton:SetShow(true)
		Panel_Lobby_UI.SC_CharacterDeleteCancelButton:SetShow(false)
		Panel_Lobby_UI.SC_CharacterDeleteCancelTitle:SetShow(false)
		Panel_Lobby_UI.SC_CharacterDeleteCancelDate:SetShow(false)
	else
		Panel_CharacterDoing._ticketNoByRegion:SetText( "" )
		Panel_Lobby_UI.SC_CharacterDeleteCancelDate:SetText( PAGetString(Defines.StringSheet_GAME, "LUA_CHARACTER_DELETE") .. " ( " .. removeTime .. " )" ) --removeTime .. '( 삭제 예정 )')
		Panel_Lobby_UI.SC_StartGameButton:SetShow(false)
		Panel_Lobby_UI.SC_ChracterSelectButtonMain:SetShow(false)
		Panel_Lobby_UI.SC_CharacterDeleteButton:SetShow(false)
		Panel_Lobby_UI.SC_CharacterDeleteCancelButton:SetShow(true)
		Panel_Lobby_UI.SC_CharacterDeleteCancelTitle:SetShow(true)
		Panel_Lobby_UI.SC_CharacterDeleteCancelDate:SetShow(true)
	end

	if Panel_Lobby_UI.SC_CharacterCreateButton:GetShow() then
		Panel_Lobby_UI.SC_ChracterSelectButtonMain:SetText(PAGetString(Defines.StringSheet_GAME, "CHARACTER_SELECT_BTN_CREATE"))
		Panel_Lobby_UI.SC_ChracterSelectButtonMain	:addInputEvent("Mouse_LUp", "changeCreateCharacterMode_SelectClass()")
	else
		Panel_Lobby_UI.SC_ChracterSelectButtonMain:SetText(PAGetString(Defines.StringSheet_GAME, "CHARACTER_SELECT_BTN_CONNECT"))
		Panel_Lobby_UI.SC_ChracterSelectButtonMain	:addInputEvent("Mouse_LUp", "Panel_Lobby_function_SelectCharacter()")
	end
	
	Panel_Lobby_Global_Variable.characterSelect = index
	Panel_Lobby_Global_Variable.notClearValueCharacterSelect = index
	
	-- 선택한  Slot 위치에, 삭제 & 접속 버튼을 위치시킴
	local selectedButton = Panel_Lobby_Global_Variable.UIList[index]
	Panel_Lobby_UI.SC_CharacterDeleteButton:SetPosY( selectedButton:GetPosY() + 4)
	Panel_Lobby_UI.SC_StartGameButton:SetPosY( selectedButton:GetPosY() + 5 )
	
	local classType = getCharacterClassType(characterData)	
	local randomTime = getRandomValue(0, 23)
	
	characterTicketAbleUI[index]:SetShow( false )
	
	-- 캐릭터 선택(클래스 선택 아님) 화면에서 대기자세 보여주기
	if classType == 0 then	-- 워리어
		viewCharacter(index, -50, -40, -65, 0.15)
		viewCharacterPitchRoll(0.0, 0.0)
		viewCharacterFov(0.75)	-- 0.0 ~ 6.28 사이값
		setWeatherTime(8 ,1)
		
	elseif classType == 4 then	-- 레인저
		viewCharacter(index, -40, -10, -40, 0.45)
		viewCharacterPitchRoll(-0.05, 0.0)
		viewCharacterFov(0.55)	-- 0.0 ~ 6.28 사이값
		setWeatherTime(8 ,0)
		
	elseif classType == 8 then	-- 소서러
		viewCharacter(index, -40, -30, -75, 0.55)
		viewCharacterPitchRoll(-0.0, -0.0)
		setWeatherTime(8 ,9)
		viewCharacterFov(0.55)
		
	elseif classType == 12 then	-- 자이언트
		viewCharacter(index, -50, -25, -94, -0.6)
		viewCharacterPitchRoll(0.2, 0.0)
		setWeatherTime(8 ,3)
		
	elseif classType == 16 then	-- 금수랑
		viewCharacter(index, -30, -50, -94, -0.1)
		viewCharacterPitchRoll(-0.0, 0.0)
		setWeatherTime(8 ,17)
		viewCharacterFov(0.55)
		
	else
		viewCharacter(index, 0, 0, 0, 0)
		viewCharacterPitchRoll(3.14, 0.0)
	end
end

function Panel_Lobby_function_SelectCharacter()

local characterData 			= getCharacterDataByIndex( Panel_Lobby_Global_Variable.characterSelect )

	Panel_Lobby_Global_Variable.characterSelect = Panel_Lobby_Global_Variable.notClearValueCharacterSelect
	if ( -1 ~= Panel_Lobby_Global_Variable.characterSelect ) then
		if (getContentsServiceType() == CppEnums.ContentsServiceType.eContentsServiceType_CBT)
			or (getContentsServiceType() == CppEnums.ContentsServiceType.eContentsServiceType_OBT)
			or (getContentsServiceType() == CppEnums.ContentsServiceType.eContentsServiceType_Commercial)
		then
			if 1 == Panel_Lobby_Global_Variable.selectCharacterLevel then
				FGlobal_FirstLogin_Open( Panel_Lobby_Global_Variable.characterSelect )
			else
				if ePcWorkingType.ePcWorkType_Empty ~= characterData._pcWorkingType and ePcWorkingType.ePcWorkType_Play ~= characterData._pcWorkingType then
					if ePcWorkingType.ePcWorkType_Delivery == characterData._pcWorkingType then
						contentString = PAGetString(Defines.StringSheet_GAME, "LUA_GAMEEXIT_WORKING_NOW_CHANGE_Q") .. PAGetString(Defines.StringSheet_GAME, "LUA_LOBBY_MAIN_MOVECHARACTER_MSG")
					elseif ePcWorkingType.ePcWorkType_ReadBook == characterData._pcWorkingType then
						contentString = PAGetString(Defines.StringSheet_GAME, "LUA_GAMEEXIT_WORKING_NOW_READ_BOOK")--"캐릭터가 책을 읽는 중입니다. 교체하실 경우 책읽기가 취소됩니다"
					elseif ePcWorkingType.ePcWorkType_RepairItem == characterData._pcWorkingType then
						contentString = PAGetString(Defines.StringSheet_GAME, "LUA_GAMEEXIT_WORKING_NOW_REPAIR")
					end

					local messageboxData = { title = "PC 일하는 중", content = contentString, functionYes = Panel_Lobby_function_SelectEnterToGame, functionCancel = MessageBox_Empty_function, priority = CppEnums.PAUIMB_PRIORITY.PAUIMB_PRIORITY_LOW } -- "캐릭터 이동중 입니다.. 교체하겠습니까?"
					MessageBox.showMessageBox( messageboxData )
				else
					selectCharacter(Panel_Lobby_Global_Variable.characterSelect)
				end
			end
		else
			local titleText = PAGetString( Defines.StringSheet_GAME, "LUA_MESSAGEBOX_NOTIFY" )
			local messageboxData = { title = titleText, content = PAGetString(Defines.StringSheet_GAME, "PANEL_LOBBY_PREDOWNLOAD"), functionApply = MessageBox_Empty_function , priority = CppEnums.PAUIMB_PRIORITY.PAUIMB_PRIORITY_LOW, exitButton = false }
			MessageBox.showMessageBox(messageboxData)
		
		end
	end
end

function Panel_Lobby_function_SelectEnterToGame()
	selectCharacter(Panel_Lobby_Global_Variable.characterSelect)
end

function Panel_Lobby_function_DeleteCharacter( )
	if ( -1 ~= Panel_Lobby_Global_Variable.characterSelect ) then
		deleteCharacter(Panel_Lobby_Global_Variable.characterSelect)
	end
end

function Panel_Lobby_function_DeleteCharacter_Cancel( )
	-- 아무것도 안한다.!
end

function Panel_Lobby_function_DeleteCharacter_MessageBox( )
	--UI.debugMessage( "Panel_Lobby_Global_Variable.characterSelect : " .. Panel_Lobby_Global_Variable.characterSelect )
	Panel_Lobby_Global_Variable.characterSelect = Panel_Lobby_Global_Variable.notClearValueCharacterSelect
	local characterData = getCharacterDataByIndex(Panel_Lobby_Global_Variable.characterSelect)
	if ( nil == characterData ) then
		return
	end
	
	local removeTimeCheckLevel 	= getCharacterRemoveTimeCheckLevel()
	local removeTime 			= convertStringFromDatetime(getCharacterRemoveTime())
	
	local messageContent	= ""
	if(characterData._level < removeTimeCheckLevel) then
		messageContent	= PAGetStringParam1(Defines.StringSheet_GAME, "CHARACTER_IMMEDIATE_DELETE_MESSAGEBOX_MEMO", "character_name", getCharacterName(characterData) )
	else
		messageContent	= PAGetStringParam3(Defines.StringSheet_GAME, "CHARACTER_LATER_DELETE_MESSAGEBOX_MEMO", "character_removeLevel", removeTimeCheckLevel, "character_removeTime", removeTime, "character_name", getCharacterName(characterData) )
	end
	
	local messageboxData	= { title = PAGetString(Defines.StringSheet_GAME, "CHARACTER_DELETE_MESSAGEBOX_TITLE"), content = messageContent, functionYes = Panel_Lobby_function_DeleteCharacter, functionNo = Panel_Lobby_function_DeleteCharacter_Cancel, priority = CppEnums.PAUIMB_PRIORITY.PAUIMB_PRIORITY_LOW}
	MessageBox.showMessageBox(messageboxData, "top")
end

function Panel_Lobby_function_DeleteCancelCharacter( )
	if ( -1 ~= Panel_Lobby_Global_Variable.characterSelect ) then
		deleteCancelCharacter(Panel_Lobby_Global_Variable.characterSelect)
	end
	
	Panel_Lobby_UI.SC_CharacterDeleteCancelButton:SetShow(false)
	Panel_Lobby_UI.SC_CharacterDeleteCancelTitle:SetShow(false)
	Panel_Lobby_UI.SC_CharacterDeleteCancelDate:SetShow(false)
end

function click_backServerSelect()
	backServerSelect()
end

function lobby_GameEnd()
	local messageboxData = { title = PAGetString(Defines.StringSheet_GAME, "GAME_EXIT_MESSAGEBOX_TITLE"), content = PAGetString(Defines.StringSheet_GAME, "GAME_EXIT_MESSAGEBOX_MEMO"), functionYes = lobby_GameClose, functionNo = MessageBox_Empty_function, priority = CppEnums.PAUIMB_PRIORITY.PAUIMB_PRIORITY_LOW}
	MessageBox.showMessageBox(messageboxData)
end

function lobby_GameClose()
	disConnectToGame()	
	GlobalExitGameClient()
end

------------------------------------------------------------------------------------------------------------
------------------------------------------------------------------------------------------------------------
-- 케릭터 생성화면 관련 함수들
------------------------------------------------------------------------------------------------------------
------------------------------------------------------------------------------------------------------------
local Panel_Lobby_function_characterIndexToUI = function( index )
--[[
	if ( index == Panel_Lobby_Enum.eClassType_Warrior ) then
		return Panel_Lobby_UI.CC_WarriorRadio
	elseif ( index == Panel_Lobby_Enum.eClassType_Giant ) then
		return Panel_Lobby_UI.CC_GiantRadio
	elseif ( index == Panel_Lobby_Enum.eClassType_Tamer ) then
		return Panel_Lobby_UI.CC_TamerRadio
	elseif ( index == Panel_Lobby_Enum.eClassType_Sorcerer ) then
		return Panel_Lobby_UI.CC_SorcererRadio
	elseif ( index == Panel_Lobby_Enum.eClassType_BladeMaster ) then
		return Panel_Lobby_UI.CC_BladeMasterRadio
	elseif ( index == Panel_Lobby_Enum.eClassType_Ranger ) then
		return Panel_Lobby_UI.CC_RangerRadio
	elseif ( index == Panel_Lobby_Enum.eClassType_Kunoichi ) then
		return Panel_Lobby_UI.CC_KunoichiRadio
	else
		return nil
	end
]]
end



---------------------------------------------------------------
-- 		클래스 선택창에서 클래스 선택 버튼시 변수들
local lobby_ClassType = 
{
	[0] =	Panel_Lobby_UI.CCSC_WarriorButton,
			Panel_Lobby_UI.CCSC_RangerButton,
			Panel_Lobby_UI.CCSC_SorcerButton,
			Panel_Lobby_UI.CCSC_GiantButton,
			Panel_Lobby_UI.CCSC_TamerButton,
			Panel_Lobby_UI.CCSC_BladeMasterButton,
			Panel_Lobby_UI.CCSC_KunoichiButton,
			Panel_Lobby_UI.CCSC_ValkyrieButton,
			Panel_Lobby_UI.CCSC_WizardButton,
}
---------------------------------------------------------------
--					클래스를 선택했다!!
---------------------------------------------------------------
function Panel_Lobby_function_SelectClassType( index, isOn )
	if ( index < getClassDataCount() ) then
		if ( index ~= getClassDataCount() ) then
			for key, value in pairs ( lobby_ClassType ) do
				value:SetMonoTone( true )
				value:ResetVertexAni()
				value:SetVertexAniRun( "Ani_Color_Reset", true )
				value:EraseAllEffect()
			end
		end
		
		--------------------------------------
		--  선택한 클래스는 모노톤을 꺼주자
		lobby_ClassType[index]:SetMonoTone( false )
		lobby_ClassType[index]:AddEffect( "UI_CharactorSelcect_Line", true, 10, 4 )
		lobby_ClassType[index]:ResetVertexAni()
		-- lobby_ClassType[index]:SetVertexAniRun( "Ani_Color_Bright", true )

		---------------------------------------------
		--			클래스별 영상을 켜준다
		local movieName = getClassMovie(index)
		Panel_Lobby_UI.CCSC_ClassMovie:TriggerEvent("PlayMovie", "coui://"..movieName)

		viewCharacterCreateSelectClassMode(index )
		Panel_Lobby_Global_Variable.characterSelectType = index

		Panel_Lobby_UI.CCSC_ClassName:SetText( getClassName(index) )
		Panel_Lobby_UI.CCSC_ClassDesc:SetTextMode( UI_TM.eTextMode_AutoWrap )
		Panel_Lobby_UI.CCSC_ClassDesc:SetText( getClassDescription(index) )
		
		-----------------------------------------------
		--			스테이터스 보여주기
		-----------------------------------------------
		if ( index == 0 ) then
			Character_Status._status_Warrior:SetShow( true )
			Character_Status._status_Ranger:SetShow( false )
			Character_Status._status_Sorcerer:SetShow( false )
			Character_Status._status_Giant:SetShow( false )
			Character_Status._status_BeastMaster:SetShow( false )
			
		elseif ( index == 1 ) then
			Character_Status._status_Warrior:SetShow( false )
			Character_Status._status_Ranger:SetShow( true )
			Character_Status._status_Sorcerer:SetShow( false )
			Character_Status._status_Giant:SetShow( false )
			Character_Status._status_BeastMaster:SetShow( false )
			
		elseif ( index == 2 ) then
			Character_Status._status_Warrior:SetShow( false )
			Character_Status._status_Ranger:SetShow( false )
			Character_Status._status_Sorcerer:SetShow( true )
			Character_Status._status_Giant:SetShow( false )
			Character_Status._status_BeastMaster:SetShow( false )
			
		elseif ( index == 3 ) then
			Character_Status._status_Warrior:SetShow( false )
			Character_Status._status_Ranger:SetShow( false )
			Character_Status._status_Sorcerer:SetShow( false )
			Character_Status._status_Giant:SetShow( true )
			Character_Status._status_BeastMaster:SetShow( false )
			
		elseif ( index == 4 ) then
			Character_Status._status_Warrior:SetShow( false )
			Character_Status._status_Ranger:SetShow( false )
			Character_Status._status_Sorcerer:SetShow( false )
			Character_Status._status_Giant:SetShow( false )
			Character_Status._status_BeastMaster:SetShow( true )
			
		end
	end
end

function Panel_Lobby_SelectClass_MouseEvent( index, isOn )
	if ( isOn == true ) then
		lobby_ClassType[index]:SetVertexAniRun( "Ani_Color_Bright", true )
	else
		lobby_ClassType[index]:ResetVertexAni()
		lobby_ClassType[index]:SetVertexAniRun( "Ani_Color_Reset", true )
	end
end

function Panel_CharacterCreateOk()
	chracterCreate( Panel_Lobby_Global_Variable.characterSelectType, Panel_Lobby_UI.CC_CharacterNameEdit:GetEditText() )
end
-- 기존의 캐릭터 생성 함수 대체 Panel_CharacterCreateOK 차 후 기존 함수는 삭제해주자
function Panel_CharacterCreateOK_NewCustomization()
	chracterCreate( Panel_Lobby_Global_Variable.characterSelectType, Panel_Lobby_UI.CM_Edit_CharacterName:GetEditText() )
end
function Panel_CharacterCreateCancel()
	Panel_CharacterCreateSelectClass:SetShow(false) 
	characterCreateCancel()
end

------------------------------------------------------------------------------------------------------------
--										하단부 현재 진행상황 함수
------------------------------------------------------------------------------------------------------------
--local panel_lobby_CharacterInfoClear = function()
function panel_lobby_CharacterInfoClear()
	Panel_CharacterDoing._CharInfo_Name:SetText( "Lv. 0" )
	Panel_CharacterDoing._CharInfo_DoText:SetText( "-" )
	Panel_CharacterDoing._CharInfo_WhereText:SetText( "" )
	Panel_CharacterDoing._ticketNoByRegion:SetText( "" )
end

function Panel_Lobby_CharacterInfo()
	local ScrSizeX = getScreenSizeX()
	local ScrSizeY = getScreenSizeY()
	
	_CharInfo_BG:SetPosX( ( ScrSizeX * 0.5 ) - ( _CharInfo_BG:GetSizeX() * 0.5 ) )
	_CharInfo_BG:SetPosY( ScrSizeY - _CharInfo_BG:GetSizeY() - 35 )
	_CharInfo_BG:SetShow( false )
	
	_CharInfo_BG:AddChild ( Panel_CharacterDoing._CharInfo_Name )
	_CharInfo_BG:AddChild ( Panel_CharacterDoing._CharInfo_GaugeBG )
	_CharInfo_BG:AddChild ( Panel_CharacterDoing._CharInfo_Gauge )
	_CharInfo_BG:AddChild ( Panel_CharacterDoing._CharInfo_DoText )
	_CharInfo_BG:AddChild ( Panel_CharacterDoing._CharInfo_NowPos )
	_CharInfo_BG:AddChild ( Panel_CharacterDoing._CharInfo_WhereText )
	_CharInfo_BG:AddChild ( Panel_CharacterDoing._ticketNoByRegion )
	_CharInfo_BG:AddChild ( Panel_Lobby_UI.SC_ChracterSelectButtonMain )
	
	Panel_CharacterSelect:RemoveControl ( Panel_CharacterDoing._CharInfo_Name )
	Panel_CharacterSelect:RemoveControl ( Panel_CharacterDoing._CharInfo_GaugeBG )
	Panel_CharacterSelect:RemoveControl ( Panel_CharacterDoing._CharInfo_Gauge )
	Panel_CharacterSelect:RemoveControl ( Panel_CharacterDoing._CharInfo_DoText )
	Panel_CharacterSelect:RemoveControl ( Panel_CharacterDoing._CharInfo_NowPos )
	Panel_CharacterSelect:RemoveControl ( Panel_CharacterDoing._CharInfo_WhereText )
	Panel_CharacterSelect:RemoveControl ( Panel_CharacterDoing._ticketNoByRegion )
	Panel_CharacterSelect:RemoveControl ( Panel_Lobby_UI.SC_ChracterSelectButtonMain )
	
	Panel_CharacterDoing._CharInfo_Name:SetShow( true )
	Panel_CharacterDoing._CharInfo_GaugeBG:SetShow( false )
	Panel_CharacterDoing._CharInfo_Gauge:SetShow( false )
	Panel_CharacterDoing._CharInfo_DoText:SetShow( true )
	Panel_CharacterDoing._CharInfo_NowPos:SetShow( true )
	Panel_CharacterDoing._CharInfo_WhereText:SetShow( true )
	Panel_CharacterDoing._ticketNoByRegion:SetShow( true )
	Panel_Lobby_UI.SC_ChracterSelectButtonMain:SetShow( false )
end

function Panel_Lobby_CharacterInfo_UpdateFunc( characterData )
	_CharInfo_BG:SetShow( true )
	Panel_CharacterDoing._CharInfo_Name:SetShow( true )
	Panel_CharacterDoing._CharInfo_DoText:SetShow( true )

	----------------------------------------
	-- 			캐릭터 이름 바꿔준다
	local characterName = getCharacterName(characterData)
	local ChkLevel	= string.format( "Lv.%d", characterData._level )
	Panel_CharacterDoing._CharInfo_Name:SetText( "<PAColor0xFFFFBD2E>"..ChkLevel.."<PAOldColor>  "..characterName )
	
	-- 기본 옵션 체크용
	Panel_Lobby_Global_Variable.selectCharacterLevel = characterData._level

	----------------------------------------
	-- 			지금 어디에 있는가?
	if 0 ~= characterData._currentPosition.x and 0 ~= characterData._currentPosition.y and 0 ~= characterData._currentPosition.z then	-- 0 이라면 생성만하고 접속을 한번도 하지 않은 캐릭터이다. text를 보여주지 않는다.
		local regionInfo = getRegionInfoByPosition( characterData._currentPosition )
		Panel_Lobby_Global_Variable.selectRegionInfo = regionInfo
		Panel_CharacterDoing._CharInfo_WhereText:SetText( regionInfo:getAreaName() )
	else
		Panel_CharacterDoing._CharInfo_WhereText:SetText( "-" )
	end
	
	setUpdateTicketNo( characterData )
	
	----------------------------------------
	-- 				게임 접속버튼
	Panel_Lobby_UI.SC_ChracterSelectButtonMain:SetShow( true )
	
	----------------------------------------
	-- 			일 진행 중에만 나온다 (진행 체크가 마지막에 하도록 추가사항은 위에 추가하도록하자)
	Panel_CharacterDoing._CharInfo_GaugeBG:SetShow( false )
	Panel_CharacterDoing._CharInfo_Gauge:SetShow( false )
	Panel_CharacterDoing._CharInfo_DoText:SetShow( true )
	
	-- 시간설정이 되어 있지는 않다.
	-- local serverUtc64 = getServerUtc64()
	-- UI.debugMessage( "serverUtc64 : " .. tostring( serverUtc64 ) .. " characterData._workingStartCompletingDate : " .. tostring( characterData._workingStartCompletingDate ) )
	-- if characterData._workingStartCompletingDate < serverUtc64 then
		-- -- 작업완료
		-- Panel_CharacterDoing._CharInfo_DoText:SetText( PAGetString( Defines.StringSheet_GAME, "CHARACTER_WORKING_TEXT_NONE" ) )
		-- return
	-- end

	
	--Panel_CharacterDoing._CharInfo_DoText:SetText( PAGetString( Defines.StringSheet_GAME, "CHARACTER_WORKING_TEXT_PLAY" ) )
	if ePcWorkingType.ePcWorkType_Empty == characterData._pcWorkingType or ePcWorkingType.ePcWorkType_Play == characterData._pcWorkingType then
		Panel_CharacterDoing._CharInfo_DoText:SetText( PAGetString( Defines.StringSheet_GAME, "CHARACTER_WORKING_TEXT_NONE" ) )
	
	elseif ePcWorkingType.ePcWorkType_RepairItem == characterData._pcWorkingType then
		Panel_CharacterDoing._CharInfo_DoText:SetText( PAGetString( Defines.StringSheet_GAME, "CHARACTER_WORKING_TEXT_REPAIRITEM" ) )
		
	elseif ePcWorkingType.ePcWorkType_Delivery == characterData._pcWorkingType then
		Panel_CharacterDoing._CharInfo_DoText:SetText( PAGetString( Defines.StringSheet_GAME, "CHARACTER_WORKING_TEXT_DELIVERY" ) )
		
	elseif ePcWorkingType.ePcWorkType_Relex == characterData._pcWorkingType then
		Panel_CharacterDoing._CharInfo_DoText:SetText( PAGetString( Defines.StringSheet_GAME, "CHARACTER_WORKING_TEXT_RELEX" ) )
		
	elseif ePcWorkingType.ePcWorkType_ReadBook == characterData._pcWorkingType then
		Panel_CharacterDoing._CharInfo_DoText:SetText( PAGetString( Defines.StringSheet_GAME, "CHARACTER_WORKING_TEXT_READBOOK" ) )
		Panel_CharacterDoing._CharInfo_GaugeBG:SetShow( true )
		Panel_CharacterDoing._CharInfo_Gauge:SetShow( true )
		
		local totalWorkingTime = characterData._workingStartCompletingDate - characterData._workingStartDate
		local workedTime = serverUtc64 - characterData._workingStartDate
		
		local workRate = string.format( "%.1f", (Int64toInt32(workedTime) / Int64toInt32(totalWorkingTime) * 100 ) )
		Panel_CharacterDoing._CharInfo_Gauge:SetProgressRate( workRate )
	else
		_PA_ASSERT(false, "캐릭터 작업 타입이 추가 되었습니다. Lobby_New.lua 에도 추가해 주어야 합니다.")
	end
end

	
----------------------------------------
-- 동접자수
function setUpdateTicketNo( characterData )
	-- .. "\n" .. "대기자 : " .. tostring( characterData._lastTicketNoByRegion ) .. " 명" .. "\n first : " .. tostring( getFirstTicketNoByAll() )
	local firstTicketNo = getFirstTicketNoByAll()

	local currentTicketNo = getCurrentTicketNo()
	local ticketCountByRegion = characterData._lastTicketNoByRegion
	local myRegionWaitingPlayerCount = currentTicketNo - ticketCountByRegion
	local serverPlayingCount = currentTicketNo - firstTicketNo
	
	--UI.debugMessage( "(".. tostring(serverPlayingCount) .. ", " .. tostring(currentTicketNo) .. ")" .. " firstTicketNo : " .. tostring( firstTicketNo ) .. " ticketCountByRegion : " .. tostring(ticketCountByRegion) .. " myRegionWaitingPlayerCount : " .. tostring( myRegionWaitingPlayerCount ) )
	if const_64.s64_m1 ~= firstTicketNo or const_64.s64_m1 ~= ticketCountByRegion then
		Panel_CharacterDoing._ticketNoByRegion:SetFontColor( Defines.Color.C_FFD20000 )
		Panel_CharacterDoing._ticketNoByRegion:SetText( PAGetString(Defines.StringSheet_GAME, "LUA_GAMEEXIT_NOT_ENTER_TO_FIELD") )	-- 대기자 있음 .. " " .. tostring( firstTicketNo ) .. " " .. tostring( ticketCountByRegion ) .. " " .. tostring( myRegionWaitingPlayerCount )
	else
		Panel_CharacterDoing._ticketNoByRegion:SetFontColor( Defines.Color.C_FF96D4FC )
		Panel_CharacterDoing._ticketNoByRegion:SetText( PAGetString(Defines.StringSheet_GAME, "LUA_GAMEEXIT_ENTER_TO_FIELD") )	-- 바로 입장 가능	 .. " " .. tostring( firstTicketNo ) .. " " .. tostring( ticketCountByRegion ) .. " " .. tostring( myRegionWaitingPlayerCount )
	end
	
	--Panel_CharacterDoing._ticketNoByRegion:SetText( tostring( currentTicketNo ) .. " 명" )
end

-- 대기열 창을 닫기 응답이 왔을 경우 호출된다.
function cancelEnterWaitingLine()
	if true == Panel_Lobby_Global_Variable.isWaitLine then
		MessageBox_HideAni()
		Panel_Lobby_Global_Variable.isWaitLine = false
	end
end

-- 대기열 표시
function makeEnterWaitingUserMsg( receiveTicketNoMyRegion )
	local ticketCountByRegion = receiveTicketNoMyRegion						-- 해당 region의 티켓 번호
	local waitingLineCancelCount = getCancelCount()
	if -1 == ticketCountByRegion then
		local regionInfo = Panel_Lobby_Global_Variable.selectRegionInfo
		local regionGroupKey = 1	-- 기본값 벨리아
		if nil ~= regionInfo then
			--UI.ASSERT( false, "비정상적인 regionInfo입니다." )
			regionGroupKey = regionInfo:getRegionGroupKey()
		end

		ticketCountByRegion = getTicketCountByRegion( regionGroupKey )
		--waitingLineCancelCount = waitingLineCancelCount - getEnterPlayerInWaitingLineByRegion(regionGroupKey)
	end

	local currentTicketNo = getCurrentTicketNo()			-- 나의 티켓번호
	local firstTicketNoByAll = getFirstTicketNoByAll()		-- 서버 최초 티켓번호 ( -1 : 은 현재 대기자 없음 )
	--local cancelTicketNo = getCancelTicketNo()

	-- if currentTicketNo < then
	-- end
	
	local totalWaitingPlayerCount =  getAllWaitingLine() - getAllCancelCount() --currentTicketNo - firstTicketNoByAll
	local myRegionWaitingPlayerCount = getMyWaitingLine() - getCancelCount()	--currentTicketNo - waitingLineCancelCount -- ticketCountByRegion

	if totalWaitingPlayerCount < 0 then
		totalWaitingPlayerCount = 0
	end
	
	if myRegionWaitingPlayerCount <= 0 then
		--UI.debugMessage( "myRegionWaitingPlayerCount : " .. myRegionWaitingPlayerCount .. tostring( getMyWaitingLine()) .. " " .. tostring(getCancelCount())  )
		myRegionWaitingPlayerCount = 0
	end
	--UI.debugMessage( "my: " .. tostring( currentTicketNo ) .. " regionTicket: " .. tostring( ticketCountByRegion ) .. " cancel : " .. tostring( waitingLineCancelCount ) )
	--UI.debugMessage( myRegionWaitingPlayerCount .. tostring(getCancelCount()) .. "서버 대기자 : " .. tostring( totalWaitingPlayerCount ) .. " currentTicketNo : " .. tostring( currentTicketNo ) .. " first : " .. tostring( firstTicketNoByAll ) .. " currentRegion : " .. tostring( ticketCountByRegion ) )
	local waitMsg = PAGetString( Defines.StringSheet_GAME, "CHARACTER_WAIT_MESSAGE" )
	local serverWaitStr = PAGetStringParam1( Defines.StringSheet_GAME, "CHARACTER_SERVER_WAIT_COUNT", "iCount", tostring( totalWaitingPlayerCount ) )
	local regionWaitStr = PAGetStringParam1( Defines.StringSheet_GAME, "CHARACTER_REGION_WAIT_COUNT", "iCount", tostring( myRegionWaitingPlayerCount ) )
	local emptyStr = PAGetString(Defines.StringSheet_GAME, "CHARACTER_WAITING_PLAYER_EMPTY")
		
	if const_64.s64_m1 == firstTicketNoByAll and const_64.s64_m1 ~= ticketCountByRegion then
	--if const_64.s64_0 == totalWaitingPlayerCount and const_64.s64_0 < myRegionWaitingPlayerCount then
		-- 전체 인원은 비었지만 접속하려는 곳에 대기열이 있다면 띄워 준다.
		strWaitingMsg = waitMsg .. "\n\n" .. regionWaitStr
	elseif (const_64.s64_m1 == ticketCountByRegion and const_64.s64_m1 ~= firstTicketNoByAll) or (const_64.s64_m1 ~= ticketCountByRegion and 0 == myRegionWaitingPlayerCount) then
	--elseif const_64.s64_0 < totalWaitingPlayerCount and const_64.s64_0 == myRegionWaitingPlayerCount then
		-- 전체 대기열은 있지만 입장하려는 지역은 대기열이 없다.		
		strWaitingMsg = waitMsg .. "\n\n" .. serverWaitStr .. "\n\n" .. PAGetString( Defines.StringSheet_GAME, "CHARACTER_REGION_WAIT_TEXT" ) .. emptyStr
	else
		strWaitingMsg = waitMsg .. "\n\n" .. serverWaitStr .. "\n\n" .. regionWaitStr
	end
	
	return strWaitingMsg
end

-- 대기열 수신
function receiveEnterWaiting()
--UI.debugMessage( "receive" )
	Panel_Lobby_Global_Variable.isWaitLine = true
	local characterData = getCharacterDataByIndex(Panel_Lobby_Global_Variable.characterSelect)
	if ( nil == characterData ) then
		UI.ASSERT( false, "캐릭터 선택이 되지 않았나...?" )
		return
	end

	Panel_CharacterDoing._ticketNoByRegion:SetFontColor( Defines.Color.C_FFD20000 )	
	Panel_CharacterDoing._ticketNoByRegion:SetText( PAGetString(Defines.StringSheet_GAME, "LUA_GAMEEXIT_NOT_ENTER_TO_FIELD") )
	
	local strWaitingMsg = makeEnterWaitingUserMsg( characterData._lastTicketNoByRegion )
	local messageboxData = { title = PAGetString(Defines.StringSheet_GAME, "CHARACTER_ENTER_WAITING_TITLE"), content = strWaitingMsg, functionCancel = click_EnterWaitingCancel, priority = CppEnums.PAUIMB_PRIORITY.PAUIMB_PRIORITY_1m }	--functionYes = Panel_Lobby_function_SelectEnterToGame, 
	MessageBox.showMessageBox( messageboxData )
end

-- 대기중 갱신
function setEnterWaitingUserCount()
--UI.debugMessage( "대기중 갱신" )
	if false == Panel_Lobby_Global_Variable.isWaitLine then
		return
	end
	local strWaitingMsg = makeEnterWaitingUserMsg( -1 )

	--local strWaitingMsg = "\n\n잠시만 기다려달라~" .. "\n\n" .. "전체 대기자 수 : " .. tostring( totalWaitingPlayerCount ) .. " 명" .. "\n\n 예상 대기자 수 : " .. tostring( myRegionWaitingPlayerCount ) .. " 명"
	local messageboxData = { title = PAGetString(Defines.StringSheet_GAME, "CHARACTER_ENTER_WAITING_TITLE"), content = strWaitingMsg, functionCancel = click_EnterWaitingCancel, priority = CppEnums.PAUIMB_PRIORITY.PAUIMB_PRIORITY_1m }	--functionYes = Panel_Lobby_function_SelectEnterToGame, 
	if true == MessageBox.doHaveMessageBoxData( messageboxData.title ) then
		setCurrentMessageData( messageboxData )
	else
		MessageBox.showMessageBox( messageboxData )
	end
end

function click_EnterWaitingCancel()
--UI.debugMessage( "캔슬..." )
	if true == Panel_Lobby_Global_Variable.isWaitLine then
		sendEnterWaitingCancel()
	end
end

------------------------------------------------------------------------------------------------------------
-- 										추가생성 버튼 관리함수
------------------------------------------------------------------------------------------------------------
function Panel_Lobby_function_CreateButton( controlName, controlType, controlKey, baseControl, basePositionY )
	local aControl = UI.createControl( controlType, Panel_Lobby_Global_Variable.UiMaker, controlName .. tostring(controlKey) )

	Panel_Lobby_Global_Variable.UIList[controlKey] = aControl

	CopyBaseProperty( baseControl, aControl )

	aControl:SetShow(true)
	aControl:SetPosX(baseControl:GetPosX() )
	aControl:SetPosY(baseControl:GetPosY() + basePositionY)

	return aControl
end

-- 클래스 선택창에 다음 클래스 선택, 이전 클래스 선택 버튼 생성하는 코드
function Panel_Lobby_function_CreateButtonPosX( controlName, controlKey, baseControl, basePositionX )
	local aControl = UI.createControl( UCT_BUTTON, Panel_Lobby_Global_Variable.UiMaker, controlName .. tostring(controlKey) )

	Panel_Lobby_Global_Variable.UIList[controlKey] = aControl

	CopyBaseProperty( baseControl, aControl )

	aControl:SetShow(true)
	aControl:SetPosX(baseControl:GetPosX() + basePositionX )
	aControl:SetPosY(baseControl:GetPosY())

	return aControl
end

function Panel_Lobby_function_DeleteButton( )
	if ( nil == Panel_Lobby_Global_Variable.UiMaker ) then
		return
	end

	for _, value in pairs(Panel_Lobby_Global_Variable.UIList) do
		UI.deleteControl(value)
	end

	Panel_Lobby_Global_Variable.UIList = {}
	Panel_Lobby_Global_Variable.UiMaker = nil
end


------------------------------------------------------------------------------------------------------------
------------------------------------------------------------------------------------------------------------
-- Initialize
------------------------------------------------------------------------------------------------------------
------------------------------------------------------------------------------------------------------------
Panel_Lobby_Function_Initialize()
registerEvent("EventChangeLobbyStageToCharacterCreate_SelectClass", "Panel_Lobby_Function_showCharacterCreate_SelectClass") -- 클래스 선택창
registerEvent("EventChangeLobbyStageToCharacterSelect", "Panel_Lobby_Function_showCharacterSelect")
--zezzeg : 커스터마이징 테스트 시 아래의 함수가 호출된다.
registerEvent("EventCharacterCustomizationInitUi", "Panel_Lobby_Function_showCharacterCustomization")

-- enterWating
registerEvent( "EventCancelEnterWating", "cancelEnterWaitingLine" )
registerEvent( "EventReceiveEnterWating" , "receiveEnterWaiting" )
registerEvent( "EventSetEnterWating" , "setEnterWaitingUserCount" )
