local UI_PSFT 		= CppEnums.PAUI_SHOW_FADE_TYPE
local UI_ANI_ADV 	= CppEnums.PAUI_ANIM_ADVANCE_TYPE
local UI_IT 		= CppEnums.UiInputType
local UI_PUCT 		= CppEnums.PA_UI_CONTROL_TYPE
local IM			= CppEnums.EProcessorInputMode

Panel_Menu:SetShow( false )
Panel_Menu:setGlassBackground( true )
Panel_Menu:ActiveMouseEventEffect( true )

Panel_Menu:RegisterShowEventFunc( true, 'Panel_Menu_ShowAni()' )
Panel_Menu:RegisterShowEventFunc( false, 'Panel_Menu_HideAni()' )

-- 메뉴가 추가될 경우, ID 및 텍스처를 등록해주세요!
local MenuButtonId =
{
	btn_HelpGuide			= 1,				-- 도움말
	btn_Productnote			= 2,				-- 제작
	btn_CashShop			= 3,				-- 캐시샵
	btn_Beauty				= 4,				-- 뷰티
	btn_Dye					= 5,				-- 염색
	btn_ColorMix			= 6,				-- 염료혼합
	btn_Pet					= 7,				-- 애완동물
	
	btn_PlayerInfo			= 8,				-- 내 정보
	btn_Inventory			= 9,				-- 가방
	btn_BlackSpirit			= 10,				-- 흑정령
	btn_Quest				= 11,				-- 의뢰
	btn_Skill				= 12,				-- 스킬
	btn_Guild				= 13,				-- 길드
	btn_Manufacture			= 14,				-- 가공

	btn_FishEncyclopedia	= 15,				-- 어류도감
	btn_Knowledge			= 16,				-- 지식
	btn_WorldMap			= 17,				-- 월드맵
	btn_Rescue				= 18,				-- 탈출
	btn_FriendList			= 19,				-- 친구
	btn_Mail				= 20,				-- 편지
	btn_UiSetting			= 21,				-- UI편집

	btn_Event				= 22,				-- 이벤트
	btn_GameOption			= 23,				-- 옵션
	btn_GameExit			= 24,				-- 종료
}

local MenuButtonTextId = 
{
	[MenuButtonId.btn_HelpGuide]		= PAGetStringParam1( Defines.StringSheet_GAME, "LUA_MENU_MENUBUTTONTEXTID_HELP", "Help", keyCustom_GetString_UiKey(UI_IT.UiInputType_Help) ), 									-- "도움말
	[MenuButtonId.btn_PlayerInfo]		= PAGetStringParam1( Defines.StringSheet_GAME, "LUA_MENU_MENUBUTTONTEXTID_MYINFO", "PlayerInfo", keyCustom_GetString_UiKey(UI_IT.UiInputType_PlayerInfo) ),						-- "내 정보
	[MenuButtonId.btn_Inventory]		= PAGetStringParam1( Defines.StringSheet_GAME, "LUA_MENU_MENUBUTTONTEXTID_BAG", "Inventory", keyCustom_GetString_UiKey(UI_IT.UiInputType_Inventory) ),							-- "가방
	[MenuButtonId.btn_Skill]			= PAGetStringParam1( Defines.StringSheet_GAME, "LUA_MENU_MENUBUTTONTEXTID_SKILL", "Skill", keyCustom_GetString_UiKey(UI_IT.UiInputType_Skill) ), 								-- "스킬
	[MenuButtonId.btn_Guild]			= PAGetStringParam1( Defines.StringSheet_GAME, "LUA_MENU_MENUBUTTONTEXTID_GUILD", "Guild", keyCustom_GetString_UiKey(UI_IT.UiInputType_Guild) ), 								-- "길드
	[MenuButtonId.btn_WorldMap]			= PAGetStringParam1( Defines.StringSheet_GAME, "LUA_MENU_MENUBUTTONTEXTID_WORLDMAP", "WorldMap", keyCustom_GetString_UiKey(UI_IT.UiInputType_WorldMap) ),						-- "월드맵
	[MenuButtonId.btn_BlackSpirit]		= PAGetStringParam1( Defines.StringSheet_GAME, "LUA_MENU_MENUBUTTONTEXTID_BLACKSPIRIT", "BlackSpirit", keyCustom_GetString_UiKey(UI_IT.UiInputType_BlackSpirit) ),				-- "흑정령
	[MenuButtonId.btn_Quest]			= PAGetStringParam1( Defines.StringSheet_GAME, "LUA_MENU_MENUBUTTONTEXTID_QUESTHISTORY", "QuestHistory", keyCustom_GetString_UiKey(UI_IT.UiInputType_QuestHistory) ),			-- "의뢰
	[MenuButtonId.btn_Knowledge]		= PAGetStringParam1( Defines.StringSheet_GAME, "LUA_MENU_MENUBUTTONTEXTID_MENTALKNOWLEDGE", "MentalKnowledge", keyCustom_GetString_UiKey(UI_IT.UiInputType_MentalKnowledge) ),	-- "지식
	[MenuButtonId.btn_Productnote]		= PAGetStringParam1( Defines.StringSheet_GAME, "LUA_MENU_MENUBUTTONTEXTID_PRODUCTIONNOTE", "ProductionNote", keyCustom_GetString_UiKey(UI_IT.UiInputType_ProductionNote) ),		-- "제작
	[MenuButtonId.btn_FriendList]		= PAGetStringParam1( Defines.StringSheet_GAME, "LUA_MENU_MENUBUTTONTEXTID_FRIENDLIST", "FriendList", keyCustom_GetString_UiKey(UI_IT.UiInputType_FriendList) ),					-- "친구
	[MenuButtonId.btn_Mail]				= PAGetStringParam1( Defines.StringSheet_GAME, "LUA_MENU_MENUBUTTONTEXTID_MAIL", "Mail", keyCustom_GetString_UiKey(UI_IT.UiInputType_Mail) ),									-- "편지
	[MenuButtonId.btn_Pet]				= PAGetString(Defines.StringSheet_GAME, "LUA_MENU_MENUBUTTONTEXTID_PET"),																										-- "애완동물",
	[MenuButtonId.btn_Dye]				= PAGetStringParam1( Defines.StringSheet_GAME, "LUA_MENU_MENUBUTTONTEXTID_DYE", "Dyeing", keyCustom_GetString_UiKey(UI_IT.UiInputType_Dyeing) ),								-- "염색
	[MenuButtonId.btn_CashShop]			= PAGetStringParam1( Defines.StringSheet_GAME, "LUA_MENU_MENUBUTTONTEXTID_CASHSHOP", "CashShop", keyCustom_GetString_UiKey(UI_IT.UiInputType_CashShop) ),						-- "캐시샵
	[MenuButtonId.btn_Beauty]			= PAGetString(Defines.StringSheet_GAME, "LUA_MENU_MENUBUTTONTEXTID_BEAUTY"),																									-- "뷰티(F4)",
	[MenuButtonId.btn_GameOption]		= PAGetString(Defines.StringSheet_GAME, "LUA_MENU_MENUBUTTONTEXTID_OPTION"),																									-- "게임 설정",
	[MenuButtonId.btn_GameExit]			= PAGetString(Defines.StringSheet_GAME, "LUA_MENU_MENUBUTTONTEXTID_EXIT"),																										-- "접속 종료",
	[MenuButtonId.btn_Rescue]			= PAGetString(Defines.StringSheet_GAME, "LUA_MENU_MENUBUTTONTEXTID_ESCAPE"),																									-- "탈출",
	[MenuButtonId.btn_UiSetting]		= PAGetString(Defines.StringSheet_GAME, "LUA_MENU_MENUBUTTONTEXTID_INTERFACEMOVE"),																								-- UI편집
	[MenuButtonId.btn_Manufacture]		= "가공(" .. keyCustom_GetString_UiKey(UI_IT.UiInputType_Manufacture) .. ")",																									-- 가공
	[MenuButtonId.btn_FishEncyclopedia]	= "어류도감",			-- 어류도감
	[MenuButtonId.btn_ColorMix]			= "염색약 혼합",		-- 염색약 혼합
	[MenuButtonId.btn_Event]			= "이벤트",				-- 이벤트
}

local _badges = {
	[MenuButtonId.btn_Quest]		= { count = 0, isShow = false },
	[MenuButtonId.btn_BlackSpirit]	= { count = 0, isShow = false },
	[MenuButtonId.btn_Skill]		= { count = 0, isShow = false },
	[MenuButtonId.btn_Inventory]	= { count = 0, isShow = false },
	[MenuButtonId.btn_Knowledge]	= { count = 0, isShow = false },
	[MenuButtonId.btn_FriendList]	= { count = 0, isShow = false },
}

local btn_Close		= UI.getChildControl( Panel_Menu, "Button_Win_Close" )
btn_Close:addInputEvent( "Mouse_LUp", "Panel_Menu_ShowToggle()" )

local menu_Bg		= UI.getChildControl( Panel_Menu, "Static_MenuBG" )
local menuIconBg	= UI.getChildControl( Panel_Menu, "Static_MenuIconBG" )
local menuIcon		= UI.getChildControl( Panel_Menu, "StaticText_MenuIcon" )
local menuBadge		= UI.getChildControl( Panel_CheckedQuest, "StaticText_Number" )

local maxButtonCount	= #MenuButtonTextId
local menuButtonBG		= {}
local menuButtonIcon	= {}
local menuBadgePool		= {}
local iconBgPosX		= menuIconBg:GetPosX()
local iconBgPosY		= menuIconBg:GetPosY()
local iconPosX			= menuIcon:GetPosX()
local iconPosY			= menuIcon:GetPosY()

local buttonTexture = {
	[MenuButtonId.btn_HelpGuide]		= { 2,		81,		46,		125 },
	[MenuButtonId.btn_UiSetting]		= { 2,		219,	46,		263 },
	[MenuButtonId.btn_PlayerInfo]		= { 48,		81,		92,		125 },
	[MenuButtonId.btn_Inventory]		= { 94,		81,		138,	125 },
	[MenuButtonId.btn_Skill]			= { 140,	81,		184,	125 },
	[MenuButtonId.btn_Guild]			= { 186,	81,		230,	125 },
	[MenuButtonId.btn_WorldMap]			= { 232,	81,		276,	125 },
	[MenuButtonId.btn_BlackSpirit]		= { 2,		127,	46,		171 },
	[MenuButtonId.btn_Quest]			= { 48,		127,	92,		171 },
	[MenuButtonId.btn_Knowledge]		= { 94,		127,	138,	171 },
	[MenuButtonId.btn_Productnote]		= { 140,	127,	184,	171 },
	[MenuButtonId.btn_FriendList]		= { 186,	127,	230,	171 },
	[MenuButtonId.btn_Mail]				= { 232,	127,	276,	171 },
	[MenuButtonId.btn_Pet]				= { 2,		173,	46,		217 },
	[MenuButtonId.btn_Dye]				= { 48,		173,	92,		217 },
	[MenuButtonId.btn_CashShop]			= { 94,		173,	138,	217 },
	[MenuButtonId.btn_Beauty]			= { 140,	173,	184,	217 },
	[MenuButtonId.btn_GameOption]		= { 186,	173,	230,	217 },
	[MenuButtonId.btn_GameExit]			= { 232,	173,	276,	217 },
	[MenuButtonId.btn_Rescue]			= { 48,		219,	92,		263 },
	[MenuButtonId.btn_Manufacture]		= { 140,	219,	184,	263 },
	[MenuButtonId.btn_FishEncyclopedia]	= {	94,		219,	138,	263 },
	[MenuButtonId.btn_ColorMix]			= {	186,	219,	230,	263 },
	[MenuButtonId.btn_Event]			= {	232,	219,	276, 	263 },
}


function TargetWindow_ShowToggle( index )
	Panel_UIControl_SetShow( false )								-- 컨트롤 창 끄기
	--Panel_Menu:SetShow( false, false )

	if		( MenuButtonId.btn_GameExit == index ) then
		GameExitShowToggle()
	elseif	( MenuButtonId.btn_Rescue == index ) then
		HandleClicked_RescueConfirm()
	elseif	( MenuButtonId.btn_GameOption == index ) then
		showGameOption()
	elseif	( MenuButtonId.btn_UiSetting == index ) then
		FGlobal_UiSet_Open()
	elseif	( MenuButtonId.btn_FriendList == index ) then
		GlobalKeyBinder_MouseKeyMap( UI_IT.UiInputType_FriendList )
	elseif	( MenuButtonId.btn_Mail == index ) then
		GlobalKeyBinder_MouseKeyMap( UI_IT.UiInputType_Mail )
	elseif	( MenuButtonId.btn_Pet == index ) then
		FGlobal_PetListNew_Toggle()
	elseif	( MenuButtonId.btn_Knowledge == index ) then
		GlobalKeyBinder_MouseKeyMap( UI_IT.UiInputType_MentalKnowledge )
	elseif	( MenuButtonId.btn_Productnote == index ) then
		Panel_ProductNote_ShowToggle()
	elseif	( MenuButtonId.btn_Inventory == index ) then
		GlobalKeyBinder_MouseKeyMap( UI_IT.UiInputType_Inventory )
	elseif	( MenuButtonId.btn_Skill == index ) then
		GlobalKeyBinder_MouseKeyMap( UI_IT.UiInputType_Skill )
	elseif	( MenuButtonId.btn_BlackSpirit == index ) then
		GlobalKeyBinder_MouseKeyMap( UI_IT.UiInputType_BlackSpirit )
	elseif	( MenuButtonId.btn_Quest == index ) then
		GlobalKeyBinder_MouseKeyMap( UI_IT.UiInputType_QuestHistory )
	elseif	( MenuButtonId.btn_WorldMap == index ) then
		GlobalKeyBinder_MouseKeyMap( UI_IT.UiInputType_WorldMap )
	elseif	( MenuButtonId.btn_PlayerInfo == index ) then
		GlobalKeyBinder_MouseKeyMap( UI_IT.UiInputType_PlayerInfo )
	elseif	( MenuButtonId.btn_Guild == index ) then
		GlobalKeyBinder_MouseKeyMap( UI_IT.UiInputType_Guild )
	elseif	( MenuButtonId.btn_HelpGuide == index ) then
		GlobalKeyBinder_MouseKeyMap( UI_IT.UiInputType_Help )
	elseif	( MenuButtonId.btn_Dye == index ) then
		GlobalKeyBinder_MouseKeyMap( UI_IT.UiInputType_Dyeing )
	elseif	( MenuButtonId.btn_Beauty == index ) then
		IngameCustomize_Show()
	elseif	( MenuButtonId.btn_CashShop == index ) then
		GlobalKeyBinder_MouseKeyMap( UI_IT.UiInputType_CashShop )
	elseif	( MenuButtonId.btn_Manufacture == index ) then
		GlobalKeyBinder_MouseKeyMap( UI_IT.UiInputType_Manufacture )
	elseif	( MenuButtonId.btn_FishEncyclopedia == index ) then
		FGlobal_FishEncyclopedia_Open()	-- Panel_FishEncyclopedia
	elseif	( MenuButtonId.btn_ColorMix == index ) then
		Panel_ColorBalance_Show()	-- Panel_FishEncyclopedia
	elseif ( MenuButtonId.btn_Event == index ) then
		EventNotify_Open( true )
	end
end

function Panel_Menu_ShowAni()
	Panel_Menu:SetAlpha( 0 )
	UIAni.AlphaAnimation( 1, Panel_Menu, 0.0, 0.15 )

	local aniInfo1 = Panel_Menu:addScaleAnimation( 0.0, 0.15, UI_ANI_ADV.PAUI_ANIM_ADVANCE_COS_HALF_PI)
	aniInfo1:SetStartScale(1.5)
	aniInfo1:SetEndScale(0.8)
	aniInfo1.AxisX = Panel_Menu:GetSizeX() / 2
	aniInfo1.AxisY = Panel_Menu:GetSizeY() / 2
	aniInfo1.ScaleType = 0
	aniInfo1.IsChangeChild = true
	
	local aniInfo2 = Panel_Menu:addScaleAnimation( 0.15, 0.2, UI_ANI_ADV.PAUI_ANIM_ADVANCE_COS_HALF_PI)
	aniInfo2:SetStartScale(0.8)
	aniInfo2:SetEndScale(1.0)
	aniInfo2.AxisX = Panel_Menu:GetSizeX() / 2
	aniInfo2.AxisY = Panel_Menu:GetSizeY() / 2
	aniInfo2.ScaleType = 0
	aniInfo2.IsChangeChild = true
end
function Panel_Menu_HideAni()
	Panel_Menu:SetAlpha( 1 )
	local aniInfo = UIAni.AlphaAnimation( 0, Panel_Menu, 0.0, 0.1 )
	aniInfo:SetHideAtEnd(true)
end

function GameMenu_Init()
	local columnCount		= 0
	local columnCountByRaw	= 7
	local rowCount			= 0
	local iconGap			= 46
	for index = 1, maxButtonCount do
		local tempBg	= UI.createControl( UI_PUCT.PA_UI_CONTROL_STATIC, menu_Bg, "Static_MenuBg_" .. index )
		CopyBaseProperty( menuIconBg, tempBg )
		menuButtonBG[index] = tempBg
		menuButtonBG[index]:SetShow( true )
		menuButtonBG[index]:ResetVertexAni()

		menuButtonBG[index]:SetPosX( iconBgPosX + ( menuIconBg:GetSizeX() ) * columnCount )
		menuButtonBG[index]:SetPosY( iconBgPosY + ( menuIconBg:GetSizeY() ) * rowCount )
		menuButtonBG[index]:addInputEvent( "Mouse_LUp",		"TargetWindow_ShowToggle(" .. index .. ")" )
		menuButtonBG[index]:addInputEvent( "Mouse_On",		"HandleOn_SlotBg(" .. index .. ")" )
		menuButtonBG[index]:addInputEvent( "Mouse_Out",		"HandleOn_SlotBg()" )
			
		local tempIcon	= UI.createControl( UI_PUCT.PA_UI_CONTROL_STATICTEXT, menuButtonBG[index], "StaticText_MenuIcon_" .. index )
		CopyBaseProperty( menuIcon, tempIcon )
		menuButtonIcon[index] = tempIcon
		menuButtonIcon[index]:SetShow( true )

		local badgeIcon	= UI.createControl( UI_PUCT.PA_UI_CONTROL_STATICTEXT, menuButtonBG[index], "StaticText_MenuBadge_" .. index )
		CopyBaseProperty( menuBadge, badgeIcon )
		badgeIcon:SetPosX( tempBg:GetSizeX() - badgeIcon:GetSizeX() )
		badgeIcon:SetPosY( 2 )
		menuBadgePool[index] = badgeIcon
		menuBadgePool[index]:SetShow( false )
		
		if 1 == index then				-- 도움말(F1)은 가운데 정렬할 경우 슬롯을 벗어나므로 강제로 텍스트 위치를 잡아준다!!!
			menuButtonIcon[index]:SetTextHorizonLeft()
			menuButtonIcon[index]:SetTextSpan( -4, 42)
		else
			menuButtonIcon[index]:SetTextHorizonCenter()
		end
		menuButtonIcon[index]:SetText( MenuButtonTextId[index] )
		GameMenu_ChangeButtonTexture( index )	-- 버튼 텍스쳐 변경
		
		if ( 0 == index % columnCountByRaw ) then
			columnCount = 0
			rowCount = rowCount + 1
		else
			columnCount = columnCount + 1
		end
	end

	local totalRaw		= math.ceil(maxButtonCount / columnCountByRaw)
	local buttonSizeX	= menuButtonBG[2]:GetPosX() - menuButtonBG[1]:GetPosX()
	local buttonGapX	= 7
	local bgSizeX		= ( buttonSizeX ) * columnCountByRaw
	menu_Bg		:SetSize( bgSizeX + (buttonGapX * 2) , ( menuIconBg:GetSizeX() + 2 ) * totalRaw + buttonGapX )
	Panel_Menu	:SetSize( menu_Bg:GetSizeX() + ( buttonGapX * 6 ) , menu_Bg:GetSizeY() + 65 )
end

function GameMenu_ChangeButtonTexture( index )
	menuButtonIcon[index]:ChangeTextureInfoName ( "New_UI_Common_forLua/Widget/Menu/Menu_01.dds" )
	local x1, y1, x2, y2 = setTextureUV_Func( menuButtonIcon[index], buttonTexture[index][1], buttonTexture[index][2], buttonTexture[index][3], buttonTexture[index][4] )
	menuButtonIcon[index]:getBaseTexture():setUV(  x1, y1, x2, y2  )
	menuButtonIcon[index]:setRenderTexture(menuButtonIcon[index]:getBaseTexture())
end

function HandleOn_SlotBg( index )
	GameMenu_ResetVertexAni()
	if nil ~= index then
		menuButtonBG[index]:SetVertexAniRun( "Ani_Color_New", true )
	end
end

function GameMenu_ResetVertexAni()
	for i = 1, maxButtonCount  do
		menuButtonBG[i]:ResetVertexAni()
		menuButtonBG[i]:SetVertexAniRun( "Ani_Color_Reset", true )
	end
end

function mainUI_Badges_Count()
	if true == _badges[MenuButtonId.btn_Quest].isShow then
		_badges[MenuButtonId.btn_Quest].count = _badges[MenuButtonId.btn_Quest].count +1
	end
	if true == _badges[MenuButtonId.btn_BlackSpirit].isShow then
		_badges[MenuButtonId.btn_BlackSpirit].count = _badges[MenuButtonId.btn_BlackSpirit].count +1
	end
	if true == _badges[MenuButtonId.btn_Skill].isShow then
		_badges[MenuButtonId.btn_Skill].count = _badges[MenuButtonId.btn_Skill].count +1
	end
	if true == _badges[MenuButtonId.btn_FriendList].isShow then
		_badges[MenuButtonId.btn_FriendList].count = _badges[MenuButtonId.btn_FriendList].count +1
	end

	menuBadgePool[MenuButtonId.btn_Quest]		:SetText( _badges[MenuButtonId.btn_Quest].count )
	menuBadgePool[MenuButtonId.btn_BlackSpirit]	:SetText( _badges[MenuButtonId.btn_BlackSpirit].count )
	menuBadgePool[MenuButtonId.btn_Skill]		:SetText( _badges[MenuButtonId.btn_Skill].count )
	menuBadgePool[MenuButtonId.btn_FriendList]	:SetText( _badges[MenuButtonId.btn_FriendList].count )
end

--------------------------------------------------------------------------------
function UIMain_ItemUpdate()	-- 슬롯 수만큼 돌아서 넘어온다.
	local newItemCount = Inventory_GetFirstItemCount()
	if not menuBadgePool[MenuButtonId.btn_Inventory]:GetShow() then
		menuBadgePool[MenuButtonId.btn_Inventory]:SetShow( true )
	end
	menuBadgePool[MenuButtonId.btn_Inventory]:SetText( newItemCount )
end
function UIMain_ItemUpdateRemove()
	menuBadgePool[MenuButtonId.btn_Inventory]:SetText( 0 )
	menuBadgePool[MenuButtonId.btn_Inventory]:SetShow( false )
end
function UIMain_FriendListUpdate()
	if false == _badges[MenuButtonId.btn_FriendList].isShow then
		_badges[MenuButtonId.btn_FriendList].isShow = true
		menuBadgePool[MenuButtonId.btn_FriendList]:SetShow( true )
		mainUI_Badges_Count()
	end
end
function UIMain_FriendListUpdateRemove()
	_badges[MenuButtonId.btn_FriendList].isShow = false
	_badges[MenuButtonId.btn_FriendList].count	= 0
	menuBadgePool[MenuButtonId.btn_FriendList]:SetShow( false )
	mainUI_Badges_Count()
end

-- 지식 버튼 처리
local knowledgePoint = 0
function UIMain_KnowledgeUpdate()
	knowledgePoint = knowledgePoint + 1
	if 0 ~= knowledgePoint then
		if 1 < knowledgePoint then
			return
		end
		menuBadgePool[MenuButtonId.btn_Knowledge]:SetShow( true )
		menuBadgePool[MenuButtonId.btn_Knowledge]:SetText("N")
	end
end
function UIMain_KnowledgeUpdateRemove()
	knowledgePoint = 0
	menuBadgePool[MenuButtonId.btn_Knowledge]:SetShow( false )
end


-- 스킬 버튼 처리
function UI_MAIN_checkSkillLearnable()	-- 스킬을 배울 수 있나?
	local isLearnable = SkillWindow_PlayerLearnableSkill()
	if( isLearnable ) then
		menuBadgePool[MenuButtonId.btn_Skill]:SetShow( true )
		menuBadgePool[MenuButtonId.btn_Skill]:SetText("N")
	end
end
function UIMain_SkillPointUpdateRemove()
	menuBadgePool[MenuButtonId.btn_Skill]:SetShow( false )
end


--------------------------------------------------------------------------------
function Panel_Menu_ShowToggle()
	local scrSizeX = getScreenSizeX()
	local scrSizeY = getScreenSizeY()

	if ( Panel_Menu:IsShow() == true ) then
		Panel_Menu_Close()
		return false;
	else
		_Panel_Menu_OpenLimit()

		Panel_Menu:SetPosX( scrSizeX - (scrSizeX/2) - ( Panel_Menu:GetSizeX() / 2 ) )
		Panel_Menu:SetPosY( Panel_Menu:GetSizeY() * 0.35 )
		Panel_Menu:SetShow( true, true )
		Panel_Menu:SetDragAll( true )
		Panel_Menu:SetIgnore( false )
		audioPostEvent_SystemUi(01,37)

		return true;
	end

	return false
end

function _Panel_Menu_OpenLimit()
	if nil ~= getSelfPlayer() then
		if 10 < getSelfPlayer():get():getLevel() then
			for index=1, maxButtonCount do
				menuButtonBG[index]		:SetEnable( true )
				menuButtonBG[index]		:SetMonoTone( false )
				menuButtonIcon[index]	:SetEnable( true )
				menuButtonIcon[index]	:SetMonoTone( false )
			end
		else
			for index=1, maxButtonCount do
				menuButtonBG[index]		:SetEnable( true )
				menuButtonBG[index]		:SetMonoTone( false )
				menuButtonIcon[index]	:SetEnable( true )
				menuButtonIcon[index]	:SetMonoTone( false )
			end
			menuButtonBG[MenuButtonId.btn_UiSetting]:SetEnable( false )
			menuButtonBG[MenuButtonId.btn_UiSetting]:SetMonoTone( true )
			menuButtonIcon[MenuButtonId.btn_UiSetting]:SetEnable( false )
			menuButtonIcon[MenuButtonId.btn_UiSetting]:SetMonoTone( true )
		end
	end
end

function Panel_Menu_Close()
	Panel_Menu:SetShow( false, true )
	Panel_Menu:SetDragAll( false )
	Panel_Menu:SetIgnore( true )
	if false == check_ShowWindow() then
		UI.Set_ProcessorInputMode(IM.eProcessorInputMode_GameMode)
	end
end

function HandleClicked_RescueConfirm()
	local	messageBoxTitle = "알 림"
	local	messageBoxMemo = "탈출 하시겠습니까?\n탈출하게 되면 가까운 마을로 캐릭터가 이동합니다."
	local	messageBoxData = { title = messageBoxTitle, content = messageBoxMemo, functionYes = RescueExecute, functionNo = MessageBox_Empty_function, priority = CppEnums.PAUIMB_PRIORITY.PAUIMB_PRIORITY_LOW}
		MessageBox.showMessageBox(messageBoxData)
end

function RescueExecute()
	callRescue()
end


function panelMenu_OnScreenResize()
	local scrSizeX = getScreenSizeX()
	Panel_Menu:SetPosX( scrSizeX - (scrSizeX/2) - ( Panel_Menu:GetSizeX() / 2 ) )
	Panel_Menu:SetPosY( Panel_Menu:GetSizeY() * 0.35 )
end


GameMenu_Init()

registerEvent("onScreenResize", 			"panelMenu_OnScreenResize" )