-- 미니게임 타입 2 (커맨드 입력)

local MGKT = CppEnums.MiniGameKeyType
local UIColor = Defines.Color
local UI_ANI_ADV	= CppEnums.PAUI_ANIM_ADVANCE_TYPE

Panel_Command:SetShow(false, false)

-- Panel_Command:RegisterShowEventFunc( true, 'HudTimerShowAni()' )
------------------------------------------------------------------------------------------------------------------------------------
------------------------------------------------------------------------------------------------------------------------------------

local CommandText =
{
	UI.getChildControl(Panel_Command, "StaticText_Command_0"),
	UI.getChildControl(Panel_Command, "StaticText_Command_1"),
	UI.getChildControl(Panel_Command, "StaticText_Command_2"),
	UI.getChildControl(Panel_Command, "StaticText_Command_3"),
	UI.getChildControl(Panel_Command, "StaticText_Command_4"),
	UI.getChildControl(Panel_Command, "StaticText_Command_5"),
	UI.getChildControl(Panel_Command, "StaticText_Command_6"),
	UI.getChildControl(Panel_Command, "StaticText_Command_7"),
	UI.getChildControl(Panel_Command, "StaticText_Command_8"),
	UI.getChildControl(Panel_Command, "StaticText_Command_9")
}

local gameOptionActionKey = {
	Forward		= 0,
	Back		= 1,
	Left		= 2,
	Right		= 3,
	Attack		= 4,
	SubAttack	= 5,
	Dash		= 6,
	Jump		= 7,
}

local _sinGauge_Result_Perfect 		= UI.getChildControl ( Panel_Command, "Static_Result_Perfect" )
local _sinGauge_Result_Bad 			= UI.getChildControl ( Panel_Command, "Static_Result_Bad" )

-- 애니메이션
	-- KEY Currecet!
local _Command_CurrentKey_Eff0 		= UI.getChildControl ( Panel_Command, "Static_Eff_Currect_Eff0" )

local _CommandTimeBG			 	= UI.getChildControl ( Panel_Command, "Static_TimerGaugeBG" )
local _CommandTimerBar			 	= UI.getChildControl ( Panel_Command, "Static_TimerGauge" )

local _Result_Success				= UI.getChildControl ( Panel_Command, "Static_Result_Success" )
local _Result_Failed				= UI.getChildControl ( Panel_Command, "Static_Result_Failed" )

local _fishGrade					= UI.getChildControl ( Panel_Command, "StaticText_FishGrade" )
_fishGrade:SetShow( false )

-- 부가 정보
local panelSizeX = Panel_Command:GetSizeX()
local panelSizeY = Panel_Command:GetSizeY()

local isCommandFinished = true			-- 커맨드 게임이 끝났느냐!

-- 생선의 등급을 골라냄
local fishCommandCount = {
	[0] = { min = 2, max = 3 },			-- 일반 = 2 ~ 4개
	{ min = 4, max = 5 },				-- 매직 = 4 ~ 5개
	{ min = 5, max = 6 },				-- 레어 = 5 ~ 6개
	{ min = 7, max = 9 },				-- 유니크 = 7 ~ 9개
	{ min = 10, max = 10 },				-- 에픽 = 10개
}

local fishCount = -1
local FishGrade = -1
local getFishCountCalc = function()
	FishGrade = getSelfPlayer():get():getFishGrade()	-- 잡은 물고기 등급 알아오기
	--local FishGrade = 3
	if ( FishGrade < 5 ) then
		local currCount = fishCommandCount[FishGrade]
		fishCount = math.random(currCount.min, currCount.max)
	else
		UI.ASSERT(false, "그레이드가 잘못 들어왔습니다. 루아에도 물고기 그레이드를 바꿔주세요.")
	end
end

------------------------------------------------------------------------------------------------------------------------------------
------------------------------------------------------------------------------------------------------------------------------------
-- 화면 리포지션
function Command_RePosition()
	screenX = getScreenSizeX()
	Panel_Command:SetPosX( ( screenX / 2 ) - ( Panel_Command:GetSizeX() / 2 ) )
	Panel_Command:SetPosY( 350 )
end

local _math_random = math.random
local _math_randomSeed = math.randomseed
local commands = {}
local currentCommandIndex= 1
local passedTimePerNext = 0		-- 한번 누른 이후 지난 시간

local Command_CreateRandomText = function()
	commands = {}
	
	local cmd, cmdText
	local textControl

	for index = 1, fishCount do
		cmd = _math_random(0, 3)
		textControl = CommandText[index]
		
		if 0 == cmd then
			if getGamePadEnable() then
				cmdText = keyCustom_GetString_ActionPad( gameOptionActionKey.Forward );
			else
				cmdText = keyCustom_GetString_ActionKey( gameOptionActionKey.Forward );
			end
			textControl:ChangeTextureInfoName("New_UI_Common_forLua/widget/instance/MiniGame_00.dds")
				local x1, y1, x2, y2 = setTextureUV_Func( textControl, 400, 1, 426, 27 )
				textControl:getBaseTexture():setUV(  x1, y1, x2, y2  )
				textControl:setRenderTexture(textControl:getBaseTexture())
		elseif 1 == cmd then
			if getGamePadEnable() then
				cmdText = keyCustom_GetString_ActionPad( gameOptionActionKey.Back );
			else
				cmdText = keyCustom_GetString_ActionKey( gameOptionActionKey.Back );
			end
			textControl:ChangeTextureInfoName("New_UI_Common_forLua/widget/instance/MiniGame_00.dds")
				local x1, y1, x2, y2 = setTextureUV_Func( textControl, 400, 28, 426, 54 )
				textControl:getBaseTexture():setUV(  x1, y1, x2, y2  )
				textControl:setRenderTexture(textControl:getBaseTexture())
		elseif 2 == cmd then
			if getGamePadEnable() then
				cmdText = keyCustom_GetString_ActionPad( gameOptionActionKey.Left );
			else
				cmdText = keyCustom_GetString_ActionKey( gameOptionActionKey.Left );
			end
			textControl:ChangeTextureInfoName("New_UI_Common_forLua/widget/instance/MiniGame_00.dds")
				local x1, y1, x2, y2 = setTextureUV_Func( textControl, 373, 1, 399, 27 )
				textControl:getBaseTexture():setUV(  x1, y1, x2, y2  )
				textControl:setRenderTexture(textControl:getBaseTexture())
		else
			if getGamePadEnable() then
				cmdText = keyCustom_GetString_ActionPad( gameOptionActionKey.Right );
			else
				cmdText = keyCustom_GetString_ActionKey( gameOptionActionKey.Right );
			end
			textControl:ChangeTextureInfoName("New_UI_Common_forLua/widget/instance/MiniGame_00.dds")
				local x1, y1, x2, y2 = setTextureUV_Func( textControl, 373, 28, 399, 54 )
				textControl:getBaseTexture():setUV(  x1, y1, x2, y2  )
				textControl:setRenderTexture(textControl:getBaseTexture())
			cmd = 3
		end

		textControl:SetText( cmdText )
		textControl:SetColor( UIColor.C_FFEFEFEF )
		textControl:SetFontColor( UIColor.C_FFEFEFEF )
		textControl:SetPosX( index * 35 - 17 )
		textControl:SetPosY( 31 )
		textControl:SetShow( true )

		commands[index] = cmd
	end
end

-- 켜기
function Panel_Minigame_Command_Start()
	Panel_Command:SetShow( true, false )
	
	getFishCountCalc()
	isCommandFinished = false
	
	_fishGrade:SetShow( true )
	if ( fishCount > 0 ) and ( fishCount <= 2 ) then
		_fishGrade:SetText( PAGetString(Defines.StringSheet_GAME, "LUA_MINIGAME_FishGrade1") )
	elseif ( fishCount >= 3 ) and ( fishCount <= 4 ) then
		_fishGrade:SetText( PAGetString(Defines.StringSheet_GAME, "LUA_MINIGAME_FishGrade2") )
	elseif ( fishCount >= 5 ) and ( fishCount <= 7 ) then
		_fishGrade:SetText( PAGetString(Defines.StringSheet_GAME, "LUA_MINIGAME_FishGrade3") )
	elseif ( fishCount >= 8 ) and ( fishCount <= 9 ) then
		_fishGrade:SetText( PAGetString(Defines.StringSheet_GAME, "LUA_MINIGAME_FishGrade4") )
	elseif ( fishCount == 10 ) then
		_fishGrade:SetText( PAGetString(Defines.StringSheet_GAME, "LUA_MINIGAME_FishGrade5") )
	end

	_Result_Failed:SetShow(false)
	_Result_Failed:ResetVertexAni()
	_Result_Failed:SetAlpha(0)
	_Result_Success:SetShow(false)
	_Result_Success:ResetVertexAni()
	_Result_Success:SetAlpha(0)
	
	_Command_CurrentKey_Eff0:SetShow(false)
	_Command_CurrentKey_Eff0:ResetVertexAni()
	_Command_CurrentKey_Eff0:SetAlpha(0)
	
	_math_randomSeed( os.time() )
	Command_CreateRandomText()
	currentCommandIndex = 1
	Panel_Command:RegisterUpdateFunc("Command_UpdateText")

	passedTimePerNext = 0

	_sinGauge_Result_Bad:SetShow( false )
	_sinGauge_Result_Perfect:SetShow( false )

	for index = 1, 10 do
		CommandText[index]:SetShow( index <= fishCount )
		CommandText[index]:SetFontColor( UIColor.C_FFFFFFFF )
		CommandText[index]:SetColor( UIColor.C_FFFFFFFF )
	end
end

-- 끄기
function Panel_Minigame_Command_End()
	Panel_Command:RegisterUpdateFunc("")
	Panel_Command:SetShow( false, false )

	isCommandFinished = true
end

-- 모두 맞췄을 때!!!!!
local MiniGame_Command_OnSuccess = function()
	-- ♬ 성공 사운드
	audioPostEvent_SystemUi(11,04)
	
	getSelfPlayer():get():SetMiniGameResult( 2 )		-- Success !!!
	Panel_Command:RegisterUpdateFunc("")
	--UI.debugMessage( 'Success!' )
	isCommandFinished = true

	_sinGauge_Result_Perfect:ResetVertexAni()
	_sinGauge_Result_Perfect:SetVertexAniRun("Perfect_Ani", true)
	_sinGauge_Result_Perfect:SetVertexAniRun("Perfect_ScaleAni", true)
	_sinGauge_Result_Perfect:SetVertexAniRun("Perfect_AniEnd", true)
	
	_Result_Success:SetShow(true)
	_Result_Success:ResetVertexAni()
	_Result_Success:SetVertexAniRun("Ani_Scale_Result_Success_empty", true)
	_Result_Success:SetVertexAniRun("Ani_Scale_Result_Success", true)
	_Result_Success:SetVertexAniRun("Ani_Color_Result_Success_empty", true)
	_Result_Success:SetVertexAniRun("Ani_Color_Result_Success", true)
end


-- 실패 했을 때 동작하는 코드!
local MiniGame_Command_OnFailed = function()
	-- ♬ 실패 사운드
	audioPostEvent_SystemUi(11,07)
	
	local textControl = CommandText[currentCommandIndex]

	getSelfPlayer():get():SetMiniGameResult( 0 )		-- FAIL!!
	isCommandFinished = true
	Panel_Command:RegisterUpdateFunc("")
	-- UI.debugMessage( 'Failed!' )
	textControl:SetColor( UIColor.C_FFFF0000 )		-- 틀린것도 색을 바꿔준다!
	textControl:SetFontColor( UIColor.C_FFFF0000 )		-- 틀린것도 색을 바꿔준다!
	
	_sinGauge_Result_Bad:ResetVertexAni()
	_sinGauge_Result_Bad:SetVertexAniRun("Bad_Ani", true)
	_sinGauge_Result_Bad:SetVertexAniRun("Bad_ScaleAni", true)
	_sinGauge_Result_Bad:SetVertexAniRun("Bad_AniEnd", true)

	_Result_Failed:SetShow(true)
	_Result_Failed:ResetVertexAni()
	_Result_Failed:SetVertexAniRun("Ani_Scale_Result_Failed_empty", true)
	_Result_Failed:SetVertexAniRun("Ani_Scale_Result_Failed", true)
	_Result_Failed:SetVertexAniRun("Ani_Color_Result_Failed_empty", true)
	_Result_Failed:SetVertexAniRun("Ani_Color_Result_Failed", true)
end

function MiniGame_Command_ddukdition( keyType )
	if ( isCommandFinished ) then
		return
	end

	-- UI.debugMessage('Aurah - 2 !!!!!!!!!!!!!!!!!')

	local textControl = CommandText[currentCommandIndex]
	if (keyType < MGKT.MiniGameKeyType_W) or (MGKT.MiniGameKeyType_D < keyType) then
		return
	end
	
	--_PA_LOG("LUA", 'Command Good Key Type ' .. tostring(keyType) )

	if commands[currentCommandIndex] == keyType then
		-- 성공했을 때!!!!
		-- ♬ 키 하나 성공했을 때 사운드
		audioPostEvent_SystemUi(11,00)
		
		textControl:SetColor( UIColor.C_FF88DF00 )		-- 맞춘건 색을 바꿔준다!
		textControl:SetFontColor( UIColor.C_FF88DF00 )		-- 맞춘건 색을 바꿔준다!
		currentCommandIndex = currentCommandIndex + 1
		
		_Command_CurrentKey_Eff0:SetShow(true)
		_Command_CurrentKey_Eff0:EraseAllEffect()
		_Command_CurrentKey_Eff0:AddEffect( "UI_LevelUP_Skill", false, 0, -8 )
		_Command_CurrentKey_Eff0:AddEffect( "fUI_LevelUP_Skill02", false, 0, -8 )
		_Command_CurrentKey_Eff0:SetPosX( textControl:GetPosX() - 23 )
		_Command_CurrentKey_Eff0:SetPosY( textControl:GetPosY() / 2 - 12 )
		
		if fishCount < currentCommandIndex then
			MiniGame_Command_OnSuccess()
		end
	else
		MiniGame_Command_OnFailed()
	end
end

function Command_UpdateText( deltaTime )
	passedTimePerNext = passedTimePerNext + deltaTime
	local rate = passedTimePerNext / 6
	if ( 1 < rate  ) then
		rate = 1
	end
	
	_CommandTimerBar:SetSize( ( 1 - rate ) * 271 , 18 )

	-- UI.debugMessage('rate : ' .. rate )
	
	-- 3초씩 주어진다!
	if ( 6 < passedTimePerNext ) then
		MiniGame_Command_OnFailed()
	end
end

registerEvent( "onScreenResize", "Command_RePosition" )
registerEvent("EventActionMiniGameKeyDownOnce",	"MiniGame_Command_ddukdition")
Command_RePosition()
