Panel_Party:ActiveMouseEventEffect(true)
Panel_Party:SetShow( false, false )
Panel_PartyOption:SetShow( false, false )

Panel_Party:RegisterShowEventFunc( true, 'PartyShowAni()' )
Panel_Party:RegisterShowEventFunc( false, 'PartyHideAni()' )
Panel_PartyOption:RegisterShowEventFunc( true, 'PartyOptionShowAni()' )
Panel_PartyOption:RegisterShowEventFunc( false, 'PartyOptionHideAni()' )

local CT2S 			= CppEnums.ClassType2String
local PLT 			= CppEnums.PartyLootType
local PLT2S 		= CppEnums.PartyLootType2String
local UI_ANI_ADV 	= CppEnums.PAUI_ANIM_ADVANCE_TYPE
local UI_PSFT 		= CppEnums.PAUI_SHOW_FADE_TYPE
local PP 			= CppEnums.PAUIMB_PRIORITY
local UI_color 		= Defines.Color
local UI_Class		= CppEnums.ClassType

local _last_Index 	= nil
local _partyData 	= {}
local withdrawMember

local requestPlayerList = {}

local controlTemplate =
{
	_styleLeaderIcon 		= UI.getChildControl( Panel_Party, 	"Static_Icon_Leader"  ),
	_styleBackGround		= UI.getChildControl( Panel_Party, 	"Static_ClassSlot"  ),
	_styleClassIcon 		= UI.getChildControl( Panel_Party, 	"Static_Icon_Class"  ),
	_styleUserName 			= UI.getChildControl( Panel_Party, 	"StaticText_UserName"  ),
	_styleHpBG				= UI.getChildControl( Panel_Party, 	"Static_HpBG"  ),
	_styleHp 				= UI.getChildControl( Panel_Party, 	"Progress2_Hp"  ),
	_styleMp			 	= UI.getChildControl( Panel_Party, 	"Progress2_Mp"  ),
	_styleUserLevel			= UI.getChildControl( Panel_Party, 	"StaticText_UserLevel"  ),
	-- _styleMpHead			 	= nil,
	-- _stylePortraitCharacter	= UI.getChildControl( Panel_Party, 	"Static_Portrait_Character"  ),
	-- _stylePortraitDeco		= UI.getChildControl( Panel_Party, 	"Static_Portrait_Deco"  ),
	_styleConditionBG 		= UI.getChildControl( Panel_Party, 	"Static_DeadConditionBG"  ),
	_styleConditionTxt 		= UI.getChildControl( Panel_Party, 	"StaticText_NowCondition"  ),
	_stylePartyOptionBtn	= UI.getChildControl( Panel_Party, "Button_Option" ),
}
-- controlTemplate._styleMpHead = UI.getChildControl(controlTemplate._styleMp, 	"Progress2_2_Mp_Head"  )

controlTemplate._styleBackGround:SetShow(false)
controlTemplate._styleUserName:SetShow(false)
controlTemplate._styleHpBG:SetShow(false)
-- controlTemplate._styleMpBG:SetShow(false)
controlTemplate._styleHp:SetShow(false)
controlTemplate._styleUserLevel:SetShow(false)
-- controlTemplate._styleMpHead:SetShow(false)
controlTemplate._styleClassIcon:SetShow(false)
-- controlTemplate._stylePortraitCharacter:SetShow(false)
-- controlTemplate._stylePortraitDeco:SetShow(false)
controlTemplate._styleLeaderIcon:SetShow(false)
controlTemplate._styleConditionBG:SetShow(false)
controlTemplate._styleConditionTxt:SetShow(false)
controlTemplate._stylePartyOptionBtn:SetShow(false)

local _styleLootType 			= UI.getChildControl( Panel_Party, "StaticText_LootType"  )
local _uiComboLootingOption		= UI.getChildControl( Panel_Party, "Combobox_Looting_Option" )
_styleLootType:SetShow(false)
_uiComboLootingOption:SetShow(false)

local _uiPartyMemberList 		= {}
_maxPartyMemberCount 			= 5
local _preLootType

local _uiButtonChangeLeader		= UI.getChildControl( Panel_PartyOption, "Button_Change_Leader" )
local _uiButtonWithdrawMember	= UI.getChildControl( Panel_PartyOption, "Button_Withdraw_Member" )
-- local _uiButtonWinClose 		= UI.getChildControl( Panel_PartyOption, "Button_Win_Close" )
-- local _uiButtonQuestion	 		= UI.getChildControl( Panel_PartyOption, "Button_Question" )				-- 물음표 버튼


local closePartyOption = function()
	-- 꺼준다
	Panel_PartyOption:SetShow(false)
end


function PartyShowAni()
end

function PartyHideAni()
end


function PartyOptionShowAni()
	UIAni.fadeInSCR_Down(Panel_PartyOption)
end

function PartyOptionHideAni()
	Panel_PartyOption:SetShowWithFade(UI_PSFT.PAUI_ANI_TYPE_FADE_OUT)
	local aniInfo1 = Panel_PartyOption:addColorAnimation( 0.0, 0.22, UI_ANI_ADV.PAUI_ANIM_ADVANCE_SIN_HALF_PI)
	aniInfo1:SetStartColor( UI_color.C_FFFFFFFF )
	aniInfo1:SetEndColor( UI_color.C_00FFFFFF )
	aniInfo1:SetStartIntensity( 3.0 )
	aniInfo1:SetEndIntensity( 1.0 )
	aniInfo1.IsChangeChild = true
	aniInfo1:SetHideAtEnd(true)
	aniInfo1:SetDisableWhileAni(true)

	local aniInfo2 = Panel_PartyOption:addScaleAnimation( 0.0, 0.22, UI_ANI_ADV.PAUI_ANIM_ADVANCE_SIN_HALF_PI)
	aniInfo2:SetStartScale(1.0)
	aniInfo2:SetEndScale(0.97)
	aniInfo2.AxisX = 200
	aniInfo2.AxisY = 295
	aniInfo2.IsChangeChild = true
end

function Looting_ComboBox()
	local lootingList = _uiComboLootingOption:GetListControl()
	
	lootingList:addInputEvent( "Mouse_LUp", "changeLooting()" )
	_uiComboLootingOption:ToggleListbox()
end

function changeLooting()
	local selectKey = _uiComboLootingOption:GetSelectKey()
	_uiComboLootingOption:SetSelectItemIndex( selectKey )
	RequestParty_changeLooting(selectKey)
	_uiComboLootingOption:SetShow(false)
end

local createPartyControls = function()
	for index = 0 , _maxPartyMemberCount-1, 1 do
		local partyMember = {}
		partyMember._base 					= UI.createControl( CppEnums.PA_UI_CONTROL_TYPE.PA_UI_CONTROL_STATIC, 		Panel_Party,		'PartyMember_Back' .. index)
		partyMember._leader					= UI.createControl( CppEnums.PA_UI_CONTROL_TYPE.PA_UI_CONTROL_STATIC, 		partyMember._base,	'PartyMember_Leader' .. index)
		partyMember._name 					= UI.createControl( CppEnums.PA_UI_CONTROL_TYPE.PA_UI_CONTROL_STATICTEXT, 	partyMember._base,	'PartyMember_UserName' .. index)
		partyMember._class					= UI.createControl( CppEnums.PA_UI_CONTROL_TYPE.PA_UI_CONTROL_STATIC, 		partyMember._base,	'PartyMember_Class' .. index)
		partyMember._hpBG					= UI.createControl( CppEnums.PA_UI_CONTROL_TYPE.PA_UI_CONTROL_STATIC, 		partyMember._base,	'PartyMember_HpBG' .. index)
		partyMember._hp						= UI.createControl( CppEnums.PA_UI_CONTROL_TYPE.PA_UI_CONTROL_PROGRESS2, 	partyMember._base,	'PartyMember_Hp' .. index)
		partyMember._mp						= UI.createControl( CppEnums.PA_UI_CONTROL_TYPE.PA_UI_CONTROL_PROGRESS2, 	partyMember._base,	'PartyMember_Mp' .. index)
		partyMember._level					= UI.createControl( CppEnums.PA_UI_CONTROL_TYPE.PA_UI_CONTROL_STATICTEXT, 	partyMember._base,	'PartyMember_UserLevel' .. index)
		partyMember._conditionBG			= UI.createControl( CppEnums.PA_UI_CONTROL_TYPE.PA_UI_CONTROL_STATIC, 		partyMember._base,	'PartyMember_ConditionBG' .. index)
		partyMember._conditionTxt			= UI.createControl( CppEnums.PA_UI_CONTROL_TYPE.PA_UI_CONTROL_STATICTEXT,	partyMember._base,	'PartyMember_ConditionTxt' .. index)
		partyMember._stylePartyOptionBtn	= UI.createControl( CppEnums.PA_UI_CONTROL_TYPE.PA_UI_CONTROL_BUTTON,		partyMember._base,	'PartyMember_OptionBtn' .. index)

		CopyBaseProperty( controlTemplate._styleLeaderIcon, 		partyMember._leader )
		CopyBaseProperty( controlTemplate._styleUserName, 			partyMember._name )
		CopyBaseProperty( controlTemplate._styleBackGround,			partyMember._base )
		CopyBaseProperty( controlTemplate._styleClassIcon, 			partyMember._class )
		CopyBaseProperty( controlTemplate._styleHpBG, 				partyMember._hpBG )
		CopyBaseProperty( controlTemplate._styleHp, 				partyMember._hp )
		CopyBaseProperty( controlTemplate._styleMp, 				partyMember._mp )
		CopyBaseProperty( controlTemplate._styleUserLevel, 			partyMember._level )
		CopyBaseProperty( controlTemplate._styleConditionBG, 		partyMember._conditionBG )
		CopyBaseProperty( controlTemplate._styleConditionTxt, 		partyMember._conditionTxt )
		CopyBaseProperty( controlTemplate._stylePartyOptionBtn, 	partyMember._stylePartyOptionBtn )

		partyMember._leader:SetShow(false)
		partyMember._name:SetShow(true)
		partyMember._base:SetShow(true)
		partyMember._class:SetShow(true)
		partyMember._hpBG:SetShow(true)
		partyMember._hp:SetShow(true)
		partyMember._mp:SetShow(true)
		partyMember._level:SetShow(true)
		partyMember._conditionBG:SetShow(true)
		partyMember._conditionTxt:SetShow(true)

		partyMember._base:SetAlpha( 0.7 )
		partyMember._base:SetShow(true)
		partyMember._base:SetPosY(index*partyMember._base:GetSizeY()*1.08)

		partyMember._name:SetIgnore(true)
		partyMember._class:SetIgnore(true)
		partyMember._hpBG:SetIgnore(true)
		partyMember._hp:SetIgnore(true)
		partyMember._mp:SetIgnore(true)
		partyMember._level:SetIgnore(true)
		partyMember._leader:SetIgnore(true)
		partyMember._conditionBG:SetIgnore(true)
		partyMember._conditionTxt:SetIgnore(true)

		partyMember._stylePartyOptionBtn:addInputEvent( "Mouse_LUp", "PartyPop_clickPartyOption("..index..")")
		
		_uiPartyMemberList[index] = partyMember
	end

	Panel_Party:SetChildIndex( _styleLootType:GetKey(), Panel_Party:GetChildSize() )
end

createPartyControls()

function ResponseParty_createPartyList()
	local partyMemberCount = RequestParty_getPartyMemberCount()
	if (0<partyMemberCount) then
		Panel_Party:SetShow(true, false)
		table.remove( requestPlayerList )
		ResponseParty_updatePartyList()
		-- Panel_WidgetControl_Toggle("Panel_Party", true)
	end
end

function ResponseParty_updatePartyList() 	-- 내가 리더인지 필요할듯(팀원중에 리더가 없으면으로 판단할까?)
	if (Panel_Party:IsShow()) then
		local partyMemberCount = RequestParty_getPartyMemberCount()
		local classTypeTexture
		local lootType = RequestParty_getPartyLootType()
		local classMP = ""
		
		local _idx = 0
		local isSelfMaster = false
		_partyData = {}
		for index = 0, (partyMemberCount - 1) do
			local idx = 0
			local memberData = RequestParty_getPartyMemberAt(index)
			if true == RequestParty_isSelfPlayer(index) then
				idx = 0
			else
				idx = _idx + 1
				_idx = idx
			end
						
			_partyData[idx] = 
			{
				_index		= index,
				_isMaster 	= memberData._isMaster,
				_isSelf		= RequestParty_isSelfPlayer(index),
				_name 		= memberData:name(),
				_class 		= memberData:classType(),
				_level 		= memberData._level,
				_nowHp 		= memberData._hp * 100,
				_maxHp 		= memberData._maxHp,
				_nowMp 		= memberData._mp * 100,
				_maxMp 		= memberData._maxMp,
			}	
			
			if true == _partyData[idx]._isSelf and true == _partyData[idx]._isMaster then
				isSelfMaster = true			
			end
		end
		
		for index = 0, _maxPartyMemberCount-1, 1 do
			_uiPartyMemberList[index]._hpBG:SetShow(true)

			if( index <= partyMemberCount-1 ) and nil ~= _partyData[index] then
				_uiPartyMemberList[index]._name:SetText( _partyData[index]._name )
				_uiPartyMemberList[index]._level:SetText( _partyData[index]._level )
				_uiPartyMemberList[index]._hp:SetProgressRate( _partyData[index]._nowHp / _partyData[index]._maxHp )
				_uiPartyMemberList[index]._mp:SetProgressRate( _partyData[index]._nowMp / _partyData[index]._maxMp )
				if true == isSelfMaster or true == _partyData[index]._isSelf then
					local spanSizeX = _uiPartyMemberList[index]._name:GetTextSizeX() + _uiPartyMemberList[index]._name:GetPosX()
					_uiPartyMemberList[index]._stylePartyOptionBtn:SetSpanSize( spanSizeX + 10, _uiPartyMemberList[index]._stylePartyOptionBtn:GetSpanSize().y )
					_uiPartyMemberList[index]._stylePartyOptionBtn:SetShow(true)
				else
					_uiPartyMemberList[index]._stylePartyOptionBtn:SetShow(false)
				end
				classTypeTexture = "new_ui_common_forlua/widget/party/portrait_" .. CT2S[_partyData[index]._class].. ".dds"
				if(_partyData[index]._class == 4) then
					classMP = "new_ui_common_forlua/default/Default_Gauges.dds"				-- EP
					_uiPartyMemberList[index]._mp:ChangeTextureInfoName(classMP)

						local x1, y1, x2, y2 = setTextureUV_Func( _uiPartyMemberList[index]._mp, 1, 70, 233, 76 )
						_uiPartyMemberList[index]._mp:getBaseTexture():setUV(  x1, y1, x2, y2  )
						_uiPartyMemberList[index]._mp:setRenderTexture(_uiPartyMemberList[index]._mp:getBaseTexture())

				elseif(_partyData[index]._class == 8 or _partyData[index]._class == 16) then
					classMP = "new_ui_common_forlua/default/Default_Gauges.dds"				-- MP
					_uiPartyMemberList[index]._mp:ChangeTextureInfoName(classMP)

						local x1, y1, x2, y2 = setTextureUV_Func( _uiPartyMemberList[index]._mp, 1, 63, 233, 69 )
						_uiPartyMemberList[index]._mp:getBaseTexture():setUV(  x1, y1, x2, y2  )
						_uiPartyMemberList[index]._mp:setRenderTexture(_uiPartyMemberList[index]._mp:getBaseTexture())

				elseif(_partyData[index]._class == 0 or _partyData[index]._class == 12) then
					classMP = "new_ui_common_forlua/default/Default_Gauges.dds"				-- FP
					_uiPartyMemberList[index]._mp:ChangeTextureInfoName(classMP)

						local x1, y1, x2, y2 = setTextureUV_Func( _uiPartyMemberList[index]._mp, 1, 56, 233, 62 )
						_uiPartyMemberList[index]._mp:getBaseTexture():setUV(  x1, y1, x2, y2  )
						_uiPartyMemberList[index]._mp:setRenderTexture(_uiPartyMemberList[index]._mp:getBaseTexture())
				end

				---------------------------------------------------------
				--			클래스 별로 클래스 아이콘을 바꿔준다
				if ( _partyData[index]._class == UI_Class.ClassType_Warrior ) then	-- 워리어
				classTypeTexture = "new_ui_common_forlua/widget/party/Party_00.dds"
				_uiPartyMemberList[index]._class:ChangeTextureInfoName(classTypeTexture)
					local x1, y1, x2, y2 = setTextureUV_Func( _uiPartyMemberList[index]._class, 77, 25, 107, 55 )
					_uiPartyMemberList[index]._class:getBaseTexture():setUV(  x1, y1, x2, y2  )
					_uiPartyMemberList[index]._class:setRenderTexture(_uiPartyMemberList[index]._class:getBaseTexture())

				elseif ( _partyData[index]._class == UI_Class.ClassType_Ranger ) then	-- 레인저
				classTypeTexture = "new_ui_common_forlua/widget/party/Party_00.dds"
				_uiPartyMemberList[index]._class:ChangeTextureInfoName(classTypeTexture)
					local x1, y1, x2, y2 = setTextureUV_Func( _uiPartyMemberList[index]._class, 108, 25, 138, 55 )
					_uiPartyMemberList[index]._class:getBaseTexture():setUV(  x1, y1, x2, y2  )
					_uiPartyMemberList[index]._class:setRenderTexture(_uiPartyMemberList[index]._class:getBaseTexture())
					
				elseif ( _partyData[index]._class == UI_Class.ClassType_Sorcerer ) then	-- 소서러
				classTypeTexture = "new_ui_common_forlua/widget/party/Party_00.dds"
				_uiPartyMemberList[index]._class:ChangeTextureInfoName(classTypeTexture)
					local x1, y1, x2, y2 = setTextureUV_Func( _uiPartyMemberList[index]._class, 139, 25, 169, 55 )
					_uiPartyMemberList[index]._class:getBaseTexture():setUV(  x1, y1, x2, y2  )
					_uiPartyMemberList[index]._class:setRenderTexture(_uiPartyMemberList[index]._class:getBaseTexture())
					
				elseif ( _partyData[index]._class == UI_Class.ClassType_Giant ) then	-- 자이언트
				classTypeTexture = "new_ui_common_forlua/widget/party/Party_00.dds"
				_uiPartyMemberList[index]._class:ChangeTextureInfoName(classTypeTexture)
					local x1, y1, x2, y2 = setTextureUV_Func( _uiPartyMemberList[index]._class, 170, 25, 200, 55 )
					_uiPartyMemberList[index]._class:getBaseTexture():setUV(  x1, y1, x2, y2  )
					_uiPartyMemberList[index]._class:setRenderTexture(_uiPartyMemberList[index]._class:getBaseTexture())

				elseif ( _partyData[index]._class == UI_Class.ClassType_Tamer ) then	-- 테이머
				classTypeTexture = "new_ui_common_forlua/widget/party/Party_00.dds"
				_uiPartyMemberList[index]._class:ChangeTextureInfoName(classTypeTexture)
					local x1, y1, x2, y2 = setTextureUV_Func( _uiPartyMemberList[index]._class, 167, 56, 197, 86 )
					_uiPartyMemberList[index]._class:getBaseTexture():setUV(  x1, y1, x2, y2  )
					_uiPartyMemberList[index]._class:setRenderTexture(_uiPartyMemberList[index]._class:getBaseTexture())

				elseif ( _partyData[index]._class == UI_Class.ClassType_BladeMaster ) then	-- 블레이더
				classTypeTexture = "new_ui_common_forlua/widget/party/Party_00.dds"
				_uiPartyMemberList[index]._class:ChangeTextureInfoName(classTypeTexture)
					local x1, y1, x2, y2 = setTextureUV_Func( _uiPartyMemberList[index]._class, 198, 56, 228, 86 )
					_uiPartyMemberList[index]._class:getBaseTexture():setUV(  x1, y1, x2, y2  )
					_uiPartyMemberList[index]._class:setRenderTexture(_uiPartyMemberList[index]._class:getBaseTexture())

				end
				
				------------------------------------------------------
				--					캐릭터가 사망했다!!
				if ( 0 >= _partyData[index]._nowHp ) then
					_uiPartyMemberList[index]._conditionBG:SetShow( true )
					_uiPartyMemberList[index]._conditionTxt:SetShow( true )
					_uiPartyMemberList[index]._conditionTxt:SetText( PAGetString( Defines.StringSheet_GAME, "PANEL_PARTY_DEATH" ) )
				elseif ( _partyData[index]._nowHp >= 1 ) then
					_uiPartyMemberList[index]._conditionBG:SetShow( false )
					_uiPartyMemberList[index]._conditionTxt:SetShow( false )
					_uiPartyMemberList[index]._conditionTxt:SetText( "" )
				end
				-- 리더이면!
				if true == _partyData[index]._isMaster then
					_uiPartyMemberList[index]._leader:SetShow( true )
				else
					_uiPartyMemberList[index]._leader:SetShow( false )
				end

				_uiPartyMemberList[index]._base:SetShow(true)
			else
				_uiPartyMemberList[index]._base:SetShow(false)
			end
		end

		if(_preLootType ~= nil ) and (_preLootType ~= PLT2S[lootType]) then
			local rottingMsg = PAGetString( Defines.StringSheet_GAME, "PANEL_PARTY_CHANGE_LOOTING_RULE1" ) .. " " .. PLT2S[lootType] .. PAGetString( Defines.StringSheet_GAME, "PANEL_PARTY_CHANGE_LOOTING_RULE2" )
			-- 획득 방식을 변경하였습니다.
			Proc_ShowMessage_Ack(rottingMsg)
		end

		_styleLootType:SetText(PAGetString( Defines.StringSheet_GAME, "PANEL_PARTY_LOOTING_RULE" ) .. " : " .. PLT2S[lootType])		-- 획득 방식
		_preLootType = PLT2S[lootType]

		if(0 == partyMemberCount) then
			_styleLootType:SetShow(false)
			_uiComboLootingOption:SetShow(false)
			Panel_Party:SetShow(false, false)
			requestPlayerList = {}
			Panel_PartyOption:SetShow(false, false)
			-- Panel_WidgetControl_Toggle("Panel_Party", false)
		else
			_styleLootType:SetPosY(partyMemberCount*Panel_Party:GetSizeY()+20)
			_styleLootType:SetShow(true)
			_uiComboLootingOption:SetPosY(_styleLootType:GetPosY())
		end
	end
end

local messageBox_party_accept = function()
	requestPlayerList = {}
	RequestParty_acceptInvite()
end

local messageBox_party_refuse = function()
	RequestParty_refuseInvite()
end


function ResponseParty_withdraw( withdrawType, actorKey, isMe )

	-- withdrawType
	local message = ""
	if 0 == withdrawType then -- 스스로 탈퇴
		if( isMe ) then
			message = PAGetString( Defines.StringSheet_GAME, "PANEL_PARTY_LEAVE_PARTY_SELF" )
		else
			local actorProxyWrapper = getActor(actorKey)
			if ( nil ~= actorProxyWrapper ) then
				local textName = actorProxyWrapper:getName()
				message = (tostring(textName) .. PAGetString( Defines.StringSheet_GAME, "PANEL_PARTY_LEAVE_PARTY_MEMBER" ))
			end
		end
	elseif 1 == withdrawType then -- 추방

		if( isMe ) then
			message = PAGetString( Defines.StringSheet_GAME, "PANEL_PARTY_FORCEOUT_SELF" )
		else
			local actorProxyWrapper = getActor(actorKey)
			if ( nil ~= actorProxyWrapper ) then
				local textName = actorProxyWrapper:getName()
				message = (tostring(textName) .. PAGetString( Defines.StringSheet_GAME, "PANEL_PARTY_FORCEOUT_MEMBER" ))
			end
		end

	elseif 2 == withdrawType then -- 파티 해산

		message = PAGetString( Defines.StringSheet_GAME, "PANEL_PARTY_DISPERSE" )

	end

	Proc_ShowMessage_Ack( message )
	--chatting_sendMessage( "", message, CppEnums.ChatType.System )

end

function ResponseParty_changeLeader( actorKey )

	local actorProxyWrapper = getActor(actorKey)
	if ( nil == actorProxyWrapper ) then
		return
	end
	local textName = actorProxyWrapper:getName()
	Proc_ShowMessage_Ack( ( tostring(textName) .. PAGetString( Defines.StringSheet_GAME, "PANEL_PARTY_CHANGE_PARTY_LEADER" ) ) )
	ResponseParty_updatePartyList()
end

function ResponseParty_refuse(reason)
	local contentString = reason
	local messageboxData = { title = PAGetString( Defines.StringSheet_GAME, "PARTY_INVITE_MESSAGEBOX_TITLE" ), content = contentString, functionYes = MessageBox_Empty_function, priority = CppEnums.PAUIMB_PRIORITY.PAUIMB_PRIORITY_LOW}
	MessageBox.showMessageBox(messageboxData)
end

function ResponseParty_invite( hostName )
	for ii = 0, #requestPlayerList do
		if requestPlayerList[ii] == hostName then
			--_PA_LOG( "TESTAAAAa", "중복 : " .. ii .. " " .. requestPlayerList[ii] .. " : " .. #requestPlayerList )
			return
		end
	end
	
	requestPlayerList[#requestPlayerList] = hostName
	
	local messageboxMemo	= hostName .. PAGetString( Defines.StringSheet_GAME, "PANEL_PARTY_INVITE_ACCEPT" )	--"님이 파티에 초대하셨습니다. 수락하시겠습니까?"
	local messageboxData	= { title = PAGetString( Defines.StringSheet_GAME, "PARTY_INVITE_MESSAGEBOX_TITLE"), content = messageboxMemo, functionYes = messageBox_party_accept, functionNo = messageBox_party_refuse, priority = PP.PAUIMB_PRIORITY_LOW}
	MessageBox.showMessageBox(messageboxData)
end

function PartyPop_clickChangeLeader( index )
	RequestParty_changeLeader( index )
	local memberData = RequestParty_getPartyMemberAt(index)
	--Proc_ShowMessage_Ack(memberData:name()..PAGetString( Defines.StringSheet_GAME, "PANEL_PARTY_CHANGE_PARTY_LEADER" ) ) -- "님으로 파티장으로 변경되었습니다."
	closePartyOption()
end

function PartyPop_clickWithdrawMember( index )
	RequestParty_withdrawMember( index )
	Proc_ShowMessage_Ack(PAGetString( Defines.StringSheet_GAME, "PANEL_PARTY_LEAVE_PARTY_SELF" ))
	closePartyOption()
end

function messageBox_party_withdrawMember()
	local memberData = RequestParty_getPartyMemberAt(withdrawMember)
	RequestParty_withdrawMember( withdrawMember )
	Proc_ShowMessage_Ack(memberData:name().. PAGetString( Defines.StringSheet_GAME, "PANEL_PARTY_FORCEOUT_MEMBER" ))	--"님이 파티에서 추방되었습니다."
end

function PartyPop_clickBanishMember( index )
	withdrawMember = index
	local memberData = RequestParty_getPartyMemberAt(index)
	local contentString = memberData:name().. PAGetString( Defines.StringSheet_GAME, "PANEL_PARTY_FORCEOUT_QUESTION" )--"님을 파티에서 추방하시겠습니까?"
	local titleForceOut = PAGetString( Defines.StringSheet_GAME, "PANEL_PARTY_FORCEOUT" )
	local messageboxData = { title = titleForceOut, content = contentString, functionYes = messageBox_party_withdrawMember, functionCancel = MessageBox_Empty_function, priority = PP.PAUIMB_PRIORITY_LOW}
	MessageBox.showMessageBox(messageboxData)
	closePartyOption()
end

local ResponseParty_showList = function( idx )
	
	local index = _partyData[idx]._index
	local isShow = Panel_PartyOption:IsShow()
	if isShow == true and _last_Index == idx then
		closePartyOption()
	else
		-- local posY = 250 + controlTemplate._styleBackGround:GetSizeY()*(0.75*idx)
		local posY = _uiPartyMemberList[idx]._stylePartyOptionBtn:GetParentPosY() - 2
		local posX = _uiPartyMemberList[idx]._stylePartyOptionBtn:GetParentPosX() + _uiPartyMemberList[idx]._stylePartyOptionBtn:GetSizeX()
		--local posX = controlTemplate._styleBackGround:GetSizeX()
		
		if _partyData[idx]._isSelf == true then
			_uiButtonWithdrawMember:SetText(PAGetString( Defines.StringSheet_GAME, "PANEL_PARTY_SELF_OUT" ))		--파티 탈퇴
			_uiButtonWithdrawMember:addInputEvent( "Mouse_LUp", "PartyPop_clickWithdrawMember("..index..")")
			_uiButtonWithdrawMember:SetShow(true)
			_uiButtonChangeLeader:SetShow(false)

			-- 켜준다
			Panel_PartyOption:SetPosX(posX)
			Panel_PartyOption:SetPosY(posY)
			Panel_PartyOption:SetShow(true,true)

		else
			if _partyData[0]._isMaster == true then
				_uiButtonWithdrawMember:SetText(PAGetString( Defines.StringSheet_GAME, "PANEL_PARTY_MEMBER_FORCEOUT" ))		-- 파티원 추방
				_uiButtonWithdrawMember:addInputEvent( "Mouse_LUp", "PartyPop_clickBanishMember("..index..")")
				_uiButtonChangeLeader:addInputEvent( "Mouse_LUp", "PartyPop_clickChangeLeader("..index..")")
				_uiButtonChangeLeader:SetShow(true)

				-- 켜준다
				Panel_PartyOption:SetPosX(posX)
				Panel_PartyOption:SetPosY(posY)
				Panel_PartyOption:SetShow(true,true)
			else
				_uiButtonWithdrawMember:SetShow(false)
				_uiButtonChangeLeader:SetShow(false)

			end
		end
	end
	_last_Index = idx
end

function PartyPop_clickPartyOption( index )
	ResponseParty_showList( index )
end

function PartyOption_Hide()
	Panel_PartyOption:SetShow(false)
end

function PartyPop_onLootingOptionUI()
	if RequestParty_isLeader() == true then
		local lootType = RequestParty_getPartyLootType()
		_uiComboLootingOption:DeleteAllItem()
		for ii = 0, PLT.LootType_Bound-1 do
			_uiComboLootingOption:AddItem( PLT2S[ii], ii )
		end
		_uiComboLootingOption:SetSelectItemIndex(lootType)
		--Panel_Party:SetChildOrder(_styleLootType:GetKey(), _uiComboLootingOption:GetKey())

		_uiComboLootingOption:SetShow(true, false)
	end
end

function PartyPop_offLootingOptionUI()
	local list = _uiComboLootingOption:GetListControl();

	if( list:GetShow() ) then
		return
	end
	_uiComboLootingOption:SetShow(false, false)
end

function Panel_Party_ShowToggle()
	local isShow = Panel_Party:GetShow()
	if RequestParty_getPartyMemberCount() == 0 then
		return
	end
	-- UI.debugMessage(RequestParty_getPartyMemberCount())
	if isShow == true then
		Panel_Party:SetShow ( false )
		requestPlayerList = {}
	else
		Panel_Party:SetShow ( true )
	end
end

function partWidget_OnscreenEvent()
	Panel_Party:ComputePos()
	changePositionBySever(Panel_Party, CppEnums.PAGameUIType.PAGameUIPanel_Party, true, true, false)
end

function FromClient_NotifyPartyMemberPickupItem( userName, itemName )
	local message = ""
	message = PAGetStringParam2(Defines.StringSheet_GAME, "GAME_MESSAGE_NOTIFY_PARTYMEMBER_PICKUP_ITEM", "userName", userName, "itemName", itemName)
	Proc_ShowMessage_Ack(message)
end


_styleLootType			:addInputEvent("Mouse_On",	"PartyPop_onLootingOptionUI()")
_uiComboLootingOption	:addInputEvent("Mouse_LUp",	"Looting_ComboBox()" )
Panel_Party				:addInputEvent("Mouse_LUp",	"ResetPos_WidgetButton()" )			--메인UI위젯 위치 초기화

registerEvent("ResponseParty_createPartyList",	"ResponseParty_createPartyList")
registerEvent("ResponseParty_updatePartyList",	"ResponseParty_updatePartyList")
registerEvent("ResponseParty_invite",			"ResponseParty_invite")
registerEvent("ResponseParty_refuse",			"ResponseParty_refuse")
registerEvent("ResponseParty_changeLeader",		"ResponseParty_changeLeader")
registerEvent("ResponseParty_withdraw",			"ResponseParty_withdraw")
registerEvent("FromClient_GroundMouseClick",	"PartyOption_Hide")
registerEvent("onScreenResize", 				"partWidget_OnscreenEvent" )

registerEvent("FromClient_NotifyPartyMemberPickupItem", "FromClient_NotifyPartyMemberPickupItem")

ResponseParty_createPartyList()

local postFlushFunction = function()
	--파티원 체크
	if ( 0 == RequestParty_getPartyMemberCount() ) then
		Panel_Party:SetShow ( false )
		requestPlayerList = {}
	end
end

UI.addRunPostRestorFunction( postFlushFunction )					-- Flush 모드가 true에서 false가 될 때 다시 체크해줌

changePositionBySever(Panel_Party, CppEnums.PAGameUIType.PAGameUIPanel_Party, true, true, false)