---------------------------
-- Panel Init
---------------------------
Panel_Radar			:SetShow(true, false)
Panel_Radar			:SetIgnore(true)
Panel_Radar			:setGlassBackground(true)

Panel_TimeBar		:SetShow(true, false)
Panel_TimeBar		:RegisterShowEventFunc(true, " ")
Panel_TimeBar		:RegisterShowEventFunc(false, " ")
Panel_TimeBarNumber	:SetIgnore(true)

Panel_Radar			:RegisterShowEventFunc( true, 'RaderShowAni()' )
Panel_Radar			:RegisterShowEventFunc( false, 'RaderHideAni()' )

ToClient_setRadorUIPanel(Panel_Radar)
ToClient_setRadorUIViewDistanceRate( 85 * 85 )
ToCleint_InitializeRadarActorPool(1000)

---------------------------
-- Local Variablesicon_quest_accept
---------------------------
local CGT 							= CppEnums.CharacterGradeType
local UI_ANI_ADV 					= CppEnums.PAUI_ANIM_ADVANCE_TYPE
local UI_color 						= Defines.Color
local UI_TM							= CppEnums.TextMode
local UI_RT		 					= CppEnums.RegionType

local isDrag						= false
local alphaValue					= 1.0	-- 배경 알파값이 30%가 기본이다
local simpleUIAlpha 				= 0.0;

local raderText						= UI.getChildControl( Panel_Radar,		"StaticText_raderText" )
local radar_Background				= UI.getChildControl( Panel_Radar, 		"rader_background" )
local radar_SizeSlider				= UI.getChildControl( Panel_Radar, 		"Slider_MapSize" )
local radar_SizeBtn					= UI.getChildControl( radar_SizeSlider, "Slider_MapSize_Btn" )
local radar_AlphaScrl				= UI.getChildControl( Panel_Radar, 		"Slider_RadarAlpha" )
local radar_AlphaBtn				= UI.getChildControl( radar_AlphaScrl,	"RadarAlpha_CtrlBtn" )
local radar_OverName				= UI.getChildControl( Panel_Radar, 		"Static_OverName" )
local radar_MiniMapScl				= UI.getChildControl( Panel_Radar, 		"Button_SizeControl" )
local radar_regionName				= UI.getChildControl( Panel_Radar, 		"StaticText_RegionName" )
radar_regionName:SetAutoResize( true )
radar_regionName:SetNotAbleMasking( true )

local Panel_OrigSizeX				= 320 --Panel_Radar:GetSizeXOrigin()
local Panel_OrigSizeY				= 280 --Panel_Radar:GetSizeYOrigin()
local wheelCount					= 0.5		-- 0.95
local cacheSimpleUI_ShowButton 		= true;
local isMouseOn 					= false
local scaleMinValue					= 50
local scaleMaxValue 				= 150

local beforSafeZone					= false		-- 이전 지역이 안전 지역이었나?
local beforeCombatZone				= false		-- 이전 지역이 전투 지역이었나?

radar_Background:SetAlpha( 0.0 )

-- 함수 전방 선언
local RadarMap_UpdatePixelRate 		-- PixelRate가 변경 될때, 호출 된다.
-- 함수 전방 선언 끝
local radarTime =
{
	controls =
	{
		-- timeLine				= UI.getChildControl(Panel_TimeBar, "timeLine"),
		-- timeElement			= UI.getChildControl(Panel_TimeBar, "timeElement"),
		-- timeElement_right	= UI.getChildControl(Panel_TimeBar, "timeElement2"),
		iconNotice				= UI.getChildControl(Panel_TimeBar, "StaticText_Icon_Notice"),	-- 아이콘 도움말 풍선
		commandCenter			= UI.getChildControl(Panel_TimeBar, "Static_CommandCenter"),	-- 지휘소
		citadel					= UI.getChildControl(Panel_TimeBar, "Static_Citadel"),			-- 성채
		raining					= UI.getChildControl(Panel_TimeBar, "Static_Raining"),			-- 비
		siegeArea				= UI.getChildControl(Panel_TimeBar, "Static_SiegeArea" ),		-- 점령전 건물 건설 가능 여부
		regionType				= UI.getChildControl(Panel_TimeBar, "regionType"),				-- 안전 지역
		regionName				= UI.getChildControl(Panel_TimeBar, "regionName"),				-- 지역 이름
		terrainInfo				= UI.getChildControl(Panel_TimeBar, "StaticText_Terrain"),		-- 도로 위
		serverName				= UI.getChildControl(Panel_TimeBar, "StaticText_ServerName"),	-- 서버이름
		channelName				= UI.getChildControl(Panel_TimeBar, "StaticText_ChannelName"),	-- 채널이름
		gameTime				= UI.getChildControl(Panel_TimeBar, "StaticText_Time"),			-- 시간
	}
}
radarTime.controls.regionType:SetShow( false )
radarTime.controls.regionName:SetShow( false )

local UCT_STATICTEXT			= CppEnums.PA_UI_CONTROL_TYPE.PA_UI_CONTROL_STATICTEXT
local terrainNotice 			= UI.getChildControl ( Panel_Radar, "Static_Notice")
local terrainNoticeStyle		= UI.getChildControl ( Panel_Radar, "StaticText_Notice")
local terrainNoticeText			= UI.createControl( UCT_STATICTEXT, terrainNotice, "terrainNoticeText")
local textInfo					= ""
Panel_Radar:SetChildIndex( terrainNotice:GetKey(),						9999 )
CopyBaseProperty( terrainNoticeStyle, terrainNoticeText )
UI.deleteControl(terrainNoticeStyle)
terrainNoticeStyle = nil
terrainNoticeText:SetSpanSize(10,0)

-- 사용할 전역 함수들!
local floor = math.floor
local sqrt = math.sqrt

local RegionData_IngameTime = 0
local RegionData_RealIngameTime = 0
-- local RegionData_ElementWidth = radarTime.controls.timeElement:GetSizeX()
local dayCycle = 24 * 60 * 60
local QuestArrowHalfSize = 0
---------------------------
-- Functions
---------------------------
local checkLoad = function()
	local radarControl = radarMap.controls

	local SPI = radarControl.icon_SelfPlayer			-- Self Player Icon
	-- 코드에, icon_SelfPlayer 가 가로 세로가 동일한 정사각형이라고 가정하고 작성한 코드가 있다!
	UI.ASSERT(SPI:GetSizeX() == SPI:GetSizeY()			, "[Radar.lua] icon_SelfPlayer MEST BE 'square'")
end

local updateWorldMapDistance = function( mapRadius )
	local config = radarMap.config
	config.mapRadius = math.min(math.max(mapRadius, scaleMinValue), scaleMaxValue)
	radarMap.worldDistanceToPixelRate = config.mapRadiusByPixel / config.mapRadius
	ToClient_setRadorUIDistanceToPixelRate(radarMap.worldDistanceToPixelRate / 100 * 2)

	RadarMap_UpdatePixelRate()
end

function Rader_updateWorldMapDistance_Reset( )
--[[	updateWorldMapDistance(30)
	
	wheelCount = 0.7;
	radar_SizeSlider:SetControlPos( 30 )
	audioPostEvent_SystemUi(00,00)
]]--
	radarMap.config.mapRadius = radarMap.config.constMapRadius;
	FGlobal_Rader_updateWorldMapDistance_Relative( 1.3 )
end

function FGlobal_Rader_updateWorldMapDistance_Relative( value )
--	_PA_LOG("최대호", tostring( value ).." " ..tostring( radarMap.config.mapRadius * value ) )
	updateWorldMapDistance(radarMap.config.mapRadius + ( radarMap.config.constMapRadius * value ) )	
	local percents = (radarMap.config.mapRadius - scaleMinValue)
	percents = math.max(math.min(percents, 100), 0)
	radar_SizeSlider:SetControlPos( 100 - percents )
	audioPostEvent_SystemUi(00,00)
end

function FGlobal_Rader_UpdateWorldMapDistance( value )
	
end

--버튼들 정렬
local controlAlign = function()
	local scl_minus = radarMap.controls.rader_Minus
	local scl_plus = radarMap.controls.rader_Plus

	radar_SizeSlider:SetScale( radarMap.scaleRateWidth, 1.0 )	
	scl_plus:SetPosX( scl_minus:GetPosX() + scl_minus:GetSizeX() + radar_SizeSlider:GetSizeX() + 15 )

	local alpha_plus = radarMap.controls.rader_AlphaPlus
	local alpha_minus = radarMap.controls.rader_AlphaMinus	
	
	radar_AlphaScrl:SetScale( 1.0, radarMap.scaleRateHeight )	
	
	alpha_minus:SetPosY( alpha_plus:GetPosY() + radar_AlphaScrl:GetSizeY() + alpha_minus:GetSizeY() + 5 )
	
	local resetIcon = radarMap.controls.rader_Reset
	
	resetIcon:SetVerticalBottom()
	resetIcon:SetHorizonRight()
	radar_MiniMapScl:SetVerticalBottom()	
end

local MAX_WIDTH = 512
local MAX_HEIGHT = 512

--미니맵 스케일링
function FromClient_MapSizeScale()
	local origEndX = Panel_Radar:GetPosX() + Panel_Radar:GetSizeX()
	
	if( MAX_WIDTH >= origEndX - getMousePosX() and origEndX - getMousePosX() >= Panel_OrigSizeX  ) then
		Panel_Radar:SetPosX( getMousePosX() )
		Panel_Radar:SetSize( origEndX - getMousePosX(), Panel_Radar:GetSizeY() )
		
		radarMap.controls.rader_Background:SetPosX( 0 )
		radarMap.controls.rader_Background:SetSize( origEndX - getMousePosX(), Panel_Radar:GetSizeY() )
	end
	
	if(  MAX_HEIGHT >= getMousePosY() - Panel_Radar:GetPosY() and getMousePosY() - Panel_Radar:GetPosY() >= Panel_OrigSizeY ) then
		Panel_Radar:SetSize( Panel_Radar:GetSizeX(), getMousePosY() - Panel_Radar:GetPosY() )
		
		radarMap.controls.rader_Background:SetSize( Panel_Radar:GetSizeX(), getMousePosY() - Panel_Radar:GetPosY() )
	end
		
	
	radarMap.scaleRateWidth = Panel_Radar:GetSizeX() / Panel_OrigSizeX
	radarMap.scaleRateHeight = Panel_Radar:GetSizeY() / Panel_OrigSizeY	
	
	local SPI = radarMap.controls.icon_SelfPlayer
	
	local halfSelfSizeX = SPI:GetSizeX() / 2
	local halfSelfSizeY = SPI:GetSizeY() / 2
	
	local halfSizeX = Panel_Radar:GetSizeX() / 2
	local halfSizeY = Panel_Radar:GetSizeY() / 2	
	
	SPI:SetPosX( (halfSizeX - halfSelfSizeX) )
	SPI:SetPosY( (halfSizeY - halfSelfSizeY) )
	
	radarMap.pcPosBaseControl.x = SPI:GetPosX() + halfSelfSizeX
	radarMap.pcPosBaseControl.y = SPI:GetPosY() + halfSelfSizeY	
	
	ToClient_setRadorUICenterPosition( int2(radarMap.pcPosBaseControl.x, radarMap.pcPosBaseControl.y) )

	controlAlign()	
	
	NpcNavi_Reset_Posistion()		-- NPC 찾기창 위치 초기화
	Panel_Endurance_Resize()
	TownNpcIcon_Resize()
	
	ToClient_SaveUiInfo(false)
end

------------------------------------------------------------------------------
--					레이다 배경 알파 조정하는 함수
------------------------------------------------------------------------------

function Rader_IconsSetAlpha( alpha )

	local actorAlpha = math.max( math.min( alpha + 0.2, 1 ), 0.7 );
	for _,areaQuest in pairs(radarMap.areaQuests) do
		areaQuest.icon_QuestArea:SetAlpha( actorAlpha );
		areaQuest.icon_QuestArrow:SetAlpha( actorAlpha );
	end

	radarMap.controls.icon_SelfPlayer:SetAlpha(actorAlpha )

	RaderMapBG_SetAlphaValue( alphaValue );
	FGlobal_PositionGuideSetAlpha( actorAlpha);
end
function Radar_CalcAlaphValue( alpha )
	alphaValue = math.max(math.min( alpha , 1.0 ), 0.0)
	radar_AlphaScrl:SetControlPos( 100 * (1 - alphaValue) )

	alphaValue = alphaValue + ( (1 - alphaValue) * 0.5)
	return alphaValue;
end


function Rader_updateWorldMap_AlphaControl( alpha )
	alphaValue = Radar_CalcAlaphValue( 1 -radar_AlphaScrl:GetControlPos() + alpha );
	Rader_IconsSetAlpha( alphaValue )	
end

function FGlobal_ReloadRaderAlphaValue()
	alphaValue = Radar_CalcAlaphValue( alphaValue );
	Rader_IconsSetAlpha( alphaValue );
end



------------------------------------------------------------------------------
--				레이다 배경 알파 조정하는 함수 - 스크롤
------------------------------------------------------------------------------
function Rader_updateWorldMap_AlphaControl_Scrl()	
	local alphaSlideValue = 1.0 - radar_AlphaScrl:GetControlPos()
	--radarMap.controls.rader_Background:SetAlpha( alphaSlideValue )
	alphaSlideValue = Radar_CalcAlaphValue( alphaSlideValue )
	Rader_IconsSetAlpha( alphaSlideValue )
	alphaValue = alphaSlideValue
end

------------------------------------------------------------------------------
--				레이다 스케일링 함수 - 스크롤
------------------------------------------------------------------------------
function Rader_updateWorldMap_ScaleControl_Scrl()

	local scaleSlideValue = 1.0 - radar_SizeSlider:GetControlPos()
	updateWorldMapDistance(scaleMinValue + scaleSlideValue * 100)
	--updateWorldMapDistance(radarMap.config.mapRadius + scaleSlideValue * 100)
	NpcNavi_Reset_Posistion()
end

-- 레이다 스케일링이 휠 스크롤로도 가능하게
function Rader_updateWorldMap_ScaleControl_Wheel( isUp )
	if true == isUp then
		if wheelCount > 0 then
			wheelCount = wheelCount - 0.05
--			updateWorldMapDistance(scaleMinValue + wheelCount * 100)
			updateWorldMapDistance(radarMap.config.mapRadius + wheelCount * 100)
		end
	else
		if wheelCount < 1 then
			wheelCount = wheelCount + 0.05
--			updateWorldMapDistance(scaleMinValue + wheelCount * 100)
			updateWorldMapDistance(radarMap.config.mapRadius + wheelCount * 100)
		end
	end

	--local percents = (radarMap.config.mapRadius * wheelCount) / 60 * 100
	--percents = math.max(math.min(percents, 100), 0)
	local percents = wheelCount * 100
	radar_SizeSlider:SetControlPos( 100 - percents )

	NpcNavi_Reset_Posistion()
end
--------------------------------------------------------------------------------------------
-- PIN
--------------------------------------------------------------------------------------------
local pinX, pinZ
function Radar_PinUpdate( isAlways )	
	SendPingInfo_ToClient( isAlways )
end

function Radar_MouseOn()
	isMouseOn = true;	
end

function Radar_MouseOut()
	isMouseOn = false;
end

function RadarMap_Background_MouseRUp()
	local mousePosX = getMousePosX();
	local mousePosY = getMousePosY();

	local posX = mousePosX - Panel_Radar:GetPosX();
	local posZ = mousePosY - Panel_Radar:GetPosY() - Panel_Radar:GetSizeY();

	if getSelfPlayer():get():getLevel() < 11 then
		Proc_ShowMessage_Ack( "튜토리얼 진행 중에는 네비게이션을 임의로 바꾸거나 설정할 수 없습니다." )
		updateQuestWidgetList( FGlobal_QuestWidgetGetStartPosition() )	-- 의뢰 업데이트!
		updateQuestWindowList( FGlobal_QuestWindowGetStartPosition() )	-- 의뢰 업데이트!
		return
	end

	if ToClient_IsShowNaviGuideGroup(0) then
		radar_MiniMapScl:AddEffect( "fUI_Button_Hide", false, posX, posZ)
		ToClient_DeleteNaviGuideByGroup(0);
	else
		radar_MiniMapScl:AddEffect( "fUI_Button_Hide", false, posX, posZ)

		local posX = getMousePosX() - Panel_Radar:GetPosX()		-- 레이더 기준의로 좌표 변환
		local posY = getMousePosY() - Panel_Radar:GetPosY()		-- 레이더 기준으로 좌표 변환
	
		local intervalX = posX - ( radarMap.controls.icon_SelfPlayer:GetPosX() + (radarMap.controls.icon_SelfPlayer:GetSizeX() / 2))	-- 레이더 내의 포지션을 기준으로 좌표 변환
		local intervalZ = ( radarMap.controls.icon_SelfPlayer:GetPosY() + (radarMap.controls.icon_SelfPlayer:GetSizeY() / 2)) - posY
	
		intervalX = intervalX * ( 100 / ( radarMap.worldDistanceToPixelRate * 2 ) )
		intervalZ = intervalZ * ( 100 / ( radarMap.worldDistanceToPixelRate * 2 )  )
	
		local selfPosition = getSelfPlayer():get3DPos();
	-- * 100의 이유는 Radar의 축적이  1 : 100이다.(미터)
		local float3Pos = float3(selfPosition.x + intervalX,		-- X 좌표를 월드로 변환
							0,													-- Y는 쓰지 않는다
							selfPosition.z + intervalZ	)
		
--		posX =  (mousePosX - (Panel_Radar:GetPosX() + Panel_Radar:GetSizeX() / 2.0)) * 12800.0 / 255;
--		posZ = -(mousePosY - (Panel_Radar:GetPosY() + Panel_Radar:GetSizeY() / 2.0)) * 12800.0 / 255;
		
--		selfPosition.x = selfPosition.x + posX;
--		selfPosition.z = selfPosition.z + posZ;
		float3Pos.y = selfPosition.y
		ToClient_WorldMapNaviStart( float3Pos, NavigationGuideParam(), false, true );
		audioPostEvent_SystemUi(00,14)
	end
end

local controlInit = function()
	-- Radar
	-- Panel_Radar:SetIgnore(true)	
	local radarControl = radarMap.controls
	radarControl.timeNum:SetShow(false)		-- 시간 숫자는 최초에 꺼진 상태
	radarControl.timeNum:SetIgnore(true)

	local SPI = radarControl.icon_SelfPlayer	-- Self Player Icon
	
	radarMap.pcPosBaseControl.x = SPI:GetPosX() + SPI:GetSizeX() / 2
	radarMap.pcPosBaseControl.y = SPI:GetPosY() + SPI:GetSizeY() / 2	
	ToClient_setRadorUICenterPosition( int2(radarMap.pcPosBaseControl.x, radarMap.pcPosBaseControl.y) )

	FGlobal_Rader_updateWorldMapDistance_Relative( 1.3 )
--	updateWorldMapDistance(radarMap.config.mapRadius)

	radarTime.controls.terrainInfo:addInputEvent("Mouse_On", "TerrainInfo_ShowBubble(true)")
	radarTime.controls.terrainInfo:addInputEvent("Mouse_Out", "TerrainInfo_ShowBubble(false)")
	
	radarTime.controls.raining:addInputEvent("Mouse_On", 		"Rader_Icon_Help_BubbleShowFunc(".. 0 .. ", true )")
	radarTime.controls.raining:addInputEvent("Mouse_Out", 		"Rader_Icon_Help_BubbleShowFunc(".. 0 .. ", false )")
	radarTime.controls.citadel:addInputEvent("Mouse_On", 		"Rader_Icon_Help_BubbleShowFunc(".. 1 .. ", true )")
	radarTime.controls.citadel:addInputEvent("Mouse_Out", 		"Rader_Icon_Help_BubbleShowFunc(".. 1 .. ", false )")
	radarTime.controls.siegeArea:addInputEvent("Mouse_On", 		"Rader_Icon_Help_BubbleShowFunc(".. 2 .. ", true )")
	radarTime.controls.siegeArea:addInputEvent("Mouse_Out", 	"Rader_Icon_Help_BubbleShowFunc(".. 2 .. ", false )")
	
	-- radarTime.controls.commandCenter:addInputEvent("Mouse_On", 	"Rader_Icon_Help_BubbleShowFunc(".. 2 .. ", true )")
	-- radarTime.controls.commandCenter:addInputEvent("Mouse_Out", "Rader_Icon_Help_BubbleShowFunc(".. 2 .. ", false )")
	
	-- 매 프레임 업데이트 함수
	Panel_Radar:RegisterUpdateFunc( "RadarMap_UpdatePerFrame" )

	radarControl.rader_Plus			:addInputEvent("Mouse_LUp",		"FGlobal_Rader_updateWorldMapDistance_Relative(-0.1)")
	radarControl.rader_Minus		:addInputEvent("Mouse_LUp",		"FGlobal_Rader_updateWorldMapDistance_Relative(0.1)")
	radar_SizeBtn					:addInputEvent("Mouse_LPress",	"Rader_updateWorldMap_ScaleControl_Scrl()")
	radar_SizeSlider				:addInputEvent("Mouse_LPress",	"Rader_updateWorldMap_ScaleControl_Scrl()")
	
	radarControl.rader_AlphaPlus	:addInputEvent("Mouse_LUp",		"Rader_updateWorldMap_AlphaControl(0.05)")
	radarControl.rader_AlphaMinus	:addInputEvent("Mouse_LUp",		"Rader_updateWorldMap_AlphaControl(-0.05)")
	radar_AlphaBtn					:addInputEvent("Mouse_LPress",	"Rader_updateWorldMap_AlphaControl_Scrl()")
	radar_AlphaScrl					:addInputEvent("Mouse_LPress",	"Rader_updateWorldMap_AlphaControl_Scrl()")
	radar_AlphaScrl					:SetControlPos( 100 - (alphaValue * 100) )
	
	radarControl.rader_Reset:addInputEvent("Mouse_LUp", "Rader_updateWorldMapDistance_Reset()")
	radarControl.rader_Close:addInputEvent("Mouse_LDown", "Panel_Radar_ShowToggle()")
	radarControl.rader_NpcFind_Toggle:addInputEvent("Mouse_LDown", "NpcNavi_ShowToggle()")	--NPC 찾기
	radarControl.rader_NpcFind_Toggle:SetShow( true )
	radarControl.rader_Background:SetSize(  Panel_Radar:GetSizeX(), Panel_Radar:GetSizeY() )
	radarControl.rader_Background:addInputEvent("Mouse_LDown", 		"Radar_PinUpdate(false)")
	radarControl.rader_Background:addInputEvent("Mouse_LDClick", 	"Radar_PinUpdate(true)")
	radarControl.rader_Background:addInputEvent("Mouse_UpScroll",	"FGlobal_Rader_updateWorldMapDistance_Relative(-0.1)"	)
	radarControl.rader_Background:addInputEvent("Mouse_RUp",		"RadarMap_Background_MouseRUp()"	)	
	radarControl.rader_Background:addInputEvent("Mouse_DownScroll",	"FGlobal_Rader_updateWorldMapDistance_Relative(0.1)"	)
	radar_MiniMapScl:addInputEvent( "Mouse_LPress", "FromClient_MapSizeScale()" )
	
	controlAlign()

	RadarMap_Init()
	Panel_Radar:ChangeSpecialTextureInfoName( "New_UI_Common_forLua/Widget/Rader/Minimap_Mask.dds" )
	Panel_Radar:setMaskingChild(true)
	
	radarControl.rader_Plus:SetNotAbleMasking( true )
	radarControl.rader_Minus:SetNotAbleMasking( true )
	radar_SizeBtn:SetNotAbleMasking(true)
	radar_SizeSlider:SetNotAbleMasking(true)
	radarControl.rader_AlphaPlus:SetNotAbleMasking( true )
	radarControl.rader_AlphaMinus:SetNotAbleMasking( true )
	radar_AlphaBtn:SetNotAbleMasking( true )
	radar_AlphaScrl:SetNotAbleMasking( true )
	radarControl.rader_Reset:SetNotAbleMasking( true )
	radarControl.rader_Close:SetNotAbleMasking( true )
	radarControl.rader_NpcFind_Toggle:SetNotAbleMasking( true )
	radar_MiniMapScl:SetNotAbleMasking(true)

	radarControl.rader_Plus:SetAlpha( 0.0 )
	radarControl.rader_Minus:SetAlpha( 0.0 )
	radar_SizeBtn:SetAlpha( 0.0 )
	radar_SizeSlider:SetAlpha( 0.0 )
	radarControl.rader_AlphaPlus:SetAlpha( 0.0 )
	radarControl.rader_AlphaMinus:SetAlpha( 0.0 )
	radar_AlphaBtn:SetAlpha( 0.0 )
	radar_AlphaScrl:SetAlpha( 0.0 )
	radarControl.rader_Reset:SetAlpha( 0.0 )
	radarControl.rader_Close:SetAlpha( 0.0 )
	radarControl.rader_NpcFind_Toggle:SetAlpha( 0.0 )
	radar_MiniMapScl:SetAlpha( 0.0 )


	Rader_updateWorldMap_AlphaControl( 0 )
end



local weatherTooltip	= 0
local buildingTooltip	= 0
local siegeTooltip		= 0
function Rader_Icon_Help_BubbleShowFunc( iconNo, isOn )
	if iconNo == 0 then
		if 0 == weatherTooltip then
			name = "날씨 : 비"
			desc = PAGetString(Defines.StringSheet_GAME, "LUA_RADER_REDUCED_DAMAGE_REASON_RAIN")
			uiControl = radarTime.controls.raining
		else
			name = "날씨 : 맑음"
			desc = "날씨가 맑아 전투에 영향을 끼치는 요소가 없습니다."
			uiControl = radarTime.controls.raining
		end
	elseif iconNo == 1 then
		if 1 == buildingTooltip or 2 == buildingTooltip then
			name = "점령전 가능 지역"
			desc = "점령전 시 PvP가 가능해지는 지역입니다."
			-- desc = PAGetString(Defines.StringSheet_GAME, "LUA_Rader_CAN_BUILD_ACROPOLIS")
			uiControl = radarTime.controls.citadel
		else
			name = "점령전 불가 지역"
			desc = "점령전이 진행되지 않는 지역입니다."
			uiControl = radarTime.controls.citadel
		end
	elseif iconNo == 2 then
		if 0 == siegeTooltip then
			name = "성채 건설 가능 지역"
			desc = "성채를 지을 수 있는 지역입니다."
			uiControl = radarTime.controls.siegeArea
		elseif 1 == siegeTooltip then
			name = "지휘소 건설 가능 지역"
			desc = "지휘소를 지을 수 있는 지역입니다."
			uiControl = radarTime.controls.siegeArea
		else
			name = "건설 불가 지역"
			desc = "점령전용 건물을 지을 수 없는 지역입니다."
			uiControl = radarTime.controls.siegeArea
		end
	end

	if isOn == true then
		TooltipSimple_Show( uiControl, name, desc )
	else
		TooltipSimple_Hide()
	end
end

function TerrainInfo_ShowBubble(isShow)

	local terraintype = selfPlayerNaviMaterial()
	local radarControl = radarTime.controls

	if terraintype == 0 then
		textInfo = PAGetString( Defines.StringSheet_GAME, "LUA_RADAR_TERRAININFO_NORMAL" )
		roadInfo = PAGetString(Defines.StringSheet_GAME, "LUA_RADAR_TERRAINTYPE_NORMAL" )
	elseif terraintype == 1 then
		textInfo = PAGetString( Defines.StringSheet_GAME, "LUA_RADAR_TERRAININFO_ROAD")
		roadInfo = PAGetString(Defines.StringSheet_GAME, "LUA_RADAR_TERRAINTYPE_ROAD" )
	elseif terraintype == 2 then
		textInfo = PAGetString( Defines.StringSheet_GAME, "LUA_RADAR_TERRAININFO_SNOW")
		roadInfo = PAGetString(Defines.StringSheet_GAME, "LUA_RADAR_TERRAINTYPE_SNOW" )
	elseif terraintype == 3 then
		textInfo = PAGetString( Defines.StringSheet_GAME, "LUA_RADAR_TERRAININFO_DESERT")
		roadInfo = PAGetString(Defines.StringSheet_GAME, "LUA_RADAR_TERRAINTYPE_DESERT" )
	elseif terraintype == 4 then
		textInfo = PAGetString( Defines.StringSheet_GAME, "LUA_RADAR_TERRAININFO_SWAMP")
		roadInfo = PAGetString(Defines.StringSheet_GAME, "LUA_RADAR_TERRAINTYPE_SWAMP" )
	elseif terraintype == 5 then
		textInfo = PAGetString( Defines.StringSheet_GAME, "LUA_RADAR_TERRAININFO_OBJECT")
		roadInfo = PAGetString(Defines.StringSheet_GAME, "LUA_RADAR_TERRAINTYPE_OBJECT" )
	elseif terraintype == 6 then
		textInfo = PAGetString( Defines.StringSheet_GAME, "LUA_RADAR_TERRAININFO_WATER")
		roadInfo = PAGetString(Defines.StringSheet_GAME, "LUA_RADAR_TERRAINTYPE_WATER" )
	elseif terraintype == 7 then
		textInfo = PAGetString( Defines.StringSheet_GAME, "LUA_RADAR_TERRAININFO_GRASS")
		roadInfo = PAGetString(Defines.StringSheet_GAME, "LUA_RADAR_TERRAINTYPE_GRASS" )
	elseif terraintype == 8 then
		textInfo = PAGetString( Defines.StringSheet_GAME, "LUA_RADAR_TERRAININFO_DEEPWATER")
		roadInfo = PAGetString(Defines.StringSheet_GAME, "LUA_RADAR_TERRAINTYPE_DEEPWATER" )
	elseif terraintype == 9 then
		textInfo = PAGetString( Defines.StringSheet_GAME, "LUA_RADAR_TERRAININFO_AIR")
		roadInfo = PAGetString(Defines.StringSheet_GAME, "LUA_RADAR_TERRAINTYPE_AIR" )
	else
		textInfo = PAGetString( Defines.StringSheet_GAME, "LUA_RADAR_TERRAININFO_NORMAL")
		roadInfo = PAGetString(Defines.StringSheet_GAME, "LUA_RADAR_TERRAINTYPE_NORMAL" )
	end


	name = roadInfo
	desc = textInfo
	uiControl = radarTime.controls.terrainInfo

	if true == isShow then
		TooltipSimple_Show( uiControl, name, desc )
	else
		TooltipSimple_Hide()
	end	
	-- local radarControl = radarTime.controls
	-- terrainNoticeText:SetTextMode( UI_TM.eTextMode_AutoWrap )
	-- terrainNoticeText:SetAutoResize( true )
	-- terrainNotice:SetPosX(radarControl.terrainInfo:GetPosX() + 50)
	-- terrainNotice:SetPosY(radarControl.terrainInfo:GetPosY() + 10)
	-- if isShow == true then
	-- 	terrainNoticeText:SetText(textInfo)
	-- 	terrainNotice:SetSize(terrainNoticeText:GetSizeX()+20, terrainNoticeText:GetSizeY()+2)
	-- 	terrainNotice:SetShow(true)
	-- else
	-- 	terrainNotice:SetShow(false)
	-- end
end

function RaderShowAni()
	Panel_Radar:SetShowWithFade(CppEnums.PAUI_SHOW_FADE_TYPE.PAUI_ANI_TYPE_FADE_IN)

	local MainStatusOpen_Alpha = Panel_Radar:addColorAnimation( 0.0, 0.35, UI_ANI_ADV.PAUI_ANIM_ADVANCE_SIN_HALF_PI)
	MainStatusOpen_Alpha:SetStartColor( UI_color.C_00FFFFFF )
	MainStatusOpen_Alpha:SetEndColor( UI_color.C_FFFFFFFF )
	MainStatusOpen_Alpha.IsChangeChild = true
end


function RaderHideAni()
	Panel_Radar:SetShowWithFade(CppEnums.PAUI_SHOW_FADE_TYPE.PAUI_ANI_TYPE_FADE_OUT)
	local MainStatusOpen_Alpha = Panel_Radar:addColorAnimation( 0.0, 0.25, UI_ANI_ADV.PAUI_ANIM_ADVANCE_SIN_HALF_PI)
	MainStatusOpen_Alpha:SetStartColor( UI_color.C_FFFFFFFF )
	MainStatusOpen_Alpha:SetEndColor( UI_color.C_00FFFFFF )
	MainStatusOpen_Alpha.IsChangeChild = true
	MainStatusOpen_Alpha:SetHideAtEnd(true)
	MainStatusOpen_Alpha:SetDisableWhileAni(true)
end

function SortRador_IconIndex()
	-- 버튼을 퀘스트 영역보다 위로 한다.
	local mapButton = radarMap.controls
	Panel_Radar:SetChildIndex( radar_SizeSlider:GetKey(),						9999 )
	Panel_Radar:SetChildIndex( radar_AlphaScrl:GetKey(),						9999 )
	Panel_Radar:SetChildIndex( mapButton.rader_Reset:GetKey(),					9999 )
	Panel_Radar:SetChildIndex( mapButton.rader_NpcFind_Toggle:GetKey(),			9999 )
	Panel_Radar:SetChildIndex( radar_MiniMapScl:GetKey(),						9999 )
end

-- Static 을 Pool 로 관리한다. Pool 에서 꺼내오거나, Pool 이 비었으면 새로 생성한다.
function radarMap:getIdleIcon()
	local iconPool = self.iconPool
	if 0 < iconPool:length() then
		return iconPool:pop_back()
	else
		self.iconCreateCount = self.iconCreateCount + 1
		local make_Icon = UI.createControl( CppEnums.PA_UI_CONTROL_TYPE.PA_UI_CONTROL_STATIC, Panel_Radar, "Static_Icon_" .. self.iconCreateCount )
		-- Panel_Radar:SetChildIndex(make_Icon:GetKey(), 8000 )
		return make_Icon
	end
end


-- Static 을 Pool 에 넣는다.
function radarMap:returnIconToPool( icon )
	UI.ASSERT( (nil ~= icon) and (icon.__name == 'PAUIPureStatic'),			'[Radar.lua] PAUIPureStatic 이 아닌데, 풀에 반납 되었다!!')		-- 서비스 버전에서는 제거해야 하는 코드입니다.!
	self.iconPool:push_back( icon )
end


function radarMap:getIdleQuest()
	local questPool = self.questIconPool
	if 0 < questPool:length() then
		return questPool:pop_back()
	else
		self.questCreateCount = self.questCreateCount + 1

		local iconQuestArea = UI.createControl( CppEnums.PA_UI_CONTROL_TYPE.PA_UI_CONTROL_STATIC, Panel_Radar, "Static_QuestArea_" .. self.questCreateCount )
		local iconQuestArrow = UI.createControl( CppEnums.PA_UI_CONTROL_TYPE.PA_UI_CONTROL_STATIC, Panel_Radar, "Static_QuestArrow_" .. self.questCreateCount )

		CopyBaseProperty( self.template.area_quest,				iconQuestArea	)
		CopyBaseProperty( self.template.area_quest_guideArrow,	iconQuestArrow	)

		iconQuestArea:SetShow( false )
		iconQuestArrow:SetShow( false )

		iconQuestArea:SetSize( self.template.area_quest:GetSizeX(), self.template.area_quest:GetSizeY() )

		iconQuestArrow:SetPosX( self.pcPosBaseControl.x - iconQuestArrow:GetSizeX() / 2 )
		iconQuestArrow:SetPosY( self.pcPosBaseControl.y - iconQuestArrow:GetSizeY() / 2 )
		iconQuestArrow:SetSize( self.template.area_quest_guideArrow:GetSizeX(), self.template.area_quest_guideArrow:GetSizeY() )
		QuestArrowHalfSize = iconQuestArrow:GetSizeY() / 2
		
		local questIcon =
		{
			icon_QuestArea = iconQuestArea,
			icon_QuestArrow = iconQuestArrow,
		}
		return questIcon
	end
end

-- Static 을 Pool 에 넣는다.
function radarMap:returnQuestToPool( questIcon )
	-- UI.ASSERT( (nil ~= quest) and (quest.__name == 'PAUIPureStatic'),			'[Radar.lua] PAUIPureStatic 이 아닌데, 풀에 반납 되었다!!')		-- 서비스 버전에서는 제거해야 하는 코드입니다.!
	self.questIconPool:push_back( questIcon )
end

---------------------------------------------------------------------------------------------------------------------
--- 패널의 드래그 설정 -------------------------------------------------------------------------------------------------
---------------------------------------------------------------------------------------------------------------------

	-- Panel_Radar:SetDragEnable( true )

---------------------------------------------------------------------------------------------------------------------
-- 패널 및 지역명, 지역 타입, 서버시간 및 타임바 표시 관련 -------------------------------------------------------------------
---------------------------------------------------------------------------------------------------------------------
-- \brief 서버시간 표시/타임바 Toggle
-- function RadarTimeBar_ShowToggle( isShow )
	-- local radarTimeControl = radarTime.controls

	-- radarTimeControl.timeLine:SetShow(not isShow)
	-- radarTimeControl.timeElement:SetShow(not isShow)
	-- radarTimeControl.timeElement_right:SetShow(not isShow)
	
	
	-- if ( isShow ) then
		-- Panel_TimeBar:SetAlpha(0.0)
		-- Panel_TimeBarNumber:SetAlpha(0.0)
	-- else
		-- Panel_TimeBar:SetAlpha(1.0)
		-- Panel_TimeBarNumber:SetAlpha(1.0)
	-- end

	-- Panel_TimeBarNumber:SetPosX(Panel_TimeBar:GetPosX())
	-- Panel_TimeBarNumber:SetPosY(Panel_TimeBar:GetPosY())
	-- radarMap.controls.timeNum:SetShow(isShow)
-- end
function Panel_TimeBar_ShowToggle()
	local isShow = Panel_TimeBar:IsShow()
	if isShow then
		Panel_TimeBarNumber:SetShow( false )
		Panel_TimeBar:SetShow( false )
	else
		-- Panel_TimeBarNumber:SetShow( true )
		Panel_TimeBar:SetShow( true )
	end
end

-- \brief 지역명 갱신
function RadarMap_updateRegion(regionData)
	if nil == regionData then
		return
	end

	local radarControl = radarTime.controls

	local isArenaZone = regionData:get():isArenaZone() 								-- 결투장
	local isSafetyZone = regionData:get():isSafeZone()								-- 안전지역 여부 출력
	
	if isSafetyZone then
		radar_regionName:SetFontColor(4285975295)
		-- radarControl.regionName:SetFontColor(4285975295)
		-- radarControl.regionType:SetText(PAGetString( Defines.StringSheet_GAME, "PANEL_RADER_SAFETY_ZONE" ))		--'안전지역'
		if true == beforeCombatZone then	-- 이전 지역이 안전/결투 지역이었는데, 전투 지역으로 이동했으면;
			local msg = { main = "안전 지역에 진입했습니다.", sub = "" }
			Proc_ShowMessage_Ack_WithOut_ChattingMessage_For_RewardSelect( msg, 6, 0)
		end
		beforSafeZone = true
		beforeCombatZone = false 

	elseif isArenaZone then
		radar_regionName:SetFontColor(4294954530)
		-- radarControl.regionName:SetFontColor(4294954530)
		-- radarControl.regionType:SetText(PAGetString( Defines.StringSheet_GAME, "PANEL_RADER_PvP_ZONE" ))		--'결투지역'
		beforSafeZone = false
		beforeCombatZone = false
	else
		radar_regionName:SetFontColor(4294926175)
		-- radarControl.regionName:SetFontColor(4294926175)
		-- radarControl.regionType:SetText(PAGetString( Defines.StringSheet_GAME, "PANEL_RADER_BATTLE_ZONE" ))		--'전투지역'
		
		if true == beforSafeZone then	-- 이전 지역이 안전/결투 지역이었는데, 전투 지역으로 이동했으면;
			local msg = { main = "전투 지역에 진입했습니다.", sub = "" }
			Proc_ShowMessage_Ack_WithOut_ChattingMessage_For_RewardSelect( msg, 6, 1)
		end
		beforSafeZone = false
		beforeCombatZone = true
	end

	-- radarControl.regionName:SetText( regionData:getAreaName() )				-- 지역명 출력
	radar_regionName:SetText( regionData:getAreaName() )						-- 지역명 출력
	radar_regionName:SetSize( radar_regionName:GetTextSizeX() + 40, radar_regionName:GetSizeY() + 3 )
	radar_regionName:ComputePos()
	radarMap.regionTypeValue = regionData:get():getRegionType()
end
-- \brief 시간 갱신(매 프레임 호출된다)
local _nightCheck = 0
local _nightAlertCheck = 0
function RadarMap_UpdateTimePerFrame()
	local ingameTime = getIngameTime_variableSecondforLua()
	if ingameTime < 0 then
		return
	end
	
	if ( dayCycle < ingameTime ) then
		ingameTime = ingameTime % dayCycle
	end

	if ( ingameTime ~= RegionData_IngameTime ) then
		RegionData_IngameTime = ingameTime

		local minute = ( floor(ingameTime/60) % 60 )
		local hour = floor( ingameTime / 3600 )

		local calcMinute = "00"
		if minute < 10 then
			calcMinute = "0" .. minute
		else
			calcMinute = tostring(minute)
		end

		local radarControl = radarTime.controls
		if hour == 12 then
			radarControl.gameTime:SetText( 'PM ' .. tostring(hour) .. ' : ' .. calcMinute )
		elseif hour == 0 then
			local calcHour = hour + 12
			radarControl.gameTime:SetText( 'AM ' .. tostring(calcHour) .. ' : ' .. calcMinute )
		elseif hour == 24 then
			local calcHour = hour
			radarControl.gameTime:SetText( 'AM ' .. "0" .. ' : ' .. calcMinute )
		elseif hour > 11 then
			local calcHour = hour - 12
			radarControl.gameTime:SetText( 'PM ' .. tostring(calcHour) .. ' : ' .. calcMinute )
		else
			radarControl.gameTime:SetText( 'AM ' .. tostring(hour) .. ' : ' .. calcMinute )
		end
	end



	------------------------------------------------------------
	local radarTimeControl = radarTime.controls
	local realInGameTime = getIngameTime_minute()

	if ( RegionData_RealIngameTime ~= realInGameTime ) then
		if ( 24 * 60 < realInGameTime ) then
			realInGameTime = realInGameTime % (24 * 60)
		end
		local minute = floor( realInGameTime % 60 )
		local hour = floor( realInGameTime / 60 )

		if ( 22 == hour ) and ( 0 == minute / 60 ) then				-- 밤 10시가 되면
			_nightCheck = 22
			if ( _nightCheck ~= _nightAlertCheck ) then
				Night_Alert( _nightCheck )
				_nightAlertCheck = _nightCheck
			end
		end
		
		if ( 2 == hour ) and ( 0 == minute / 60 ) then				-- 새벽 2시가 되면
			_nightCheck = 2
			if ( _nightCheck ~= _nightAlertCheck ) then
				Night_Alert( _nightCheck )
				_nightAlertCheck = _nightCheck
			end
		end
	end
end

-------------------------------------------------------------------
-- 밤 10시, 새벽 7시 메시지 세팅
-------------------------------------------------------------------
Panel_Rader_NightAlert:SetShow(false, false)
Panel_Rader_NightAlert:setMaskingChild(true)

Panel_Rader_NightAlert:RegisterShowEventFunc( true, 'Rader_NightAlert_ShowAni()' )
Panel_Rader_NightAlert:RegisterShowEventFunc( false, 'Rader_NightAlert_HideAni()' )

local Night_AlertPanel = UI.getChildControl( Panel_Rader_NightAlert, "Static_AlertPanel" )
local Night_AlertText = UI.getChildControl( Panel_Rader_NightAlert, "StaticText_Alert_NoticeText" )

function Night_Alert( _nightCheck )
	local message = ""
	if ( 22 == _nightCheck ) then
		Night_AlertText:SetText( PAGetString(Defines.StringSheet_GAME, "PANEL_RADER_NIGHT_ALERT_TEXT1") ) -- 밤 10시가 되자 몬스터가 흉포해집니다. 몬스터의 공격력이 증가하지만, 획득 경험치도 늘어납니다.
	elseif ( 2 == _nightCheck ) then
		Night_AlertText:SetText( PAGetString(Defines.StringSheet_GAME, "PANEL_RADER_NIGHT_ALERT_TEXT2") ) -- 오전 7시가 되니 몬스터가 힘을 잃고 원래의 상태로 돌아갑니다.
	else
		return
	end
	Panel_Rader_NightAlert:SetShow( true, true )
	Night_AlertPanel:SetShow( true )
end

local _cumulateTime = 0
function Rader_NightAlert_Close ( fDeltaTime )
	_cumulateTime = _cumulateTime + fDeltaTime
	if _cumulateTime >= 9.0 then
		Panel_Rader_NightAlert:SetShow( false, true )
		_cumulateTime = 0
	end
end
Panel_Rader_NightAlert:RegisterUpdateFunc("Rader_NightAlert_Close")

function Rader_NightAlert_ShowAni()
	audioPostEvent_SystemUi(01,09)
	UIAni.fadeInSCR_MidOut( Panel_Rader_NightAlert )
end

function Rader_NightAlert_HideAni()
	-- 꺼준다
	Panel_Rader_NightAlert:SetShowWithFade(CppEnums.PAUI_SHOW_FADE_TYPE.PAUI_ANI_TYPE_FADE_OUT)
	local aniInfo6 = Panel_Rader_NightAlert:addColorAnimation( 0.0, 1.5, UI_ANI_ADV.PAUI_ANIM_ADVANCE_COS_HALF_PI)
	aniInfo6:SetStartColor( UI_color.C_FFFFFFFF )
	aniInfo6:SetEndColor( UI_color.C_00FFFFFF )
	aniInfo6.IsChangeChild = true
	aniInfo6:SetHideAtEnd(true)
	aniInfo6:SetDisableWhileAni(true)
end

---------------------------------------------------------------------------------------------------------------------
-- 레이더 및 각종 아이콘 표시 관련 ---------------------------------------------------------------------------------------
---------------------------------------------------------------------------------------------------------------------
-- \brief PC 정보 갱신. Ratation 변경. (매 프레임 호출된다)
local RadarMap_UpdateSelfPlayerPerFrame = function()
	local selfPlayerWrapper = getSelfPlayer()
	if nil == selfPlayerWrapper then
		return
	end
	local selfPlayer = selfPlayerWrapper:get()

	if nil == selfPlayer then
			return;
	end

	local selfPlayerIcon = radarMap.controls.icon_SelfPlayer
	-- selfPlayerIcon:SetRotate( selfPlayer:getRotation() ) 케릭터 방향에서 Camera 방향으로 변환
	selfPlayerIcon:SetRotate( getCameraRotation() )	

	-- 매 프레임 현재 위치를 갱신해준다!
	local pcInfo = radarMap.pcInfo
	local selfPlayerPos = pcInfo.position
	selfPlayerPos.x = selfPlayer:getPositionX()
	selfPlayerPos.y = selfPlayer:getPositionY()
	selfPlayerPos.z = selfPlayer:getPositionZ()

	pcInfo.s64_teamNo = selfPlayerWrapper:getTeamNo_s64()
end
-- Actor 위치를 컨트롤 위치로 변경해준다. PC 와의 Distance 를 체크해서 일정 거리 이상은 뿌리지 않도록 처리한다.
-- Panel_worldMap.lua : WorldMap_UpdateOtherActor에서 사용 ( 리소스 공유 )
local getPosBaseControl = function( actorPosition )	-- pa::float3
	local selfPlayerPos = radarMap.pcInfo.position
	local selfPlayerControlPos = radarMap.pcPosBaseControl

	local dx = (actorPosition.x - selfPlayerPos.x) / 100
	local dz = (selfPlayerPos.z - actorPosition.z) / 100		-- Z 축은 World 좌표와 Screen 좌표가 방향이 반대이다.

	local distance = sqrt( dx * dx + dz * dz )

	local dxPerPixel = dx * radarMap.worldDistanceToPixelRate + selfPlayerControlPos.x
	local dyPerPixel = dz * radarMap.worldDistanceToPixelRate + selfPlayerControlPos.y

	return (distance < radarMap.config.mapRadius), dxPerPixel, dyPerPixel
end


local getPosQuestControl = function( areaQuest )
	local selfPlayerPos = radarMap.pcInfo.position
	local selfPlayerControlPos = radarMap.pcPosBaseControl

	-- position 은 CM 단위. M 로 변환을 위해 100 을 나눈다
	local dx = (areaQuest.x - selfPlayerPos.x) / 100
	local dz = (selfPlayerPos.z - areaQuest.z) / 100		-- Z 축은 World 좌표와 Screen 좌표가 방향이 반대이다.

	local distance = sqrt( dx * dx + dz * dz )

	local dxPerPixel = dx * radarMap.worldDistanceToPixelRate * 2 + selfPlayerControlPos.x
	local dyPerPixel = dz * radarMap.worldDistanceToPixelRate * 2 + selfPlayerControlPos.y

	-- TRadius 는 cm 단위. M 로 변환을 위해, 100 으로 나눠준다.
	return (distance <= (radarMap.config.mapRadius + areaQuest.radius / 100)), dxPerPixel, dyPerPixel
end


-- Actor 에 따른 아이콘 종류를 찾는다.
-- 여기의 조건에 해당하지 않는 것들은 아이콘이 나오지 않을 것이다!
-- Panel_worldMap.lua : WorldMap_UpdateOtherActor에서 사용 ( 리소스 공유 )

getActorIcon = function( actorProxyWrapper, actorData )

	if( nil == getSelfPlayer() ) then
		return
	end

	local actorProxy = actorProxyWrapper:get()
	local template = radarMap.template
	if actorProxy:isMonster() then
		-- UI.debugMessage( 'isMonster' )
		local characterWrapper = actorData:getCharacterActorProxyWrapper()
		if characterWrapper:getTeamNo_s64() == radarMap.pcInfo.s64_teamNo then
			return template.icon_Horse			-- 소환수
		end
		local isQuestMonster = radarMap_IsQuestMonster( characterWrapper:get():getCharacterStaticStatus() )
		-- UI.debugMessage( tostring(actorProxyWrapper:getActorKey()) .. '/' .. tostring(isQuestMonster) )
		local gradeType = characterWrapper:getCharacterGradeType()
		-- if CGT.CharacterGradeType_Hero == gradeType then
			-- gradeType = CGT.CharacterGradeType_Normal
		-- end
		if (CGT.CharacterGradeType_Normal == gradeType) or (CGT.CharacterGradeType_Assistant == gradeType) or (CGT.CharacterGradeType_Hero == gradeType) or (CGT.CharacterGradeType_Legend == gradeType) then
			if isQuestMonster then
				return template.icon_Monster_general_quest
			else
				return template.icon_Monster_general_normal
			end
		-- 히어로 타입은 단순히 구분짓기 위해 들어간 것! 레이더 아이콘 구분이 필요해지면 풀어준다!!!!, 레전드 타입은 현재 안 씀!
		elseif (CGT.CharacterGradeType_Elite == gradeType) then
			if isQuestMonster then
				return template.icon_Monster_named_quest
			else
				return template.icon_Monster_named_normal
			end
		elseif CGT.CharacterGradeType_Boss == gradeType then
			if isQuestMonster then
				return template.icon_Monster_boss_quest
			else
				return template.icon_Monster_boss_normal
			end
		end
	elseif actorProxy:isNpc() then
		local characterStaticStatus = actorData:getCharacterActorProxyWrapper():get():getCharacterStaticStatus()

		if (false == checkActiveCondition(actorData:getCharacterActorProxyWrapper():getCharacterKey()) ) then
			return template.icon_NPC_unknown
		elseif characterStaticStatus:isSkillTrainer() then
			return template.icon_NPC_trainner
		elseif characterStaticStatus:isItemRepairer() then
			return template.icon_NPC_itemRepairer
		elseif characterStaticStatus:isShopMerchant() or characterStaticStatus:isTradeMerchant() then
			return template.icon_NPC_liquidStore
		elseif characterStaticStatus:isImportantNpc() then
			return template.icon_NPC_talkable
		end
	elseif actorProxy:isPlayer() then
		-- UI.debugMessage( 'isPlayer' )
		local selfPlayer = getSelfPlayer()
		if selfPlayer:isPartyMemberActorKey( actorProxyWrapper:getActorKey() ) then
			return template.icon_Party
		elseif selfPlayer:isGuildMemberActorKey( actorProxyWrapper:getActorKey() ) then
			return template.icon_Guild
		else
			return template.icon_Player
		end
	-- elseif actorProxy:isAlterego() then
	elseif actorProxy:isVehicle() then
		local vehicleActorProxy = actorData:getVehicleActorProxyWrapper():get()
		if vehicleActorProxy:isSelfVehicle() and (not vehicleActorProxy:hasRider()) then
			return template.icon_Horse
		end
	elseif actorProxy:isHouseHold() then
		local householdActorProxy = actorData:getHouseholdActorProxyWrapper():get()
		local isMyHouse = householdActorProxy:isOwnedBySelfPlayer();
		if( isMyHouse ) then
			local s64_householdNo = householdActorProxy:getHouseholdNo_s64();
			local s64_SelectedHouseholdNo = housing_getSelectedMyHouseholdNo_s64();
			if( s64_householdNo == s64_SelectedHouseholdNo ) then
				return template.icon_Horse			-- 설치물
			end
		end
	elseif actorProxy:isDeadBody() then
		local temporaryWrapper = getTemporaryInformationWrapper()
		if	(nil ~= temporaryWrapper)	then
			local actorKeyRaw = actorProxyWrapper:getActorKey()
			if (temporaryWrapper:isSelfDeadBody(actorKeyRaw)) then
				return template.icon_DeadBody	
			end
		end
	end

	return nil
end

-- 사용하지 않을 Static 을 반납하고, Actor 정보를 지운다.
local RadarMap_DestoryQuestIcons = function()
	for idx, areaQuest in pairs(radarMap.areaQuests) do
		if nil ~= areaQuest then
			-- Show 를 끄고, Pool 에 반납한다!
			areaQuest.icon_QuestArea:SetShow( false )
			areaQuest.icon_QuestArrow:SetShow( false )
			radarMap:returnQuestToPool( areaQuest )
		end
	end
	radarMap.areaQuests = {}
end

function regeistTooltipInfo( index, isArrow )
	if isArrow then
		registTooltipControl(radarMap.areaQuests[index].icon_QuestArrow, Panel_QuestInfo)
	else
		registTooltipControl(radarMap.areaQuests[index].icon_QuestArea, Panel_QuestInfo)
	end
end

function QuestTooltipForHandle( index, controlIdx, IsArrow )
	regeistTooltipInfo( controlIdx, IsArrow )
	QuestInfoData.questDescShowWindowForLeft( index )
end

function Radar_UpdateQuestList()
	RadarMap_DestoryQuestIcons()

	local questCount = questList_getCheckedProgressQuestCount()
	local controlCount = 1
	local pixelRate = radarMap.worldDistanceToPixelRate / 100 * 2;

	for index = 1, questCount do
		local progressQuest = questList_getCheckedProgressQuestAt(index-1)
		if ( nil ~= progressQuest ) then
			local questGroupId 		= progressQuest:getQuestNo()._group
			local questId 			= progressQuest:getQuestNo()._quest
			local questCondition	= 0
			if true == progressQuest:isSatisfied() then
				questCondition = 0
			else
				questCondition = 1
			end

			local positionCount 	= progressQuest:getQuestPositionCount()
			if 0 ~= positionCount and not progressQuest:isSatisfied() then
				for posIndex = 1, positionCount do
					local questPosition = progressQuest:getQuestPositionAt(posIndex-1)
					
					local areaQuest = radarMap:getIdleQuest()

					-- local isShow, posX, posY = getPosQuestControl( questPosition )
					areaQuest.index = index - 1

					areaQuest.icon_QuestArea:addInputEvent("Mouse_On",	"QuestTooltipForHandle(" ..(index-1)..", "..controlCount..", false)")
					areaQuest.icon_QuestArea:addInputEvent("Mouse_Out",	"QuestInfoData.questDescHideWindow()")
					areaQuest.icon_QuestArea:addInputEvent("Mouse_LUp", "HandleClicked_QuestWidget_FindTarget(" ..questGroupId..", "..questId..", " .. questCondition .. ", false)" )
					areaQuest.icon_QuestArea:setTooltipEventRegistFunc("QuestTooltipForHandle(" ..(index-1)..", "..controlCount..", false)")
					
					areaQuest.icon_QuestArrow:addInputEvent("Mouse_On",	"QuestTooltipForHandle(" ..(index-1)..", "..controlCount..", true)")					
					areaQuest.icon_QuestArrow:addInputEvent("Mouse_Out","QuestInfoData.questDescHideWindow()")
					areaQuest.icon_QuestArrow:addInputEvent("Mouse_LUp", "HandleClicked_QuestWidget_FindTarget(" ..questGroupId..", "..questId..", " .. questCondition .. ", false)" )
					areaQuest.icon_QuestArrow:setTooltipEventRegistFunc("QuestTooltipForHandle(" ..(index-1)..", "..controlCount..", false)")
					
					areaQuest.x = questPosition._position.x
					areaQuest.y = questPosition._position.y
					areaQuest.z = questPosition._position.z		-- WorldPos 에서 Z 임.
					areaQuest.radius = questPosition._radius
					-- 반지름이라 * 2	
					local size = floor(pixelRate * areaQuest.radius) * 2
					areaQuest.icon_QuestArea:SetSize( size, size )
					--areaQuest.icon_QuestArea:SetEnableArea( questPosition._position.x, questPosition._position.y,
					--questPosition._position.x + size, questPosition._position.y + size )

					radarMap.areaQuests[controlCount] = areaQuest
					controlCount = controlCount + 1
				end
			end
		end
	end
	
	for idx, areaQuest in pairs(radarMap.areaQuests) do
		if nil ~= areaQuest then			
			Panel_Radar:SetChildIndex( areaQuest.icon_QuestArrow:GetKey(),	9999 )
		end
	end	
	
	for actorKeyRaw,_ in pairs(radarMap.actorIcons) do
		RadarMap_DestoryOtherActor( actorKeyRaw )
	end
end

RadarMap_UpdatePixelRate = function()
	for _,areaQuest in pairs(radarMap.areaQuests) do

		local size = floor(radarMap.worldDistanceToPixelRate * areaQuest.radius / 100 * 2)
		areaQuest.icon_QuestArea:SetSize( size, size )
	end
end

local RadarMap_UpdateQuestAreaPositionPerFrame = function()
	local self = radarMap
	local enableHalfSize = 12
	local sizeX = Panel_Radar:GetSizeX()
	local sizeY = Panel_Radar:GetSizeY() * 0.9

	for _,areaQuest in pairs(self.areaQuests) do
		local questAreaIcon = areaQuest.icon_QuestArea
		local questArrowIcon = areaQuest.icon_QuestArrow

		local isShow, posX, posY = getPosQuestControl( areaQuest )
		if isShow then
			-- AreaIcon	
			posX = posX - floor(questAreaIcon:GetSizeX() / 2)
			posY = posY - floor(questAreaIcon:GetSizeY() / 2)
			questAreaIcon:SetPosX( posX )
			questAreaIcon:SetPosY( posY )


--			questAreaIcon:SetScale( radarMap.worldDistanceToPixelRate * 2,
--									radarMap.worldDistanceToPixelRate * 2)
			--클리핑 영역 설정[최대호]
			
			questAreaIcon:SetRectClip( float2( -posX, -posY ),
									float2( Panel_Radar:GetPosX() + sizeX - questAreaIcon:GetParentPosX(),
									Panel_Radar:GetPosY() + sizeY - questAreaIcon:GetPosY() ) )
			else
			-- ArrowIcon			
			questArrowIcon:SetPosX((Panel_Radar:GetSizeX() - questArrowIcon:GetSizeX()) / 2)
			questArrowIcon:SetPosY((Panel_Radar:GetSizeY() - questArrowIcon:GetSizeY()) / 2)
			local dx = self.pcInfo.position.x - areaQuest.x
			local dy = self.pcInfo.position.z - areaQuest.z
			local radian = math.atan2( dx, dy )
			questArrowIcon:SetRotate( radian )

			local tempPos = float2(0.0, QuestArrowHalfSize)
			tempPos:rotate(-radian)	
			
			questArrowIcon:SetEnableArea(QuestArrowHalfSize+tempPos.x-enableHalfSize, QuestArrowHalfSize+tempPos.y-enableHalfSize, QuestArrowHalfSize+tempPos.x+enableHalfSize, QuestArrowHalfSize+tempPos.y+enableHalfSize );
			
		end
		
		local sizeX = Panel_Radar:GetSizeX()/2
		local sizeY = Panel_Radar:GetSizeY()/2
		local centerPosX = Panel_Radar:GetPosX() + sizeX - 5
		local centerPosY = Panel_Radar:GetPosY() + sizeY + 15
		local dx = getMousePosX() - centerPosX
		local dy = getMousePosY() - centerPosY	

		local distance = sqrt( dx * dx + dy * dy )
		
		if distance < sizeX then
			questAreaIcon:SetIgnore( false )
			if isQuestDescShow then
				Panel_QuestInfo:SetShow( true, true )
			end
		else 
			questAreaIcon:SetIgnore( true )
			--Panel_QuestInfo:SetShow( false, true )
		end

		-- UI.debugMessage( tostring(isShow) .. posX .. '/' .. posY .. '/' .. questAreaIcon:GetSizeX() .. '/' .. questAreaIcon:GetSizeX() )
		questAreaIcon:SetShow( isShow )
		questArrowIcon:SetShow( not isShow )
	end
end

-- 아이콘 위치 및 종류 갱신(매 프레임, Actor 마다 호출된다. ActorProxyFactor 를 iteration 돈다)
-- 아이콘이 나와야 하는 대상의 기준은 nameTag 가 나오는 기준과 유사하다.
-- 따라서 @param nameTagShow 를 사용한다.
function RadarMap_UpdateOtherActor( actorProxyWrapper, worldPos, isCulled, nameTagShow, actorData )
	if nil == actorProxyWrapper then
		UI.ASSERT(false,"actorProxy is nil critical!!!")
		return
	end
	if actorProxyWrapper:get():isSelfPlayer() then
		return
	end

	local actorKeyRaw = actorProxyWrapper:getActorKey()

	local isDeadBody = false
	if actorProxyWrapper:get():isDeadBody() then
		local	temporaryWrapper = getTemporaryInformationWrapper()
		if	(nil ~= temporaryWrapper)	then
			isDeadBody = temporaryWrapper:isSelfDeadBody(actorKeyRaw);
		end
	end
	
	if isCulled or (not nameTagShow and not isDeadBody) then
		-- Show 를 끄고, Pool 에 반납한다!
		RadarMap_DestoryOtherActor( actorKeyRaw )
		return
	end

	-- worldPos 가지고 위치를 계산해야 한다!
	local isShow, posX, posY = getPosBaseControl( worldPos )
	if not isShow then
		-- Scene 에는 보이지만, RadarMap 표시 영역 바깥이다. Show 를 끄고, Pool 에 반납한다!
		RadarMap_DestoryOtherActor( actorKeyRaw )
		return
	end

	-- UI.debugMessage( tostring(posX) .. ',' .. tostring(posY) )
	-- Actor 는 표시해야 하는데, 아이콘이 없다!
	local actorIcon = radarMap.actorIcons[actorKeyRaw]
	if nil == actorIcon then
		-- Actor 에 해당하는 아이콘 Template 을 찾는다.
		local template = getActorIcon( actorProxyWrapper, actorData )
		if nil == template then
			-- 해당하는 아이콘 Template 이 없다면, 뿌리지 않는다!
			-- UI.debugMessage('Type 이 올바르지 않다!!!')
			return
		end

		-- Pool 에서 하나 꺼내오거나, 아니면 아이콘을 생성
		actorIcon = radarMap:getIdleIcon()
		Panel_Radar:SetChildIndex(actorIcon:GetKey(), 8000 )
		UI.ASSERT( nil ~= actorIcon, 		'[Radar.lua] Pool 에 잘못된 값이 들어갔거나, 생성에 실패했다!!!' )
		radarMap.actorIcons[actorKeyRaw] = actorIcon

		-- 새로 꺼내온 것은 아이콘 모양이 다를 수 있다. 다시 세팅해줘야 한다!
		CopyBaseProperty( template, actorIcon )
	end
	-- UI.debugMessage( tostring(posX) .. ',' .. tostring(posY) )

	-- 아이콘 중앙 정렬
	posX = floor(posX - actorIcon:GetSizeX() / 2)
	posY = floor(posY - actorIcon:GetSizeY() / 2)

	actorIcon:SetPosX( posX )
	actorIcon:SetPosY( posY )
	actorIcon:SetShow( true )
end
-- 사용하지 않을 Static 을 반납하고, Actor 정보를 지운다.
function RadarMap_DestoryOtherActor( actorKeyRaw )
	local actorIcon = radarMap.actorIcons[actorKeyRaw]
	if nil ~= actorIcon then
		-- Show 를 끄고, Pool 에 반납한다!
		actorIcon:SetShow( false )
		radarMap:returnIconToPool( actorIcon )
		radarMap.actorIcons[actorKeyRaw] = nil
	end
end

function Rader_ChangeTexture_On()
	-- _close_Rader:SetShow(true)
	-- 드래그 상태로 바꾼다 (마우스가 올라가 있을 때)
	raderText:SetText(PAGetString( Defines.StringSheet_GAME, "PANEL_RADER_RADER" ) .. "-" ..PAGetString( Defines.StringSheet_GAME, "PANEL_RADER_MOVE_DRAG" ))		--"레이더 - 드래그해서 옮기세요."
end

function Rader_ChangeTexture_Off()
	-- _close_Rader:SetShow(false)
	-- 드래그 상태지만 마우스가 올라가지 않았을 때 - isWidget 상태
		
	raderText:SetText(PAGetString( Defines.StringSheet_GAME, "PANEL_RADER_RADER" ))	--"레이더"
	-- Panel_TimeBarNumber:SetPosX(Panel_TimeBar:GetPosX())
	-- Panel_TimeBarNumber:SetPosY(Panel_TimeBar:GetPosY())
end

function Panel_Radar_ShowToggle()
	local isShow = Panel_Radar:IsShow()
	if isShow then
		Panel_Radar:SetShow( false )
		RaderBackground_Hide()
	else
		Panel_Radar:SetShow( true )
		RaderBackground_Show()
	end
	
	-- widgetControlButtonFunction(8)
end

-- 튜토리얼로 미니맵 오픈될 때 이펙트 부여
function FGlobal_Panel_RadarShow()
	Panel_Radar:SetShow( true )
	radar_Background:AddEffect("UI_Tuto_MiniMap_1", false, 0, 0)
	radar_Background:AddEffect("fUI_Tuto_MiniMap_01A", false, 0, 0)
end

function RadarMap_UpdateTerrainInfo()
	local terraintype = selfPlayerNaviMaterial()
	local radarControl = radarTime.controls.terrainInfo
	radarControl:ChangeTextureInfoName( "new_ui_common_forlua/default/default_etc_01.dds" )
	local x1, y1, x2, y2 = 0, 0, 0, 0

	if terraintype == 0 then
		x1, y1, x2, y2 = setTextureUV_Func( radarControl, 73, 170, 93, 190 )
		textInfo = PAGetString( Defines.StringSheet_GAME, "LUA_RADAR_TERRAININFO_NORMAL" )
		-- radarControl.terrainInfo:SetText( PAGetString(Defines.StringSheet_GAME, "LUA_RADAR_TERRAINTYPE_NORMAL" ))
	elseif terraintype == 1 then
		x1, y1, x2, y2 = setTextureUV_Func( radarControl, 52, 170, 72, 190 )
		textInfo = PAGetString( Defines.StringSheet_GAME, "LUA_RADAR_TERRAININFO_ROAD")
		-- radarControl.terrainInfo:SetText( PAGetString(Defines.StringSheet_GAME, "LUA_RADAR_TERRAINTYPE_ROAD" ))
	elseif terraintype == 2 then
		x1, y1, x2, y2 = setTextureUV_Func( radarControl, 108, 177, 128, 197 )
		textInfo = PAGetString( Defines.StringSheet_GAME, "LUA_RADAR_TERRAININFO_SNOW")
		-- radarControl.terrainInfo:SetText( PAGetString(Defines.StringSheet_GAME, "LUA_RADAR_TERRAINTYPE_SNOW" ))
	elseif terraintype == 3 then
		x1, y1, x2, y2 = setTextureUV_Func( radarControl, 129, 177, 149, 197 )
		textInfo = PAGetString( Defines.StringSheet_GAME, "LUA_RADAR_TERRAININFO_DESERT")
		-- radarControl.terrainInfo:SetText( PAGetString(Defines.StringSheet_GAME, "LUA_RADAR_TERRAINTYPE_DESERT" ))
	elseif terraintype == 4 then
		x1, y1, x2, y2 = setTextureUV_Func( radarControl, 150, 177, 170, 197 )
		textInfo = PAGetString( Defines.StringSheet_GAME, "LUA_RADAR_TERRAININFO_SWAMP")
		-- radarControl.terrainInfo:SetText( PAGetString(Defines.StringSheet_GAME, "LUA_RADAR_TERRAINTYPE_SWAMP" ))
	elseif terraintype == 5 then
		x1, y1, x2, y2 = setTextureUV_Func( radarControl, 73, 170, 93, 190 )
		textInfo = PAGetString( Defines.StringSheet_GAME, "LUA_RADAR_TERRAININFO_OBJECT")
		-- radarControl.terrainInfo:SetText( PAGetString(Defines.StringSheet_GAME, "LUA_RADAR_TERRAINTYPE_OBJECT" ))
	elseif terraintype == 6 then
		x1, y1, x2, y2 = setTextureUV_Func( radarControl, 171, 177, 191, 197 )
		textInfo = PAGetString( Defines.StringSheet_GAME, "LUA_RADAR_TERRAININFO_WATER")
		-- radarControl.terrainInfo:SetText( PAGetString(Defines.StringSheet_GAME, "LUA_RADAR_TERRAINTYPE_WATER" ))
	elseif terraintype == 7 then
		x1, y1, x2, y2 = setTextureUV_Func( radarControl, 73, 170, 93, 190 )
		textInfo = PAGetString( Defines.StringSheet_GAME, "LUA_RADAR_TERRAININFO_GRASS")
		-- radarControl.terrainInfo:SetText( PAGetString(Defines.StringSheet_GAME, "LUA_RADAR_TERRAINTYPE_GRASS" ))
	elseif terraintype == 8 then
		x1, y1, x2, y2 = setTextureUV_Func( radarControl, 171, 156, 191, 176 )
		textInfo = PAGetString( Defines.StringSheet_GAME, "LUA_RADAR_TERRAININFO_DEEPWATER")
		-- radarControl.terrainInfo:SetText( PAGetString(Defines.StringSheet_GAME, "LUA_RADAR_TERRAINTYPE_DEEPWATER" ))
	elseif terraintype == 9 then
		x1, y1, x2, y2 = setTextureUV_Func( radarControl, 171, 135, 191, 155 )
		textInfo = PAGetString( Defines.StringSheet_GAME, "LUA_RADAR_TERRAININFO_AIR")
		-- radarControl.terrainInfo:SetText( PAGetString(Defines.StringSheet_GAME, "LUA_RADAR_TERRAINTYPE_AIR" ))
	else
		x1, y1, x2, y2 = setTextureUV_Func( radarControl, 73, 170, 93, 190 )
		textInfo = PAGetString( Defines.StringSheet_GAME, "LUA_RADAR_TERRAININFO_NORMAL")
		-- radarControl.terrainInfo:SetText( PAGetString(Defines.StringSheet_GAME, "LUA_RADAR_TERRAINTYPE_NORMAL" ))
	end

	radarControl:getBaseTexture():setUV(  x1, y1, x2, y2  )
	radarControl:setRenderTexture(radarControl:getBaseTexture())
end

local _isSiegeArea = false
local buildingType = ""
function RadarMap_UpdatePosition()
	if( false == Panel_TimeBar:GetShow() ) then
		return;
	end

	local radarTimeControl = radarTime.controls
	-- local posX = radarTimeControl.gameTime:GetPosX() - radarTimeControl.gameTime:GetTextSizeX() - gapX - radarTimeControl.regionName:GetTextSizeX()
	local gapX = 15
	local regionNameSpanY = 0

	local posX = radarTimeControl.gameTime:GetTextSizeX() + gapX	-- 시간 표시
	radarTimeControl.channelName:SetSpanSize(posX - 3, regionNameSpanY )	-- 채널이름 표시

	posX = posX + radarTimeControl.channelName:GetTextSizeX()
	radarTimeControl.serverName:SetSpanSize(posX, regionNameSpanY )	-- 서버 이름 표시

	-- posX = posX + gapX + radarTimeControl.serverName:GetTextSizeX()
	-- radarTimeControl.regionName:SetSpanSize(posX, regionNameSpanY)	-- 지역 이름 표시

	-- posX = posX + gapX + radarTimeControl.regionName:GetTextSizeX()
	-- radarTimeControl.regionType:SetSpanSize(posX, regionNameSpanY)	-- 안전 지역 표시
	
	-- posX = posX + gapX + radarTimeControl.serverName:GetTextSizeX()
	-- radarTimeControl.terrainInfo:SetSpanSize(posX, regionNameSpanY + 1)	-- 거친 노면 표시
	radarTimeControl.terrainInfo:ComputePos()
	
	posX = radarTimeControl.terrainInfo:GetSizeX() + 5
	local iconSize = 20
	------------------------------------
	--		비를 맞고 있는 경우 비 아이콘 아니면 해 아이콘
	radarTimeControl.raining:ChangeTextureInfoName( "new_ui_common_forlua/widget/rader/minimap_00.dds" )
	local x1, y1, x2, y2 = 0, 0, 0, 0
	if ( 0 < getWeatherInfoBySelfPos(CppEnums.WEATHER_SYSTEM_FACTOR_TYPE.eWSFT_RAIN_AMOUNT) ) then
		weatherTooltip = 0
		x1, y1, x2, y2 = setTextureUV_Func( radarTimeControl.raining, 43, 133, 62, 152 )
	else
		weatherTooltip = 1
		x1, y1, x2, y2 = setTextureUV_Func( radarTimeControl.raining, 171, 187, 188, 205 )
	end
	radarTimeControl.raining:getBaseTexture():setUV(  x1, y1, x2, y2  )
	radarTimeControl.raining:setRenderTexture(radarTimeControl.raining:getBaseTexture())


	radarTimeControl.raining:SetShow(true)
	radarTimeControl.raining:SetSpanSize(posX, regionNameSpanY + 1)
	posX = posX + iconSize
	
	---------------------------------------------
	--		성채가 설치 가능한 지역일 경우
	radarTimeControl.citadel:ChangeTextureInfoName( "new_ui_common_forlua/window/guild/guild_00.dds" )
	local x1, y1, x2, y2 = 0, 0, 0, 0
	if (UI_RT.eRegionType_Fortress == radarMap.regionTypeValue) then	-- 성채
		buildingTooltip = 1
		x1, y1, x2, y2 = setTextureUV_Func( radarTimeControl.siegeArea, 291, 31, 311, 51 )
	elseif (UI_RT.eRegionType_Siege == radarMap.regionTypeValue) then	-- 지휘소
		buildingTooltip = 2
		x1, y1, x2, y2 = setTextureUV_Func( radarTimeControl.siegeArea, 291, 31, 311, 51 )
	else	-- 건설 불가
		buildingTooltip = 0
		x1, y1, x2, y2 = setTextureUV_Func( radarTimeControl.siegeArea, 312, 31, 332, 51 )
	end
	radarTimeControl.citadel:getBaseTexture():setUV(  x1, y1, x2, y2  )
	radarTimeControl.citadel:setRenderTexture(radarTimeControl.citadel:getBaseTexture())
	
	radarTimeControl.citadel:SetShow(true)
	radarTimeControl.citadel:SetSpanSize(posX, regionNameSpanY + 1)
	posX = posX + iconSize
	
	-- 성채/지휘소 건설 가능 지역인지 체크해서 빅나크 띄움 / 아이콘 체인지
	local CheckSiegeArea = function( installType )
		local x1, y1, x2, y2 = 0, 0, 0, 0
		local radarTimeControl = radarTime.controls
		radarTimeControl.siegeArea:ChangeTextureInfoName( "new_ui_common_forlua/window/guild/guild_00.dds" )
		
		if ( UI_RT.eRegionType_Fortress == installType ) and ( true == selfPlayerCurrentSiegeCanInstall()) then
			buildingType = "성채"
			if false == _isSiegeArea then
				_isSiegeArea = true
				local msg = { main = buildingType .. " 건설 가능 지역에 진입했습니다.", sub = "" }
				Proc_ShowMessage_Ack_For_RewardSelect( msg, 2.3, 20 )				-- 성채/지휘소 건설 가능 지역
			end
			x1, y1, x2, y2 = setTextureUV_Func( radarTimeControl.citadel, 166, 1, 186, 21 )
			siegeTooltip = 0
		elseif ( UI_RT.eRegionType_Siege == installType ) and ( true == selfPlayerCurrentSiegeCanInstall()) then
			buildingType = "지휘소"
			if false == _isSiegeArea then
				_isSiegeArea = true
				local msg = { main = buildingType .. " 건설 가능 지역에 진입했습니다.", sub = "" }
				Proc_ShowMessage_Ack_For_RewardSelect( msg, 2.3, 20 )				-- 성채/지휘소 건설 가능 지역
			end
			x1, y1, x2, y2 = setTextureUV_Func( radarTimeControl.citadel, 187, 1, 207, 21 )
			siegeTooltip = 1
		else
			if true == _isSiegeArea then
				_isSiegeArea = false
				local msg = { main = buildingType .. " 건설 가능 지역에서 벗어났습니다.", sub = "" }
				Proc_ShowMessage_Ack_For_RewardSelect( msg, 2.3, 21 )				-- 성채/지휘소 건설 가능 지역 이탈
			end
			x1, y1, x2, y2 = setTextureUV_Func( radarTimeControl.citadel, 249, 31, 269, 51 )
			siegeTooltip = 2
		end
		
		radarTimeControl.siegeArea:getBaseTexture():setUV(  x1, y1, x2, y2  )
		radarTimeControl.siegeArea:setRenderTexture(radarTimeControl.siegeArea:getBaseTexture())

		radarTimeControl.siegeArea:SetShow(true)
		radarTimeControl.siegeArea:SetSpanSize(posX, regionNameSpanY + 1)
	end
	
	radarTimeControl.commandCenter:SetShow(false)	-- 사용하지 않음!
	CheckSiegeArea( radarMap.regionTypeValue )
	
	Panel_TimeBar:SetSize( 295, 22 )
	Panel_TimeBar:ComputePos()

	radarTimeControl.gameTime:ComputePos()
	radarTimeControl.channelName:ComputePos()
	radarTimeControl.serverName:ComputePos()
	radarTimeControl.terrainInfo:ComputePos()
	radarTimeControl.raining:ComputePos()
	radarTimeControl.citadel:ComputePos()
	radarTimeControl.siegeArea:ComputePos()
	radarTimeControl.commandCenter:ComputePos()

	radar_regionName:ComputePos()
	-- radarTimeControl.regionType:ComputePos()

	---------------------------------------------------
	-- radarTimeControl.regionName:SetSpanSize( 120, 35 )	-- 지역 이름 표시
	-- radarTimeControl.regionName:ComputePos()
end

function RadarMap_MouseOnOffAnimation(deltaTime)	
	local IsMouseOver = 	Panel_Radar:GetPosX() - 20 < getMousePosX() and getMousePosX() < Panel_Radar:GetPosX() + Panel_Radar:GetSizeX() + 20 and
							Panel_Radar:GetPosY() - 20 < getMousePosY() and getMousePosY() < Panel_Radar:GetPosY() + Panel_Radar:GetSizeY() + 20;

	if IsMouseOver then
		simpleUIAlpha = 1.0;
	else
		simpleUIAlpha = 0.0;
	end
	
	UIAni.perFrameAlphaAnimation(simpleUIAlpha, radarMap.controls.timeNum, 						5 * deltaTime);
	UIAni.perFrameAlphaAnimation(simpleUIAlpha, radarMap.controls.rader_Plus, 					5 * deltaTime);
	UIAni.perFrameAlphaAnimation(simpleUIAlpha, radarMap.controls.rader_Minus, 					5 * deltaTime);
	UIAni.perFrameAlphaAnimation(simpleUIAlpha, radarMap.controls.rader_AlphaPlus, 				5 * deltaTime);
	UIAni.perFrameAlphaAnimation(simpleUIAlpha, radarMap.controls.rader_AlphaMinus, 			5 * deltaTime);
	UIAni.perFrameAlphaAnimation(simpleUIAlpha, radarMap.controls.rader_Reset, 					5 * deltaTime);
	UIAni.perFrameAlphaAnimation(simpleUIAlpha, radarMap.controls.rader_NpcFind_Toggle, 		5 * deltaTime);

	UIAni.perFrameAlphaAnimation(simpleUIAlpha, radar_SizeSlider,								5 * deltaTime);
	UIAni.perFrameAlphaAnimation(simpleUIAlpha, radar_SizeBtn, 									5 * deltaTime);
	UIAni.perFrameAlphaAnimation(simpleUIAlpha, radar_AlphaScrl,								5 * deltaTime);
	UIAni.perFrameAlphaAnimation(simpleUIAlpha, radar_AlphaBtn, 								5 * deltaTime);
	UIAni.perFrameAlphaAnimation(simpleUIAlpha, radar_MiniMapScl, 								5 * deltaTime);
end

-- 매 프레임 호출되는 함수 PAUIPanel:Update
function RadarMap_UpdatePerFrame(deltaTime)
	--local profile1 = startProfileLog("RadarMap_UpdateTimePerFrame()");
	RadarMap_UpdateTimePerFrame()	
	--endProfileLog( profile1 );
	-------------------------------------------------------------------
	--local profile2 = startProfileLog("RadarMap_UpdateSelfPlayerPerFrame()");
	RadarMap_UpdateSelfPlayerPerFrame()
	--endProfileLog( profile2 );
	-------------------------------------------------------------------
	--local profile4 = startProfileLog("RadarMap_UpdateQuestAreaPositionPerFrame()");
	RadarMap_UpdateQuestAreaPositionPerFrame()
	--endProfileLog( profile4 );
	-------------------------------------------------------------------
	--local profile5 = startProfileLog("RadarMap_UpdateTerrainInfo()");
	RadarMap_UpdateTerrainInfo()	
	--endProfileLog( profile5 );
	-------------------------------------------------------------------
	--local profile6 = startProfileLog("RadarMap_UpdatePosition()");
	RadarMap_UpdatePosition()
	--endProfileLog( profile6 );
	-------------------------------------------------------------------
	--local profile7 = startProfileLog("RadarMap_MouseOnOffAnimation()");
	RadarMap_MouseOnOffAnimation(deltaTime)
	--endProfileLog( profile7 );
	-------------------------------------------------------------------
	--local profile8 = startProfileLog("RadarMap_UpdatePerFrame()");	
	
	local SPI = radarMap.controls.icon_SelfPlayer
	
	local halfSelfSizeX = SPI:GetSizeX() / 2
	local halfSelfSizeY = SPI:GetSizeY() / 2
	
	local halfSizeX = Panel_Radar:GetSizeX() / 2
	local halfSizeY = Panel_Radar:GetSizeY() / 2	
	
	SPI:SetPosX( (halfSizeX - halfSelfSizeX) )
	SPI:SetPosY( (halfSizeY - halfSelfSizeY) )
	
	radarMap.pcPosBaseControl.x = SPI:GetPosX() + halfSelfSizeX
	radarMap.pcPosBaseControl.y = SPI:GetPosY() + halfSelfSizeY	
	
	ToClient_setRadorUICenterPosition( int2(radarMap.pcPosBaseControl.x, radarMap.pcPosBaseControl.y) )
	ToClient_SetRadarCenterPos(float2( radarMap.pcPosBaseControl.x,	radarMap.pcPosBaseControl.y))
	--[[test
	local selfPlayerWrapper = getSelfPlayer()
	local selfPlayer = selfPlayerWrapper:get()
	
	local icoposX = radarMap.controls.icon_SelfPlayer:GetPosX() + radarMap.controls.icon_SelfPlayer:GetSizeX() /2
	local icoposY = radarMap.controls.icon_SelfPlayer:GetPosY() + radarMap.controls.icon_SelfPlayer:GetSizeY() / 2
	
	local posX = (pinX - selfPlayer:getPositionX()) / 100
	local posZ = (selfPlayer:getPositionZ() - pinZ) / 100

	_PA_LOG("최대호", tostring(pinZ/100) )
	_PA_LOG("최대호", tostring(selfPlayer:getPositionZ()/100) )
	_PA_LOG("최대호", tostring(posZ) )
	
	radarMap.template.icon_PIN_PartyMine:SetPosX( icoposX + posX )
	radarMap.template.icon_PIN_PartyMine:SetPosY( icoposY + posZ )]]--
	--endProfileLog( profile8 );	
	-------------------------------------------------------------------
	--local profile9 = startProfileLog("FGlobal_UpdateRadarPin()");
	FGlobal_UpdateRadarPin()
	--endProfileLog( profile9 );
	-------------------------------------------------------------------
	--local profile10 = startProfileLog("RaderBackground_updatePerFrame()");
	RaderBackground_updatePerFrame(deltaTime)
	--endProfileLog( profile10 );

	GameTips_MessageUpdate( deltaTime )
end

function RadarMap_SimpleUIUpdatePerFrame( deltaTime )
	local isUiMode = (CppEnums.EProcessorInputMode.eProcessorInputMode_UiMode == getInputMode() or CppEnums.EProcessorInputMode.eProcessorInputMode_ChattingInputMode == getInputMode());

	local IsMouseOver = 	Panel_Radar:GetPosX() - 20 < getMousePosX() and getMousePosX() < Panel_Radar:GetPosX() + Panel_Radar:GetSizeX() + 20 and
							Panel_Radar:GetPosY() - 20 < getMousePosY() and getMousePosY() < Panel_Radar:GetPosY() + Panel_Radar:GetSizeY() + 20;	
	
	if isUiMode then
		isUiMode = IsMouseOver;
	end
	
	if isUiMode then
		simpleUIAlpha = 1.0;
	else
		simpleUIAlpha = 0.0;
	end
	
	local tmpRaderAlphaValue = 0.7;
	local tmpRaderMoreAlphaValue = 0.5;
	if isUiMode then
		tmpRaderAlphaValue = 1.0;
		tmpRaderMoreAlphaValue = 1.0;
	end
	
	if( Panel_Radar:GetShow() ) then
		UIAni.perFrameAlphaAnimation(simpleUIAlpha, radarMap.controls.rader_Plus, 					2.8 * deltaTime);
		UIAni.perFrameAlphaAnimation(simpleUIAlpha, radarMap.controls.rader_Minus, 					2.8 * deltaTime);
		UIAni.perFrameAlphaAnimation(simpleUIAlpha, radarMap.controls.rader_AlphaPlus, 				2.8 * deltaTime);
		UIAni.perFrameAlphaAnimation(simpleUIAlpha, radarMap.controls.rader_AlphaMinus, 			2.8 * deltaTime);
		UIAni.perFrameAlphaAnimation(simpleUIAlpha, radarMap.controls.rader_Reset, 					2.8 * deltaTime);
		UIAni.perFrameAlphaAnimation(simpleUIAlpha, radarMap.controls.rader_NpcFind_Toggle, 		2.8 * deltaTime);
		UIAni.perFrameAlphaAnimation(simpleUIAlpha, radarMap.controls.rader_Close, 					2.8 * deltaTime);
		UIAni.perFrameAlphaAnimation(simpleUIAlpha, radar_SizeSlider,								2.8 * deltaTime);
		UIAni.perFrameAlphaAnimation(simpleUIAlpha, radar_SizeBtn, 									2.8 * deltaTime);
		UIAni.perFrameAlphaAnimation(simpleUIAlpha, radar_AlphaScrl,								2.8 * deltaTime);
		UIAni.perFrameAlphaAnimation(simpleUIAlpha, radar_AlphaBtn, 								2.8 * deltaTime);
		UIAni.perFrameAlphaAnimation(simpleUIAlpha, radar_MiniMapScl, 								2.8 * deltaTime);
		UIAni.perFrameAlphaAnimation(tmpRaderAlphaValue,		radarMap.controls.icon_SelfPlayer, 	2.8 * deltaTime);
	end
	
	-- _PA_LOG("Test", "Test:"..tostring(Panel_TimeBar:GetShow()));
	--if( Panel_TimeBar:GetShow() ) then
		UIAni.perFrameAlphaAnimation(simpleUIAlpha, radarMap.controls.timeNum, 						2.8 * deltaTime);
		UIAni.perFrameAlphaAnimation(tmpRaderMoreAlphaValue,	Panel_TimeBar, 						2.8 * deltaTime);
	--end
end

registerEvent( "SimpleUI_UpdatePerFrame",		"RadarMap_SimpleUIUpdatePerFrame")

function RaderMap_GetDistanceToPixelRate()
	return radarMap.worldDistanceToPixelRate
end

function RaderMap_GetSelfPosInRader()
	return radarMap.pcPosBaseControl
end

-- 최대호 스케일 비율
function RadarMap_GetScaleRateWidth()
	return radarMap.scaleRateWidth
end

function RadarMap_GetScaleRateHeight()
	return radarMap.scaleRateHeight
end


checkLoad()			-- 서비스 버전에서는 없어도 되는 함수이다.
controlInit()		-- 초기화 함수
Radar_UpdateQuestList()  -- 퀘스트 표시 함수
-- RadarTimeBar_ShowToggle( true )

registerEvent("selfPlayer_regionChanged", "RadarMap_updateRegion")
-- registerEvent("EventActorUpdate",			"RadarMap_UpdateOtherActor")		EventActorUpdate 이벤트는 성능 Issue 로 인해서, global_main_update.lua 에서 직접 관리하도록 변경되었다!
registerEvent("EventActorDelete",			"RadarMap_DestoryOtherActor")
registerEvent("EventQuestListChanged",		"Radar_UpdateQuestList")
registerEvent("FromClient_UpdateQuestList", 	"Radar_UpdateQuestList")

-- 켜고 끄기 이벤트 함수~!
Panel_Radar:addInputEvent( "Mouse_On",	"Rader_ChangeTexture_On()" )
Panel_Radar:addInputEvent( "Mouse_Out", "Rader_ChangeTexture_Off()" )
Panel_Radar:addInputEvent( "Mouse_LUp", "ResetPos_WidgetButton()" )			--메인UI위젯 위치 초기화



function RadarMap_EnableSimpleUI_Force_Over()
	RadarMap_EnableSimpleUI( true );
end
function RadarMap_EnableSimpleUI_Force_Out()
	RadarMap_EnableSimpleUI( false );
end
registerEvent( "EventSimpleUIEnable",			"RadarMap_EnableSimpleUI_Force_Over")
registerEvent( "EventSimpleUIDisable",			"RadarMap_EnableSimpleUI_Force_Out")

function RadarMap_EnableSimpleUI(isEnable)
	if isEnable then
		Rader_updateWorldMap_AlphaControl(-1.0);
	end
	
	cacheSimpleUI_ShowButton = true;
end

if getEnableSimpleUI() then
--	RadarMap_EnableSimpleUI(true);
--	RadarMapBG_EnableSimpleUI(true)
end

--------------------------------drag 타임 설정용

function RadarMap_SetDragMode( isSet )
	isDrag = isSet
end




-----------------------------------------------------------------
-- Rador New
-----------------------------------------------------------------


local radorType =
{
	radorType_none						= 0,	--보여주지 않을 actor

	radorType_allymonster				= 1,	--플레이어의 소환수 or 같은팀인 몬스터
	radorType_normalMonster				= 2,	--일반적인 몹들
	radorType_namedMonster				= 3,	--이름있는 몹들
	radorType_bossMonster				= 4,	--보스 몹들
	radorType_normalMonsterQuestTarget	= 5,	--퀘스트 목표인 일반적인 몹들
	radorType_namedMonsterQuestTarget	= 6,	--퀘스트 목표인 이름있는 몹들
	radorType_bossMonsterQuestTarget	= 7,	--퀘스트 목표인 보스 몹들

	radorType_lordManager				= 8, 	--영지 정보 관리인 Npc
	radorType_skillTrainner				= 9,	--스킬 교관 Npc
	radorType_tradeMerchantNpc			= 10,	--무역관리인 Npc(무역)
	radorType_nodeManager				= 11,	--탐험 노드관리인 Npc
	radorType_normalNpc					= 12,	--일반적인 npc
	radorType_warehouseNpc				= 13,	--창고관리인 Npc
	radorType_potionNpc					= 14,	--물약상인 Npc
	radorType_weaponNpc					= 15,	--무기상인 Npc
	radorType_horseNpc					= 16,	--마구간지기 Npc
	radorType_workerNpc					= 17,	--작업감독관 Npc
	radorType_jewelNpc					= 18,	--보석상인 Npc
	radorType_furnitureNpc				= 19,	--가구상인 Npc
	radorType_collectNpc				= 20,	--재료상인 Npc
	radorType_shipNpc					= 21,	--나루터지기 Npc
	radorType_alchemyNpc				= 22,	--연금술사 Npc
	radorType_fishNpc					= 23,	--물고기상인 Npc
	
	radorType_guild	    				= 24,   --길드 Npc
	radorType_guildShop 				= 25,   --길드하우스 경매 Npc
	radorType_itemTrader    			= 26,   --아이템 거래소 Npc
	radorType_TerritorySupply			= 27,   --황실납품 Npc
	radorType_TerritoryTrade			= 28,   --황실무역 Npc
	radorType_Cook						= 29,   --요리 Npc
	radorType_Wharf                     = 30,   --나루터지기 Npc
	
	radorType_itemRepairer				= 31,	--수리 Npc
	radorType_shopMerchantNpc			= 32,	--상인 Npc(일반) 
	radorType_ImportantNpc				= 33,	--그외 중요 Npc
	radorType_QuestAcceptable			= 34,	-- 퀘스트를 완료 할 수 있는 경우
	radorType_QuestProgress				= 35,	-- 퀘스트를 수행 중인 경우
	radorType_QuestComplete				= 36,	-- 퀘스트를 완료할 수 있는 경우
	radorType_unknownNpc				= 37,	--현재 발견되지 않은 Npc
		
	radorType_partyMember				= 38,	-- 파티원 플레이어
	radorType_guildMember				= 39,	-- 길드원 플레이어
	radorType_normalPlayer				= 40,	-- 그외 플레이어

	radorType_isHorse					= 41,	--플레이어의 소환수 or 같은팀인 몬스터

	radorType_installation				= 42,	--설치물
	radorType_kingGuildTent				= 43,	--공성 길드텐트
	radorType_lordGuildTent				= 44,	--영지 길드텐트

	radorType_selfDeadBody				= 45,	--셀프플레이어의 시체 계통
		
	radorType_Count						= 46,
}


-- radorType_none						-- 보여주지 않을 actor

-- radorType_allymonster				-- 플레이어의 소환수 or 같은팀인 몬스터
-- radorType_normalMonster				-- 일반적인 몹들
-- radorType_namedMonster				-- 이름있는 몹들
-- radorType_bossMonster				-- 보스 몹들
-- radorType_normalMonsterQuestTarget	-- 퀘스트 목표인 일반적인 몹들
-- radorType_namedMonsterQuestTarget	-- 퀘스트 목표인 이름있는 몹들
-- radorType_bossMonsterQuestTarget		-- 퀘스트 목표인 보스 몹들

-- radorType_lordManager				-- 영지 정보 관리인 (new)
-- radorType_skillTrainner				-- 스킬 교관
-- radorType_tradeMerchantNpc			-- 무역 관리인
-- radorType_nodeManager				-- 탐험 노드관리인 (new)

-- radorType_normalNpc					-- 일반적인 npc

-- radorType_warehouseNpc				-- 창고관리인 (new)
-- radorType_potionNpc					-- 물약 상인 (new)
-- radorType_weaponNpc					-- 무기 상인 (new)
-- radorType_horseNpc					-- 마구간지기 (new)
-- radorType_workerNpc					-- 작업감독관 (new)
-- radorType_jewelNpc					-- 보석 상인 (new)
-- radorType_furnitureNpc				-- 가구 상인 (new)
-- radorType_collectNpc					-- 재료 상인 (new)
-- radorType_shipNpc					-- 나루터지기 (new)
-- radorType_alchemyNpc					-- 연금술사 (new)
-- radorType_fisherNpc					-- 물고기 상인 (new)
-- radorType_guild	    				-- 길드 Npc
-- radorType_guildShop 				    -- 길드하우스 경매 Npc
-- radorType_itemTrader    			    -- 아이템 거래소 Npc
-- radorType_TerritorySupply			-- 황실납품 Npc
-- radorType_TerritoryTrade			    -- 황실무역 Npc
-- radorType_Cook						-- 요리 Npc
-- radorType_Wharf                      -- 나루터지기 Npc

-- radorType_itemRepairer				-- 장비 수리 Npc
-- radorType_shopMerchantNpc			-- 상인 Npc(일반) -- 빠지는게 좋을듯
-- radorType_ImportantNpc				-- 그외 중요 Npc
-- radorType_unknownNpc					-- 현재 발견되지 않은 Npc

-- radorType_partyMember				-- 파티원 플레이어
-- radorType_guildMember				-- 길드원 플레이어
-- radorType_normalPlayer				-- 그외 플레이어
                                    
-- radorType_isHorse					-- 플레이어의 소환수 or 같은팀인 몬스터
-- radorType_installation				-- 설치물
-- radorType_selfDeadBody				-- 셀프플레이어의 시체 계통



local template = {
	[radorType.radorType_none] = nil,

	[radorType.radorType_allymonster]				= UI.getChildControl( Panel_Radar, "icon_horse"),
	[radorType.radorType_normalMonster]				= UI.getChildControl( Panel_Radar, "icon_monsterGeneral_normal"),
	[radorType.radorType_namedMonster]				= UI.getChildControl( Panel_Radar, "icon_monsterNamed_normal"),		-- <난폭한>
	[radorType.radorType_bossMonster]				= UI.getChildControl( Panel_Radar, "icon_monsterBoss_normal"),		-- <우두머리>
	[radorType.radorType_normalMonsterQuestTarget]	= UI.getChildControl( Panel_Radar, "icon_monsterGeneral_quest"),
	[radorType.radorType_namedMonsterQuestTarget]	= UI.getChildControl( Panel_Radar, "icon_monsterNamed_quest"),
	[radorType.radorType_bossMonsterQuestTarget]	= UI.getChildControl( Panel_Radar, "icon_monsterBoss_quest"),

	[radorType.radorType_lordManager]				= UI.getChildControl( Panel_Radar, "icon_npc_lordManager"),		-- 영지 정보 관리인 Npc
	[radorType.radorType_skillTrainner]				= UI.getChildControl( Panel_Radar, "icon_npc_skillTrainner"),   -- 스킬 교관 Npc
	[radorType.radorType_tradeMerchantNpc]			= UI.getChildControl( Panel_Radar, "icon_npc_trader"),     		-- 무역관리인 Npc(무역)
	[radorType.radorType_nodeManager]				= UI.getChildControl( Panel_Radar, "icon_npc_nodeManager"),     -- 탐험 노드관리인 Npc
	--[radorType.radorType_normalNpc]					= UI.getChildControl( Panel_Radar, "icon_npc_general"),		    -- 일반적인 npc
	[radorType.radorType_normalNpc]					= nil,		    -- 일반적인 npc
	[radorType.radorType_warehouseNpc]				= UI.getChildControl( Panel_Radar, "icon_npc_warehouse"),		-- 창고관리인 Npc
	[radorType.radorType_potionNpc]					= UI.getChildControl( Panel_Radar, "icon_npc_potion"),		    -- 물약상인 Npc
	[radorType.radorType_weaponNpc]					= UI.getChildControl( Panel_Radar, "icon_npc_storeArmor"),		-- 무기상인 Npc
	[radorType.radorType_horseNpc]					= UI.getChildControl( Panel_Radar, "icon_npc_horse"),		    -- 마구간지기 Npc
	[radorType.radorType_workerNpc]					= UI.getChildControl( Panel_Radar, "icon_npc_worker"),		    -- 작업감독관 Npc
	[radorType.radorType_jewelNpc]					= UI.getChildControl( Panel_Radar, "icon_npc_jewel"),		    -- 보석상인 Npc
	[radorType.radorType_furnitureNpc]				= UI.getChildControl( Panel_Radar, "icon_npc_furniture"),		-- 가구상인 Npc
	[radorType.radorType_collectNpc]				= UI.getChildControl( Panel_Radar, "icon_npc_collect"),		    -- 재료상인 Npc
	[radorType.radorType_shipNpc]					= UI.getChildControl( Panel_Radar, "icon_npc_ship"),		     	-- 나루터지기 Npc
	[radorType.radorType_alchemyNpc]				= UI.getChildControl( Panel_Radar, "icon_npc_alchemy"),		    -- 연금술사 Npc
	[radorType.radorType_fishNpc]					= UI.getChildControl( Panel_Radar, "icon_npc_fish"),		     	-- 물고기상인 Npc

	[radorType.radorType_guild]	    	        	= UI.getChildControl( Panel_Radar, "icon_npc_guild"),          --길드 Npc
	[radorType.radorType_guildShop] 	            = UI.getChildControl( Panel_Radar, "icon_npc_guildShop"),      --길드하우스 경매 Npc
	[radorType.radorType_itemTrader]    	        = UI.getChildControl( Panel_Radar, "icon_npc_itemTrader"),     --아이템 거래소 Npc
	[radorType.radorType_TerritorySupply]			= UI.getChildControl( Panel_Radar, "icon_npc_territorySupply"),--황실납품 Npc
	[radorType.radorType_TerritoryTrade]  			= UI.getChildControl( Panel_Radar, "icon_npc_territoryTrade"), --황실무역 Npc
	[radorType.radorType_Cook]			    	    = UI.getChildControl( Panel_Radar, "icon_npc_cook"),           --요리 Npc
    [radorType.radorType_Wharf]                     = UI.getChildControl( Panel_Radar, "icon_npc_wharf"),          --나루터지기 Npc
	
	                                                                                                            
	[radorType.radorType_itemRepairer]				= UI.getChildControl( Panel_Radar, "icon_npc_repairer"),		-- 수리공
	[radorType.radorType_shopMerchantNpc]			= UI.getChildControl( Panel_Radar, "icon_npc_shop"),			-- 상점
	[radorType.radorType_ImportantNpc]				= UI.getChildControl( Panel_Radar, "icon_npc_important"),		-- 중요 NPC
	
	[radorType.radorType_QuestAcceptable]			= UI.getChildControl( Panel_Radar, "icon_quest_accept"),		-- 퀘스트 수락 가능
	[radorType.radorType_QuestProgress]				= UI.getChildControl( Panel_Radar, "icon_quest_doing"),			-- 퀘스트 수행중
	[radorType.radorType_QuestComplete]				= UI.getChildControl( Panel_Radar, "icon_quest_clear"),			-- 퀘스트 완료 가능
	
	[radorType.radorType_unknownNpc]				= UI.getChildControl( Panel_Radar, "icon_npc_unknown"),			-- ?
	
	[radorType.radorType_partyMember]				= UI.getChildControl( Panel_Radar, "icon_partyMember"),
	[radorType.radorType_guildMember]				= UI.getChildControl( Panel_Radar, "icon_guildMember"),
	[radorType.radorType_normalPlayer]				= UI.getChildControl( Panel_Radar, "icon_player"),
	
	[radorType.radorType_isHorse]					= UI.getChildControl( Panel_Radar, "icon_horse"),
	
	[radorType.radorType_installation]				= UI.getChildControl( Panel_Radar, "icon_tent"),
	[radorType.radorType_kingGuildTent]				= UI.getChildControl( Panel_Radar, "icon_tent"),
	[radorType.radorType_lordGuildTent]				= UI.getChildControl( Panel_Radar, "icon_tent"),
	
	[radorType.radorType_selfDeadBody]				= UI.getChildControl( Panel_Radar, "icon_deadbody"),
}

local typeDepth = {
	[radorType.radorType_none] = nil,

	[radorType.radorType_allymonster]				= -2,
	[radorType.radorType_normalMonster]				= -2,
	[radorType.radorType_namedMonster]				= -10,	-- <난폭한>
	[radorType.radorType_bossMonster]				= -10,	-- <우두머리>
	[radorType.radorType_normalMonsterQuestTarget]	= -2,
	[radorType.radorType_namedMonsterQuestTarget]	= -2,
	[radorType.radorType_bossMonsterQuestTarget]	= -2,

	[radorType.radorType_lordManager]				= -2,	-- 영지 정보 관리인 Npc
	[radorType.radorType_skillTrainner]				= -2,	-- 스킬 교관 Npc
	[radorType.radorType_tradeMerchantNpc]			= -2,	-- 무역관리인 Npc(무역)
	[radorType.radorType_nodeManager]				= -2,	-- 탐험 노드관리인 Npc

	[radorType.radorType_normalNpc]					= -2,  -- 일반적인 npc
	[radorType.radorType_warehouseNpc]				= -2,  -- 창고관리인 Npc
	[radorType.radorType_potionNpc]					= -2,  -- 물약상인 Npc
	[radorType.radorType_weaponNpc]					= -2,  -- 무기상인 Npc
	[radorType.radorType_horseNpc]					= -2,  -- 마구간지기 Npc
	[radorType.radorType_workerNpc]					= -2,  -- 작업감독관 Npc
	[radorType.radorType_jewelNpc]					= -2,  -- 보석상인 Npc
	[radorType.radorType_furnitureNpc]				= -2,  -- 가구상인 Npc
	[radorType.radorType_collectNpc]				= -2,  -- 재료상인 Npc
	[radorType.radorType_shipNpc]					= -2,  -- 나루터지기 Npc
	[radorType.radorType_alchemyNpc]				= -2,  -- 연금술사 Npc
	[radorType.radorType_fishNpc]					= -2,  -- 물고기상인 Npc

	[radorType.radorType_guild]	    	        	= -2,  --길드 Npc           
	[radorType.radorType_guildShop] 	            = -2,  --길드하우스 경매 Npc
	[radorType.radorType_itemTrader]    	        = -2,  --아이템 거래소 Npc  
	[radorType.radorType_TerritorySupply]			= -2,  --황실납품 Npc       
	[radorType.radorType_TerritoryTrade]  			= -2,  --황실무역 Npc       
	[radorType.radorType_Cook]			    	    = -2,  --요리 Npc           
    [radorType.radorType_Wharf]                     = -2,  --나루터지기 Npc

	[radorType.radorType_itemRepairer]				= -2,	-- 수리공
	[radorType.radorType_shopMerchantNpc]			= -2,	-- 상점
	[radorType.radorType_ImportantNpc]				= -2,	-- 중요 NPC

	[radorType.radorType_QuestAcceptable]			= -2,	-- 퀘스트 수락 가능
	[radorType.radorType_QuestProgress]				= -2,	-- 퀘스트 수행중
	[radorType.radorType_QuestComplete]				= -2,	-- 퀘스트 완료 가능

	[radorType.radorType_unknownNpc]				= -2,	-- ?

	[radorType.radorType_partyMember]				= -90,	-- 파티원
	[radorType.radorType_guildMember]				= -80,	-- 길드원들
	[radorType.radorType_normalPlayer]				= -1,	-- 일반플레이어들

	[radorType.radorType_isHorse]					= -100,	-- 내 탈것들

	[radorType.radorType_installation]				= -10,	-- 설치물
	[radorType.radorType_kingGuildTent]				= -10,	-- 
	[radorType.radorType_lordGuildTent]				= -10,	-- 

	[radorType.radorType_selfDeadBody]				= -10,
}

function FromClient_RadorUICreated( actorKeyRaw, control, actorProxyWrapper, radorType )
	control:SetSize(10, 10)

	if ( actorProxyWrapper:get():isHiddenName() ) then		
		control:SetShow(false)
		return
	end
	local base = template[radorType] -- radorType대로 안넣는경우가 있으면 병화에게 알려주세요.
	
	if ( nil ~= base ) then		
		CopyBaseProperty( base, control)		
		control:SetShow(true)
	else		
	    control:SetShow(false)
	end		

	monsterTitle = nil
	SortRador_IconIndex()
	ToClient_setRadorUICenterPosition( int2(radarMap.pcPosBaseControl.x, radarMap.pcPosBaseControl.y) )
	control:SetDepth( typeDepth[radorType] )
end

function FromClient_RadorTypeChanged( actorKeyRaw, targetUI, radorType )
	local templateUI = template[radorType]
	if ( nil == templateUI ) then
		targetUI:SetShow(false)
		return
	end

	CopyBaseProperty( templateUI, targetUI )
	targetUI:SetDepth( typeDepth[radorType] )
	--Panel_Radar:SetChildIndex( targetUI:GetKey(), 9000 )
end
registerEvent("FromClient_RadorTypeChanged", "FromClient_RadorTypeChanged")
registerEvent("FromClient_RadorUICreated", "FromClient_RadorUICreated" )

local check_ServerChannel = function()
	local radarTimeControl = radarTime.controls
	radarTimeControl.serverName:SetText( getCurrentWolrdName() )
	-- if mainChannel then radarTimeControl.channelName:SetText( "(" .. getCurrentChannelIndex()+1 .. "채널)" ) + 아이콘 켠다. else
	local curChannelData	= getCurrentChannelServerData()
	local channelName		= getChannelName(curChannelData._worldNo, curChannelData._serverNo )
	radarTimeControl.channelName:SetText( "(<PAColor0xFFb0cd61>" .. channelName .. "<PAOldColor>)" )
	-- end
end
check_ServerChannel()


function CalcPositionUseToTextUI( targetUI, textUI )
	if( Panel_Radar:GetSizeX() < targetUI:GetPosX() + textUI:GetTextSizeX() ) then
		textUI:SetPosX( Panel_Radar:GetSizeX() - textUI:GetTextSizeX() )
	else
		textUI:SetPosX( targetUI:GetPosX() )
	end
	
	if( Panel_Radar:GetPosY() > targetUI:GetPosY() - textUI:GetTextSizeY() ) then
		textUI:SetPosY( Panel_Radar:GetPosY() )
	else
		textUI:SetPosY( targetUI:GetPosY() - textUI:GetTextSizeY() )
	end
end

function FromClient_setNameOfMouseOverIcon( actorName, targetUI )	
	radar_OverName:SetShow(true)
	radar_OverName:SetText( actorName )
	radar_OverName:SetSize( radar_OverName:GetTextSizeX() + 15, radar_OverName:GetTextSizeY() + radar_OverName:GetSpanSize().y )
	Panel_Radar:SetChildIndex(radar_OverName:GetKey(), 9999 )
	CalcPositionUseToTextUI( targetUI, radar_OverName )
	
	
	--[[
	if( Panel_Radar:GetSizeX() < targetUI:GetPosX() + radar_OverName:GetTextSizeX() ) then
		radar_OverName:SetPosX( Panel_Radar:GetSizeX() - radar_OverName:GetTextSizeX() )
	else
		radar_OverName:SetPosX( targetUI:GetPosX() )
	end
	
	if( Panel_Radar:GetPosY() > targetUI:GetPosY() - radar_OverName:GetTextSizeY() ) then
		radar_OverName:SetPosY( Panel_Radar:GetPosY() )
	else
		radar_OverName:SetPosY( targetUI:GetPosY() - radar_OverName:GetTextSizeY() )
	end
	]]--
	
end

function FromClient_NameOff()
	if(radar_OverName:GetShow() ) then		
		radar_OverName:SetShow(false)
	end
end

registerEvent("FromClient_setNameOfMouseOverIcon", "FromClient_setNameOfMouseOverIcon" )
registerEvent("FromClient_NameOff", "FromClient_NameOff" )


changePositionBySever(Panel_Radar, CppEnums.PAGameUIType.PAGameUIPanel_RadarMap, true, false, false)

----------------------------------------------------------------------------------------------------
--									도움말 텍스트 모음
----------------------------------------------------------------------------------------------------
-- --------------------------
-- -- 		레이더
-- Panel_Radar:SetHelpText( "현재 네 주변에 있는 것들을 표시해주는 레이더야. NPC나 몬스터들의 위치가 표시되고, 의뢰를 수행 중이라면 의뢰의 위치도 알려주지. 중요한 것은, 현재 바라보고 있는 방향의 것들만 보인 다는 것, 명심해둬." )

-- --------------------------
-- -- 		지역정보
-- Panel_TimeBar:SetHelpText( "현재 네가 서 있는 곳의 다양한 정보를 표시하고, 현재 이 세계의 시간이 표시되는 곳이지. 밤 10시부터 오전 2시까지는 퇴근하는 NPC들이 여럿 존재하니 명심해." )
