---------------------------
-- Panel Init
---------------------------
Panel_Region:SetShow(false, false)			-- Default Hide!
Panel_Region:setMaskingChild(true)

Panel_Region:RegisterShowEventFunc( true, 'Region_ShowAni()' )
Panel_Region:RegisterShowEventFunc( false, 'Region_HideAni()' )

---------------------------
-- Local Variables
---------------------------
local UI_ANI_ADV = CppEnums.PAUI_ANIM_ADVANCE_TYPE
local UI_RT		 = CppEnums.RegionType
local UI_color 	 = Defines.Color

local regionName = UI.getChildControl ( Panel_Region, "RegionText" )
local regigonPlace = UI.getChildControl ( Panel_Region, "StaticText_Regiontext" )
local siegeHouse = UI.getChildControl ( Panel_Region, "StaticText_Siegetext" )

local isShowAlert = false;
local alertBackImg = UI.getChildControl ( Panel_Region, "Static_AlertPanel" )
local alertText = UI.getChildControl ( Panel_Region, "StaticText_Alert_NoticeText" )

local L_Line = UI.getChildControl ( Panel_Region, "Static_L_Line" )
local R_Line = UI.getChildControl ( Panel_Region, "Static_R_Line" )

function Region_ShowAni()
-- 패널 따로
	UIAni.fadeInSCR_MidOut(Panel_Region)
	-- -- _PA_LOG( 'Lua Debug', 'call RegionShow' )
	local aniInfo = Panel_Region:addColorAnimation( 0.0, 1.05, UI_ANI_ADV.PAUI_ANIM_ADVANCE_SIN_HALF_PI)
	aniInfo:SetStartColor( UI_color.C_00FFFFFF )
	aniInfo:SetEndColor( UI_color.C_FFFFFFFF )
	aniInfo.IsChangeChild = false

	-- 텍스트 따로
	local aniInfo2 = regionName:addColorAnimation( 0.0, 1.05, UI_ANI_ADV.PAUI_ANIM_ADVANCE_SIN_HALF_PI)
	aniInfo2:SetStartColor( UI_color.C_00FFFFFF )
	aniInfo2:SetEndColor( UI_color.C_FFFFFFFF )
	aniInfo2.IsChangeChild = false

	local aniInfo3 = regigonPlace:addColorAnimation( 0.0, 1.05, UI_ANI_ADV.PAUI_ANIM_ADVANCE_SIN_HALF_PI)
	aniInfo3:SetStartColor( UI_color.C_00FFFFFF )
	aniInfo3:SetEndColor( UI_color.C_FFFFFFFF )
	aniInfo3.IsChangeChild = false
	
	local aniInfo4 = siegeHouse:addColorAnimation( 0.0, 1.05, UI_ANI_ADV.PAUI_ANIM_ADVANCE_SIN_HALF_PI)
	aniInfo4:SetStartColor( UI_color.C_00FFFFFF )
	aniInfo4:SetEndColor( UI_color.C_FFFFFFFF )
	aniInfo4.IsChangeChild = false

	local aniInfo5 = L_Line:addColorAnimation( 0.0, 1.5, UI_ANI_ADV.PAUI_ANIM_ADVANCE_SIN_HALF_PI)
	aniInfo5:SetStartColor( UI_color.C_00FFFFFF )
	aniInfo5:SetEndColor( UI_color.C_FFFFFFFF )
	aniInfo5.IsChangeChild = false

	local aniInfo6 = R_Line:addColorAnimation( 0.0, 1.5, UI_ANI_ADV.PAUI_ANIM_ADVANCE_SIN_HALF_PI)
	aniInfo6:SetStartColor( UI_color.C_00FFFFFF )
	aniInfo6:SetEndColor( UI_color.C_FFFFFFFF )
	aniInfo6.IsChangeChild = false
	
	if isShowAlert  then

		local aniInfo_alsertImg = alertBackImg:addColorAnimation( 0.0, 1.05, UI_ANI_ADV.PAUI_ANIM_ADVANCE_SIN_HALF_PI)
		aniInfo_alsertImg:SetStartColor( UI_color.C_00FFFFFF )
		aniInfo_alsertImg:SetEndColor( UI_color.C_FFFFFFFF )
		aniInfo_alsertImg.IsChangeChild = false
		
		local aniInfo_alertText = alertText:addColorAnimation( 0.0, 1.05, UI_ANI_ADV.PAUI_ANIM_ADVANCE_SIN_HALF_PI)
		aniInfo_alertText:SetStartColor( UI_color.C_00FFFFFF )
		aniInfo_alertText:SetEndColor( UI_color.C_FFFFFFFF )
		aniInfo_alertText.IsChangeChild = false

	end
	
	
end

Panel_Region:RegisterUpdateFunc("Region_Close")

local _cumulateTime = 0
function Region_Close ( fDeltaTime )
	_cumulateTime = _cumulateTime + fDeltaTime
	if _cumulateTime >= 9.0 then
		Panel_Region:SetShow( false, true )
		_cumulateTime = 0
	end
end

function Region_HideAni()
	-- 꺼준다
	Panel_Region:SetShowWithFade(CppEnums.PAUI_SHOW_FADE_TYPE.PAUI_ANI_TYPE_FADE_OUT)
	local aniInfo6 = Panel_Region:addColorAnimation( 0.0, 1.5, UI_ANI_ADV.PAUI_ANIM_ADVANCE_COS_HALF_PI)
	aniInfo6:SetStartColor( UI_color.C_FFFFFFFF )
	aniInfo6:SetEndColor( UI_color.C_00FFFFFF )
	aniInfo6.IsChangeChild = true
	aniInfo6:SetHideAtEnd(true)
	aniInfo6:SetDisableWhileAni(true)
end

function Region_OnResize()
	local ScrX = getScreenSizeX()
	local ScrY = getScreenSizeY()

	Panel_Region:SetSize ( ScrX, 64 )
	Panel_Region:SetPosX ( 0 )
	Panel_Region:SetPosY ( ScrY - 250 )

	regionName:SetPosX ( ScrX / 2 - 256 )
	regigonPlace:SetPosX ( ScrX / 2 - 256 )
	siegeHouse:SetPosX ( ScrX / 2 - 256 )
	
	L_Line:SetSize ( ScrX / 2 - 278, 11 )
	R_Line:SetSize ( ScrX / 2 - 278, 11 )

	L_Line:SetPosX ( 0 )
	R_Line:SetPosX ( ScrX - (ScrX / 2) + 278)

	L_Line:SetPosY ( 32 )
	R_Line:SetPosY ( 32 )
	
	-- x 좌표를 계산
	alertBackImg:ComputePos();
	alertText:ComputePos();
	
	-- y 좌표는 직접 넣어준다.
	alertBackImg:SetPosY( - ScrY / 2 );
	alertText:SetPosY( - ScrY / 2 );
	
end

function Region_OnChangeRegion( regionData )

	if nil == regionData then
		Panel_Region:SetShow(false, false)
	else
		
		regionName:SetText ( regionData:getAreaName() )				-- 지역명 출력
		regigonPlace:SetText ( regionData:getTerritoryName() )		-- 영지명 출력
		local regionType = regionData:get():getRegionType()
		local isArenaZone = regionData:get():isArenaZone() 			-- 결투장
		
		if Panel_Npc_Dialog:GetShow() then
			return
		end

		Panel_Region:SetShow(true, true)
		
		if ( UI_RT.eRegionType_Siege == regionType ) then
			siegeHouse:SetShow( true )
			siegeHouse:SetText( PAGetString( Defines.StringSheet_GAME, "LUA_REGION_POSSIBLE_COMMAND_POST") )
			
		elseif ( UI_RT.eRegionType_Fortress == regionType ) then
			siegeHouse:SetShow( true )
			siegeHouse:SetText( PAGetString( Defines.StringSheet_GAME, "LUA_REGION_POSSIBLE_FORTESS") )

		else	
			siegeHouse:SetShow( false )
		end	
		
		local siegeWrapper = ToClient_GetSiegeWrapper(regionData:getTerritoryKeyRaw())
		if ( nil ~= siegeWrapper ) then
			local isSiegeBeing = siegeWrapper:isSiegeBeing()
			local isShow = (UI_RT.eRegionType_Siege == regionType) or (UI_RT.eRegionType_Fortress == regionType)
			
			isShowAlert = ( isSiegeBeing ) and ( isShow )
			
			if ( isArenaZone ) then
				isShowAlert = ( isArenaZone )
			end
		else
			isShowAlert = false
		end
		
		alertBackImg:SetShow( isShowAlert )
		alertText:SetShow( isShowAlert )
		if ( isArenaZone == true ) then
			alertText:SetText( PAGetString ( Defines.StringSheet_GAME, "LUA_ALERTMESSAGE_PVPZONE" ) )
		else
			alertText:SetText( PAGetString ( Defines.StringSheet_GAME, "LUA_ALERTMESSAGE_SIEGE" ) )
		end
	
		-- regionName:SetText ( tostring ( regionData:getNationalName() ) )			-- ?
		-- UI.debugMessage(tostring(regionData:getAreaName() ) )

		-- regionData:getTerritoryName()
		-- regionData:getAreaName()
		-- regionData:getNationalName()
	end
end

--[[ *************************** 메시지 처리 *************************** --]]
registerEvent("selfPlayer_regionChanged", "Region_OnChangeRegion")
registerEvent("onScreenResize", "Region_OnResize")
Region_OnResize()

--[[ *************************** 메시지 가 데이터 *************************** --]]
-- Region_OnChangeRegion('aa')



--------------------------------------------------
--					HELP 메시지
--------------------------------------------------
------------------------------
--			지역명
Panel_Region:SetHelpText( "네가 현재 어느 지역에 들어섰다는 것을 나타내지. 잠깐 나오고 사라져 자칫 지나쳐버릴 수 있지만, 신경쓰지 않고 있다가 위험한 지역에 들어설 수 있으니 주의해." )




