CppEnums.SiegeNotifyType =
{
	Insert		= 0,	-- 참전
	Unbuild		= 1,	-- 회수
	Destroy		= 2,	-- 파괴
	DestroyGate	= 3,	-- 문 파괴
}

local UI_ANI_ADV 		= CppEnums.PAUI_ANIM_ADVANCE_TYPE
local UI_TM				= CppEnums.TextMode
local UI_color			= Defines.Color

Panel_WarInfoMessage:SetShow( false, false )
Panel_WarInfoMessage:RegisterShowEventFunc( true, 'WarInfoMessageShowAni()' )
Panel_WarInfoMessage:RegisterShowEventFunc( false, 'WarInfoMessageHideAni()' )

local panel_BG			= UI.getChildControl(Panel_WarInfoMessage, "Static_BGTexture")
local panel_MainMessage	= UI.getChildControl(Panel_WarInfoMessage, "StaticText_MainMessage")
local panel_SubMessage	= UI.getChildControl(Panel_WarInfoMessage, "StaticText_SubMessage")
local panel_Effect		= UI.getChildControl(Panel_WarInfoMessage, "Static_Effect")
local onTime = 0

local chanege_BG = function( control, type )
	if 0 == type then		-- 어떤 성채 파괴
		control:ChangeTextureInfoName ( "New_UI_Common_forLua/Widget/WarInfoMessage/destroyGuildTent.dds" )
	elseif 1 == type then	-- 어떤 성채 추가
		control:ChangeTextureInfoName ( "New_UI_Common_forLua/Widget/WarInfoMessage/addGuildTent.dds" )
	elseif 2 == type then	-- 해방
		control:ChangeTextureInfoName ( "New_UI_Common_forLua/Widget/WarInfoMessage/newTerritoryOwner.dds" )
	elseif 3 == type then	-- 피격
		control:ChangeTextureInfoName ( "New_UI_Common_forLua/Widget/WarInfoMessage/attackGuildTent.dds" )
	elseif 4 == type then	-- 종료
		control:ChangeTextureInfoName ( "New_UI_Common_forLua/Widget/WarInfoMessage/newTerritoryOwner.dds" )
	elseif 5 == type then	-- 점령전 시작
		control:ChangeTextureInfoName ( "New_UI_Common_forLua/Widget/WarInfoMessage/startWars.dds" )
	elseif 6 == type then	-- 길드전 시작
		control:ChangeTextureInfoName ( "New_UI_Common_forLua/Widget/WarInfoMessage/guildWarStart.dds" )
	elseif 7 == type then	-- 길드전 종료
		control:ChangeTextureInfoName ( "New_UI_Common_forLua/Widget/WarInfoMessage/guildWarEnd.dds" )
	end
	local x1, y1, x2, y2 = setTextureUV_Func( control, 0, 0, 562, 128 )
	control:getBaseTexture():setUV(  x1, y1, x2, y2  )
	control:setRenderTexture(control:getBaseTexture())
	return control
end

local warMsgCheckPanel = UI.createPanel("warMsgCheckPanel", Defines.UIGroup.PAGameUIGroup_ModalDialog)
warMsgCheckPanel:SetSize(1,1)
warMsgCheckPanel:SetIgnore( true )
warMsgCheckPanel:SetHorizonCenter()
warMsgCheckPanel:SetVerticalTop()

local send_WarMsgPool = Array.new()

function send_WarMsgHandle( deltaTime )
	if not Panel_WarInfoMessage:GetShow() then
		local msg = send_WarMsgPool:pop_front()
		if nil == msg then
			warMsgCheckPanel:SetShow( false )
			return
		else
			panel_Effect:EraseAllEffect()
			if 0 == msg[0] then		-- 이탈
				panel_Effect:AddEffect ( "UI_CastleMinusLight", false, 0, 0 )
				-- ♬ 이탈 할 때
				audioPostEvent_SystemUi(15,02)
			elseif 1 == msg[0] then	-- 참전
				panel_Effect:AddEffect ( "UI_CastlePlusLight", false, 0, 0 )
				-- ♬ 난입 할 때
				audioPostEvent_SystemUi(15,01)
			elseif 2 == msg[0] then	-- 해방
				panel_Effect:AddEffect ( "UI_SiegeWarfare_Win", false, -19, 0 )
				panel_Effect:AddEffect ( "fUI_SkillAwakenBoom", false, -19, 0 )
				-- ♬ 해방될 때
				audioPostEvent_SystemUi(15,04)
			elseif 3 == msg[0] then	-- 피격
				panel_Effect:AddEffect ( "UI_SiegeWarfare_Alarm", true, -16, -22 )
				-- ♬ 내 성채가 맞을 때
				audioPostEvent_SystemUi(15,03)
			elseif 4 == msg[0] then	-- 종료
				panel_Effect:AddEffect ( "UI_SiegeWarfare_Win", false, -19, 0 )
				panel_Effect:AddEffect ( "fUI_SkillAwakenBoom", false, -19, 0 )
				-- ♬ 점령전이 종료 될 때
				audioPostEvent_SystemUi(15,04)
			elseif 5 == msg[0] then	-- 점령전 시작
				panel_Effect:AddEffect ( "UI_SiegeWarfare_Win_Green", false, -19, 0 )
				panel_Effect:AddEffect ( "fui_skillawakenboom_green", false, -19, 0 )
				-- ♬ 점령전이 시작 될 때
				audioPostEvent_SystemUi(15,00)
			elseif 6 == msg[0] then	-- 길드 전쟁 시작
				panel_Effect:AddEffect ( "UI_SiegeWarfare_Win_Red", false, -19, 0 )
				panel_Effect:AddEffect ( "fui_skillawakenboom_red", false, -19, 0 )
				-- ♬ 길드전이 시작 될 때
				audioPostEvent_SystemUi(15,04)
			elseif 7 == msg[0] then	-- 길드 전쟁 종료
				panel_Effect:AddEffect ( "UI_SiegeWarfare_Win_Red", false, -19, 0 )
				panel_Effect:AddEffect ( "fui_skillawakenboom_red", false, -19, 0 )
				-- ♬ 길드전이 종료 될 때
				audioPostEvent_SystemUi(15,04)
			end

			chanege_BG( panel_BG, msg[0] )
			panel_MainMessage:SetText( msg[1] )
			panel_SubMessage:SetText( msg[2] )
			Panel_WarInfoMessage:SetShow( true, true )
		end
	end
end
warMsgCheckPanel:RegisterUpdateFunc("send_WarMsgHandle")


function WarInfoMessageShowAni()
	local aniInfo1 = Panel_WarInfoMessage:addScaleAnimation( 0.0, 0.05, UI_ANI_ADV.PAUI_ANIM_ADVANCE_COS_HALF_PI)
	aniInfo1:SetStartScale(0.8)
	aniInfo1:SetEndScale(1.3)
	aniInfo1.AxisX = Panel_WarInfoMessage:GetSizeX() / 2
	aniInfo1.AxisY = Panel_WarInfoMessage:GetSizeY() / 2
	aniInfo1.ScaleType = 2
	aniInfo1.IsChangeChild = true
	
	local aniInfo2 = Panel_WarInfoMessage:addScaleAnimation( 0.05, 0.15, UI_ANI_ADV.PAUI_ANIM_ADVANCE_COS_HALF_PI)
	aniInfo2:SetStartScale(1.3)
	aniInfo2:SetEndScale(1.0)
	aniInfo2.AxisX = Panel_WarInfoMessage:GetSizeX() / 2
	aniInfo2.AxisY = Panel_WarInfoMessage:GetSizeY() / 2
	aniInfo2.ScaleType = 2
	aniInfo2.IsChangeChild = true
end
function WarInfoMessageHideAni()
	local aniInfo1 = Panel_WarInfoMessage:addColorAnimation( 0.0, 0.15, UI_ANI_ADV.PAUI_ANIM_ADVANCE_SIN_HALF_PI)
	aniInfo1:SetStartColor( UI_color.C_FFFFFFFF )
	aniInfo1:SetEndColor( UI_color.C_00FFFFFF )
	aniInfo1:SetStartIntensity( 3.0 )
	aniInfo1:SetEndIntensity( 1.0 )
	aniInfo1.IsChangeChild = true
	aniInfo1:SetHideAtEnd(true)
	aniInfo1:SetDisableWhileAni(true)
end

--------------------------------------------------------------------------------
-- 점령함
--------------------------------------------------------------------------------
function FromClient_NotifyOccupySiege( territoryKeyRaw, guildName )
	local territoryKey	= getTerritoryByIndex( territoryKeyRaw )
	local territoryName	= getTerritoryNameByKey( territoryKey )

	local msg_type	= 4
	local msg_Main	= "<PAColor0xffcab120>" .. territoryName .. " 점령전이 종료됐습니다.<PAOldColor>"
	local msg_Sub	= "<PAColor0xfffff179>이제 <PAColor0xffffffff>" .. territoryName .. "<PAOldColor><PAColor0xfffff179>은 <PAOldColor><PAColor0xffffffff>" .. guildName .. "<PAOldColor><PAColor0xfffff179> 길드의 관리를 받습니다.<PAOldColor>"

	local message = { main = msg_Main, sub = msg_Sub, addMsg = "" }
	Proc_ShowMessage_Ack_For_RewardSelect( message, 4, 11 )

	-- send_WarMsgPool:push_back( { [0] = msg_type, [1] = msg_Main, [2] = msg_Sub } )

	-- if not warMsgCheckPanel:GetShow() then
	-- 	warMsgCheckPanel:SetShow( true )
	-- end
end

--------------------------------------------------------------------------------
-- 해방됨
--------------------------------------------------------------------------------
function FromClient_NotifyReleaseSiege( territoryKeyRaw )
	local territoryKey	= getTerritoryByIndex( territoryKeyRaw )
	local territoryName	= getTerritoryNameByKey( territoryKey )

	local msg_type	= 2
	local msg_Main	= "<PAColor0xffc29d0a>" .. territoryName .. "이 해방됐습니다.<PAOldColor>"
	local msg_Sub	= "<PAColor0xffcab120>" .. territoryName .. " 점령 길드가 패배했습니다.<PAOldColor>"

	local message = { main = msg_Main, sub = msg_Sub, addMsg = "" }
	Proc_ShowMessage_Ack_For_RewardSelect( message, 4, 11 )

	-- send_WarMsgPool:push_back( { [0] = msg_type, [1] = msg_Main, [2] = msg_Sub } )

	-- if not warMsgCheckPanel:GetShow() then
	-- 	warMsgCheckPanel:SetShow( true )
	-- end
end


--------------------------------------------------------------------------------
-- 성채 추가, 파괴, 삭제
--------------------------------------------------------------------------------
function	FromClient_NotifyKingOrLordTentChange( notifyType, territoryKeyRaw, guildName, guildNamePeer )
	-- CppEnums.SiegeNotifyType 참조.
	-- UI.debugMessage( tostring(notifyType) .. "/" .. tostring(territoryKeyRaw) .. "/" .. tostring(guildName) .. "/" .. tostring(guildNamePeer)  )
	local	territoryKey		= getTerritoryByIndex( territoryKeyRaw )
	local	territoryName		= getTerritoryNameByKey( territoryKey )
	local	count_CompleteTent	= getCompleteKingOrLordTentCount( territoryKeyRaw )
	local	msg_type			= nil
	local	msg_Main			= nil
	local	msg_Sub				= nil
					
	if	( CppEnums.SiegeNotifyType.Insert == notifyType )	then
		msg_type	= 1
		msg_Main	= "<PAColor0xff00d8ff>" .. guildName .. " 길드 참전<PAOldColor>" 
		msg_Sub		= "<PAColor0xff9cf7ff>" .. territoryName .. " 점령전은 " .. count_CompleteTent .. "개 길드가 참전중입니다.<PAOldColor>"

		local message = { main = msg_Main, sub = msg_Sub, addMsg = "" }
		Proc_ShowMessage_Ack_For_RewardSelect( message, 4, 12 )

	elseif	( CppEnums.SiegeNotifyType.Unbuild == notifyType )	then
		msg_type	= 0
		msg_Main	= "<PAColor0xffff0000>" .. guildName .. "길드 점령전 철수<PAOldColor>" 
		msg_Sub		= "<PAColor0xffff6363>" .. territoryName .. " 점령전은 " .. count_CompleteTent .. "개 길드가 참전중입니다.<PAOldColor>"

		local message = { main = msg_Main, sub = msg_Sub, addMsg = "" }
		Proc_ShowMessage_Ack_For_RewardSelect( message, 4, 13 )

	elseif	( CppEnums.SiegeNotifyType.Destroy == notifyType )	then
		msg_type	= 0
		msg_Main	= "<PAColor0xffff0000>" .. guildNamePeer .. "길드가 " .. guildName .. "길드 지휘소/성채 파괴<PAOldColor>" 
		msg_Sub		= "<PAColor0xffff6363>" .. territoryName .. " 점령전은 " .. count_CompleteTent .. "개 길드가 참전중입니다.<PAOldColor>"

		local message = { main = msg_Main, sub = msg_Sub, addMsg = "" }
		Proc_ShowMessage_Ack_For_RewardSelect( message, 43, 13 )

	elseif	( CppEnums.SiegeNotifyType.DestroyGate == notifyType )	then
		msg_type	= 0
		msg_Main	= "<PAColor0xffff0000>" .. territoryName .. " 성문 파괴<PAOldColor>" 
		msg_Sub		= "<PAColor0xffff6363>" .. territoryName .. " 점령전은 " .. count_CompleteTent .. "개 길드가 참전중입니다.<PAOldColor>"

		local message = { main = msg_Main, sub = msg_Sub, addMsg = "" }
		Proc_ShowMessage_Ack_For_RewardSelect( message, 4, 13 )

	else
		return
	end
	
	-- send_WarMsgPool:push_back( { [0] = msg_type, [1] = msg_Main, [2] = msg_Sub } )
	
	-- if not warMsgCheckPanel:GetShow() then
	-- 	warMsgCheckPanel:SetShow( true )
	-- end
end


Panel_WarInfoMessage:RegisterUpdateFunc('warInfoMessage_check')
function warInfoMessage_check( deltaTime )
	onTime = onTime + deltaTime
	if 4 < onTime and Panel_WarInfoMessage:GetShow() then
		Panel_WarInfoMessage:SetShow( false, false )
		onTime = 0
	end
	if 6 < onTime then
		onTime = 0
	end
end

--------------------------------------------------------------------------------
-- 내 성채 피격
--------------------------------------------------------------------------------
function	FromClient_NotifyAttackedKingOrLoadTent( percent, territoryKeyRaw )
	if percent < 0 then
		return
	end

	local msg_type	= 3
	local msg_Main	= nil
	if percent <= 600000 and 300001 <= percent then
		msg_Main = PAGetStringParam2( Defines.StringSheet_GAME, "LUA_GUILD_ATTACKEDKINGORLOADTENT_UNDER", "Percent", 60, "left_HP", string.format( "%.1f", percent/10000 ) )
		-- 내구도가 {Percent}% 미만입니다. (내구도 {left_HP}%)
	elseif percent <= 300000 then
		msg_Main = PAGetStringParam2( Defines.StringSheet_GAME, "LUA_GUILD_ATTACKEDKINGORLOADTENT_DANGER", "Percent", 30, "left_HP", string.format( "%.1f", percent/10000 ) )
		-- 위험합니다. 내구도가 {Percent}% 미만입니다. (내구도 {left_HP}%)
	else
		msg_Main = PAGetStringParam1( Defines.StringSheet_GAME, "LUA_GUILD_ATTACKEDKINGORLOADTENT_NOTY", "Percent", string.format( "%.1f", percent/10000 ) )
		-- 내구도가 {Percent}% 남았습니다.
	end
	msg_Main = "<PAColor0xffaf1426>" .. msg_Main .. "<PAOldColor>"
	local msg_Sub	= "<PAColor0xfff14152>" .. PAGetString(Defines.StringSheet_GAME, "Lua_Guild_AttackedKingOrLoadTent") .. "<PAOldColor>"	-- 지휘소 혹은 성채가 공격 받고 있습니다.
	
	local message = { main = msg_Main, sub = msg_Sub, addMsg = "" }
	Proc_ShowMessage_Ack_For_RewardSelect( message, 4, 14 )

	-- send_WarMsgPool:push_back( { [0] = msg_type, [1] = msg_Main, [2] = msg_Sub } )

	-- if not warMsgCheckPanel:GetShow() then
	-- 	warMsgCheckPanel:SetShow( true )
	-- end
end

--------------------------------------------------------------------------------
-- 내 성채 파괴
--------------------------------------------------------------------------------
function FromClient_KingOrLordTentDestroy( notifyType, territoryKeyRaw )
	-- 어느 영지의 내 성채가 파괴 됐다.
	-- CppEnums.SiegeNotifyType 참조.

	local territoryKey	= getTerritoryByIndex( territoryKeyRaw )
	local territoryName	= getTerritoryNameByKey( territoryKey )

	local msg_type	= 3
	local msg_Main	= "<PAColor0xffaf1426>점령전에서 패배했습니다.<PAOldColor>"
	
	local msg_Sub = ""
	if( 1 == notifyType ) then --해체
		msg_Sub	= "<PAColor0xfff14152>" .. territoryName .. "의 지휘소/성채가 해체됐습니다.<PAOldColor>"
	else
		msg_Sub	= "<PAColor0xfff14152>" .. territoryName .. "의 지휘소/성채가 파괴됐습니다.<PAOldColor>"
	end
	
	local message = { main = msg_Main, sub = msg_Sub, addMsg = "" }
	Proc_ShowMessage_Ack_For_RewardSelect( message, 4, 14 )

	-- send_WarMsgPool:push_back( { [0] = msg_type, [1] = msg_Main, [2] = msg_Sub } )

	-- if not warMsgCheckPanel:GetShow() then
	-- 	warMsgCheckPanel:SetShow( true )
	-- end
end

--------------------------------------------------------------------------------
-- 길드 vs 길드
--------------------------------------------------------------------------------
function FromClient_NotifyGuildWar( msgType, guildName, targetGuildName )
	local msg_type	= nil
	local msg_Main	= nil
	local msg_Sub	= nil

	if( 0 == msgType ) then
		msg_type	= 6
		msg_Main	= "<PAColor0xffaf1426>길드 전쟁이 시작됩니다.<PAOldColor>"
		msg_Sub		= "<PAColor0xfff14152>" .. guildName .. " 길드가 " .. targetGuildName .. " 길드에 전쟁을 선포했습니다.<PAOldColor>"

		local message = { main = msg_Main, sub = msg_Sub, addMsg = "" }
		Proc_ShowMessage_Ack_For_RewardSelect( message, 4, 15 )
	elseif( 1 == msgType ) then
		msg_type	= 7
		msg_Main	= "<PAColor0xff9a9a9a>길드 전쟁이 종료됩니다.<PAOldColor>"
		msg_Sub		= "<PAColor0xffd3d3d3>" .. guildName .. " 길드가 " .. targetGuildName .. " 길드와의 전쟁을 철회했습니다.<PAOldColor>"

		local message = { main = msg_Main, sub = msg_Sub, addMsg = "" }
		Proc_ShowMessage_Ack_For_RewardSelect( message, 4, 16 )
	elseif( 2 == msgType ) then
		msg_type	= 7
		msg_Main	= "<PAColor0xff9a9a9a>길드가 해산되었습니다.<PAOldColor>"
		msg_Sub		= "<PAColor0xffd3d3d3>전쟁 중인 " .. targetGuildName .. " 길드가 해산되었습니다.<PAOldColor>"

		local message = { main = msg_Main, sub = msg_Sub, addMsg = "" }
		Proc_ShowMessage_Ack_For_RewardSelect( message, 4, 16 )
	end

	-- send_WarMsgPool:push_back( { [0] = msg_type, [1] = msg_Main, [2] = msg_Sub } )

	-- if not warMsgCheckPanel:GetShow() then
	-- 	warMsgCheckPanel:SetShow( true )
	-- end
end

--------------------------------------------------------------------------------
-- 점령전 시작!!!!!!!!!
--------------------------------------------------------------------------------
function FromClient_NotifyStartSiege( msgtype,  territoryKeyRaw )
	-- msgtype = int : 0 시작, 1 진행중
	_PA_LOG("김창욱", "FromClient_NotifyStartSiege : " .. msgtype .. "/" .. territoryKeyRaw)
	local territoryKey	= getTerritoryByIndex( territoryKeyRaw )
	local territoryName	= getTerritoryNameByKey( territoryKey )

	-- 영지 키 입력
	local selfPlayer = getSelfPlayer();
	local regionInfoWrapper = getRegionInfoWrapper(selfPlayer:getRegionKeyRaw())
	if (nil == regionInfoWrapper) then
		Proc_ShowMessage_Ack("플레이어의 현재위치가 비정상적입니다")
		return
	end	
	
	local isSelfPlayerLocal = false
	if territoryKeyRaw == regionInfoWrapper:getTerritoryKeyRaw() then
		isSelfPlayerLocal = true;
	end
	
	if 1 == msgtype then 
		if( isSelfPlayerLocal ) then
			local msg_type	= 5
			local msg_Main	= "<PAColor0xff3a811b>" .. territoryName .."점령전이 진행되고 있습니다.<PAOldColor>"
			local msg_Sub	= "<PAColor0xff81ac2d>준비하신 여러분의 승전을 기원합니다.<PAOldColor>"

			local message = { main = msg_Main, sub = msg_Sub, addMsg = "" }
			Proc_ShowMessage_Ack_For_RewardSelect( message, 4, 10 )
			-- send_WarMsgPool:push_back( { [0] = msg_type, [1] = msg_Main, [2] = msg_Sub } )

			-- if not warMsgCheckPanel:GetShow() then
			-- 	warMsgCheckPanel:SetShow( true )
			-- end
		end
		
	elseif 0 == msgtype then
		if( isSelfPlayerLocal ) then
			local msg_type	= 5
			local msg_Main	= "<PAColor0xff3a811b>" .. territoryName .. " 점령전이 시작됩니다.<PAOldColor>"
			local msg_Sub	= "<PAColor0xff81ac2d>준비하신 여러분의 승전을 기원합니다.<PAOldColor>"

			local message = { main = msg_Main, sub = msg_Sub, addMsg = "" }
			Proc_ShowMessage_Ack_For_RewardSelect( message, 4, 10 )

			-- send_WarMsgPool:push_back( { [0] = msg_type, [1] = msg_Main, [2] = msg_Sub } )

			-- if not warMsgCheckPanel:GetShow() then
			-- 	warMsgCheckPanel:SetShow( true )
			-- end
		end
	end
end




--------------------------------------------------------------------------------
-- 플레이어 Kill or Death
--------------------------------------------------------------------------------
local killDeathScore ={
	content		= UI.getChildControl(Panel_TerritoryWarKillingScore, "Static_Content"),
}
local TWKScore_PosIndex		= 0
local TWKScore_PanelCount	= 3
local TWKScore_PanelUIPool	= {}
local TWKScore_AlertList	= {}
local create_TWKScore_Panel	= function()
	for panel_idx = 1, TWKScore_PanelCount do
		local panel = UI.createPanel("territoryWar_KillDeathScore_Panel_" .. panel_idx, Defines.UIGroup.PAGameUIGroup_ModalDialog)
		-- CopyBaseProperty( Panel_TerritoryWarKillingScore, panel )
		panel:SetSize( 370, 35 )
		panel:SetIgnore( true )
		panel:SetHorizonCenter()
		panel:SetShow(false, false)

		local panel_StaticText	= UI.createAndCopyBasePropertyControl( Panel_TerritoryWarKillingScore, "Static_Content", panel, "territoryWar_KillDeathScore_Panel_" .. panel_idx .."_StaticText" )
		CopyBaseProperty(killDeathScore.content, panel_StaticText)
		panel_StaticText:SetIgnore( true )
		panel_StaticText:SetShow(true)
		panel_StaticText:SetSize( 370, 35 )


		TWKScore_PanelUIPool[panel_idx] = panel
		TWKScore_AlertList[panel_idx]	= panel_StaticText

	end
end
create_TWKScore_Panel()

local TWKScore_Open = function(panel)
	-- ♬ 시스템 메시지가 나올 때 사운드 추가
	audioPostEvent_SystemUi(04,04)
	
	panel:SetShow(true, false)	
	panel:ResetVertexAni()
	panel:SetScaleChild( 1, 1 )

	-- 켜기
	local aniInfo = panel:addColorAnimation( 0.0, 0.25, UI_ANI_ADV.PAUI_ANIM_ADVANCE_SIN_HALF_PI)
	aniInfo:SetStartColor( UI_color.C_00FFFFFF )
	aniInfo:SetEndColor( UI_color.C_FFFFFFFF )
	aniInfo.IsChangeChild = true

	-- 꺼준다
	local aniInfo3 = panel:addColorAnimation( 0.26, 8.0, UI_ANI_ADV.PAUI_ANIM_ADVANCE_SIN_HALF_PI)
	aniInfo3:SetStartColor( UI_color.C_FFFFFFFF )
	aniInfo3:SetEndColor( UI_color.C_00FFFFFF )
	aniInfo3.IsChangeChild = true
	
	local aniInfo4 = panel:addScaleAnimation( 8.0, 8.25, UI_ANI_ADV.PAUI_ANIM_ADVANCE_SIN_HALF_PI)
	aniInfo4:SetStartScale(1.0)
	aniInfo4:SetEndScale(0)
	aniInfo4.IsChangeChild = true
end

local TWKScore_updatePosition = function()
	-- local centerPos = ( getScreenSizeX() / 2) - (Panel_TerritoryWarKillingScore:GetSizeX() / 2)
	--한칸씩 위로 올림.
	for index = 1, TWKScore_PanelCount, 1 do
		local realIndex = ( index - TWKScore_PosIndex + 5 ) % TWKScore_PanelCount + 1
		local panel = TWKScore_PanelUIPool[index]
		if (panel:IsShow()) then
			-- panel:SetPosX( centerPos )	
			panel:SetPosY( Panel_WarInfoMessage:GetPosY() + (Panel_TerritoryWarKillingScore:GetSizeY() * realIndex) + 5 )	
		end
	end
end

function	FromClient_NotifyKillOrDeathPlayer( isKill, characterName, characterNamePeer, guildNamePeer )
	TWKScore_PosIndex = (TWKScore_PosIndex % TWKScore_PanelCount ) + 1

	local targetControl = TWKScore_AlertList[TWKScore_PosIndex]
	if isKill then
		targetControl:SetText( PAGetStringParam3( Defines.StringSheet_GAME, "LUA_GUILD_ATTACKEDKINGORLOADTENT_TARGETCONTROL1", "characterName", characterName, "guildNamePeer", guildNamePeer, "characterNamePeer", characterNamePeer ) )  -- characterName .. " : " .. guildNamePeer .. " 길드 - " .. characterNamePeer .. " 사살"
		targetControl:ChangeTextureInfoName ( "New_UI_Common_forLua/Widget/WarInfoMessage/score_KillingEnemy.dds" )
		targetControl:SetFontColor( 4282165742 )
	else
		targetControl:SetText ( PAGetStringParam3( Defines.StringSheet_GAME, "LUA_GUILD_ATTACKEDKINGORLOADTENT_TARGETCONTROL2", "characterName", characterName, "guildNamePeer", guildNamePeer, "characterNamePeer", characterNamePeer ) )  -- characterName .. " : " .. guildNamePeer .. " 길드 - " .. characterNamePeer .. "에 의해 사망"
		targetControl:ChangeTextureInfoName ( "New_UI_Common_forLua/Widget/WarInfoMessage/score_DeathAlly.dds" )
		targetControl:SetFontColor( 4294057271 )
	end

	local x1, y1, x2, y2 = setTextureUV_Func( targetControl, 0, 0, 370, 35 )
	targetControl:getBaseTexture():setUV(  x1, y1, x2, y2  )
	targetControl:setRenderTexture(targetControl:getBaseTexture())

	TWKScore_Open(TWKScore_PanelUIPool[TWKScore_PosIndex])
	TWKScore_updatePosition()
end



registerEvent("FromClient_KillOrDeathPlayer",				"FromClient_NotifyKillOrDeathPlayer")			-- Player 킬 변화
registerEvent("FromClient_KingOrLordTentChange",			"FromClient_NotifyKingOrLordTentChange")		-- 성채/지휘소 변화
registerEvent("FromClient_OccupySiege",						"FromClient_NotifyOccupySiege")					-- 점령 : 인자 territoryKeyRaw, guildName
registerEvent("FromClient_ReleaseSiege",					"FromClient_NotifyReleaseSiege")				-- 해방 : 인자 territoryKeyRaw
registerEvent("FromClient_NotifyAttackedKingOrLordTent",	"FromClient_NotifyAttackedKingOrLoadTent")		-- 내성채 피격 : 인자 : percent, territoryKeyRaw
registerEvent("FromClient_KingOrLordTentDestroy", 			"FromClient_KingOrLordTentDestroy")				-- 내 성채 파괴 : 인자 : territoryKeyRaw
registerEvent("FromClient_NotifyGuildWar",					"FromClient_NotifyGuildWar")					-- 전쟁 선포 : 인자 : msgType(int), guildName, targetGuildName
registerEvent("FromClient_NotifyStartSiege",				"FromClient_NotifyStartSiege")					-- 점령전 시작 : 인자 msgtype(int), territoryKey(int)