Panel_Manufacture:ActiveMouseEventEffect(true)
Panel_Manufacture:SetShow(false,false)
Panel_Manufacture:setGlassBackground(true)

Panel_Manufacture:RegisterShowEventFunc( true, 'ManufactureShowAni()' )
Panel_Manufacture:RegisterShowEventFunc( false, 'ManufactureHideAni()' )

registerEvent("Event_ManufactureUpdateSlot", "Manufacture_Response") -- 개수 모자람
registerEvent("EventShowManufactureWindow", "Manufacture_ToggleWindow")
registerEvent("Event_ManufactureResultList", "Manufacture_ResponseResultItem")

local IM 			= CppEnums.EProcessorInputMode
local UI_PSFT 		= CppEnums.PAUI_SHOW_FADE_TYPE
local UI_ANI_ADV 	= CppEnums.PAUI_ANIM_ADVANCE_TYPE
local UI_color 		= Defines.Color
local UIMode 		= Defines.UIMode

-- 액션 차트에 있는 액션과 이름이 같아야한다~!!!!
local _ACTIONNAME_SHAKE 		= "MANUFACTURE_SHAKE"
local _ACTIONNAME_GRIND 		= "MANUFACTURE_GRIND"
local _ACTIONNAME_FIREWOOD 		= "MANUFACTURE_FIREWOOD"
local _ACTIONNAME_DRY 			= "MANUFACTURE_DRY"
local _ACTIONNAME_THINNING 		= "MANUFACTURE_THINNING"
local _ACTIONNAME_HEAT			= "MANUFACTURE_HEAT"
local _ACTIONNAME_RAINWATER		= "MANUFACTURE_RAINWATER"

local _ACTIONNAME_REPAIR		= "REPAIR_ITEM"

local MAX_ACTION_BTN			=  8 --9
local SUBTEXT_OFFSETX			= 60
local SUBTEXT_OFFSETY			= 17
local ACTION_BTN_HEIGHT			= 50

local invenShow					= false

local INSTALLATIONTYPE_ACTIONNAME = {}
INSTALLATIONTYPE_ACTIONNAME[ CppEnums.InstallationType.eType_Mortar ] = _ACTIONNAME_GRIND
INSTALLATIONTYPE_ACTIONNAME[ CppEnums.InstallationType.eType_Stump ] = _ACTIONNAME_FIREWOOD
INSTALLATIONTYPE_ACTIONNAME[ CppEnums.InstallationType.eType_FireBowl ] = _ACTIONNAME_HEAT
INSTALLATIONTYPE_ACTIONNAME[ CppEnums.InstallationType.eType_Anvil ] = _ACTIONNAME_REPAIR

local _defaultSlotNo = 255

local _materialSlotNoList = { [0] = _defaultSlotNo, _defaultSlotNo, _defaultSlotNo, _defaultSlotNo, _defaultSlotNo }
local _materialSlotNoListItemIn = { [0] = false, false, false, false, false }

local _actionIndex	   = -1 -- 0. 흔들어 섞기 1. 빻기 2. 장작 패기 3. 말리기 4. 솎아내기 5. 가열하기 6. 빗물 받기 7. 수리하기
local _actionName	   = "NONE"

local _usingInstallationType = CppEnums.InstallationType.TypeCount

local _listAction = {}
local manufactureAction =
{
	_radioBtn,
	_subText,
	_actionName
}

local manufactureListDesc =
{
	[0] = "GAME_MANUFACTURE_DESC_SHAKE",
	[1] = "GAME_MANUFACTURE_DESC_GRIND",
	[2] = "GAME_MANUFACTURE_DESC_FIREWOOD",
	[3] = "GAME_MANUFACTURE_DESC_DRY",
	[4] = "GAME_MANUFACTURE_DESC_THINNING",
	[5] = "GAME_MANUFACTURE_DESC_HEAT",
	[6] = "GAME_MANUFACTURE_DESC_RAINWATER", 
	[7] = "GAME_MANUFACTURE_DESC_REPAIR",
}

local manufactureListName =
{
	[0] = "ALCHEMY_MANUFACTURE_SHAKE",
	[1] = "ALCHEMY_MANUFACTURE_GRIND",
	[2] = "ALCHEMY_MANUFACTURE_WOODSPLITTING",
	[3] = "ALCHEMY_MANUFACTURE_DRY",
	[4] = "ALCHEMY_MANUFACTURE_THINNING",
	[5] = "ALCHEMY_MANUFACTURE_HEATING",
	[6] = "", 
	[7] = "ALCHEMY_MANUFACTURE_REPAIR",
}

local _usingItemSlotCount	= 0 -- 0. 흔들어 섞기(2) 1. 빻기(1) 2. 장작 패기(1) 3. 말리기(1) 4. 솎아내기(1) 5. 가열하기(2) 6. 빗물 받기(1) 7. 수리하기(1)
local _whiteCircle = UI.getChildControl ( Panel_Manufacture, "Static_WhiteCircle" )

local _slotConfig =
{	-- 일단 아이콘, 테두리, 카운트(숫자) 만 적용한다!
	createIcon		= true,
	createBorder	= false,
	createCount		= true,
	createCash		= true
}

local _slotCount = 5
local _pointList = {}

for ii=0 , _slotCount-1 do
	_pointList[ii] = UI.getChildControl ( Panel_Manufacture, "Static_Point_" ..ii+1 )
	_pointList[ii]:SetShow(false)
end

local _slotList = {}
for index = 0, _slotCount-1, 1 do
	local createdSlot = {}
	SlotItem.new( createdSlot, 'ItemIconSlot'..index , 0, Panel_Manufacture, _slotConfig )
	createdSlot:createChild()
	createdSlot.icon:addInputEvent( "Mouse_RUp",  "Material_Mouse_RUp(" ..index.. ")" )
	createdSlot.icon:addInputEvent( "Mouse_On",  "Material_Mouse_On(" ..index.. ")" )
	createdSlot.icon:addInputEvent( "Mouse_Out", "Material_Mouse_Out(" ..index.. ")" )
	_slotList[index] = createdSlot
end

local SLOT_POSITION = {}
-- 사용하는 슬롯이 하나일때 첫번째 X,Y
SLOT_POSITION[0] = { [0] = {80, 158}  }
-- 사용하는 슬롯이 두개
SLOT_POSITION[1] = { [0] = {80, 158}, [1] = {80, 307 } } 
-- 사용하는 슬롯이 세개
SLOT_POSITION[2] = { [0] = {80, 158}, [1] = {80, 205}, [2] = {80, 245} } 
-- 사용하는 슬롯이 네개
SLOT_POSITION[3] = { [0] = {80, 158}, [1] = {80, 200}, [2] = {80, 240}, [3] = {80, 280} }
-- 사용하는 슬롯이 다섯개
SLOT_POSITION[4] = { [0] = {80, 158}, [1] = {80, 200}, [2] = {80, 240}, [3] = {80, 280}, [4] = {80, 320} }


local _manufactureText = UI.getChildControl ( Panel_Manufacture, "StaticText_CircleName" )
_manufactureText:SetShow(false)

local _uiButtonManufacture = UI.getChildControl( Panel_Manufacture, "Button_Manufacture")
_uiButtonManufacture:addInputEvent( "Mouse_LUp",  "Manufacture_Mouse_LUp()" )
_uiButtonManufacture:addInputEvent( "Mouse_On",  "Manufacture_Mouse_On()" )


local _uiButtonClose = UI.getChildControl( Panel_Manufacture, "Button_Close" )
_uiButtonClose:addInputEvent( "Mouse_LUp",  "Manufacture_Close()" )

local _buttonQuestion = UI.getChildControl( Panel_Manufacture, "Button_Question" )	-- 물음표 버튼
_buttonQuestion:addInputEvent( "Mouse_LUp",  "Panel_WebHelper_ShowToggle( \"PanelManufacture\" )" )	-- 물음표 마우스 좌클릭
_buttonQuestion:addInputEvent( "Mouse_On",  "HelpMessageQuestion_Show( \"PanelManufacture\", \"true\")" )		-- 물음표 마우스오버
_buttonQuestion:addInputEvent( "Mouse_Out",  "HelpMessageQuestion_Show( \"PanelManufacture\", \"false\")" )		-- 물음표 마우스아웃

local _textTemp 			= UI.getChildControl( Panel_Manufacture, "StaticText_Template" )
_textTemp:SetShow(false)
_textTemp:SetIgnore(true)
_textTemp:SetTextMode( CppEnums.TextMode.eTextMode_AutoWrap )

local _textDesc 			= UI.getChildControl( Panel_Manufacture, "StaticText_Desc" )
_textDesc:SetIgnore(true)
_textDesc:SetTextMode( CppEnums.TextMode.eTextMode_AutoWrap )
_textDesc:SetText("")

local _frame 				= UI.getChildControl( Panel_Manufacture, "Frame_Manufacture" )
local _frameContents 		= UI.getChildControl( _frame, 			"Frame_Contents" )
local _frameScroll			= UI.getChildControl( _frame, 			"Frame_Scroll" )
local _frameScroll_Btn		= UI.getChildControl( _frameScroll, 	"Scroll_Bar_CtrlButton" )

local Manufacture_Notify =
{
	_progress_BG 		= UI.getChildControl ( Panel_Manufacture_Notify, "Static_Progress_BG" ),
	_progress_Bar 		= UI.getChildControl ( Panel_Manufacture_Notify, "Progress2_Manufacture" ),
	_progress_Text 		= UI.getChildControl ( Panel_Manufacture_Notify, "StaticText_Manufacture_Progress" ),
	_progress_Effect	= UI.getChildControl ( Panel_Manufacture_Notify, "Static_Progress_Effect" ),
	_type_Name	 		= UI.getChildControl ( Panel_Manufacture_Notify, "StaticText_Manufacture_Type" ),	
	_result_Title 		= UI.getChildControl ( Panel_Manufacture_Notify, "StaticText_Result_Title" ),	
	
	_item_Resource 		= {},
	_icon_ResourceBG 	= {},
	_icon_Resource 		= {},
	_item_Result 		= {},
	_icon_ResultBG 		= {},
	_icon_Result 		= {},
	
	 _templat =
	{
		_item_Resource 		= UI.getChildControl ( Panel_Manufacture_Notify, "StaticText_ResourceItem" ),
		_icon_ResourceBG 	= UI.getChildControl ( Panel_Manufacture_Notify, "Static_ResourceIcon_BG" ),
		_icon_Resource 		= UI.getChildControl ( Panel_Manufacture_Notify, "Static_ResourceIcon" ),
		_item_Result 		= UI.getChildControl ( Panel_Manufacture_Notify, "StaticText_ResultItem" ),
		_icon_ResultBG 		= UI.getChildControl ( Panel_Manufacture_Notify, "Static_ResultIcon_BG" ),
		_icon_Result 		= UI.getChildControl ( Panel_Manufacture_Notify, "Static_ResultIcon" ),
	},
	
	_data_Resource 		= {},
	_data_Result 		= {},
	
	_gapY				= 20,
	_defalutSpanY		= 0,
	
	_failCount 			= 0,
	_successCount 		= 0,
}


local _defaultMSG1 	= UI.getChildControl ( Panel_Manufacture, "StaticText_DefaultMSG1" )	
_defaultMSG1:SetShow( false )
local _defaultMSG2 	= UI.getChildControl ( Panel_Manufacture, "StaticText_DefaultMSG2" )
_defaultMSG2:SetShow( false )

local _uiButtonNote = UI.getChildControl( Panel_Manufacture, "Button_Note" )			-- 제작노트
_uiButtonNote:addInputEvent( "Mouse_LUp", "Note_Mouse_LUp()" )
_uiButtonNote:addInputEvent( "Mouse_On", "Note_Mouse_On()" )

function ManufactureActionBtnTextInit( action, index , desc)
	action._subText = UI.createControl( CppEnums.PA_UI_CONTROL_TYPE.PA_UI_CONTROL_STATICTEXT, _frameContents, "actionBtnText"..index )
	CopyBaseProperty( _textTemp, action._subText )
	action._subText:SetPosX( action._radioBtn:GetPosX() + SUBTEXT_OFFSETX )
	action._subText:SetPosY( action._radioBtn:GetPosY() + SUBTEXT_OFFSETY )
	action._subText:SetText( desc )
	action._subText:ComputePos()
	action._subText:SetShow(true)
end

-------------------------------------------------------------------------------------
-- 지식 리스트
-------------------------------------------------------------------------------------

local _frameManufactureDesc		= UI.getChildControl ( Panel_Manufacture, 		"Frame_ManufactureDesc" )
local _frameContent				= UI.getChildControl ( _frameManufactureDesc, 	"Frame_1_Content" )
local _frameDescScroll			= UI.getChildControl ( _frameManufactureDesc, 	"VerticalScroll" )
local _frameDescScroll_Btn		= UI.getChildControl ( _frameDescScroll, 		"VerticalScroll_CtrlButton" )

local _uiKnowledgeDesc			= UI.getChildControl( _frameContent, "StaticText_KnowledgeDesc" )
_uiKnowledgeDesc:SetAutoResize(true)

local _uiKnowledgeIcon 			= UI.getChildControl( Panel_Manufacture, "Static_KnoeledgeIcon" )

local _uiListBG					= UI.getChildControl( Panel_Manufacture, "Static_ListBG" )
-- local _uiKnowledgeBG			= UI.getChildControl( Panel_Manufacture, "Static_KnowledgeBG" )

local _uiListScroll				= UI.getChildControl( Panel_Manufacture, "Scroll_Bar" )
_uiListScroll:GetControlButton():addInputEvent("Mouse_LPress","ManufactureKnowledge_ScrollEvent()" )
local _uiListScrollOriginPosX 	= _uiListScroll:GetPosX()

local _uiListSelect				= UI.getChildControl( Panel_Manufacture, "Static_SelectList" )
_uiListSelect:SetShow(false)
_uiListSelect:SetIgnore(true)

local TEMPLATE_KNOWLEDGE_TEXT = UI.getChildControl( Panel_Manufacture, "StaticText_KnowledgeRecipe" )
TEMPLATE_KNOWLEDGE_TEXT:SetShow(false)

local KNOWLEDGE_TEXT_COUNT = 14
local _uiListText	=	{}
for index = 0, KNOWLEDGE_TEXT_COUNT-1 do

	local tempText = UI.createControl( CppEnums.PA_UI_CONTROL_TYPE.PA_UI_CONTROL_STATICTEXT, _uiListBG, 'StaticText_AlchemyRecipe_' .. (index) )
	CopyBaseProperty( TEMPLATE_KNOWLEDGE_TEXT, tempText )

	tempText:SetPosX( 7 )
	tempText:SetPosY( 7 + (index*tempText:GetSizeY() ) )
	tempText:addInputEvent( "Mouse_UpScroll",	"ManufactureKnowledge_ScrollEvent( true )" )
	tempText:addInputEvent( "Mouse_DownScroll",	"ManufactureKnowledge_ScrollEvent( false )" )
	tempText:addInputEvent( "Mouse_LUp",  		"Manufacture_KnowledgeList_SelectKnowledge("..index..")" )
	tempText:SetIgnore( false )

	_uiListText[index] = tempText
end

local _startKnowledgeIndex = 0

local SHAKE_MENTALTHEMEKEY 		= 30200
local DRY_MENTALTHEMEKEY 		= 30300
local THINNING_MENTALTHEMEKEY 	= 30400
local GRIND_MENTALTHEMEKEY 		= 30500
local HEAT_MENTALTHEMEKEY		= 30600
local FIREWOOD_MENTALTHEMEKEY	= 30700

-- 나중에 넣어준다. 현재 없음
local RAINWATER_MENTALTHEMEKEY	= 30800

-- local _defaultMessage = nil

-------------------------------------------------------------------------------------
------
--------------------------------------------------------------------------------------
function ManufactureControlInit()

	local manufactureAction1 = {}
	manufactureAction1._actionName = _ACTIONNAME_SHAKE
	manufactureAction1._radioBtn = UI.getChildControl( _frameContents, "RadioButton_Action1" )
	manufactureAction1._radioBtn:SetText( PAGetString( Defines.StringSheet_GAME, "ALCHEMY_MANUFACTURE_SHAKE" ) )
	manufactureAction1._radioBtn:addInputEvent( "Mouse_LUp",  "Manufacture_Button_LUp_Shake(true)" )
	manufactureAction1._radioBtn:addInputEvent( "Mouse_On",  "Manufacture_Button_MouseOverFunc( 0 )" )
	ManufactureActionBtnTextInit( manufactureAction1, 1, PAGetString( Defines.StringSheet_GAME, "GAME_MANUFACTURE_DESC_SHAKE" ) )
	_listAction[0] = manufactureAction1

	local manufactureAction2 = {}
	manufactureAction2._actionName = _ACTIONNAME_GRIND
	manufactureAction2._radioBtn = UI.getChildControl( _frameContents, "RadioButton_Action2" )
	manufactureAction2._radioBtn:SetText( PAGetString( Defines.StringSheet_GAME, "ALCHEMY_MANUFACTURE_GRIND" ) )
	manufactureAction2._radioBtn:addInputEvent( "Mouse_LUp",  "Manufacture_Button_LUp_Grind(true)" )
	manufactureAction2._radioBtn:addInputEvent( "Mouse_On",  "Manufacture_Button_MouseOverFunc( 1 )" )
	ManufactureActionBtnTextInit( manufactureAction2, 2, PAGetString( Defines.StringSheet_GAME, "GAME_MANUFACTURE_DESC_GRIND" ) )
	_listAction[1] = manufactureAction2

	local manufactureAction3 = {}
	manufactureAction3._actionName = _ACTIONNAME_FIREWOOD
	manufactureAction3._radioBtn = UI.getChildControl( _frameContents, "RadioButton_Action3" )
	manufactureAction3._radioBtn:SetText( PAGetString( Defines.StringSheet_GAME, "ALCHEMY_MANUFACTURE_WOODSPLITTING" ) )
	manufactureAction3._radioBtn:addInputEvent( "Mouse_LUp",  "Manufacture_Button_LUp_FireWood(true)" )
	manufactureAction3._radioBtn:addInputEvent( "Mouse_On",  "Manufacture_Button_MouseOverFunc( 2 )" )
	ManufactureActionBtnTextInit( manufactureAction3, 3, PAGetString( Defines.StringSheet_GAME, "GAME_MANUFACTURE_DESC_FIREWOOD" ) )
	_listAction[2] = manufactureAction3

	local manufactureAction4 = {}
	manufactureAction4._actionName = _ACTIONNAME_DRY
	manufactureAction4._radioBtn = UI.getChildControl( _frameContents, "RadioButton_Action4" )
	manufactureAction4._radioBtn:SetText( PAGetString( Defines.StringSheet_GAME, "ALCHEMY_MANUFACTURE_DRY" ) )
	manufactureAction4._radioBtn:addInputEvent( "Mouse_LUp",  "Manufacture_Button_LUp_Dry(true)" )
	manufactureAction4._radioBtn:addInputEvent( "Mouse_On",  "Manufacture_Button_MouseOverFunc( 3 )" )
	ManufactureActionBtnTextInit( manufactureAction4, 4, PAGetString( Defines.StringSheet_GAME, "GAME_MANUFACTURE_DESC_DRY" ) )
	_listAction[3] = manufactureAction4

	local manufactureAction5 = {}
	manufactureAction5._actionName = _ACTIONNAME_THINNING
	manufactureAction5._radioBtn = UI.getChildControl( _frameContents, "RadioButton_Action5" )
	manufactureAction5._radioBtn:SetText( PAGetString( Defines.StringSheet_GAME, "ALCHEMY_MANUFACTURE_THINNING" ) )
	manufactureAction5._radioBtn:addInputEvent( "Mouse_LUp",  "Manufacture_Button_LUp_Thinning(true)" )
	manufactureAction5._radioBtn:addInputEvent( "Mouse_On",  "Manufacture_Button_MouseOverFunc( 4 )" )
	ManufactureActionBtnTextInit( manufactureAction5, 5, PAGetString( Defines.StringSheet_GAME, "GAME_MANUFACTURE_DESC_THINNING" ) )
	_listAction[4] = manufactureAction5

	local manufactureAction6 = {}
	manufactureAction6._actionName = _ACTIONNAME_HEAT
	manufactureAction6._radioBtn = UI.getChildControl( _frameContents, "RadioButton_Action6" )
	manufactureAction6._radioBtn:SetText( PAGetString( Defines.StringSheet_GAME, "ALCHEMY_MANUFACTURE_HEATING" ) )
	manufactureAction6._radioBtn:addInputEvent( "Mouse_LUp",  "Manufacture_Button_LUp_Heat(true)" )
	manufactureAction6._radioBtn:addInputEvent( "Mouse_On",  "Manufacture_Button_MouseOverFunc( 5 )" )
	ManufactureActionBtnTextInit( manufactureAction6, 6, PAGetString( Defines.StringSheet_GAME, "GAME_MANUFACTURE_DESC_HEAT" ) )
	_listAction[5] = manufactureAction6

	local manufactureAction7 = {}
	manufactureAction7._actionName = _ACTIONNAME_RAINWATER
	manufactureAction7._radioBtn = UI.getChildControl( _frameContents, "RadioButton_Action7" )
	manufactureAction7._radioBtn:SetText( PAGetString( Defines.StringSheet_GAME, "GAME_MANUFACTURE_RAINWATER" ) )
	manufactureAction7._radioBtn:addInputEvent( "Mouse_LUp",  "Manufacture_Button_LUp_Rainwater(true)" )
	manufactureAction7._radioBtn:addInputEvent( "Mouse_On",  "Manufacture_Button_MouseOverFunc( 6 )" )
	ManufactureActionBtnTextInit( manufactureAction7, 7, PAGetString( Defines.StringSheet_GAME, "GAME_MANUFACTURE_DESC_RAINWATER" ) )
	_listAction[6] = manufactureAction7

	local manufactureAction8 = {}
	manufactureAction8._actionName = _ACTIONNAME_REPAIR
	manufactureAction8._radioBtn = UI.getChildControl( _frameContents, "RadioButton_RepairItem" )
	manufactureAction8._radioBtn:SetText( PAGetString( Defines.StringSheet_GAME, "ALCHEMY_MANUFACTURE_REPAIR" ) )
	manufactureAction8._radioBtn:addInputEvent( "Mouse_LUp",  "Manufacture_Button_LUp_RepairItem(true)" )
	manufactureAction8._radioBtn:addInputEvent( "Mouse_On",  "Manufacture_Button_MouseOverFunc( 7 )" )
	ManufactureActionBtnTextInit( manufactureAction8, 8, PAGetString( Defines.StringSheet_GAME, "GAME_MANUFACTURE_DESC_REPAIR" ) )
	_listAction[7] = manufactureAction8

	-- _frameScroll:SetControlPos(0)
	-- _frame:UpdateContentPos()
	
	_frame:UpdateContentScroll()					-- 스크롤 감도 동일하게
	_frameScroll:SetInterval(3)

	-- _frameManufactureDesc:UpdateContentPos()
	_frameManufactureDesc:UpdateContentScroll()		-- 스크롤 감도 동일하게
	_frameDescScroll:SetInterval(3)

end

function ManufactureControlEnable( control, isEnable )

	if( true == isEnable ) then
		control:SetIgnore( false )
		control:SetEnable( true )
		control:SetDisableColor( false )
	else
		control:SetIgnore( true )
		control:SetEnable( false )
		control:SetDisableColor( true )
	end

end

function ManufactureShowAni()
	UIAni.fadeInSCR_Down( Panel_Manufacture )
	-- ♬ 창 켤 때 소리난다요
	-- audioPostEvent_SystemUi(01,00)
	_whiteCircle:SetShow( true )
	_whiteCircle:SetAlpha( 0 )
	UIAni.AlphaAnimation( 1, _whiteCircle, 0.0, 0.2 )
	
	local aniInfo1 = Panel_Manufacture:addScaleAnimation( 0.0, 0.08, UI_ANI_ADV.PAUI_ANIM_ADVANCE_COS_HALF_PI)
	aniInfo1:SetStartScale(0.5)
	aniInfo1:SetEndScale(1.1)
	aniInfo1.AxisX = Panel_Manufacture:GetSizeX() / 2
	aniInfo1.AxisY = Panel_Manufacture:GetSizeY() / 2
	aniInfo1.ScaleType = 2
	aniInfo1.IsChangeChild = true
	
	local aniInfo2 = Panel_Manufacture:addScaleAnimation( 0.08, 0.15, UI_ANI_ADV.PAUI_ANIM_ADVANCE_COS_HALF_PI)
	aniInfo2:SetStartScale(1.1)
	aniInfo2:SetEndScale(1.0)
	aniInfo2.AxisX = Panel_Manufacture:GetSizeX() / 2
	aniInfo2.AxisY = Panel_Manufacture:GetSizeY() / 2
	aniInfo2.ScaleType = 2
	aniInfo2.IsChangeChild = true
end

function ManufactureHideAni()
	Panel_Manufacture:SetShowWithFade(CppEnums.PAUI_SHOW_FADE_TYPE.PAUI_ANI_TYPE_FADE_OUT)
	local aniInfo1 = Panel_Manufacture:addColorAnimation( 0.0, 0.15, UI_ANI_ADV.PAUI_ANIM_ADVANCE_SIN_HALF_PI)
	aniInfo1:SetStartColor( UI_color.C_FFFFFFFF )
	aniInfo1:SetEndColor( UI_color.C_00FFFFFF )
	aniInfo1:SetStartIntensity( 3.0 )
	aniInfo1:SetEndIntensity( 1.0 )
	aniInfo1.IsChangeChild = true
	aniInfo1:SetHideAtEnd(true)
	aniInfo1:SetDisableWhileAni(true)
	
	-- ♬ 창 끌 때 소리난다요
	-- audioPostEvent_SystemUi(01,01)
	
	local alphaAni = UIAni.AlphaAnimation( 0, _whiteCircle, 0.0, 0.12 )
	alphaAni:SetHideAtEnd(true)
	
	-- local scaleAni2 = Panel_Manufacture:addScaleAnimation( 0.0, 0.15, UI_ANI_ADV.PAUI_ANIM_ADVANCE_SIN_HALF_PI)
	-- scaleAni2:SetStartScale(1.0)
	-- scaleAni2:SetEndScale(0.8)
	-- scaleAni2.AxisX = Panel_Manufacture:GetPosX() / 2
	-- scaleAni2.AxisY = Panel_Manufacture:GetPosY() / 2
	-- scaleAni2.IsChangeChild = true
end

function Manufacture_SetRadioBtnFontColor( control )
	if control:IsChecked() then
		control:SetFontColor (UI_color.C_FFFFFFFF)
	else
		control:SetFontColor (UI_color.C_FFC4BEBE)
	end
end

function Manufacture_UpdateCheckRadioButton( isClear )

	for i=0, MAX_ACTION_BTN-1 do
		if( nil ~= isClear) and ( true == isClear ) then
			_listAction[i]._radioBtn:SetCheck( false )
		end
		Manufacture_SetRadioBtnFontColor( _listAction[i]._radioBtn )
	end
	
	for i=0, MAX_ACTION_BTN-1 do
		local isEnable = isEnableManufactureAction( _listAction[i]._actionName )
		if not isEnable then
			_listAction[i]._subText:SetText(PAGetString(Defines.StringSheet_GAME, "LUA_MANUFACTURE_NEED_KNOWLEDGE")) -- 지식 획득 필요
			_listAction[i]._subText:SetFontColor( UI_color.C_FFFF0000 )
		else
			_listAction[i]._subText:SetText(PAGetString( Defines.StringSheet_GAME, manufactureListDesc[i] ))
			_listAction[i]._subText:SetFontColor( UI_color.C_FFFFCE22 )
		end
	end
end

function Manufacture_UpdateVisibleRadioButton( installationType )

	-- visible 검증, 특정 설비도구를 이용할 경우, 그 설비도구에 해당하는 액션만 검증하고 나머지는 안보이게 한다..
	if( nil ~= installationType and CppEnums.InstallationType.TypeCount ~= installationType ) then
		local tempActionName = INSTALLATIONTYPE_ACTIONNAME[installationType]
		for i=0, MAX_ACTION_BTN-1 do
			if ( tempActionName == _listAction[i]._actionName ) then
				local isVisible = isVisibleManufactureAction( _listAction[i]._actionName )
				_listAction[i]._radioBtn:SetShow( isVisible )
				_listAction[i]._subText:SetShow( isVisible )
			else
				_listAction[i]._radioBtn:SetShow( false )
				_listAction[i]._subText:SetShow( false )
			end
		end
	else
		for i=0, MAX_ACTION_BTN-1 do
			local isVisible = isVisibleManufactureAction( _listAction[i]._actionName )
			_listAction[i]._radioBtn:SetShow( isVisible )
			_listAction[i]._subText:SetShow( isVisible )
		end
	end
	
	-- enable 검증
	--local isNearMortar = isNearInstallation( CppEnums.InstallationType.eType_Mortar ) -- 절구
	--local isNearStump = isNearInstallation( CppEnums.InstallationType.eType_Stump ) -- 그루터기
	--local isNearFireBowl = isNearInstallation( CppEnums.InstallationType.eType_FireBowl ) -- 화로
	local isNearAnvil = isNearInstallation( CppEnums.InstallationType.eType_Anvil ) -- 모루
	local isNearMortar = true 
	local isNearStump = true
	local isNearFireBowl = true
	
	
	for i=0, MAX_ACTION_BTN-1 do
		if( true == _listAction[i]._radioBtn:GetShow() ) then
			local isEnable = isEnableManufactureAction( _listAction[i]._actionName )

			if( _ACTIONNAME_GRIND == _listAction[i]._actionName ) then
				ManufactureControlEnable( _listAction[i]._radioBtn, isEnable and isNearMortar )
			elseif( _ACTIONNAME_FIREWOOD == _listAction[i]._actionName ) then
				ManufactureControlEnable( _listAction[i]._radioBtn, isEnable and isNearStump )
			elseif( _ACTIONNAME_HEAT == _listAction[i]._actionName ) then
				ManufactureControlEnable( _listAction[i]._radioBtn, isEnable and isNearFireBowl )
			elseif( _ACTIONNAME_REPAIR == _listAction[i]._actionName ) then
				ManufactureControlEnable( _listAction[i]._radioBtn, isEnable and isNearAnvil )
			--elseif( _ACTIONNAME_COOK == _listAction[i]._actionName ) then
			--	ManufactureControlEnable( _listAction[i]._radioBtn, isEnable and isNearCooker )
			else
				ManufactureControlEnable( _listAction[i]._radioBtn, isEnable )
			end
		end
	end

	-- 보여지는 액션 버튼 위치 잡아준다.
	local showCount = 0
	for i=0, MAX_ACTION_BTN-1 do
		if( true == _listAction[i]._radioBtn:GetShow() ) then
			_listAction[i]._radioBtn:SetPosY( showCount * ACTION_BTN_HEIGHT )
			_listAction[i]._subText:SetPosY( showCount * ACTION_BTN_HEIGHT + SUBTEXT_OFFSETY )
			showCount = showCount + 1
		end
	end

	-- _frameScroll:SetControlPos(0)
	-- _frame:UpdateContentPos()
end


local slideBtnSize = 0
function Manufacture_Show( installationType, isClear, showType )
	InventoryWindow_Show()
	ReconstructionAlchemyKnowledge()
--	UI.Set_ProcessorInputMode(IM.eProcessorInputMode_UiMode)
	Panel_Manufacture:SetShow(true,true)
	
	local noticeText = ""
	invenShow = showType
	StopManufactureAction()

	if( nil ~= isClear and true == isClear ) then
		-- UI.debugMessage(tostring(isClear))
		Manufacture_ClearMaterial()
	end

	Manufacture_UpdateVisibleRadioButton( installationType )

	-- 설비도구 사용시, 선택시키기.
	if( nil ~= installationType ) then

		local isEnable =  false
		if( installationType  == CppEnums.InstallationType.eType_Mortar ) then
			-- 절구 - GRIND
			isEnable = isEnableManufactureAction( _listAction[1]._actionName )
			_listAction[1]._radioBtn:SetCheck(true)
			Manufacture_Button_LUp_Grind(false)
			if( not isEnable ) then
				_textDesc:SetText(PAGetString(Defines.StringSheet_GAME, "LUA_MANUFACTURE_NEED_KNOWLEDGE_MORTAR"))
			end
		elseif(  installationType  == CppEnums.InstallationType.eType_Anvil ) then
			-- 모루 - Repair
			isEnable = isEnableManufactureAction( _listAction[7]._actionName )
			_listAction[7]._radioBtn:SetCheck(true)
			Manufacture_Button_LUp_RepairItem(false)
			if( not isEnable ) then
				_textDesc:SetText(PAGetString(Defines.StringSheet_GAME, "LUA_MANUFACTURE_NEED_KNOWLEDGE_ANVIL"))
			end
		elseif( installationType == CppEnums.InstallationType.eType_Stump ) then
			-- 그루터기 - FireWood
			isEnable = isEnableManufactureAction( _listAction[2]._actionName )
			_listAction[2]._radioBtn:SetCheck(true)
			Manufacture_Button_LUp_FireWood(false)
			if( not isEnable ) then
				_textDesc:SetText(PAGetString(Defines.StringSheet_GAME, "LUA_MANUFACTURE_NEED_KNOWLEDGE_STUMP"))
			end
		elseif( installationType  == CppEnums.InstallationType.eType_FireBowl ) then
			-- 화로 -- Heat
			isEnable = isEnableManufactureAction( _listAction[5]._actionName )
			_listAction[5]._radioBtn:SetCheck(true)
			Manufacture_Button_LUp_Heat(false)
			if( not isEnable ) then
				_textDesc:SetText(PAGetString(Defines.StringSheet_GAME, "LUA_MANUFACTURE_NEED_KNOWLEDGE_FIREBOWL"))
			end
		else
			_textDesc:SetText(PAGetString(Defines.StringSheet_GAME, "LUA_MANUFACTURE_SELECT_TYPE"))	-- 원하는 가공 방식을 ...
		end

		Manufacture_UpdateCheckRadioButton()

		-- 현재 액션이 사용가능?
		if( isEnable ) then

		else

		end
		_uiButtonManufacture:SetShow(isEnable)

	else
		Manufacture_UpdateCheckRadioButton(true)
		ManufactureKnowledge_ShowList(true)
		-- _uiButtonManufacture:SetShow(true)
		_uiButtonManufacture:SetShow(false)
	end

	_frameScroll:SetControlPos(0)
	_frame:UpdateContentScroll()					-- 스크롤 감도 동일하게
	_frame:UpdateContentPos()
	
	_frameDescScroll:SetControlPos(0)
	_frameManufactureDesc:UpdateContentScroll()		-- 스크롤 감도 동일하게
	_frameManufactureDesc:UpdateContentPos()
	
	Inventory_SetFunctor( ManufactureAction_InvenFiler, Manufacture_PushItemFromInventory, Manufacture_Close, nil  )
	
	local manuContent_SizeY = _frameContents:GetSizeY()
	local _sld_btnSize = _frame:GetSizeY() - ( manuContent_SizeY - _frame:GetSizeY() )
	_frameScroll_Btn:SetSize ( _frameScroll_Btn:GetSizeX(), _sld_btnSize  )
	
	slideBtnSize = _frameScroll_Btn:GetSizeY()
	if ( slideBtnSize > 140 ) then
		local manuContent_SizeY = _frameContents:GetSizeY()
		local _sld_btnSize = _frame:GetSizeY() - ( manuContent_SizeY - _frame:GetSizeY() )
		_frameScroll_Btn:SetSize ( _frameScroll_Btn:GetSizeX(), _sld_btnSize  )
		
		slideBtnSize = _frameScroll:GetSizeY()
	elseif ( 130 >= slideBtnSize ) then
		_frameScroll:SetSize ( _frameScroll:GetSizeX(), 130 )
		
		slideBtnSize = _frameScroll:GetSizeY()
	end

	_uiListScroll:SetShow(false)
end

function Manufacture_Close()
	--StopManufactureAction()
	Panel_Manufacture:SetShow(false,false)
	Inventory_SetFunctor( nil, nil, nil, nil )

	if true == invenShow then
		Panel_Equipment:SetShow(true)
		Panel_Window_Inventory:SetShow(true)
		-- Inventory_SetFunctor( nil, nil, nil, nil )
		invenShow = false
	else
		Panel_Equipment:SetShow(false)
		InventoryWindow_Close()	
		HelpMessageQuestion_Out()		-- 물음표 버튼 툴팁 끄기
	end

	
	
end


function Manufacture_ClearMaterial()

	audioPostEvent_SystemUi(10, 3)

	_materialSlotNoList = { [0] = _defaultSlotNo, _defaultSlotNo, _defaultSlotNo, _defaultSlotNo, _defaultSlotNo }
	_materialSlotNoListItemIn = { [0] = false, false, false, false }

	_actionIndex = -1
	_usingInstallationType = CppEnums.InstallationType.TypeCount
	_usingItemSlotCount = 0

	for ii=0 , _slotCount-1 do
		_pointList[ii]:SetShow(false)
	end

	_manufactureText:SetText("")
	_manufactureText:SetShow(false)
	_textDesc:SetText(PAGetString(Defines.StringSheet_GAME, "LUA_MANUFACTURE_SELECT_TYPE"))

	_uiButtonManufacture:SetText(PAGetString( Defines.StringSheet_GAME, "ALCHEMY_MANUFACTURE_BTN_MANUFACTURE" ))

	Manufacture_UpdateSlot()
end

function Manufacture_PushItemFromInventory(slotNo, itemWrapper, count)

	if( checkManufactureAction() ) then
		Proc_ShowMessage_Ack( PAGetString( Defines.StringSheet_GAME, "ALCHEMY_MANUFACTURE_DONT_CHANGE_ACTION" ) )
		return
	end

	local inventory = getSelfPlayer():get():getInventory()
	local invenSize = inventory:size()

	for ii=0, _usingItemSlotCount-1   do

		if( slotNo == _materialSlotNoList[ii] ) then
			break
		end

		if( _defaultSlotNo == _materialSlotNoList[ii] ) then
			_materialSlotNoList[ii] = slotNo
			audioPostEvent_SystemUi(13,08)									 -- 인벤토리에서 아이템 넣을 때 사운드
			break
		end
	end

	Manufacture_UpdateSlot()
end

function Manufacture_ShowPointEffect()
	for ii=0 , _slotCount-1 do
		if( ii < _usingItemSlotCount ) then
			_pointList[ii]:SetShow(true)
			_pointList[ii]:AddEffect("fUI_Light", true, 0.0, 0.0 )
		else
			_pointList[ii]:SetShow(false)
		end
	end
end

function Manufacture_UpdateSlotPos()

	local posIndex = _usingItemSlotCount-1
	if( posIndex < 0 ) then
		return
	end

	local posArray = SLOT_POSITION[posIndex]

	for ii=0 , _usingItemSlotCount-1 do
		local pos = posArray[ii]
		_slotList[ii].icon:SetPosX( pos[1] + 14 )
		_slotList[ii].icon:SetPosY( pos[2] + 9 )

		_pointList[ii]:SetPosX( pos[1] + 28 )
		_pointList[ii]:SetPosY( pos[2] + 18 )
	end
end

function Manufacture_UpdateSlot()

	--audioPostEvent_SystemUi(12, 12)				--슬롯에 재료 넣을 때 나는 효과음
	_whiteCircle:EraseAllEffect()

	local inventory = getSelfPlayer():get():getInventory()
	local invenSize = inventory:size()

	for ii = 0, _slotCount-1  do
		_slotList[ii].icon:SetShow(false)
		if( nil ~= _materialSlotNoList[ii] and  _materialSlotNoList[ii] <= invenSize ) then
			local itemWrapper = getInventoryItem( _materialSlotNoList[ii] )
			if( nil ~= itemWrapper ) then
				_slotList[ii]:setItemByStaticStatus( itemWrapper:getStaticStatus(), itemWrapper:get():getCount_s64() )
				_slotList[ii].icon:SetShow(true)
				_slotList[ii].icon:AddEffect( "fUI_ItemInstall_Produce", false, -7.0, 3.0 )
				_whiteCircle:AddEffect( "UI_ItemInstall_ProduceRing", false, -7.0, 3.0 )
				_materialSlotNoListItemIn[ii] = true
			else
				_materialSlotNoList[ii] = _defaultSlotNo
				_materialSlotNoListItemIn[ii] = false
			end
		end
	end

	local isEnable = false
	for i=0, MAX_ACTION_BTN-1 do
		if( true == _listAction[i]._radioBtn:IsCheck() ) then
			isEnable = true
		end
	end
	_uiButtonManufacture:SetShow(isEnable)
end

function Manufacture_Response()
	local _uiMode = GetUIMode()
	if _uiMode == Defines.UIMode.eUIMode_Default then
		Manufacture_Show( nil, true)
	end
end

function Manufacture_ResponseResultItem( itemDynamicListWrapper, failReason )
	local size = itemDynamicListWrapper:getSize()

	if( 0 < size ) then --성공
		Manufacture_Notify._failCount = 0
		Manufacture_Notify._successCount = Manufacture_Notify._successCount + 1
		for index = 0, size-1, 1 do
			local itemDynamicInformationWrapper		= itemDynamicListWrapper:getElement(index)
			local ItemEnchantStaticStatusWrapper	= itemDynamicInformationWrapper:getStaticStatus()
			local itemKey							= ItemEnchantStaticStatusWrapper:get()._key
			local s64_stackCount 					= Int64toInt32(itemDynamicInformationWrapper:getCount_s64())
						
			local idx = nil
			
			for key, value in pairs (Manufacture_Notify._data_Result) do
				if value._key:getItemKey() == itemKey:getItemKey() then
					idx = key
				end
			end
			
			if nil == idx then
				idx = #Manufacture_Notify._data_Result + 1
				Manufacture_Notify._data_Result[idx] = {}
				Manufacture_Notify._data_Result[idx]._key 			= itemKey
				Manufacture_Notify._data_Result[idx]._name			= ItemEnchantStaticStatusWrapper:getName()
				Manufacture_Notify._data_Result[idx]._iconPath		= "Icon/" .. ItemEnchantStaticStatusWrapper:getIconPath()
				Manufacture_Notify._data_Result[idx]._currentCnt	= s64_stackCount
			else
				Manufacture_Notify._data_Result[idx]._currentCnt	= Manufacture_Notify._data_Result[idx]._currentCnt + s64_stackCount
			end
		
		end
		
		for key, value in pairs (Manufacture_Notify._data_Resource) do
			local itemWrapper = getInventoryItem( value._slotNo )
			local count = 0
			if nil ~= itemWrapper then
				local itemStaticWrapper = itemWrapper:getStaticStatus()
				count = Int64toInt32(itemWrapper:get():getCount_s64())
			end
			
			value._currentCnt = count
		end
		Manufacture_Progress_Update()
	else -- 실패
		
		--[[
			0 은 성공이다.
			1 : 아이템이 부족합니다.
			2 : 빈슬롯입니다.
			3 : 조건에 맞지 않습니다.
			4 : 결과 아이템이 없습니다.( 재료와 액션에 부합하는 가공식이 없다)
			5 : 사용해야하는 설비도구가 없다.
			6 : 가공시간이 비정상이다.
			7 : 가공의 확률에 의해 실패했다			
		]]--
		
		local message = nil
		if( 0 == failReason ) then
			
		elseif( 1 == failReason ) then
			message = "가공을 완료했다. 재료가 부족해서 연속 가공을 진행할 수 없다."
		elseif( 2 == failReason ) then
			message = "가진 재료를 모두 소모해 가공을 완료했다."
		elseif( 3 == failReason ) then
			message = "지금은 가공을 진행할 수 없다. 가공 조건을 확인해보자."
		elseif( 4 == failReason ) then
			message = "이대로는 아무 것도 만들 수 없을 것 같다."
		elseif( 5 == failReason ) then
			message = "근처에 가공을 위한 도구가 없다. 가공 도구가 필요하다."
		elseif( 6 == failReason ) then
			--message = "가공 시간이 비정상적이다."--
		elseif( 7 == failReason ) then
			message = "가공이 생각대로 잘 되지 않는다."
		end
		
		if( 6 ~= failReason ) and ( nil ~= message ) then
			Proc_ShowMessage_Ack( message )
		end
		
		Manufacture_Notify._failCount = Manufacture_Notify._failCount + 1

		-- 가공 확률이 적어지면서 실패가 많아졌다. 그래서 실패 횟수를 늘림(20->30)
		if Manufacture_Notify._failCount >= 30 then
			Proc_ShowMessage_Ack(PAGetString( Defines.StringSheet_GAME, "ALCHEMY_MANUFACTURE_DONT_THIS_WAY" ))
			Manufacture_Notify._failCount = 0
			Manufacture_Response()
		end
	end
end

function Manufacture_ToggleWindow( installationType, isClear )
	if( Panel_Manufacture:GetShow() ) then
		Manufacture_Close()
	else
		InventoryWindow_Show()
		Manufacture_Show(installationType, isClear)
	end

end

function Manufacture_Mouse_LUp()
	if( _actionIndex == -1 ) then
		return
	end
	
	local inventory = getSelfPlayer():get():getInventory()
	local invenSize = inventory:size()
	local freeCount	= inventory:getFreeCount()

	if 1 > freeCount then
		-- 결과템이 들어갈 빈 공간이 없으면, 가공은 실패한다! 스택형으로 이미 가방에 있다면 성공한다!
		Proc_ShowMessage_Ack( PAGetString( Defines.StringSheet_GAME, "ALCHEMY_MANUFACTURE_INVENTORY_LEAST_ONE" ) ) -- String (가방에 빈 공간이 없습니다.)
	end
							
	local sum_MaterialSlot = {} -- 재료 슬롯을 체크한다.
	Manufacture_Notify:clear()
	
	for index = 0, _usingItemSlotCount - 1, 1 do
		if true == _materialSlotNoListItemIn[index] and _materialSlotNoList[index] <= invenSize then		-- 가공 조건에 따른 슬롯 수-1 만큼  for문을 돌리면서 index에 1씩 더함.
			sum_MaterialSlot[#sum_MaterialSlot + 1] = _materialSlotNoList[index]
			
			local itemWrapper = getInventoryItem( _materialSlotNoList[index] )
			local itemStaticWrapper = itemWrapper:getStaticStatus()
			local idx = #Manufacture_Notify._data_Resource + 1
			Manufacture_Notify._data_Resource[idx] = {}
			Manufacture_Notify._data_Resource[idx]._slotNo 		= _materialSlotNoList[index]
			Manufacture_Notify._data_Resource[idx]._key 		= itemStaticWrapper:get()._key
			Manufacture_Notify._data_Resource[idx]._name 		= itemStaticWrapper:getName()
			Manufacture_Notify._data_Resource[idx]._iconPath 	= "Icon/" .. itemStaticWrapper:getIconPath()
			Manufacture_Notify._data_Resource[idx]._originalCnt = Int64toInt32(itemWrapper:get():getCount_s64())
			Manufacture_Notify._data_Resource[idx]._currentCnt 	= Manufacture_Notify._data_Resource[idx]._originalCnt
		end
	end

	if #sum_MaterialSlot == 0 then 
		if _actionIndex == 5 then
			Proc_ShowMessage_Ack( PAGetString( Defines.StringSheet_GAME, "ALCHEMY_MANUFACTURE_SLOT_LEAST_ONE" ) )
		else
			Proc_ShowMessage_Ack( PAGetString( Defines.StringSheet_GAME, "ALCHEMY_MANUFACTURE_SLOT_EMPTY" ) )
		end
		return
	end

	_whiteCircle:AddEffect( "UI_ItemInstall_Spin", true, 0.0, 0.0 )
	--[[
	if ( _usingItemSlotCount == 2 ) then
		_whiteCircle:AddEffect( "UI_ItemInstall_Spin", true, 0.0, 0.0 )
	else
		_whiteCircle:AddEffect( "UI_ItemInstall_Spin", true, 0.0, 0.0 )
	end--]]
	
	-- 수리는 따로 처리한다.
	if( _actionIndex == 7 ) then
		for key, value in pairs (sum_MaterialSlot) do
			local rv = repair_RepairItemBySelf( value )	-- return 값(rv)이 0이면 정상적으로 진행!
			if rv == 0 then
				break
			end
		end
	else
		local rv = Manufacture_Do( _usingInstallationType, _listAction[_actionIndex]._actionName, _materialSlotNoList[0], _materialSlotNoList[1], _materialSlotNoList[2], _materialSlotNoList[3], _materialSlotNoList[4])
	end

	audioPostEvent_SystemUi(00,00)

	Manufacture_Notify._failCount = 0	-- 가공 실패 횟수 체크용 변수
	Manufacture_Notify._successCount = 0	-- 가공 실패 횟수 체크용 변수

	-- 가공 시작하면 닫아준다.
	Manufacture_Close()
	Interaction_Close()
	
	audioPostEvent_SystemUi(13,11)								-- 가공하기 시작버튼 누를 때 사운드
end

function Manufacture_Mouse_On()
	audioPostEvent_SystemUi(01,13)								-- 가공하기 시작버튼 마우스오버 시 사운드
end

function Manufacture_UpdateRepairTime()
	local repairTime = repair_getRepairTime( _materialSlotNoList[0] )
	if( toUint64(0,0) < repairTime ) then
		local tempString = PAGetString( Defines.StringSheet_GAME, "ALCHEMY_MANUFACTURE_REPAIR_TOTAL_TIME" ) .." : " ..( convertStringFromMillisecondtime( repairTime ) )
		_manufactureText:SetText(tempString )
	end
end

function Material_Mouse_RUp( index )
	audioPostEvent_SystemUi(13,12)								-- 가공하기 창에서 재료 뺄 때 사운드~
	StopManufactureAction()
	
	if( index < _usingItemSlotCount ) then
		_materialSlotNoList[index] = _defaultSlotNo
		_materialSlotNoListItemIn[index] = false
	end

	Manufacture_UpdateSlot()
end

function Material_Mouse_On( index )

	if( 0 == index ) then

	elseif( 1 == index ) then

	end

end

function Material_Mouse_Out( index )

	if( 0 == index ) then

	elseif( 1 == index ) then

	end

end

------------------------------------------------
-- 				클릭했을 때의 함수
------------------------------------------------
function Manufacture_Button_LUp_Shake( isClear )
	-- ♬ 
	audioPostEvent_SystemUi(13,10)

	if( nil ~= isClear and true == isClear ) then
		Manufacture_ClearMaterial()
	end
	StopManufactureAction()

	_actionIndex = 0
	_usingItemSlotCount = 2
	-- 사용하는 슬롯의 갯수가 바뀌면 위치도 업데이트해줘야한다.
	Manufacture_UpdateSlotPos()
	Manufacture_ShowPointEffect()

	_usingInstallationType = CppEnums.InstallationType.TypeCount

	_manufactureText:SetText( PAGetString( Defines.StringSheet_GAME, "ALCHEMY_MANUFACTURE_SHAKE" ) )
	_manufactureText:SetShow(true)
	_textDesc:SetText( PAGetString( Defines.StringSheet_GAME, "GAME_MANUFACTURE_DESC2_SHAKE" ) )

	_uiButtonManufacture:SetText( PAGetString( Defines.StringSheet_GAME, "ALCHEMY_MANUFACTURE_BTN_MANUFACTURE" ) )

	Manufacture_UpdateCheckRadioButton()

	-- 지식리스트 업데이트
	_startKnowledgeIndex = 0
	_uiListScroll:SetControlPos(0)
	_uiListSelect:SetShow(false)	
	ReconstructionAlchemyKnowledge( SHAKE_MENTALTHEMEKEY )
	ManufactureKnowledge_UpdateList()

	_defaultMSG1:SetShow( false )
	_defaultMSG2:SetShow( false )
	Material_Update( _usingItemSlotCount )
	
	Inventory_updateSlotData()
end

function Manufacture_Button_LUp_Grind( isClear )
	audioPostEvent_SystemUi(13,02)

	if( nil ~= isClear and true == isClear ) then
		Manufacture_ClearMaterial()
	end
	StopManufactureAction()

	_actionIndex = 1
	_usingItemSlotCount = 1
	-- 사용하는 슬롯의 갯수가 바뀌면 위치도 업데이트해줘야한다.
	Manufacture_UpdateSlotPos()
	Manufacture_ShowPointEffect()

	_usingInstallationType = CppEnums.InstallationType.TypeCount

	_manufactureText:SetText( PAGetString( Defines.StringSheet_GAME, "ALCHEMY_MANUFACTURE_GRIND" ) )
	_manufactureText:SetShow(true)
	_textDesc:SetText( PAGetString( Defines.StringSheet_GAME, "GAME_MANUFACTURE_DESC2_GRIND" ) )

	_uiButtonManufacture:SetText( PAGetString( Defines.StringSheet_GAME, "ALCHEMY_MANUFACTURE_BTN_MANUFACTURE" ) )

	Manufacture_UpdateCheckRadioButton()

	_startKnowledgeIndex = 0
	_uiListScroll:SetControlPos(0)
	_uiListSelect:SetShow(false)
	ReconstructionAlchemyKnowledge( GRIND_MENTALTHEMEKEY )
	ManufactureKnowledge_UpdateList()

	_defaultMSG1:SetShow( false )
	_defaultMSG2:SetShow( false )
	Material_Update( _usingItemSlotCount )
	
	Inventory_updateSlotData()
end

function Manufacture_Button_LUp_FireWood(isClear)
	audioPostEvent_SystemUi(13,00)

	if( nil ~= isClear and true == isClear ) then
		Manufacture_ClearMaterial()
	end
	StopManufactureAction()

	_actionIndex = 2
	_usingItemSlotCount = 1
	-- 사용하는 슬롯의 갯수가 바뀌면 위치도 업데이트해줘야한다.
	Manufacture_UpdateSlotPos()
	Manufacture_ShowPointEffect()

	_usingInstallationType = CppEnums.InstallationType.TypeCount

	_manufactureText:SetText( PAGetString( Defines.StringSheet_GAME, "ALCHEMY_MANUFACTURE_WOODSPLITTING" ) )
	_manufactureText:SetShow(true)
	_textDesc:SetText( PAGetString( Defines.StringSheet_GAME, "GAME_MANUFACTURE_DESC2_FIREWOOD" ) )

	_uiButtonManufacture:SetText( PAGetString( Defines.StringSheet_GAME, "ALCHEMY_MANUFACTURE_BTN_MANUFACTURE" ) )

	Manufacture_UpdateCheckRadioButton()

	_startKnowledgeIndex = 0
	_uiListScroll:SetControlPos(0)
	_uiListSelect:SetShow(false)
	ReconstructionAlchemyKnowledge( FIREWOOD_MENTALTHEMEKEY )
	ManufactureKnowledge_UpdateList()

	_defaultMSG1:SetShow( false )
	_defaultMSG2:SetShow( false )
	Material_Update( _usingItemSlotCount )
	
	Inventory_updateSlotData()
end

function Manufacture_Button_LUp_Dry(isClear)
	audioPostEvent_SystemUi(13,01)

	if( nil ~= isClear and true == isClear ) then
		Manufacture_ClearMaterial()
	end
	StopManufactureAction()

	_actionIndex = 3
	_usingItemSlotCount = 1
	-- 사용하는 슬롯의 갯수가 바뀌면 위치도 업데이트해줘야한다.
	Manufacture_UpdateSlotPos()
	Manufacture_ShowPointEffect()

	_usingInstallationType = CppEnums.InstallationType.TypeCount

	_manufactureText:SetText( PAGetString( Defines.StringSheet_GAME, "ALCHEMY_MANUFACTURE_DRY" ) )
	_manufactureText:SetShow(true)
	_textDesc:SetText( PAGetString( Defines.StringSheet_GAME, "GAME_MANUFACTURE_DESC2_DRY" ) )

	_uiButtonManufacture:SetText( PAGetString( Defines.StringSheet_GAME, "ALCHEMY_MANUFACTURE_BTN_MANUFACTURE" ) )

	Manufacture_UpdateCheckRadioButton()

	_startKnowledgeIndex = 0
	_uiListScroll:SetControlPos(0)
	_uiListSelect:SetShow(false)
	ReconstructionAlchemyKnowledge( DRY_MENTALTHEMEKEY )
	ManufactureKnowledge_UpdateList()

	_defaultMSG1:SetShow( false )
	_defaultMSG2:SetShow( false )
	Material_Update( _usingItemSlotCount )
	
	Inventory_updateSlotData()
end

function Manufacture_Button_LUp_Thinning(isClear)
	audioPostEvent_SystemUi(13,03)

	if( nil ~= isClear and true == isClear ) then
		Manufacture_ClearMaterial()
	end
	StopManufactureAction()

	_actionIndex = 4
	_usingItemSlotCount = 1
	-- 사용하는 슬롯의 갯수가 바뀌면 위치도 업데이트해줘야한다.
	Manufacture_UpdateSlotPos()
	Manufacture_ShowPointEffect()

	_usingInstallationType = CppEnums.InstallationType.TypeCount

	_manufactureText:SetText( PAGetString( Defines.StringSheet_GAME, "ALCHEMY_MANUFACTURE_THINNING" ) )
	_manufactureText:SetShow(true)
	_textDesc:SetText( PAGetString( Defines.StringSheet_GAME, "GAME_MANUFACTURE_DESC2_THINNING" ) )

	_uiButtonManufacture:SetText( PAGetString( Defines.StringSheet_GAME, "ALCHEMY_MANUFACTURE_BTN_MANUFACTURE" ) )

	Manufacture_UpdateCheckRadioButton()


	_startKnowledgeIndex = 0
	_uiListScroll:SetControlPos(0)
	_uiListSelect:SetShow(false)
	ReconstructionAlchemyKnowledge( THINNING_MENTALTHEMEKEY )
	ManufactureKnowledge_UpdateList()

	_defaultMSG1:SetShow( false )
	_defaultMSG2:SetShow( false )
	Material_Update( _usingItemSlotCount )
	
	Inventory_updateSlotData()
end

function Manufacture_Button_LUp_Heat(isClear)
	audioPostEvent_SystemUi(13,04)

	if( nil ~= isClear and true == isClear ) then
		Manufacture_ClearMaterial()
	end
	StopManufactureAction()

	_actionIndex = 5
	_usingItemSlotCount = 2
	-- 사용하는 슬롯의 갯수가 바뀌면 위치도 업데이트해줘야한다.
	Manufacture_UpdateSlotPos()
	Manufacture_ShowPointEffect()

	_usingInstallationType = CppEnums.InstallationType.TypeCount

	_manufactureText:SetText( PAGetString( Defines.StringSheet_GAME, "ALCHEMY_MANUFACTURE_HEATING" ) )
	_manufactureText:SetShow(true)
	_textDesc:SetText( PAGetString( Defines.StringSheet_GAME, "GAME_MANUFACTURE_DESC2_HEAT" ) )

	_uiButtonManufacture:SetText( PAGetString( Defines.StringSheet_GAME, "ALCHEMY_MANUFACTURE_BTN_MANUFACTURE" ) )

	Manufacture_UpdateCheckRadioButton()

	_startKnowledgeIndex = 0
	_uiListScroll:SetControlPos(0)
	_uiListSelect:SetShow(false)
	ReconstructionAlchemyKnowledge( HEAT_MENTALTHEMEKEY )
	ManufactureKnowledge_UpdateList()

	_defaultMSG1:SetShow( false )
	_defaultMSG2:SetShow( false )
	Material_Update( _usingItemSlotCount )
	
	Inventory_updateSlotData()
end

function Manufacture_Button_LUp_Rainwater(isClear)
	audioPostEvent_SystemUi(00,01)

	if( nil ~= isClear and true == isClear ) then
		Manufacture_ClearMaterial()
	end
	StopManufactureAction()

	_actionIndex = 6
	_usingItemSlotCount = 1
	-- 사용하는 슬롯의 갯수가 바뀌면 위치도 업데이트해줘야한다.
	Manufacture_UpdateSlotPos()
	Manufacture_ShowPointEffect()

	_usingInstallationType = CppEnums.InstallationType.TypeCount

	_manufactureText:SetText( PAGetString( Defines.StringSheet_GAME, "GAME_MANUFACTURE_RAINWATER" ) )
	_manufactureText:SetShow(true)
	_textDesc:SetText( PAGetString( Defines.StringSheet_GAME, "GAME_MANUFACTURE_DESC2_RAINWATER" ) )

	_uiButtonManufacture:SetText( PAGetString( Defines.StringSheet_GAME, "ALCHEMY_MANUFACTURE_BTN_MANUFACTURE" ) )

	Manufacture_UpdateCheckRadioButton()


	_startKnowledgeIndex = 0
	_uiListScroll:SetControlPos(0)
	_uiListSelect:SetShow(false)
	ReconstructionAlchemyKnowledge( RAINWATER_MENTALTHEMEKEY )
	ManufactureKnowledge_UpdateList()

	_defaultMSG1:SetShow( false )
	_defaultMSG2:SetShow( false )
	
	Inventory_updateSlotData()
end

function Manufacture_Button_LUp_RepairItem(isClear)
	audioPostEvent_SystemUi(13,09)

	if( nil ~= isClear and true == isClear ) then
		Manufacture_ClearMaterial()
	end

	StopManufactureAction()

	_actionIndex = 7
	_usingItemSlotCount = 1
	-- 사용하는 슬롯의 갯수가 바뀌면 위치도 업데이트해줘야한다.
	Manufacture_UpdateSlotPos()
	Manufacture_ShowPointEffect()

	_usingInstallationType = CppEnums.InstallationType.eType_Anvil

	_manufactureText:SetText( PAGetString( Defines.StringSheet_GAME, "ALCHEMY_MANUFACTURE_REPAIR" ) )
	_manufactureText:SetShow(true)
	_textDesc:SetText( PAGetString( Defines.StringSheet_GAME, "GAME_MANUFACTURE_DESC2_REPAIR" ) )

	_uiButtonManufacture:SetText( PAGetString( Defines.StringSheet_GAME, "ALCHEMY_MANUFACTURE_BTN_REPAIR" ) )

	Manufacture_UpdateCheckRadioButton()

	ManufactureKnowledge_ClearList()
	
	_defaultMSG1:SetShow( false )
	_defaultMSG2:SetShow( false )
	
	Inventory_updateSlotData()
end

------------------------------------------------
-- 			마우스 오버했을 때 함수
------------------------------------------------
function Manufacture_Button_MouseOverFunc( actionType )
	if ( actionType == 0 ) then
		--♬ 흔들어 섞기
		audioPostEvent_SystemUi(01,13)
	elseif ( actionType == 1 ) then
		--♬ 빻기
		audioPostEvent_SystemUi(01,13)
	elseif ( actionType == 2 ) then
		--♬ 장작패기
		audioPostEvent_SystemUi(01,13)
	elseif ( actionType == 3 ) then
		--♬ 말리기
		audioPostEvent_SystemUi(01,13)
	elseif ( actionType == 4 ) then
		--♬ 솎아내기
		audioPostEvent_SystemUi(01,13)
	elseif ( actionType == 5 ) then
		--♬ 가열하기
		audioPostEvent_SystemUi(01,13)
	elseif ( actionType == 6 ) then
		--♬ 빗물받기
		audioPostEvent_SystemUi(01,13)
	elseif ( actionType == 7 ) then
		--♬ 수리하기
		audioPostEvent_SystemUi(01,13)
	end
end



------------------------------------------------------------------------------------
-- 지식 리스트 관련
-------------------------------------------------------------------------------------
function ManufactureKnowledge_ScrollEvent( isUp )
	if( false == _uiListScroll:IsEnable() ) then
		return
	end

	local count = getCountAlchemyKnowledge()

	if ( count == 0 ) or ( count <= KNOWLEDGE_TEXT_COUNT) then
		return
	end

	local maxStartSlotCount = count - KNOWLEDGE_TEXT_COUNT
	local divideScroll = 1 / maxStartSlotCount

	if( nil ~= isUp ) then
		if (true == isUp) then
			_startKnowledgeIndex	= _startKnowledgeIndex - 1
			_uiListScroll:ControlButtonUp()
		else
			_startKnowledgeIndex	= _startKnowledgeIndex + 1
			_uiListScroll:ControlButtonDown()
		end

		if	_startKnowledgeIndex < 0	then
			_startKnowledgeIndex	= 0
		end

		if	maxStartSlotCount  < _startKnowledgeIndex	then
			_startKnowledgeIndex	= maxStartSlotCount
		end
	else
		local	currentScrollPos	= _uiListScroll:GetControlPos()
		local	startSlotIndexString	= string.format( "%.0f", currentScrollPos / divideScroll )
		_startKnowledgeIndex	= tonumber(startSlotIndexString)
	end

	_uiListScroll:SetControlPos(  divideScroll * _startKnowledgeIndex )

	ManufactureKnowledge_UpdateList()
end

function Manufacture_KnowledgeList_SelectKnowledge( index )

	local posX = _uiListBG:GetPosX() + _uiListText[index]:GetPosX()
	local posY = _uiListBG:GetPosY() + _uiListText[index]:GetPosY()
	_uiListSelect:SetPosX( posX - 7 )
	_uiListSelect:SetPosY( posY - 1 )
	_uiListSelect:SetShow(true)

	local knowledgeIndex = _startKnowledgeIndex + index
	local mentalCardStaticWrapper = getAlchemyKnowledge(knowledgeIndex)
	if( nil ~= mentalCardStaticWrapper ) then
		local isLearn = isLearnMentalCardForAlchemy( mentalCardStaticWrapper:getKey() )
		if( true == isLearn ) then
			_uiKnowledgeDesc:SetTextMode( CppEnums.TextMode.eTextMode_AutoWrap )
			_uiKnowledgeDesc:SetText( mentalCardStaticWrapper:getDesc() )
			_frameContent:SetSize( _frameContent:GetSizeX(), _uiKnowledgeDesc:GetSizeY() )
			if ( 110 < _uiKnowledgeDesc:GetSizeY() ) then
				_frameDescScroll:SetShow(true)
				_frameDescScroll:SetControlPos(0)
			else
				_frameDescScroll:SetShow(false)
			end

			-- _uiKnowledgeIcon:ChangeTextureInfoName(  mentalCardStaticWrapper:getImagePath() ) -- 사용하지 않음.
			_uiKnowledgeIcon:ChangeTextureInfoName( mentalCardStaticWrapper:getImagePath() )
			local x1, y1, x2, y2 = setTextureUV_Func( _uiKnowledgeIcon, 0, 0, 360, 360 )
			_uiKnowledgeIcon:getBaseTexture():setUV(  x1, y1, x2, y2  )
			_uiKnowledgeIcon:setRenderTexture(_uiKnowledgeIcon:getBaseTexture())
		else
			_uiKnowledgeDesc:SetText( " " )
			_uiKnowledgeIcon:ChangeTextureInfoName( "UI_Artwork/Unkown_Intelligence.dds" )
			_frameContent:SetSize( _frameContent:GetSizeX(), _uiKnowledgeDesc:GetSizeY() )
			_frameDescScroll:SetShow(false)
		end
	end

end

function ManufactureKnowledge_UpdateList( )
	-- 열려진 리스트를 꺼야 한다.
	ManufactureKnowledge_ClearList( )
	local count = getCountAlchemyKnowledge()

	-- ManufactureKnowledge_ShowList( 0 < count ) 

	if( KNOWLEDGE_TEXT_COUNT < count ) then
		_uiListScroll:SetShow(true)
		_uiListScroll:SetMonoTone(false)
	else
		_uiListScroll:SetShow(false)
		_uiListScroll:SetMonoTone(true)
	end

	if ( count <= 0 ) then
		return
	end
	
	local endIndex = _startKnowledgeIndex + (KNOWLEDGE_TEXT_COUNT-1)
	if( count-1 < endIndex ) then
		endIndex = count-1
	end

	local ctrlIndex = 0
	for index=_startKnowledgeIndex, endIndex do
		local mentalCardStaticWrapper = getAlchemyKnowledge(index)
		if( nil ~= mentalCardStaticWrapper ) then
			local isLearn = isLearnMentalCardForAlchemy( mentalCardStaticWrapper:getKey() )
			if( true == isLearn ) then
				_uiListText[ctrlIndex]:SetFontColor( UI_color.C_FF84FFF5 ) -- 하늘색
				_uiListText[ctrlIndex]:SetText( mentalCardStaticWrapper:getName() )
			else
				_uiListText[ctrlIndex]:SetFontColor( UI_color.C_FF888888 ) -- 회색
				_uiListText[ctrlIndex]:SetText( "??? ( " .. mentalCardStaticWrapper:getKeyword() .. " )" ) -- 미확인 지식
			end
			_uiListText[ctrlIndex]:SetShow(true)
		else
			_uiListText[ctrlIndex]:SetShow(false)
		end
		ctrlIndex = ctrlIndex + 1
	end
	
	UIScroll.SetButtonSize( _uiListScroll, KNOWLEDGE_TEXT_COUNT, count )		-- 스크롤 컨트롤들 , UI에서 보여주는 최대개수 , 실제 리스트의 수
	
end

function ManufactureKnowledge_ShowList( isShow )

	for index=0, KNOWLEDGE_TEXT_COUNT-1 do
		_uiListText[index]:SetText("")
		_uiListText[index]:SetShow(false)
	end

	if( isShow ) then

		-- Panel_Manufacture:SetSize( 740, 540 )
		_uiListScroll:SetPosX(_uiListScrollOriginPosX)
		
		-- 창 열고 가공 선택하지 않았을 경우에 우측 패널에 메시지 표시
		_defaultMSG1:SetText( PAGetString( Defines.StringSheet_GAME, "LUA_MANUFACTURE_DEFAULT_MSG_1" ) )
		_defaultMSG2:SetText( PAGetString( Defines.StringSheet_GAME, "LUA_MANUFACTURE_DEFAULT_MSG_2" ) )
		_defaultMSG1:SetShow( true )
		_defaultMSG2:SetShow( true )
		
		-- if nil ~= _defaultMessage then
			-- _defaultMessage = nil
		-- end
		-- _defaultMessage = UI.createControl( CppEnums.PA_UI_CONTROL_TYPE.PA_UI_CONTROL_STATICTEXT, Panel_Manufacture, 'StaticText_DefaultMSG' )
		-- CopyBaseProperty( _manufactureText, _defaultMessage )
		-- _defaultMessage:SetShow( true )
		-- -- _defaultMessage:SetPosX( _manufactureText:GetPosX() + 50 )
		-- -- _defaultMessage:SetPosY( _manufactureText:GetPosY() )
		-- _defaultMessage:SetText( PAGetString( Defines.StringSheet_GAME, "LUA_MANUFACTURE_DEFAULT" ) )

		-- else
		-- Panel_Manufacture:SetSize( 425, 540 )
	end

	-- _uiKnowledgeBG:SetShow( isShow )
	_uiListBG:SetShow( isShow )
	_uiListScroll:SetShow( isShow )

	-- _uiKnowledgeBG:ComputePos()
	_uiListBG:ComputePos()
	_uiListScroll:ComputePos()
	_uiListSelect:ComputePos()
	_uiKnowledgeIcon:ComputePos()
	
	_uiKnowledgeIcon:ReleaseTexture()
	_uiKnowledgeIcon:SetShow(isShow)

	_uiKnowledgeDesc:SetText("")
	_uiKnowledgeDesc:SetShow(isShow)
	_frameDescScroll:SetShow(false)
	_frameContent:SetSize( _frameContent:GetSizeX(), _uiKnowledgeDesc:GetSizeY() )
	_uiListSelect:SetShow(false)

	UI.getChildControl( Panel_Manufacture, "Button_Close" ):ComputePos()
	UI.getChildControl( Panel_Manufacture, "Button_Question" ):ComputePos()
	UI.getChildControl( Panel_Manufacture, "StaticText_Title" ):ComputePos()

	--Panel_Manufacture:ComputePos()
end



function ManufactureKnowledge_ClearList( )

	for index=0, KNOWLEDGE_TEXT_COUNT-1 do
		_uiListText[index]:SetText("")
		_uiListText[index]:SetShow(false)
	end

	-- _uiKnowledgeBG:SetShow( true )
	_uiListBG:SetShow( true )
	_uiListScroll:SetShow( false )

	_uiKnowledgeIcon:ReleaseTexture()
	_uiKnowledgeIcon:SetShow(true)

	_uiKnowledgeDesc:SetText("")
	_frameContent:SetSize( _frameContent:GetSizeX(), _uiKnowledgeDesc:GetSizeY() )
	_uiKnowledgeDesc:SetShow(true)
	_uiListSelect:SetShow(false)

end

function Note_Mouse_LUp()
	Panel_ProductNote_ShowToggle()
end

function Note_Mouse_On()
	audioPostEvent_SystemUi(01,13)							-- 제작노트 버튼에 마우스 오버 시 사운드
end

-- 초기화
ManufactureControlInit()

function Material_Update( slotCount )
	local inventory = getSelfPlayer():get():getInventory()
	local invenSize = inventory:size()

	for ii = 0, slotCount-1  do
		if( nil ~= _materialSlotNoList[ii] and  _materialSlotNoList[ii] <= invenSize ) then
			local itemWrapper = getInventoryItem( _materialSlotNoList[ii] )
			if( nil ~= itemWrapper ) then
				_slotList[ii]:setItemByStaticStatus( itemWrapper:getStaticStatus(), itemWrapper:get():getCount_s64() )
			end
		end
	end
end

------------------------------------------------------------------------------------------------------------


function Manufacture_Notify:Init()
	for key, value in pairs (self._templat) do
		value:SetShow(false)
	end	

	self._defalutSpanY = Panel_Manufacture_Notify:GetSpanSize().y	
	self._result_Title:SetText(PAGetString(Defines.StringSheet_GAME, "ALCHEMY_MANUFACTURE_RESULT"))
	self._progress_Effect:AddEffect("UI_Quest_Complete_GreenAura", true, 15, 0)
end
Manufacture_Notify:Init()

function Manufacture_Notify:createResultControl(index)
	if nil == self._item_Result[index] or nil == self._icon_ResultBG[index] or nil == self._icon_Result[index] then
		self._item_Result[index] 		= UI.createControl(CppEnums.PA_UI_CONTROL_TYPE.PA_UI_CONTROL_STATICTEXT, Panel_Manufacture_Notify, "item_Result_"..index )
		self._icon_ResultBG[index] 		= UI.createControl(CppEnums.PA_UI_CONTROL_TYPE.PA_UI_CONTROL_STATIC,	 Panel_Manufacture_Notify, "icon_ResultBG_"..index )
		self._icon_Result[index] 		= UI.createControl(CppEnums.PA_UI_CONTROL_TYPE.PA_UI_CONTROL_STATIC,	 Panel_Manufacture_Notify, "icon_Result_"..index )

		CopyBaseProperty( self._templat._item_Result, 		self._item_Result[index] )
		CopyBaseProperty( self._templat._icon_ResultBG, 	self._icon_ResultBG[index] )
		CopyBaseProperty( self._templat._icon_Result, 		self._icon_Result[index] )
		
		self._item_Result[index]		:SetSpanSize(self._item_Result[index]		:GetSpanSize().x, 	self._item_Result[index]		:GetSpanSize().y - self._gapY * (index - 1) )
		self._icon_ResultBG[index]		:SetSpanSize(self._icon_ResultBG[index]		:GetSpanSize().x, 	self._icon_ResultBG[index]		:GetSpanSize().y - self._gapY * (index - 1) )
		self._icon_Result[index]		:SetSpanSize(self._icon_Result[index]		:GetSpanSize().x,	self._icon_Result[index]		:GetSpanSize().y - self._gapY * (index - 1) )
		self._icon_ResultBG[index]		:addInputEvent("Mouse_On","Manufacture_Tooltip_Item_Show(" .. index .. ", true)")
		self._icon_ResultBG[index]		:addInputEvent("Mouse_Out","Panel_Tooltip_Item_hideTooltip()")
	end
end

function Manufacture_Notify:createResourceControl(index)
	if nil == self._item_Resource[index] or nil == self._icon_ResourceBG[index] or nil == self._icon_Resource[index] then
		self._item_Resource[index] 		= UI.createControl(CppEnums.PA_UI_CONTROL_TYPE.PA_UI_CONTROL_STATICTEXT, Panel_Manufacture_Notify, "item_Resource_"..index )
		self._icon_ResourceBG[index]	= UI.createControl(CppEnums.PA_UI_CONTROL_TYPE.PA_UI_CONTROL_STATIC,	 Panel_Manufacture_Notify, "icon_ResourceBG_"..index )
		self._icon_Resource[index] 		= UI.createControl(CppEnums.PA_UI_CONTROL_TYPE.PA_UI_CONTROL_STATIC,	 Panel_Manufacture_Notify, "icon_Resource_"..index )
		
		CopyBaseProperty( self._templat._item_Resource, 	self._item_Resource[index] )
		CopyBaseProperty( self._templat._icon_ResourceBG, 	self._icon_ResourceBG[index] )
		CopyBaseProperty( self._templat._icon_Resource, 	self._icon_Resource[index] )
		
		self._item_Resource[index]		:SetSpanSize(self._templat._item_Resource	:GetSpanSize().x, 	self._templat._item_Resource	:GetSpanSize().y + self._gapY * (index - 1) )
		self._icon_ResourceBG[index]	:SetSpanSize(self._templat._icon_ResourceBG	:GetSpanSize().x, 	self._templat._icon_ResourceBG	:GetSpanSize().y + self._gapY * (index - 1) )
		self._icon_Resource[index]		:SetSpanSize(self._templat._icon_Resource	:GetSpanSize().x,	self._templat._icon_Resource	:GetSpanSize().y + self._gapY * (index - 1) )
		self._icon_ResourceBG[index]	:addInputEvent("Mouse_On","Manufacture_Tooltip_Item_Show(" .. index .. ", false)")
		self._icon_ResourceBG[index]	:addInputEvent("Mouse_Out","Panel_Tooltip_Item_hideTooltip()")
	end
end

function Manufacture_Notify:clear()
	Manufacture_Notify._data_Resource = {}
	Manufacture_Notify._data_Result = {}
	Manufacture_Notify._progress_Bar:SetSmoothMode(false)
	Manufacture_Notify._progress_Bar:SetProgressRate(0)
	
	for key, value in pairs (self._item_Resource) do
		value:SetShow(false)
	end	
	for key, value in pairs (self._icon_ResourceBG) do
		value:SetShow(false)
	end	
	for key, value in pairs (self._icon_Resource) do
		value:SetShow(false)
	end	
	for key, value in pairs (self._item_Result) do
		value:SetShow(false)
	end	
	for key, value in pairs (self._icon_ResultBG) do
		value:SetShow(false)
	end	
	for key, value in pairs (self._icon_Result) do
		value:SetShow(false)
	end	
end

function Manufacture_Notify:SetPos()
	local gapCnt = #self._data_Resource
	Panel_Manufacture_Notify:SetSpanSize(Panel_Manufacture_Notify:GetSpanSize().x, self._defalutSpanY + self._gapY * gapCnt)
end

function Manufacture_Progress_Update()
	local progressRate = 0
	for key, value in pairs (Manufacture_Notify._data_Resource) do
		local index = key
		local _name = value._name
		local _originalCnt = value._originalCnt
		local _currentCnt = value._currentCnt
		local _iconPath = value._iconPath
		local _param = Manufacture_Notify._successCount / math.floor(_originalCnt / ( (_originalCnt - _currentCnt) / Manufacture_Notify._successCount ))		
		local _rate = math.floor( _param * 100 )
		
		Manufacture_Notify:createResourceControl(index)
		
		Manufacture_Notify._item_Resource[index]	:SetText(_name .. " (" .. _currentCnt ..")")
		Manufacture_Notify._icon_Resource[index]	:ChangeTextureInfoName(_iconPath)
		local width
		
		Manufacture_Notify._item_Resource[index]	:SetShow(true)
		Manufacture_Notify._icon_Resource[index]	:SetShow(true)		
		Manufacture_Notify._icon_ResourceBG[index]	:SetShow(true)		
		Manufacture_Notify._icon_ResourceBG[index]	:SetEnableArea(0.0, 0.0, Manufacture_Notify._icon_ResourceBG[index]:GetSizeX() + Manufacture_Notify._item_Resource[index]:GetTextSizeX(), Manufacture_Notify._icon_ResourceBG[index]:GetSizeY())		
		 
		if progressRate < _rate then
			progressRate = _rate
		end
	end	
	
	if Manufacture_Notify._successCount > 0 then
			Manufacture_Notify._progress_Bar:SetSmoothMode(true)
	end
	Manufacture_Notify._progress_Bar:SetProgressRate(progressRate)
	Manufacture_Notify._progress_Text:SetText(progressRate .. "%")
	
	for key, value in pairs (Manufacture_Notify._data_Result) do
		local index = key
		local _name			= value._name	
		local _iconPath		= value._iconPath
		local _currentCnt	= value._currentCnt		

		Manufacture_Notify:createResultControl(index)
		
		Manufacture_Notify._item_Result[index] 		:SetText(_name .. " (" .. _currentCnt ..")")
		Manufacture_Notify._icon_Result[index] 		:ChangeTextureInfoName(_iconPath)
		
		Manufacture_Notify._item_Result[index] 		:SetShow(true)
		Manufacture_Notify._icon_Result[index] 		:SetShow(true)
		Manufacture_Notify._icon_ResultBG[index] 	:SetShow(true)
		Manufacture_Notify._icon_ResultBG[index] 	:SetEnableArea(- Manufacture_Notify._item_Result[index]:GetTextSizeX(), 0.0, Manufacture_Notify._icon_ResultBG[index]:GetSizeX() , Manufacture_Notify._icon_ResultBG[index]:GetSizeY())		
	end
	
	if #Manufacture_Notify._data_Result > 0 then
		Manufacture_Notify._result_Title:SetSpanSize(Manufacture_Notify._result_Title:GetSpanSize().x, Manufacture_Notify._templat._item_Result:GetSpanSize().y - Manufacture_Notify._gapY * #Manufacture_Notify._data_Result )
		Manufacture_Notify._result_Title:SetShow(true)
	else
		Manufacture_Notify._result_Title:SetShow(false)
	end
end

function Manufacture_Tooltip_Item_Show(index, isResult)
	local itemKey = nil
	local uiBase = nil
	if isResult then
		itemKey = Manufacture_Notify._data_Result[index]._key
		uiBase = Manufacture_Notify._icon_ResultBG[index]
	elseif false == isResult then
		itemKey = Manufacture_Notify._data_Resource[index]._key
		uiBase = Manufacture_Notify._icon_ResourceBG[index]
	end
	
	if itemKey == nil or nil == uiBase then
		return
	end

	local staticStatusWrapper = getItemEnchantStaticStatus( itemKey )
	
	Panel_Tooltip_Item_Show(staticStatusWrapper, uiBase, true, false)
end

-- registerEvent로 EventChangedSelfPlayerActionVariable 를 체크하면 값이 2개로 온다.
function IsManufacture_Chk(variableName, value)
	-- 가공 시작하면, 가공 중임을 알린다.
	if variableName == "IsManufactureChk"  then
			if( AllowChangeInputMode() ) then
				if( check_ShowWindow() ) then
					UI.Set_ProcessorInputMode( IM.eProcessorInputMode_UiMode )
				else
					UI.Set_ProcessorInputMode( IM.eProcessorInputMode_GameMode)
				end
			else
				SetFocusChatting()
			end
		if value == 0 then
			Panel_Manufacture_Notify:SetShow(false)
			Manufacture_Notify:clear()
		else
			Panel_Manufacture_Notify:SetShow(true)
			Manufacture_Notify._type_Name:SetText(PAGetString(Defines.StringSheet_GAME, manufactureListName[_actionIndex]))
			Manufacture_Notify:SetPos()
			Manufacture_Progress_Update()
		end
	else
		Panel_Manufacture_Notify:SetShow(false)
		Manufacture_Notify:clear()
	end
end

function Manufacture_Notify_Check()
	if true == Panel_Manufacture_Notify:GetShow() and 0 == #Manufacture_Notify._data_Resource then
		Panel_Manufacture_Notify:SetShow(false)
	end
end

function ManufactureAction_InvenFiler( slotNo, itemWrapper, count, inventoryType )
	
	if( -1 == _actionIndex ) then
		return false;
	end
	
	local actionName = _listAction[_actionIndex]._actionName;
	
	local isEnable = isManufactureItem( inventoryType, slotNo, actionName );

	return ( not isEnable )
end

-- Pc_Common.xml과 각 클래스 ??_Basic.xml 내 FrameEvent의  Event 값이 Variable 이 변하면, isManufacture_Chk 함수를 실행한다.
registerEvent("EventChangedSelfPlayerActionVariable", "IsManufacture_Chk")
Panel_Manufacture_Notify:RegisterUpdateFunc( "Manufacture_Notify_Check" )