Panel_GuildHouse_Auction:SetShow( false )

local UI_TM 		= CppEnums.TextMode
local UI_ANI_ADV 	= CppEnums.PAUI_ANIM_ADVANCE_TYPE
local UI_PP 		= CppEnums.PAUIMB_PRIORITY
local UI_PUCT 		= CppEnums.PA_UI_CONTROL_TYPE
local UI_PSFT 		= CppEnums.PAUI_SHOW_FADE_TYPE
local UI_color 		= Defines.Color

Panel_GuildHouse_Auction:setMaskingChild( true )
Panel_GuildHouse_Auction:ActiveMouseEventEffect( true )
Panel_GuildHouse_Auction:setGlassBackground( true )

Panel_GuildHouse_Auction:RegisterShowEventFunc( true, "Panel_GuildHouse_Auction_ShowAni()")
Panel_GuildHouse_Auction:RegisterShowEventFunc( false, "Panel_GuildHouse_Auction_HideAni()")

function Panel_GuildHouse_Auction_ShowAni()
	UIAni.fadeInSCR_Down( Panel_GuildHouse_Auction )

	local aniInfo1 = Panel_GuildHouse_Auction:addScaleAnimation( 0.0, 0.08, UI_ANI_ADV.PAUI_ANIM_ADVANCE_COS_HALF_PI)
	aniInfo1:SetStartScale(0.5)
	aniInfo1:SetEndScale(1.1)
	aniInfo1.AxisX = Panel_GuildHouse_Auction:GetSizeX() / 2
	aniInfo1.AxisY = Panel_GuildHouse_Auction:GetSizeY() / 2
	aniInfo1.ScaleType = 2
	aniInfo1.IsChangeChild = true
	
	local aniInfo2 = Panel_GuildHouse_Auction:addScaleAnimation( 0.08, 0.15, UI_ANI_ADV.PAUI_ANIM_ADVANCE_COS_HALF_PI)
	aniInfo2:SetStartScale(1.1)
	aniInfo2:SetEndScale(1.0)
	aniInfo2.AxisX = Panel_GuildHouse_Auction:GetSizeX() / 2
	aniInfo2.AxisY = Panel_GuildHouse_Auction:GetSizeY() / 2
	aniInfo2.ScaleType = 2
	aniInfo2.IsChangeChild = true
end

function Panel_GuildHouse_Auction_HideAni()
	Panel_GuildHouse_Auction:SetShowWithFade(UI_PSFT.PAUI_ANI_TYPE_FADE_OUT)
	local aniInfo1 = Panel_GuildHouse_Auction:addColorAnimation( 0.0, 0.25, UI_ANI_ADV.PAUI_ANIM_ADVANCE_SIN_HALF_PI)
	aniInfo1:SetStartColor( UI_color.C_FFFFFFFF )
	aniInfo1:SetEndColor( UI_color.C_00FFFFFF )
	aniInfo1:SetStartIntensity( 3.0 )
	aniInfo1:SetEndIntensity( 1.0 )
	aniInfo1.IsChangeChild = true
	aniInfo1:SetHideAtEnd( true )
	aniInfo1:SetDisableWhileAni( true )
end

local Template = {
	BG					= UI.getChildControl( Panel_GuildHouse_Auction, "Template_Style_BG"),
	Area				= UI.getChildControl( Panel_GuildHouse_Auction, "Template_StaticText_Area"),
	Name				= UI.getChildControl( Panel_GuildHouse_Auction, "Template_StaticText_Name"),
	AucPrice			= UI.getChildControl( Panel_GuildHouse_Auction, "Template_StaticText_AucPrice"),
	MyPrice				= UI.getChildControl( Panel_GuildHouse_Auction, "Template_StaticText_MyPrice"),
	Edit_InGold			= UI.getChildControl( Panel_GuildHouse_Auction, "Template_Edit_InGold"),
	Btn_Cancel_Get		= UI.getChildControl( Panel_GuildHouse_Auction, "Template_Button_Cancel_Get"),
	Btn_Get				= UI.getChildControl( Panel_GuildHouse_Auction, "Template_Button_Get"),
	SpecialService		= UI.getChildControl( Panel_GuildHouse_Auction, "Template_StaticText_SpecialService"),
	RemainCount			= UI.getChildControl( Panel_GuildHouse_Auction, "Template_StaticText_RemainCount"),
	House_Image			= UI.getChildControl( Panel_GuildHouse_Auction, "Template_Static_Image"),
	Time				= UI.getChildControl( Panel_GuildHouse_Auction, "Template_StaticText_Time"),
}

local GuildHouseAuction = {
	panelBG					= UI.getChildControl( Panel_GuildHouse_Auction, "Static_BackGround"),
	panelTitle				= UI.getChildControl( Panel_GuildHouse_Auction, "StaticText_Title"),

	btn_MyBidList			= UI.getChildControl( Panel_GuildHouse_Auction, "Button_MyBidList"),
	btn_Win_Close			= UI.getChildControl( Panel_GuildHouse_Auction, "Button_Win_Close"),
	btn_Question			= UI.getChildControl( Panel_GuildHouse_Auction, "Button_Question"),

	btn_Page_Prv			= UI.getChildControl( Panel_GuildHouse_Auction, "Button_List_Left"),
	btn_Page_Next			= UI.getChildControl( Panel_GuildHouse_Auction, "Button_List_Right"),
	nowPage					= UI.getChildControl( Panel_GuildHouse_Auction, "StaticText_List"),

	auctionGuideBG			= UI.getChildControl( Panel_GuildHouse_Auction, "Static_BottomNoticeBG"),
	auctionGuide			= UI.getChildControl( Panel_GuildHouse_Auction, "StaticText_AutionGuide"),
	
	btn_myBidList 			= UI.getChildControl( Panel_GuildHouse_Auction, "Button_MyBidList"),
	
	auctionHouseDescFrame	= {}	
}

function GuildHouseAuction_InitControl()
	
	local self = GuildHouseAuction;

	self.auctionHouseDescFrame	= {		
									[0] = {	Frame = UI.getChildControl( Panel_GuildHouse_Auction,	"Frame_1_AuctionDesc" )	},
									[1] = {	Frame = UI.getChildControl( Panel_GuildHouse_Auction,	"Frame_2_AuctionDesc" )	},
									[2] = {	Frame = UI.getChildControl( Panel_GuildHouse_Auction,	"Frame_3_AuctionDesc" )	},
									[3] = {	Frame = UI.getChildControl( Panel_GuildHouse_Auction,	"Frame_4_AuctionDesc" )	}
								}
											
	self.auctionHouseDescFrame[0].FrameContent	= UI.getChildControl( self.auctionHouseDescFrame[0].Frame,	"Frame_1_AuctionDesc_Content" )
	self.auctionHouseDescFrame[1].FrameContent	= UI.getChildControl( self.auctionHouseDescFrame[1].Frame,	"Frame_2_AuctionDesc_Content" )
	self.auctionHouseDescFrame[2].FrameContent	= UI.getChildControl( self.auctionHouseDescFrame[2].Frame,	"Frame_3_AuctionDesc_Content" )
	self.auctionHouseDescFrame[3].FrameContent	= UI.getChildControl( self.auctionHouseDescFrame[3].Frame,	"Frame_4_AuctionDesc_Content" )

	self.btn_Win_Close:addInputEvent("Mouse_LUp", "FGlobal_GuildHouseAuctionWindow_Hide()")
	self.btn_Question:addInputEvent( "Mouse_LUp", "Panel_WebHelper_ShowToggle( \"HouseAuction\" )" )				-- 물음표 좌클릭
	self.btn_Question:addInputEvent( "Mouse_On", "HelpMessageQuestion_Show( \"HouseAuction\", \"true\")" )			-- 물음표 마우스오버
	self.btn_Question:addInputEvent( "Mouse_Out", "HelpMessageQuestion_Show( \"HouseAuction\", \"false\")" )		-- 물음표 마우스아웃
	
	self.btn_MyBidList:addInputEvent("Mouse_LUp", "HandleClicked_GuildHouseAuctionPageChange()")
end

local GuildHouseAuctionManager = 
{
	_houseAuctionList = {}
}

-- 사용 변수 
local startX 	= 5
local startY 	= 40
local gapX 		= 10
local gapY 		= 10
local sizeX 	= 450
local sizeY 	= 190
local maxXCount = 2
local maxYCount = 2

-- 경매장 남은 시간 계산
local auctionDisplayTime = function(timeValue)
	timeValue = timeValue / toUint64(0, 1000)
	
	if timeValue > toUint64(0, 3600) then
		timeValue = timeValue / toUint64(0, 3600)
		return tostring(timeValue) .. PAGetString(Defines.StringSheet_GAME, "LUA_GLOBAL_TIME_HOUR")
	elseif timeValue > toUint64(0, 120) then
		timeValue = timeValue / toUint64(0, 60)
		return tostring(timeValue) .. PAGetString(Defines.StringSheet_GAME, "LUA_GLOBAL_TIME_MINUTE")
	elseif timeValue > toUint64(0, 0) then	
		return PAGetString(Defines.StringSheet_GAME, "LUA_WORLD_MAP_HOUSE_DEADLINE")
	else
		return PAGetString(Defines.StringSheet_GAME, "LUA_HOUSEAUCTION_CLOSEAUCTION")
	end
end

-- 페이지 변경 함수
function HandleClicked_GuildHouseAuctionPageChange()
	local myAuctionInfo = RequestGetAuctionInfo()
	local auctionType = myAuctionInfo:getAuctionType()
	
	for key,value in pairs(GuildHouseAuctionManager._houseAuctionList) do
		value._editInGold:SetEditText("", true)
	end
	ClearFocusEdit()
	
	if (auctionType == 1) then
		RequestBiddingPage()
		GuildHouseAuction.panelTitle:SetText("길드 하우스 내 입찰 목록")
	elseif (auctionType == 5) then
		RequestAuctionListPage()
		GuildHouseAuction.panelTitle:SetText("길드 하우스 경매")
	end
end


-- '<' 버튼
GuildHouseAuction.btn_Page_Prv:addInputEvent("Mouse_LUp", "HandleClickedAuctionPrevButton()")
function HandleClickedAuctionPrevButton()
	for key,value in pairs(GuildHouseAuctionManager._houseAuctionList) do
		value._editInGold:SetEditText("", true)
	end
	ClearFocusEdit()
	RequestAuctionPrevPage()
end

-- '>' 버튼
GuildHouseAuction.btn_Page_Next:addInputEvent("Mouse_LUp", "HandleClickedAuctionNextButton()")
function HandleClickedAuctionNextButton()
	local myAuctionInfo		= RequestGetAuctionInfo()
	local houseCount		= myAuctionInfo:getHouseAuctionListCount()

	if 4 <= houseCount then
		for key,value in pairs(GuildHouseAuctionManager._houseAuctionList) do
			value._editInGold:SetEditText("", true)
		end

		ClearFocusEdit()
		RequestAuctionNextPage()
	end
end

-- 'x' 버튼.. 다른 lua 소스에서도 사용 함수
function FGlobal_GuildHouseAuctionWindow_Hide() 
	local isShow = Panel_GuildHouse_Auction:IsShow()

	if ( isShow == true ) then
		Panel_GuildHouse_Auction:SetShow( false, false )
	end
end

function FGlobal_GuildHouseAuctionWindow_Show() 
	local isShow = Panel_GuildHouse_Auction:IsShow()
	
	if ( isShow == false ) then
		UIAni.fadeInSCR_Down(Panel_GuildHouse_Auction)
		Panel_GuildHouse_Auction:SetShow( true, true )
	end	
end


function GuildHouseAuctionManager:initialize()
	for y=0, (maxYCount - 1), 1 do
		for x=0, (maxXCount - 1), 1 do
			local index = y * maxXCount + x
			local houselist = {}
			
			houselist._bg = UI.createControl(CppEnums.PA_UI_CONTROL_TYPE.PA_UI_CONTROL_STATIC		, Panel_GuildHouse_Auction, "Style_BG_"..index)
			houselist._area = UI.createControl(CppEnums.PA_UI_CONTROL_TYPE.PA_UI_CONTROL_STATICTEXT, houselist._bg, "StaticText_Area_"..index)	
			houselist._name = UI.createControl(CppEnums.PA_UI_CONTROL_TYPE.PA_UI_CONTROL_STATICTEXT, houselist._bg, "StaticText_Name_"..index)
			houselist._aucPrice = UI.createControl(CppEnums.PA_UI_CONTROL_TYPE.PA_UI_CONTROL_STATICTEXT	, houselist._bg, "StaticText_AucPrice_"..index)
			houselist._myPrice = UI.createControl(CppEnums.PA_UI_CONTROL_TYPE.PA_UI_CONTROL_STATICTEXT	, houselist._bg, "StaticText_MyPrice_"..index)
			houselist._editInGold = UI.createControl(CppEnums.PA_UI_CONTROL_TYPE.PA_UI_CONTROL_EDIT		, houselist._bg, "Edit_InGold_"..index)
			houselist._btn_Cancel_Get = UI.createControl(CppEnums.PA_UI_CONTROL_TYPE.PA_UI_CONTROL_BUTTON	, houselist._bg, "Button_Cancel_Get_"..index)
			houselist._btn_Get = UI.createControl(CppEnums.PA_UI_CONTROL_TYPE.PA_UI_CONTROL_BUTTON	, houselist._bg, "Button_Get_"..index)
			houselist._specialService = UI.createControl(CppEnums.PA_UI_CONTROL_TYPE.PA_UI_CONTROL_STATICTEXT, houselist._bg, "StaticText_SpecialService_"..index)
			houselist._remainCount = UI.createControl(CppEnums.PA_UI_CONTROL_TYPE.PA_UI_CONTROL_STATICTEXT, houselist._bg, "StaticText_RemainCount_"..index)	
			houselist._house_Image = UI.createControl(CppEnums.PA_UI_CONTROL_TYPE.PA_UI_CONTROL_STATIC	, houselist._bg, "Static_Image_"..index)
			houselist._aucRemainTime = UI.createControl(CppEnums.PA_UI_CONTROL_TYPE.PA_UI_CONTROL_STATICTEXT, houselist._bg, "StaticText_Time_"..index)	
			
					
			CopyBaseProperty(Template.BG, 				houselist._bg)
			CopyBaseProperty(Template.Area, 			houselist._area)
			CopyBaseProperty(Template.Name, 			houselist._name)
			CopyBaseProperty(Template.AucPrice, 		houselist._aucPrice)
			CopyBaseProperty(Template.MyPrice, 			houselist._myPrice)
			CopyBaseProperty(Template.Edit_InGold, 		houselist._editInGold)
			CopyBaseProperty(Template.Btn_Cancel_Get, 	houselist._btn_Cancel_Get)
			CopyBaseProperty(Template.Btn_Get, 			houselist._btn_Get)
			CopyBaseProperty(Template.SpecialService, 	houselist._specialService)
			CopyBaseProperty(Template.RemainCount, 		houselist._remainCount)
			CopyBaseProperty(Template.House_Image, 		houselist._house_Image)
			CopyBaseProperty(Template.Time, 			houselist._aucRemainTime)
			
			houselist._bg:SetPosX((x*sizeX)+startX+(x*gapX))
			houselist._bg:SetPosY((y*sizeY)+startY+(y*gapY))
				
			houselist._bg:SetShow(true)
			houselist._area:SetShow(true) 			
			houselist._specialService:SetShow(true) 
			houselist._name:SetShow(true) 			
			houselist._aucPrice:SetShow(true) 		
			houselist._myPrice:SetShow(true) 		
			houselist._editInGold:SetShow(true)
			houselist._editInGold:SetNumberMode(true)
			houselist._btn_Cancel_Get:SetShow(false) 
			houselist._btn_Get:SetShow(true) 		
			houselist._remainCount:SetShow(true) 	
			houselist._house_Image:SetShow(true) 	
			houselist._aucRemainTime:SetShow(true) 	
			
			houselist._btn_Get:addInputEvent("Mouse_LUp", "HandleClickedAuctionBidGuildHouse("..index..")")

			-- 프레임 처리용.
			houselist._bg:AddChild( GuildHouseAuction.auctionHouseDescFrame[index].Frame, true, false )
			Panel_GuildHouse_Auction:RemoveControl( GuildHouseAuction.auctionHouseDescFrame[index].Frame)
			
			GuildHouseAuction.auctionHouseDescFrame[index].FrameContent:AddChild( houselist._area, 				true, false )
			GuildHouseAuction.auctionHouseDescFrame[index].FrameContent:AddChild( houselist._specialService, 	true, false )
			houselist._bg:RemoveControl(houselist._area)
			houselist._bg:RemoveControl(houselist._specialService)

			GuildHouseAuction.auctionHouseDescFrame[index].Frame:SetPosX( 190 )
			GuildHouseAuction.auctionHouseDescFrame[index].Frame:SetPosY( 30 )
	
			self._houseAuctionList[index] = houselist
		end
	end
	
	Panel_GuildHouse_Auction:RemoveControl(Template.BG) 				
	Panel_GuildHouse_Auction:RemoveControl(Template.Area) 			
	Panel_GuildHouse_Auction:RemoveControl(Template.Name)			
	Panel_GuildHouse_Auction:RemoveControl(Template.AucPrice) 		
	Panel_GuildHouse_Auction:RemoveControl(Template.MyPrice)			
	Panel_GuildHouse_Auction:RemoveControl(Template.Edit_InGold) 		
	Panel_GuildHouse_Auction:RemoveControl(Template.Btn_Cancel_Get) 	
	Panel_GuildHouse_Auction:RemoveControl(Template.Btn_Get) 			
	Panel_GuildHouse_Auction:RemoveControl(Template.SpecialService) 	
	Panel_GuildHouse_Auction:RemoveControl(Template.RemainCount) 		
	Panel_GuildHouse_Auction:RemoveControl(Template.House_Image) 		
	Panel_GuildHouse_Auction:RemoveControl(Template.Time) 		
	
end

-- 입찰버튼 클릭
function HandleClickedAuctionBidGuildHouse(index)
	local price = GuildHouseAuctionManager._houseAuctionList[index]._editInGold:GetEditNumber()
	local myAuctionInfo	= RequestGetAuctionInfo()
	local houseAuctionNowPrice = myAuctionInfo:getHouseAuctionListAt(index)

	for key,value in pairs(GuildHouseAuctionManager._houseAuctionList) do
		value._editInGold:SetEditText("", true)
	end

	if ( Uint64toUint32(houseAuctionNowPrice:getPrice_s64()) <= price ) then
		ClearFocusEdit()
		RequestBidAuction(index, price)
		--RequestBiddingPage()
	else
		ClearFocusEdit()
		RequestBidAuction(index, price)
		RequestAuctionListPage()
	end
end

-- 집 목록 업데이트 함수
function GuildHouseAuctionManager:updateHouseList()
	local myAuctionInfo = RequestGetAuctionInfo()
	local houseCount = myAuctionInfo:getHouseAuctionListCount()

	for index = 0, 3, 1 do
		if index < houseCount then		
			self._houseAuctionList[index]._bg:SetShow(true)
			GuildHouseAuctionManager:setHouseData(index)		
		else
			self._houseAuctionList[index]._bg:SetShow(false)
		end
	end	
end

-- 집 목록 업데이트 값 설정 함수
function GuildHouseAuctionManager:setHouseData(index)

	local myAuctionInfo = RequestGetAuctionInfo()
	local houseAuctionInfo = myAuctionInfo:getHouseAuctionListAt(index)
	
	self._houseAuctionList[index]._name:SetText(houseAuctionInfo:getGoodsName())
	self._houseAuctionList[index]._btn_Get:SetShow(true)
	self._houseAuctionList[index]._btn_Cancel_Get:SetShow(false)
	
	-- 집 경매는 최소 입찰가만 보여준다.
	--if(houseAuctionInfo:getPrice_s64() <= houseAuctionInfo:getHighPrice_s64()) then
	--	self._houseAuctionList[index]._aucPrice:SetText( (PAGetString(Defines.StringSheet_GAME, "LUA_HOUSEAUCTION_NOWPRICE")) .." ".. tostring(Uint64toUint32(houseAuctionInfo:getHighPrice_s64())) .. " " .. (PAGetString(Defines.StringSheet_GAME, "LUA_AUCTION_GOLDTEXT")))
	--else		
		self._houseAuctionList[index]._aucPrice:SetText( "최소 입찰가 : ".. makeDotMoney(Uint64toUint32(houseAuctionInfo:getPrice_s64())) .. " " .. (PAGetString(Defines.StringSheet_GAME, "LUA_AUCTION_GOLDTEXT")) )
	--end
	
	self._houseAuctionList[index]._myPrice:SetShow(true)
	self._houseAuctionList[index]._editInGold:SetShow(true)	
		
	self._houseAuctionList[index]._house_Image:ChangeTextureInfoName( houseAuctionInfo:getGoodsScreenShotPath( 0 ) )
	self._houseAuctionList[index]._aucRemainTime:SetText(auctionDisplayTime(houseAuctionInfo:getExpireTime_u64()))
	self._houseAuctionList[index]._area:SetText( (PAGetString(Defines.StringSheet_GAME, "LUA_HOUSEAUCTION_AREA")) .." ".. tostring(Uint64toUint32(houseAuctionInfo:getGoodsArea())).."㎡")	
	
	local featureText = houseAuctionInfo:getGoodsFeature1()..houseAuctionInfo:getGoodsFeature2()
	self._houseAuctionList[index]._specialService:SetAutoResize(true)
	self._houseAuctionList[index]._specialService:SetTextMode( UI_TM.eTextMode_AutoWrap )
	self._houseAuctionList[index]._specialService:SetText( (PAGetString(Defines.StringSheet_GAME, "LUA_HOUSEAUCTION_SPECIAL")) .." ".. featureText )
	
	self._houseAuctionList[index]._remainCount:SetShow(false);
	
	GuildHouseAuction.auctionHouseDescFrame[index].FrameContent:SetSize( GuildHouseAuction.auctionHouseDescFrame[index].FrameContent:GetSizeX(), self._houseAuctionList[index]._specialService:GetTextSizeY() )
	GuildHouseAuction.auctionHouseDescFrame[index].Frame:UpdateContentScroll()
	GuildHouseAuction.auctionHouseDescFrame[index].Frame:SetShow( true )
end


-- 입찰한 집 목록 업데이트 함수
function GuildHouseAuctionManager:updateBidList()
	local myAuctionInfo = RequestGetAuctionInfo()
	local bidCount = myAuctionInfo:getMyBidListCount()

	for index = 0, 3, 1 do
		if index < bidCount then
			self._houseAuctionList[index]._bg:SetShow(true)
			GuildHouseAuctionManager:setBidData(index)
		else
			self._houseAuctionList[index]._bg:SetShow(false)
		end
	end
end

-- 입찰한 집 목록 업데이트 값 설정 함수
function GuildHouseAuctionManager:setBidData(index)
	local myAuctionInfo = RequestGetAuctionInfo()
	local bidAuctionInfo = myAuctionInfo:getMyBidListAt(index)
	
	local upperBidPrice = bidAuctionInfo:getUpperBidPrice_s64()
	local myBidPrice	= bidAuctionInfo:getMyBidPrice_s64()
	
	--[[
	local characterStaticWarpper =  bidAuctionInfo:getCharacterStaticStatus()	
	local screenShotPath 	= characterStaticWarpper:getObjectStaticStatus():getHouseScreenShotPath(0)	-- 스크린샷 ( 0 ~ 3번까지 가져올 수 있다 )
	local descArea 			= characterStaticWarpper:getObjectStaticStatus():getDescArea()				-- 면적
	local descFeature1		= characterStaticWarpper:getObjectStaticStatus():getDescFeature1()			-- 기본 제공
	local descFeature2		= characterStaticWarpper:getObjectStaticStatus():getDescFeature2()			-- 특징
	]]--
	
	if( bidAuctionInfo:isAuctionEnd() ) then
		self._houseAuctionList[index]._btn_Cancel_Get:SetShow(true)
		self._houseAuctionList[index]._btn_Cancel_Get:SetText( PAGetString(Defines.StringSheet_GAME, "LUA_HOUSEAUCTION_RETURNMONEY") ) -- 입찰금 회수
	else
		if upperBidPrice <= myBidPrice then
			self._houseAuctionList[index]._btn_Cancel_Get:SetShow(false)
		else
			self._houseAuctionList[index]._btn_Cancel_Get:SetShow(true)
			self._houseAuctionList[index]._btn_Cancel_Get:SetText( PAGetString(Defines.StringSheet_GAME, "LUA_HOUSEAUCTION_RETURNMONEY") ) -- 입찰금 회수
		end		
	end
	self._houseAuctionList[index]._btn_Cancel_Get:addInputEvent("Mouse_LUp", "HandleClickedAuctionCancelButton("..index..")")
	
	self._houseAuctionList[index]._name:SetText(bidAuctionInfo:getGoodsName())	
	self._houseAuctionList[index]._btn_Get:SetShow(false)
	
	--self._houseAuctionList[index]._nowPrice:SetText( (PAGetString(Defines.StringSheet_GAME, "LUA_HOUSEAUCTION_NOWPRICE")) ..tostring(Uint64toUint32(bidAuctionInfo:getUpperBidPrice_s64())) .. " " .. (PAGetString(Defines.StringSheet_GAME, "LUA_AUCTION_GOLDTEXT")) )
	
	self._houseAuctionList[index]._aucPrice:SetShow(true)
	self._houseAuctionList[index]._aucPrice:SetText( (PAGetString(Defines.StringSheet_GAME, "LUA_HOUSEAUCTION_BIDPRICE")) .. makeDotMoney(Uint64toUint32(bidAuctionInfo:getMyBidPrice_s64())) .. " " .. (PAGetString(Defines.StringSheet_GAME, "LUA_AUCTION_GOLDTEXT")) )
	
	self._houseAuctionList[index]._myPrice:SetShow(false)
	self._houseAuctionList[index]._editInGold:SetShow(false)	
	
	self._houseAuctionList[index]._house_Image:ChangeTextureInfoName(bidAuctionInfo:getGoodsScreenShotPath(0))
	self._houseAuctionList[index]._aucRemainTime:SetText(auctionDisplayTime(bidAuctionInfo:getExpireTime_u64()))
	self._houseAuctionList[index]._area:SetText(bidAuctionInfo:getGoodsArea())
	self._houseAuctionList[index]._area:SetText( (PAGetString(Defines.StringSheet_GAME, "LUA_HOUSEAUCTION_AREA")) ..tostring(Uint64toUint32(bidAuctionInfo:getGoodsArea())).."㎡")
	
	local featureText = bidAuctionInfo:getGoodsFeature1()..bidAuctionInfo:getGoodsFeature2()
	self._houseAuctionList[index]._specialService:SetAutoResize(true)
	self._houseAuctionList[index]._specialService:SetTextMode( UI_TM.eTextMode_AutoWrap )
	self._houseAuctionList[index]._specialService:SetText( (PAGetString(Defines.StringSheet_GAME, "LUA_HOUSEAUCTION_SPECIAL")) ..featureText )
	
	self._houseAuctionList[index]._remainCount:SetShow(true);
	self._houseAuctionList[index]._remainCount:SetText( "남은 입찰 횟수 : " ..tostring(bidAuctionInfo:getRemainBidCount()) );
	
	GuildHouseAuction.auctionHouseDescFrame[index].FrameContent:SetSize( GuildHouseAuction.auctionHouseDescFrame[index].FrameContent:GetSizeX(), self._houseAuctionList[index]._specialService:GetTextSizeY() )
	GuildHouseAuction.auctionHouseDescFrame[index].Frame:UpdateContentScroll()
	GuildHouseAuction.auctionHouseDescFrame[index].Frame:SetShow( true )

end

-- 입찰 취소 버튼 클릭
function HandleClickedAuctionCancelButton(index)
	RequestAuction_CancelGoods(index)
end

registerEvent("FromClient_ResponseAuction_UpdateAuctionList", "FromClient_ResponseAuction_UpdateGuildHouseAuctionList()")
function FromClient_ResponseAuction_UpdateGuildHouseAuctionList()
	Panel_GuildHouse_Auction:SetShow( true, true )
	local myAuctionInfo 	= RequestGetAuctionInfo()
	local auctionType		= myAuctionInfo:getAuctionType()
	local houseListCount	= myAuctionInfo:getHouseAuctionListCount()
	local bidListCount		= myAuctionInfo:getMyBidListCount()
	local houseMaxCount		= ( houseListCount / 4 ) + 1
	--AuctionTab_SellItem = 0,
	-- AuctionTab_SellHouse = 1,
	-- AuctionTab_BuyItem = 2,
	-- AuctionTab_MySellPage = 3,
	-- AuctionTab_MyBuyPage = 4,
	-- AuctionTab_MyBidPage = 5,
	-- AuctionTab_tradeTapRate = 6,
	-- AuctionTab_ServantMating = 7,
	-- AuctionTab_ServantMarket = 8,
	-- AuctionTab_MyServantMating = 9,
	-- AuctionTab_MyServantMarket = 10,
	-- AuctionTab_TerritoryTradeAuthority = 11,
	-- AuctionTab_Count

	if ( tonumber(string.sub(houseMaxCount, 1, 1)) == ( myAuctionInfo:getCurrentPage() + 1 )) then
		GuildHouseAuction.btn_Page_Next:SetIgnore( true )
	else
		GuildHouseAuction.btn_Page_Next:SetIgnore( false )
	end
	if ( ( myAuctionInfo:getCurrentPage() + 1 ) == 1) then
		GuildHouseAuction.btn_Page_Prv:SetIgnore( true )
	else	
		GuildHouseAuction.btn_Page_Prv:SetIgnore( false )
	end
	GuildHouseAuction.nowPage:SetText(myAuctionInfo:getCurrentPage() + 1)

	if(auctionType == 1) then
		GuildHouseAuction.btn_MyBidList:SetText(PAGetString(Defines.StringSheet_GAME, "LUA_HOUSEAUCTION_MYBID"))
		GuildHouseAuctionManager:updateHouseList()
    elseif(auctionType == 5) then
		GuildHouseAuction.btn_MyBidList:SetText(PAGetString(Defines.StringSheet_GAME, "LUA_HOUSEAUCTION_AUCTIONLIST"))
		GuildHouseAuctionManager:updateBidList()
	end
end


--------------------------- 컨트롤 생성, 및 패널 구성 초기화--------------------------------
GuildHouseAuction_InitControl()
GuildHouseAuctionManager:initialize()
