local UI_ANI_ADV 	= CppEnums.PAUI_ANIM_ADVANCE_TYPE
local UI_color 		= Defines.Color
local UI_TM			= CppEnums.TextMode
local UI_TT			= CppEnums.PAUI_TEXTURE_TYPE

Panel_Window_Enchant:setMaskingChild(true)
Panel_Window_Enchant:setGlassBackground(true)

-- Panel_Window_Enchant:SetShow(true)		--테스트용 삭제해야함

Panel_Window_Enchant:RegisterShowEventFunc( true, 'Enchant_ShowAni()' )
Panel_Window_Enchant:RegisterShowEventFunc( false, 'Enchant_HideAni()' )


local	Xgap			= 7

----------------------------------------------------------------------------------
-- 단순 핼프 메시지
local EnchantHelpMessage = 
{
	_helpTargetItem 	= UI.getChildControl ( Panel_Window_Enchant, "StaticText_Notice_Slot_0" ),
	_helpEnchantItem 	= UI.getChildControl ( Panel_Window_Enchant, "StaticText_Notice_Slot_1" ),
	_helpEnchantBtn		= UI.getChildControl ( Panel_Window_Enchant, "StaticText_Notice_Enchant" ),
	_helpPerfectEnchant	= UI.getChildControl ( Panel_Window_Enchant, "StaticText_Notice_GoGoGo" ),
}

local _buttonQuestion = UI.getChildControl ( Panel_Window_Enchant, "Button_Question" )		-- 물음표 버튼
_buttonQuestion:addInputEvent( "Mouse_LUp",  "Panel_WebHelper_ShowToggle( \"SpiritEnchant\" )" )								-- 물음표 좌클릭
_buttonQuestion:addInputEvent( "Mouse_On", "HelpMessageQuestion_Show( \"SpiritEnchant\", \"true\")" )		-- 물음표 마우스오버
_buttonQuestion:addInputEvent( "Mouse_Out", "HelpMessageQuestion_Show( \"SpiritEnchant\", \"false\")" )		-- 물음표 마우스아웃

local Enchant_fadeInSCR_Down = function( panel )
	local FadeMaskAni = panel:addTextureUVAnimation (0.0, 0.28, UI_ANI_ADV.PAUI_ANIM_ADVANCE_COS_HALF_PI )
	FadeMaskAni:SetTextureType(UI_TT.PAUI_TEXTURE_TYPE_MASK)

	FadeMaskAni:SetStartUV ( 0.0, 0.6, 0 )
	FadeMaskAni:SetEndUV ( 0.0, 0.1, 0 )

	FadeMaskAni:SetStartUV ( 1.0, 0.6, 1 )
	FadeMaskAni:SetEndUV ( 1.0, 0.1, 1 )

	FadeMaskAni:SetStartUV ( 0.0, 1.0, 2 )
	FadeMaskAni:SetEndUV ( 0.0, 0.4, 2 )

	FadeMaskAni:SetStartUV ( 1.0, 1.0, 3 )
	FadeMaskAni:SetEndUV ( 0.0, 0.4, 3 )

	panel:SetShowWithFade(CppEnums.PAUI_SHOW_FADE_TYPE.PAUI_ANI_TYPE_FADE_IN)

	local aniInfo3 = panel:addColorAnimation( 0.0, 0.20, UI_ANI_ADV.PAUI_ANIM_ADVANCE_COS_HALF_PI)
	aniInfo3:SetStartColor( UI_color.C_00FFFFFF )
	aniInfo3:SetEndColor( UI_color.C_FFFFFFFF )

	-- 소켓 배경 따로 관리해준다
	-- for key, value in pairs(onlySocketListBG) do
	-- 	local socketBG_1 = value:addColorAnimation( 0.0, 0.50, UI_ANI_ADV.PAUI_ANIM_ADVANCE_COS_HALF_PI)
	-- 	socketBG_1:SetStartColor( UI_color.C_00626262 )
	-- 	socketBG_1:SetEndColor( UI_color.C_FF626262 )
	-- end

	local aniInfo8 = panel:addColorAnimation( 0.12, 0.23, UI_ANI_ADV.PAUI_ANIM_ADVANCE_COS_HALF_PI)
	aniInfo8:SetStartColor( UI_color.C_00FFFFFF )
	aniInfo8:SetEndColor( UI_color.C_FFFFFFFF )
	aniInfo8:SetStartIntensity( 3.0 )
	aniInfo8:SetEndIntensity( 1.0 )
end

-- 보여주기 애니메이션
function Enchant_ShowAni()
	-- Enchant_fadeInSCR_Down(Panel_Window_Enchant)
	audioPostEvent_SystemUi(01,00)
	local aniInfo1 = Panel_Window_Enchant:addScaleAnimation( 0.0, 0.08, UI_ANI_ADV.PAUI_ANIM_ADVANCE_COS_HALF_PI)
	aniInfo1:SetStartScale(0.5)
	aniInfo1:SetEndScale(1.13)
	aniInfo1.AxisX = Panel_Window_Enchant:GetSizeX() / 2
	aniInfo1.AxisY = Panel_Window_Enchant:GetSizeY() / 2
	aniInfo1.ScaleType = 2
	aniInfo1.IsChangeChild = true
	
	local aniInfo2 = Panel_Window_Enchant:addScaleAnimation( 0.08, 0.1, UI_ANI_ADV.PAUI_ANIM_ADVANCE_COS_HALF_PI)
	aniInfo2:SetStartScale(1.13)
	aniInfo2:SetEndScale(1.0)
	aniInfo2.AxisX = Panel_Window_Enchant:GetSizeX() / 2
	aniInfo2.AxisY = Panel_Window_Enchant:GetSizeY() / 2
	aniInfo2.ScaleType = 2
	aniInfo2.IsChangeChild = true
end
-- 끄기 애니메이션
function Enchant_HideAni()
	local enchantHide = UIAni.AlphaAnimation( 0, Panel_Window_Enchant, 0.0, 0.2 )
	enchantHide:SetHideAtEnd(true)
	audioPostEvent_SystemUi(01,01)
end

local btnMouseOnCount = 0
local enchantHelpDesc = ""
function HandleOn_ShowHelpDesc( isShow )
	if ( 0 == btnMouseOnCount%3 ) then
		enchantHelpDesc = PAGetString(Defines.StringSheet_GAME, "LUA_SPIRITENCHANT_DESC_1" )		-- 블랙스톤 하나를 소모해 장비를 강화할 수 있어.
	elseif ( 1 == btnMouseOnCount%3 ) then
		enchantHelpDesc = PAGetString(Defines.StringSheet_GAME, "LUA_SPIRITENCHANT_DESC_2" )		-- 무기는 +7까지, 방어구는 +5까지 실패없이 안전하게 강화할 수 있어.
	else
		enchantHelpDesc = PAGetString(Defines.StringSheet_GAME, "LUA_SPIRITENCHANT_DESC_3" )		-- 돌파에 실패하면 장비의 최대 내구도가 떨어지니 주의해!
	end
	
	local self = EnchantHelpMessage
	self._helpEnchantBtn:SetShow( isShow )
	self._helpEnchantBtn:SetNotAbleMasking( true )
	self._helpEnchantBtn:SetTextMode( UI_TM.eTextMode_AutoWrap )
	self._helpEnchantBtn:SetAutoResize( true )
	self._helpEnchantBtn:SetText( enchantHelpDesc )
	self._helpEnchantBtn:SetSize( self._helpEnchantBtn:GetSizeX(), self._helpEnchantBtn:GetSizeY() + 30 )
	
	if true == isShow then
		btnMouseOnCount = btnMouseOnCount + 1
		self._helpPerfectEnchant:SetShow( false )
	end
end

function EnchantHelpMessage:setNeedPerfectEnchantItemCount(needCount)
	if(0 < needCount) then
		self._helpPerfectEnchant:SetShow( true )
		self._helpPerfectEnchant:SetNotAbleMasking( true )
		self._helpPerfectEnchant:SetTextMode( UI_TM.eTextMode_AutoWrap )
		self._helpPerfectEnchant:SetAutoResize( true )
		self._helpPerfectEnchant:SetText(PAGetStringParam1(Defines.StringSheet_GAME, "LUA_SPIRITENCHANT_BLACKSTONE_COUNT", "needCount", needCount)) -- "블랙 스톤이" ..tostring(needCount) .."개가 모이면 무조건 성공할 수 있어!"
		self._helpPerfectEnchant:SetSize( self._helpPerfectEnchant:GetSizeX() + Xgap, self._helpPerfectEnchant:GetSizeY() + 30 )
	else
		self._helpPerfectEnchant:SetShow( false )
		self._helpPerfectEnchant:SetSize( 220, 60 )
	end
end

------------------------------------------------------------------------------------
local EnchantManager =
{
	_constEnchantProgressTime 	= 4.0,		-- 진행되는 초를 설정한다 (Progress Bar)
	_enchantItemType 			= 0,				-- 0: 무기, 1: 방어구
	_slotConfig =
	{
		createIcon 		= false,
		createBorder 	= true,
		createCount 	= true,
		createEnchant 	= true,
		createCash		= true
	},
	
	_buttonApply 		= UI.getChildControl( Panel_Window_Enchant, "Button_Apply" ),		-- 강화
	_buttonSureSuccess	= UI.getChildControl( Panel_Window_Enchant, "Button_GoGoGo" ),		-- 무조건 강화
	_enchantEffect 		= UI.getChildControl( Panel_Window_Enchant, "Static_AddEffect" ),
	
	_slotTargetItem		= {},
	_slotEnchantItem	= {},
	
	_isStartEnchantNormal		= false,
	_isStartEnchantSureSuccess	= false,
	_currentTime				= 0,
	_isDoingEnchant				= false,
}

function EnchantManager:clear()
	EnchantHelpMessage._helpPerfectEnchant:SetShow( false )
	EnchantHelpMessage._helpPerfectEnchant:SetSize( 220, 60 )
	self._slotTargetItem:clearItem()
	self._slotTargetItem.empty			= true
	self._slotTargetItem.slotNo			= nil
	self._slotTargetItem.inventoryType	= nil
	
	self._slotEnchantItem:clearItem()
	self._slotEnchantItem.empty			= true
	self._slotEnchantItem.slotNo		= nil
	self._slotEnchantItem.inventoryType	= nil

	--self._slotTargetItem.icon:EraseAllEffect()
	--self._slotEnchantItem.icon:EraseAllEffect()
	--self._enchantEffect:EraseAllEffect()
	self._buttonApply:EraseAllEffect()
	
	self._buttonApply:SetIgnore(true);
	self._buttonApply:SetMonoTone(true);
	self._buttonSureSuccess:SetIgnore(true);
	self._buttonSureSuccess:SetShow(false)
	
	self._isStartEnchantNormal		= false;
	self._isStartEnchantSureSuccess	= false;
	self._isDoingEnchant			= false;
	self._buttonApply:SetText( PAGetString( Defines.StringSheet_GAME, "LUA_ENCHANT_DOENCHANT" ) )		-- 돌파!	
	
	getEnchantInformation():clearData()
end
function EnchantManager:isStartEnchant()
	return (self._isStartEnchantNormal or self._isStartEnchantSureSuccess)
end
function EnchantManager:isDoingEnchant()
	return self._isDoingEnchant;
end

-- local DefaultEquipmentPosX = nil
function EnchantManager:show()
	-- INVENTORY_FILTER ON ENCHANT_MAIN_ITEM
	self._slotTargetItem.icon:EraseAllEffect()
	self._slotEnchantItem.icon:EraseAllEffect()
	self._enchantEffect:EraseAllEffect()
	self:clear()
	
	Inventory_SetFunctor( Enchant_InvenFiler_MainItem, HandleEnchant_InteractortionFromInventory, FGlobalEnchant_Hide, nil  )
	FGlobal_SetInventoryDragNoUse(Panel_Window_Enchant)

	Panel_Window_Enchant:SetShow( true, true )
	-- ♬ 창을 열 때 사운드 추가
	audioPostEvent_SystemUi(01,00)

	-- 인벤토리와 장비창을 연다.
	InventoryWindow_Show()
	Equipment_PosSaveMemory() -- 이전 위치를 저장한다.
	Panel_Equipment:SetShow(true, true)
	Panel_Equipment:SetPosX(10)
	Panel_Equipment:SetPosY( getScreenSizeY() - (getScreenSizeY()/2) - (Panel_Equipment:GetSizeY()/2) ) -- 모르겠지만, 시간 지연
	btnMouseOnCount = 0
	enchantHelpDesc = ""
end
function EnchantManager:hide()
	Equipment_PosLoadMemory()	-- 이전 위치를 불러온다.
	Panel_Window_Enchant:SetShow( false, false )
	ToClient_BlackspiritEnchantClose()
	
	--Inventory_SetFunctor( Enchant_InvenFiler_MainItem, HandleEnchant_InteractortionFromInventory, FGlobalEnchant_Hide  )
	
	self:clear()
	-- end
	local self = EnchantHelpMessage
	self._helpEnchantBtn:SetShow( false )
end

--------------------------------------------------------
--					강화 시작할 때
--------------------------------------------------------
function EnchantManager:startEnchant( isSureSuccess )
	-- ♬ 강화를 시작했다
	audioPostEvent_SystemUi(05,06)
	audioPostEvent_SystemUi(05,09)
	
	self._currentTime = 0
	self._isStartEnchantNormal	= (false == isSureSuccess)
	self._isStartEnchantSureSuccess	= isSureSuccess
	
	self._slotTargetItem.icon:EraseAllEffect()
	self._slotEnchantItem.icon:EraseAllEffect()
	self._enchantEffect:EraseAllEffect()
	
	self._isDoingEnchant = true;
		
	self._slotTargetItem.icon:AddEffect( "fUI_LimitOver01A", false, 0, 0 )
	self._slotEnchantItem.icon:AddEffect( "fUI_LimitOver01A", false, 0, 0 )
	self._enchantEffect:AddEffect("fUI_LimitOver02A", true, 0, 0)
			
	if ( self._enchantItemType == 0 ) then			-- 무기
		self._enchantEffect:AddEffect( "UI_LimitOverLine", false, 0, 0 )
		self._enchantEffect:AddEffect( "fUI_LimitOver_Spark", false, 0, 0 )
	elseif ( self._enchantItemType == 1 ) then		-- 방어구
		self._enchantEffect:AddEffect( "UI_LimitOverLine_Red", false, 0, 0 )
		self._enchantEffect:AddEffect( "fUI_LimitOver_Spark", false, 0, 0 )
	end		
	-----------------------------------------------------
	-- 			돌파 중 취소버튼으로 바꿔준다
	-----------------------------------------------------
	self._buttonSureSuccess:SetIgnore( true )

	self._buttonApply:EraseAllEffect()
	self._buttonApply:SetAlpha( 1.0 )
	self._buttonApply:SetText( PAGetString( Defines.StringSheet_GAME, "LUA_ENCHANT_CANCEL" ) )		-- 돌파 취소
	self._buttonApply:SetFontColor( UI_color.C_FFC4BEBE )
			
	ToClient_BlackspiritEnchantStart()		-- 흑정령 애니메이션 시작해라/ 애니는 한번만!
end
function EnchantManager:doEnchant()
	EnchantManager._isDoingEnchant = false;
	getEnchantInformation():doEnchant(self._isStartEnchantSureSuccess);
end
function EnchantManager:cancelEnchant()
	EnchantManager:clear()
	Inventory_SetFunctor( Enchant_InvenFiler_MainItem, HandleEnchant_InteractortionFromInventory, FGlobalEnchant_Hide, nil  )
	self._slotTargetItem.icon:EraseAllEffect()
	self._slotEnchantItem.icon:EraseAllEffect()
	self._enchantEffect:EraseAllEffect()
	ToClient_BlackspiritEnchantCancel();
end
function EnchantManager:successEnchant()
	render_setChromaticBlur( 40, 1.0 )
	render_setPointBlur( 0.05, 0.045 )
	render_setColorBypass( 0.85, 0.08 )
				
	ToClient_BlackspiritEnchantSuccess()
	self._buttonApply:SetText( PAGetString( Defines.StringSheet_GAME, "LUA_ENCHANT_DOENCHANT" ) )		-- 돌파!
end
function EnchantManager:failEnchant()
	ToClient_BlackspiritEnchantFail();
	self._buttonApply:SetText( PAGetString( Defines.StringSheet_GAME, "LUA_ENCHANT_DOENCHANT" ) )		-- 돌파!
end
function EnchantManager:initialize()
	EnchantHelpMessage._helpPerfectEnchant:SetShow( false )
	EnchantHelpMessage._helpPerfectEnchant:SetSize( 220, 60 )
	
	self._buttonApply:addInputEvent( "Mouse_LUp", "HandleClickedEnchantApplyButton()" )
	self._buttonSureSuccess:addInputEvent( "Mouse_LUp", "HandleClickedSureSuccessButton()" )
	self._buttonSureSuccess:SetShow(false)
	
	self._slotTargetItem.icon = UI.getChildControl( Panel_Window_Enchant, "Static_Slot_0" )
	SlotItem.new( self._slotTargetItem, 'Slot_0', 0, Panel_Window_Enchant, self._slotConfig )
	self._slotTargetItem:createChild()
	self._slotTargetItem.empty = true
	
	Panel_Tooltip_Item_SetPosition(0, self._slotTargetItem, "Enchant")

	self._slotEnchantItem.icon = UI.getChildControl( Panel_Window_Enchant, "Static_Slot_1" )
	SlotItem.new( self._slotEnchantItem, 'Slot_1', 1, Panel_Window_Enchant, self._slotConfig )
	self._slotEnchantItem:createChild()
	self._slotEnchantItem.empty = true
	
	self._currentTime = 0
	
	Panel_Tooltip_Item_SetPosition(1, self._slotEnchantItem, "Enchant")
	
	EnchantManager._buttonApply:addInputEvent( "Mouse_On", "HandleOn_ShowHelpDesc(true)" )
	EnchantManager._buttonApply:addInputEvent( "Mouse_Out", "HandleOn_ShowHelpDesc(false)" )

	EnchantManager._buttonSureSuccess:addInputEvent( "Mouse_On", "HandleOnSureSuccessButton()" )
	EnchantManager._buttonSureSuccess:addInputEvent( "Mouse_Out", "HandleOutSureSuccessButton()" )
	
	EnchantManager._slotTargetItem.icon:addInputEvent( "Mouse_On",	"EnchantManager_HandleOnEnchantItem()" )
	EnchantManager._slotTargetItem.icon:addInputEvent( "Mouse_Out",	"EnchantManager_HandleOutEnchantItem()" )
	
	EnchantManager._slotEnchantItem.icon:addInputEvent( "Mouse_On",	"EnchantManager_HandleOnTargetItem()" )
	EnchantManager._slotEnchantItem.icon:addInputEvent( "Mouse_Out","EnchantManager_HandleOutTargetItem()" )
	
end

-----------------------------------------------------
-----------------------------------------------------
function HandleClickedEnchantApplyButton()
	if(EnchantManager:isDoingEnchant()) then
		EnchantManager:cancelEnchant()
	else
		EnchantManager:startEnchant( false )
	end
end
function HandleClickedSureSuccessButton()
	if(EnchantManager:isDoingEnchant()) then
		EnchantManager:cancelEnchant()
	else
		EnchantManager:startEnchant( true )
	end
end


-----------------------------------------------------
-- 				160초 후에 계속 됩니다.
-----------------------------------------------------
function Enchant_InvenFiler_MainItem( slotNo, itemWrapper )
	if nil == itemWrapper then
		return true
	end
	-- 강화 불가능이면 true 를 리턴, 가능하면 false
	return( false == itemWrapper:checkToEnchantItem(false) )
end
function Enchant_InvenFiler_SubItem( slotNo, itemWrapper )
	if nil == itemWrapper then
		return true
	end

	-- 유효하지 않은 재료 아이템이면 true 를 리턴
	return(0 ~= getEnchantInformation():checkIsValidSubItem( slotNo ))
end


function HandleEnchant_InteractortionFromInventory( slotNo, itemWrapper, count, inventoryType )	
	local	self			= EnchantManager
	local	enchantInfo		= getEnchantInformation()
	local	rv				= enchantInfo:SetEnchantSlot( inventoryType, slotNo )
	if( 0 ~= rv )	then
		return
	end

	local itemWrapper
	if ( self._slotTargetItem.empty ) then
		-- 들어오는대로 이펙트를 뿌려준다
		if ( self._slotTargetItem.icon ) then
			-- ♬ 아이템을 박았다
			audioPostEvent_SystemUi(00,16)
			self._slotTargetItem.icon:AddEffect( "UI_Button_Hide", false, 0, 0 )
		end
		
		self._slotTargetItem.empty			= false
		self._slotTargetItem.slotNo			= slotNo
		self._slotTargetItem.inventoryType	= inventoryType
		itemWrapper = getInventoryItem( slotNo )
		self._slotTargetItem:setItem( itemWrapper )
		
		EnchantHelpMessage:setNeedPerfectEnchantItemCount(itemWrapper:getNeedEnchantItem(true))
		
		-- INVENTORY_FILTER ON ENCHANT_SUB_ITEM
		Inventory_SetFunctor( Enchant_InvenFiler_SubItem, HandleEnchant_InteractortionFromInventory, FGlobalEnchant_Hide, nil )
		
	elseif self._slotEnchantItem.empty then
		self._slotEnchantItem.empty			= false
		self._slotEnchantItem.slotNo		= slotNo
		self._slotEnchantItem.inventoryType	= inventoryType
		itemWrapper = getInventoryItem( slotNo )
		self._slotEnchantItem:setItem( itemWrapper )

		--self._slotEnchantItem.icon:EraseAllEffect()
		-- ♬ 블랙스톤을 박았다
		audioPostEvent_SystemUi(00,07)
		if ( 16002 == itemWrapper:get():getKey():getItemKey() ) then				-- 무기 블랙스톤일 경우
			self._enchantEffect:AddEffect( "fUI_Gauge_Blue", true, 0, 0 )			
			self._slotEnchantItem.icon:AddEffect( "fUI_DarkstoneAura02", false, 0, 0 )
			self._slotEnchantItem.icon:AddEffect( "UI_Button_Hide", false, 0, 0 )
			self._enchantItemType = 0

		elseif ( 16001 == itemWrapper:get():getKey():getItemKey() ) then			-- 방어구 블랙스톤일 경우
			self._enchantEffect:AddEffect("fUI_Gauge_Red", true, 0, 0)
			self._slotEnchantItem.icon:AddEffect("fUI_DarkstoneAura01", true, 0, 0)
			self._slotEnchantItem.icon:AddEffect( "UI_Button_Hide", false, 0, 0 )
			self._enchantItemType = 1
		end
	else
		UI.ASSERT( false, 'Client data, UI data is Mismatch!!!!!' )
		return
	end
	
	-- 잠재력 돌파 가능하다!!
	local enchantable = (0 == enchantInfo:IsReadyEnchant())
	local enchantablePerfect = (0 == enchantInfo:IsReadyPerfectEnchant())

	if ( true == enchantable ) then
		self._buttonApply:AddEffect( "UI_Trade_Button", true, 0, -1 )
		self._buttonApply:SetAlpha( 1.0 )	
	end

	if(true == enchantablePerfect) then
		--self._buttonSureSuccess:AddEffect( "UI_Trade_Button", true, 0, -1 )		
		self._buttonSureSuccess:SetAlpha( 1.0 )	
	end

	local ItemEnchantStaticStatus = getInventoryItem( slotNo ):getStaticStatus():get()
	if ItemEnchantStaticStatus:isEquipable() then
		local needCount_Perfect = itemWrapper:getNeedEnchantItem(true)
		if 0 < needCount_Perfect then
			self._buttonSureSuccess:SetShow(true)
			self._buttonApply:SetFontColor(4294918722)
		else
			self._buttonSureSuccess:SetShow(false)
			self._buttonApply:SetFontColor(4294901502)
		end
		self._buttonSureSuccess:SetFontColor(4294901502)
	end
	
	self._buttonApply:SetIgnore( false == enchantable )
	self._buttonApply:SetMonoTone( false == enchantable )
	self._buttonSureSuccess:SetIgnore( false == enchantablePerfect )
	self._buttonSureSuccess:SetMonoTone( false == enchantablePerfect )
	self._buttonApply:SetEnable( enchantable )
	self._buttonSureSuccess:SetEnable( enchantablePerfect )
	
	if ( true == enchantable ) then
		HandleOn_ShowHelpDesc( true )
	end
end

-- 
function UpdateFunc_DoingEnchant( deltaTime )	
	if(true == EnchantManager:isDoingEnchant()) then
		EnchantManager._currentTime = EnchantManager._currentTime + deltaTime
		if ( 6 <= EnchantManager._currentTime ) then
			EnchantManager:doEnchant()
		end
	end
end


function FromClient_EnchantResultShow( resultType, mainWhereType, mainSlotNo, subWhereType, subSlotNo )
	local self = EnchantManager
	Inventory_SetFunctor( Enchant_InvenFiler_MainItem, HandleEnchant_InteractortionFromInventory, FGlobalEnchant_Hide, nil  )

	if( 0 == resultType ) then	-- 강화 성공
		-- ♬ 강화를 성공했다
		EnchantManager:successEnchant();
		self._slotTargetItem.icon:AddEffect("UI_ItemEnchant01", false, -6.0, -6.0)
	elseif( 1 == resultType ) then	-- 강화 실패 파괴
		EnchantManager:failEnchant();
	elseif( 2 == resultType ) then	-- 강화 실패 강화 수치 다운
		EnchantManager:failEnchant();
	elseif( 3 == resultType ) then	-- 강화 실패, 변화 없음
		EnchantManager:failEnchant();
	else 
		EnchantManager:failEnchant();
	end
	
	self:clear();
	
	--{
		local	mainInventory = getSelfPlayer():get():getInventoryByType(mainWhereType)
		if false == mainInventory:empty( mainSlotNo ) then
			HandleEnchant_InteractortionFromInventory( mainSlotNo, nil, 0, mainWhereType )
		end
	--}
		
	--{
		local	subInventory = getSelfPlayer():get():getInventoryByType(subWhereType)
		if false == subInventory:empty( subSlotNo ) then
			HandleEnchant_InteractortionFromInventory( subSlotNo, nil, 0, subWhereType )	
		end
	--}
end




function FGlobalEnchant_Show()
	EnchantManager:show()
end
function FGlobalEnchant_Hide()
	EnchantManager:hide()
	-- if Panel_Equipment:IsShow() then
	-- 	Panel_Equipment:SetShow(false, false)
	-- end
	-- Panel_Equipment:SetPosX(DefaultEquipmentPosX)
	-- DefaultEquipmentPosX = nil
	InventoryWindow_Close()
	Equipment_PosLoadMemory()	-- 이전 위치를 불러온다.
	Panel_Equipment:SetShow( false, false )	
end


------------------------------
function HandleOnSureSuccessButton()
	EnchantHelpMessage._helpPerfectEnchant:SetShow( true )
	EnchantHelpMessage._helpEnchantBtn:SetShow( false )
end

function HandleOutSureSuccessButton()
	EnchantHelpMessage._helpPerfectEnchant:SetShow( false )
	EnchantHelpMessage._helpPerfectEnchant:SetSize( 220, 60 )
end

function	EnchantItem_FromItemWrapper()
	local	self			= EnchantManager
	if	( nil == self._slotEnchantItem.slotNo )	then
		return(nil)
	end

	return( getInventoryItemByType(self._slotEnchantItem.inventoryType, self._slotEnchantItem.slotNo) )
end

function	EnchantItem_ToItemWrapper()
	local	self			= EnchantManager
	if	( nil == self._slotTargetItem.slotNo )	then
		return(nil)
	end
	
	return( getInventoryItemByType(self._slotTargetItem.inventoryType, self._slotTargetItem.slotNo) )
end

function	EnchantManager_HandleOnTargetItem()
	if ( true == EnchantManager._slotEnchantItem.empty ) then
		EnchantHelpMessage._helpTargetItem:SetShow(true)
		EnchantHelpMessage._helpTargetItem:SetTextMode( UI_TM.eTextMode_AutoWrap )
		EnchantHelpMessage._helpTargetItem:SetAutoResize( true )
		EnchantHelpMessage._helpTargetItem:SetText(PAGetString(Defines.StringSheet_GAME, "LUA_SPIRITENCHANT_HELPMESSAGE1" )) -- "먼저 장비를 올려놓았다면, 네가 가지고 있는 블랙 스톤을 장비 타입에 맞게 올려놓도록 해. 
		EnchantHelpMessage._helpTargetItem:SetSize( EnchantHelpMessage._helpTargetItem:GetSizeX() + Xgap, EnchantHelpMessage._helpTargetItem:GetSizeY() + 30 )
	else
		Panel_Tooltip_Item_Show_GeneralNormal( 1, "Enchant", true )
	end
end

function	EnchantManager_HandleOutTargetItem()
	if ( true == EnchantManager._slotEnchantItem.empty ) then
		EnchantHelpMessage._helpTargetItem:SetShow(false)
		EnchantHelpMessage._helpTargetItem:SetSize( 220, 60 )
	else
		Panel_Tooltip_Item_Show_GeneralNormal( 1, "Enchant", false )
	end
end

function	EnchantManager_HandleOnEnchantItem()
	if ( true == EnchantManager._slotTargetItem.empty ) then
		EnchantHelpMessage._helpEnchantItem:SetShow( true )
		EnchantHelpMessage._helpEnchantItem:SetTextMode( UI_TM.eTextMode_AutoWrap )
		EnchantHelpMessage._helpEnchantItem:SetAutoResize( true )
		EnchantHelpMessage._helpEnchantItem:SetText(PAGetString(Defines.StringSheet_GAME, "LUA_SPIRITENCHANT_HELPMESSAGE2" )) -- 블랙 스톤을 넣기 전에 잠재력을 돌파시킬 장비를 하나 올려놓도록 해.
		EnchantHelpMessage._helpEnchantItem:SetSize( EnchantHelpMessage._helpEnchantItem:GetSizeX() + Xgap, EnchantHelpMessage._helpEnchantItem:GetSizeY() + 30 )
	else
		Panel_Tooltip_Item_Show_GeneralNormal( 0, "Enchant", true )
	end
end

function	EnchantManager_HandleOutEnchantItem()
	if ( true == EnchantManager._slotTargetItem.empty ) then
		EnchantHelpMessage._helpEnchantItem:SetShow(false)
		EnchantHelpMessage._helpEnchantItem:SetSize( 220, 60 )
	else
		Panel_Tooltip_Item_Show_GeneralNormal( 0, "Enchant", false )
	end
end

function EnchantManager_OnScreenEvent()
	local sizeX = getScreenSizeX()
	local sizeY = getScreenSizeY()

	Panel_Window_Enchant:SetPosX( (sizeX/2) - (Panel_Window_Enchant:GetSizeX()/2) )
	Panel_Window_Enchant:SetPosY( sizeY/3 )

	Panel_Window_Enchant:ComputePos()
end

-----------------------------------------------------------------------------------------
--								일단 초기화 시켜주자
-----------------------------------------------------------------------------------------
EnchantManager:initialize();
Panel_Window_Enchant:RegisterUpdateFunc( "UpdateFunc_DoingEnchant" )
------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------
------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------
--					결과를 보여준다
registerEvent("EventEnchantResultShow", "FromClient_EnchantResultShow")
registerEvent( "onScreenResize", "EnchantManager_OnScreenEvent" )