Panel_Equipment:SetShow(false, false)
Panel_Equipment:ActiveMouseEventEffect(true)
Panel_Equipment:setMaskingChild(true)
Panel_Equipment:setGlassBackground(true)

Panel_Equipment:RegisterShowEventFunc( true, 'EquipmentWindow_ShowAni()' )
Panel_Equipment:RegisterShowEventFunc( false, 'EquipmentWindow_HideAni()' )

local EquipNoMin		= CppEnums.EquipSlotNo.rightHand
--local EquipNoMax		= CppEnums.EquipSlotNo.avatarUnderWear
local EquipNoMax		= CppEnums.EquipSlotNo.faceDecoration3

local UnUsedEquipNo_01	= 100--CppEnums.EquipSlotNo._UNUSED_01_
local UnUsedEquipNo_02	= 101--CppEnums.EquipSlotNo._UNUSED_02_

local UI_ANI_ADV		= CppEnums.PAUI_ANIM_ADVANCE_TYPE
local UI_color 			= Defines.Color

local equip = {
	slotConfig =
	{
		-- 일단 아이콘, 테두리, 카운트(숫자) 만 적용한다!
		createIcon			= false,
		createBorder		= true,
		createCount			= true,
		createCash			= true,
		createEnduranceIcon = true,
	},
	
	slotNoId = 
	{
		[0] = 'Static_Slot_RightHand',
		[1] = 'Static_Slot_LeftHand',
		[2] = 'Static_Slot_Gather',
		
		[3] = 'Static_Slot_Chest',
		[4] = 'Static_Slot_Glove',
		[5] = 'Static_Slot_Boots',
		[6] = 'Static_Slot_Helm',
		
		[7] = 'Static_Slot_Necklace',
		[8] = 'Static_Slot_Ring1',
		[9] = 'Static_Slot_Ring2',
		[10] = 'Static_Slot_Earing1',
		[11] = 'Static_Slot_Earing2',
		[12] = 'Static_Slot_Belt',
		[13] = 'Static_Slot_Lantern',
		
		[14] = 'Static_Slot_Avatar_Chest',
		[15] = 'Static_Slot_Avatar_Gloves',
		[16] = 'Static_Slot_Avatar_Boots',
		[17] = 'Static_Slot_Avatar_Helm',

		[18] = 'Static_Slot_Avatar_RightHand',
		[19] = 'Static_Slot_Avatar_LeftHand',
		[20] = 'Static_Slot_Avatar_UnderWear',
		[21] = 'Static_Slot_FaceDecoration1',
		[22] = 'Static_Slot_FaceDecoration2',
		[23] = 'Static_Slot_FaceDecoration3',
	},

	slotNoIdToString = 
	{
		[0] = '주무기',
		[1] = '보조무기',
		[2] = '도구',
		
		[3] = '갑옷',
		[4] = '장갑',
		[5] = '신발',
		[6] = '투구',
		
		[7] = '목걸이',
		[8] = '반지',
		[9] = '반지',
		[10] = '귀걸이',
		[11] = '귀걸이',
		[12] = '벨트',
		[13] = '랜턴',
		
		[14] = '갑옷(의상)',
		[15] = '장갑(의상)',
		[16] = '신발(의상)',
		[17] = '투구(의상)',

		[18] = '주무기(의상)',
		[19] = '보조무기(의상)',
		[20] = '속옷(의상)',
		[21] = '얼굴1',
		[22] = '얼굴2',
		[23] = '얼굴3',
	},
	
	-- 컨트롤들
	slots					= Array.new(),
	slotBGs					= Array.new(),
	staticTitle				= UI.getChildControl( Panel_Equipment, "Static_Text_Title" ),
	buttonClose				= UI.getChildControl( Panel_Equipment, "Button_Close" ),
	enchantText				= UI.getChildControl( Panel_Equipment, "Static_Text_Slot_Enchant_value" ),
	attackText				= UI.getChildControl( Panel_Equipment, "StaticText_Attack" ),
	attackValue				= UI.getChildControl( Panel_Equipment, "StaticText_Attack_Value" ),
	defenceText				= UI.getChildControl( Panel_Equipment, "StaticText_Defence" ),
	defenceValue			= UI.getChildControl( Panel_Equipment, "StaticText_Defence_Value" ),
	effectBG				= UI.getChildControl( Panel_Equipment, "Static_Effect" ),
	checkHelm				= UI.getChildControl( Panel_Equipment, "CheckButton_Helm_Invisual" ),
	checkHelmOpen			= UI.getChildControl( Panel_Equipment, "CheckButton_HelmOpen"),
	btn_PetList				= UI.getChildControl( Panel_Equipment, "Button_PetInfo" ),
	
	extendedSlotInfoArray	= {},
	checkExtendedSlot		= 0,
}

local _buttonQuestion	= UI.getChildControl( Panel_Equipment, "Button_Question" )			-- 물음표 버튼
local toolTip_Templete	= UI.getChildControl ( Panel_CheckedQuest, "StaticText_Notice_1")
local toolTip_BlankSlot	= UI.createControl( CppEnums.PA_UI_CONTROL_TYPE.PA_UI_CONTROL_STATICTEXT, Panel_Equipment, "toolTip_BlankSlot_For_Equipment" )
CopyBaseProperty( toolTip_Templete, toolTip_BlankSlot )
toolTip_BlankSlot:SetColor( ffffffff )
toolTip_BlankSlot:SetAlpha( 1.0 )
toolTip_BlankSlot:SetFontColor( UI_color.C_FFC4BEBE )
toolTip_BlankSlot:SetAutoResize( true )
toolTip_BlankSlot:SetTextHorizonCenter()
toolTip_BlankSlot:SetShow( false )
toolTip_BlankSlot:SetIgnore( false )

-- 초기화 함수
function equip:initControl()
	for v = EquipNoMin, EquipNoMax do
		if	(UnUsedEquipNo_01 ~= v) and (UnUsedEquipNo_02 ~= v)	then
			-- 컨트롤 생성
			local slot = {}
			slot.icon = UI.getChildControl( Panel_Equipment, self.slotNoId[v] )
			SlotItem.new( slot, 'Equipment_' .. v,  v, Panel_Equipment, self.slotConfig )
			slot:createChild()
		
			slot.icon:addInputEvent( "Mouse_RUp", "Equipment_RClick(" .. v .. ")" )
			slot.icon:addInputEvent( "Mouse_LUp", "Equipment_LClick(" .. v .. ")" )
			slot.icon:addInputEvent( "Mouse_On", "Equipment_MouseOn(" .. v .. ",true)" )
			slot.icon:addInputEvent( "Mouse_Out","Equipment_MouseOn(" .. v .. ",false)" )
		
			Panel_Tooltip_Item_SetPosition(v, slot, "equipment")
			self.slots[v] = slot

			local targetControl = UI.createControl( CppEnums.PA_UI_CONTROL_TYPE.PA_UI_CONTROL_STATICTEXT, Panel_Equipment, "Equip_Enchant_" .. v )
			CopyBaseProperty( equip.enchantText, targetControl )
			targetControl:SetPosX( slot.icon:GetPosX()  )
			targetControl:SetPosY( slot.icon:GetPosY() + 8 )
			targetControl:SetShow(false)
			slot.enchantText = targetControl

			--BG슬롯 컨트롤 가져와서 배열에 담는거
			local slotBG = UI.getChildControl( Panel_Equipment, self.slotNoId[v] .. "_BG" )
			slotBG:SetShow( false )
			self.slotBGs[v] = slotBG
		end
	end
	-- equip.checkHelm:SetShow( false )  -- 안쓰지만 일단 setshow false 처리
	self.checkHelm:SetShow(true)
	self.checkHelmOpen:SetShow( true )
	self.enchantText:SetShow(false)

	self.checkHelm		:addInputEvent( "Mouse_On",		"Equipment_SimpleToolTips( true, 0 )" )
	self.checkHelm		:addInputEvent( "Mouse_Out",	"Equipment_SimpleToolTips( false)" )
	self.checkHelmOpen	:addInputEvent( "Mouse_On",		"Equipment_SimpleToolTips( true, 1 )" )
	self.checkHelmOpen	:addInputEvent( "Mouse_Out",	"Equipment_SimpleToolTips( false )" )
	self.btn_PetList	:addInputEvent( "Mouse_On",		"Equipment_SimpleToolTips( true, 2 )" )
	self.btn_PetList	:addInputEvent( "Mouse_Out",	"Equipment_SimpleToolTips( false )" )
end

-- 이벤트 핸들러들
function EquipmentWindow_Close()
	-- 꺼준다
	if Panel_Equipment:IsShow() then
		Panel_Equipment:SetShow(false, false);
		CharacterInfoWindow_Hide()
	end	
	
	HelpMessageQuestion_Out()		-- 물음표 버튼 툴팁 끄기
end


function EquipmentWindow_ShowAni()
	UIAni.fadeInSCR_Left(Panel_Equipment)
	
	local aniInfo1 = Panel_Equipment:addScaleAnimation( 0.0, 0.08, UI_ANI_ADV.PAUI_ANIM_ADVANCE_COS_HALF_PI)
	aniInfo1:SetStartScale(0.5)
	aniInfo1:SetEndScale(1.05)
	aniInfo1.AxisX = Panel_Equipment:GetSizeX() / 2
	aniInfo1.AxisY = Panel_Equipment:GetSizeY() / 2
	aniInfo1.ScaleType = 2
	aniInfo1.IsChangeChild = true
	
	local aniInfo2 = Panel_Equipment:addScaleAnimation( 0.08, 0.15, UI_ANI_ADV.PAUI_ANIM_ADVANCE_COS_HALF_PI)
	aniInfo2:SetStartScale(1.05)
	aniInfo2:SetEndScale(1.0)
	aniInfo2.AxisX = Panel_Equipment:GetSizeX() / 2
	aniInfo2.AxisY = Panel_Equipment:GetSizeY() / 2
	aniInfo2.ScaleType = 2
	aniInfo2.IsChangeChild = true
end

function EquipmentWindow_HideAni()
	-- 꺼준다
	Panel_Equipment:SetShowWithFade(CppEnums.PAUI_SHOW_FADE_TYPE.PAUI_ANI_TYPE_FADE_OUT)
	local aniInfo1 = Panel_Equipment:addColorAnimation( 0.0, 0.1, UI_ANI_ADV.PAUI_ANIM_ADVANCE_SIN_HALF_PI)
	aniInfo1:SetStartColor( UI_color.C_FFFFFFFF )
	aniInfo1:SetEndColor( UI_color.C_00FFFFFF )
	aniInfo1:SetStartIntensity( 3.0 )
	aniInfo1:SetEndIntensity( 1.0 )
	aniInfo1.IsChangeChild = true
	aniInfo1:SetHideAtEnd(true)
	aniInfo1:SetDisableWhileAni(true)
end

function Equipment_MouseOn( slotNo, isOn )
	Panel_Tooltip_Item_Show_GeneralNormal(slotNo, "equipment", isOn)
	-- 비어있을 때!
	-- Equipment_NilSlot_MouseOn( slotNo, isOn )
end

function Equipment_NilSlot_MouseOn( slotNo, isOn )
	local self = equip
	if true == isOn then
		toolTip_BlankSlot:SetText( self.slotNoIdToString[slotNo] )
		toolTip_BlankSlot:SetSize( toolTip_BlankSlot:GetTextSizeX() + 30, toolTip_BlankSlot:GetSizeY() )
		toolTip_BlankSlot:SetPosX( self.slots[slotNo].icon:GetPosX() - toolTip_BlankSlot:GetTextSizeX() )
		toolTip_BlankSlot:SetPosY( self.slots[slotNo].icon:GetPosY() - toolTip_BlankSlot:GetSizeY() )
		toolTip_BlankSlot:SetShow( true )
	else
		toolTip_BlankSlot:SetShow( false )
	end
end

function Equipment_RClick( slotNo )
	local itemWrapper = getEquipmentItem( slotNo )
	if nil ~= itemWrapper then
		if( Panel_Window_Repair:IsShow() ) then -- 수리UI가 열려있을 경우 수리를 해준다.
			Repair_EquipWindowRClick( slotNo, itemWrapper );
		else
			equipmentDoUnequip( slotNo )
		end
	end
end

function Equipment_LClick( slotNo )
	if DragManager.dragStartPanel == Panel_Window_Inventory then
		--장착 가능한 슬롯인지 체크코드 삽입해야한다.
		local dragSlotNo = DragManager.dragSlotInfo
		local itemWrapper = getInventoryItem( dragSlotNo )
		if (nil ~= itemWrapper) then
			local itemStatic = itemWrapper:getStaticStatus()
			if itemStatic:isEquipable() then 
				Inventory_SlotRClick(DragManager.dragSlotInfo, slotNo)
				DragManager:clearInfo()
			end
		end
			-- local itemWrapper = getEquipmentItem( slotNo )
			-- if nil ~= itemWrapper then
			-- 	equipmentDoUnequip( slotNo )
		 --  	end
	end
end

--[[
function Equipment_ShowToggle()
	local isShow = Panel_Equipment:IsShow()
	Equipment_SetShow( not false )
end]]--
local equipMentPosX = 0
local equipMentPosY = 0
function Equipment_PosSaveMemory()
	equipMentPosX = Panel_Equipment:GetPosX()
	equipMentPosY = Panel_Equipment:GetPosY()
end
function Equipment_PosLoadMemory()
	Panel_Equipment:SetPosX(equipMentPosX)
	Panel_Equipment:SetPosY(equipMentPosY)
end

function Equipment_SetShow( isShow )

	if true == isShow then
		if GetUIMode() == Defines.UIMode.eUIMode_NpcDialog then
			Panel_Equipment:SetShow(false, false)
		else
			Panel_Equipment:SetShow(true, true)
		end
	else
		Panel_Equipment:SetShow(false, false)
	end
	Inventory_SetFunctor( nil, nil, EquipmentWindow_Close, nil )

	-- if Panel_Equipment:IsShow() ~= isShow then
	-- 	if isShow then
	-- 		Panel_Equipment:SetShow(false, false)
	-- 	end
	-- 	Panel_Equipment:SetShow(isShow, isShow)

	-- 	if isShow then
	-- 		Inventory_SetFunctor( nil, nil, EquipmentWindow_Close, nil );
	-- 	end
	-- end
end

function FGlobal_Equipment_SetHide( isShow )
	Equipment_SetShow( isShow )
end

function equip:registEventHandler()
	self.buttonClose	:addInputEvent( "Mouse_LUp",	"EquipmentWindow_Close()" )
	self.checkHelm		:addInputEvent( "Mouse_LUp",		"Check_Helm()" )
	self.checkHelmOpen	:addInputEvent( "Mouse_LUp",	"Check_HelmOpen()")
	_buttonQuestion		:addInputEvent( "Mouse_LUp",		"Panel_WebHelper_ShowToggle( \"PanelWindowEquipment\" )" )						-- 물음표 좌클릭
	_buttonQuestion		:addInputEvent( "Mouse_On",		"HelpMessageQuestion_Show( \"PanelWindowEquipment\", \"true\")" )			-- 물음표 마우스오버
	_buttonQuestion		:addInputEvent( "Mouse_Out",		"HelpMessageQuestion_Show( \"PanelWindowEquipment\", \"false\")" )			-- 물음표 마우스아웃

	self.btn_PetList	:addInputEvent( "Mouse_LUp",	"FGlobal_PetListNew_Open()" )	-- 펫 리스트를 연다.
--	registerKeyEvent( CppEnums.VirtualKeyCode.KeyCode_I, "KeyDown", "Equipment_ShowToggle")
end

local function extendedSlotInfo( itemWrapper, SlotNo )	
	
	local itemSSW = itemWrapper:getStaticStatus()
	local itemName = itemSSW:getName()
	local slotNoMax = itemSSW:getExtendedSlotCount()
	local extendedSlotString = ""
	local compareSlot = {}

	for i = 1, slotNoMax do
		local extendSlotNo = itemSSW:getExtendedSlotIndex(i-1)		
		if( slotNoMax ~= extendSlotNo ) then
			equip.extendedSlotInfoArray[extendSlotNo] = SlotNo
			setItemCount = equip.extendedSlotInfoArray[extendSlotNo]
			equip.checkExtendedSlot = 1
			compareSlot[i] = extendSlotNo
			extendedSlotString = extendedSlotString .. ", " .. equip.slotNoId[extendSlotNo] .. "_BG"
		end
	end
end

local function setItemInfoUseWrapper( slot, itemWrapper, isMono, isExtended )
	slot:setItem( itemWrapper )

	local itemSSW = itemWrapper:getStaticStatus()
	local enchantCount = itemSSW:get()._key:getEnchantLevel()
	
	if (enchantCount > 0) and (false == isExtended) then
		slot.enchantText:SetText( "+" .. tostring(enchantCount) )		-- 인챈트 수치
		slot.enchantText:SetShow(true)
	else
		slot.enchantText:SetShow(false)
	end
	
	if ( false == isExtended ) then
		slot.icon:SetEnable( true )
	else
		slot.icon:SetEnable( false )
	end	
	
	if ( true == isMono ) then
		slot.icon:SetMonoTone(true)
		slot.enchantText:SetMonoTone(true)
	elseif ( false == isMono ) then
		slot.icon:SetMonoTone(false)
		slot.enchantText:SetMonoTone(false)
	end
end

-- 메시지 핸들러들
-- 슬롯 정보 갱신. 한번에 전체를 모두 갱신한다.!
function Equipment_updateSlotData()
	local self = equip

	self.extendedSlotInfoArray = {}
	self.checkExtendedSlot = 0

	for v = EquipNoMin, EquipNoMax do
		if	(UnUsedEquipNo_01 ~= v) and (UnUsedEquipNo_02 ~= v) then
			local itemWrapper = getEquipmentItem( v )
			local slot = self.slots[v]
			local slotBG = self.slotBGs[v]
			if nil ~= itemWrapper then
--[[			slot:setItem( itemWrapper )

				local itemSSW = itemWrapper:getStaticStatus()
				local enchantCount = itemSSW:get()._key:getEnchantLevel()
				if enchantCount > 0 then
					slot.enchantText:SetText( "+" .. tostring(enchantCount) )		-- 인챈트 수치
					slot.enchantText:SetShow(true)
				else
					slot.enchantText:SetShow(false)
				end
				slot.icon:SetEnable( true ) ]]--
				extendedSlotInfo( itemWrapper, v )
				setItemInfoUseWrapper( slot, itemWrapper, false, false)

				local itemss = itemWrapper:getStaticStatus()
				local name = itemss:getName()
				slotBG:SetShow( false )

				slot.icon:addInputEvent( "Mouse_On", "Equipment_MouseOn(" .. v .. ",true)" )
				slot.icon:addInputEvent( "Mouse_Out","Equipment_MouseOn(" .. v .. ",false)" )
			else
				slot.enchantText:SetShow(false)
				slot:clearItem()
				slot.icon:SetEnable( true )
				slotBG:SetShow( true )

				slot.icon:addInputEvent( "Mouse_On", "Equipment_NilSlot_MouseOn(" .. v .. ",true)" )
				slot.icon:addInputEvent( "Mouse_Out","Equipment_NilSlot_MouseOn(" .. v .. ",false)" )
			end
		end
	end		
	
	if( self.checkExtendedSlot == 1 ) then
		for  extendSlotNo, parentSlotNo in pairs(self.extendedSlotInfoArray) do
			local itemWrapper = getEquipmentItem( parentSlotNo )
			local setSlotBG = self.slotBGs[extendSlotNo]
			slot = self.slots[extendSlotNo]
			setSlotBG:SetShow( false )
			setItemInfoUseWrapper( slot, itemWrapper, true, true )
		end
	end
	
	interaction_Forceed()	-- 채집 도구 유무에 따른 인터렉션 갱신용.
	updateAttackStat();		-- 공격력, 방어력 계산
		
	self.attackValue:SetText(tostring(getOffence()))
	self.defenceValue:SetText( tostring(getDefence()))

	if Panel_Global_Manual:GetShow() then
		setFishingResourcePool_text()
	end
end

function	Equipment_equipItem( slotNo )
	local self = equip
	local slot = self.slots[slotNo]
	if 13 < slotNo and slotNo < 24 then
		slot.icon:AddEffect("UI_ItemInstall_Cash", false, 0.0, 0.0)
	else
		slot.icon:AddEffect("UI_ItemInstall", false, 0.0, 0.0)
	end
	slot.icon:AddEffect("fUI_SkillButton01", false, 0.0, 0.0)
	if slotNo < 14 then
		self.effectBG:AddEffect("UI_ItemInstall_BigRing", false, -2.8, -42.0)
	else
		self.effectBG:AddEffect("UI_ItemInstall_BigRing02", false, -2.8, -42.0)
	end
	
	local itemWrapper = getEquipmentItem( slotNo )
	if nil ~= itemWrapper then
		local meleeAttack = itemWrapper:getStaticStatus():getMaxDamage(0)
		local rangeAttack = itemWrapper:getStaticStatus():getMaxDamage(1)
		local magicAttack = itemWrapper:getStaticStatus():getMaxDamage(2)
		local defence = itemWrapper:getStaticStatus():getDefence(0)
		
		if 0 < meleeAttack or 0 < rangeAttack or 0 < magicAttack then
			self.effectBG:AddEffect("fUI_SkillButton01", false, 0, -68)
			self.effectBG:AddEffect("UI_SkillButton01", false, 0, -68)
		end
	
		if 0 < defence then
			self.effectBG:AddEffect("fUI_SkillButton01", false, -1, -13)
			self.effectBG:AddEffect("UI_SkillButton01", false, -1, -13)
		end
	end
end
function	Equipment_onScreenResize()
	Panel_Equipment:SetPosX( Panel_Window_Inventory:GetPosX() - Panel_Equipment:GetSizeX() )
	Panel_Equipment:SetPosY( getScreenSizeY() - (getScreenSizeY()/2) - (Panel_Equipment:GetSizeY()/2) )
end

function equip:registMessageHandler()
	registerEvent("EventEquipmentUpdate",	"Equipment_updateSlotData");
	registerEvent("EventEquipItem",			"Equipment_equipItem");
	registerEvent("EventPCEquipSetShow",	"Equipment_SetShow");
	registerEvent("onScreenResize",			"Equipment_onScreenResize" )
end

function Check_Helm()
	selfPlayerShowHelmet( not equip.checkHelm:IsCheck() )
end

function Check_HelmOpen()
	selfPlayerShowBattleHelmet( equip.checkHelmOpen:IsCheck() )
end

function Equipment_SimpleToolTips( isShow, btnType )
	if btnType == 0 then -- 투구 벗기
		name = "머리 부위 장비 설정"
		desc = "머리 부위의 장비를 가리거나 보이게 합니다."
		uiControl = equip.checkHelm
	elseif btnType == 1 then -- 안면 투구 열기
		name = "안면 보호대 설정"
		desc = "안면 보호대를 열거나 닫습니다."
		uiControl = equip.checkHelmOpen
	elseif btnType == 2 then -- 펫 버튼
		name = "애완동물"
		desc = "애완동물 목록을 볼 수 있습니다."
		uiControl = equip.btn_PetList
	end
	if true == isShow then
		TooltipSimple_Show( uiControl, name, desc )
	else
		TooltipSimple_Hide()
	end
end

-- 초기화 코드
equip:initControl()
equip:registEventHandler()
equip:registMessageHandler()