local UI_PSFT 			= CppEnums.PAUI_SHOW_FADE_TYPE
local UI_ANI_ADV 		= CppEnums.PAUI_ANIM_ADVANCE_TYPE
local UI_color 			= Defines.Color
local UI_TM 			= CppEnums.TextMode
local UCT 				= CppEnums.PA_UI_CONTROL_TYPE
local UI_Class			= CppEnums.ClassType
local PP 				= CppEnums.PAUIMB_PRIORITY
local ePcWorkingType 	= CppEnums.PcWorkType
local const_64			= Defines.s64_const

Panel_GameExit:setMaskingChild(true)
Panel_GameExit:ActiveMouseEventEffect(true)
Panel_GameExit:setGlassBackground(true)

Panel_GameExit:SetShow( false )

------------------------------------------
--		애니메이션 처리 함수
------------------------------------------
Panel_GameExit:RegisterShowEventFunc( true, 'Panel_GameExit_ShowAni()' )
Panel_GameExit:RegisterShowEventFunc( false, 'Panel_GameExit_HideAni()' )

function Panel_GameExit_ShowAni()
	UIAni.fadeInSCR_Down( Panel_GameExit )
	audioPostEvent_SystemUi(01,00)
end

function Panel_GameExit_HideAni()
	Panel_GameExit:SetShowWithFade(UI_PSFT.PAUI_ANI_TYPE_FADE_OUT)
	local aniInfo1 = Panel_GameExit:addColorAnimation( 0.0, 0.2, UI_ANI_ADV.PAUI_ANIM_ADVANCE_SIN_HALF_PI)
	aniInfo1:SetStartColor( UI_color.C_FFFFFFFF )
	aniInfo1:SetEndColor( UI_color.C_00FFFFFF )
	aniInfo1:SetStartIntensity( 3.0 )
	aniInfo1:SetEndIntensity( 1.0 )
	aniInfo1.IsChangeChild = true
	aniInfo1:SetHideAtEnd( true )
	aniInfo1:SetDisableWhileAni( true )
	
	audioPostEvent_SystemUi(01,01)
end

-----------------------------------------------------------------------------------------------------------------------------------------------
-----------------------------------------------------------------------------------------------------------------------------------------------
local _btn_winClose 		= UI.getChildControl( Panel_GameExit,	"Button_Win_Close" )				-- x 버튼

local _btn_selectCharacter 	= UI.getChildControl( Panel_GameExit,	"Button_CharacterSelect" )		-- 선택창 가기 버튼
local _btn_gameExit 		= UI.getChildControl( Panel_GameExit,	"Button_GameExit" )				-- 게임 종료 버튼
local _btn_cancel 			= UI.getChildControl( Panel_GameExit,	"Button_Cancel" )					-- 취소 버튼
local _charSlotBG 			= UI.getChildControl( Panel_GameExit,	"Static_CharSlot_BG" )
local _btn_NoticeMsg		= UI.getChildControl( Panel_GameExit,	"Button_NoticeMsg" )
local _btn_PreCharPage		= UI.getChildControl( Panel_GameExit,	"Button_PrePage" )
local _btn_NextCharPage		= UI.getChildControl( Panel_GameExit,	"Button_NextPage" )
local _combo_ChangeChannel	= UI.getChildControl( Panel_GameExit,	"Combobox_ChangeChannel" )
local _block_BG				= UI.getChildControl( Panel_GameExit,	"Static_block_BG" )

local _progressingQuest		= UI.getChildControl( Panel_GameExit,	"StaticText_ProgressingQuest_Value" )
local _completeQuest		= UI.getChildControl( Panel_GameExit,	"StaticText_LastCompleteQuest_Value" )
local _addMessage			= UI.getChildControl( Panel_GameExit,	"Edit_AddMessage" )
local journalFrame			= UI.getChildControl( Panel_GameExit,	"Frame_TodayMyChallenge" )
local journalFrameContents	= UI.getChildControl( journalFrame,		"Frame_1_Content" )
local journalFrameScroll	= UI.getChildControl( journalFrame,		"Frame_Scroll_TodayMyChallenge" )
local journalContents		= UI.getChildControl( Panel_GameExit,	"StaticText_TodayMyChallenge_Contents" )
journalFrameContents:AddChild( journalContents )
Panel_GameExit:RemoveControl( journalContents )
journalContents:SetAutoResize( true )
journalContents:SetTextMode( UI_TM.eTextMode_AutoWrap )
journalContents:SetPosX( 0 )
journalContents:SetPosY( 0 )
_addMessage:SetMaxInput( 24 )


local	currentDate	=
{
	_year			=	ToClient_GetThisYear(),			-- 올해
	_month			=	ToClient_GetThisMonth(),		-- 이달
	_day			=	ToClient_GetToday(),			-- 오늘
}

local 	_buttonQuestion = UI.getChildControl( Panel_GameExit, "Button_Question" )			-- 물음표 버튼

local Copy_UI_CharChange = 
{
	_copy_CharSlot 			= UI.getChildControl( Panel_GameExit, "Static_CharSlot" ),
	_copy_CharLevel 		= UI.getChildControl( Panel_GameExit, "StaticText_Char_Level" ),
	_copy_CharName 			= UI.getChildControl( Panel_GameExit, "StaticText_Char_Name" ),
	_copy_CharGaugeBG 		= UI.getChildControl( Panel_GameExit, "Static_Char_GaugeBG" ),
	_copy_CharGauge 		= UI.getChildControl( Panel_GameExit, "Static_Char_Gauge" ),
	_copy_CharWorkTxt 		= UI.getChildControl( Panel_GameExit, "StaticText_Char_Work" ),
	_copy_CharWhere 		= UI.getChildControl( Panel_GameExit, "StaticText_Char_Where" ),
	_copy_CharPosition 		= UI.getChildControl( Panel_GameExit, "StaticText_Char_Position" ),
	_copy_CharEnterWaiting	= UI.getChildControl( Panel_GameExit, "StaticText_EnterWaiting" ),
	_copy_CharChange 		= UI.getChildControl( Panel_GameExit, "Button_Change" ),
	_copy_CharSelect 		= UI.getChildControl( Panel_GameExit, "Static_CharSlot_Select" ),
}

-----------------------------------------------------------------------------------------------------------------------------------------------
-----------------------------------------------------------------------------------------------------------------------------------------------


------------------------------------------------------------
--						변수 모음
local totalCharacterCount = 4
local startPosX = 4
local exitMode = -1	-- 0 : 게임 종료 1 : 캐릭터 선택창으로 가기 2 : 캐릭터 교체
local logoutDelayTime = getLogoutWaitingTime()

enum_ExitMode =
{
	eExitMode_GameExit 		= 0,
	eExitMode_BackCharacter = 1,
	eExitMode_SwapCharacter = 2,
}

local exit_Time = 0.0
local prevTime = 0
local selectCharacterIndex = -1
local back_CharacterSelectTime = 0.0
local selfCharacterIndex = -1

local isCharacterSlot = {}
local CharacterChangeButton = {}
local isCharacterSelect = {}

-- 갱신될 정보들
local charWorking = {}
local charEnterWaiting = {}
local charLevelPool = {}
local charNamePool = {}
local charPositionPool = {}


-- 채널 이동 관련
local _selectChannel = -1;

------------------------------------------------------------
--						초기화 함수
------------------------------------------------------------
function Panel_GameExit_Initialize()
	--------------------------------------
	--		캐릭터 개수대로 복사하기
	local selfProxy = getSelfPlayer()
	local characterNo_64 = toInt64( 0, 0 )
	
	if nil ~= selfProxy then
		 characterNo_64 = selfProxy:getCharacterNo_64()
	end
	
	for idx = 0, totalCharacterCount - 1, 1 do
		-- 슬롯 복사
		local charSlot	= UI.createControl( UCT.PA_UI_CONTROL_STATIC, _charSlotBG, 'Static_CharSlot_' .. idx )
		CopyBaseProperty( Copy_UI_CharChange._copy_CharSlot, charSlot )
		charSlot:SetShow( false )
		charSlot:SetPosX( startPosX + idx * 159 )
		charSlot:SetPosY( 4 )
		isCharacterSlot[idx] = charSlot
		
		-- 캐릭터 레벨 복사
		local charLevel	= UI.createControl( UCT.PA_UI_CONTROL_STATICTEXT, charSlot, 'StaticText_CharLevel_' .. idx )
		CopyBaseProperty( Copy_UI_CharChange._copy_CharLevel, charLevel )
		charLevel:SetShow( false )
		charLevelPool[idx] = charLevel
		
		-- 캐릭터 이름 복사
		local charName	= UI.createControl( UCT.PA_UI_CONTROL_STATICTEXT, charSlot, 'StaticText_CharName_' .. idx )
		CopyBaseProperty( Copy_UI_CharChange._copy_CharName, charName )
		charName:SetShow( false )
		charNamePool[idx] = charName
		
		-- 작업중 텍스트 복사
		local charWorkTxt	= UI.createControl( UCT.PA_UI_CONTROL_STATICTEXT, charSlot, 'StaticText_CharWorkText_' .. idx )
		CopyBaseProperty( Copy_UI_CharChange._copy_CharWorkTxt, charWorkTxt )
		charWorkTxt:SetShow( false )
		charWorking[idx] = charWorkTxt
		
		-- 실제 위치 복사
		local charPositionTxt	= UI.createControl( UCT.PA_UI_CONTROL_STATICTEXT, charSlot, 'StaticText_CharPosition_' .. idx )
		CopyBaseProperty( Copy_UI_CharChange._copy_CharPosition, charPositionTxt )
		charPositionTxt:SetShow( false )
		charPositionPool[idx] = charPositionTxt

		-- 대기열 복사
		local charEnterWaitingTxt	= UI.createControl( UCT.PA_UI_CONTROL_STATICTEXT, charSlot, 'StaticText_EnterWaiting_' .. idx )
		CopyBaseProperty( Copy_UI_CharChange._copy_CharEnterWaiting, charEnterWaitingTxt )
		charEnterWaitingTxt:SetShow( false )			
		charEnterWaiting[idx] = charEnterWaitingTxt

		-- 교체버튼 복사
		local charChange	= UI.createControl( UCT.PA_UI_CONTROL_BUTTON, charSlot, 'Button_CharChange_' .. idx )
		CopyBaseProperty( Copy_UI_CharChange._copy_CharChange, charChange )
		charChange:SetShow( false )
		CharacterChangeButton[idx] = charChange
		
		-- 선택한 테두리 복사
		local charSelected	= UI.createControl( UCT.PA_UI_CONTROL_STATIC, _charSlotBG, 'Statc_CharSelected_' .. idx )
		CopyBaseProperty( Copy_UI_CharChange._copy_CharSelect, charSelected )
		charSelected:SetShow( false )
		charSelected:SetPosX( 2 + idx * 159 )
		charSelected:SetPosY( 2 )
		
		isCharacterSelect[idx] = charSelected
	end

	--------------------------------------
	--		복사 후 기본 꺼주기
	for _, value in pairs ( Copy_UI_CharChange ) do
		value:SetShow(false)
	end

	-- 채널 변경 콤보 박스 맨 위로 올리기
	Panel_GameExit:SetChildIndex(_combo_ChangeChannel:GetKey(), 9999 )

	local curChannelData		= getCurrentChannelServerData()
	if ( nil == curChannelData ) then
		-- _PA_LOG("Lua error", "getCurrentChannelServerData() 값이 없습니다. ")
		return;
	end
	
	local curWorldData			= getGameWorldServerDataByWorldNo( curChannelData._worldNo )
	local channelCount			= getGameChannelServerDataCount( curWorldData._worldNo )
	local restrictedServerNo	= curWorldData._restrictedServerNo
	local curServerNo			= curChannelData._serverNo

	for chIndex = 0, channelCount - 1, 1 do
		local tempChannel = getGameChannelServerDataByWorldNo(curChannelData._worldNo, chIndex)

		local isAdmission = true
		if( restrictedServerNo ~= 0 ) then
			if( restrictedServerNo == tempChannel._serverNo ) then
				isAdmission = true
			else
				isAdmission = false
			end		
		
		else
		
			
		end

		local channelName	= getChannelName(tempChannel._worldNo, tempChannel._serverNo )
		if (curChannelData._worldNo == tempChannel._worldNo) and (curChannelData._serverNo == tempChannel._serverNo) then
			channelName = PAGetString(Defines.StringSheet_GAME, "LUA_GAMEEXIT_CHANNELNAME_CURRENT") .. channelName
		end

		if tempChannel._isMain then
			channelName = channelName .. "(Main)"
		else
			channelName = channelName
		end

		if not isAdmission then
			channelName = channelName .. PAGetString(Defines.StringSheet_GAME, "LUA_GAMEEXIT_CHANNELNAME_LIMIT") 
		else
			channelName = channelName
		end
		_combo_ChangeChannel:AddItem( channelName )
	end
	-- 다른 곳을 클릭하지 못하도록 막는다.
	_block_BG:SetSize( getScreenSizeX(), getScreenSizeY() )
end

-- 
function refreshCharacterInfoData( startIdx )
	local selfProxy			= getSelfPlayer()
	local characterNo_64	= toInt64( 0, 0 )

	if nil == startIdx then
		startIdx = 0
	end

	if nil ~= selfProxy then
		 characterNo_64 = selfProxy:getCharacterNo_64()
	end
	
	if false == Panel_GameExit:IsShow() then
		return 	-- 종료 창이 닫혀 있다면 갱신하지 않는다.
	end

	local currentTicketNo		= getCurrentTicketNo()
	local uiCount				= 0
	local characterTicketNo
	local firstTicketNo			= getFirstTicketNoByAll()
	local characterDatacount	= getCharacterDataCount()
	local nowPlayCharaterSlotNo	= nil
	
	for idx = startIdx, characterDatacount - 1 do
		local characterData = getCharacterDataByIndex( idx )								-- 캐릭터 정보 데이터 바인드
		local char_Type 	= getCharacterClassType( characterData )						-- 클래스 타입
		local char_Level 	= string.format( "Lv. %d", characterData._level )				-- 캐릭터 레벨
		local char_Name 	= getCharacterName( characterData )								-- 캐릭터 이름
		local char_WorkTxt 	= global_workTypeToStringSwap( characterData._pcWorkingType )	-- 작업중 텍스트
		local regionInfo	= getRegionInfoByPosition( characterData._currentPosition )

		isCharacterSlot[uiCount]:SetShow( true )
		--	클래스에 따라 바꿔준다
		if ( char_Type == UI_Class.ClassType_Warrior ) then
			isCharacterSlot[uiCount]:ChangeTextureInfoName("New_UI_Common_forLua/Window/GameExit/GameExit_CharSlot_00.dds")
			local x1, y1, x2, y2 = setTextureUV_Func( isCharacterSlot[uiCount], 1, 1, 156, 201 )
			isCharacterSlot[uiCount]:getBaseTexture():setUV(  x1, y1, x2, y2  )
			isCharacterSlot[uiCount]:setRenderTexture(isCharacterSlot[uiCount]:getBaseTexture())
		elseif ( char_Type == UI_Class.ClassType_Ranger ) then
			isCharacterSlot[uiCount]:ChangeTextureInfoName("New_UI_Common_forLua/Window/GameExit/GameExit_CharSlot_00.dds")
			local x1, y1, x2, y2 = setTextureUV_Func( isCharacterSlot[uiCount], 157, 1, 312, 201 )
			isCharacterSlot[uiCount]:getBaseTexture():setUV(  x1, y1, x2, y2  )
			isCharacterSlot[uiCount]:setRenderTexture(isCharacterSlot[uiCount]:getBaseTexture())
		elseif ( char_Type == UI_Class.ClassType_Sorcerer ) then
			isCharacterSlot[uiCount]:ChangeTextureInfoName("New_UI_Common_forLua/Window/GameExit/GameExit_CharSlot_00.dds")
			local x1, y1, x2, y2 = setTextureUV_Func( isCharacterSlot[uiCount], 313, 1, 468, 201 )
			isCharacterSlot[uiCount]:getBaseTexture():setUV(  x1, y1, x2, y2  )
			isCharacterSlot[uiCount]:setRenderTexture(isCharacterSlot[uiCount]:getBaseTexture())
		elseif ( char_Type == UI_Class.ClassType_Giant ) then
			isCharacterSlot[uiCount]:ChangeTextureInfoName("New_UI_Common_forLua/Window/GameExit/GameExit_CharSlot_00.dds")
			local x1, y1, x2, y2 = setTextureUV_Func( isCharacterSlot[uiCount], 1, 202, 156, 402 )
			isCharacterSlot[uiCount]:getBaseTexture():setUV(  x1, y1, x2, y2  )
			isCharacterSlot[uiCount]:setRenderTexture(isCharacterSlot[uiCount]:getBaseTexture())
		elseif ( char_Type == UI_Class.ClassType_Tamer ) then
			isCharacterSlot[uiCount]:ChangeTextureInfoName("New_UI_Common_forLua/Window/GameExit/GameExit_CharSlot_00.dds")
			local x1, y1, x2, y2 = setTextureUV_Func( isCharacterSlot[uiCount], 157, 202, 312, 402 )
			isCharacterSlot[uiCount]:getBaseTexture():setUV(  x1, y1, x2, y2  )
			isCharacterSlot[uiCount]:setRenderTexture(isCharacterSlot[uiCount]:getBaseTexture())
		elseif ( char_Type == UI_Class.ClassType_BladeMaster ) then
			isCharacterSlot[uiCount]:ChangeTextureInfoName("New_UI_Common_forLua/Window/GameExit/GameExit_CharSlot_00.dds")
			local x1, y1, x2, y2 = setTextureUV_Func( isCharacterSlot[uiCount], 313, 202, 468, 402 )
			isCharacterSlot[uiCount]:getBaseTexture():setUV(  x1, y1, x2, y2  )
			isCharacterSlot[uiCount]:setRenderTexture(isCharacterSlot[uiCount]:getBaseTexture())
		end

		charLevelPool[uiCount]			:SetText( char_Level )
		charNamePool[uiCount]			:SetText( char_Name )
		if 0 == characterData._currentPosition.x and 0 == characterData._currentPosition.y and 0 == characterData._currentPosition.z then
			charPositionPool[uiCount]		:SetText( "-" )
		else
			charPositionPool[uiCount]		:SetText( regionInfo:getAreaName() )
		end
		charWorking[uiCount]			:SetShow( true )
		charLevelPool[uiCount]			:SetShow( true )
		charNamePool[uiCount]			:SetShow( true )
		charPositionPool[uiCount]		:SetShow( true )
		charEnterWaiting[uiCount]		:SetShow( true )

		isCharacterSlot[uiCount]		:addInputEvent( "Mouse_LUp", "Panel_GameExit_ClickCharSlot(" .. uiCount .. ")" )
		CharacterChangeButton[uiCount]	:addInputEvent( "Mouse_LUp", "Panel_GameExit_ChangeCharacter(".. idx ..")" )

		local selfProxy = getSelfPlayer()
		local characterNo_64 = toInt64( 0, 0 )
		if nil ~= selfProxy then
			 characterNo_64 = selfProxy:getCharacterNo_64()
		end

		if characterNo_64 == characterData._characterNo_s64 then
			isCharacterSlot[uiCount]		:SetEnable(false)
			isCharacterSlot[uiCount]		:SetMonoTone(true)
			CharacterChangeButton[uiCount]	:SetEnable(false)
			charWorking[uiCount]			:SetText( PAGetString( Defines.StringSheet_GAME, "LUA_GAMEEXIT_MESSAGE_ONLINE" ) )			-- "접속중"
			charWorking[uiCount]			:SetFontColor(UI_color.C_FF6DC6FF)
			local myRegionInfo	= getRegionInfoByPosition( selfProxy:get():getPosition() )
			charPositionPool[uiCount]		:SetText( myRegionInfo:getAreaName() )
			nowPlayCharaterSlotNo = uiCount
		else
			isCharacterSlot[uiCount]		:SetEnable(true)
			isCharacterSlot[uiCount]		:SetMonoTone(false)
			CharacterChangeButton[uiCount]	:SetEnable(true)
			charWorking[uiCount]			:SetText( char_WorkTxt )						-- 작업중 텍스트
			charWorking[uiCount]			:SetFontColor(UI_color.C_FFE7E7E7)
			
			local	removeTime	= getCharacterDataRemoveTime(idx)
			if nil ~= removeTime then
				charWorking[uiCount]			:SetText( PAGetString( Defines.StringSheet_GAME, "CHARACTER_DELETING" ) )			-- "삭제중"
			else
				charWorking[uiCount]			:SetText( char_WorkTxt )						-- 작업중 텍스트
			end
		end

		characterTicketNo = currentTicketNo - characterData._lastTicketNoByRegion
		if const_64.s64_m1 ~= firstTicketNo or (const_64.s64_m1 ~= characterData._lastTicketNoByRegion and const_64.s64_m1 < characterTicketNo) then		-- const_64.s64_m1
			--charEnterWaiting[ uiCount ]:SetShow( true )
			--charEnterWaiting[ uiCount ]:SetText( "대기자 : " .. tostring( characterTicketNo ) .. " 명" )
			charEnterWaiting[uiCount]:SetText(PAGetString( Defines.StringSheet_GAME, "LUA_GAMEEXIT_NOT_ENTER_TO_FIELD" ) )		-- 접속 대기 필요
		else
			if characterNo_64 == characterData._characterNo_s64 then
				charEnterWaiting[uiCount]:SetShow( false )
			else
				charEnterWaiting[uiCount]:SetText( PAGetString( Defines.StringSheet_GAME, "LUA_GAMEEXIT_ENTER_TO_FIELD" ) )			-- 바로 접속 가능
			end
		end

		uiCount = uiCount + 1

		if 4 == uiCount then
			break
		end
	end

	if nil ~= nowPlayCharaterSlotNo then
		local basePosX = _charSlotBG:GetPosX()
		local basePosY = _charSlotBG:GetPosY()
		local posX = ( ( basePosX + isCharacterSlot[nowPlayCharaterSlotNo]:GetPosX()) + ( isCharacterSlot[nowPlayCharaterSlotNo]:GetSizeX()/2) ) - (_combo_ChangeChannel:GetSizeX()/2)
		local posY = ( basePosY + isCharacterSlot[nowPlayCharaterSlotNo]:GetPosY())+ isCharacterSlot[nowPlayCharaterSlotNo]:GetSizeY() - _combo_ChangeChannel:GetSizeY() - 10
		_combo_ChangeChannel:SetPosX( posX )
		_combo_ChangeChannel:SetPosY( posY )
		_combo_ChangeChannel:SetShow( true )
		_combo_ChangeChannel:addInputEvent("Mouse_LUp", "HandleClicked_ChangeChannel()")
	else
		_combo_ChangeChannel:SetShow( false )
	end

	if (characterDatacount - 1) < (startIdx + 4) then
		_btn_NextCharPage:addInputEvent("Mouse_LUp", "")
		_btn_NextCharPage:SetShow(false)
	else
		_btn_NextCharPage:addInputEvent("Mouse_LUp", "refreshCharacterInfoData(" .. startIdx+1 .. ")")
		_btn_NextCharPage:SetShow(true)
	end
	if 0 < startIdx then
		_btn_PreCharPage:addInputEvent("Mouse_LUp", "refreshCharacterInfoData(" .. startIdx-1 .. ")")
		_btn_PreCharPage:SetShow(true)
	else
		_btn_PreCharPage:addInputEvent("Mouse_LUp", "")
		_btn_PreCharPage:SetShow(false)
	end
end

function HandleClicked_ChangeChannel()
	-- 현재 채널 인덱스를 알아야 한다.

	local	list = _combo_ChangeChannel:GetListControl()
	list:addInputEvent( "Mouse_LUp", "_do_ChangeChannel()" )
	_combo_ChangeChannel:ToggleListbox()
end
function _do_ChangeChannel()
	
	local selfProxy = getSelfPlayer()
	local regionInfo = getRegionInfoByPosition( selfProxy:get():getPosition() )
	if false == regionInfo:get():isSafeZone() then
		NotifyDisplay( PAGetString( Defines.StringSheet_GAME, "GAMEEXIT_TEXT_DO_SAFEZONE" ) )
		return
	end

	_selectChannel = _combo_ChangeChannel:GetSelectIndex()
	local comboList	= _combo_ChangeChannel:GetListControl()
	local channelName = comboList:GetItemText( _selectChannel )
	
	local	messageBoxMemo	= PAGetStringParam1( Defines.StringSheet_GAME, "LUA_GAMEEXIT_CHANNELMOVE_MSG", "channelName", tostring( channelName ) ) -- "[" .. tostring( channelName ).. "]으로 채널이동을 하시겠습니까? "
	local	messageBoxData = { title = PAGetString(Defines.StringSheet_GAME, "LUA_GAMEEXIT_CHANNELMOVE_TITLE_MSG"), content = messageBoxMemo, functionYes = confirm_MoveChannel_From_MessageBox, functionNo = MessageBox_Empty_function, priority = CppEnums.PAUIMB_PRIORITY.PAUIMB_PRIORITY_LOW}
	MessageBox.showMessageBox(messageBoxData)
	
	-- 현재 종료창을 닫아 준다.
	--GameExitShowToggle()
end

function confirm_MoveChannel_From_MessageBox()

	gameExit_MoveChannel(_selectChannel);
	
	local	messageBoxMemo	= PAGetString(Defines.StringSheet_GAME, "LUA_GAMEEXIT_CHANNELWAIT_MSG") -- "채널 이동 대기중 입니다"
	local	messageBoxData = { title = PAGetString(Defines.StringSheet_GAME, "LUA_GAMEEXIT_CHANNELMOVE_TITLE_MSG"), content = messageBoxMemo, functionYes = nil, functionClose = nil, exitButton = true, priority = CppEnums.PAUIMB_PRIORITY.PAUIMB_PRIORITY_LOW}
	MessageBox.showMessageBox(messageBoxData)
end

---------------------------------------------
--		교체 캐릭터의 상태 가져오기
function global_workTypeToStringSwap( workingType )
	local workingText

	if ePcWorkingType.ePcWorkType_Empty == workingType then
		workingText = PAGetString( Defines.StringSheet_GAME, "CHARACTER_WORKING_TEXT_NONE" )		-- 대기 중
	elseif ePcWorkingType.ePcWorkType_Play == workingType then
		workingText = PAGetString( Defines.StringSheet_GAME, "CHARACTER_WORKING_TEXT_PLAY" )		-- 플레이 중
	elseif ePcWorkingType.ePcWorkType_RepairItem == workingType then
		workingText = PAGetString( Defines.StringSheet_GAME, "CHARACTER_WORKING_TEXT_REPAIRITEM" )	-- 수리 중
	elseif ePcWorkingType.ePcWorkType_Delivery == workingType then
		workingText = PAGetString( Defines.StringSheet_GAME, "CHARACTER_WORKING_TEXT_DELIVERY" )	-- 캐릭터 이동 중
	elseif ePcWorkingType.ePcWorkType_Relex == workingType then
		workingText = PAGetString( Defines.StringSheet_GAME, "CHARACTER_WORKING_TEXT_RELEX" )		-- 휴식 중
	elseif ePcWorkingType.ePcWorkType_ReadBook == workingType then
		workingText = PAGetString( Defines.StringSheet_GAME, "CHARACTER_WORKING_TEXT_READBOOK" )	-- 책 읽는 중
	else
		_PA_ASSERT(false, "캐릭터 작업 타입이 추가 되었습니다. Lobby_New.lua 도 추가해 주어야 합니다.")
		workingText = "unKnown"		
	end

	return workingText
end

------------------------------------------------------------
--			해당케릭터가 종료될때 메모및 현재 길찾기 정보를 기억해준다.
------------------------------------------------------------
function gameExit_saveCurrentData()
	getSelfPlayer():updateNavigationInformation(_addMessage:GetEditText())
end

------------------------------------------------------------
--			버튼 눌렀을 때를 계속 감시한다
------------------------------------------------------------
function gameExit_UpdatePerFrame( deltaTime )
	if exit_Time > 0.0 then
		exit_Time = exit_Time - deltaTime

		local remainTime = math.floor( exit_Time )
		if prevTime ~= remainTime then
			if 0 > remainTime then
				remainTime = 0
			end

			prevTime = remainTime
			
			--------------------------------
			--		종료를 눌렀다
			if enum_ExitMode.eExitMode_GameExit == exitMode then
				_btn_NoticeMsg:SetText( PAGetStringParam1( Defines.StringSheet_GAME, "GAMEEXIT_TEXT_COMMENT_TO_EXIT", "remainTime", tostring(remainTime) ) )		-- {remainTime}초 뒤 게임 종료. <PAColor0xffff7383>클릭하면 취소됩니다.<PAOldColor>
				
				if prevTime <= 0 then
					exit_Time = -1
					_btn_NoticeMsg:SetText( PAGetString( Defines.StringSheet_GAME, "GAMEEXIT_TEXT_COMMENT_PROGRESS" ) )				-- 잠시 후 종료 됩니다.
					doGameLogOut()
				end
				
			--------------------------------
			--		캐릭터 선택을 눌렀다
			elseif enum_ExitMode.eExitMode_BackCharacter == exitMode then
				_btn_NoticeMsg:SetText( PAGetStringParam1( Defines.StringSheet_GAME, "GAMEEXIT_TEXT_COMMENT_TO_CHARACTER_SELECT", "remainTime", tostring(remainTime) ) )	-- {remainTime}초 뒤 캐릭터 선택 화면으로 이동. <PAColor0xffff7383>클릭하면 취소됩니다.<PAOldColor>
				
				if prevTime <= 0 then
					exit_Time = -1

					_btn_NoticeMsg:SetText( PAGetString( Defines.StringSheet_GAME, "GAMEEXIT_TEXT_COMMENT_GO_CHARACTERSELECT" ) )
				end
				
			--------------------------------
			--		교체를 눌렀다
			elseif enum_ExitMode.eExitMode_SwapCharacter == exitMode then
				_btn_NoticeMsg:SetText( PAGetStringParam1( Defines.StringSheet_GAME, "GAMEEXIT_TEXT_COMMENT_TO_CHARACTER_CHANGE", "remainTime", tostring(remainTime) ) )		-- {remainTime}초 뒤 캐릭터 교체. <PAColor0xffff7383>클릭하면 취소됩니다.<PAOldColor>
				--_btn_NoticeMsg:SetText( PAGetString( Defines.StringSheet_GAME, "GAMEEXIT_TEXT_COMMENT_GO_SWAPCHARACTER" ) )
				if prevTime <= 0 then
					exit_Time = -1
					_btn_NoticeMsg:SetText( PAGetString( Defines.StringSheet_GAME, "GAMEEXIT_TEXT_COMMENT_GO_SWAPCHARACTER" ) )
				end
			else
				_btn_NoticeMsg:SetShow( false )
			end
		end
	end
end

------------------------------------------------------------
--				선택 취소 보내기
------------------------------------------------------------
function Panel_GameExit_sendGameDelayExitCancel()
	if not _btn_NoticeMsg:GetShow() then
		return
	end
	local regionInfo = getRegionInfoByPosition( getSelfPlayer():get():getPosition() )			-- 안전지대에서는 딜레이가 없어진다.
	local cancelAble = true
	if (exitMode == enum_ExitMode.eExitMode_BackCharacter) and true == regionInfo:get():isSafeZone() then
		cancelAble = false
	end
	
	if true == cancelAble then
		sendGameDelayExitCancel()
	end

	_btn_NoticeMsg:SetShow( false )
	_btn_selectCharacter:SetShow( true )
	_btn_gameExit:SetShow( true )
	_btn_cancel:SetShow( true )

	exit_Time = 0.0
	exitMode = -1
end

------------------------------------------------------------
--				캐릭터 슬롯을 클릭했다~!
------------------------------------------------------------
local prevClickIndex = 0
function Panel_GameExit_ClickCharSlot( idx )
	if prevClickIndex ~= idx then
		isCharacterSelect[prevClickIndex]:SetShow( false )
		CharacterChangeButton[prevClickIndex]:SetShow( false )
		isCharacterSlot[prevClickIndex]:ResetVertexAni()
		isCharacterSlot[prevClickIndex]:SetAlpha(1)
	end
	
	isCharacterSelect[idx]:SetShow( true )
	CharacterChangeButton[idx]:SetShow( true )
	isCharacterSlot[idx]:ResetVertexAni()
	isCharacterSlot[idx]:SetVertexAniRun( "Ani_Color_New", true )

	prevClickIndex = idx
end


------------------------------------------------------------
--				캐릭터 선택창을 눌렀다!
------------------------------------------------------------
function Panel_GameExit_ClickSelectCharacter()
	local contentStr = PAGetString(Defines.StringSheet_GAME, "LUA_GAMEEXIT_BACK_TO_CHARACTERSELECT_Q")	-- 캐릭터 선택 창으로 가시겠습니까?
	local messageboxData = { title = "", content = contentStr, functionYes = Panel_GameExit_CharSelect_Yes, functionCancel = MessageBox_Empty_function, priority = PP.PAUIMB_PRIORITY_LOW, exitButton = true }
	MessageBox.showMessageBox( messageboxData )
end

function Panel_GameExit_CharSelect_Yes()
	exitMode = enum_ExitMode.eExitMode_BackCharacter
	gameExit_saveCurrentData()
	sendCharacterSelect()
	
	_btn_selectCharacter:SetShow( false )
	_btn_gameExit:SetShow( false )
	_btn_cancel:SetShow( false )
	
	_btn_NoticeMsg:SetShow ( true )
	
	local regionInfo = getRegionInfoByPosition( getSelfPlayer():get():getPosition() )			-- 안전지대에서는 딜레이가 없어진다.
	if true == regionInfo:get():isSafeZone() then
		_btn_NoticeMsg:SetIgnore( true )
		_btn_NoticeMsg:SetText( PAGetString( Defines.StringSheet_GAME, "GAMEEXIT_TEXT_COMMENT_GO_CHARACTERSELECT" ) )
	else
		_btn_NoticeMsg:SetIgnore( false )
		_btn_NoticeMsg:SetText( PAGetStringParam1( Defines.StringSheet_GAME, "GAMEEXIT_TEXT_COMMENT_TO_CHARACTER_SELECT", "remainTime", logoutDelayTime ) )
	end
end

------------------------------------------------------------
--					캐릭터 교체를 눌렀다!!
------------------------------------------------------------
local changeIndex = 0
function Panel_GameExit_ChangeCharacter( index )
	changeIndex = index
	local characterData 			= getCharacterDataByIndex( index )
	if characterData._level < 5 then
		NotifyDisplay( PAGetStringParam1( Defines.StringSheet_GAME, "LUA_GAMEEXIT_DONT_CHAGECHARACTER", "iLevel", 4 ) )
		return
	end
	
	local selfProxy = getSelfPlayer()
	local regionInfo = getRegionInfoByPosition( selfProxy:get():getPosition() )
	if false == regionInfo:get():isSafeZone() then
		NotifyDisplay( PAGetString( Defines.StringSheet_GAME, "GAMEEXIT_TEXT_DO_SAFEZONE" ) )
		return
	end
	
	local	removeTime	= getCharacterDataRemoveTime(index)
	if nil ~= removeTime then
		NotifyDisplay( PAGetString( Defines.StringSheet_GAME, "GAMEEXIT_TEXT_CHARACTER_DELETE" ) )
		return
	end
	
	local contentString = ""
	if const_64.s64_m1 ~= characterData._lastTicketNoByRegion then
		contentString = PAGetString( Defines.StringSheet_GAME, "GAMEEXIT_TEXT_WAIT" ) .. "\n"
	end

	if ePcWorkingType.ePcWorkType_Empty ~= characterData._pcWorkingType then
	
		if ePcWorkingType.ePcWorkType_ReadBook == characterData._pcWorkingType then
			contentString = contentString .. PAGetString(Defines.StringSheet_GAME, "LUA_GAMEEXIT_WORKING_NOW_READ_BOOK")
		else
			contentString = contentString .. PAGetString(Defines.StringSheet_GAME, "LUA_GAMEEXIT_WORKING_NOW_CHANGE_Q")
		end
		
	end
	
	if nil ~= contentString then
		contentString = contentString .. "\n" .. PAGetString(Defines.StringSheet_GAME, "LUA_GAMEEXIT_CHARACTER_CHANGE_QUESTION")
		local messageboxData = { title = "", content = contentString, functionYes = Panel_GameExit_CharChange_Confirm, functionCancel = MessageBox_Empty_function, priority = PP.PAUIMB_PRIORITY_LOW } -- "작업중에 있습니다. 교체하겠습니까?"
		MessageBox.showMessageBox( messageboxData )
	else
		Panel_GameExit_CharChange_Confirm()
	end
end

function Panel_GameExit_CharChange_Confirm()
	gameExit_saveCurrentData()
	local rv = swapCharacter_Select( changeIndex, true )

	if false == rv then
		--NotifyDisplay( PAGetString( Defines.StringSheet_GAME, "GAMEEXIT_TEXT_NOT_SAFETYZONE" ) )
		return
	end
	
	exitMode = enum_ExitMode.eExitMode_SwapCharacter
	
	_btn_selectCharacter:SetShow( false )
	_btn_gameExit:SetShow( false )
	_btn_cancel:SetShow( false )
	
	_btn_NoticeMsg:SetShow ( true )
	_btn_NoticeMsg:SetText( PAGetStringParam1( Defines.StringSheet_GAME, "GAMEEXIT_TEXT_COMMENT_TO_CHARACTER_CHANGE", "remainTime", logoutDelayTime ) )
	--_btn_NoticeMsg:SetText( PAGetString( Defines.StringSheet_GAME, "GAMEEXIT_TEXT_COMMENT_GO_SWAPCHARACTER" ) )
end

------------------------------------------------------------
--				게임 종료를 눌렀다!
------------------------------------------------------------
function Panel_GameExit_ClickGameOff()
	--isCharacterSlot[1]:testFunc()
	local contentStr = PAGetString(Defines.StringSheet_GAME, "LUA_GAMEEXIT_QUIT_GAME_Q")	-- 게임을 종료하시겠습니까?
	local messageboxData = { title = "", content = contentStr, functionYes = Panel_GameExit_GameOff_Yes, functionCancel = MessageBox_Empty_function, priority = PP.PAUIMB_PRIORITY_LOW }
	MessageBox.showMessageBox( messageboxData )
end

function Panel_GameExit_GameOff_Yes()
	exitMode = enum_ExitMode.eExitMode_GameExit
	gameExit_saveCurrentData()
	sendBeginGameDelayExit( enum_ExitMode.eExitMode_SwapCharacter == exitMode )

	_btn_selectCharacter:SetShow( false )
	_btn_gameExit:SetShow( false )
	_btn_cancel:SetShow( false )
	
	_btn_NoticeMsg:SetShow ( true )
	
	local regionInfo = getRegionInfoByPosition( getSelfPlayer():get():getPosition() )			-- 안전지대에서는 딜레이가 없어진다.

	if true == regionInfo:get():isSafeZone() then
		_btn_NoticeMsg:SetText( PAGetString( Defines.StringSheet_GAME, "GAMEEXIT_TEXT_COMMENT_PROGRESS" ) )
		_btn_NoticeMsg:SetIgnore( true )
	else
		_btn_NoticeMsg:SetText( PAGetStringParam1( Defines.StringSheet_GAME, "GAMEEXIT_TEXT_COMMENT_TO_EXIT", "remainTime", logoutDelayTime ) )
		_btn_NoticeMsg:SetIgnore( false )
	end
end

-- 게임 종료
function doGameLogOut()
	--Panel_GameExit:SetShow( false )
	SetUIMode( Defines.UIMode.eUIMode_Default )
	sendGameLogOut()
end

-- 서버로 부터 지연 종료 처리 시간을 받음
function setGameExitDelayTime( delayTime )
	if false == Panel_GameExit:GetShow() then
		return
	end

	exit_Time = delayTime
	
	_btn_NoticeMsg:SetIgnore( false )
	if enum_ExitMode.eExitMode_SwapCharacter ~= exitMode then
		-- _textExitQuestionMsg:SetText( PAGetString( Defines.StringSheet_GAME, "GAMEEXIT_TEXT_COMMENT_CANCEL" ) )
		_btn_NoticeMsg:SetText( PAGetStringParam1( Defines.StringSheet_GAME, "GAMEEXIT_TEXT_COMMENT_TO_CHARACTER_CHANGE", "remainTime", tostring(delayTime) ) )
	elseif enum_ExitMode.eExitMode_GameExit == exitMode then
		_btn_NoticeMsg:SetText( PAGetStringParam1( Defines.StringSheet_GAME, "GAMEEXIT_TEXT_COMMENT_TO_EXIT", "remainTime", tostring(delayTime) ) )
	elseif enum_ExitMode.eExitMode_BackCharacter == exitMode then
		_btn_NoticeMsg:SetText( PAGetStringParam1( Defines.StringSheet_GAME, "GAMEEXIT_TEXT_COMMENT_TO_CHARACTER_SELECT", "remainTime", tostring(delayTime) ) )
	end
end

------------------------------------------------------------
--				게임 종료창 SHOW TOGGLE
------------------------------------------------------------
function characterInfoRequest()
	--swapCharacter_sendLoginUserFieldServerReq()
end

local prevUIMode = 0
function GameExitShowToggle()
	if ( CppEnums.EProcessorInputMode.eProcessorInputMode_ChattingInputMode == UI.Get_ProcessorInputMode() ) then 
		return
	end
	
	if ( ToClient_cutsceneIsPlay() ) then
		return
	end
	
	if( isFlushedUI() ) then
		return
	end		

	local isShow = Panel_GameExit:IsShow()
	
	if (true == isShow) then
		Panel_GameExit:SetShow( false, true )
		
		SetUIMode( prevUIMode )
		UI.Set_ProcessorInputMode(CppEnums.EProcessorInputMode.eProcessorInputMode_GameMode)
		
		if -1 ~= exitMode then
			Panel_GameExit_sendGameDelayExitCancel()
		end

		local focusEdit = GetFocusEdit()
		if ( nil ~= focusEdit ) and ( focusEdit:GetKey() == _addMessage:GetKey() ) then
			ClearFocusEdit()
		end
	else
		prevUIMode = GetUIMode()
		SetUIMode( Defines.UIMode.eUIMode_GameExit )
		Panel_GameExit:SetShow( true, true )
		sendWaitingListOfMyCharacters()
		
		refreshCharacterInfoData( 0 )
		--swapCharacter_sendLoginUserFieldServerReq()

		-- { 기억 저장 }
			local questWrapper
			local questNo0 = getSelfPlayer():get():getLastCompleteQuest(0)
			questWrapper = ToClient_getQuestWrapper( questNo0 )
			if ( nil ~= questWrapper ) then
				_completeQuest		:SetText(questWrapper:getTitle())
			else
				_completeQuest		:SetText("-")
			end

			local questNo1 = getSelfPlayer():get():getLastCompleteQuest(1)
			questWrapper = ToClient_getQuestWrapper( questNo1 )
			if ( nil ~= questWrapper ) then
				_progressingQuest	:SetText(questWrapper:getTitle())
			else
				_progressingQuest	:SetText("-")
			end

			-- 오늘의 일지를 가져온다.
			ToClient_RequestJournalList( currentDate._year, currentDate._month, currentDate._myHistory )
			local journal_Count	= ToClient_GetJournalListCount( currentDate._year, currentDate._month, currentDate._myHistory )
			if 0 < journal_Count then
				for journal_Idx = journal_Count -1, 0, -1 do	-- 최근 것부터 역으로.
					local journalWarraper =	ToClient_GetJournal( currentDate._year, currentDate._month, currentDate._myHistory, journal_Idx )
					local stringData = "[" .. string.format( "%.02d", journalWarraper:getJournalHour() ) .. ":" .. string.format( "%.02d", journalWarraper:getJournalMinute() ) .. "] " .. journalWarraper:getName()
					if (journal_Count -1) == journal_Idx then
						journalContents:SetText( stringData )
					else
						journalContents:SetText( journalContents:GetText() .. "\n" .. stringData )
					end
					journalFrameContents:SetSize( journalFrameContents:GetSizeX(), journalContents:GetTextSizeY() )
				end
			else
				journalContents:SetText( "- 일지에 기록된 내용이 없습니다." )
			end

			if journalFrame:GetSizeY() < journalFrameContents:GetSizeY() then
				journalFrameScroll:SetShow( true )
			else
				journalFrameScroll:SetShow( false )
			end

			journalFrame:UpdateContentScroll()
			journalFrame:UpdateContentPos()
		-- }
	end
	
	local selfProxy = getSelfPlayer()
	local characterNo_64 = toInt64( 0, 0 )

	if nil ~= selfProxy then
		 characterNo_64 = selfProxy:getCharacterNo_64()
	end
	
	----------------------------------------
	--	선택했던 놈의 효과를 강제로 끈다!
	local uiCount = 0
	local characterDatacount = getCharacterDataCount()
	-- 현재 슬롯 넘버, 캐릭터 개수,
	for index = 0, 3, 1 do
		local characterData = getCharacterDataByIndex( charIndex )								-- 캐릭터 정보 데이터 바인드
		if nil == characterData then
			return
		end
		if characterNo_64 ~= characterData._characterNo_s64 then
			isCharacterSlot[index]:ResetVertexAni()
			isCharacterSelect[index]:SetShow( false )
			CharacterChangeButton[index]:SetShow( false )
		end
		if 4 == uiCount then
			break
		end
		uiCount = uiCount + 1
	end
	local uiCount = 0
	local characterDatacount = getCharacterDataCount()
	for charIndex = 0, 3, 1  do
		local characterData	= getCharacterDataByIndex( charIndex )								-- 캐릭터 정보 데이터 바인드
		if nil == characterData then
			return
		end

		if nil ~= characterData and characterNo_64 ~= characterData._characterNo_s64 then
			charEnterWaiting[ uiCount ]:SetText( "-" )		-- PAGetString( Defines.StringSheet_GAME, "LUA_GAMEEXIT_ENTER_TO_FIELD" )
			uiCount = uiCount + 1
		end
		if 4 == uiCount then
			break
		end
	end
end

function EventUpdateServerInformation_Exit()
	local isShow = Panel_GameExit:IsShow()	-- 서버 데이터를 업데이트했다.
	if( false == isShow ) then
		return;
	end
	----------------------------------------------------------------------------
	-- 채널 콤보 박스 업데이트
	----------------------------------------------------------------------------
	_combo_ChangeChannel:DeleteAllItem()	-- 일단 지움
	local curChannelData		= getCurrentChannelServerData()
	if ( nil == curChannelData ) then
		-- _PA_LOG("Lua error", "getCurrentChannelServerData() 값이 없습니다. ")
		return;
	end

	local curWorldData			= getGameWorldServerDataByWorldNo( curChannelData._worldNo )
	local channelCount			= getGameChannelServerDataCount( curWorldData._worldNo )
	local restrictedServerNo	= curWorldData._restrictedServerNo	-- restrictedServerNo 있을 때만 타임 체크를 한다.
	local curServerNo			= curChannelData._serverNo

	for chIndex = 0, channelCount - 1, 1 do
		local tempChannel = getGameChannelServerDataByWorldNo(curChannelData._worldNo, chIndex)
		if nil == tempChannel then
			return
		end

		local isAdmission = true
		if( restrictedServerNo ~= 0 ) then
			if( restrictedServerNo == tempChannel._serverNo ) then
				isAdmission = true
			else
				isAdmission = false
			end
		end

		local channelName	= getChannelName(tempChannel._worldNo, tempChannel._serverNo )
		if nil == channelName then
			channelName = ""
		end

		if (curChannelData._worldNo == tempChannel._worldNo) and (curChannelData._serverNo == tempChannel._serverNo) then
			channelName = PAGetString(Defines.StringSheet_GAME, "LUA_GAMEEXIT_CHANNELNAME_CURRENT") .. channelName
		end

		if tempChannel._isMain then
			channelName = channelName .. "(Main)"
		else
			channelName = channelName
		end

		if not isAdmission then
			channelName = channelName .. PAGetString(Defines.StringSheet_GAME, "LUA_GAMEEXIT_CHANNELNAME_LIMIT")
		else
			channelName = channelName
		end
		_combo_ChangeChannel:AddItem( channelName )
	end

	-- 콤보 박스 초기화
	_combo_ChangeChannel:SetEnable( true )
	_combo_ChangeChannel:SetMonoTone( false )

	if 0 ~= restrictedServerNo then
		local remainTime64 = getChannelMoveableRemainTime()
		_combo_ChangeChannel:SetEnable( false )
		_combo_ChangeChannel:SetMonoTone( true )
		if( Defines.s64_const.s64_0 < remainTime64 ) then
			local remainMoveTime = Util.Time.timeFormatting( Int64toInt32(remainTime64) )
			_combo_ChangeChannel:SetText( PAGetStringParam1( Defines.StringSheet_GAME, "LUA_GAMEEXIT_CHANNELCHANGE", "remainMoveTime", remainMoveTime ) ) -- remainMoveTime .. "후 가능" )
			-- 채널 이동 불가능.
		else
			_combo_ChangeChannel:SetText( PAGetString(Defines.StringSheet_GAME, "LUA_GAMEEXIT_CHANNELCHANGE_LIMIT") ) -- "채널이동 제한"
			-- 서버 이동이 제한된 상태이거나(무기한 제한)
		end
	end
end

function GameExit_onScreenResize()
	_block_BG:SetSize( getScreenSizeX(), getScreenSizeY() )
end
----------------------------------------------------------------------------------------------------------------------------------------------------------------
----------------------------------------------------------------------------------------------------------------------------------------------------------------

Panel_GameExit_Initialize()

local registEventHandler = function()
	_btn_cancel:			addInputEvent( "Mouse_LUp", "GameExitShowToggle()" )								-- 취소 버튼
	_btn_winClose:			addInputEvent( "Mouse_LUp", "GameExitShowToggle()" )								-- x 버튼
	_btn_gameExit:			addInputEvent( "Mouse_LUp", "Panel_GameExit_ClickGameOff()" )
	_btn_selectCharacter:	addInputEvent( "Mouse_LUp", "Panel_GameExit_ClickSelectCharacter()" )
	_btn_NoticeMsg:			addInputEvent( "Mouse_LUp", "Panel_GameExit_sendGameDelayExitCancel()" )			-- 알림 메시지 x초 후 XXX 합니다. 취소하려면 클릭

	_buttonQuestion:		addInputEvent( "Mouse_LUp", "Panel_WebHelper_ShowToggle( \"PanelGameExit\" )()" )									-- 물음표 좌클릭
	_buttonQuestion:		addInputEvent( "Mouse_On", "HelpMessageQuestion_Show( \"PanelGameExit\", \"true\")" )					-- 물음표 마우스오버
	_buttonQuestion:		addInputEvent( "Mouse_Out", "HelpMessageQuestion_Show( \"PanelGameExit\", \"false\")" )					-- 물음표 마우스아웃
end

local registMessageHandler = function()
	Panel_GameExit:RegisterUpdateFunc("gameExit_UpdatePerFrame")
	registerEvent("EventGameExitDelayTime",			"setGameExitDelayTime")
	registerEvent("EventReceiveEnterWating",		"refreshCharacterInfoData")	--refreshCharacterInfoData	-- GameExitShowToggle
	registerEvent("EventGameWindowClose",			"GameExitShowToggle")
	registerEvent("EventUpdateServerInformationForExit",	"EventUpdateServerInformation_Exit")
	registerEvent("onScreenResize",					"GameExit_onScreenResize")
end

registEventHandler()
registMessageHandler()

