local UI_TM 		= CppEnums.TextMode
local UI_color 		= Defines.Color
local UI_Class		= CppEnums.ClassType
local UCT 			= CppEnums.PA_UI_CONTROL_TYPE
local IM 			= CppEnums.EProcessorInputMode
local VCK			= CppEnums.VirtualKeyCode

----------------------------------------------------------------------------------------------------------------
--	변수 모음
----------------------------------------------------------------------------------------------------------------

local _constGuildListMaxCount 	= 150
local _startMemberIndex 		= 0
local _constStartY 				= 5

local _constStartButtonX		= 8
local _constStartButtonY 		= 5
local _constStartButtonGapY		= 30
local _constCollectionX			= 320
local _constCollectionY			= 80
local _selectIndex				= 0		-- 선택된 길드 멤버 Index

local	_UI_Menu_Button	=
{
	Type_Deportation		= 0,	-- 추방
	Type_AppointCommander	= 1,	-- 분대장 임명
	Type_CancelAppoint		= 2,	-- 임명 해제
	Type_ChangeMaster		= 3,	-- 대장 위임	
	Type_Count				= 4
}

local numberKeyCode =		-- 입금 - 값 실시간 체크를 위한
{
	VCK.KeyCode_0,			
	VCK.KeyCode_1,	
	VCK.KeyCode_2,	
	VCK.KeyCode_3,	
	VCK.KeyCode_4,	
	VCK.KeyCode_5,	
	VCK.KeyCode_6,	
	VCK.KeyCode_7,	
	VCK.KeyCode_8,	
	VCK.KeyCode_9,
	VCK.KeyCode_NUMPAD0,
	VCK.KeyCode_NUMPAD1,
	VCK.KeyCode_NUMPAD2,
	VCK.KeyCode_NUMPAD3,
	VCK.KeyCode_NUMPAD4,
	VCK.KeyCode_NUMPAD5,
	VCK.KeyCode_NUMPAD6,
	VCK.KeyCode_NUMPAD7,
	VCK.KeyCode_NUMPAD8,
	VCK.KeyCode_NUMPAD9
}

local inputGuildDepositNum_s64		= toInt64(0, 0)
local inputGuildDepositMaxNum_s64	= toInt64(0, 0)
----------------------------------------------------------------------------------------------------------------
------------ 길드원 현황 관리
----------------------------------------------------------------------------------------------------------------
GuildListInfoPage = 
{
	_frameDefaultBG		= UI.getChildControl ( Panel_Window_Guild,	"Static_Frame_ListBG" ),
	_buttonListBG		= UI.getChildControl ( Panel_Guild_List,	"Static_FunctionBG" ),
	_scrollBar,
--	_scrollBarCtrl,
	_list = {},
	_buttonList = {},
	_textBusinessFunds,
	_btnGiveIncentive,
	_btnDeposit,		
	_btnPaypal,
	decoIcon_Guild,
	decoIcon_Clan,
	_frameGuildList,
	_contentGuildList,
}
--[[
GuildWarfareInfoPage
	initialize()
	UpdateData()
	Show()
	Hide()
	_list : rtGuildListInfo의 리스트	
		rtGuildListInfo로 검색해서 맴버 확인 요망	
	_buttonList : rtGuildListInfoButton의 리스트
]]--

--------------------------------------------------------------------------------
-- 지원금 관련 초기화 설정
--------------------------------------------------------------------------------
Panel_GuildIncentive:SetShow( false )
local incentive_InputMoney	= UI.getChildControl ( Panel_GuildIncentive,	"Edit_InputIncentiveValue" )
local btn_incentive_Send	= UI.getChildControl ( Panel_GuildIncentive,	"Button_Confirm" )
local btn_incentive_Cancle	= UI.getChildControl ( Panel_GuildIncentive,	"Button_Cancle" )
local btn_incentive_Help	= UI.getChildControl ( Panel_GuildIncentive,	"Button_Question" )
incentive_InputMoney:SetNumberMode( true )

local txt_incentive_Title			= UI.getChildControl ( Panel_GuildIncentive,	"StaticText_Title" )
local txt_incentive_Deposit			= UI.getChildControl ( Panel_GuildIncentive,	"StaticText_Incentive" )
local txt_incentive_Notify			= UI.getChildControl ( Panel_GuildIncentive,	"StaticText_Notify" )
txt_incentive_Notify:SetTextMode( UI_TM.eTextMode_AutoWrap )

incentive_InputMoney		:addInputEvent("Mouse_LUp", "HandleClicked_SetIncentive()")
btn_incentive_Send			:addInputEvent("Mouse_LUp", "HandleClicked_GuildIncentive_Send()")
btn_incentive_Cancle		:addInputEvent("Mouse_LUp", "HandleClicked_GuildIncentive_Close()")
btn_incentive_Help			:addInputEvent("Mouse_LUp", "")

-- 0 이면 지원금에서 사용하는 것이고, 1이면 입급에서 사용된다.
local _incentivePanelType = 0

------------------------------------------------------
--				최초 초기화 해주는 함수 (Panel_Guild.lua 에서 사용)
------------------------------------------------------
local frameSizeY = 0
local contentSizeY = 0

local staticText_activity				= UI.getChildControl ( Panel_Guild_List,	"StaticText_M_Activity" )
local staticText_contributedTendency	= UI.getChildControl ( Panel_Guild_List,	"StaticText_M_ContributedTendency" )
local staticText_contract				= UI.getChildControl ( Panel_Guild_List,	"StaticText_M_Contract" )

staticText_activity				:addInputEvent("Mouse_On",	"_guildListInfoPage_titleTooltipShow( true,		" .. 0 .. " )")
staticText_activity				:addInputEvent("Mouse_Out",	"_guildListInfoPage_titleTooltipShow( false,	" .. 0 .. " )")
-- staticText_contributedTendency	:addInputEvent("Mouse_On",	"_guildListInfoPage_titleTooltipShow( true,		" .. 1 .. " )")
-- staticText_contributedTendency	:addInputEvent("Mouse_Out",	"_guildListInfoPage_titleTooltipShow( false,	" .. 1 .. " )")
staticText_contract				:addInputEvent("Mouse_On",	"_guildListInfoPage_titleTooltipShow( true,		" .. 2 .. " )")
staticText_contract				:addInputEvent("Mouse_Out",	"_guildListInfoPage_titleTooltipShow( false,	" .. 3 .. " )")

function _guildListInfoPage_titleTooltipShow( isShow, titleType )
	local control = nil
	local name = ""
	local desc = ""
	if 0 == titleType then
		control = staticText_activity
		name = PAGetString(Defines.StringSheet_GAME, "LUA_GUILDLIST_ACTIVITY_TITLE")	-- "길드 활동량"
		-- desc = "준비중인 기능입니다."
		desc = PAGetString(Defines.StringSheet_GAME, "LUA_GUILDLIST_ACTIVITY_CONTENTS")
		-- "길드에 속한 시점부터 현재까지 활동한 정도를 수치로 나타낸 항목입니다."
	elseif 1 == titleType then
		control = staticText_contributedTendency
		name = PAGetString(Defines.StringSheet_GAME, "LUA_GUILDLIST_CONTRIBUTEDTENDENCY_TITLE")	-- "길드 성향 기여도"
		desc = PAGetString(Defines.StringSheet_GAME, "LUA_GUILDLIST_CONTRIBUTEDTENDENCY_CONTENTS")
		-- "길드에 속한 시점부터 현재까지 성향치에 관하여 활동한 정도를 수치로 나타낸 항목입니다."
	elseif 2 == titleType then
		control = staticText_contract
		name = PAGetString(Defines.StringSheet_GAME, "LUA_GUILDLIST_CONTRACT_TITLE")	-- "길드 계약서 보기"
		desc = PAGetString(Defines.StringSheet_GAME, "LUA_GUILDLIST_CONTRACT_CONTENTS")
		-- "해당 길드원의 길드 계약 내용을 열람할 수 있는 항목입니다."
	end

	if true == isShow then
		TooltipSimple_Show( control, name, desc )
	else
		TooltipSimple_Hide()
	end
end


function GuildListInfoPage:initialize()
	self._frameGuildList				= UI.getChildControl ( Panel_Guild_List, 	"Frame_GuildList" )
	self._contentGuildList				= UI.getChildControl ( self._frameGuildList, 	"Frame_1_Content" )

	local _copyGrade					= UI.getChildControl ( self._contentGuildList, 	"StaticText_C_Grade" )
	local _copyLevel					= UI.getChildControl ( self._contentGuildList, 	"StaticText_C_Level" )
	local _copyClass					= UI.getChildControl ( self._contentGuildList, 	"StaticText_C_Class" )
	local _copyCharName					= UI.getChildControl ( self._contentGuildList, 	"StaticText_C_CharName" )
	local _copyContributedTendency		= UI.getChildControl ( self._contentGuildList, 	"StaticText_C_ContributedTendency" )
	local _copyActivity					= UI.getChildControl ( self._contentGuildList,	"StaticText_C_Activity" )
	
	local _copyPartLine					= UI.getChildControl ( self._contentGuildList, 	"Static_C_PartLine" )	
	local _copyContractButton			= UI.getChildControl ( self._contentGuildList, 	"Button_C_Contract" )
	
	local _copyButton					= UI.getChildControl ( Panel_Guild_List, 	"Button_Function" )

	GuildListInfoPage._textBusinessFundsBG	= UI.getChildControl ( Panel_Guild_List, 	"StaticText_GuildMoney" )
	GuildListInfoPage._textBusinessFunds	= UI.getChildControl ( Panel_Guild_List, 	"StaticText_GuildMoney_Value" )
	
	GuildListInfoPage._btnGiveIncentive		= UI.getChildControl ( Panel_Guild_List,	"Button_Incentive" )
	GuildListInfoPage._btnDeposit			= UI.getChildControl ( Panel_Guild_List, 	"Button_Deposit" )
	GuildListInfoPage._btnPaypal			= UI.getChildControl ( Panel_Guild_List, 	"Button_Paypal" )

	GuildListInfoPage.decoIcon_Guild		= UI.getChildControl ( self._contentGuildList, 	"Static_DecoIcon_Guild" )
	GuildListInfoPage.decoIcon_Clan			= UI.getChildControl ( self._contentGuildList, 	"Static_DecoIcon_Clan" )

	GuildListInfoPage._btnGiveIncentive	:addInputEvent("Mouse_LUp",	"HandleCLicked_IncentiveOption()")
	GuildListInfoPage._btnDeposit		:addInputEvent("Mouse_LUp",	"HandleCLicked_GuildListIncentive_Deposit()")
	GuildListInfoPage._btnPaypal		:addInputEvent("Mouse_LUp",	"HandleCLicked_GuildListIncentive_Paypal()")

	-- 스크롤 관련 부분------------------------------------------------
	self._scrollBar = UI.getChildControl ( self._frameGuildList,		"VerticalScroll" )
	UIScroll.InputEvent( self._scrollBar, "GuildListMouseScrollEvent" )
	
	self._contentGuildList:addInputEvent("Mouse_UpScroll", 		"GuildListMouseScrollEvent(true)")
	self._contentGuildList:addInputEvent("Mouse_DownScroll", 	"GuildListMouseScrollEvent(false)")
	---------------------------------------------------------------------
	
	-- 리스트 생성
	function createListInfo( pIndex )
		local rtGuildListInfo = {}
		
		rtGuildListInfo._grade 					= UI.createControl( UCT.PA_UI_CONTROL_STATICTEXT, 	self._contentGuildList, 'StaticText_Grade_' .. pIndex )	
		rtGuildListInfo._level 					= UI.createControl( UCT.PA_UI_CONTROL_STATICTEXT, 	self._contentGuildList, 'StaticText_Level_' .. pIndex )
		rtGuildListInfo._class 					= UI.createControl( UCT.PA_UI_CONTROL_STATICTEXT, 	self._contentGuildList, 'StaticText_Class_' .. pIndex )
		rtGuildListInfo._charName 				= UI.createControl( UCT.PA_UI_CONTROL_STATICTEXT, 	self._contentGuildList, 'StaticText_CharName_' .. pIndex )
		rtGuildListInfo._contributedTendency	= UI.createControl( UCT.PA_UI_CONTROL_STATICTEXT, 	self._contentGuildList, 'StaticText_ContributedTendency_' .. pIndex )	-- 성향치 기여도
		rtGuildListInfo._activity				= UI.createControl( UCT.PA_UI_CONTROL_STATICTEXT, 	self._contentGuildList, 'StaticText_Activity_' .. pIndex )	-- 활동량
		rtGuildListInfo._partLine 				= UI.createControl( UCT.PA_UI_CONTROL_STATIC, 		self._contentGuildList, "Static_C_PartLine_".. pIndex )
		rtGuildListInfo._contractBtn 			= UI.createControl( UCT.PA_UI_CONTROL_BUTTON, 		self._contentGuildList, "Button_C_Contract_".. pIndex )
			
		CopyBaseProperty( _copyGrade, 					rtGuildListInfo._grade )	
		CopyBaseProperty( _copyLevel, 					rtGuildListInfo._level )
		CopyBaseProperty( _copyClass, 					rtGuildListInfo._class )
		CopyBaseProperty( _copyCharName, 				rtGuildListInfo._charName )
		CopyBaseProperty( _copyContributedTendency, 	rtGuildListInfo._contributedTendency )
		CopyBaseProperty( _copyActivity, 				rtGuildListInfo._activity)
		CopyBaseProperty( _copyPartLine, 				rtGuildListInfo._partLine )
		CopyBaseProperty( _copyContractButton, 			rtGuildListInfo._contractBtn )
	
		rtGuildListInfo._grade					:SetPosY( _constStartY + pIndex * 30 )	
		rtGuildListInfo._level					:SetPosY( _constStartY + pIndex * 30 )
		rtGuildListInfo._class					:SetPosY( _constStartY + pIndex * 30 )
		rtGuildListInfo._charName				:SetPosY( _constStartY + pIndex * 30 )
		rtGuildListInfo._contributedTendency	:SetPosY( _constStartY + pIndex * 30 )
		rtGuildListInfo._activity				:SetPosY( _constStartY + pIndex * 30 )
		rtGuildListInfo._partLine				:SetPosY( pIndex * 30 )
		rtGuildListInfo._contractBtn			:SetPosY( (pIndex * 30) + 6 )
		
		rtGuildListInfo._grade					:SetIgnore( false )
		rtGuildListInfo._level					:SetIgnore( false )
		rtGuildListInfo._class					:SetIgnore( false )
		rtGuildListInfo._charName				:SetIgnore( false )
		rtGuildListInfo._contributedTendency	:SetIgnore( false )
		rtGuildListInfo._activity				:SetIgnore( false )
		rtGuildListInfo._partLine				:SetIgnore( false )
		
		rtGuildListInfo._grade					:addInputEvent( "Mouse_LUp",			"HandleClickedGuildMemberMenuButton(" .. pIndex .. ")"	)
		rtGuildListInfo._level					:addInputEvent( "Mouse_LUp",			"HandleClickedGuildMemberMenuButton(" .. pIndex .. ")"	)
		rtGuildListInfo._class					:addInputEvent( "Mouse_LUp",			"HandleClickedGuildMemberMenuButton(" .. pIndex .. ")"	)
		rtGuildListInfo._charName				:addInputEvent( "Mouse_LUp",			"HandleClickedGuildMemberMenuButton(" .. pIndex .. ")"	)
		rtGuildListInfo._contributedTendency	:addInputEvent( "Mouse_LUp",			"HandleClickedGuildMemberMenuButton(" .. pIndex .. ")"	)
		rtGuildListInfo._activity				:addInputEvent( "Mouse_LUp",			"HandleClickedGuildMemberMenuButton(" .. pIndex .. ")"	)
		rtGuildListInfo._contractBtn			:addInputEvent( "Mouse_LUp",			"HandleClickedGuildMemberContractButton(" .. pIndex .. ")"	)
		
		rtGuildListInfo._grade					:addInputEvent( "Mouse_UpScroll", 		"GuildListMouseScrollEvent(true)")
		rtGuildListInfo._level					:addInputEvent( "Mouse_UpScroll", 		"GuildListMouseScrollEvent(true)")
		rtGuildListInfo._class					:addInputEvent( "Mouse_UpScroll", 		"GuildListMouseScrollEvent(true)")
		rtGuildListInfo._charName				:addInputEvent( "Mouse_UpScroll", 		"GuildListMouseScrollEvent(true)")
		rtGuildListInfo._contributedTendency	:addInputEvent( "Mouse_UpScroll", 		"GuildListMouseScrollEvent(true)")
		rtGuildListInfo._activity				:addInputEvent( "Mouse_UpScroll", 		"GuildListMouseScrollEvent(true)")
		rtGuildListInfo._partLine				:addInputEvent( "Mouse_UpScroll", 		"GuildListMouseScrollEvent(true)")
		rtGuildListInfo._contractBtn			:addInputEvent( "Mouse_UpScroll", 		"GuildListMouseScrollEvent(true)")
		
		rtGuildListInfo._grade					:addInputEvent( "Mouse_DownScroll", 	"GuildListMouseScrollEvent(false)")
		rtGuildListInfo._level					:addInputEvent( "Mouse_DownScroll", 	"GuildListMouseScrollEvent(false)")
		rtGuildListInfo._class					:addInputEvent( "Mouse_DownScroll", 	"GuildListMouseScrollEvent(false)")
		rtGuildListInfo._charName				:addInputEvent( "Mouse_DownScroll", 	"GuildListMouseScrollEvent(false)")
		rtGuildListInfo._contributedTendency	:addInputEvent( "Mouse_DownScroll", 	"GuildListMouseScrollEvent(false)")
		rtGuildListInfo._activity				:addInputEvent( "Mouse_DownScroll", 	"GuildListMouseScrollEvent(false)")
		rtGuildListInfo._partLine				:addInputEvent( "Mouse_DownScroll", 	"GuildListMouseScrollEvent(false)")
		rtGuildListInfo._contractBtn			:addInputEvent( "Mouse_DownScroll", 	"GuildListMouseScrollEvent(false)")
	
		function rtGuildListInfo:SetShow( isShow )
			rtGuildListInfo._grade:SetShow(isShow)
			rtGuildListInfo._level:SetShow(isShow)
			rtGuildListInfo._class:SetShow(isShow)
			rtGuildListInfo._charName:SetShow(isShow)
			rtGuildListInfo._contributedTendency:SetShow(isShow)
			rtGuildListInfo._activity:SetShow(isShow)
			rtGuildListInfo._partLine:SetShow(isShow)
			rtGuildListInfo._contractBtn:SetShow(isShow)
		end
		
		function rtGuildListInfo:SetIgnore( isIgnore )
			rtGuildListInfo._grade:SetIgnore( isIgnore )	
			rtGuildListInfo._level:SetIgnore( isIgnore )	
			rtGuildListInfo._class:SetIgnore( isIgnore )	
			rtGuildListInfo._charName:SetIgnore( isIgnore )	
			rtGuildListInfo._contributedTendency:SetIgnore( isIgnore )	
			rtGuildListInfo._activity:SetIgnore( isIgnore )	
			rtGuildListInfo._partLine:SetIgnore( isIgnore )	
			-- rtGuildListInfo._contractBtn:SetIgnore( isIgnore )
		end
			
		return rtGuildListInfo		
	end

	-- 버튼 생성
	function createListInfoButton( pIndex )
		local rtGuildListInfoButton = {}
		
		local rtGuildListInfoButton	= UI.createControl( UCT.PA_UI_CONTROL_BUTTON, self._buttonListBG, 'Guild_Menu_Button_' .. pIndex )
		CopyBaseProperty( _copyButton, rtGuildListInfoButton )
		
		rtGuildListInfoButton:SetText( PAGetString( Defines.StringSheet_GAME,  "GULD_BUTTON" .. tostring(pIndex)) )
		rtGuildListInfoButton:SetPosX( _constStartButtonX )
		--rtGuildListInfoButton:SetPosY( _constStartButtonY + (pIndex * _constStartButtonGapY) )
		rtGuildListInfoButton:SetShow( true )
		
		rtGuildListInfoButton:addInputEvent( "Mouse_LUp", "HandleClickedGuildMenuButton(" .. pIndex .. ")"	)
		
		return rtGuildListInfoButton
	end
	
	-- 버튼 창에서 마우스 벗어날 시에 창 닫기
	self._buttonListBG:addInputEvent( "Mouse_Out", "MouseOutGuildMenuButton()"	)
	
	for index = 0, _constGuildListMaxCount - 1, 1 do
		self._list[index] = createListInfo(index)
	end

	for	index = 0, (_UI_Menu_Button.Type_Count-1), 1 do
		self._buttonList[index] = createListInfoButton(index)
	end
	
	GuildListInfoPage._buttonList[0]:SetText( PAGetString(Defines.StringSheet_GAME, "LUA_GUILDLIST_BUTTONLIST_TEXT_1" ) )   --추방
	GuildListInfoPage._buttonList[1]:SetText( PAGetString(Defines.StringSheet_GAME, "LUA_GUILDLIST_BUTTONLIST_TEXT_2" ) )	--임명
	GuildListInfoPage._buttonList[2]:SetText( PAGetString(Defines.StringSheet_GAME, "LUA_GUILDLIST_BUTTONLIST_TEXT_3" ) )	--임명취소
	GuildListInfoPage._buttonList[3]:SetText( PAGetString(Defines.StringSheet_GAME, "LUA_GUILDLIST_BUTTONLIST_TEXT_0" ) )	--대장위임
	
	UI.deleteControl( _copyGrade )
	UI.deleteControl( _copyLevel )
	UI.deleteControl( _copyClass )
	UI.deleteControl( _copyCharName )
	UI.deleteControl( _copyContributedTendency )
	UI.deleteControl( _copyActivity )
	UI.deleteControl( _copyPartLine )
	UI.deleteControl( _copyContractButton )
	UI.deleteControl( _copyButton )
		
	_copyGrade					= nil
	_copyLevel					= nil
	_copyClass					= nil
	_copyCharName				= nil
	_copyContributedTendency	= nil
	_copyPartLine				= nil
	_copyContractButton			= nil
	_copyButton					= nil

	frameSizeY = self._frameGuildList:GetSizeY()	-- 업데이트문에서 스크롤 노출 여부를 계산 하기 위해 쓰임

	self._frameGuildList:UpdateContentScroll()		-- 프레임 내 스크롤 적용.
	self._frameGuildList:UpdateContentPos()			-- 프레임 내용 갱신

	self._frameDefaultBG:MoveChilds(self._frameDefaultBG:GetID(), Panel_Guild_List)
	UI.deletePanel(Panel_Guild_List:GetID())
	Panel_Guild_List = nil
end

----------------------------------------------------------------------
-- 					길드 멤버 클릭시 메뉴창 팝업
----------------------------------------------------------------------

function HandleClickedGuildMemberMenuButton( index )	
	local grade = ToClient_GetMyGuildInfoWrapper():getMember( index ):getGrade()
	local isGuildMaster = getSelfPlayer():get():isGuildMaster()	
	local isGuildSubMaster = getSelfPlayer():get():isGuildSubMaster()	

	local buttonListBgX = getMousePosX() - Panel_Window_Guild:GetPosX() - _constCollectionX
	local buttonListBgY = getMousePosY() - Panel_Window_Guild:GetPosY() - _constCollectionY	
	GuildListInfoPage._buttonListBG:SetPosX( buttonListBgX )
	GuildListInfoPage._buttonListBG:SetPosY( buttonListBgY )
	
	for index = 0, 3, 1 do	
		GuildListInfoPage._buttonList[index]:SetShow(false)
	end

	if true == isGuildMaster then
		if 0 == grade then
			GuildListInfoPage._buttonListBG:SetShow(false)
		elseif 1 == grade then
			GuildListInfoPage._buttonListBG:SetShow(true)
			
			GuildListInfoPage._buttonList[0]:SetShow( true );
			GuildListInfoPage._buttonList[0]:SetPosY( _constStartButtonY );
			
			GuildListInfoPage._buttonList[2]:SetShow( true );
			GuildListInfoPage._buttonList[2]:SetPosY( _constStartButtonY + _constStartButtonGapY );
			
			GuildListInfoPage._buttonListBG:SetSize(140, 70)
			_selectIndex	= index
		else 
			GuildListInfoPage._buttonListBG:SetShow(true)
			
			GuildListInfoPage._buttonList[0]:SetShow( true );
			GuildListInfoPage._buttonList[0]:SetPosY( _constStartButtonY );
			
			GuildListInfoPage._buttonList[1]:SetShow( true );
			GuildListInfoPage._buttonList[1]:SetPosY( _constStartButtonY + _constStartButtonGapY );
			
			GuildListInfoPage._buttonListBG:SetSize(140, 70)
			_selectIndex	= index
		end
	elseif true == isGuildSubMaster then
		if 2 == grade then
			GuildListInfoPage._buttonListBG:SetSize(140, 40)
			GuildListInfoPage._buttonListBG:SetShow(true)
			
			GuildListInfoPage._buttonList[0]:SetShow( true );
			GuildListInfoPage._buttonList[0]:SetPosY( _constStartButtonY );
			
			_selectIndex	= index
		else	
			GuildListInfoPage._buttonListBG:SetShow(false)
		end
	else
		GuildListInfoPage._buttonListBG:SetShow(false)
	end
end

function HandleClickedGuildMemberContractButton( index )	-- 계약서 보기
	local memberIndex		= index
	local myGuildListInfo	= ToClient_GetMyGuildInfoWrapper()
	local myGuildMemberInfo = myGuildListInfo:getMember(memberIndex)
	-- local grade				= ToClient_GetMyGuildInfoWrapper():getMember(memberIndex):getGrade()
	
	local isGuildMaster		= getSelfPlayer():get():isGuildMaster()
	local isGuildSubMaster	= getSelfPlayer():get():isGuildSubMaster()
	local usableActivity	= myGuildMemberInfo:getUsableActivity()
	
	if true == isGuildMaster then
		FGlobal_AgreementGuild_Master_Open( memberIndex , 0, usableActivity );
	
	elseif true == isGuildSubMaster then
		FGlobal_AgreementGuild_Master_Open( memberIndex , 1, usableActivity );
	
	else
		FGlobal_AgreementGuild_Master_Open( memberIndex, 2, usableActivity );
	
	end
end

function HandleCLicked_IncentiveOption()
	Panel_GuildIncentiveOption_ShowToggle()
end

function HandleCLicked_GuildListIncentive_Open()
	_incentivePanelType = 0
	incentive_InputMoney:SetEditText('', true)
	Panel_GuildIncentive:SetShow( true )
	
	txt_incentive_Title		:SetText( PAGetString(Defines.StringSheet_GAME, "LUA_GUILDLIST_INCENTIVE_TITLE") ) -- "지원금 지급"
	txt_incentive_Deposit	:SetText( PAGetString(Defines.StringSheet_GAME, "LUA_GUILDLIST_INCENTIVE_DEPOSIT") ) -- "지급 금액"
	txt_incentive_Notify	:SetText( PAGetString(Defines.StringSheet_GAME, "LUA_GUILDLIST_INCENTIVE_NOTIFY") ) -- "모든 길드원에게 지원금를 지급합니다."
end

function HandleCLicked_GuildListIncentive_Deposit()
	_incentivePanelType = 1

	local myGuildListInfo = ToClient_GetMyGuildInfoWrapper()
	if nil == myGuildListInfo then
		return
	end
	local businessFunds		= Int64toInt32( myGuildListInfo:getGuildBusinessFunds() )	-- 현재 길드 자금.
	local unpaidTax			= Int64toInt32( myGuildListInfo:getAccumulateTax() )		-- 미납 법인세.
	local unpaidCost		= Int64toInt32( myGuildListInfo:getAccumulateGuildHouseCost() )		-- 미납 법인세.
	
	local maxInputValue_s64 = 0;
	local maxInputValue = 0;
	if( 0 < unpaidTax ) then
		maxInputValue_s64	= myGuildListInfo:getAccumulateTax() - myGuildListInfo:getGuildBusinessFunds()
		maxInputValue		= unpaidTax - businessFunds
	elseif( 0 < unpaidCost ) then
		maxInputValue_s64	= myGuildListInfo:getAccumulateGuildHouseCost() - myGuildListInfo:getGuildBusinessFunds()
		maxInputValue		= unpaidCost - businessFunds
	end
	
	inputGuildDepositMaxNum_s64 = maxInputValue_s64	-- 자동 검사를 위해 넣는다.

	incentive_InputMoney:SetEditText( maxInputValue, true)
	Panel_GuildIncentive:SetShow( true )
	
	txt_incentive_Title		:SetText( PAGetString(Defines.StringSheet_GAME, "LUA_GUILDLIST_DEPOSIT_TITLE") ) -- "입금"
	txt_incentive_Deposit	:SetText( PAGetString(Defines.StringSheet_GAME, "LUA_GUILDLIST_DEPOSIT_DEPOSIT") ) -- "입금 금액"
	txt_incentive_Notify	:SetText( PAGetStringParam1( Defines.StringSheet_GAME, "LUA_GUILDLIST_DEPOSIT_NOTIFY", "maxInput", makeDotMoney(maxInputValue_s64) ) ) -- 미납 조합세에서 현재 길드가 보유한 자금을 뺀 나머지({maxInput} 은화)만 입금이 가능하고, 누구나 입금은 가능합니다.
end

function HandleCLicked_GuildListIncentive_Paypal()
	ToClient_TakeMyGuildBenefit()
end

----------------------------------------------------------------------
-- 					길드 멤버 클릭시 메뉴창 팝업
----------------------------------------------------------------------
function HandleClickedGuildMenuButton( index )

	local myGuildListInfo = ToClient_GetMyGuildInfoWrapper()
	if nil == myGuildListInfo then
		return
	end
	
	-- _PA_LOG( "lua_debug", "HandleClickedGuildMenuButton : _selectIndex ".. _selectIndex);
	
	local myGuildMemberInfo = myGuildListInfo:getMember(_selectIndex)
	if nil == myGuildMemberInfo then
		return
	end	
			
	local messageTitle		= "";
	local messageContent	= ""; 
	local yesFunction;
	local targetName = myGuildMemberInfo:getName();
	
	if		(index == _UI_Menu_Button.Type_ChangeMaster)	then
	
		messageTitle 	= 	PAGetString( Defines.StringSheet_GAME, "LUA_GUILD_TEXT_DELEGATE_MASTER" )
		messageContent 	=	"'"..tostring(targetName).."'".. PAGetString( Defines.StringSheet_GAME, "LUA_GUILD_TEXT_DELEGATE_MASTER_QUESTION" )
		yesFunction		=	MessageBoxYesFunction_ChangeGuildMaster	
		--ToClient_RequestChangeGuildMaster( _selectIndex )
		
	elseif	(index == _UI_Menu_Button.Type_Deportation)		then
	
		messageTitle 	= PAGetString( Defines.StringSheet_GAME, "LUA_GUILD_TEXT_EXPEL_GUILDMEMBER" )
		messageContent 	=	"'"..tostring(targetName).."'".. PAGetString( Defines.StringSheet_GAME, "LUA_GUILD_TEXT_EXPEL_GUILDMEMBER_QUESTION" )
		yesFunction		=	MessageBoxYesFunction_ExpelMember
		--ToClient_RequestExpelMemberFromGuild( _selectIndex )
	
	elseif	(index == _UI_Menu_Button.Type_AppointCommander)then
	
		messageTitle 	= 	PAGetString( Defines.StringSheet_GAME, "LUA_GUILD_TEXT_APPOINT_GUILDSUBMASTER" )
		messageContent 	=	"'"..tostring(targetName).."'"..PAGetString( Defines.StringSheet_GAME, "LUA_GUILD_TEXT_APPOINT_GUILDSUBMASTER_QUESTION" )
		yesFunction		=	MessageBoxYesFunction_AppointCommander
		--ToClient_RequestChangeGuildMemberGrade( _selectIndex, 1 );
	
	elseif	(index == _UI_Menu_Button.Type_CancelAppoint)	then		
	
		messageTitle 	= 	PAGetString( Defines.StringSheet_GAME, "LUA_GUILD_TEXT_APPOINT_GUILDMEMBER" )
		messageContent 	=	"'"..tostring(targetName).."'".. PAGetString( Defines.StringSheet_GAME, "LUA_GUILD_TEXT_APPOINT_GUILDMEMBER_QUESTION" )
		yesFunction		=	MessageBoxYesFunction_CancelAppoint
		--ToClient_RequestChangeGuildMemberGrade( _selectIndex, 2 );
	
	else
		UI.ASSERT( false, "작업해야합니다!" )
		return
	end
	
	GuildListInfoPage._buttonListBG:SetShow(false)
	
	local messageboxData	= { title = messageTitle, content = messageContent, functionYes = yesFunction, functionNo = MessageBox_Empty_function, priority = CppEnums.PAUIMB_PRIORITY.PAUIMB_PRIORITY_LOW}
	MessageBox.showMessageBox(messageboxData)

end

function MessageBoxYesFunction_ChangeGuildMaster()
	ToClient_RequestChangeGuildMaster( _selectIndex )
end

function MessageBoxYesFunction_ExpelMember()
	ToClient_RequestExpelMemberFromGuild( _selectIndex )
end

function MessageBoxYesFunction_AppointCommander()
	ToClient_RequestChangeGuildMemberGrade( _selectIndex, 1 );
end

function MessageBoxYesFunction_CancelAppoint()
	ToClient_RequestChangeGuildMemberGrade( _selectIndex, 2 );
end

-- 버튼 창에서 마우스 벗어날 시에 창닫기
function MouseOutGuildMenuButton()
	
	local self = GuildListInfoPage
	
	local sizeX = self._buttonListBG:GetSizeX();
	local sizeY = self._buttonListBG:GetSizeY();
	local posX	= self._buttonListBG:GetPosX();
	local posY	= self._buttonListBG:GetPosY();
	--local mousePosX = getMousePosX();
	--local mousePosY = getMousePosY();
	
	local mousePosX = getMousePosX() - Panel_Window_Guild:GetPosX() - _constCollectionX
	local mousePosY = getMousePosY() - Panel_Window_Guild:GetPosY() - _constCollectionY

	
	-- _PA_LOG("luadebug", "MouseOutGuildMenuButton " ..posX.." "..posY.." "..sizeX.." "..sizeY.." "..mousePosX.." "..mousePosY )
	
	if( 	( posX < mousePosX) and ( mousePosX < (posX+sizeX) ) 
		and ( posY < mousePosY) and ( mousePosY < (posY+sizeY) )  ) then
		-- 영역 안에 있다.
	else
		self._buttonListBG:SetShow(false)
	end
end

----------------------------------------------------------------------
-- 			스크롤 버튼 사용시
----------------------------------------------------------------------
function GuildListMouseScrollEvent( isUpScroll )
	local memberCount = ToClient_GetMyGuildInfoWrapper():getMemberCount()

	UIScroll.ScrollEvent( GuildListInfoPage._scrollBar, isUpScroll, memberCount, memberCount, 0, 1 )

	GuildListInfoPage:UpdateData()
end

----------------------------------------------------------------------
-- 		길드원 현황 업데이트
----------------------------------------------------------------------
function GuildListInfoPage:UpdateData()
	local myGuildListInfo = ToClient_GetMyGuildInfoWrapper()
	
	if nil == myGuildListInfo then
		return
	end
	
	local businessFunds = Int64toInt32( myGuildListInfo:getGuildBusinessFunds())
	local guildGrade	= myGuildListInfo:getGuildGrade()
	GuildListInfoPage._textBusinessFunds:SetText( makeDotMoney(businessFunds) );
	
	local memberCount		= myGuildListInfo:getMemberCount()
	local isGuildMaster		= getSelfPlayer():get():isGuildMaster()	
	local isGuildSubMaster	= getSelfPlayer():get():isGuildSubMaster()

	contentSizeY = 0	-- 초기화
	for index = 0, _constGuildListMaxCount - 1, 1 do
		self._list[index]:SetShow( false )
	end

	for index = 0, memberCount - 1, 1 do
		local myGuildMemberInfo = myGuildListInfo:getMember( index )
		if( nil == myGuildMemberInfo ) then
			_PA_ASSERT( false, "멤버 데이터가 없을 수 있나? 확인 바랍니다.");
			return;
		end
		
		local gradeType = myGuildMemberInfo:getGrade()
		if 0 == gradeType then
			self._list[index]._grade:SetText(PAGetString( Defines.StringSheet_GAME, "LUA_GUILD_TEXT_GUILDMASTER" ))
		elseif 1 == gradeType then
			self._list[index]._grade:SetText(PAGetString( Defines.StringSheet_GAME, "LUA_GUILD_TEXT_GUILDSUBMASTER" ))
		elseif 2 == gradeType then
			self._list[index]._grade:SetText(PAGetString( Defines.StringSheet_GAME, "LUA_GUILD_TEXT_GUILDMEMBER" ))
		end
		
		self._list[index]:SetIgnore(true)
		if isGuildMaster then	
			if (1 == gradeType) or (2 == gradeType) then
				self._list[index]:SetIgnore(false)
			end
		elseif isGuildSubMaster then
			if (2 == gradeType) then
				self._list[index]:SetIgnore(false)
			end
		end
			
		self._list[index]._level:SetText( myGuildMemberInfo:getLevel() )
			
		local classType = myGuildMemberInfo:getClassType()
		if UI_Class.ClassType_Warrior == classType then 
			self._list[index]._class:SetText(PAGetString(Defines.StringSheet_GAME, "LUA_GLOBAL_CLASSTYPE_WARRIOR" ))
		elseif UI_Class.ClassType_Ranger == classType then
			self._list[index]._class:SetText(PAGetString(Defines.StringSheet_GAME, "LUA_GLOBAL_CLASSTYPE_RANGER" ))
		elseif UI_Class.ClassType_Sorcerer == classType then
			self._list[index]._class:SetText(PAGetString(Defines.StringSheet_GAME, "LUA_GLOBAL_CLASSTYPE_SORCERER" ))
		elseif UI_Class.ClassType_Giant == classType then
			self._list[index]._class:SetText(PAGetString(Defines.StringSheet_GAME, "LUA_GLOBAL_CLASSTYPE_GIANT" ))
		elseif UI_Class.ClassType_Tamer == classType then
			self._list[index]._class:SetText(PAGetString(Defines.StringSheet_GAME, "LUA_GLOBAL_CLASSTYPE_TAMER" ))
		elseif UI_Class.ClassType_BladeMaster == classType then
			self._list[index]._class:SetText(PAGetString(Defines.StringSheet_GAME, "LUA_GLOBAL_CLASSTYPE_BLADEMASTER" ))
		elseif UI_Class.ClassType_Kunoichi == classType then
			self._list[index]._class:SetText(PAGetString(Defines.StringSheet_GAME, "LUA_GLOBAL_CLASSTYPE_KUNOICHI" ))
		end
		
		-- local contributedTendency = myGuildMemberInfo:getContributedTendency()

		local maxWp				= myGuildMemberInfo:getMaxWp()
		if 0 == maxWp then
			maxWp = "-"
		end
		local explorationPoint	= myGuildMemberInfo:getExplorationPoint()
		self._list[index]._contributedTendency:SetText( maxWp .. "/" .. explorationPoint )
		
		if myGuildMemberInfo:isOnline() == true then
			local usableActivity = myGuildMemberInfo:getUsableActivity()
			if 10000 < usableActivity then
				usableActivity = 10000
			end
			local textActivity = tostring(myGuildMemberInfo:getTotalActivity()).."(<PAColor0xfface400>+".. tostring( usableActivity ).."<PAOldColor>)"
			self._list[index]._activity:SetText( textActivity )
			
			-- local tendencyColor = UI_color.C_FFC4BEBE
			-- if 0 < contributedTendency then
			-- 	tendencyColor = UI_color.C_FF2478FF
			-- elseif contributedTendency < 0 then
			-- 	tendencyColor = UI_color.C_FFFF0000
			-- end
			-- self._list[index]._contributedTendency:SetFontColor( tendencyColor )
			self._list[index]._activity:SetFontColor( UI_color.C_FFC4BEBE )
			self._list[index]._level:SetFontColor( UI_color.C_FFC4BEBE )
			self._list[index]._class:SetFontColor( UI_color.C_FFC4BEBE )
			self._list[index]._contributedTendency:SetFontColor( UI_color.C_FFC4BEBE )
			
			if myGuildMemberInfo:isSelf() then
				self._list[index]._charName:SetFontColor( UI_color.C_FFEF9C7F )
			else
				self._list[index]._charName:SetFontColor( UI_color.C_FFC4BEBE )	
			end
			self._list[index]._charName:SetText( myGuildMemberInfo:getName().." ("..myGuildMemberInfo:getCharacterName()..")" )

		else
			local textActivity = tostring(myGuildMemberInfo:getTotalActivity()).."(+".. tostring(myGuildMemberInfo:getUsableActivity())..")"
			self._list[index]._activity:SetText( textActivity )
			self._list[index]._contributedTendency:SetFontColor( UI_color.C_FF515151 )
			self._list[index]._activity:SetFontColor( UI_color.C_FF515151 )
			self._list[index]._level:SetFontColor( UI_color.C_FF515151 )
			self._list[index]._class:SetFontColor( UI_color.C_FF515151 )
			self._list[index]._charName:SetFontColor( UI_color.C_FF515151 )
			self._list[index]._charName:SetText(myGuildMemberInfo:getName().." ( - )")

			self._list[index]._level:SetText("-")
			self._list[index]._class:SetText("-")
		end
		
		self._list[index]:SetShow(true)

		-- 길드 등급에 따라 계약서 버튼을 노출.
		if 0 == ToClient_GetMyGuildInfoWrapper():getGuildGrade() then
			self._list[index]._contractBtn:SetIgnore( true )
			self._list[index]._contractBtn:SetMonoTone( true )
		else
			self._list[index]._contractBtn:SetIgnore( false )
			self._list[index]._contractBtn:SetMonoTone( false )
		end

		contentSizeY = contentSizeY + self._list[index]._charName:GetSizeY() + 2
		
	end
	
	self._contentGuildList:SetSize( self._frameGuildList:GetSizeX(), contentSizeY )	-- 프레임 컨텐츠 영역 사이즈 지정.

	if ( contentSizeY <= frameSizeY ) then
		self._scrollBar:SetShow( false )
	else
		self._scrollBar:SetShow( true )
	end
	
	self._frameGuildList:UpdateContentScroll()	-- 스크롤 갱신
	self._frameGuildList:UpdateContentPos()		-- 내용 갱신.	
end

----------------------------------------------------------------------
-- 					길드 현황을 켜고 끄는 함수 (Panel_Guild.lua 에서 사용)
----------------------------------------------------------------------

function GuildListInfoPage:Show()
	if false == self._frameDefaultBG:GetShow() then
		self._frameDefaultBG:SetShow( true )	
		self._scrollBar:SetControlPos( 0 )
		self:UpdateData()
	end
end

function GuildListInfoPage:Hide()
	if true == self._frameDefaultBG:GetShow() then
		self._frameDefaultBG:SetShow( false )
	end
end

--------------------------------------------------------------------------------
-- 길드 지원금 관련 함수
--------------------------------------------------------------------------------
function HandleClicked_SetIncentive()
	UI.Set_ProcessorInputMode(IM.eProcessorInputMode_ChattingInputMode)
	SetFocusEdit( incentive_InputMoney );
	inputGuildDepositNum_s64	= toInt64(0, 0) -- 어떤 값을 넣어도 초기화 되는 현상 때문에 리셋 시킨다.
	incentive_InputMoney:SetEditText('', true)
	incentive_InputMoney:SetNumberMode( true )
end
function FGlobal_GuildIncentive_Close()
	if( not Panel_GuildIncentive:GetShow() ) then
		return;
	end
	
	ClearFocusEdit()
	Panel_GuildIncentive:SetShow( false )
	if ( AllowChangeInputMode() ) then
		if( UI.checkShowWindow() ) then
			UI.Set_ProcessorInputMode(IM.eProcessorInputMode_UiMode) 
		else
			UI.Set_ProcessorInputMode(IM.eProcessorInputMode_GameMode)
		end
	else
		SetFocusChatting()
	end
end
function HandleClicked_GuildIncentive_Close()
	if( not Panel_GuildIncentive:GetShow() ) then
		return;
	end
	
	ClearFocusEdit()
	if ( AllowChangeInputMode() ) then
		if( UI.checkShowWindow() ) then
			UI.Set_ProcessorInputMode(IM.eProcessorInputMode_UiMode) 
		else
			UI.Set_ProcessorInputMode(IM.eProcessorInputMode_GameMode)
		end
	else
		SetFocusChatting()
	end
	Panel_GuildIncentive:SetShow( false )
end

function HandleClicked_GuildIncentive_Send()
	local tempMoney = tonumber( incentive_InputMoney:GetEditText() )
	-- _PA_LOG( "luadebug", "HandleClicked_GuildIncentive_Send( text : ".. tostring(incentive_InputMoney:GetEditText()) );
	-- _PA_LOG( "luadebug", "HandleClicked_GuildIncentive_Send( tonum :".. tempMoney );
 	
	if( nil == tempMoney) or ( tempMoney <= 0) or (tempMoney == "") then  -- 입력 받은 값이 0보다 작거나 같으면 조건 추가. by 태곤
		Proc_ShowMessage_Ack( PAGetString(Defines.StringSheet_GAME, "LUA_VENDINGMACHINE_PERFORM_MESSAGE_0") )
		return;
	end
	
	if( 0 == _incentivePanelType ) then
	
	else
		ToClient_DepositToGuildWareHouse( tempMoney );
	end

	FGlobal_GuildIncentive_Close()
end

function FGlobal_SaveGuildMoney_Send()
	HandleClicked_GuildIncentive_Send()
end

function FGlobal_GuildDeposit_InputCheck()
	for idx,val in ipairs(numberKeyCode) do
		if isKeyDown_Once( val ) then
			if (idx > 10) then
				_GuildDeposit_InputCheck_Command( idx - 11 )
			else
				_GuildDeposit_InputCheck_Command( idx - 1 )
			end
		end
	end
	
	if isKeyDown_Once( VCK.KeyCode_BACK ) then
		_GuildDeposit_InputCheck_BackSpaceCommand()
	end
end

function _GuildDeposit_InputCheck_Command( number )
	local str = tostring( inputGuildDepositNum_s64 );
	local newStr = ( str..tostring(number) )
	local s64_newNumber	= tonumber64( newStr )
	local s64_MAX		= inputGuildDepositMaxNum_s64
	if( s64_MAX < s64_newNumber ) then
		inputGuildDepositNum_s64 = inputGuildDepositMaxNum_s64
	else
		inputGuildDepositNum_s64 = s64_newNumber;
	end
	incentive_InputMoney:SetEditText( tostring( inputGuildDepositNum_s64 ), true );	
end

function _GuildDeposit_InputCheck_BackSpaceCommand()
	local str = tostring( inputGuildDepositNum_s64 );
	local length = strlen(str);
	local newStr = "";
	
	if 1 < length  then
		newStr = substring( str, 1, length-1 );
		inputGuildDepositNum_s64= tonumber64(newStr);	
	else
		newStr = "0";
		inputGuildDepositNum_s64 = Defines.s64_const.s64_0;
	end
	
	incentive_InputMoney:SetEditText( newStr, true );
end


----------------------------------------------------------------------------------------------------------------
--									클라이언트에서 보내는 이벤트
----------------------------------------------------------------------------------------------------------------
registerEvent("FromClient_ResponseGuildMasterChange",		"FromClient_ResponseGuildMasterChange")
registerEvent("FromClient_ResponseChangeGuildMemberGrade",	"FromClient_ResponseChangeGuildMemberGrade")
registerEvent("FromClient_RequestExpelMemberFromGuild",		"FromClient_RequestExpelMemberFromGuild")
registerEvent("FromClient_RequestChangeGuildMemberGrade",	"FromClient_RequestChangeGuildMemberGrade")

function FromClient_ResponseGuildMasterChange(userNo, targetNo)
	local userNum = Int64toInt32( getSelfPlayer():get():getUserNo() )
	
	if userNum == Int64toInt32(userNo) then
		Proc_ShowMessage_Ack( PAGetString( Defines.StringSheet_GAME, "LUA_GUILD_MASTERCHANGE_MESSAGE_0") )
	elseif userNum == Int64toInt32(targetNo) then
		Proc_ShowMessage_Ack( PAGetString( Defines.StringSheet_GAME, "LUA_GUILD_MASTERCHANGE_MESSAGE_1") )
	end
	GuildListInfoPage:UpdateData()
end

function FromClient_ResponseChangeGuildMemberGrade(targetNo, grade)
	local userNum = Int64toInt32( getSelfPlayer():get():getUserNo() )

	if userNum == Int64toInt32(targetNo) then
		if 1 == grade then
			Proc_ShowMessage_Ack( PAGetString( Defines.StringSheet_GAME, "LUA_GUILD_GRADECHANGE_MESSAGE_0") )
		elseif 2 == grade then
			Proc_ShowMessage_Ack( PAGetString( Defines.StringSheet_GAME, "LUA_GUILD_GRADECHANGE_MESSAGE_1") )
		end
	end
	GuildListInfoPage:UpdateData()
end

function FromClient_RequestExpelMemberFromGuild()
	--Proc_ShowMessage_Ack( PAGetString( Defines.StringSheet_GAME, "LUA_GUILD_EXPELMEMBER_MESSAGE") )
	if( true == Panel_Window_Guild:GetShow() ) then
		GuildListInfoPage:UpdateData()
	elseif ( true == Panel_ClanList:GetShow() ) then
		 FGlobal_ClanList_Update()
	end

end

function FromClient_RequestChangeGuildMemberGrade(grade)
	if 1 == grade then
		Proc_ShowMessage_Ack( PAGetString( Defines.StringSheet_GAME, "LUA_GUILD_GRADECHANGE_MESSAGE_2") )
	elseif 2 == grade then
		Proc_ShowMessage_Ack( PAGetString( Defines.StringSheet_GAME, "LUA_GUILD_GRADECHANGE_MESSAGE_3") )
	end
	GuildListInfoPage:UpdateData()
end

