local UI_TM 		= CppEnums.TextMode
local UI_color 		= Defines.Color
local UCT 			= CppEnums.PA_UI_CONTROL_TYPE

----------------------------------------------------------------------------------------------------------------
local _constGuildListMaxCount 	= 22	-- 리스트 최대 표시 갯수
local _startMemberIndex 		= 0		-- 스크롤 변경시 사용 변수
----------------------------------------------------------------------------------------------------------------
--									길드원 현황 프레임 불러오기
----------------------------------------------------------------------------------------------------------------


------------------------------------------------------------------
--					전쟁현황 관리
------------------------------------------------------------------
GuildWarfareInfoPage =
{	
	_frameDefaultBG_Warfare	= UI.getChildControl ( Panel_Window_Guild, "Static_Frame_WarfareBG" ),
	_scrollBar,
	_scrollBarCtrl,
	_list = {}
}
--[[
GuildWarfareInfoPage
	initialize()
	UpdateData()
	Show()
	Hide()
	_list : rtGuildWarfareInfo의 리스트	
		rtGuildWarfareInfo로 검색해서 맴버 확인 요망		
]]--


-- 성채 파괴
-- 지휘소 파괴
-- 성문 파괴
-- 도움 회수
-- 소환수 처리
-- 설치물 파괴
-- 대장 처치
-- 부대장 처치
-- 길드원 처치
-- 사망 회수

------------------------------------------------------------------
--				각 아이콘 설명 풍선 띄워주기
------------------------------------------------------------------
local _iconHelper 	= UI.getChildControl ( Panel_Guild_Warfare, "StaticText_IconHelper" )

local ui_Icons = 
{
	[0]  	= UI.getChildControl ( Panel_Guild_Warfare, "Static_M_CommandCenter" ),
	[1]  	= UI.getChildControl ( Panel_Guild_Warfare, "Static_M_Tower" ),
	[2]  	= UI.getChildControl ( Panel_Guild_Warfare, "Static_M_CastleGate" ),
	[3]  	= UI.getChildControl ( Panel_Guild_Warfare, "Static_M_Help" ),
	[4]  	= UI.getChildControl ( Panel_Guild_Warfare, "Static_M_Summons" ),
	[5]  	= UI.getChildControl ( Panel_Guild_Warfare, "Static_M_Installation" ),
	[6]  	= UI.getChildControl ( Panel_Guild_Warfare, "Static_M_Master" ),
	[7]  	= UI.getChildControl ( Panel_Guild_Warfare, "Static_M_Commander" ),
	[8]  	= UI.getChildControl ( Panel_Guild_Warfare, "Static_M_Member" ),
	[9]  	= UI.getChildControl ( Panel_Guild_Warfare, "Static_M_Death" ),
}

function Panel_Guild_Warfare_Icon_ToolTip_Func()
	for idx = 0 , 9 do
		ui_Icons[idx]:addInputEvent ( "Mouse_On", "Panel_Guild_Warfare_Icon_ToolTip_Show(".. idx ..", true )" )
		ui_Icons[idx]:addInputEvent ( "Mouse_Out", "Panel_Guild_Warfare_Icon_ToolTip_Show(".. idx ..", false )" )
	end
end

function Panel_Guild_Warfare_Icon_ToolTip_Show( iconNo, isOn )
	local mouse_posX = getMousePosX()
	local mouse_posY = getMousePosY()
	
	local panel_posX = GuildWarfareInfoPage._frameDefaultBG_Warfare:GetParentPosX()
	local panel_posY = GuildWarfareInfoPage._frameDefaultBG_Warfare:GetParentPosY()
	
	_iconHelper:SetPosX( mouse_posX - panel_posX  )
	_iconHelper:SetPosY( mouse_posY - panel_posY + 15 )
	
	if ( isOn == true ) then
		if ( iconNo == 0 ) then
			_iconHelper:SetShow ( true )
			_iconHelper:SetText( PAGetString( Defines.StringSheet_GAME, "LUA_GUILD_TXT_WARFARE_HELP_COMMAND" ) )	-- 지휘소 파괴
			
		elseif ( iconNo == 1 ) then
			_iconHelper:SetShow ( true )
			_iconHelper:SetText( PAGetString( Defines.StringSheet_GAME, "LUA_GUILD_TXT_WARFARE_HELP_TOWER" ) )		-- 성채 파괴
			
		elseif ( iconNo == 2 ) then
			_iconHelper:SetShow ( true )
			_iconHelper:SetText( PAGetString( Defines.StringSheet_GAME, "LUA_GUILD_TXT_WARFARE_HELP_DOOR" ) )		-- 성문 파괴
			
		elseif ( iconNo == 3 ) then
			_iconHelper:SetShow ( true )
			_iconHelper:SetText( PAGetString( Defines.StringSheet_GAME, "LUA_GUILD_TXT_WARFARE_HELP_HELPER" ) )		-- 도움 횟수
			
		elseif ( iconNo == 4 ) then
			_iconHelper:SetShow ( true )
			_iconHelper:SetText( PAGetString( Defines.StringSheet_GAME, "LUA_GUILD_TXT_WARFARE_HELP_SUMMON" ) )		-- 소환수 처치
			
		elseif ( iconNo == 5 ) then
			_iconHelper:SetShow ( true )
			_iconHelper:SetText( PAGetString( Defines.StringSheet_GAME, "LUA_GUILD_TXT_WARFARE_HELP_OBJECT" ) )		-- 설치물 파괴
			
		elseif ( iconNo == 6 ) then
			_iconHelper:SetShow ( true )
			_iconHelper:SetText( PAGetString( Defines.StringSheet_GAME, "LUA_GUILD_TXT_WARFARE_HELP_MASTER" ) )		-- 대장 처치
			
		elseif ( iconNo == 7 ) then
			_iconHelper:SetShow ( true )
			_iconHelper:SetText( PAGetString( Defines.StringSheet_GAME, "LUA_GUILD_TXT_WARFARE_HELP_COMMANDER" ) )	-- 부대장 처치
			
		elseif ( iconNo == 8 ) then
			_iconHelper:SetShow ( true )
			_iconHelper:SetText( PAGetString( Defines.StringSheet_GAME, "LUA_GUILD_TXT_WARFARE_HELP_MEMBER" ) )		-- 길드원 처치
			
		elseif ( iconNo == 9 ) then
			_iconHelper:SetShow ( true )
			_iconHelper:SetText( PAGetString( Defines.StringSheet_GAME, "LUA_GUILD_TXT_WARFARE_HELP_DEATH" ) )		-- 사망 횟수
		end
	else
		_iconHelper:SetShow ( false )
	end
end

------------------------------------------------------------------
--		최초 초기화 해주는 함수	(Panel_Guild.lua 에서 사용)
------------------------------------------------------------------
local frameSizeY = 0
local contentSizeY = 0
function GuildWarfareInfoPage:initialize()
	Panel_Guild_Warfare_Icon_ToolTip_Func()		-- 아이콘별 설명서 띄워주기 함수
	
	local constStartY = 5

	local frame_Warfare			= UI.getChildControl ( Panel_Guild_Warfare, "Frame_GuildWarfare" )
	local content_Warfare		= UI.getChildControl ( frame_Warfare, 		"Frame_1_Content" )
	
	frameSizeY = frame_Warfare:GetSizeY()
	contentSizeY = content_Warfare:GetSizeY()
	
	local copyCharName			= UI.getChildControl ( content_Warfare, 	"StaticText_C_CharName" )
	local copyTower		 		= UI.getChildControl ( content_Warfare, 	"StaticText_C_Tower" )
	local copyCommandCenter 	= UI.getChildControl ( content_Warfare, 	"StaticText_C_CommandCenter" )
	local copyCastleGate	 	= UI.getChildControl ( content_Warfare, 	"StaticText_C_CastleGate" )
	local copyHelp			 	= UI.getChildControl ( content_Warfare, 	"StaticText_C_Help" )
	local copySummons		 	= UI.getChildControl ( content_Warfare, 	"StaticText_C_Summons" )
	local copyInstallation	 	= UI.getChildControl ( content_Warfare, 	"StaticText_C_Installation" )
	local copyMaster		 	= UI.getChildControl ( content_Warfare, 	"StaticText_C_Master" )
	local copyCommander	 		= UI.getChildControl ( content_Warfare, 	"StaticText_C_Commander" )
	local copyMember		 	= UI.getChildControl ( content_Warfare, 	"StaticText_C_Member" )
	local copyDeath		 		= UI.getChildControl ( content_Warfare, 	"StaticText_C_Death" )
	local copyPartline		 	= UI.getChildControl ( content_Warfare, 	"Static_C_PartLine" )
	
	-- 스크롤 관련 부분------------------------------------------------
	self._scrollBar 			= UI.getChildControl ( frame_Warfare, 				"VerticalScroll" )
	UIScroll.InputEvent( self._scrollBar, "GuildWarfareMouseScrollEvent" )
	
	content_Warfare:addInputEvent("Mouse_UpScroll",		"GuildWarfareMouseScrollEvent( true )" )
	content_Warfare:addInputEvent("Mouse_DownScroll",	"GuildWarfareMouseScrollEvent( false )" )
	---------------------------------------------------------------------
	
	-- 현황 리스트 만드는 함수
	function createWarfareInfo( pIndex )	
		local rtGuildWarfareInfo = {}
	
		rtGuildWarfareInfo._txtCharName 		= UI.createControl(UCT.PA_UI_CONTROL_STATICTEXT, content_Warfare, "StaticText_C_CharName_"..pIndex )
		rtGuildWarfareInfo._txtTower 			= UI.createControl(UCT.PA_UI_CONTROL_STATICTEXT, content_Warfare, "StaticText_C_Tower_"..pIndex )
		rtGuildWarfareInfo._txtCommandCenter 	= UI.createControl(UCT.PA_UI_CONTROL_STATICTEXT, content_Warfare, "StaticText_C_CommandCenter_"..pIndex )
		rtGuildWarfareInfo._txtCastleGate 		= UI.createControl(UCT.PA_UI_CONTROL_STATICTEXT, content_Warfare, "StaticText_C_CastleGate_"..pIndex )
		rtGuildWarfareInfo._txtHelp 			= UI.createControl(UCT.PA_UI_CONTROL_STATICTEXT, content_Warfare, "StaticText_C_Help_"..pIndex )
		rtGuildWarfareInfo._txtSummons 			= UI.createControl(UCT.PA_UI_CONTROL_STATICTEXT, content_Warfare, "StaticText_C_Summons_"..pIndex )
		rtGuildWarfareInfo._txtInstallation 	= UI.createControl(UCT.PA_UI_CONTROL_STATICTEXT, content_Warfare, "StaticText_C_Installation_"..pIndex )
		rtGuildWarfareInfo._txtMaster 			= UI.createControl(UCT.PA_UI_CONTROL_STATICTEXT, content_Warfare, "StaticText_C_Master_"..pIndex )
		rtGuildWarfareInfo._txtCommander 		= UI.createControl(UCT.PA_UI_CONTROL_STATICTEXT, content_Warfare, "StaticText_C_Commander_"..pIndex )
		rtGuildWarfareInfo._txtMember 			= UI.createControl(UCT.PA_UI_CONTROL_STATICTEXT, content_Warfare, "StaticText_C_Member_"..pIndex )
		rtGuildWarfareInfo._txtDeath 			= UI.createControl(UCT.PA_UI_CONTROL_STATICTEXT, content_Warfare, "StaticText_C_Death_"..pIndex )
		rtGuildWarfareInfo._Partline 			= UI.createControl(UCT.PA_UI_CONTROL_STATIC,	 content_Warfare, "Static_C_PartLine_"..pIndex )
		
		CopyBaseProperty( copyCharName, 		rtGuildWarfareInfo._txtCharName )
		CopyBaseProperty( copyTower, 			rtGuildWarfareInfo._txtTower )
		CopyBaseProperty( copyCommandCenter, 	rtGuildWarfareInfo._txtCommandCenter )
		CopyBaseProperty( copyCastleGate, 		rtGuildWarfareInfo._txtCastleGate )
		CopyBaseProperty( copyHelp, 			rtGuildWarfareInfo._txtHelp )
		CopyBaseProperty( copySummons, 			rtGuildWarfareInfo._txtSummons )
		CopyBaseProperty( copyInstallation, 	rtGuildWarfareInfo._txtInstallation )
		CopyBaseProperty( copyMaster, 			rtGuildWarfareInfo._txtMaster )
		CopyBaseProperty( copyCommander, 		rtGuildWarfareInfo._txtCommander )
		CopyBaseProperty( copyMember, 			rtGuildWarfareInfo._txtMember )
		CopyBaseProperty( copyDeath, 			rtGuildWarfareInfo._txtDeath )
		CopyBaseProperty( copyPartline, 		rtGuildWarfareInfo._Partline )
		
		rtGuildWarfareInfo._txtCharName:SetPosY( constStartY + pIndex * 25 )
		rtGuildWarfareInfo._txtTower:SetPosY( constStartY + pIndex * 25 )
		rtGuildWarfareInfo._txtCommandCenter:SetPosY( constStartY + pIndex * 25 )
		rtGuildWarfareInfo._txtCastleGate:SetPosY( constStartY + pIndex * 25 )
		rtGuildWarfareInfo._txtHelp:SetPosY( constStartY + pIndex * 25 )
		rtGuildWarfareInfo._txtSummons:SetPosY( constStartY + pIndex * 25 )
		rtGuildWarfareInfo._txtInstallation:SetPosY( constStartY + pIndex * 25 )
		rtGuildWarfareInfo._txtMaster:SetPosY( constStartY + pIndex * 25 )
		rtGuildWarfareInfo._txtCommander:SetPosY( constStartY + pIndex * 25 )
		rtGuildWarfareInfo._txtMember:SetPosY( constStartY + pIndex * 25 )
		rtGuildWarfareInfo._txtDeath:SetPosY( constStartY + pIndex * 25 )
		rtGuildWarfareInfo._Partline:SetPosY( pIndex * 25 )
		
		function rtGuildWarfareInfo:SetShow( isShow )
			rtGuildWarfareInfo._txtCharName:SetShow(isShow)
			rtGuildWarfareInfo._txtTower:SetShow(isShow)
			rtGuildWarfareInfo._txtCommandCenter:SetShow(isShow)
			rtGuildWarfareInfo._txtCastleGate:SetShow(isShow)
			rtGuildWarfareInfo._txtHelp:SetShow(isShow)
			rtGuildWarfareInfo._txtSummons:SetShow(isShow)
			rtGuildWarfareInfo._txtInstallation:SetShow(isShow)
			rtGuildWarfareInfo._txtMaster:SetShow(isShow)
			rtGuildWarfareInfo._txtCommander:SetShow(isShow)
			rtGuildWarfareInfo._txtMember:SetShow(isShow)
			rtGuildWarfareInfo._txtDeath:SetShow(isShow)
			rtGuildWarfareInfo._Partline:SetShow(isShow)
		end
		
		function rtGuildWarfareInfo:SetData( pData )
			if pData:isOnline() then
				rtGuildWarfareInfo._txtCharName:SetText( pData:getName().." ("..pData:getCharacterName()..")" )
			else
				rtGuildWarfareInfo._txtCharName:SetText( pData:getName() )
			end
			rtGuildWarfareInfo._txtCommandCenter:SetText( pData:commandPostCount() )
			rtGuildWarfareInfo._txtTower:SetText( pData:towerCount() )
			rtGuildWarfareInfo._txtCastleGate:SetText( pData:gateCount() )
			rtGuildWarfareInfo._txtHelp:SetText( pData:assistCount() )
			rtGuildWarfareInfo._txtSummons:SetText( pData:summonedCount() )
			rtGuildWarfareInfo._txtInstallation:SetText( pData:obstacleCount() )
			rtGuildWarfareInfo._txtMaster:SetText( pData:guildMasterCount() )
			rtGuildWarfareInfo._txtCommander:SetText( pData:squadLeaderCount() )
			rtGuildWarfareInfo._txtMember:SetText( pData:squadMemberCount() )
			rtGuildWarfareInfo._txtDeath:SetText( pData:deathCount() )
		end
		
		return rtGuildWarfareInfo
	end
	
	for index=0, _constGuildListMaxCount-1, 1 do
		self._list[index] = createWarfareInfo(index)
	end		
	
	UI.deleteControl( copyCharName )
	UI.deleteControl( copyTower )
	UI.deleteControl( copyCommandCenter )
	UI.deleteControl( copyCastleGate )
	UI.deleteControl( copyHelp )
	UI.deleteControl( copySummons )
	UI.deleteControl( copyInstallation )
	UI.deleteControl( copyMaster )
	UI.deleteControl( copyCommander )
	UI.deleteControl( copyMember )
	UI.deleteControl( copyDeath )
	UI.deleteControl( copyPartline )	
	
	copyCharName = nil
	copyTower = nil
	copyCommandCenter = nil
	copyCastleGate = nil
	copyHelp = nil
	copySummons = nil
	copyInstallation = nil
	copyMaster = nil
	copyCommander = nil
	copyMember = nil
	copyDeath = nil
	copyPartline = nil

	self._frameDefaultBG_Warfare:MoveChilds( self._frameDefaultBG_Warfare:GetID(), Panel_Guild_Warfare )
	UI.deletePanel(Panel_Guild_Warfare:GetID())	
	Panel_Guild_Warfare = nil
	
	-- self.frame_Warfare:UpdateContentScroll()		-- 스크롤 감도 동일하게
end

----------------------------------------------------------------------
-- 			스크롤 버튼 사용시
----------------------------------------------------------------------
function GuildWarfareMouseScrollEvent( isUpScroll )
	local memberCount = ToClient_GetMyGuildInfoWrapper():getMemberCount()
	
	_startMemberIndex = UIScroll.ScrollEvent( GuildWarfareInfoPage._scrollBar, isUpScroll, _constGuildListMaxCount, memberCount, _startMemberIndex, 1 )
	GuildWarfareInfoPage:UpdateData()
end

----------------------------------------------------------------------
-- 				업데이트 해주는 함수
----------------------------------------------------------------------
function GuildWarfareInfoPage:UpdateData()
	for index=0, _constGuildListMaxCount-1, 1 do
		self._list[index]:SetShow(false)
	end

	local myGuildInfo = ToClient_GetMyGuildInfoWrapper()
	if	(nil == myGuildInfo)	then
		return
	end
	
	local	memberCount	= myGuildInfo:getMemberCount()
	for index=0, _constGuildListMaxCount - 1, 1 do
		if (_startMemberIndex + index) < memberCount then -- _startMemberIndex : 스크롤로 인한 업데이트용도
			self._list[index]:SetData( myGuildInfo:getMember( _startMemberIndex + index) )
			self._list[index]:SetShow(true)
		else
			self._list[index]:SetShow(false)
		end
	end
		
	-- frameSizeY = frame_Warfare:GetSizeY()
	-- contentSizeY = content_Warfare:GetSizeY()
	
	if ( frameSizeY >= contentSizeY ) then
		self._scrollBar:SetShow( false )
	else
		self._scrollBar:SetShow( true )
	end
	
	-- self.frame_Warfare:UpdateContentScroll()		-- 스크롤 감도 동일하게
end

----------------------------------------------------------------------
-- 					길드 현황을 켜고 끄는 함수 (Panel_Guild.lua 에서 사용)
----------------------------------------------------------------------
function GuildWarfareInfoPage:Show()
	-- if false == self._frameDefaultBG_Warfare:GetShow() then
		self._frameDefaultBG_Warfare:SetShow( true )
		self._scrollBar:SetControlPos( 0 )
		self:UpdateData()
	-- end
end

function GuildWarfareInfoPage:Hide()
	if true == self._frameDefaultBG_Warfare:GetShow() then
		self._frameDefaultBG_Warfare:SetShow( false )
	end
end

----------------------------------------------------------------------
--	클라이언트에서 보내는 이벤트
----------------------------------------------------------------------
registerEvent("Event_SiegeScoreUpdateData", "FromClient_GuildWarfareInfoUpdate")

function FromClient_GuildWarfareInfoUpdate()
	GuildWarfareInfoPage:UpdateData()
end