local CT2S 			= CppEnums.ClassType2String
local UI_PSFT 		= CppEnums.PAUI_SHOW_FADE_TYPE
local UI_ANI_ADV 	= CppEnums.PAUI_ANIM_ADVANCE_TYPE
local UI_color 		= Defines.Color
local UCT 			= CppEnums.PA_UI_CONTROL_TYPE
local UI_TM 		= CppEnums.TextMode
local IM 			= CppEnums.EProcessorInputMode

Panel_Window_Guild:SetShow ( false )	
Panel_Window_Guild:setMaskingChild( true )
Panel_Window_Guild:setGlassBackground( true )

Panel_Window_Guild:RegisterShowEventFunc( true, 'guild_ShowAni()' )
Panel_Window_Guild:RegisterShowEventFunc( false, 'guild_HideAni()' )

local guildLoginMsg = true

------------------------------------------------------
--					창 애니메이션
------------------------------------------------------
function guild_ShowAni()
	UIAni.fadeInSCR_Down( Panel_Window_Guild )
	-- audioPostEvent_SystemUi(01,00)
	
	local aniInfo1 = Panel_Window_Guild:addScaleAnimation( 0.0, 0.08, UI_ANI_ADV.PAUI_ANIM_ADVANCE_COS_HALF_PI)
	aniInfo1:SetStartScale(0.5)
	aniInfo1:SetEndScale(1.2)
	aniInfo1.AxisX = Panel_Window_Guild:GetSizeX() / 2
	aniInfo1.AxisY = Panel_Window_Guild:GetSizeY() / 2
	aniInfo1.ScaleType = 2
	aniInfo1.IsChangeChild = true
	
	local aniInfo2 = Panel_Window_Guild:addScaleAnimation( 0.08, 0.15, UI_ANI_ADV.PAUI_ANIM_ADVANCE_COS_HALF_PI)
	aniInfo2:SetStartScale(1.2)
	aniInfo2:SetEndScale(1.0)
	aniInfo2.AxisX = Panel_Window_Guild:GetSizeX() / 2
	aniInfo2.AxisY = Panel_Window_Guild:GetSizeY() / 2
	aniInfo2.ScaleType = 2
	aniInfo2.IsChangeChild = true
end

function guild_HideAni()
	Panel_Window_Guild:SetAlpha( 1 )
	local aniInfo = UIAni.AlphaAnimation( 0, Panel_Window_Guild, 0.0, 0.1 )
	aniInfo:SetHideAtEnd(true)
end

------------------------------------------------------------------------------------------------------------------------------------------------

local constCreateWarInfoCount = 4 	-- 총 4개까지만 생성한다

------------------------------------------------------------------------------------------------------------------------------------------------
----------------------------------------------------------------------------------------------------------------
------------ 좌측 상단 길드 정보 관리
----------------------------------------------------------------------------------------------------------------
local GuildInfoPage = {}
--[[
GuildInfoPage
	initialize()
	UpdateData()	
]]--

-- 초기화
function GuildInfoPage:initialize()
	self._windowTitle			= UI.getChildControl ( Panel_Window_Guild, "StaticText_Title" )
	self._textGuildInfoTitle	= UI.getChildControl ( Panel_Window_Guild, "StaticText_Title_Info" )
	self._txtGuildName 			= UI.getChildControl ( Panel_Window_Guild, "StaticText_GuildName" )
	self._iconOccupyTerritory	= UI.getChildControl ( Panel_Window_Guild, "Static_GuildIcon_BG" )
	self._iconGuildMark			= UI.getChildControl ( Panel_Window_Guild, "Static_Guild_Icon" )
	self._txtMaster  			= UI.getChildControl ( Panel_Window_Guild, "StaticText_Master" )
	self._txtPersonNo  			= UI.getChildControl ( Panel_Window_Guild, "StaticText_PersonNumber" )
	
	self._txtRGuildName			= UI.getChildControl ( Panel_Window_Guild, "StaticText_R_GuildName" )
	self._txtRMaster  			= UI.getChildControl ( Panel_Window_Guild, "StaticText_R_Master" )
	self._txtRRank  			= UI.getChildControl ( Panel_Window_Guild, "StaticText_GuildRank_Value" )
	self._txtRPersonNo	  		= UI.getChildControl ( Panel_Window_Guild, "StaticText_R_PersonNumber" )
	-- self._txtRTendency	  		= UI.getChildControl ( Panel_Window_Guild, "StaticText_R_Tendency" )
	self._txtUnpaidTax	  		= UI.getChildControl ( Panel_Window_Guild, "StaticText_UnpaidTax" )
	
	self._btnGuildDel	  		= UI.getChildControl ( Panel_Window_Guild, "Button_GuildDispersal" )
	self._btnChangeMark  		= UI.getChildControl ( Panel_Window_Guild, "Button_GuildMark" )
	self._btnIncreaseMember  	= UI.getChildControl ( Panel_Window_Guild, "Button_IncreaseMember" )
	
	self._btnTaxPayment			= UI.getChildControl ( Panel_Window_Guild, "Button_TaxPayment" )
	
	-- self._txtInfoHelp			= UI.getChildControl ( Panel_Window_Guild, "StaticText_Description" )

	function self:SetShow(isShow)
		self._btnChangeMark:SetShow( isShow )
		-- self._txtInfoHelp:SetShow( isShow )
	end
	
	function self:GetShow()
		return self._btnGuildDel:GetShow();
	end
	
	self:SetShow(false)
	
	-- self._txtInfoHelp:SetTextMode( UI_TM.eTextMode_AutoWrap )
	-- self._txtInfoHelp:SetText( PAGetString(Defines.StringSheet_GAME, "LUA_GUILD_TEXT_INFOHELP" ) )
	
	self._btnGuildDel		:addInputEvent("Mouse_LUp",	"HandleClickedGuildDel()")
	self._btnChangeMark		:addInputEvent("Mouse_LUp",	"HandleClickedChangeMark()")
	self._btnTaxPayment		:addInputEvent("Mouse_LUp",	"HandleClicked_TaxPayment()")
	
	self._btnIncreaseMember	:addInputEvent("Mouse_LUp",	"HandleClickedIncreaseMember()")
	self._btnIncreaseMember	:addInputEvent("Mouse_On",	"Panel_Guild_Tab_ToolTip_Func( 5, true )")
	self._btnIncreaseMember	:addInputEvent("Mouse_Out",	"Panel_Guild_Tab_ToolTip_Func( 5, false )" )
end

local HandleClickedGuildDelContinue = function ()
	ToClient_RequestDestroyGuild()
	GuildManager:Hide()--FGlobal_guildWindow_Hide()
end

local HandleClickedGuildLeaveContinue = function ()
	ToClient_RequestDisjoinGuild()
	GuildManager:Hide()
end
-- 길드 해산 버튼
function HandleClickedGuildDel()
	
	local myGuildInfo = ToClient_GetMyGuildInfoWrapper();
	if( nil == myGuildInfo ) then
		_PA_ASSERT( false, "ResponseGuildInviteForGuildGrade 에서 길드 정보가 없습니다.");
		return;
	end
	
	local guildGrade	= myGuildInfo:getGuildGrade()
		
	local messageboxData 	
	if true == getSelfPlayer():get():isGuildMaster() then
		if ToClient_GetMyGuildInfoWrapper():getMemberCount() <= 1 then
			messageboxData = { title = PAGetString( Defines.StringSheet_GAME, "LUA_GUILD_DISPERSE_GUILD" ) , content = PAGetString( Defines.StringSheet_GAME, "LUA_GUILD_DISPERSE_GUILD_ASK" ) , functionYes = HandleClickedGuildDelContinue, functionNo = MessageBox_Empty_function, priority = UCT.PAUIMB_PRIORITY_LOW}
			MessageBox.showMessageBox(messageboxData)
			
		else
			Proc_ShowMessage_Ack( PAGetString( Defines.StringSheet_GAME, "LUA_GUILD_CANT_DISPERSE" ) )
		end
	else
		local tempText;
		if( 0 == guildGrade ) then
			tempText = PAGetString(Defines.StringSheet_GAME,"LUA_GUILD_TEXT_CLANLIST_CLANOUT_ASK") -- '클랜에서 탈퇴 하시겠습니까?'
		else
			tempText = PAGetString( Defines.StringSheet_GAME, "LUA_GUILD_WITHDRAW_GUILD_ASK" ) .. PAGetString(Defines.StringSheet_GAME, "LUA_GUILD_TEXT_GUILD_MENTINFO")
		end		
	
		messageboxData = { title = PAGetString( Defines.StringSheet_GAME, "LUA_GUILD_WITHDRAW_GUILD" ), content = tempText , functionYes = HandleClickedGuildLeaveContinue, functionNo = MessageBox_Empty_function, priority = UCT.PAUIMB_PRIORITY_LOW}
		MessageBox.showMessageBox(messageboxData)
	end
end



-- 길드 마크 등록 버튼
function HandleClickedChangeMark()
	messageboxData = { title = PAGetString( Defines.StringSheet_GAME, "LUA_GUILD_ADDMARK_MESSAGEBOX_TITLE" ), content = PAGetString( Defines.StringSheet_GAME, "LUA_GUILD_ADDMARK_MESSAGEBOX_TEXT" ), functionYes = HandleClickedChangeMark_Continue, functionNo = MessageBox_Empty_function, priority = UCT.PAUIMB_PRIORITY_LOW}
	MessageBox.showMessageBox(messageboxData, "top")
end

function HandleClickedChangeMark_Continue()
	guildMarkUpdate()
end

-- 성문 열기
function HandleClickedOpenSiegeGate()
	ToClient_RequestOpenSiegeGate()
end

-- 법인세 납부
function HandleClicked_TaxPayment()
	local myGuildInfo = ToClient_GetMyGuildInfoWrapper()
	if( nil == myGuildInfo ) then
		return;
	end

	local taxValue			=  Int64toInt32( myGuildInfo:getAccumulateTax() )
	local costValue			=  Int64toInt32( myGuildInfo:getAccumulateGuildHouseCost() )
	
	if( 0 < taxValue  ) then
		local msgBox_Title		= PAGetString(Defines.StringSheet_GAME, "LUA_GUILD_TEXT_GUILD_GUILDLAWTAX") --"길드 법인세 납부"
		local msgBox_Content	= PAGetStringParam1( Defines.StringSheet_GAME, "LUA_GUILD_TEXT_GUILD_GUILDLAWTAX_ASK", "taxValue", taxValue ) -- "길드 법인세 " .. taxValue .. " 실버를 납부하시겠습니까?"
		messageboxData = { title = msgBox_Title, content = msgBox_Content, functionYes = Guild_DoTaxPayment, functionNo = MessageBox_Empty_function, priority = UCT.PAUIMB_PRIORITY_LOW}
		MessageBox.showMessageBox(messageboxData, "middle")
	elseif( 0 < costValue ) then
		local msgBox_Title		= PAGetString(Defines.StringSheet_GAME, "LUA_GUILD_TEXT_GUILD_HOUSECOSTS_PAY") -- "길드 하우스 유지 비용 납부"
		local msgBox_Content	= PAGetStringParam1( Defines.StringSheet_GAME, "LUA_GUILD_TEXT_GUILD_HOUSECOSTS_PAY_ASK", "taxValue", costValue ) -- "길드 하우스 유지 비용 " .. taxValue .. " 실버를 납부하시겠습니까?"
		messageboxData = { title = msgBox_Title, content = msgBox_Content, functionYes = Guild_DoGuildHouseCost, functionNo = MessageBox_Empty_function, priority = UCT.PAUIMB_PRIORITY_LOW}
		MessageBox.showMessageBox(messageboxData, "middle")
	else
		Proc_ShowMessage_Ack( PAGetString(Defines.StringSheet_GAME, "LUA_GUILD_TEXT_GUILD_UNPAID_CONFIRM") ); -- "미납된 공금(법인세,길드하우스유지비용)이 없습니다."
		return;
	end
	
end
function Guild_DoTaxPayment()
	ToClient_PayComporateTax()
end

-- 길드하우스 유지 비용
function Guild_DoGuildHouseCost()
	ToClient_PayGuildHouseCost()
end


function HandleClickedIncreaseMember()
	local skillPointInfo = getSkillPointInfo( 3 )			
	if skillPointInfo._remainPoint < 2 then
		local messageContent	= PAGetString( Defines.StringSheet_GAME, "LUA_GUILD_NEED_GUILDSKILLPOINT" ) .. tostring( skillPointInfo._remainPoint) .. PAGetString( Defines.StringSheet_GAME, "LUA_GUILD_EXPAND_POINT_LACK")
		local messageboxData	= { title = PAGetString( Defines.StringSheet_GAME, "LUA_GUILD_EXPAND_MAX_COUNT" ) , content = messageContent, functionApply = MessageBox_Empty_function, priority = CppEnums.PAUIMB_PRIORITY.PAUIMB_PRIORITY_LOW}
		MessageBox.showMessageBox(messageboxData)
	else
		local messageContent	= PAGetString( Defines.StringSheet_GAME, "LUA_GUILD_EXPAND_MAX_COUNT_EXECUTE" ) .. tostring( skillPointInfo._remainPoint) 
		local messageboxData	= { title = PAGetString( Defines.StringSheet_GAME, "LUA_GUILD_EXPAND_MAX_COUNT" ) , content = messageContent, functionYes = Guild_IncreaseMember_Confirm, functionNo = MessageBox_Empty_function, priority = CppEnums.PAUIMB_PRIORITY.PAUIMB_PRIORITY_LOW}
		MessageBox.showMessageBox(messageboxData, "top")
	end
end

function Guild_IncreaseMember_Confirm()
	ToClient_RequestVaryJoinableGuildMemeberCount();
end



-- 길드 정보 업데이트
function GuildInfoPage:UpdateData()
	SetDATAByGuildGrade()

	local myGuildInfo = ToClient_GetMyGuildInfoWrapper()
	if myGuildInfo ~= nil then
		local guildRank			= myGuildInfo:getMemberCountLevel()
		local guildRankString	= ""
		if 1 == guildRank then
			guildRankString = "소형"
		elseif 2 == guildRank then
			guildRankString = "중형"
		elseif 3 == guildRank then
			guildRankString = "대형"
		elseif 4 == guildRank then
			guildRankString = "초대형"
		end
		self._txtRGuildName	:SetText( myGuildInfo:getName() )
		self._txtRRank		:SetText( guildRankString )
		self._txtRMaster	:SetText( myGuildInfo:getGuildMasterName() )
		-- self._txtRTendency	:SetText( myGuildInfo:getGuildTendency() )
		self._txtRPersonNo	:SetText( myGuildInfo:getMemberCount().."/".. myGuildInfo:getJoinableMemberCount() )

		if( toInt64(0, 0) < myGuildInfo:getAccumulateTax() ) then
			self._txtUnpaidTax:SetText( PAGetStringParam1( Defines.StringSheet_GAME, "LUA_GUILD_TEXT_GUILD_UNPAIDTAX", "getAccumulateTax", tostring( myGuildInfo:getAccumulateTax() ) ) ) -- 미납 법인세 내역
		elseif( toInt64(0, 0) < myGuildInfo:getAccumulateGuildHouseCost() ) then
			self._txtUnpaidTax:SetText( PAGetStringParam1( Defines.StringSheet_GAME, "LUA_GUILD_TEXT_GUILD_UNPAIDTAX_HOUSE", "getAccumulateGuildHouseCost", tostring( myGuildInfo:getAccumulateGuildHouseCost() ) ) ) -- 미납 길드하우스 유지비	
		end
		
		local isGuildMaster = getSelfPlayer():get():isGuildMaster()	
		if true == isGuildMaster then	
			self:SetShow(true)	
			if 0 == myGuildInfo:getGuildGrade() then
				self._btnGuildDel:SetText( PAGetString(Defines.StringSheet_GAME, "LUA_GUILD_DISPERSE_CLAN") ) -- 길드 해산
			else
				self._btnGuildDel:SetText(PAGetString(Defines.StringSheet_RESOURCE, "GUILD_BTN_DISMISS" )) -- 길드 해산
			end
			
			local skillPointInfo = getSkillPointInfo( 3 )
			local isEnable =  ( ToClient_GetGuildSkillPointPerIncreaseMember() <= skillPointInfo._remainPoint)
				
			-- self._btnIncreaseMember:SetEnable( isEnable ); 	
			self._btnIncreaseMember:SetMonoTone( not isEnable );
			
		else
			self:SetShow(false)
			if 0 == myGuildInfo:getGuildGrade() then
				self._btnGuildDel:SetText( PAGetString(Defines.StringSheet_GAME, "LUA_GUILD_WITHDRAW_CLAN") ) -- 길드 탈퇴
			else
				self._btnGuildDel:SetText(PAGetString(Defines.StringSheet_RESOURCE, "GUILD_BTN_LEAVE" )) -- 길드 탈퇴
			end
		end

		local hasOccupyTerritory = myGuildInfo:getHasSiegeCount()	-- 소유 영지가 있으면 배경이 나옴.
		if 0 ~= hasOccupyTerritory then
			GuildInfoPage._iconOccupyTerritory:SetShow( true )
		else
			GuildInfoPage._iconOccupyTerritory:SetShow( false )
		end

		local isSet = setGuildTextureByGuildNo( myGuildInfo:getGuildNo_s64(), GuildInfoPage._iconGuildMark )
		if ( false == isSet ) then
			GuildInfoPage._iconGuildMark:ChangeTextureInfoName("New_UI_Common_forLua/Default/Default_Buttons.dds")
			local x1, y1, x2, y2 = setTextureUV_Func( GuildInfoPage._iconGuildMark, 183, 1, 188, 6 )
			GuildInfoPage._iconGuildMark:getBaseTexture():setUV(  x1, y1, x2, y2  )
			GuildInfoPage._iconGuildMark:setRenderTexture(GuildInfoPage._iconGuildMark:getBaseTexture())
		else	
			GuildInfoPage._iconGuildMark:getBaseTexture():setUV(  0, 0, 1, 1  )
			GuildInfoPage._iconGuildMark:setRenderTexture(GuildInfoPage._iconGuildMark:getBaseTexture())
		end
	else
		GuildManager:Hide()
	end
end



----------------------------------------------------------------------------------------------------------------
------------ 좌측 중간 전쟁 선포 관련 관리
----------------------------------------------------------------------------------------------------------------
local GuildLetsWarPage = {}
--[[
GuildLetsWarPage
	initialize()
	UpdateData()	
]]--

-- 초기화
function GuildLetsWarPage:initialize()
	self._letsWarBG				= UI.getChildControl ( Panel_Window_Guild, "Static_Menu_BG_2")			
	self._txtLetsWarTitle 		= UI.getChildControl ( Panel_Window_Guild, "StaticText_Title_LetsWar" )
	self._btnLetsWarDoWar 		= UI.getChildControl ( Panel_Window_Guild, "Button_LetsWar" )
	self._editLetsWarInputName 	= UI.getChildControl ( Panel_Window_Guild, "Edit_InputGuild" )
	self._txtLetsWarHelp 		= UI.getChildControl ( Panel_Window_Guild, "StaticText_WarDesc_help" )
	
	function self:SetShow(isShow)
		self._letsWarBG:SetShow(isShow)
		self._txtLetsWarTitle:SetShow(isShow)
		self._btnLetsWarDoWar:SetShow(isShow)
		self._editLetsWarInputName:SetShow(isShow)	
		self._txtLetsWarHelp:SetShow(isShow)	
	end
	
	function self:GetShow()
		return self._letsWarBG:GetShow();
	end
	
	self:SetShow(false)
	
	self._txtLetsWarHelp:SetTextMode( UI_TM.eTextMode_AutoWrap )
	self._txtLetsWarHelp:SetText( PAGetString(Defines.StringSheet_GAME, "LUA_GUILD_TEXT_LETSWARHELP" ) )
	
	self._btnLetsWarDoWar:addInputEvent("Mouse_LUp", "HandleClickedLetsWar()")
	self._editLetsWarInputName:addInputEvent("Mouse_LUp", "HandleClickedLetsWarEditName()")
end

-- 전쟁 선포 버튼
function HandleClickedLetsWar()
	local guildName		= GuildLetsWarPage._editLetsWarInputName:GetEditText()
	local myGuildInfo	= ToClient_GetMyGuildInfoWrapper()
	local myGuildName	= myGuildInfo:getName()

	-- 미납 상태를 체크한다.
	local accumulateTax_s32		= Int64toInt32( myGuildInfo:getAccumulateTax() )
	local accumulateCost_s32	= Int64toInt32( myGuildInfo:getAccumulateGuildHouseCost() )
	
	if (0 < accumulateTax_s32) or (0 < accumulateCost_s32) then
		Proc_ShowMessage_Ack("조합세를 먼저 납부해야 합니다.")
		return
	end
	
	if guildName == myGuildName then
		local messageboxData = { title = "", content = PAGetString(Defines.StringSheet_GAME, "LUA_GUILD_TEXT_LETSWARFAIL" ), functionApply = MessageBox_Empty_function, priority = CppEnums.PAUIMB_PRIORITY.PAUIMB_PRIORITY_LOW }
		MessageBox.showMessageBox( messageboxData )
	else
		ToClient_RequestDeclareGuildWar(guildName)
	end	
	GuildLetsWarPage._editLetsWarInputName:SetEditText('', true)
	ClearFocusEdit()
	
	if ( AllowChangeInputMode() ) then
		if( UI.checkShowWindow() ) then
			UI.Set_ProcessorInputMode(IM.eProcessorInputMode_UiMode) 
		else
			UI.Set_ProcessorInputMode(IM.eProcessorInputMode_GameMode)
		end
	else
		SetFocusChatting()
	end
end

-- 전쟁 선포 옆 에디트 
function HandleClickedLetsWarEditName()
	UI.Set_ProcessorInputMode(IM.eProcessorInputMode_ChattingInputMode)
	GuildLetsWarPage._editLetsWarInputName:SetEditText('', true)
end

function FGlobal_CheckGuildLetsWarUiEdit(targetUI)
	return ( nil ~= targetUI ) and ( targetUI:GetKey() == GuildLetsWarPage._editLetsWarInputName:GetKey() )
end

function FGlobal_GuildLetsWarClearFocusEdit()
	GuildLetsWarPage._editLetsWarInputName:SetText("",true)
	ClearFocusEdit()
	if ( AllowChangeInputMode() ) then
		if( UI.checkShowWindow() ) then
			UI.Set_ProcessorInputMode(IM.eProcessorInputMode_UiMode) 
		else
			UI.Set_ProcessorInputMode(IM.eProcessorInputMode_GameMode)
		end
	else
		SetFocusChatting()
	end
end

-- 전쟁 선포 업데이트
function GuildLetsWarPage:UpdateData()
	local isGuildMaster = getSelfPlayer():get():isGuildMaster()
	if true == isGuildMaster then
		self:SetShow(true)
	else
		self:SetShow(false)
	end
end

----------------------------------------------------------------------------------------------------------------
------------ 좌측 하단 전쟁 현황 관리
----------------------------------------------------------------------------------------------------------------
local GuildWarInfoPage = 
{
	_list = {}
}

--[[
GuildWarInfoPage
	initialize()
	UpdateData()	
]]--

-- 초기화
function GuildWarInfoPage:initialize()
	local constStartY 	= 450
	
	self._txtWarInfoTitle	= UI.getChildControl ( Panel_Window_Guild, "StaticText_Title_WarInfo" )
	self._static_WarInfoBG	= UI.getChildControl ( Panel_Window_Guild, "Static_Menu_BG_1" )
	self._txtNoWar			= UI.getChildControl ( Panel_Window_Guild, "StaticText_NoWar" )
	self._txtWarHelp		= UI.getChildControl ( Panel_Window_Guild, "StaticText_WarInfo_help" )

	local copyWarBG			= UI.getChildControl ( Panel_Window_Guild, "Static_C_WarBG" )
	local copyGuildIcon		= UI.getChildControl ( Panel_Window_Guild, "Static_C_EnemyGuild_Icon" )
	local copyGuildName		= UI.getChildControl ( Panel_Window_Guild, "StaticText_C_EnemyGuild_Name" )
	local copyKill			= UI.getChildControl ( Panel_Window_Guild, "StaticText_C_Kill" )
	local copyDeath			= UI.getChildControl ( Panel_Window_Guild, "StaticText_C_Death" )
	local copyStopWar		= UI.getChildControl ( Panel_Window_Guild, "Button_C_WarStop" )
	
	self._txtWarInfoTitle	:AddChild( self._static_WarInfoBG )
	Panel_Window_Guild		:RemoveControl( self._static_WarInfoBG )
	self._static_WarInfoBG	:SetSpanSize( -5, self._txtWarInfoTitle:GetSizeY() + 2 )
	self._static_WarInfoBG	:ComputePos()

	self._static_WarInfoBG	:AddChild( self._txtNoWar )
	self._static_WarInfoBG	:AddChild( self._txtWarHelp )
	Panel_Window_Guild		:RemoveControl( self._txtNoWar )
	Panel_Window_Guild		:RemoveControl( self._txtWarHelp )
	self._txtNoWar			:ComputePos()
	self._txtWarHelp		:ComputePos()

	function createWarinfo( pIndex )
		local rtGuildWarInfo = {}
		rtGuildWarInfo._warBG 			= UI.createControl( UCT.PA_UI_CONTROL_STATIC,		self._static_WarInfoBG,	'Static_WarBG_' .. pIndex )
		rtGuildWarInfo._guildIcon 		= UI.createControl( UCT.PA_UI_CONTROL_STATIC,		rtGuildWarInfo._warBG,	'Static_GuildIcon_' .. pIndex )
		rtGuildWarInfo._txtGuildName 	= UI.createControl( UCT.PA_UI_CONTROL_STATICTEXT,	rtGuildWarInfo._warBG,	'StaticText_GuildName_' .. pIndex )
		rtGuildWarInfo._txtKill 		= UI.createControl( UCT.PA_UI_CONTROL_STATICTEXT,	rtGuildWarInfo._warBG,	'StaticText_Kill_' .. pIndex )
		rtGuildWarInfo._txtDeath 		= UI.createControl( UCT.PA_UI_CONTROL_STATICTEXT,	rtGuildWarInfo._warBG,	'StaticText_Death_' .. pIndex )
		rtGuildWarInfo._txtStopWar 		= UI.createControl( UCT.PA_UI_CONTROL_BUTTON,		rtGuildWarInfo._warBG,	'Button_WarStop_' .. pIndex )
		
		CopyBaseProperty( copyWarBG, 		rtGuildWarInfo._warBG )
		CopyBaseProperty( copyGuildIcon, 	rtGuildWarInfo._guildIcon )
		CopyBaseProperty( copyGuildName, 	rtGuildWarInfo._txtGuildName )
		CopyBaseProperty( copyKill, 		rtGuildWarInfo._txtKill )
		CopyBaseProperty( copyDeath, 		rtGuildWarInfo._txtDeath )
		CopyBaseProperty( copyStopWar, 		rtGuildWarInfo._txtStopWar )
		
		rtGuildWarInfo._warBG			:ComputePos()
		rtGuildWarInfo._guildIcon		:ComputePos()
		rtGuildWarInfo._txtGuildName	:ComputePos()
		rtGuildWarInfo._txtKill			:ComputePos()
		rtGuildWarInfo._txtDeath		:ComputePos()
		rtGuildWarInfo._txtStopWar		:ComputePos()
		
		rtGuildWarInfo._warBG			:SetPosY( (pIndex * 51) + 5 )	
		rtGuildWarInfo._guildIcon		:SetPosY( pIndex + 5 )	
		rtGuildWarInfo._txtGuildName	:SetPosY( pIndex + 7  )
		rtGuildWarInfo._txtKill			:SetPosY( pIndex + 25 )
		rtGuildWarInfo._txtDeath		:SetPosY( pIndex + 25 )
		rtGuildWarInfo._txtStopWar		:SetPosY( pIndex + 5 )	 
		
		rtGuildWarInfo._txtStopWar		:SetShow( false )
		rtGuildWarInfo._txtStopWar		:addInputEvent("Mouse_LUp", "HandleClickedStopWar("..pIndex..")")
		
		function rtGuildWarInfo:SetShow( isShow )
			rtGuildWarInfo._warBG		:SetShow(isShow)
			rtGuildWarInfo._guildIcon	:SetShow(isShow)
			rtGuildWarInfo._txtGuildName:SetShow(isShow)
			rtGuildWarInfo._txtKill		:SetShow(isShow)
			rtGuildWarInfo._txtDeath	:SetShow(isShow)
		end
		
		function rtGuildWarInfo:GetShow()
			return rtGuildWarInfo._warBG:GetShow()
		end
		
		function rtGuildWarInfo:SetData( pWarringGuild )
			local isSet = setGuildTextureByGuildNo( pWarringGuild:getGuildNo(), rtGuildWarInfo._guildIcon )
			if ( false == isSet ) then
				rtGuildWarInfo._guildIcon:ChangeTextureInfoName("New_UI_Common_forLua/Default/Default_Buttons.dds")
				local x1, y1, x2, y2 = setTextureUV_Func( rtGuildWarInfo._guildIcon, 183, 1, 188, 6 )
				rtGuildWarInfo._guildIcon:getBaseTexture():setUV(  x1, y1, x2, y2  )
				rtGuildWarInfo._guildIcon:setRenderTexture(rtGuildWarInfo._guildIcon:getBaseTexture())
			else	
				rtGuildWarInfo._guildIcon:getBaseTexture():setUV(  0, 0, 1, 1  )
				rtGuildWarInfo._guildIcon:setRenderTexture(rtGuildWarInfo._guildIcon:getBaseTexture())
			end
			
			if pWarringGuild:isExist() then
				rtGuildWarInfo._txtGuildName:SetMonoTone( false )
				rtGuildWarInfo._txtGuildName:SetText( pWarringGuild:getGuildName() )
			else
				rtGuildWarInfo._txtGuildName:SetMonoTone( true )
				rtGuildWarInfo._txtGuildName:SetText( pWarringGuild:getGuildName().." (해산됨)" )
			end
			
			rtGuildWarInfo._txtKill:SetText( PAGetStringParam1(Defines.StringSheet_GAME, "LUA_GUILD_TEXT_KILLCOUNT", "kill_count", tostring( Uint64toUint32( pWarringGuild:getKillCount() ) ) ) )
			rtGuildWarInfo._txtDeath:SetText( PAGetStringParam1(Defines.StringSheet_GAME, "LUA_GUILD_TEXT_DEATHCOUNT", "death_count", tostring( Uint64toUint32( pWarringGuild:getDeathCount() ) ) ) )
		end
		 	
		return rtGuildWarInfo
	end
	
	for index = 0, (constCreateWarInfoCount - 1), 1 do
		self._list[index] = createWarinfo(index)
	end
	
	self._txtNoWar:SetText( PAGetString(Defines.StringSheet_GAME, "LUA_GUILD_TEXT_NOWAR" ) )
	self._txtNoWar:SetShow(false)
	
	self._txtWarHelp:SetTextMode( UI_TM.eTextMode_AutoWrap )
	self._txtWarHelp:SetText( PAGetString(Defines.StringSheet_GAME, "LUA_GUILD_TEXT_WARHELP" ) )
	
	UI.deleteControl(copyWarBG)
	UI.deleteControl(copyGuildIcon)
	UI.deleteControl(copyGuildName)
	UI.deleteControl(copyKill)
	UI.deleteControl(copyDeath)
	UI.deleteControl(copyStopWar)
	
	copyWarBG = nil
	copyGuildIcon = nil
	copyGuildName = nil
	copyKill = nil
	copyDeath = nil
	copyWarBG = nil

	self._txtWarInfoTitle:SetSpanSize( self._txtWarInfoTitle:GetSpanSize().x, 400 )
	self._txtWarInfoTitle:ComputePos()
end

-- 전쟁 선포 중지 버튼
function HandleClickedStopWar (index)
	ToClient_RequestStopGuildWar(index)
end

-- 전쟁 현황 업데이트
function GuildWarInfoPage:UpdateData()
	local warringGuildCount = ToClient_GetWarringGuildListCount()

	if 0 == warringGuildCount then	-- "현재 전쟁중인 길드가 없습니다" 문구 호출 용도
		for index = 0, (constCreateWarInfoCount - 1), 1 do
			self._list[index]:SetShow(false)
		end
		self._list[0]._warBG:SetShow(false)
		self._list[0]._txtStopWar:SetShow(false)
		self._txtNoWar:SetShow(true)
	else
		for index=0, (constCreateWarInfoCount - 1), 1 do	
			if index < warringGuildCount then
				self._txtNoWar:SetShow(false)
				self._list[index]:SetShow(true)
				self._list[index]:SetData( ToClient_GetWarringGuildListAt(index) )
				
				local isGuildMaster = getSelfPlayer():get():isGuildMaster()
				if true == isGuildMaster then
					self._list[index]._txtStopWar:SetShow(true)
				else
					self._list[index]._txtStopWar:SetShow(false)
				end
			else	
				self._list[index]:SetShow(false)
			end
		end	
	end
	
end

----------------------------------------------------------------------------------------------------------------
------------ 길드 창 관리 (최상위)
----------------------------------------------------------------------------------------------------------------
GuildManager = 
{
	_mainTagName		= UI.getChildControl ( Panel_Window_Guild, "StaticText_MenuTag" ),
	_haveSiegeCount		= 0,
}
--[[
GuildWarfareInfoPage
	initialize()
	TabToggle( index )
	Show()
	Hide()	
]]--

local _txt_Help_History 		= UI.getChildControl ( Panel_Window_Guild, "StaticText_Help_History" )
local _txt_Help_GuildMember 	= UI.getChildControl ( Panel_Window_Guild, "StaticText_Help_GuildMember" )
local _txt_Help_GuildQuest 		= UI.getChildControl ( Panel_Window_Guild, "StaticText_Help_GuildQuest" )
local _txt_Help_GuildSkill 		= UI.getChildControl ( Panel_Window_Guild, "StaticText_Help_GuildSkill" )
local _txt_Help_WarInfo 		= UI.getChildControl ( Panel_Window_Guild, "StaticText_Help_WarInfo" )

------------------------------------------------------
--				최초 초기화 해주는 함수
------------------------------------------------------
function GuildManager:initialize()
	-- 상위 탭 버튼------------------------------------------
	self.mainBtn_History	= UI.getChildControl ( Panel_Window_Guild, "Button_Tab_History" )
	self.mainBtn_Info		= UI.getChildControl ( Panel_Window_Guild, "Button_Tab_GuildInfo" )
	self.mainBtn_Quest   	= UI.getChildControl ( Panel_Window_Guild, "Button_Tab_GuildQuest" )
	self.mainBtn_Tree    	= UI.getChildControl ( Panel_Window_Guild, "Button_Tab_Skill" )
	self.mainBtn_Warfare 	= UI.getChildControl ( Panel_Window_Guild, "Button_Tab_Warfare" )
	self.closeButton 		= UI.getChildControl ( Panel_Window_Guild, "Button_Close" )
	self._buttonQuestion	= UI.getChildControl ( Panel_Window_Guild, "Button_Question" )		-- 물음표 버튼
	
	
	self.mainBtn_History:addInputEvent( "Mouse_LUp", "GuildManager:TabToggle( 0 )" )
	self.mainBtn_Info:addInputEvent( "Mouse_LUp", "GuildManager:TabToggle( 1 )" )
	self.mainBtn_Quest:addInputEvent( "Mouse_LUp", "GuildManager:TabToggle( 2 )" )
	self.mainBtn_Tree:addInputEvent( "Mouse_LUp", "GuildManager:TabToggle( 3 )" )
	self.mainBtn_Warfare:addInputEvent( "Mouse_LUp", "GuildManager:TabToggle( 4 )" )
	self.closeButton:addInputEvent("Mouse_LUp", "HandleClickedGuildHideButton()")
	self._buttonQuestion:addInputEvent("Mouse_LUp", "Panel_WebHelper_ShowToggle( \"PanelGuild\" )")					-- 물음표 좌클릭
	self._buttonQuestion:addInputEvent("Mouse_On", "HelpMessageQuestion_Show( \"PanelGuild\", \"true\")")			-- 물음표 마우스오버
	self._buttonQuestion:addInputEvent("Mouse_Out", "HelpMessageQuestion_Show( \"PanelGuild\", \"false\")")			-- 물음표 마우스아웃
	
	self.mainBtn_History:addInputEvent( "Mouse_On", "Panel_Guild_Tab_ToolTip_Func( 0, true )" )
	self.mainBtn_Info:addInputEvent( "Mouse_On", "Panel_Guild_Tab_ToolTip_Func( 1, true )" )
	self.mainBtn_Quest:addInputEvent( "Mouse_On", "Panel_Guild_Tab_ToolTip_Func( 2, true )" )
	self.mainBtn_Tree:addInputEvent( "Mouse_On", "Panel_Guild_Tab_ToolTip_Func( 3, true )" )
	self.mainBtn_Warfare:addInputEvent( "Mouse_On", "Panel_Guild_Tab_ToolTip_Func( 4, true )" )
	
	self.mainBtn_History:addInputEvent( "Mouse_Out", "Panel_Guild_Tab_ToolTip_Func( 0, false )" )
	self.mainBtn_Info:addInputEvent( "Mouse_Out", "Panel_Guild_Tab_ToolTip_Func( 1, false )" )
	self.mainBtn_Quest:addInputEvent( "Mouse_Out", "Panel_Guild_Tab_ToolTip_Func( 2, false )" )
	self.mainBtn_Tree:addInputEvent( "Mouse_Out", "Panel_Guild_Tab_ToolTip_Func( 3, false )" )
	self.mainBtn_Warfare:addInputEvent( "Mouse_Out", "Panel_Guild_Tab_ToolTip_Func( 4, false )" )

	GuildInfoPage:initialize()		-- 길드정보 초기화
	GuildLetsWarPage:initialize()	-- 길드 전쟁선포 초기화
	GuildWarInfoPage:initialize()	-- 길드 전쟁 현황 초기화
	
	
	-- 다른 lua 파일에 선언됨-------------------------------------------------------
	GuildListInfoPage:initialize()				-- 길드원 현황 초기화
	GuildQuestInfoPage:initialize()				-- 길드 임무 초기화
	-- GuildProgressQuestInfoPage:initialize() 	-- 길드 임무 퀘스트 좌측 상단 표시
	GuildWarfareInfoPage:initialize() 			-- 길드 전쟁 현황 초기화
	GuildSkillFrame_Init()						-- 길드 스킬 초기화
	---------------------------------------------------------------------------------
		
	function self:ChangeTab( pText, pX1, pY1, pX2, pY2)
		local x1, y1, x2, y2 = setTextureUV_Func( self._mainTagName, pX1, pY1, pX2, pY2 )
		self._mainTagName:SetText( pText )		
		self._mainTagName:getBaseTexture():setUV(  x1, y1, x2, y2  )
		self._mainTagName:setRenderTexture(self._mainTagName:getBaseTexture())	
	end
end

-- 'x' 버튼 클릭
function HandleClickedGuildHideButton()
	GuildManager:Hide()--FGlobal_guildWindow_Hide()
	GuildLetsWarPage._editLetsWarInputName:SetEditText('', true)
	UI.Set_ProcessorInputMode(IM.eProcessorInputMode_GameMode)
	ClearFocusEdit()
end



function Panel_Guild_Tab_ToolTip_Func( tabNo, isOn )
	local mouse_posX = getMousePosX()
	local mouse_posY = getMousePosY()
	
	local panel_posX = Panel_Window_Guild:GetPosX()
	local panel_posY = Panel_Window_Guild:GetPosY()
		
	_txt_Help_History:SetTextMode( UI_TM.eTextMode_AutoWrap )

	local myGuildInfo	= ToClient_GetMyGuildInfoWrapper()
	local guildGrade	= nil
	if nil ~= myGuildInfo then
		guildGrade	= myGuildInfo:getGuildGrade()
	end
	if 0 == guildGrade then
		_txt_Help_History:SetText( PAGetString(Defines.StringSheet_GAME, "LUA_GUILD_TEXT_CLAN_INFO") )		-- 클랜 정보
	else
		_txt_Help_History:SetText( PAGetString( Defines.StringSheet_GAME, "LUA_GUILD_TEXT_GUILDHISTORY" ) )		-- 길드 정보
	end

	_txt_Help_GuildMember:SetTextMode( UI_TM.eTextMode_AutoWrap )
	_txt_Help_GuildMember:SetText( PAGetString( Defines.StringSheet_GAME, "LUA_GUILD_TEXT_GUILDLIST" ) )	-- 길드원 목록
	
	_txt_Help_GuildQuest:SetTextMode( UI_TM.eTextMode_AutoWrap )
	_txt_Help_GuildQuest:SetText( PAGetString( Defines.StringSheet_GAME, "LUA_GUILD_TEXT_GUILDQUEST" ) )	-- 길드 임무
	
	_txt_Help_GuildSkill:SetTextMode( UI_TM.eTextMode_AutoWrap )
	_txt_Help_GuildSkill:SetText( PAGetString( Defines.StringSheet_GAME, "LUA_GUILD_TEXT_GUILDSKILL" ) )	-- 길드 스킬
	
	_txt_Help_WarInfo:SetTextMode( UI_TM.eTextMode_AutoWrap )
	_txt_Help_WarInfo:SetText( PAGetString( Defines.StringSheet_GAME, "LUA_GUILD_TEXT_GUILDWARFAREINFO" ) )	-- 점령전 현황
	
	if ( tabNo == 0 ) then
		if ( isOn == true ) then
			_txt_Help_History:SetAlpha( 0 )
			_txt_Help_History:SetFontAlpha( 0 )
			_txt_Help_History:ResetVertexAni()
			local AniInfo = UIAni.AlphaAnimation( 1, _txt_Help_History, 0.0, 0.2 )
			_txt_Help_History:SetShow( true )
			
			_txt_Help_History:SetPosX( mouse_posX - panel_posX - 5 )
			_txt_Help_History:SetPosY( mouse_posY - panel_posY + 15 )
		else
			_txt_Help_History:ResetVertexAni()
			local AniInfo = UIAni.AlphaAnimation( 0, _txt_Help_History, 0.0, 0.2 )
			AniInfo:SetHideAtEnd( true )
		end
	
	elseif ( tabNo == 1 ) then
		if ( isOn == true ) then
			_txt_Help_GuildMember:SetAlpha( 0 )
			_txt_Help_GuildMember:SetFontAlpha( 0 )
			_txt_Help_GuildMember:ResetVertexAni()
			local AniInfo = UIAni.AlphaAnimation( 1, _txt_Help_GuildMember, 0.0, 0.2 )
			_txt_Help_GuildMember:SetShow( true )
			
			_txt_Help_GuildMember:SetPosX( mouse_posX - panel_posX - 5 )
			_txt_Help_GuildMember:SetPosY( mouse_posY - panel_posY + 15 )
		else
			_txt_Help_GuildMember:ResetVertexAni()
			local AniInfo = UIAni.AlphaAnimation( 0, _txt_Help_GuildMember, 0.0, 0.2 )
			AniInfo:SetHideAtEnd( true )
		end
		
	elseif ( tabNo == 2 ) then
		if ( isOn == true ) then
			_txt_Help_GuildQuest:SetAlpha( 0 )
			_txt_Help_GuildQuest:SetFontAlpha( 0 )
			_txt_Help_GuildQuest:ResetVertexAni()
			local AniInfo = UIAni.AlphaAnimation( 1, _txt_Help_GuildQuest, 0.0, 0.2 )
			_txt_Help_GuildQuest:SetShow( true )
			
			_txt_Help_GuildQuest:SetPosX( mouse_posX - panel_posX - 5 )
			_txt_Help_GuildQuest:SetPosY( mouse_posY - panel_posY + 15 )
		else
			local AniInfo = UIAni.AlphaAnimation( 0, _txt_Help_GuildQuest, 0.0, 0.2 )
			AniInfo:SetHideAtEnd( true )
		end
		
	elseif ( tabNo == 3 ) then
		if ( isOn == true ) then
			_txt_Help_GuildSkill:SetAlpha( 0 )
			_txt_Help_GuildSkill:SetFontAlpha( 0 )
			_txt_Help_GuildSkill:ResetVertexAni()
			local AniInfo = UIAni.AlphaAnimation( 1, _txt_Help_GuildSkill, 0.0, 0.2 )
			_txt_Help_GuildSkill:SetShow( true )
			
			_txt_Help_GuildSkill:SetPosX( mouse_posX - panel_posX - 5 )
			_txt_Help_GuildSkill:SetPosY( mouse_posY - panel_posY + 15 )
		else
			local AniInfo = UIAni.AlphaAnimation( 0, _txt_Help_GuildSkill, 0.0, 0.2 )
			AniInfo:SetHideAtEnd( true )
		end
		
	elseif ( tabNo == 4 ) then
		if ( isOn == true ) then
			_txt_Help_WarInfo:SetAlpha( 0 )
			_txt_Help_WarInfo:SetFontAlpha( 0 )
			_txt_Help_WarInfo:ResetVertexAni()
			local AniInfo = UIAni.AlphaAnimation( 1, _txt_Help_WarInfo, 0.0, 0.2 )
			_txt_Help_WarInfo:SetShow( true )
			
			_txt_Help_WarInfo:SetPosX( mouse_posX - panel_posX - 5 )
			_txt_Help_WarInfo:SetPosY( mouse_posY - panel_posY + 15 )
		else
			local AniInfo = UIAni.AlphaAnimation( 0, _txt_Help_WarInfo, 0.0, 0.2 )
			AniInfo:SetHideAtEnd( true )
		end
	elseif ( tabNo == 5) then
		if( true == isOn ) then
			_txt_Help_WarInfo:SetText(PAGetString(Defines.StringSheet_GAME, "LUA_GUILD_HELP_WARINFO" ))	-- 길드 최대 인원을 늘립니다.
			_txt_Help_WarInfo:SetAlpha( 0 )
			_txt_Help_WarInfo:SetFontAlpha( 0 )
			_txt_Help_WarInfo:ResetVertexAni()
			local AniInfo = UIAni.AlphaAnimation( 1, _txt_Help_WarInfo, 0.0, 0.2 )
			_txt_Help_WarInfo:SetShow( true )
			
			_txt_Help_WarInfo:SetPosX( mouse_posX - panel_posX - 5 )
			_txt_Help_WarInfo:SetPosY( mouse_posY - panel_posY + 15 )
		else
			local AniInfo = UIAni.AlphaAnimation( 0, _txt_Help_WarInfo, 0.0, 0.2 )
			AniInfo:SetHideAtEnd( true )
		end
	end
	
end

--------------------------------------------------------------------------------
--							탭을 눌렀을 때의 함수
--------------------------------------------------------------------------------
function GuildManager:TabToggle( index )
	self._mainTagName:ChangeTextureInfoName("New_UI_Common_forLua/Window/Guild/Guild_00.dds")
	if ( 0 == index ) then		-- 공지사항	
		self:ChangeTab( PAGetString(Defines.StringSheet_GAME, "LUA_GUILD_TEXT_GUILDHISTORY" ) , 92, 1, 104, 15 )
		FGlobal_GuildHistory_Show( true )
		GuildListInfoPage:Hide()
		GuildQuestInfoPage:Hide()
		GuildWarfareInfoPage:Hide()
		GuildSkillFrame_Hide()
					
	elseif ( 1 == index ) then	-- 길드원 현황
		local myGuildInfo	= ToClient_GetMyGuildInfoWrapper()
		local guildGrade	= nil
		if nil ~= myGuildInfo then
			guildGrade	= myGuildInfo:getGuildGrade()
		end
		if 0 == guildGrade then
			self:ChangeTab( PAGetString(Defines.StringSheet_GAME, "LUA_GUILD_TEXT_CLAN_MEMBERINFO") , 107, 1, 119, 15 )
		else
			self:ChangeTab( PAGetString(Defines.StringSheet_GAME, "LUA_GUILD_TEXT_GUILDLIST" ) , 107, 1, 119, 15 )
		end
		FGlobal_GuildHistory_Show( false )
		GuildListInfoPage:Show()
		GuildQuestInfoPage:Hide()
		GuildWarfareInfoPage:Hide()	
		GuildSkillFrame_Hide()
		
	elseif ( 2 == index ) then	-- 길드 임무	
		self:ChangeTab( PAGetString(Defines.StringSheet_GAME, "LUA_GUILD_TEXT_GUILDQUEST" ), 122, 1, 134, 15 )	
		FGlobal_GuildHistory_Show( false )
		GuildListInfoPage:Hide()
		GuildQuestInfoPage:Show()
		GuildWarfareInfoPage:Hide()
		GuildSkillFrame_Hide()		
				
	elseif ( 3 == index ) then	-- 길드 스킬	
		self:ChangeTab( PAGetString(Defines.StringSheet_GAME, "LUA_GUILD_TEXT_GUILDSKILL" ) , 137, 1, 149, 15 )		
		FGlobal_GuildHistory_Show( false )
		GuildListInfoPage:Hide()
		GuildQuestInfoPage:Hide()
		GuildWarfareInfoPage:Hide()		
		GuildSkillFrame_Show()
			
	elseif ( 4 == index ) then	-- 전쟁 정보	
		self:ChangeTab( PAGetString(Defines.StringSheet_GAME, "LUA_GUILD_TEXT_GUILDWARFAREINFO" ), 152, 1, 164, 15 )		
		FGlobal_GuildHistory_Show( false )
		GuildListInfoPage:Hide()
		GuildQuestInfoPage:Hide()
		GuildWarfareInfoPage:Show()		
		GuildSkillFrame_Hide()
		
	end
end


--------------------------------------------------------------------------------
--							길드창 켜고 끄는 함수 (globalKeyBinder.lua 에서 사용)
--------------------------------------------------------------------------------

function GuildManager:Hide()
	Panel_Window_Guild:SetShow( false, true )
	HelpMessageQuestion_Out()		-- 물음표 버튼 툴팁 끄기
	
	FGlobal_AgreementGuild_Close()
	agreementGuild_Master_Close()
	Panel_GuildIncentiveOption_Close()
	
	TooltipSimple_Hide()
end

function GuildManager:Show()
	if false == Panel_Window_Guild:IsShow() then
		local myGuildInfo = ToClient_GetMyGuildInfoWrapper()
		if myGuildInfo ~= nil then
			GuildManager._haveSiegeCount = myGuildInfo:getHasSiegeCount()
		end
		GuildManager:TabToggle( 1 )
		GuildInfoPage:UpdateData()
		GuildListInfoPage:UpdateData()
		GuildLetsWarPage:UpdateData()
		GuildWarInfoPage:UpdateData()
		GuildSkillFrame_Update()	
		
		-- 길드 리메인 타임을 적용한다.
		guildQuest_ProgressingGuildQuest_UpdateRemainTime()
		-- QuestWidget_ProgressingGuildQuest_UpdateRemainTime()
		
		Panel_Window_Guild:SetShow( true, true )
	end
end

----------------------------------------------------------------------------------------------------
GuildManager:initialize()	-- 길드 초기화


function FromClient_ResponseGuildUpdate()

	_PA_LOG("luadebug", "FromClient_ResponseGuildUpdate")
	
	if( true == Panel_Window_Guild:GetShow() ) then
		GuildInfoPage		:UpdateData()
		GuildListInfoPage	:UpdateData()
		GuildLetsWarPage	:UpdateData()
		GuildWarInfoPage	:UpdateData()
		GuildSkillFrame_Update()

		-- 길드 리메인 타임을 적용한다.
		guildQuest_ProgressingGuildQuest_UpdateRemainTime()
		-- QuestWidget_ProgressingGuildQuest_UpdateRemainTime()
	elseif ( true == Panel_ClanList:GetShow() ) then
		 FGlobal_ClanList_Update()
	end
end

function FromClient_EventActorChangeGuildInfo()
	GuildInfoPage:UpdateData()
end

local messageBox_guild_accept = function()
	ToClient_RequestAcceptGuildInvite();
end

local messageBox_guild_refuse = function()
	ToClient_RequestRefuseGuildInvite();
end

function FromClient_ResponseGuild_refuse(questName, s64_joinableTime )
	
	if( toInt64(0,0) < s64_joinableTime ) then
	
		local lefttimeText = convertStringFromDatetime(getLeftSecond_TTime64(s64_joinableTime));
		
		local contentString = PAGetStringParam2( Defines.StringSheet_GAME, "LUA_GUILD_MSGBOX_JOINWAITTIME_CONTENT", "questName", questName, "lefttimeText", lefttimeText ) -- questName.."님은 길드가입 대기시간이 " ..lefttimeText.. " 남으셨습니다."
		local messageboxData = { title = PAGetString( Defines.StringSheet_GAME, "LUA_GUILD_TEXT_GUILD_INVITE" ), content = contentString, functionYes = MessageBox_Empty_function, priority = CppEnums.PAUIMB_PRIORITY.PAUIMB_PRIORITY_LOW}
		MessageBox.showMessageBox(messageboxData)

	else
		
		local myGuildInfo = ToClient_GetMyGuildInfoWrapper();
		if( nil == myGuildInfo ) then
			_PA_ASSERT( false, "FromClient_ResponseGuild_refuse 에서 길드 정보가 없습니다.");
		end
		
		local textGuild = "";
		local guildGrade	= myGuildInfo:getGuildGrade()
		if( 0 == guildGrade ) then
			textGuild = PAGetString(Defines.StringSheet_GAME, "LUA_GUILD_TEXT_CLAN") -- "클랜"
		else
			textGuild = PAGetString(Defines.StringSheet_GAME, "LUA_GUILD_TEXT_GUILD") -- "길드"
		end
		
		local contentString = PAGetStringParam2(  Defines.StringSheet_GAME, "LUA_GUILD_REFUSE_GUILDINVITE", "name", questName, "guild", textGuild )
		local messageboxData = { title = PAGetString( Defines.StringSheet_GAME, "LUA_GUILD_TEXT_GUILD_INVITE" ), content = contentString, functionYes = MessageBox_Empty_function, priority = CppEnums.PAUIMB_PRIORITY.PAUIMB_PRIORITY_LOW}
		MessageBox.showMessageBox(messageboxData)

	end
	
end

function FromClient_ResponseGuild_invite( s64_guildNo, hostUsername, hostName, guildName, guildGrade, periodDay, benefit, penalty )	
	if(  0 == guildGrade ) then	-- 길드 등급 클랜
		local luaGuildTextGuildInviteMsg = PAGetString( Defines.StringSheet_GAME, "LUA_GUILD_TEXT_CLAN_INVITE_MSG" )
		local luaGuildTextGuildInvite = PAGetString( Defines.StringSheet_GAME, "LUA_GUILD_TEXT_CLAN_INVITE" )

		local contentString = hostUsername.."("..hostName..")"..luaGuildTextGuildInviteMsg;
		local messageboxData = { title = luaGuildTextGuildInvite, content = contentString, functionYes = messageBox_guild_accept, functionCancel = messageBox_guild_refuse, priority = CppEnums.PAUIMB_PRIORITY.PAUIMB_PRIORITY_LOW}
		MessageBox.showMessageBox(messageboxData);

	elseif( 1 == guildGrade ) then -- 길드 등급 길드
		-- 고용 계약서를 띄워준다.
		FGlobal_AgreementGuild_Open( true, hostUsername, hostName, guildName, periodDay, benefit, penalty, s64_guildNo )
	end
	
end


function messageBox_guildAlliance_accept()
	ToClient_RequestAcceptGuildAllianceInvite();
end

function messageBox_guildAlliance_refuse()
	ToClient_RequestRefuseGuildAllianceInvite();
end

function FromClient_ResponseGuildAlliance_invite( hostName )
	local luaGuildTextGuildAllianceInviteMsg = PAGetString( Defines.StringSheet_GAME, "LUA_GUILD_TEXT_GUILDALLIANCE_INVITE_MSG" )
	local luaGuildTextGuildAllianceInvite = PAGetString( Defines.StringSheet_GAME, "LUA_GUILD_TEXT_GUILDALLIANCE_INVITE" )
	
	local contentString = hostName..luaGuildTextGuildAllianceInviteMsg;
	local messageboxData = { title = luaGuildTextGuildAllianceInvite, content = contentString, functionYes = messageBox_guildAlliance_accept, functionCancel = messageBox_guildAlliance_refuse, priority = CppEnums.PAUIMB_PRIORITY.PAUIMB_PRIORITY_LOW}
	MessageBox.showMessageBox(messageboxData);
end

function FromClient_ResponseGuildAlliance_refuse( guestName )
	local luaGuildTextGuildAllianceRefuseMsg = PAGetString( Defines.StringSheet_GAME, "LUA_GUILD_TEXT_GUILDALLIANCE_REFUSE_MSG" )
	local luaGuildTextGuildAllianceRefuse = PAGetString( Defines.StringSheet_GAME, "LUA_GUILD_TEXT_GUILDALLIANCE_REFUSE" )
	
	local contentString = guestName..luaGuildTextGuildAllianceRefuseMsg;
	local messageboxData = { title = luaGuildTextGuildAllianceRefuse, content = contentString, functionYes = MessageBox_Empty_function, priority = CppEnums.PAUIMB_PRIORITY.PAUIMB_PRIORITY_LOW}
	MessageBox.showMessageBox(messageboxData);
end

function FromClient_ResponseUpdateGuildContract( notifyType, userNickName, characterName, s64_param1, s64_param2, s64_param3 )
	
	-- notifyType 
	-- 0 : 수당이 지급되었다. 수금할 수 있다.
	-- 1 : 누군가 입금했다
	-- 2 : 누군가 수당을 수금했다.
	-- 3 : 누군가 고용 계약을 갱신했다.
	-- 4 : 누군가의 고용 계약 만료
	-- 5 : 고용 계약 갱신을 위한 계약서 제시
	-- 6 : 길드 법인세 납부/미납부
	-- 7 : 위약금 내고 탈퇴
	-- 8 : 위로금을 주고 강제추방
	-- 9 : 길드 승급
	-- 10 : 길드원 활동량 변경
	-- 11 : 길드 하우스 입찰		param1 : 입찰 금액, param2 : chracterKey param3:최고가입찰인지(1), 아닌지(0)
	-- 12 : 길드 하우스 입찰 결과
	-- 13 : 길드 샵 이용
	-- 14 : 길드 인센티브 지급
	-- 15 : 길드 하우스 유지 비용 납부
	-- 16 : 길드 창설 통보
	-- 17 : 길드 퀘스트 수락
	-- 18 : 길드 퀘스트 완료
	-- 19 : 성주가 마을의 세금을 길드 자금으로 가져왔다.
	-- 20 : 길드원이 누구를 PK 했다.
	-- 21 : 길드가 전쟁 선포 하는데 성향치 얼마, 길드자금 얼마 소모 했다.
	-- 22 : 길드원의 기운이 바뀌었다.
	-- 23 : 길드원의 공헌도가 바뀌었다.
	
	local param1 = Int64toInt32(s64_param1)
	local param2 = Int64toInt32(s64_param2)
	local param3 = Int64toInt32(s64_param3)
	
	
	if( 0  == notifyType ) then
		local tempStr		= PAGetString(Defines.StringSheet_GAME, "LUA_GUILD_TEXT_GUILD_PENSION");
		local guildWrapper	= ToClient_GetMyGuildInfoWrapper()
		if nil == guildWrapper then
			return
		end
		local guildGrade	= guildWrapper:getGuildGrade()
		if 1 == guildGrade then
			Proc_ShowMessage_Ack( tempStr ) 
		end
	elseif ( 1 == notifyType ) then
		local tempStr = PAGetStringParam2( Defines.StringSheet_GAME, "LUA_GUILD_TEXT_GUILD_MONEY_DEPOSIT", "userNickName", userNickName, "money", tostring(param1) ); -- userNickName..'이 길드자금' ..tostring(param1)..'을 입금하였습니다..';
		Proc_ShowMessage_Ack( tempStr ) 
	elseif ( 2 == notifyType ) then
		local tempStr = PAGetStringParam2( Defines.StringSheet_GAME, "LUA_GUILD_TEXT_GUILD_MONEY_COLLECTION", "userNickName", userNickName, "money", tostring(param1) ); -- userNickName..'이' ..tostring(param1)..'을 수금하였습니다..';
		Proc_ShowMessage_Ack( tempStr ) 
	elseif ( 3 == notifyType ) then
		local tempStr = PAGetStringParam1( Defines.StringSheet_GAME, "LUA_GUILD_TEXT_GUILD_HIRE_RENEWAL", "userNickName", userNickName ) -- userNickName..'이 고용 계약을 갱신하였습니다'
		Proc_ShowMessage_Ack( tempStr ) 
	elseif ( 4 == notifyType ) then
		local tempStr = PAGetStringParam1( Defines.StringSheet_GAME, "LUA_GUILD_TEXT_GUILD_EXPIRATION", "userNickName", userNickName ); -- userNickName..'이 고용 계약이 만료되었습니다.'
		Proc_ShowMessage_Ack( tempStr ) 
	elseif ( 5 == notifyType ) then 	
		local periodDay 	= getTemporaryInformationWrapper():getContractedPeriodDay();
		local benefit		= getTemporaryInformationWrapper():getContractedBenefit();
		local penalty		= getTemporaryInformationWrapper():getContractedPenalty();
		local guildWrapper	= ToClient_GetMyGuildInfoWrapper()
		if( nil == guildWrapper ) then
			_PA_ASSERT(false, "길드원이 고용계약서를 받는데 길드 정보가 없습니다.");
			return;
		end
		
		FGlobal_AgreementGuild_Open( false, userNickName, characterName, PAGetString(Defines.StringSheet_GAME, "LUA_GUILD_AGREEMENTGUILDOPEN_PARAM"), periodDay, benefit, penalty,  guildWrapper:getGuildNo_s64() );
	elseif( 6 == notifyType ) then	
		
		local tempTxt = PAGetStringParam1( Defines.StringSheet_GAME, "LUA_GUILD_TEXT_GUILD_PAYMENTS", "typeMoney", tostring(param2) ) -- tostring(param2)..' 납부'
		if( 0 ~= param1 ) then
			tempTxt = PAGetStringParam1( Defines.StringSheet_GAME, "LUA_GUILD_TEXT_GUILD_UNPAID", "typeMoney", tostring(param2) ) -- tostring(param2)..' 미납'
		end
		
		Proc_ShowMessage_Ack( PAGetStringParam1( Defines.StringSheet_GAME, "LUA_GUILD_TEXT_GUILD_INCOMETAX", "type", tempTxt ) ) --'길드 법인세가' ..tempTxt.. '되었습니다' 
	
	elseif( 7 == notifyType ) then	
		
		local tempTxt = PAGetStringParam1( Defines.StringSheet_GAME, "LUA_GUILD_TEXT_GUILD_LEAVE", "userNickName", userNickName ) -- userNickName .. "님이 탈퇴하였습니다."
		if( 0 < param1 ) then
			tempTxt = PAGetStringParam2( Defines.StringSheet_GAME, "LUA_GUILD_TEXT_GUILD_PENALTIES", "tempTxt", tempTxt, "money", tostring(param1) ) -- tempTxt .."(위약금:" ..tostring(parma1)..")"
		end
		
		Proc_ShowMessage_Ack( tempTxt ) 

	elseif( 8 == notifyType ) then	
		local tempTxt = PAGetStringParam1( Defines.StringSheet_GAME, "LUA_GUILD_TEXT_GUILD_FIRE", "userNickName", userNickName ) -- userNickName .. "님이 추방되었습니다."
		if( 0 < param1 ) then
			tempTxt = PAGetStringParam2( Defines.StringSheet_GAME, "LUA_GUILD_TEXT_GUILD_BONUS", "tempTxt", tempTxt, "money", tostring(param1) ) -- tempTxt .."(위로금:" ..tostring(param1)..")"		
		end
		
		Proc_ShowMessage_Ack( tempTxt ) 
	
	elseif( 9 == notifyType ) then	
	
		Proc_ShowMessage_Ack( PAGetString(Defines.StringSheet_GAME, "LUA_GUILD_TEXT_GUILD_UPGRADES") ); -- "길드가 승급하였습니다"
	
	elseif( 10 == notifyType ) then -- 활동량 변경
		
		--
	
	elseif( 11 == notifyType ) then
	
		local text = ""
		if( 1 == param3 ) then
			text = PAGetStringParam1( Defines.StringSheet_GAME, "LUA_GUILD_TEXT_GUILD_BESTMONEY", "money", tostring( param1 ) ) -- tostring( param1 ).. "실버에 길드 하우스를 최고가로 입찰하였습니다.";
		else
			text = PAGetStringParam1( Defines.StringSheet_GAME, "LUA_GUILD_TEXT_GUILD_NOTBESTMONEY", "money", tostring( param1 ) ) -- tostring( param1 ).. "실버에 길드 하우스를 입찰했지만 최고가가 아닙니다.";
		end
		
		Proc_ShowMessage_Ack( text ); 
		
	elseif( 12 == notifyType ) then
		
		local text;
		if( 1 == param1 ) then
			text = PAGetString(Defines.StringSheet_GAME, "LUA_GUILD_TEXT_GUILD_BIDCANCEL") --"길드 하우스를 입찰금을 회수하였습니다.";
		else
			text = PAGetString(Defines.StringSheet_GAME, "LUA_GUILD_TEXT_GUILD_BIDSUCCESS") --"길드 하우스 경매에 낙찰되었습니다.";
		end
	
		Proc_ShowMessage_Ack( text ); 

	elseif( 13 == notifyType ) then
		
		-- 길드 상점이 열려있는 경우 업데이트
		if Panel_Window_NpcShop:IsShow() then
			NpcShop_UpdateContent();
			return;
		end

	elseif( 14 == notifyType ) then
		
		Proc_ShowMessage_Ack( PAGetString(Defines.StringSheet_GAME, "LUA_GUILD_TEXT_GUILD_INCENTIVE") ); -- '길드 인센티브가 지급되었습니다. 잠시후 우편으로 받으실수 있습니다.'

	elseif( 15 == notifyType ) then
		
		local tempTxt = PAGetStringParam1( Defines.StringSheet_GAME, "LUA_GUILD_TEXT_GUILD_PAYMENTS", "typeMoney", tostring(param2) ) -- tostring(param2)..' 납부'
		if( 0 ~= param1 ) then
			tempTxt = PAGetStringParam1( Defines.StringSheet_GAME, "LUA_GUILD_TEXT_GUILD_UNPAID", "typeMoney", tostring(param2) ) -- tostring(param2)..' 미납'
		end
		
		Proc_ShowMessage_Ack( PAGetStringParam1( Defines.StringSheet_GAME, "LUA_GUILD_TEXT_GUILD_HOUSECOSTS", "tempTxt", tempTxt ) ) -- '길드 하우스 유지비용 ' ..tempTxt.. '되었습니다'
	elseif( 16 == notifyType ) then
		
		local text = ""
		if( 0 == param1 ) then
			text = PAGetStringParam1(Defines.StringSheet_GAME, "LUA_GUILD_CREATE_CLAN", "name", userNickName )
		else
			text = PAGetStringParam1(Defines.StringSheet_GAME, "LUA_GUILD_CREATE_GUILD", "name", userNickName )
		end
		
		Proc_ShowMessage_Ack( text ) 		
	
	elseif( 17 == notifyType ) then
		
		Proc_ShowMessage_Ack( "길드 퀘스트 수락하였습니다." ); 		
		
	elseif( 18 == notifyType ) then
		
		Proc_ShowMessage_Ack( "길드 퀘스트를 완료하였습니다." ); 		
		
	elseif( 19 == notifyType ) then	
		
		local regionInfoWrapper = getRegionInfoWrapper(param2)
		if( nil == regionInfoWrapper ) then
			_PA_ASSERT(false, "성주가 마을세금을 수금했는데 마을 정보가 없습니다.");
			return;
		end
		
		local text = PAGetStringParam2( Defines.StringSheet_GAME, "LUA_GUILD_LORD_MOVETAX_TO_GUILDMONEY", "region", regionInfoWrapper:getAreaName(), "silver", makeDotMoney(s64_param1) )
		--local text = "성주가 " ..regionInfoWrapper:getAreaName().."에서 "..makeDotMoney(s64_param1).."실버를 길드자금으로 수령했습니다"
		
		Proc_ShowMessage_Ack( text ); 
	elseif( 20 == notifyType  )then	
		
		local text = PAGetStringParam1(Defines.StringSheet_GAME, "LUA_GUILD_MEMBER_PK_DO", "username", userNickName )
		
		Proc_ShowMessage_Ack( text );
		
	elseif( 21 == notifyType  )then	
		
		if( param3 == 1 ) then -- 응전했다.
			
			--local text = "길드전에서 응전시 성향치 감소와 길드자금의 감소는 없습니다."
			local text = PAGetString( Defines.StringSheet_GAME, "LUA_GUILD_ACCEPT_BATTLE_NO_RESOURCE" );
			Proc_ShowMessage_Ack( text );			
			
		else
			local tendency = param1
			local text = PAGetStringParam1( Defines.StringSheet_GAME, "LUA_GUILD_DECLARE_WAR_CONSUME", "silver", makeDotMoney(s64_param2) )
			Proc_ShowMessage_Ack( text );			
		end

	elseif( 22 == notifyType  )then

	elseif( 23 == notifyType  )then
		
	end
	
	-- 열려있다면 업데이트
	FromClient_ResponseGuildUpdate();
	
end

function FromClient_NotifyGuildMessage( msgType, strParam1, strParam2, s64_param1, s64_param2, s64_param3 )
	--[[ msgType에 따른 설명
	0 : 나 자신의 탈퇴, param1:길드등급
	1 : 길드원의 탈퇴, strParam1:유져닉네임, param1:길드 등급
	2 : 내가 가입
	3 : 다른이가 가입
	4 : 길드 해산
	5 : 추방 strParam1:유져닉네임, strParam2:길드이름, param1:길드 등급, param2:0(나),1(다른길드원)
	6 : 길드원 가입 가능 인원 증가 param1:이전 카운트, parma2: 현재 카운트, param3 :증가된 값
	7 : 길드원 로그인/로그아웃, strParam1:유져닉네임, strParam2:가문명, param1:0(로그인),1(로그아웃)
	8 : 연합원 로그인/로그아웃, strParam1:유져닉네임, strParam2:가문명, param1:0(로그인),1(로그아웃)
	]]--
	
	local param1 = Int64toInt32(s64_param1)
	local param2 = Int64toInt32(s64_param2)
	local param3 = Int64toInt32(s64_param3)

	if( 0  == msgType ) then 
		
		local	message	= "" 
		if(  0 == param1 ) then
			message =	PAGetString(Defines.StringSheet_GAME, "GAME_MESSAGE_CLAN_OUT")
		else
			message =	PAGetString(Defines.StringSheet_GAME, "GAME_MESSAGE_GUILD_OUT")
		end
		
		Proc_ShowMessage_Ack( message )
		
	elseif( 1 == msgType ) then
		
		local	message	= "" 
		if(  0 == param1 ) then
			message = PAGetStringParam1(Defines.StringSheet_GAME, "GAME_MESSAGE_CLANMEMBER_OUT", "familyName", strParam1 )
		else
			message = PAGetStringParam1(Defines.StringSheet_GAME, "GAME_MESSAGE_GUILDMEMBER_OUT", "familyName", strParam1 )
		end
		Proc_ShowMessage_Ack( message )
	
	elseif( 2 == msgType ) then
	
		local	message	= "" 
		if( 0 == param1 ) then
			message = PAGetStringParam1(Defines.StringSheet_GAME, "LUA_GUILD_JOIN_GUILD", "name", strParam1 )
		else
			message = PAGetStringParam1(Defines.StringSheet_GAME, "LUA_GUILD_JOIN_GUILD", "name", strParam1 )
		end
	
		Proc_ShowMessage_Ack( message )
		
	elseif( 3 == msgType ) then
	
		local	message	= "" 
		if( 0 == param1 ) then
			message = PAGetStringParam1(Defines.StringSheet_GAME, "LUA_GUILD_WHO_JOIN_CLAN", "name", strParam1 )
		else
			message = PAGetStringParam1(Defines.StringSheet_GAME, "LUA_GUILD_WHO_JOIN_GUILD", "name", strParam1 )
		end
	
		Proc_ShowMessage_Ack( message )
	
	elseif( 4 == msgType ) then
	
		local	message	= "" 
		if( 0 == param1 ) then
			message = PAGetStringParam1(Defines.StringSheet_GAME, "LUA_GUILD_DISPERSE_CLAN_MSG", "name", strParam1 )
		else
			message = PAGetStringParam1(Defines.StringSheet_GAME, "LUA_GUILD_DISPERSE_GUILD_MSG", "name", strParam1 )
		end
	
		Proc_ShowMessage_Ack( message )
		
	elseif( 5 == msgType ) then
	
		local textGrade = ""
		if( 0 == param1 ) then
			textGrade = PAGetString(Defines.StringSheet_GAME, "LUA_GUILD_TEXT_CLAN") -- "클랜"
		else
			textGrade = PAGetString(Defines.StringSheet_GAME, "LUA_GUILD_TEXT_GUILD") -- "길드"
		end
		
		local	message	= "" 
		if( 0 == param2 ) then -- 나
			--message = PAGetStringParam1(Defines.StringSheet_GAME, "LUA_GUILD_EXPEL_SELF", "guild", textGrade )
			message = PAGetStringParam1(Defines.StringSheet_GAME, "LUA_GUILD_EXPEL_SELF", "guild", strParam2 )
		else -- 다른길드원
			--message = PAGetStringParam2(Defines.StringSheet_GAME, "LUA_GUILD_EXPEL_OTHER", "name", strParam1, "guild", textGrade )
			message = PAGetStringParam2(Defines.StringSheet_GAME, "LUA_GUILD_EXPEL_OTHER", "name", strParam1, "guild", strParam2 )
		end
			
		Proc_ShowMessage_Ack( message )
		
	elseif( 6 == msgType ) then

		-- _PA_LOG("유흥신", "6 == msgType param1 param2" .. param1.." ".. param2 )
	
		local message = ""
		if( param1 <= 30 and 30 < param2 ) then
			message = PAGetStringParam2(Defines.StringSheet_GAME, "LUA_GUILD_COMPORATETAX_GUILDMEMBERCOUNT", "membercount", "30", "silver", "10만")
		elseif ( param1 <= 50 and 50 < param2 ) then
			message = PAGetStringParam2(Defines.StringSheet_GAME, "LUA_GUILD_COMPORATETAX_GUILDMEMBERCOUNT", "membercount", "50", "silver", "25만")
		elseif ( param1 <= 75 and 75 < param2 ) then
			message = PAGetStringParam2(Defines.StringSheet_GAME, "LUA_GUILD_COMPORATETAX_GUILDMEMBERCOUNT", "membercount", "75", "silver", "50만")
		else
			message =  PAGetStringParam1(Defines.StringSheet_GAME, "LUA_GUILD_INCREASE_GUILDMEMBERCOUNT", "membercount", param2 )
			--message = "길드 가입 최대 인원이 " .. tostring(param2) .."명으로 증가되었습니다"
		end
		
		Proc_ShowMessage_Ack( message )
		
	elseif( 7 == msgType ) then
	
		local message = ""
		local characterName = strParam1
		local userNickName = strParam2
		
		if true == guildLoginMsg then
			if 0 == param1 then
				message = PAGetStringParam2(Defines.StringSheet_GAME, "GAME_MESSAGE_LOGIN_GUILD_MEMBER", "familyName", userNickName, "characterName", characterName)
			elseif 1 == param1 then
				message = PAGetStringParam2(Defines.StringSheet_GAME, "GAME_MESSAGE_LOGOUT_GUILD_MEMBER", "familyName", userNickName, "characterName", characterName)
			end
			
			Proc_ShowMessage_Ack( message )
		end
		
		
	elseif ( 8 == msgType ) then
	
		local message = ""
		local characterName = strParam1
		local userNickName = strParam2
		
		if 0 == param1 then
			message = PAGetString(Defines.StringSheet_GAME, "GAME_MESSAGE_LOGIN_GUILD_ALLIANCE_MEMBER").." "..userNickName.." "..characterName
		elseif 1 == param1 then
			message = PAGetString(Defines.StringSheet_GAME, "GAME_MESSAGE_LOGOUT_GUILD_ALLIANCE_MEMBER").." "..userNickName.." "..characterName
		end
		
		Proc_ShowMessage_Ack( message )
	
	end
	

end

function FromClient_ResponseGuildInviteForGuildGrade( targetActorKeyRaw, targetName )
	
	local myGuildInfo = ToClient_GetMyGuildInfoWrapper();
	if( nil == myGuildInfo ) then
		_PA_ASSERT( false, "ResponseGuildInviteForGuildGrade 에서 길드 정보가 없습니다.");
		return;
	end
	
	local guildGrade	= myGuildInfo:getGuildGrade()
	
	-- 클랜
	if( 0 == guildGrade ) then
		
		toClient_RequestInviteGuild( targetActorKeyRaw, 0, 0, 0)
	
	else -- 길드 
		
		FGlobal_AgreementGuild_Master_Open_ForJoin( targetActorKeyRaw, targetName )
	
	end
	
end


function SetDATAByGuildGrade()
	local myGuildInfo	= ToClient_GetMyGuildInfoWrapper()
	if nil == myGuildInfo then
		-- _PA_ASSERT(false, "자신의 길드 정보가 없습니다.");
		return;
	end
	
	local guildGrade	= myGuildInfo:getGuildGrade()
	
	local memberData	= nil;
	local memberCount	= myGuildInfo:getMemberCount()
	for memberIdx = 0, memberCount - 1 do
		memberData	= myGuildInfo:getMember( memberIdx )
		if( memberData:isSelf() ) then
			break;
		end
	end
	if( nil == memberData ) then
		-- _PA_ASSERT(false, "자신의 길드 멤버 정보가 없습니다.");
		return;
	end
	
	if 0 == guildGrade then
		GuildManager.mainBtn_Info:SetEnable( true )
		GuildManager.mainBtn_History:SetEnable( false )
		GuildManager.mainBtn_Quest:SetEnable( false )
		GuildManager.mainBtn_Tree:SetEnable( false )
		GuildManager.mainBtn_Warfare:SetEnable( false )
		GuildInfoPage._btnChangeMark:SetEnable( false )
		GuildLetsWarPage._btnLetsWarDoWar:SetEnable( false )
		GuildLetsWarPage._editLetsWarInputName:SetEnable( false )

		GuildManager.mainBtn_Info:SetMonoTone( false )
		GuildManager.mainBtn_History:SetMonoTone( true )
		GuildManager.mainBtn_Quest:SetMonoTone( true )
		GuildManager.mainBtn_Tree:SetMonoTone( true )
		GuildManager.mainBtn_Warfare:SetMonoTone( true )
		GuildInfoPage._btnChangeMark:SetMonoTone( true )
		GuildLetsWarPage._btnLetsWarDoWar:SetMonoTone( true )
		GuildLetsWarPage._editLetsWarInputName:SetMonoTone( true )

		GuildInfoPage._btnTaxPayment:SetShow( false )
		GuildInfoPage._txtUnpaidTax:SetShow( false )
		GuildInfoPage._btnIncreaseMember:SetShow( false )

		GuildListInfoPage._btnPaypal:SetShow( false )
		GuildListInfoPage._btnGiveIncentive:SetShow( false )
		GuildListInfoPage._btnDeposit:SetShow( false )
		GuildListInfoPage._textBusinessFunds:SetShow( false )
		GuildListInfoPage._textBusinessFundsBG:SetShow( false )

		GuildListInfoPage.decoIcon_Guild:SetShow( false )
		GuildListInfoPage.decoIcon_Clan:SetShow( true )

		GuildInfoPage._windowTitle:SetText( PAGetString(Defines.StringSheet_GAME, "LUA_GUILD_TEXT_GUILD_CLANNAME") ) -- "클   랜"
		GuildInfoPage._textGuildInfoTitle:SetText( PAGetString(Defines.StringSheet_GAME, "LUA_GUILD_TEXT_GUILD_CLANINFO") ) -- "- 클랜 정보"
		GuildInfoPage._txtGuildName:SetText( PAGetString(Defines.StringSheet_GAME, "LUA_GUILD_TEXT_GUILD_CLANNAMING") ) -- "클랜명"

	else
		GuildManager.mainBtn_Info:SetEnable( true )
		GuildManager.mainBtn_History:SetEnable( true )
		GuildManager.mainBtn_Quest:SetEnable( true )
		GuildManager.mainBtn_Tree:SetEnable( true )
		GuildManager.mainBtn_Warfare:SetEnable( true )
		GuildInfoPage._btnChangeMark:SetEnable( true )
		GuildLetsWarPage._btnLetsWarDoWar:SetEnable( true )
		GuildLetsWarPage._editLetsWarInputName:SetEnable( true )

		GuildManager.mainBtn_Info:SetMonoTone( false )
		GuildManager.mainBtn_History:SetMonoTone( false )
		GuildManager.mainBtn_Quest:SetMonoTone( false )
		GuildManager.mainBtn_Tree:SetMonoTone( false )
		GuildManager.mainBtn_Warfare:SetMonoTone( false )
		GuildInfoPage._btnChangeMark:SetMonoTone( false )
		GuildListInfoPage._btnDeposit	:SetMonoTone( true )
		GuildLetsWarPage._btnLetsWarDoWar:SetMonoTone( false )
		GuildLetsWarPage._editLetsWarInputName:SetMonoTone( false )

		local accumulateTax_s32		= Int64toInt32( myGuildInfo:getAccumulateTax() )
		local accumulateCost_s32	= Int64toInt32( myGuildInfo:getAccumulateGuildHouseCost() )
		local businessFunds_s32		= Int64toInt32( myGuildInfo:getGuildBusinessFunds() )
		if (0 < accumulateTax_s32) or (0 < accumulateCost_s32) then
			GuildInfoPage._txtUnpaidTax		:SetShow( true )
			if ( businessFunds_s32 < accumulateTax_s32 ) or ( businessFunds_s32 < accumulateCost_s32 ) then
				GuildListInfoPage._btnDeposit	:SetMonoTone( false )
				GuildListInfoPage._btnDeposit	:SetEnable( true )
			else
				GuildListInfoPage._btnDeposit	:SetMonoTone( true )
				GuildListInfoPage._btnDeposit	:SetEnable( false )
			end
		else
			GuildInfoPage._txtUnpaidTax		:SetShow( false )
			GuildListInfoPage._btnDeposit	:SetMonoTone( true )
			GuildListInfoPage._btnDeposit	:SetEnable( false )
		end

		if getSelfPlayer():get():isGuildMaster() then
			GuildWarInfoPage._txtWarInfoTitle	:SetSpanSize( 40, 422 )
			GuildInfoPage._btnIncreaseMember	:SetShow( true )
			if (0 < accumulateTax_s32) or (0 < accumulateCost_s32)  then
				GuildInfoPage._btnTaxPayment:SetShow( true )
			else
				GuildInfoPage._btnTaxPayment		:SetShow( false )
			end
			
			if 0 < GuildManager._haveSiegeCount then
				GuildListInfoPage._btnGiveIncentive	:SetShow( true )
			else
				GuildListInfoPage._btnGiveIncentive	:SetShow( false )
			end

		elseif getSelfPlayer():get():isGuildSubMaster() then
			GuildWarInfoPage._txtWarInfoTitle	:SetSpanSize( 40, 232 )
			GuildInfoPage._btnIncreaseMember	:SetShow( false )
			GuildInfoPage._btnTaxPayment		:SetShow( false )
			GuildListInfoPage._btnGiveIncentive	:SetShow( false )
		else
			GuildWarInfoPage._txtWarInfoTitle	:SetSpanSize( 40, 232 )
			GuildInfoPage._btnIncreaseMember	:SetShow( false )
			GuildInfoPage._btnTaxPayment		:SetShow( false )
			GuildListInfoPage._btnGiveIncentive	:SetShow( false )
		end

		if memberData:isCollectableBenefit() and ( false == memberData:isFreeAgent() ) then
			GuildListInfoPage._btnPaypal:SetEnable( true )
			GuildListInfoPage._btnPaypal:SetMonoTone( false )
			-- 수금 가능한 상태인데, 길드 자금이 없다면.
			if 0 == businessFunds_s32 then
				GuildListInfoPage._btnPaypal:SetFontColor( UI_color.C_FFF26A6A )
			else
				GuildListInfoPage._btnPaypal:SetFontColor( UI_color.C_FFC4A68A )
			end
		else
			GuildListInfoPage._btnPaypal:SetEnable( false )
			GuildListInfoPage._btnPaypal:SetMonoTone( true )
		end

		GuildListInfoPage._btnPaypal:SetShow( true )
		GuildListInfoPage._textBusinessFunds:SetShow( true )
		GuildListInfoPage._textBusinessFundsBG:SetShow( true )

		GuildListInfoPage.decoIcon_Guild:SetShow( true )
		GuildListInfoPage.decoIcon_Clan:SetShow( false )

		GuildInfoPage._windowTitle:SetText( PAGetString(Defines.StringSheet_GAME, "LUA_GUILD_TEXT_GUILD_GUILDNAME") ) -- "길   드"
		GuildInfoPage._textGuildInfoTitle:SetText( PAGetString(Defines.StringSheet_GAME, "LUA_GUILD_TEXT_GUILD_GUILDINFO") ) -- "- 길드 정보"
		GuildInfoPage._txtGuildName:SetText( PAGetString(Defines.StringSheet_GAME, "LUA_GUILD_TEXT_GUILD_GUILDNAMING") ) -- "길드명"
	end
end

function FGlobal_GuildLogin( isShow )
	guildLoginMsg = isShow
end

----------------------------------------------------------------------------------------------------------------
--									클라이언트에서 보내는 이벤트
----------------------------------------------------------------------------------------------------------------
registerEvent("FromClient_ResponseGuildUpdate", 		"FromClient_ResponseGuildUpdate")
registerEvent("ResponseGuild_invite",					"FromClient_ResponseGuild_invite");
registerEvent("ResponseGuild_refuse", 					"FromClient_ResponseGuild_refuse");
registerEvent("ResponseGuildAlliance_invite",			"FromClient_ResponseGuildAlliance_invite");
registerEvent("ResponseGuildAlliance_refuse",			"FromClient_ResponseGuildAlliance_refuse");
registerEvent("EventChangeGuildInfo",					"FromClient_EventActorChangeGuildInfo" )
registerEvent("FromClient_UpdateGuildContract", 		"FromClient_ResponseUpdateGuildContract");
registerEvent("FromClient_NotifyGuildMessage", 			"FromClient_NotifyGuildMessage");
registerEvent("FromClient_GuildInviteForGuildGrade",	"FromClient_ResponseGuildInviteForGuildGrade");


-- registerEvent("FromClient_KingOrLordTentDestroy", 			"FromClient_KingOrLordTentDestroy")
-- registerEvent("FromClient_NotifyAttackedKingOrLordTent",		"NotifyAttackedKingOrLoadTent");
-- registerEvent("FromClient_KingOrLordTentCountUpdate",		"NotifyKingOrLoadTentCountUpdate");
