-- local UI_PUCT		= CppEnums.PA_UI_CONTROL_TYPE
local UI_TM			= CppEnums.TextMode

Panel_MyHouseNavi:RegisterShowEventFunc( true,	'MyHouseNaviShowAni()' )
Panel_MyHouseNavi:RegisterShowEventFunc( false,	'MyHouseNaviHideAni()' )

function	MyHouseNaviShowAni()
	UIAni.fadeInSCR_Down(Panel_MyHouseNavi)
end

function	MyHouseNaviHideAni()
	Panel_MyHouseNavi:SetShowWithFade(CppEnums.PAUI_SHOW_FADE_TYPE.PAUI_ANI_TYPE_FADE_OUT)
	local aniInfo1 = Panel_MyHouseNavi:addColorAnimation( 0.0, 0.22, UI_ANI_ADV.PAUI_ANIM_ADVANCE_SIN_HALF_PI)
	aniInfo1:SetStartColor( UI_color.C_FFFFFFFF )
	aniInfo1:SetEndColor( UI_color.C_00FFFFFF )
	aniInfo1:SetStartIntensity( 3.0 )
	aniInfo1:SetEndIntensity( 1.0 )
	aniInfo1.IsChangeChild = true
	aniInfo1:SetHideAtEnd(true)
	aniInfo1:SetDisableWhileAni(true)
end

local isCheckTentPosition = false
local isCheckHousePosition = false

----------------------------------------------------------------------------------------------------------------
----------------------------------------------------------------------------------------------------------------
local _houseIcon			= UI.getChildControl ( Panel_MyHouseNavi, "Static_Icon_House" )					-- 주거지 아이콘
local _houseBorder			= UI.getChildControl ( Panel_MyHouseNavi, "Static_SlotBackground" )
local _tentIcon				= UI.getChildControl ( Panel_MyHouseNavi, "Static_Icon_Tent" )					-- 텐트 아이콘
local _tentBorder			= UI.getChildControl ( Panel_MyHouseNavi, "Static_SlotBackground_Tent" )
local _territoryIcon		= UI.getChildControl ( Panel_MyHouseNavi, "Static_Icon_TerritoryAuth" )			-- 황실무역 아이콘
local _territoryBorder		= UI.getChildControl ( Panel_MyHouseNavi, "Static_SlotBackground_TerritoryAuth" )
local _helpTooltip			= UI.getChildControl ( Panel_MyHouseNavi, "StaticText_Helper" )					-- 마우스오버 도움말
----------------------------------------------------------------------------------------------------------------
----------------------------------------------------------------------------------------------------------------

-----------------------------------------------
--		패널은 이제 켜두지 않는다!!
-----------------------------------------------
Panel_MyHouseNavi	:SetShow( false )
_houseIcon			:SetShow( false )
_tentIcon			:SetShow( false )
_territoryIcon		:SetShow( false )
_houseIcon			:SetIgnore( true )
_tentIcon			:SetIgnore( true )
_territoryIcon		:SetIgnore( true )
_houseBorder		:SetShow( false )
_tentBorder			:SetShow( false )
_territoryBorder	:SetShow( false )
_helpTooltip		:SetShow( false )

------------------------------------------------
-- 초기 설정
------------------------------------------------
local posY, posX
local Panel_MyHouseNavi_Init = function()
	posY = Panel_SelfPlayerExpGage:GetPosY() + Panel_SelfPlayerExpGage:GetSizeY() + 10
	posX = 0
	if Panel_Window_Servant:GetShow() then
		posX = Panel_Window_Servant:GetPosX() + Panel_Window_Servant:GetSizeX() + 10
	else
		posX = 10
	end
	Panel_MyHouseNavi:SetPosX( posX )
	Panel_MyHouseNavi:SetPosY( posY )
end


function Panel_MyHouseNavi_Update( init )
	if nil == init and Defines.UIMode.eUIMode_Default ~= GetUIMode() then	-- 기본 게임모드에서만 아이콘이 나타난다!
		return
	end

	if isFlushedUI() then
		return
	end

	if ( ToClient_IsHaveDwelling() 	-- 집이 있거나, 황실무역인데, 창이 꺼져있으면 켠다.
		or ( isHaveTerritoryTradeAuthority(0) or isHaveTerritoryTradeAuthority(1) or isHaveTerritoryTradeAuthority(2) or isHaveTerritoryTradeAuthority(3) )  )
		and ( not Panel_MyHouseNavi:GetShow() ) then
		Panel_MyHouseNavi:SetShow( true, true )
	end
	
	local iconNums = 0
	------------------------------------------------------------
	--				주거지가 있을 경우 체크
	local isHaveDwelling = ToClient_IsHaveDwelling()
	local panelSizeX = 0
	if ( isHaveDwelling == true ) then
		_houseIcon	:SetShow( true )
		_houseIcon	:SetIgnore( false )
		_houseIcon	:ActiveMouseEventEffect( true )

		_houseBorder:SetShow( true )
		_houseBorder:SetIgnore( true )

		_houseIcon	:addInputEvent( "Mouse_RUp", "Panel_MyHouseNavi_FindWay( \"selfHouse\")" )
		_houseIcon	:addInputEvent( "Mouse_On", "HandleMouseOnSimpleToolTip( \"selfHouse\", true )" )
		_houseIcon	:addInputEvent( "Mouse_Out", "HandleMouseOnSimpleToolTip( \"selfHouse\", false )" )

		panelSizeX = panelSizeX + _houseBorder:GetSizeX()	-- 패널 사이즈를 더한다.
		iconNums = iconNums + 1
	else
		_houseIcon	:SetShow( false )
		_houseIcon	:SetIgnore( true )
		_houseIcon	:ActiveMouseEventEffect( false )

		_houseBorder:SetShow( false )
		_houseBorder:SetIgnore( true )
	end

	-- 황실 무역 아이콘
	-- 영지 번호 : 0(발레노스), 1(세렌디아), 2(칼페온), 3(메디아)
	
	if isHaveTerritoryTradeAuthority(0) or 
		isHaveTerritoryTradeAuthority(1) or 
		isHaveTerritoryTradeAuthority(2) or 
		isHaveTerritoryTradeAuthority(3) then

		_territoryIcon	:SetShow( true )
		_territoryIcon	:SetIgnore( false )
		_territoryIcon	:ActiveMouseEventEffect( true )

		_territoryBorder:SetShow( true )
		_territoryBorder:SetIgnore( true )

		_territoryIcon	:addInputEvent( "Mouse_On", "HandleMouseOnSimpleToolTip( \"territoryAuth\", true )" )
		_territoryIcon	:addInputEvent( "Mouse_Out", "HandleMouseOnSimpleToolTip( \"territoryAuth\", false )" )
		
		panelSizeX = panelSizeX + _territoryBorder:GetSizeX() + 5	-- 패널 사이즈를 더한다.
		
		-- 포지션 잡아준다
		if ( 0 == iconNums ) then
			_territoryBorder	:SetPosX( _houseBorder:GetPosX() )
			_territoryIcon		:SetPosX( _houseIcon:GetPosX() )
		elseif ( 1 == iconNums ) then
			_territoryBorder	:SetPosX( _houseBorder:GetPosX()	+ _houseBorder:GetSizeX()	+ 5 )
			_territoryIcon		:SetPosX( _houseIcon:GetPosX()		+ _houseIcon:GetSizeX()		+ 7 )
		elseif ( 2 == iconNums ) then
			_territoryBorder	:SetPosX( _tentBorder:GetPosX()		+ _houseBorder:GetSizeX()	+ 5 )
			_territoryIcon		:SetPosX( _tentIcon:GetPosX()		+ _houseIcon:GetSizeX()		+ 7 )
		end
		
	else
		_territoryIcon	:SetShow( false )
		_territoryIcon	:SetIgnore( true )
		_territoryIcon	:ActiveMouseEventEffect( false )

		_territoryBorder:SetShow( false )
		_territoryBorder:SetIgnore( true )
	end
	--]]--
	
	if 0 == panelSizeX then
		panelSizeX = 54
	end
	
	Panel_MyHouseNavi:SetSize( panelSizeX, Panel_MyHouseNavi:GetSizeY())

	--if (not isHaveDwelling) and (not tentCheck) then
	--if (not isHaveDwelling) and (not tentCheck) and (false == _territoryIcon:GetShow()) then
		--Panel_MyHouseNavi:SetShow( false, false )
	--else
		--Panel_MyHouseNavi:SetShow( true, true )
	--end	
end

function return_ServantIconNums( icons )							-- Panel_Window_Servant.lua로부터 서번트 아이콘 갯수 넘겨 받음
	if ( 0 == icons ) then
		Panel_MyHouseNavi:SetPosX( 10 )
		Panel_MyHouseNavi:SetPosY( posY )
	elseif ( 1 == icons ) then
		Panel_MyHouseNavi:SetPosX( 75 )
		Panel_MyHouseNavi:SetPosY( posY )
	elseif ( 2 == icons ) then
		Panel_MyHouseNavi:SetPosX( 130 )
		Panel_MyHouseNavi:SetPosY( posY )
	else
		Panel_MyHouseNavi:SetPosX( 195 )
		Panel_MyHouseNavi:SetPosY( posY )
	end
end

-------------------------------------------------------
--				마우스 오버시 도움말 툴팁
-------------------------------------------------------
function HandleMouseOnSimpleToolTip( naviType, isShow )
	-- ♬ 집 아이콘에 마우스 올려놨을 때 Over Sound
	audioPostEvent_SystemUi(00, 13)

	if ( naviType == "selfHouse" ) then	
		local characterStaticStatusWrapper = ToClient_getMyDwelling()
		if nil == characterStaticStatusWrapper then
			return
		end
		local houseName = characterStaticStatusWrapper:getName()
		
		--_helpTooltip:SetTextMode( UI_TM.eTextMode_AutoWrap )
		name		= PAGetString(Defines.StringSheet_GAME, "LUA_HOUSECONTROL_TYPENAME_MYHOUSE") -- 주거지
		desc		= PAGetString( Defines.StringSheet_GAME, "LUA_MYHOUSENAVI_HOUSE" ) .. "\n" .. "(" .. houseName .. ")" 
		uiControl	= _houseIcon
		
	elseif ( naviType == "tent" ) then -- 텃밭 위치
		name		= PAGetString(Defines.StringSheet_GAME, "LUA_MYHOUSENAVI_GARDEN") -- 텃밭
		desc		= PAGetString( Defines.StringSheet_GAME, "LUA_MYHOUSENAVI_TENT" ) -- 우클릭 : 텃밭 위치 찾기
		uiControl	= _tentIcon

	elseif ( naviType == "territoryAuth" ) then -- 황실무역
		local territoryName = {
			[0]	= tostring(PAGetString(Defines.StringSheet_GAME, "LUA_TERRITORYAUTHORITY_KEY_0")),		-- 발레노스
			[1] = tostring(PAGetString(Defines.StringSheet_GAME, "LUA_TERRITORYAUTHORITY_KEY_1")),		-- 세렌디아
			[2] = tostring(PAGetString(Defines.StringSheet_GAME, "LUA_TERRITORYAUTHORITY_KEY_2")),		-- 칼페온
			[3] = tostring(PAGetString(Defines.StringSheet_GAME, "LUA_TERRITORYAUTHORITY_KEY_3")),		-- 메디아
		}
		local _tooltiptxt = ""
		local terrAuth_Count = 0
		
		for territoryIndex = 0, 3 do
			if ( true == isHaveTerritoryTradeAuthority(territoryIndex) ) then
				if ( 0 == terrAuth_Count ) then
					_tooltiptxt = territoryName[territoryIndex]
				else
					_tooltiptxt = _tooltiptxt .. " / " .. territoryName[territoryIndex]
				end
				terrAuth_Count = terrAuth_Count + 1
			end
		end
		name = PAGetString(Defines.StringSheet_GAME, "LUA_MYHOUSENAVI_GOLDTRADE") -- 황실무역
		desc = _tooltiptxt .. PAGetString(Defines.StringSheet_GAME, "LUA_TERRITORYAUTHORITY_KEY_4")
		uiControl = _territoryIcon
	end

	if true == isShow then
		TooltipSimple_Show( uiControl, name, desc )
	else
		TooltipSimple_Hide()
	end
end


--------------------------------------------------------
--				길 찾기용 함수임
--------------------------------------------------------
function Panel_MyHouseNavi_FindWay( naviType )

	if ( isCheckTentPosition == true ) or ( isCheckHousePosition == true ) then
		ToClient_DeleteNaviGuideByGroup(0);		-- 네비 초기화

		--♬ 길찾기 버튼을 눌러서 취소
		audioPostEvent_SystemUi(00,15)
		
		isCheckTentPosition = false
		isCheckHousePosition = false
		
	----------------------------------
	--		주거지 찾기를 눌렀다
	----------------------------------
	elseif ( naviType == "selfHouse" ) and ( isCheckHousePosition == false ) then
		-- 네비 초기화
		 ToClient_DeleteNaviGuideByGroup(0);

		--♬ 길찾기 버튼을 눌렀당
		audioPostEvent_SystemUi(00,14)
		 
		local characterStaticStatusWrapper = ToClient_getMyDwelling()
		if( nil == characterStaticStatusWrapper ) then
			_PA_ASSERT(false, "주거지 정보가 없습니다.")
			return
		end
		local houseX	= characterStaticStatusWrapper:getObjectStaticStatus():getHousePosX()
		local houseY	= characterStaticStatusWrapper:getObjectStaticStatus():getHousePosY()
		local houseZ	= characterStaticStatusWrapper:getObjectStaticStatus():getHousePosZ()
		local housePos	= float3(houseX, houseY, houseZ)
		
		
		worldmapNavigatorStart( housePos, NavigationGuideParam(), false, false )
		
		isCheckHousePosition = true
	end
end

function Panel_MyHouseNavi_ShowToggle()
	if not ToClient_IsHaveDwelling() and (false == _territoryIcon:GetShow()) then
		return
	end
	
	if	Panel_MyHouseNavi:GetShow()	then
		Panel_MyHouseNavi:SetShow( false, false )
		-- Panel_WidgetControl_Toggle("Panel_MyHouseNavi", false)
	else
		Panel_MyHouseNavi:SetShow( true, true )
		-- Panel_WidgetConeeetrol_Toggle("Panel_MyHouseNavi", true)
	end
end

function PanelMyHouseNavi_RefreshPosition()
	ResetPos_WidgetButton()
end

function Panel_MyHouseNavi_PositionReset()
	local posX = 0
	if Panel_Window_Servant:GetShow() then
		posX = Panel_Window_Servant:GetPosX() + Panel_Window_Servant:GetSizeX() + 10
	else
		posX = 10
	end
	Panel_MyHouseNavi:SetPosX( posX )
	Panel_MyHouseNavi:SetPosY( Panel_SelfPlayerExpGage:GetPosY() + Panel_SelfPlayerExpGage:GetSizeY() + 10 )
	
	changePositionBySever(Panel_MyHouseNavi, CppEnums.PAGameUIType.PAGameUIPanel_MyHouseNavi, true, true, false)
end

function Panel_MyHouseNavi:registEventHandler()
	Panel_MyHouseNavi:addInputEvent( "Mouse_PressMove",	"PanelMyHouseNavi_RefreshPosition()" )
	Panel_MyHouseNavi:addInputEvent( "Mouse_LUp",		"ResetPos_WidgetButton()" )
end

Panel_MyHouseNavi_Init()
Panel_MyHouseNavi_Update( true )
Panel_MyHouseNavi:registEventHandler()

changePositionBySever(Panel_MyHouseNavi, CppEnums.PAGameUIType.PAGameUIPanel_MyHouseNavi, true, true, false)
FGlobal_PanelMove(Panel_MyHouseNavi, true)

function FGlobal_MyHouseNavi_Update()
	Panel_MyHouseNavi_Update( true )
end


registerEvent( "FromClient_ReceiveSetMyHouse",	"Panel_MyHouseNavi_Update" )
registerEvent( "FromClient_ReceiveReturnHouse",	"Panel_MyHouseNavi_Update" )
registerEvent( "FromClient_SetSelfTent",		"Panel_MyHouseNavi_Update" )
registerEvent( "FromClient_ResponseAuctionInfo","Panel_MyHouseNavi_Update" )
registerEvent( "onScreenResize", 				"Panel_MyHouseNavi_PositionReset")

UI.addRunPostRestorFunction( FGlobal_MyHouseNavi_Update )