--
-- 숫자 창 관련
--

Panel_Window_Exchange_Number:SetShow( false, false)
Panel_Window_Exchange_Number:setMaskingChild(true)
Panel_Window_Exchange_Number:ActiveMouseEventEffect(true)
Panel_Window_Exchange_Number:setGlassBackground(true)

Panel_Window_Exchange_Number:RegisterShowEventFunc( true, 'ExchangeNumberShowAni()' )
Panel_Window_Exchange_Number:RegisterShowEventFunc( false, 'ExchangeNumberHideAni()' )

local UI_ANI_ADV = CppEnums.PAUI_ANIM_ADVANCE_TYPE
local UI_PSFT = CppEnums.PAUI_SHOW_FADE_TYPE
local IM = CppEnums.EProcessorInputMode
local VCK = CppEnums.VirtualKeyCode
local UI_color 		= Defines.Color

local numberPad =
{
	MAX_NUMBER_BTN_COUNT  = 10,
	-- maxNumber 와 inputNumber 만 64비트로 사용한다.
	s64_maxNumber =  Defines.s64_const.s64_0,
	s64_inputNumber = Defines.s64_const.s64_0,
	param0		= nil,
	param1		= nil,
	confirmFunction,
	init_Number = false,				-- 최초 키패드 누를시 그 값으로 세팅해준다.
	_buttonNumber = Array.new(),
	numberPadUiModeNotInput = false
}

local numberKeyCode =
{
	VCK.KeyCode_0,			
	VCK.KeyCode_1,	
	VCK.KeyCode_2,	
	VCK.KeyCode_3,	
	VCK.KeyCode_4,	
	VCK.KeyCode_5,	
	VCK.KeyCode_6,	
	VCK.KeyCode_7,	
	VCK.KeyCode_8,	
	VCK.KeyCode_9,
	VCK.KeyCode_NUMPAD0,
	VCK.KeyCode_NUMPAD1,
	VCK.KeyCode_NUMPAD2,
	VCK.KeyCode_NUMPAD3,
	VCK.KeyCode_NUMPAD4,
	VCK.KeyCode_NUMPAD5,
	VCK.KeyCode_NUMPAD6,
	VCK.KeyCode_NUMPAD7,
	VCK.KeyCode_NUMPAD8,
	VCK.KeyCode_NUMPAD9,
}


----------------------------------------------------- -----------------------
-- 컨트롤 및 이벤트
-----------------------------------------------------------------------------
local _textNumber = UI.getChildControl(Panel_Window_Exchange_Number, "Static_DisplayNumber");

local _buttonClose = UI.getChildControl(Panel_Window_Exchange_Number, "Button_Close");
_buttonClose:addInputEvent( "Mouse_LUp", "Panel_NumberPad_ButtonCancel_Mouse_Click()" );

local _buttonCancel = UI.getChildControl(Panel_Window_Exchange_Number, "Button_Cancel");
_buttonCancel:addInputEvent( "Mouse_LUp", "Panel_NumberPad_ButtonCancel_Mouse_Click()" );

local _buttonClear = UI.getChildControl(Panel_Window_Exchange_Number, "Button_Clear");
_buttonClear:addInputEvent( "Mouse_LUp", "Panel_NumberPad_ButtonClear_Mouse_Click()" );

local _buttonBackSpace = UI.getChildControl(Panel_Window_Exchange_Number, "Button_Back");
_buttonBackSpace:addInputEvent( "Mouse_LUp", "Panel_NumberPad_ButtonBackSpace_Mouse_Click()" );

local _buttonConfirm = UI.getChildControl(Panel_Window_Exchange_Number, "Button_Apply");
_buttonConfirm:addInputEvent( "Mouse_LUp", "Panel_NumberPad_ButtonConfirm_Mouse_Click()" );
 

local _buttonAllSelect = UI.getChildControl(Panel_Window_Exchange_Number, "Button_AllSelect")
_buttonAllSelect:addInputEvent( "Mouse_LUp", "Panel_NumberPad_ButtonAllSelect_Mouse_Click()")

-- registerEvent("EventNumberPadShow", 				"Panel_NumberPad_Show" );

----------------------------------------------------------------------------
-- 지역 함수
-----------------------------------------------------------------------------
function numberPad:init()
	for ii=1, numberPad.MAX_NUMBER_BTN_COUNT do
		local btn =  UI.getChildControl(Panel_Window_Exchange_Number, "Button_"  ..(ii-1) );
		btn:addInputEvent( "Mouse_LUp", "Panel_NumberPad_ButtonNumber_Mouse_Click(" ..(ii-1).. ")" );
		numberPad._buttonNumber[ii] = btn;	
	end
	confirmFunction = Panel_NumberPad_Default_ConfirmFunction;	
end

function ExchangeNumberShowAni()
	UIAni.fadeInSCR_Down(Panel_Window_Exchange_Number)
end

function ExchangeNumberHideAni()
	Panel_Window_Exchange_Number:SetShowWithFade(UI_PSFT.PAUI_ANI_TYPE_FADE_OUT)
	local aniInfo1 = Panel_Window_Exchange_Number:addColorAnimation( 0.0, 0.22, UI_ANI_ADV.PAUI_ANIM_ADVANCE_SIN_HALF_PI)
	aniInfo1:SetStartColor( UI_color.C_FFFFFFFF )
	aniInfo1:SetEndColor( UI_color.C_00FFFFFF )
	aniInfo1:SetStartIntensity( 3.0 )
	aniInfo1:SetEndIntensity( 1.0 )
	aniInfo1.IsChangeChild = true
	aniInfo1:SetHideAtEnd(true)
	aniInfo1:SetDisableWhileAni(true)
end

----------------------------------------------------------------------------
-- 이벤트 핸들
-----------------------------------------------------------------------------
function	Panel_NumberPad_Init( param0, confirmFunction, isShow, param1 )
	numberPad.param0			= param0
	numberPad.param1			= param1
	numberPad.confirmFunction	= confirmFunction
	numberPad.init_Number		= true

	_textNumber:SetEditText( tostring(numberPad.s64_inputNumber) );
	_textNumber:SetNumberMode(true)
	
	_buttonConfirm:SetEnable(true)
	_buttonConfirm:SetMonoTone(false)
	
	if (not Panel_Window_Exchange_Number:GetShow()) then	
		Panel_Window_Exchange_Number:SetPosX(getMousePosX())
		Panel_Window_Exchange_Number:SetPosY(getMousePosY())
	end
	
	local keyPadPosY = Panel_Window_Exchange_Number:GetPosY()
	keyPadPosY = keyPadPosY + Panel_Window_Exchange_Number:GetSizeY()
	if keyPadPosY > getScreenSizeY() then
		Panel_Window_Exchange_Number:SetPosY( getScreenSizeY() - Panel_Window_Exchange_Number:GetSizeY() - 30 )
	end
	
	local keyPadPosX = Panel_Window_Exchange_Number:GetPosX()
	keyPadPosX = keyPadPosX + Panel_Window_Exchange_Number:GetSizeX()
	if keyPadPosX > getScreenSizeX() then
		Panel_Window_Exchange_Number:SetPosX( getScreenSizeX() - Panel_Window_Exchange_Number:GetSizeX() )
	end
	if	isShow	then
		Panel_NumberPad_Open()
	end
end
function	Panel_NumberPad_Open()
	if	not Panel_Window_Exchange_Number:IsShow()	then
		Panel_Window_Exchange_Number:SetShow( true, true )
	end
end
function	Panel_NumberPad_Close()
	if Panel_Window_Exchange_Number:IsShow() then
		-- maxNumber 와 inputNumber 만 64비트로 사용한다.
		numberPad.s64_maxNumber		= Defines.s64_const.s64_0
		numberPad.s64_inputNumber	= Defines.s64_const.s64_0
		numberPad.param0			= nil
		numberPad.param1			= nil
		numberPad.confirmFunction	= nil;
		
		Panel_Window_Exchange_Number:SetShow( false, true );	
	end
end

function Panel_NumberPad_Show_Min( isShow, s64_minNumber, param0, confirmFunction, param1 )
	
	if ( not isShow ) then
		Panel_NumberPad_Close()
		UI.Set_ProcessorInputMode(IM.eProcessorInputMode_UiMode)
		ClearFocusEdit()
		if ( numberPad.numberPadUiModeNotInput ) then
			UI.Set_ProcessorInputMode(IM.eProcessorInputMode_UiModeNotInput)
		end
	else
		numberPad.s64_maxNumber		= Defines.s64_const.s64_max
		numberPad.s64_inputNumber	= s64_minNumber
		
		Panel_NumberPad_Init( param0, confirmFunction, true, param1 )
		UI.Set_ProcessorInputMode(IM.eProcessorInputMode_ChattingInputMode)
		SetFocusEdit( _textNumber )
		_textNumber:SetEditText(numberPad.s64_maxNumber)
	end
end

local _isExchange = nil -- 개인 거래의 예외 처리를 위한 임시 변수!
function	Panel_NumberPad_Show( isShow, s64_maxNumber, param0, confirmFunction, isExchange, param1 )
	_isExchange = isExchange -- 개인 거래의 예외 처리를 위한 임시 변수!
	if ( not isShow ) then
		Panel_NumberPad_Close()
		UI.Set_ProcessorInputMode(IM.eProcessorInputMode_UiMode)
		ClearFocusEdit()
		if ( numberPad.numberPadUiModeNotInput ) then
			UI.Set_ProcessorInputMode(IM.eProcessorInputMode_UiModeNotInput)
		end
	else 
		numberPad.s64_maxNumber		= s64_maxNumber
		numberPad.s64_inputNumber	= Defines.s64_const.s64_1

		if( Defines.s64_const.s64_1 == s64_maxNumber ) then
			Panel_NumberPad_Init( param0, confirmFunction, false, param1 )
			Panel_NumberPad_ButtonConfirm_Mouse_Click()
		else
			Panel_NumberPad_Init( param0, confirmFunction, true, param1 )
			UI.Set_ProcessorInputMode(IM.eProcessorInputMode_ChattingInputMode)
			SetFocusEdit( _textNumber )
			_textNumber:SetEditText( "1" )
		end
	end
end

function FGlobal_SetNumberPadUiModeNotInput(isSet)
	numberPad.numberPadUiModeNotInput = isSet
end

function Panel_NumberPad_ButtonClose_Mouse_Click()
	Panel_NumberPad_Show( false, Defines.s64_const.s64_0, 0, nil);
end

function Panel_NumberPad_ButtonCancel_Mouse_Click()
	Panel_NumberPad_Show( false, Defines.s64_const.s64_0, 0, nil);
end

function Panel_NumberPad_ButtonClear_Mouse_Click()
	numberPad.s64_inputNumber = Defines.s64_const.s64_0;
	_textNumber:SetEditText( "0" );
	if _isExchange ~= true then
		_buttonConfirm:SetEnable(false)
		_buttonConfirm:SetMonoTone(true)
	end
end

function Panel_NumberPad_ButtonNumber_Mouse_Click( number )
	local str = tostring( numberPad.s64_inputNumber );
	local newStr = ( str..tostring(number) );
	--local newNumber = tonumber( newStr );
	local s64_newNumber = tonumber64(newStr);
	
	local s64_MAX = numberPad.s64_maxNumber;
	if true == numberPad.init_Number then
		numberPad.init_Number = false
		newStr = tostring( number )
		s64_newNumber = tonumber64( newStr )
	end
	
	if( s64_MAX < s64_newNumber ) then
		numberPad.s64_inputNumber = numberPad.s64_maxNumber
	else
		numberPad.s64_inputNumber = s64_newNumber;
	end
	
	_textNumber:SetEditText( tostring( numberPad.s64_inputNumber) );	

	if Defines.s64_const.s64_0 < numberPad.s64_inputNumber or _isExchange == true then -- _isExchange : 개인 거래의 예외 처리를 위한 임시 변수!
		_buttonConfirm:SetEnable(true)
		_buttonConfirm:SetMonoTone(false)
	else
		_buttonConfirm:SetEnable(false)
		_buttonConfirm:SetMonoTone(true)
	end
end

local strlen = string.len
local substring = string.sub

function Panel_NumberPad_ButtonBackSpace_Mouse_Click()
	--if Defines.s64_const.s64_0 < numberPad.s64_inputNumber then
		local str = tostring( numberPad.s64_inputNumber );
		local length = strlen(str);
		local newStr = "";
		
		if 1 < length  then
			newStr = substring( str, 1, length-1 );
			numberPad.s64_inputNumber = tonumber64(newStr);	
		else
			newStr = "0";
			numberPad.s64_inputNumber = Defines.s64_const.s64_0;
		end
		
		_textNumber:SetEditText( newStr );
		
		if Defines.s64_const.s64_0 >= numberPad.s64_inputNumber then
			_buttonConfirm:SetEnable(false)
			_buttonConfirm:SetMonoTone(true)
		end

	
	--end
end

function Panel_NumberPad_ButtonConfirm_Mouse_Click()
	if Defines.s64_const.s64_0 < numberPad.s64_inputNumber or  _isExchange == true then
		if nil ~= numberPad.confirmFunction then
			numberPad.confirmFunction( numberPad.s64_inputNumber, numberPad.param0, numberPad.param1  );
		end
		Panel_NumberPad_Show( false, Defines.s64_const.s64_0, 0, nil);	
	end	
end

function Panel_NumberPad_ButtonAllSelect_Mouse_Click()
	numberPad.s64_inputNumber = numberPad.s64_maxNumber

	if( Defines.s64_const.s64_1 == s64_maxNumber ) then
		Panel_NumberPad_Init( numberPad.param0, numberPad.confirmFunction, false, numberPad.param1 )
		Panel_NumberPad_ButtonConfirm_Mouse_Click()
	else
		Panel_NumberPad_Init( numberPad.param0, numberPad.confirmFunction, false, numberPad.param1 )
		-- Panel_NumberPad_ButtonConfirm_Mouse_Click() -- 일괄 최대 선택+구매에서 일괄 최대 선택이기 때문에 주석부분을 사용하지 않는다.
		UI.Set_ProcessorInputMode(IM.eProcessorInputMode_ChattingInputMode) -- 일괄 최대 선택에서 일괄 최대 선택+구매이기 때문에 주석부분을 사용하지 않는다.
		SetFocusEdit( _textNumber )
		_textNumber:SetEditText( tostring(numberPad.s64_maxNumber) )
	end
end



-- 임의의 기본함수
function Panel_NumberPad_Default_ConfirmFunction( count, param0, param1 )
	Panel_NumberPad_Show( false, Defines.s64_const.s64_0, 0, nil);
end

function Panel_NumberPad_IsPopUp()
	return Panel_Window_Exchange_Number:IsShow()
end

function Panel_NumberPad_NumberKey_Input()
	for idx,val in ipairs(numberKeyCode) do
		if isKeyDown_Once( val ) then
			if (idx > 10) then
				Panel_NumberPad_ButtonNumber_Mouse_Click(idx-11)
			else
				Panel_NumberPad_ButtonNumber_Mouse_Click(idx-1)
			end
		end
	end
	
	if isKeyDown_Once( VCK.KeyCode_BACK ) then
		Panel_NumberPad_ButtonBackSpace_Mouse_Click()
	end
end

-- 초기화
numberPad:init();


