Panel_Looting:SetShow(false, false)
Panel_Looting:setMaskingChild(true)
Panel_Looting:ActiveMouseEventEffect(true)
Panel_Looting:setGlassBackground(true)

Panel_Looting:RegisterShowEventFunc( true, 'LootingShowAni()' )
Panel_Looting:RegisterShowEventFunc( false, 'LootingHideAni()' )

local UI_ANI_ADV 	= CppEnums.PAUI_ANIM_ADVANCE_TYPE
local IM 			= CppEnums.EProcessorInputMode
local UI_PSFT 		= CppEnums.PAUI_SHOW_FADE_TYPE
local UI_color 		= Defines.Color

Panel_Looting_Value_isCloseLooting = false

local looting =
{
	-- 여기서만 사용하는 변수및 함수를 정의 하기 위해서 사용.
	MAX_LOOTING_SLOT_COUNT = 12,
	slotConfig =
	{
		-- 일단 아이콘, 테두리, 카운트(숫자) 만 적용한다!
		createIcon		= true,
		createBorder	= true,
		createCount		= true,
		createEnchant	= true,
		createCash		= true,
	},
	config =
	{
		-- 이 값들은 추후에 메시지로 빼어내어 세팅해야 한다!
		slotCount = MAX_LOOTING_SLOT_COUNT,
		slotCols = 4,
		slotRows = 0,	-- 계산되는 값
		slotBGStartX = 11,
		slotBGStartY = 40,
		slotStartX = 13,
		slotStartY = 42,
		slotGapX = 47,
		slotGapY = 47
	},
	slots = Array.new(),
	selectSlotNo = -1,
	remainItemCnt = 0
}

local _buttonCancel				= UI.getChildControl(Panel_Looting, "Button_Cancel"				)
local _buttonLootAll			= UI.getChildControl(Panel_Looting, "Button_LootAll"			)
local _buttonLootAllToServant	= UI.getChildControl(Panel_Looting, "Button_LootAllToServant"	)
_buttonCancel:addInputEvent(			"Mouse_LUp",	"Panel_Looting_buttonCancel_Mouse_Click()"			)
_buttonLootAll:addInputEvent(			"Mouse_LUp",	"Panel_Looting_buttonLootAll_Mouse_Click( true )"	)
_buttonLootAllToServant:addInputEvent(	"Mouse_LUp",	"Panel_Looting_buttonLootAllToServant_Mouse_Click()")


registerEvent("EventLootingWindowUpdate", 	"Panel_Looting_Update" )
registerEvent("EventLootingCancel", 		"Panel_Looting_Cancel" )
--registerEvent("EventLootingWindowShow", 	"Panel_Looting_Show" )

----------------------------------------------------------------------------
-- 지역 함수
-----------------------------------------------------------------------------
function LootingShowAni()
	Panel_Looting:SetAlpha( 0 )
	UIAni.AlphaAnimation( 1, Panel_Looting, 0.0, 0.15 )
	
	Panel_Looting_Value_isCloseLooting = false
	-- ♬ 루팅 창 열림
	-- audioPostEvent_SystemUi(03,14)
end

function LootingHideAni()
	-- Panel_Looting:SetAlpha( 1 )
	-- local aniInfo = UIAni.AlphaAnimation( 0, Panel_Looting, 0.0, 0.1 )
	-- aniInfo:SetHideAtEnd(true)
	
	-- ♬ 루팅 창 닫힘
	-- audioPostEvent_SystemUi(01,01)
end

function looting:init()
	for ii=1, looting.MAX_LOOTING_SLOT_COUNT do
		-- position Set
		local row = math.floor( (ii - 1) / looting.config.slotCols );
		local col = (ii - 1) % looting.config.slotCols;

		local looting_SlotBGBase	= UI.getChildControl(Panel_Looting, "Static_Texture_Slot_Background"	)
		local looting_SlotBG		= UI.createControl( CppEnums.PA_UI_CONTROL_TYPE.PA_UI_CONTROL_STATIC, Panel_Looting, "looting_SlotBG_" .. ii)
		CopyBaseProperty(looting_SlotBGBase, looting_SlotBG)

		local slotNo = ii - 1
		local slot = {};
		SlotItem.new( slot, 'Looting_item_' .. slotNo, slotNo, Panel_Looting, looting.slotConfig );
		slot:createChild();

		-- set Event Handler
		slot.icon:addInputEvent( "Mouse_RUp", "Panel_Looting_SlotRClick(" .. slotNo .. ")" );
		slot.icon:addInputEvent( "Mouse_LUp", "Panel_Looting_SlotLClick(" .. slotNo .. ")" );
		slot.icon:addInputEvent( "Mouse_On" , "Panel_Tooltip_Item_Show_GeneralNormal(" .. slotNo .. ", \"looting\",true)" );
		slot.icon:addInputEvent( "Mouse_Out" , "Panel_Tooltip_Item_Show_GeneralNormal(" .. slotNo .. ", \"looting\",false)" );
		Panel_Tooltip_Item_SetPosition( slotNo, slot, "looting")

		looting_SlotBG:SetPosX( looting.config.slotBGStartX + looting.config.slotGapX * col );
		looting_SlotBG:SetPosY( looting.config.slotBGStartY + looting.config.slotGapY * row + 3);
		looting_SlotBG:SetShow(true)
		looting_SlotBG:SetIgnore(false)

		slot.icon:SetPosX( looting.config.slotStartX + looting.config.slotGapX * col );
		slot.icon:SetPosY( looting.config.slotStartY + looting.config.slotGapY * row + 3);
		slot.icon:SetIgnore(false);

		looting.slots[ii] = slot;
	end
end

----------------------------------------------------------------------------
-- 전역 함수
-----------------------------------------------------------------------------

local closePanelLooting = function()
	if Panel_Looting:IsShow() then
		Panel_Looting:SetShow( false, false )
		
		_buttonLootAll:ClearDisableTime()
		
		if( AllowChangeInputMode() ) then
			if( check_ShowWindow() ) then
				UI.Set_ProcessorInputMode( IM.eProcessorInputMode_UiMode )
			else
				UI.Set_ProcessorInputMode( IM.eProcessorInputMode_GameMode)
			end
		else
			SetFocusChatting()
		end

		
		if ( Panel_Looting:IsShow() == false ) then
			Panel_Looting_Value_isCloseLooting = true
		end
	end
end

function Panel_Looting_Update( empty )
	if 1 == empty then
		Panel_Looting_Value_isCloseLooting = true
		Panel_Tooltip_Item_Show_GeneralNormal( looting.selectSlotNo, "looting", false)
		closePanelLooting()
		-- return
	else
		Panel_Looting:SetShow( true, true )
		Panel_Looting_Value_isCloseLooting = false
	end

	if Panel_Chatting_Input:GetShow() then
		UI.Set_ProcessorInputMode(CppEnums.EProcessorInputMode.eProcessorInputMode_ChattingInputMode)
	end
	
	------------------------------------------------
	--				탑승물 루팅일 때
	if	looting_isPickItemToServant()	then
		_buttonLootAllToServant:SetShow(true)	
	else
		_buttonLootAllToServant:SetShow(false)	
	end

	local lootingCount = looting_getItemCount()
	looting.remainItemCnt = 0
	for ii=1, looting.MAX_LOOTING_SLOT_COUNT do
		local slot			= looting.slots[ii]
		local itemWrapper	= looting_getItem(ii-1)
		if nil ~= itemWrapper then
			slot:setItem( itemWrapper )
			looting.remainItemCnt = looting.remainItemCnt + 1
		else
			if ii-1 == looting.selectSlotNo then
				Panel_Tooltip_Item_Show_GeneralNormal( looting.selectSlotNo, "looting", false)
			end
			slot:clearItem();
		end
	end
end

function	Panel_Looting_PickupBySlot( slotNo )
	local	self		= looting
	self.selectSlotNo	= slotNo
	
	local	itemWrapper	= looting_getItem(slotNo)
	if	(nil == itemWrapper)	then
		return
	end
	
	local	s64_count	= itemWrapper:get():getCount_s64()
	local	itemKey		= itemWrapper:get():getKey():getItemKey()
	local	itemName	= itemWrapper:getStaticStatus():getName()

	if 1 == itemKey then
		Panel_Looting_Pickup( s64_count, slotNo )
	else
		Panel_NumberPad_Show( true, s64_count, slotNo, Panel_Looting_Pickup)
	end
	
	--looting.remainItemCnt = looting.remainItemCnt - 1
	--local	lootingCount = looting_getItemCount()
	--if	(looting.remainItemCnt < 1)	then
	--	Panel_Looting_Cancel()
	--end
	audioPostEvent_SystemUi(03,06)
end

function	Panel_Looting_Pickup( s64_count, slotNo )

	looting_slotClick( slotNo, s64_count )
	
end

function	Panel_Looting_SlotRClick( slotNo )
	Panel_Looting_PickupBySlot( slotNo )
end

function Panel_Looting_SlotLClick( slotNo )
	Panel_Looting_PickupBySlot( slotNo )
end

function	Panel_Looting_buttonLootAll_Mouse_Click( isMouseEvent )

	-- 'R' 키를 입력시에도 AutoDisable을 활성화 시켜줘야 서버의 부하가 적어진다.! (20140918:홍민우)
	if	( not isMouseEvent )	then
		if	( not _buttonLootAll:checkAutoDisableTime() )	then
			return
		end

		_buttonLootAll:DoAutoDisableTime()
	end
	
	-- closePanelLooting()
	looting.selectSlotNo = -1
	looting_pickAllItemToPlayer();	
	audioPostEvent_SystemUi(03,09)
end

function	Panel_Looting_buttonLootAllToServant_Mouse_Click()
	looting.selectSlotNo = -1
	looting_pickAllItemToServant()
end

function	Panel_Looting_buttonCancel_Mouse_Click()
	-- 채집물 or 재배 작물의 경우 취소하면 다신 얻을 수 없음으로 Popup 창을 띄어 준다.
	local	dropType	= looting_getDropType()
	if	( CppEnums.DropType.Type_CollectInfo == dropType ) or ( CppEnums.DropType.Type_Harvest == dropType )	then
		local	messageBoxMemo	= PAGetString(Defines.StringSheet_GAME, "GAME_MESSAGE_LOOT_MEMO")
		local	messageboxData	= { title = PAGetString(Defines.StringSheet_GAME, "GAME_MESSAGE_LOOT_TITLE"), content = messageBoxMemo, functionYes = Panel_Looting_buttonCancel_Mouse_ClickXXX, functionNo = MessageBox_Empty_function, priority = CppEnums.PAUIMB_PRIORITY.PAUIMB_PRIORITY_LOW}
		MessageBox.showMessageBox(messageboxData)
	else
		Panel_Looting_buttonCancel_Mouse_ClickXXX()
	end
end


function	Panel_Looting_buttonCancel_Mouse_ClickXXX()
	closePanelLooting()
	looting_cancel()
	local actor			= interaction_getInteractable()
	if actor ~= nil then
		Interaction_Show( actor )
	end	
end

function Panel_Looting_Cancel()
	looting.selectSlotNo = -1
	closePanelLooting()
	looting_cancel()
	Panel_Tooltip_Item_hideTooltip()			
	
	local actor			= interaction_getInteractable()
	if actor ~= nil then
		Interaction_Show( actor )
	end	
end

function Panel_Looting_PickAll()
	looting.selectSlotNo = -1
	closePanelLooting()
end

function Panel_Looting_Show()
	looting.selectSlotNo = -1
	Panel_Looting:SetShow( true, true )
	--local lootingItemCount = looting_getItemCount();
	Interaction_Close()
end

-- 초기화
looting:init();
