Panel_Mail_Detail:ActiveMouseEventEffect(true)
Panel_Mail_Detail:setGlassBackground(true)

-- Panel_Mail_Detail:SetShow(true)		-- 테스트용 삭제해야함

Panel_Mail_Detail:RegisterShowEventFunc( true,	'Mail_Detail_ShowAni()' )
Panel_Mail_Detail:RegisterShowEventFunc( false,	'Mail_Detail_HideAni()' )

local UI_PUCT	= CppEnums.PA_UI_CONTROL_TYPE
local UI_PSFT	= CppEnums.PAUI_SHOW_FADE_TYPE
local UI_ANI_ADV= CppEnums.PAUI_ANIM_ADVANCE_TYPE
local UI_color	= Defines.Color
local UI_TM 	= CppEnums.TextMode

function Mail_Detail_ShowAni()
	UIAni.fadeInSCR_Left(Panel_Mail_Detail)
end

function Mail_Detail_HideAni()
	Panel_Mail_Detail:SetShowWithFade(UI_PSFT.PAUI_ANI_TYPE_FADE_OUT)
	local mailHideAni = Panel_Mail_Detail:addColorAnimation( 0.0, 0.22, UI_ANI_ADV.PAUI_ANIM_ADVANCE_SIN_HALF_PI)
	mailHideAni:SetStartColor( UI_color.C_FFFFFFFF )
	mailHideAni:SetEndColor( UI_color.C_00FFFFFF )
	mailHideAni:SetStartIntensity( 3.0 )
	mailHideAni:SetEndIntensity( 1.0 )
	mailHideAni.IsChangeChild = true
	mailHideAni:SetHideAtEnd(true)
	mailHideAni:SetDisableWhileAni(true)
end

local _frame 				= UI.getChildControl( Panel_Mail_Detail,"Frame_MailText" )
local _frameContents 		= UI.getChildControl( _frame, 			"Frame_Contents" )
local _frameScroll			= UI.getChildControl( _frame, 			"Frame_Scroll" )
local _frameScroll_Btn		= UI.getChildControl( _frameScroll, 	"Scroll_Bar_CtrlButton" )
local panel_SizeY			= Panel_Mail_Detail:GetSizeY()

local	mailDetail	= {
	slotConfig	=
	{
		createIcon		= true,
		createBorder	= true,
		createCount		= true,
		createEnchant	= true,
		createCash		= true
	},
	
	config	=
	{
		slotX	= 5,
		slotY	= 5,
	},

	_sender			= UI.getChildControl(Panel_Mail_Detail, "StaticText_Sender"),
	_title 			= UI.getChildControl(Panel_Mail_Detail, "StaticText_Subtitle"),	
	_contents		= UI.getChildControl(_frameContents,	"StaticText_Content"),
	_itemText		= UI.getChildControl(Panel_Mail_Detail, "StaticText_Item_Message"),
	_iconBase		= UI.getChildControl(Panel_Mail_Detail, "Static_Itemicon"),
	_buttonDelete	= UI.getChildControl(Panel_Mail_Detail, "Button_Delete"),
	_buttonReceive	= UI.getChildControl(Panel_Mail_Detail, "Button_Receive"),
	_buttonClose	= UI.getChildControl(Panel_Mail_Detail, "Button_Win_Close"),
	_buttonQuestion	= UI.getChildControl(Panel_Mail_Detail, "Button_Question"),		--물음표 버튼
	
	_itemSlot		= {}
}

function	mailDetail:init()
	UI.ASSERT( nil ~= self._sender			and 'number' ~= type(self._sender),			"StaticText_Sender" )
	UI.ASSERT( nil ~= self._title			and 'number' ~= type(self._title),			"StaticText_Subtitle" )
	UI.ASSERT( nil ~= self._contents		and 'number' ~= type(self._contents),		"StaticText_Content" )
	UI.ASSERT( nil ~= self._itemText		and 'number' ~= type(self._itemText),		"StaticText_Item_Message" )
	UI.ASSERT( nil ~= self._iconBase		and 'number' ~= type(self._iconBase),		"Static_Itemicon" )
	UI.ASSERT( nil ~= self._buttonDelete	and 'number' ~= type(self._buttonDelete),	"Button_Delete" )
	UI.ASSERT( nil ~= self._buttonClose		and 'number' ~= type(self._buttonClose),	"Button_Win_Close" )

	
	SlotItem.new( self._itemSlot, 'ItemIconSlot_' , 0, self._iconBase, self.slotConfig )
	self._itemSlot:createChild()
	
	self._itemSlot.icon:SetPosX( self.config.slotX )
	self._itemSlot.icon:SetPosY( self.config.slotY )
	
	self._itemSlot.icon:addInputEvent( "Mouse_On",	"Mail_ShowItemToolTip()" )
	self._itemSlot.icon:addInputEvent( "Mouse_Out",	"Mail_HideItemToolTip()" )
			
	self._iconBase:SetShow(false)
end

function	Mail_ShowItemToolTip()
	local self = mailDetail
	if( RequestMail_doSendCashProduct() ) then
		local productKeyRaw	= RequestMail_getMailCashProductNoRaw();
		FGlobal_CashShop_GoodsTooltipInfo_Open( productKeyRaw, self._itemSlot.icon )
	else
		local mailIESS	= mail_getMailItemStatic()
		Panel_Tooltip_Item_Show( mailIESS, self._itemSlot.icon, true, false, nil )
	end	
end

function	Mail_HideItemToolTip()
	if( RequestMail_doSendCashProduct() ) then
		FGlobal_CashShop_GoodsTooltipInfo_Close()
	else
		Panel_Tooltip_Item_hideTooltip()
	end
end

--이벤트 등록 < client -> lua >
function	mailDetail:registMessageHandler()
	registerEvent("ResponseMail_showDetail",	"Mail_Detail_Open")
end

-- 버튼 이벤트 등록
function	mailDetail:registEventHandler()
	self._buttonClose:addInputEvent( "Mouse_LUp",	"Mail_Detail_Close()");
	self._buttonQuestion:addInputEvent( "Mouse_LUp",	"Panel_WebHelper_ShowToggle( \"PanelMailDetail\" )");		--물음표 좌클릭
	self._buttonQuestion:addInputEvent( "Mouse_On",	"HelpMessageQuestion_Show( \"PanelMailDetail\", \"true\")");			--물음표 마우스오버
	self._buttonQuestion:addInputEvent( "Mouse_Out",	"HelpMessageQuestion_Show( \"PanelMailDetail\", \"false\")");			--물음표 마우스아웃
	self._buttonDelete:addInputEvent("Mouse_LUp",	"Mail_Detail_Delete()");
	self._itemSlot.icon:addInputEvent( "Mouse_RUp", "Mail_Detail_GetItem()");
	self._buttonReceive:addInputEvent("Mouse_LUp",	"Mail_Detail_GetItem()");
end

function	Mail_Detail_Open()
	if	not Panel_Mail_Detail:IsShow()	then
		Panel_Mail_Detail:SetShow(true, true)
	end
	
	FGlobal_CashShop_GoodsTooltipInfo_Close()
	Panel_Tooltip_Item_hideTooltip()

	local	self	= mailDetail
	self._sender:SetText( RequestMail_getMailSenderName() )
	self._title:SetText( RequestMail_getMailTitle() )
	
	self._contents:SetAutoResize( true )
	self._contents:SetTextMode( UI_TM.eTextMode_AutoWrap )		
	self._contents:SetText( RequestMail_getMailContents() )
	
	local textSizeY = self._contents:GetSizeY()
	local frameSizeY = _frame:GetSizeY()

	_frameContents:SetSize(_frameContents:GetSizeX(), textSizeY)	
	UIScroll.SetButtonSize( _frameScroll, frameSizeY,  textSizeY)
	_frameScroll:SetControlPos( 0 )
	
	if(RequestMail_doSendCashProduct()) then
		local mailCashProductNoRaw	= RequestMail_getMailCashProductNoRaw();
		
		local cPSSW					= nil
		if 0 ~= mailCashProductNoRaw then
			cPSSW					= ToClient_GetCashProductStaticStatusWrapperByKeyRaw(mailCashProductNoRaw)
		end	
		
		if nil ~= cPSSW then
			self._itemSlot:setItemByCashProductStaticStatus( cPSSW,  1 )
			self._iconBase:SetShow(true)
			self._itemSlot.icon:SetShow(true)
			self._itemText:SetShow(true)
			self._buttonReceive:SetShow(true)
			Panel_Mail_Detail:SetSize(Panel_Mail_Detail:GetSizeX(), panel_SizeY)
		else
			self._itemSlot:clearItem()
			self._iconBase:SetShow(false)
			self._itemSlot.icon:SetShow(false)
			self._itemText:SetShow(false)
			self._buttonReceive:SetShow(false)
			Panel_Mail_Detail:SetSize(Panel_Mail_Detail:GetSizeX(), panel_SizeY - 40)
		end
		
	else
		local mailItem	= mail_getMailItemStatic();
	
		if nil ~= mailItem then
			self._itemSlot:setItemByStaticStatus( mailItem,  RequestMail_getMailItemCount() )
			self._iconBase:SetShow(true)
			self._itemSlot.icon:SetShow(true)
			self._itemText:SetShow(true)
			self._buttonReceive:SetShow(true)
			Panel_Mail_Detail:SetSize(Panel_Mail_Detail:GetSizeX(), panel_SizeY)
		else
			self._itemSlot:clearItem()
			self._iconBase:SetShow(false)
			self._itemSlot.icon:SetShow(false)
			self._itemText:SetShow(false)
			self._buttonReceive:SetShow(false)
			Panel_Mail_Detail:SetSize(Panel_Mail_Detail:GetSizeX(), panel_SizeY - 40)
		end
	
	end
	
	mailDetail._buttonDelete:ComputePos()
end

function	Mail_Detail_Close()
	if	Panel_Mail_Detail:IsShow()	then
		Panel_Mail_Detail:SetShow(false, true)
	end
	FGlobal_CashShop_GoodsTooltipInfo_Close()
	Panel_Tooltip_Item_hideTooltip()
end


function Mail_Detail_Delete()
	RequestMail_removeMail()
	Mail_Detail_Close()
end

function Mail_Detail_GetItem()
	RequestMail_getMailItem()
end

mailDetail:init()
mailDetail:registEventHandler()
mailDetail:registMessageHandler()