Panel_Window_PetControl:SetShow( false, false )

local UI_ANI_ADV 		= CppEnums.PAUI_ANIM_ADVANCE_TYPE
local UI_color			= Defines.Color

local PetControl = {
	Btn_Follow				= UI.getChildControl( Panel_Window_PetControl, "Button_Follow" ),
	Btn_Wait				= UI.getChildControl( Panel_Window_PetControl, "Button_Wait" ),
	Btn_Find				= UI.getChildControl( Panel_Window_PetControl, "Button_Find" ),
	Btn_GetItem				= UI.getChildControl( Panel_Window_PetControl, "Button_GetItem" ),

	Dot_RedIcon				= UI.getChildControl( Panel_Window_PetControl, "Static_RedDotIcon"),
	Dot_GreenIcon			= UI.getChildControl( Panel_Window_PetControl, "Static_GreenDotIcon"),
	Dot_YellowIcon			= UI.getChildControl( Panel_Window_PetControl, "Static_YellowDotIcon"),
	Dot_PurpleIcon			= UI.getChildControl( Panel_Window_PetControl, "Static_PurpleDotIcon"),
	Dot_GrayIcon1			= UI.getChildControl( Panel_Window_PetControl, "Static_GrayDotIcon1"),
	Dot_GrayIcon2			= UI.getChildControl( Panel_Window_PetControl, "Static_GrayDotIcon2"),
	Btn_IconPet				= UI.getChildControl( Panel_Window_PetControl, "Button_IconPet"),

	Stc_HungryBG			= UI.getChildControl( Panel_Window_PetControl, "Static_HungryBG"),
	Progrss_Hungry			= UI.getChildControl( Panel_Window_PetControl, "Progress2_Hungry"),
}

local screenX		= getScreenSizeX()
local screenY		= getScreenSizeY()
local panelSizeX	= PetControl.Btn_GetItem:GetSizeX()
local panelSizeY	= PetControl.Btn_GetItem:GetSizeY()
local showIsCheck	= false

local PetControl_CurrentButtonTooltipType = -1

PetControl.Btn_Follow:ActiveMouseEventEffect( true )
PetControl.Btn_Wait:ActiveMouseEventEffect( true )

function PetControl:ButtonShow( isShow )
	self.Btn_Follow		:SetShow( isShow )
	self.Btn_Wait		:SetShow( isShow )
	self.Btn_Find		:SetShow( isShow )
	self.Btn_GetItem	:SetShow( isShow )
end


function FGlobal_PetControl_CheckUnSealPet()
	if isFlushedUI() then
		return
	end
	
	local isUnSealPet = ToClient_getPetUnsealedList()
	if 0 < isUnSealPet  then
		PetControl_SetPositon()
		Panel_Window_PetControl:SetShow( true )
		-- 펫 아이콘!
		local PetUnSealData				= ToClient_getPetUnsealedDataByIndex( 0 )
		if nil ~= PetUnSealData then
			local unsealPetStaticStatus		= PetUnSealData:getPetStaticStatus()
			local unsealIconPath			= unsealPetStaticStatus:getIconPath()
			PetControl.Btn_IconPet:ChangeTextureInfoName( unsealIconPath )
		end

		FGlobal_PetControl_SealPet()
	else
		Panel_Window_PetControl:SetShow( false )
	end
end

function PetControl_SetPositon()
	Panel_Window_PetControl:SetPosX( 10 )
	Panel_Window_PetControl:SetPosY( Panel_SelfPlayerExpGage:GetSizeY() * 2 )
end

function PetControl_Follow()
	PetControl_BTNCheckedUpdate()
end

function PetControl_Wait()
	PetControl_BTNCheckedUpdate()
end

function PetControl_GetItem() -- 주워와를 눌렀을 때
	local self = PetControl
	if false == self.Btn_GetItem:IsCheck() then
		self.Btn_GetItem:SetCheck( false )
		self.Dot_PurpleIcon:SetShow( true )
		self.Dot_GrayIcon2:SetShow( false )
		ToClient_callHandlerToPet("handlePetGetItemOn")
	else
		self.Btn_GetItem:SetCheck( true )
		self.Dot_PurpleIcon:SetShow( false )
		self.Dot_GrayIcon2:SetShow( true )
		ToClient_callHandlerToPet("handlePetGetItemOff")
	end
end
function PetControl_Find() -- 찾아와 버튼을 눌렀을 때
	local self = PetControl
	if false == self.Btn_Find:IsCheck() then
		self.Btn_Find:SetCheck( false )
		self.Dot_YellowIcon:SetShow( true )
		self.Dot_GrayIcon1:SetShow( false )
		ToClient_callHandlerToPet("handlePetFindThatOn")
	else
		self.Btn_Find:SetCheck( true )
		self.Dot_YellowIcon:SetShow( false )
		self.Dot_GrayIcon1:SetShow( true )
		ToClient_callHandlerToPet("handlePetFindThatOff")
	end
end

function FGlobal_PetControl_SealPet()	-- 펫을 찾았을 때.
	local self = PetControl

	self.Btn_Follow		:SetCheck( true )
	self.Btn_Wait		:SetCheck( false )
	self.Btn_GetItem	:SetCheck( false )
	self.Btn_Find		:SetCheck( true )

	PetControl			:ButtonShow( false )

	if ( not Panel_Window_NoPetIcon:GetShow() ) then
		self.Progrss_Hungry:SetShow( true )
		self.Stc_HungryBG:SetShow( true )
	else
		self.Progrss_Hungry:SetShow( false )
		self.Stc_HungryBG:SetShow( false )
	end

	-- self.Btn_Find		:SetCheck( true )
	-- self.Btn_GetItem	:SetCheck( false )

	self.Dot_GreenIcon	:SetShow( true )
	self.Dot_RedIcon	:SetShow( false )
	self.Dot_YellowIcon	:SetShow( false )
	self.Dot_GrayIcon1	:SetShow( true )
	self.Dot_PurpleIcon	:SetShow( true )
	self.Dot_GrayIcon2	:SetShow( false )
	
	ToClient_callHandlerToPet("handlePetFollowMaster")
	ToClient_callHandlerToPet("handlePetGetItemOn")
	-- ToClient_callHandlerToPet("handlePetFindThatOn")
	-- ToClient_callHandlerToPet("handlePetGetItemOff")
	ToClient_callHandlerToPet("handlePetFindThatOff")

	FGlobal_PetControl_RestoreUI()
end

function FGlobal_PetControl_RestoreUI()
	local self = PetControl
	TooltipSimple_Hide()
	
	showIsCheck	= false
	
	if Panel_Window_PetControl:GetShow() or Panel_Window_NoPetIcon:GetShow() then
		Panel_MovieGuideButton:SetPosX( self.Btn_IconPet:GetSizeX() + 20 )
	end
end

function HandleClicked_petControl_IconShow() -- 펫 아이콘을 클릭 했을 때
	local self = PetControl
	if showIsCheck == false then
		PetControl_ButtonShow()
		showIsCheck = true
	elseif showIsCheck == true then
		PetControl_ButtonHide()
		showIsCheck = false
	end
end

function PetControl_ButtonShow()
	local self = PetControl
	-- PetControl:ButtonShow( true )
	Panel_MovieGuideButton:SetShow( false )
	local MoveAni1 = self.Btn_Follow:addMoveAnimation( 0.0, 0.2, UI_ANI_ADV.PAUI_ANIM_ADVANCE_SIN_HALF_PI )
	MoveAni1:SetStartPosition( self.Btn_Follow:GetPosX() , self.Btn_Follow:GetPosY() )
	MoveAni1:SetEndPosition( self.Btn_Follow:GetPosX() , self.Btn_Follow:GetPosY() )
	if self.Dot_GreenIcon:GetShow() then
		self.Btn_Follow:SetShow( true )
		self.Btn_Wait:SetShow( false )
	else
		self.Btn_Wait:SetShow( true )
		self.Btn_Follow:SetShow( false )
	end

	local MoveAni2 = self.Btn_Wait:addMoveAnimation( 0.0, 0.2, UI_ANI_ADV.PAUI_ANIM_ADVANCE_SIN_HALF_PI )
	MoveAni2:SetStartPosition( self.Btn_Follow:GetPosX() , self.Btn_Wait:GetPosY() )
	MoveAni2:SetEndPosition( self.Btn_Wait:GetPosX() , self.Btn_Wait:GetPosY() )

	local MoveAni3 = self.Btn_Find:addMoveAnimation( 0.0, 0.2, UI_ANI_ADV.PAUI_ANIM_ADVANCE_SIN_HALF_PI )
	MoveAni3:SetStartPosition( self.Btn_Follow:GetPosX() , self.Btn_Find:GetPosY() )
	MoveAni3:SetEndPosition( self.Btn_Find:GetPosX() , self.Btn_Find:GetPosY() )
	self.Btn_Find:SetShow( true )

	local MoveAni4 = self.Btn_GetItem:addMoveAnimation( 0.0, 0.2, UI_ANI_ADV.PAUI_ANIM_ADVANCE_SIN_HALF_PI )
	MoveAni4:SetStartPosition( self.Btn_Follow:GetPosX() , self.Btn_GetItem:GetPosY() )
	MoveAni4:SetEndPosition( self.Btn_GetItem:GetPosX() , self.Btn_GetItem:GetPosY() )
	self.Btn_GetItem:SetShow( true )
end

function PetControl_ButtonHide()
	local self = PetControl

	PetControl:ButtonShow( false )
	Panel_MovieGuideButton:SetShow( true )
	local MoveAni1 = self.Btn_Follow:addMoveAnimation( 0.0, 0.1, UI_ANI_ADV.PAUI_ANIM_ADVANCE_SIN_HALF_PI )
	MoveAni1:SetStartPosition( self.Btn_Follow:GetSizeX() ,self.Btn_Follow:GetPosY() )
	MoveAni1:SetEndPosition( self.Btn_IconPet:GetPosX(), self.Btn_Follow:GetPosY() )
	-- MoveAni1:SetHideAtEnd( true )

	local MoveAni2 = self.Btn_Wait:addMoveAnimation( 0.0, 0.1, UI_ANI_ADV.PAUI_ANIM_ADVANCE_SIN_HALF_PI )
	MoveAni2:SetStartPosition( self.Btn_Wait:GetSizeX() , self.Btn_Wait:GetPosY() )
	MoveAni2:SetEndPosition( self.Btn_IconPet:GetPosX(), self.Btn_Wait:GetPosY() )
	-- MoveAni2:SetHideAtEnd( true )

	local MoveAni3 = self.Btn_Find:addMoveAnimation( 0.0, 0.1, UI_ANI_ADV.PAUI_ANIM_ADVANCE_SIN_HALF_PI )
	MoveAni3:SetStartPosition( self.Btn_Find:GetSizeX() , self.Btn_Find:GetPosY() )
	MoveAni3:SetEndPosition( self.Btn_IconPet:GetPosX(), self.Btn_Find:GetPosY() )
	-- MoveAni3:SetHideAtEnd( true )

	local MoveAni4 = self.Btn_GetItem:addMoveAnimation( 0.0, 0.1, UI_ANI_ADV.PAUI_ANIM_ADVANCE_SIN_HALF_PI )
	MoveAni4:SetStartPosition( self.Btn_GetItem:GetSizeX() , self.Btn_GetItem:GetPosY() )
	MoveAni4:SetEndPosition( self.Btn_IconPet:GetPosX(), self.Btn_GetItem:GetPosY() )
	-- MoveAni4:SetHideAtEnd( true )
end

function PetControl_BTNCheckedUpdate()
	local self = PetControl
	if true == self.Btn_Follow:IsCheck() then
		self.Btn_Follow			:SetShow( false )
		self.Btn_Wait			:SetShow( true )

		self.Dot_RedIcon		:SetShow( true )
		self.Dot_GreenIcon		:SetShow( false )
		ToClient_callHandlerToPet("handlePetWaitMaster")
	else
		self.Btn_Follow			:SetShow( true )
		self.Btn_Wait			:SetShow( false )

		self.Dot_GreenIcon		:SetShow( true )
		self.Dot_RedIcon		:SetShow( false )
		ToClient_callHandlerToPet("handlePetFollowMaster")
	end
end

function petControl_Button_Tooltip( isShow, buttonType )
	local uiControl, name, desc = nil, nil, nil
	if true == isShow then
		if 0 == buttonType then
			uiControl	= PetControl.Btn_Follow
			name		= "애완동물 명령:따라와"
			desc		= "애완동물이 플레이어를 따라 다니도록 설정합니다. 기다려와 따라와 중 하나만 선택할 수 있습니다."
		elseif 1 == buttonType then
			uiControl	= PetControl.Btn_Wait
			name		= "애완동물 명령:기다려"
			desc		= "애완동물이 플레이어를 제자리에서 기다리도록 설정합니다. 거리가 너무 멀어지는 경우 플레이어 옆으로 이동합니다. 기다려와 따라와 중 하나만 선택할 수 있습니다."
		elseif 2 == buttonType then
			uiControl	= PetControl.Btn_GetItem
			name		= "애완동물 명령:주워와"
			desc		= "애완동물이 플레이어 대신 아이템을 주워 옵니다."
		elseif 3 == buttonType then
			uiControl	= PetControl.Btn_Find
			name		= "애완동물 명령:찾아"
			desc		= "애완동물이 주변에서 가치 있는 장소, 물건 등을 찾습니다."
		elseif 99 == buttonType then
			uiControl	= Panel_Window_NoPetIcon
			name		= "애완동물 목록"
			desc		= "주인이 불러주길 기다리는 애완동물이 있습니다.\n애완동물을 찾아 명령을 내려보세요."
		end
		TooltipSimple_Show( uiControl, name, desc )
	else
		TooltipSimple_Hide()
	end
end

--애완동물 아이콘 밑에 배고픔 게이지
function FGlobal_PetContorl_HungryGaugeUpdate()
	if isFlushedUI() then
		return
	end
	local petCount = ToClient_getPetUnsealedList()
	if petCount == 0 then
		return
	end

	local self = PetControl

	local PcPetData 		= ToClient_getPetUnsealedDataByIndex( 0 )
	local petStaticStatus	= PcPetData:getPetStaticStatus()
	local petHungry			= PcPetData:getHungry()
	local petMaxHungry		= petStaticStatus._maxHungry
	local petHungryPercent	= ( petHungry / petMaxHungry ) * 100

	self.Progrss_Hungry:SetProgressRate( petHungryPercent )
end

function PetControl_registEventHandler()
	PetControl.Btn_Follow		:addInputEvent( "Mouse_LUp",		"PetControl_Follow()" )
	PetControl.Btn_Follow		:addInputEvent( "Mouse_On",			"petControl_Button_Tooltip( true, " .. 0 .. " )" )
	PetControl.Btn_Follow		:addInputEvent( "Mouse_Out",		"petControl_Button_Tooltip( false )" )
	PetControl.Btn_Wait			:addInputEvent( "Mouse_LUp",		"PetControl_Wait()" )
	PetControl.Btn_Wait			:addInputEvent( "Mouse_On",			"petControl_Button_Tooltip( true, " .. 1 .. " )" )
	PetControl.Btn_Wait			:addInputEvent( "Mouse_Out",		"petControl_Button_Tooltip( false )" )
	PetControl.Btn_GetItem		:addInputEvent( "Mouse_LUp",		"PetControl_GetItem()" )
	PetControl.Btn_GetItem		:addInputEvent( "Mouse_On",			"petControl_Button_Tooltip( true, " .. 2 .. " )" )
	PetControl.Btn_GetItem		:addInputEvent( "Mouse_Out",		"petControl_Button_Tooltip( false )" )
	PetControl.Btn_Find			:addInputEvent( "Mouse_LUp",		"PetControl_Find()" )
	PetControl.Btn_Find			:addInputEvent( "Mouse_On",			"petControl_Button_Tooltip( true, " .. 3 .. " )" )
	PetControl.Btn_Find			:addInputEvent( "Mouse_Out",		"petControl_Button_Tooltip( false )" )
	PetControl.Btn_IconPet		:addInputEvent( "Mouse_LUp",		"HandleClicked_petControl_IconShow()" )
	Panel_Window_NoPetIcon		:addInputEvent( "Mouse_LUp",		"FGlobal_PetListNew_Toggle()" )
	Panel_Window_NoPetIcon		:addInputEvent( "Mouse_On",			"petControl_Button_Tooltip( true, " .. 99 .. " )" )
	Panel_Window_NoPetIcon		:addInputEvent( "Mouse_Out",		"petControl_Button_Tooltip( false )" )
end

function PetControl_registMessageHandler()
	registerEvent("FromClient_PetAddList",		"FGlobal_PetContorl_HungryGaugeUpdate")
	registerEvent("FromClient_PetInfoChanged",	"FGlobal_PetContorl_HungryGaugeUpdate")
end

FGlobal_PetControl_CheckUnSealPet()
PetControl_registEventHandler()
PetControl_registMessageHandler()
UI.addRunPostRestorFunction( FGlobal_PetControl_RestoreUI )
