local UI_TM			= CppEnums.TextMode
local UI_PUCT		= CppEnums.PA_UI_CONTROL_TYPE
local UI_color		= Defines.Color
local UI_ANI_ADV	= CppEnums.PAUI_ANIM_ADVANCE_TYPE

Panel_Window_PetListNew:SetShow( false )
Panel_Window_PetListNew:setGlassBackground( true )
Panel_Window_PetListNew:ActiveMouseEventEffect( true )

Panel_Window_PetListNew:RegisterShowEventFunc( true, 'PetNewListShowAni()' )
Panel_Window_PetListNew:RegisterShowEventFunc( false, 'PetNewListHideAni()' )

function PetNewListShowAni()
end
function PetNewListHideAni()
end

local PetList = {
	panelBG			= UI.getChildControl( Panel_Window_PetListNew, "Static_BG" ),
	scroll			= UI.getChildControl( Panel_Window_PetListNew, "Scroll_PetListNew" ),
	BTN_Close		= UI.getChildControl( Panel_Window_PetListNew, "Button_Win_Close" ),
	noneUnsealPet	= UI.getChildControl( Panel_Window_PetListNew, "StaticText_NoneUnsealPet" ),
	BTN_UnSeal		= UI.getChildControl( Panel_Window_PetListNew, "Button_UnSeal"),

	TXT_HungryAlert	= UI.getChildControl( Panel_Window_PetControl, "StaticText_HungryAlert"),


	scrollInterval	= 0,
	startIndex		= 0,
	listMaxCount	= 4,
	listUIPool		= {},
	SealDATACount	= 0,
	UnSealDataCount	= 0,
}
PetList.scrollCtrBTN	= UI.getChildControl( PetList.scroll, "Scroll_CtrlButton" )

local Template = {
	static_ListContentBG		= UI.getChildControl( Panel_Window_PetListNew, "Template_Static_ListContentBG" ),
	static_IconPetBG			= UI.getChildControl( Panel_Window_PetListNew, "Template_Static_IconPetBG" ),
	static_IconPet				= UI.getChildControl( Panel_Window_PetListNew, "Template_Static_IconPet" ),
	staticText_PetName			= UI.getChildControl( Panel_Window_PetListNew, "Template_StaticText_PetName" ),
	staticText_Level			= UI.getChildControl( Panel_Window_PetListNew, "Template_StaticText_Level" ),
	staticText_Hungry			= UI.getChildControl( Panel_Window_PetListNew, "Template_Static_HungryIcon" ),
	static_Progress_Hungry_BG	= UI.getChildControl( Panel_Window_PetListNew, "Template_Static_Progress_Hungry_BG" ),
	static_Progress_Hungry		= UI.getChildControl( Panel_Window_PetListNew, "Template_Static_Progress_Hungry" ),
	staticText_Lovely			= UI.getChildControl( Panel_Window_PetListNew, "Template_Static_LovelyIcon" ),
	static_Progress_Lovely_BG	= UI.getChildControl( Panel_Window_PetListNew, "Template_Static_Progress_Lovely_BG" ),
	static_Progress_Lovely		= UI.getChildControl( Panel_Window_PetListNew, "Template_Static_Progress_Lovely" ),
	button_Info					= UI.getChildControl( Panel_Window_PetListNew, "Template_Button_Info" ),
	button_Unregister			= UI.getChildControl( Panel_Window_PetListNew, "Template_Button_Unregister" ),
	button_Seal					= UI.getChildControl( Panel_Window_PetListNew, "Template_Button_Seal" ),
}

local 	_buttonQuestion			= UI.getChildControl( Panel_Window_PetListNew, "Button_Question" )						-- 물음표 버튼
	_buttonQuestion:		addInputEvent( "Mouse_LUp", "Panel_WebHelper_ShowToggle( \"Pet\" )" )						-- 물음표 좌클릭
	_buttonQuestion:		addInputEvent( "Mouse_On", "HelpMessageQuestion_Show( \"Pet\", \"true\")" )					-- 물음표 마우스오버
	_buttonQuestion:		addInputEvent( "Mouse_Out", "HelpMessageQuestion_Show( \"Pet\", \"false\")" )				-- 물음표 마우스아웃


function PetList:Initialize()
	local itemList_PosY = 74
	for listIdx	= 0, self.listMaxCount -1 do
		local tempSlot = {}
		local Created_ListContentBG = UI.createControl( UI_PUCT.PA_UI_CONTROL_STATIC, self.panelBG, 'PetListNew_ListContentBG_' .. listIdx )
		CopyBaseProperty( Template.static_ListContentBG, Created_ListContentBG )
		Created_ListContentBG:SetPosX( 9 )
		Created_ListContentBG:SetPosY( itemList_PosY )
		Created_ListContentBG:addInputEvent("Mouse_DownScroll",		"PetListNew_ScrollEvent( true )")
		Created_ListContentBG:addInputEvent("Mouse_UpScroll",		"PetListNew_ScrollEvent( false )")
		Created_ListContentBG:SetShow( false )
		tempSlot.ListContentBG = Created_ListContentBG

		local Created_PetIconBG = UI.createControl( UI_PUCT.PA_UI_CONTROL_STATIC, Created_ListContentBG, 'PetListNew_PetIconBG_' .. listIdx )
		CopyBaseProperty( Template.static_IconPetBG, Created_PetIconBG )
		Created_PetIconBG:SetPosX( 5 )
		Created_PetIconBG:SetPosY( 5 )
		Created_PetIconBG:SetShow( true )
		tempSlot.PetIconBG = Created_PetIconBG

		local Created_PetIcon = UI.createControl( UI_PUCT.PA_UI_CONTROL_STATIC, Created_PetIconBG, 'PetListNew_PetIcon_' .. listIdx )
		CopyBaseProperty( Template.static_IconPet, Created_PetIcon )
		Created_PetIcon:SetPosX( 0 )
		Created_PetIcon:SetPosY( 0 )
		Created_PetIcon:SetShow( true )
		tempSlot.PetIcon = Created_PetIcon

		local Created_PetLev = UI.createControl( UI_PUCT.PA_UI_CONTROL_STATICTEXT, Created_ListContentBG, 'PetListNew_PetLevel_' .. listIdx )
		CopyBaseProperty( Template.staticText_Level, Created_PetLev )
		Created_PetLev:SetPosX( 70 )
		Created_PetLev:SetPosY( 10 )
		Created_PetLev:SetShow( true )
		tempSlot.PetLev = Created_PetLev

		local Created_PetName = UI.createControl( UI_PUCT.PA_UI_CONTROL_STATICTEXT, Created_ListContentBG, 'PetListNew_PetName_' .. listIdx )
		CopyBaseProperty( Template.staticText_PetName, Created_PetName )
		Created_PetName:SetPosX( 110 )
		Created_PetName:SetPosY( 10 )
		Created_PetName:SetShow( true )
		tempSlot.PetName = Created_PetName

		local Created_PetHungry = UI.createControl( UI_PUCT.PA_UI_CONTROL_STATIC, Created_ListContentBG, 'PetListNew_PetHungry_' .. listIdx )
		CopyBaseProperty( Template.staticText_Hungry, Created_PetHungry )
		Created_PetHungry:SetPosX( 70 )
		Created_PetHungry:SetPosY( 30 )
		Created_PetHungry:SetShow( true )
		tempSlot.PetHungry = Created_PetHungry

		local Created_PetHungryProgressBG = UI.createControl( UI_PUCT.PA_UI_CONTROL_STATIC, Created_ListContentBG, 'PetListNew_PetHungryProgressBG_' .. listIdx )
		CopyBaseProperty( Template.static_Progress_Hungry_BG, Created_PetHungryProgressBG )
		Created_PetHungryProgressBG:SetPosX( 105 )
		Created_PetHungryProgressBG:SetPosY( 37 )
		Created_PetHungryProgressBG:SetShow( true )
		tempSlot.PetHungryProgressBG = Created_PetHungryProgressBG

		local Created_PetHungryProgress = UI.createControl( UI_PUCT.PA_UI_CONTROL_PROGRESS2, Created_PetHungryProgressBG, 'PetListNew_PetHungryProgress_' .. listIdx )
		CopyBaseProperty( Template.static_Progress_Hungry, Created_PetHungryProgress )
		Created_PetHungryProgress:SetPosX( 1 )
		Created_PetHungryProgress:SetPosY( 1 )
		Created_PetHungryProgress:SetCurrentProgressRate( 100 )
		Created_PetHungryProgress:SetProgressRate( 80 )
		Created_PetHungryProgress:SetShow( true )
		tempSlot.PetHungryProgress = Created_PetHungryProgress
		------------------------------ 애정도 임시 숨김.
		local Created_PetLovely = UI.createControl( UI_PUCT.PA_UI_CONTROL_STATIC, Created_ListContentBG, 'PetListNew_PetLovely_' .. listIdx )
		CopyBaseProperty( Template.staticText_Lovely, Created_PetLovely )
		Created_PetLovely:SetPosX( 185 )
		Created_PetLovely:SetPosY( 30 )
		Created_PetLovely:SetShow( false )
		tempSlot.PetLovely = Created_PetLovely

		local Created_PetLovelyProgressBG = UI.createControl( UI_PUCT.PA_UI_CONTROL_STATIC, Created_ListContentBG, 'PetListNew_PetLovelyProgressBG_' .. listIdx )
		CopyBaseProperty( Template.static_Progress_Lovely_BG, Created_PetLovelyProgressBG )
		Created_PetLovelyProgressBG:SetPosX( 220 )
		Created_PetLovelyProgressBG:SetPosY( 37 )
		Created_PetLovelyProgressBG:SetShow( false )
		tempSlot.PetLovelyProgressBG = Created_PetLovelyProgressBG

		local Created_PetLovelyProgress = UI.createControl( UI_PUCT.PA_UI_CONTROL_PROGRESS2, Created_PetLovelyProgressBG, 'PetListNew_PetLovelyProgress_' .. listIdx )
		CopyBaseProperty( Template.static_Progress_Lovely, Created_PetLovelyProgress )
		Created_PetLovelyProgress:SetPosX( 1 )
		Created_PetLovelyProgress:SetPosY( 1 )
		Created_PetLovelyProgress:SetCurrentProgressRate( 100 )
		Created_PetLovelyProgress:SetProgressRate( 80 )
		Created_PetLovelyProgress:SetShow( false )
		tempSlot.PetLovelyProgress = Created_PetLovelyProgress
		------------------------------ 애정도 임시 숨김.
		local Created_BTNInfo = UI.createControl( UI_PUCT.PA_UI_CONTROL_BUTTON, Created_ListContentBG, 'PetListNew_PetBTNInfo_' .. listIdx )
		CopyBaseProperty( Template.button_Info, Created_BTNInfo )
		Created_BTNInfo:SetPosX( 300 )
		Created_BTNInfo:SetPosY( 5 )
		Created_BTNInfo:SetShow( true )
		tempSlot.BTNInfo = Created_BTNInfo

		local Created_BTNUnregister = UI.createControl( UI_PUCT.PA_UI_CONTROL_BUTTON, Created_ListContentBG, 'PetListNew_PetBTNUnregister_' .. listIdx )
		CopyBaseProperty( Template.button_Unregister, Created_BTNUnregister )
		Created_BTNUnregister:SetPosX( 300 )
		Created_BTNUnregister:SetPosY( 5 )
		Created_BTNUnregister:SetShow( true )
		tempSlot.BTNUnregister = Created_BTNUnregister

		local Created_BTNSeal = UI.createControl( UI_PUCT.PA_UI_CONTROL_BUTTON, Created_ListContentBG, 'PetListNew_PetBTNSeal_' .. listIdx )
		CopyBaseProperty( Template.button_Seal, Created_BTNSeal )
		Created_BTNSeal:SetPosX( 340 )
		Created_BTNSeal:SetPosY( 10 )
		Created_BTNSeal:SetShow( true )
		tempSlot.BTNSeal = Created_BTNSeal

		itemList_PosY	= itemList_PosY + Created_ListContentBG:GetSizeY() + 5
		self.listUIPool[listIdx] = tempSlot
	end
end
function PetList:SetScroll()
	local listCount			= ToClient_getPetSealedList()
	local pagePercent		= ( self.listMaxCount / listCount ) * 100
	local scroll_Interval	= listCount - self.listMaxCount
	local scrollSizeY		= self.scroll:GetSizeY()
	local btn_scrollSizeY	= ( scrollSizeY / 100 ) * pagePercent

	if btn_scrollSizeY < 10 then
		btn_scrollSizeY = 10
	end
	if scrollSizeY <= btn_scrollSizeY then
		btn_scrollSizeY = scrollSizeY * 0.99
	end

	self.scrollCtrBTN:SetSize( self.scrollCtrBTN:GetSizeX(), btn_scrollSizeY )
	self.scrollInterval	= scroll_Interval
	self.scroll:SetInterval( self.scrollInterval )
end
function PetList:Update( startIdx )
	-- 초기화
	for restIdx = 0, self.listMaxCount -1 do
		local UiBase = self.listUIPool[restIdx]
		UiBase.ListContentBG		:SetShow(false)
	end

	self.UnSealDATACount	= ToClient_getPetUnsealedList()

	local PetUnSealData				= ToClient_getPetUnsealedDataByIndex( 0 )
	if nil ~= PetUnSealData then
		local unsealPetStaticStatus		= PetUnSealData:getPetStaticStatus()
		local unsealIconPath			= unsealPetStaticStatus:getIconPath()
		local unsealPetNo_s64			= PetUnSealData:getPcPetNo()
		local unsealPetName				= PetUnSealData:getName()
		local unsealPetLevel			= PetUnSealData:getLevel()
		local unsealPetlovely			= PetUnSealData:getLovely()
		local unsealPethungry			= PetUnSealData:getHungry()
		local unsealMaxLevel			= unsealPetStaticStatus._maxLevel
		local unsealMaxHungry			= unsealPetStaticStatus._maxHungry
		local unsealLovelyPercent		= 0
		if 0 ~= petlovely then
			unsealLovelyPercent		= (unsealPetlovely / 100) * 100
		end
		local unsealHungruPercent		= (unsealPethungry / unsealMaxHungry) * 100
		if unsealHungruPercent <= 30 then
			self.TXT_HungryAlert:SetShow( true )
			Panel_Party:SetSpanSize( 10, 260 )
		else
			self.TXT_HungryAlert:SetShow( false )
			Panel_Party:SetSpanSize( 10, 240 )
		end

		Template.static_IconPet				:ChangeTextureInfoName( unsealIconPath )
		Template.staticText_PetName			:SetText( unsealPetName )
		Template.staticText_Level			:SetText( "Lv." .. unsealPetLevel )
		Template.static_Progress_Hungry		:SetProgressRate( unsealHungruPercent )
		Template.static_Progress_Lovely		:SetProgressRate( unsealLovelyPercent )

		PetList.BTN_UnSeal					:SetShow( true )
		Template.button_Info				:addInputEvent( "Mouse_LUp", "petListNew_ShowInfo( \"" .. tostring(unsealPetNo_s64) .. "\" )")
		PetList.BTN_UnSeal					:addInputEvent( "Mouse_LUp", "petListNew_Seal( \"" .. tostring(unsealPetNo_s64) .. "\" )")
		-- Template.button_Seal				:SetText( PAGetString(Defines.StringSheet_GAME, "LUA_PETLIST_BTN_SEAL") ) -- "넣기"


		self.noneUnsealPet					:SetShow( false )
		Template.static_IconPetBG			:SetShow( true )
		Template.static_IconPet				:SetShow( true )
		Template.staticText_PetName			:SetShow( true )
		Template.staticText_Level			:SetShow( true )
		Template.staticText_Hungry			:SetShow( true )
		Template.static_Progress_Hungry_BG	:SetShow( true )
		Template.static_Progress_Hungry		:SetShow( true )
		Template.staticText_Lovely			:SetShow( false )
		Template.static_Progress_Lovely_BG	:SetShow( false )
		Template.static_Progress_Lovely		:SetShow( false )
		Template.button_Info				:SetShow( true )
		Template.button_Unregister			:SetShow( false )
		Template.button_Seal				:SetShow( false )
	else
		self.noneUnsealPet					:SetShow( true )

		Template.staticText_PetName			:SetText( PAGetString(Defines.StringSheet_GAME, "LUA_PETLIST_TEXT_NOGETPET") ) -- "찾은 애완동물이 없습니다."
		Template.staticText_Level			:SetText( "" )
		Template.static_Progress_Hungry		:SetProgressRate( 0 )
		Template.static_Progress_Lovely		:SetProgressRate( 0 )
		Template.button_Info				:addInputEvent( "Mouse_LUp", "")
		Template.button_Seal				:addInputEvent( "Mouse_LUp", "")

		Template.static_IconPetBG			:SetShow( false )
		Template.static_IconPet				:SetShow( false )
		Template.staticText_PetName			:SetShow( false )
		Template.staticText_Level			:SetShow( false )
		Template.staticText_Hungry			:SetShow( false )
		Template.static_Progress_Hungry_BG	:SetShow( false )
		Template.static_Progress_Hungry		:SetShow( false )
		Template.staticText_Lovely			:SetShow( false )
		Template.static_Progress_Lovely_BG	:SetShow( false )
		Template.static_Progress_Lovely		:SetShow( false )
		Template.button_Info				:SetShow( false )
		Template.button_Unregister			:SetShow( false )
		Template.button_Seal				:SetShow( false )
		PetList.BTN_UnSeal					:SetShow( false )
	end

	self.SealDATACount		= ToClient_getPetSealedList()
	local petSealCount		= self.SealDATACount
	for listIdx = 0, petSealCount - 1 do
		local dataIdx				= startIdx + listIdx
		local PetSealData			= ToClient_getPetSealedDataByIndex( dataIdx )
		if nil == PetSealData then
			return
		end
		local PetStaticStatus		= PetSealData:getPetStaticStatus()
		local characterStaticStatus	= PetStaticStatus:getCharacterStaticStatus()
		local iconPath				= PetStaticStatus:getIconPath()
		local petNo_s64				= PetSealData._petNo
		local petName				= PetSealData:getName()
		local petLevel				= PetSealData._level
		local petlovely				= PetSealData._lovely
		local pethungry				= PetSealData._hungry
		local maxLevel				= PetStaticStatus._maxLevel
		local maxHungry				= PetStaticStatus._maxHungry
		local lovelyPercent			= 0
		if 0 ~= petlovely then
			lovelyPercent			= (petlovely / 100) * 100
		end
		
		local hungruPercent			= (pethungry / maxHungry) * 100

		local UiBase = self.listUIPool[listIdx]
		UiBase.ListContentBG		:SetShow(true)
		UiBase.PetIcon				:ChangeTextureInfoName( iconPath )
		UiBase.PetLev				:SetText( "Lv." .. petLevel )
		UiBase.PetName				:SetText( petName )
		UiBase.PetHungryProgress	:SetProgressRate( hungruPercent )
		UiBase.PetLovelyProgress	:SetProgressRate( lovelyPercent )

		UiBase.BTNInfo				:SetShow( false )
		UiBase.BTNUnregister		:SetShow( false ) -- 고양이는 유료캐쉬템이기 때문에 놓아주기 버튼을 노출시키지 않는다.
		-- UiBase.BTNSeal				:SetText( PAGetString(Defines.StringSheet_GAME, "LUA_PETLIST_BTN_FIND") ) -- "찾기"
		UiBase.BTNSeal				:addInputEvent( "Mouse_LUp", "petListNew_UnSeal( \"" .. tostring(petNo_s64) .. "\" )" )		-- petNo
		UiBase.BTNUnregister		:addInputEvent( "Mouse_LUp", "petListNew_UnRegister( \"" .. tostring(petNo_s64) .. "\" )" )		-- petNo

		if petSealCount <= self.listMaxCount then	-- 스크롤 보여줄까?
			self.scroll:SetShow( false )
		else
			self.scroll:SetShow( true )
		end

		if listIdx == (self.listMaxCount - 1) then
			return
		end
	end
end
function PetList:SetPosition()
	local scrSizeX		= getScreenSizeX()
	local scrSizeY		= getScreenSizeY()
	local panelSizeX 	= Panel_Window_PetListNew:GetSizeX()
	local panelSizeY 	= Panel_Window_PetListNew:GetSizeY()

	Panel_Window_PetListNew:SetPosX( (scrSizeX / 2) - (panelSizeX / 2) )
	Panel_Window_PetListNew:SetPosY( (scrSizeY / 2) - (panelSizeY / 2) )
end

function PetList:Open()
	self.scroll:SetControlTop()
	self:SetPosition()
	self:SetScroll()						-- 데이터를 카운트 해 인터벌을 정함.
	-- UI.debugMessage(self.startIndex)
	self.startIndex = 0
	self:Update( self.startIndex )
	
	Panel_Window_PetListNew:SetShow( true, true )
end
function PetList:Close()
	self.scroll:SetControlTop()
	self.startIndex = 0
	Panel_Window_PetListNew:SetShow( false, false )
end

function PetListNew_ScrollEvent( isDown )
	local self		= PetList
	local index		= self.startIndex
	local dataCount = self.SealDATACount

	if true == isDown then
		if ((dataCount - 1) - (self.listMaxCount - 1) - 1) < index then
			return
		end

		if index < self.scrollInterval then
			self.scroll:ControlButtonDown()
			index = index + 1
		else
			return
		end
	else
		if 0 < index then
			self.scroll:ControlButtonUp()
			index = index - 1
		else
			return
		end
	end	
	
	self.startIndex = index
	self:Update( index )
end
function HandleClicked_PetList_ScrollBtn()
	local self				= PetList
	local listCount			= ToClient_getPetSealedList()
	local posByIndex		= 1 / ( listCount - self.listMaxCount )
	local currentIndex		= math.floor( self.scroll:GetControlPos() / posByIndex )
	self.startIndex	= currentIndex
	self:Update( self.startIndex )
end

function petListNew_ShowInfo( petNoStr )
	audioPostEvent_SystemUi(01,40)
	FGlobal_PetInfoNew_Open( tonumber64(petNoStr) )
end
function petListNew_Seal( petNoStr )
	audioPostEvent_SystemUi(01,40)

	local self = PetList
	local petNo_s64 = tonumber64(petNoStr)
	-- _PA_LOG("test", petNoStr);
	ToClient_requestPetSeal( petNo_s64 )

	FGlobal_PetContorl_HungryGaugeUpdate()
	FGlobal_PetControl_SealPet()	-- 컨트롤 초기화
	self.startIndex = 0
	self.scroll:SetControlTop()
	self:Update( self.startIndex )	-- 나중엔 빼야 한다.

	-- Panel_MovieGuideButton:SetShow( true )	-- 펫을 보유하고 있지 않으므로 원래 위치로 고정.
	-- Panel_MovieGuideButton:SetPosX( 20 )		-- 펫을 보유하고 있지 않으므로 원래 위치로 고정.
	-- Panel_MovieGuideButton:SetPosX( self.Btn_IconPet:GetSizeX() + 20 ) -- 펫을 보유하고 있으므로 이 위치에 무비버튼을 고정.
	-- Panel_Window_NoPetIcon:SetShow( true )
	-- Panel_Window_NoPetIcon:SetPosX( 10 )
	-- Panel_Window_NoPetIcon:SetPosY( Panel_SelfPlayerExpGage:GetSizeY() * 2 )
	-- FGlobal_PetListNew_NoPet()
end
function petListNew_UnSeal( petNoStr )
	audioPostEvent_SystemUi(01,40)
	
	local self = PetList
	local petNo_s64 = tonumber64(petNoStr)
	-- _PA_LOG("test", petNoStr);
	ToClient_requestPetUnseal( petNo_s64 )
	FGlobal_PetContorl_HungryGaugeUpdate()
	-- Panel_Window_NoPetIcon:SetShow(false)
	-- FGlobal_PetListNew_NoPet()

	self.startIndex = 0
	self.scroll:SetControlTop()
	self:Update( self.startIndex )	-- 나중엔 빼야 한다.
end
function petListNew_UnRegister( petNoStr )
	audioPostEvent_SystemUi(01,40)

	local self = PetList
	local petNo_s64 = tonumber64(petNoStr)
	ToClient_requestPetUnregister( petNo_s64 )

	self.startIndex = 0
	self.scroll:SetControlTop()
	self:Update( self.startIndex )	-- 나중엔 빼야 한다.
end
function FGlobal_PetListNew_Open()
	PetList:Open()
	-- PetList:SetScroll()
end

function FGlobal_PetListNew_Close()
	PetList:Close()
end

function FGlobal_PetListNew_Toggle()
	if Panel_Window_PetListNew:GetShow() then
		PetList:Close()
	else
		PetList:Open()
		audioPostEvent_SystemUi( 01,40 )
	end
end

function FromClient_PetUpdate()
	PetList:Update( PetList.startIndex )
	FGlobal_PetControl_CheckUnSealPet()
	PetList:SetScroll()
end

function FGlobal_PetListNew_NoPet()
	local petCount			= ToClient_getPetSealedList()	-- 맡겨진 펫 갯수 리턴
	local unSealPetCount	= ToClient_getPetUnsealedList() -- 찾은 펫 갯수 리턴
	local PcPetData 		= ToClient_getPetUnsealedDataByIndex( 0 )

	if 0 == petCount and nil ~= PcPetData then		-- 등록한 펫이 1개인데 찾은 상태일 때(펫을 1개만 등록한 상태)
		Panel_Window_NoPetIcon:SetShow( false )
	elseif 0 < petCount and nil == PcPetData then	-- 등록한 펫이 있지만 펫이 맡겨진 상태일 때(등록한 펫이 있을 때)
		Panel_Window_NoPetIcon:SetShow( true )
		Panel_Window_NoPetIcon:SetPosX( 10 )
		Panel_Window_NoPetIcon:SetPosY( Panel_SelfPlayerExpGage:GetSizeY() * 2 )
		Panel_MovieGuideButton:SetPosX( 67 )
	elseif 0 < petCount and nil ~= PcPetData then		-- 등록한 펫도 있고 찾은 펫도 있을 때(펫이 2마리 이상 보유했을 때)
		Panel_Window_NoPetIcon:SetShow( false )
	elseif 0 == petCount and nil == PcPetData then	-- 찾은말도 등록한 말도 없는 펫 미보유일 때( 펫이 아예 없을 때 )
		Panel_Window_NoPetIcon:SetShow( false )
	end
end

function PetList:registEventHandler()
	self.panelBG		:addInputEvent("Mouse_DownScroll",		"PetListNew_ScrollEvent( true )")
	self.panelBG		:addInputEvent("Mouse_UpScroll",		"PetListNew_ScrollEvent( false )")
	self.scrollCtrBTN	:addInputEvent("Mouse_DownScroll",		"PetListNew_ScrollEvent( true )")
	self.scrollCtrBTN	:addInputEvent("Mouse_UpScroll",		"PetListNew_ScrollEvent( false )")
	self.scroll			:addInputEvent("Mouse_DownScroll",		"PetListNew_ScrollEvent( true )")
	self.scroll			:addInputEvent("Mouse_UpScroll",		"PetListNew_ScrollEvent( false )")

	self.BTN_Close		:addInputEvent("Mouse_LUp",				"FGlobal_PetListNew_Close()")
	self.scrollCtrBTN	:addInputEvent("Mouse_LPress",			"HandleClicked_PetList_ScrollBtn()")
	self.scroll			:addInputEvent("Mouse_LUp",				"HandleClicked_PetList_ScrollBtn()")
end

function PetList:registMessageHandler()
	registerEvent("FromClient_PetAddSealedList",		"FromClient_PetUpdate")	-- 인자 petNo
	registerEvent("FromClient_PetDelSealedList",		"FromClient_PetUpdate")	-- 인자 petNo
	registerEvent("FromClient_PetAddList",				"FromClient_PetUpdate")	-- 인자 petNo
	registerEvent("FromClient_PetDelList",				"FromClient_PetUpdate")	-- 인자 petNo
	registerEvent("FromClient_InputPetName",			"FromClient_PetUpdate")	-- 인자 ( fromWhereType, fromSlotNo )	petregister에서 써야 함.
	registerEvent("FromClient_PetAddSealedList",		"FGlobal_PetListNew_NoPet")
	registerEvent("FromClient_PetInfoChanged",			"FGlobal_PetListNew_NoPet")
	registerEvent("FromClient_PetInfoChanged",			"FromClient_PetUpdate")
	registerEvent("FromClient_PetAddList",				"FGlobal_PetListNew_NoPet")
end


PetList:Initialize()
FGlobal_PetListNew_NoPet()
PetList:registEventHandler()
PetList:registMessageHandler()
UI.addRunPostRestorFunction( FGlobal_PetListNew_NoPet )


-- getPetSealedList : 맡겨져있는 펫 리스트데이타 (리턴 : 갯수)
-- getPetSealedDataByIndex : 인덱스로 실제 데이터 뺴오기(리턴 PetSealData : _characterKey)
	-- getCharacterStaticStatus
	-- getPetStaticStatus
-- getPetUnsealedList : 찾아져있는 펫리스트(리턴:갯수)
-- getPetUnsealedDataByIndex : 인덱스에 해당하는 찾아져있는 펫 데이터(리턴 : PcPetData)

-- PcPetData : getCharacterKey()
-- getPetStaticStatus()
-- getCharacterStaticStatus()
-- getPcPetNo()
-- getLevel()
-- getExperience()
-- getMaxExperience()
-- getLovely() - 애정도
-- getHungry() - 배고픔
-- isPetActionLearned(0~9) 까지 펫 고유액션 배웠는지여부

-- - PetStaticStatus : 
--  _type, 
--  _level
--  isPassiveSkill()
--  getCoolTime()
 
-- requestPetUnegister(petNo) : 방생
-- requestPetSeal(petNo) : 맡기기
-- requestPetUnseal(petNo) : 찾기

-- ToClient_callHandlerToPet("handleDefenceMode") 이런식으로... 

-- 따라와,     (handlePetFollowMaster)
-- 기다려      (handlePetWaitMaster)
-- 주워,      (handlePetGetItemOn)
-- 주워,      (handlePetGetItemOff)
-- 찾아,      (handlePetFindThatOn)
-- 찾아,      (handlePetFindThatOff)