local UI_ANI_ADV 	= CppEnums.PAUI_ANIM_ADVANCE_TYPE
local UI_color 		= Defines.Color
local UI_TM			= CppEnums.TextMode

Panel_FixEquip:setMaskingChild(true)
Panel_FixEquip:RegisterShowEventFunc( true, 'FixEquip_ShowAni()' )
Panel_FixEquip:RegisterShowEventFunc( false, 'FixEquip_HideAni()' )

-- Panel_FixEquip:SetShow( true )		--삭제해야함 테스트용

-- local _enchantEffect 			= UI.getChildControl ( Panel_FixEquip, "Static_AddEffect" )

local fixEquip =
{
	slotConfig =
	{
		createIcon		= false,
		createBorder	= true,
		createCount		= true,
		createEnchant	= true,
		createCash		= true
	},
	control =
	{
		buttonApply 	= UI.getChildControl( Panel_FixEquip, "Button_Apply" ),
		staticDesc 		= UI.getChildControl( Panel_FixEquip, "Static_Text_Description" ),
		enchantNumber	= UI.getChildControl( Panel_FixEquip, "Static_Text_Slot_Enchant_value" ),
		fixHelp			= UI.getChildControl( Panel_FixEquip, "StaticText_HelpDesc" )
	},
	
	slotMain= nil,
	slotSub	= nil
}

fixEquip.control.fixHelp:SetTextMode( CppEnums.TextMode.eTextMode_AutoWrap )	-- Auto Wrap
fixEquip.control.fixHelp:SetText( PAGetString(Defines.StringSheet_GAME, "LUA_FIXEQUIP_REPAIR_TEXT_HELP") ) -- "잦은 잠재력 돌파로 인해 손상된 내구도를 복구할 수 있습니다. 손상된 무기와 같은 무기를 하나 더 올려놓아 최대 내구도를 복구하세요."

local uiHelp =
{
	_slot_0_Notice = UI.getChildControl ( Panel_FixEquip, "StaticText_Notice_Slot_0" ),
	_slot_1_Notice = UI.getChildControl ( Panel_FixEquip, "StaticText_Notice_Slot_1" ),
}

local tmpEnchantLevel = 0
local ENCAHNT_PROGRESS_TIME = 4.0		-- 진행되는 초를 설정한다 (Progress Bar)
local checked_EnchantItemType = 0		-- 0: 무기, 1: 방어구

local 	_buttonQuestion = UI.getChildControl( Panel_FixEquip, "Button_Question" )			-- 물음표 버튼
_buttonQuestion:addInputEvent( "Mouse_LUp", "Panel_WebHelper_ShowToggle( \"PanelFixEquip\" )" )									-- 물음표 좌클릭
_buttonQuestion:addInputEvent( "Mouse_On", "HelpMessageQuestion_Show( \"PanelFixEquip\", \"true\")" )					-- 물음표 마우스오버
_buttonQuestion:addInputEvent( "Mouse_Out", "HelpMessageQuestion_Show( \"PanelFixEquip\", \"false\")" )				-- 물음표 마우스아웃

-----------------------------------------------------------------------------------------
--					마우스 이벤트로 슬롯에 있는 아이템을 뺄 수 있다!
-----------------------------------------------------------------------------------------
local FixEquip_MouseEvent_OutSlots_Done = function( isDone )
	if ( isDone == true ) then
		fixEquip.slotMain.icon:addInputEvent( "Mouse_RUp", "FixEquip_OutSlots()" )
		fixEquip.slotSub.icon:addInputEvent( "Mouse_RUp", "FixEquip_OutSlots()" )
	else
		fixEquip.slotMain.icon:addInputEvent( "Mouse_RUp", "" )
		fixEquip.slotSub.icon:addInputEvent( "Mouse_RUp", "" )
	end
end

-----------------------------------------------------------------------------------------
--						기본 데이터를 클리어 해주는 함수!
-----------------------------------------------------------------------------------------
local FixEquip_clearData = function()
	
	local self = fixEquip
	
	self.slotMain:clearItem()
	self.slotMain.empty		= true
	self.slotMain.whereType	= nil
	self.slotMain.slotNo	= nil
	self.slotMain.itemKey	= nil
	
	self.slotSub:clearItem()
	self.slotSub.empty		= true
	self.slotSub.whereType	= nil
	self.slotSub.slotNo		= nil

	-- Panel_FixEquip:EraseAllEffect()
	-- self.control.buttonApply:EraseAllEffect()
	self.control.buttonApply:SetIgnore( true )
	self.control.buttonApply:SetMonoTone( true )
	self.control.buttonApply:SetEnable( false )
	self.control.buttonApply:SetText(PAGetString(Defines.StringSheet_GAME, "LUA_FIXEQUIP_REPAIR_MAXENDURANCE" ))		-- 최대 내구도 수리, 돌파!
	self.control.buttonApply:SetAlpha( 0.85 )
	
	FixEquip_MouseEvent_OutSlots_Done( true )		-- 슬롯에 있던 아이템을 우클릭으로 뺀다!
	
end


-----------------------------------------------------------------------------------------
--							컨트롤을 만들어주도록 하자
-----------------------------------------------------------------------------------------
local	slotMain= {}
local	slotSub	= {}
local FixEquip_createControl = function()
	slotMain.icon = UI.getChildControl( Panel_FixEquip, "Static_Slot_0" )
	SlotItem.new( slotMain, 'Slot_0', 0, Panel_FixEquip, fixEquip.slotConfig )
	slotMain:createChild()
	slotMain.empty = true
	slotMain.icon:addInputEvent( "Mouse_On", "Panel_FixEquipMouseOnEvent(0, \"FixEquip\", true)" )
	slotMain.icon:addInputEvent( "Mouse_Out","Panel_FixEquipMouseOnEvent(0, \"FixEquip\", false)" )
	Panel_Tooltip_Item_SetPosition(0, slotMain, "FixEquip")
	
	fixEquip.slotMain = slotMain
	
	slotSub.icon = UI.getChildControl( Panel_FixEquip, "Static_Slot_1" )
	SlotItem.new( slotSub, 'Slot_1', 1, Panel_FixEquip, fixEquip.slotConfig )
	slotSub:createChild()
	slotSub.empty = true
	slotSub.icon:addInputEvent( "Mouse_On", "Panel_FixEquipMouseOnEvent(1, \"FixEquip\", true)" )
	slotSub.icon:addInputEvent( "Mouse_Out","Panel_FixEquipMouseOnEvent(1, \"FixEquip\", false)" )
	Panel_Tooltip_Item_SetPosition(1, slotSub, "FixEquip")
	
	fixEquip.slotSub = slotSub

	FixEquip_clearData()
end

function Panel_FixEquipMouseOnEvent( index, type, isMouseOn )
	if ( slotMain.empty ) then
		if ( index == 0 ) then
			--왼쪽거
			if ( isMouseOn == true ) then
				uiHelp._slot_1_Notice:SetShow( true )
				uiHelp._slot_1_Notice:SetTextMode( UI_TM.eTextMode_AutoWrap )
				uiHelp._slot_1_Notice:SetAutoResize( true )
				uiHelp._slot_1_Notice:SetSize( 220, 86 )
				uiHelp._slot_1_Notice:SetText(PAGetString(Defines.StringSheet_GAME, "LUA_FIXEQUIP_REPAIR_MAXENDURANCE_GUIDE1" )) -- 최대 내구도를 수리할 아이템을 넣으세요.
				uiHelp._slot_1_Notice:SetSize ( uiHelp._slot_1_Notice:GetSizeX() + 5, uiHelp._slot_1_Notice:GetSizeY() + 30 )
			else
				uiHelp._slot_1_Notice:SetShow(false)
			end
		end
	else
		Panel_Tooltip_Item_Show_GeneralNormal( index, type, isMouseOn )
	end
	
	if ( slotSub.empty ) then
		if ( index == 1 ) then
			--오른쪽거
			if ( isMouseOn == true ) then
				uiHelp._slot_0_Notice:SetShow( true )
				uiHelp._slot_0_Notice:SetTextMode( UI_TM.eTextMode_AutoWrap )
				uiHelp._slot_0_Notice:SetAutoResize( true )
				uiHelp._slot_0_Notice:SetSize( 220, 86 )
				uiHelp._slot_0_Notice:SetText(PAGetString(Defines.StringSheet_GAME, "LUA_FIXEQUIP_REPAIR_MAXENDURANCE_GUIDE2" )) -- 재료로 쓸 아이템을 넣으세요. (수리할 아이템과 같아야 합니다.)
				uiHelp._slot_0_Notice:SetSize ( uiHelp._slot_0_Notice:GetSizeX() + 5, uiHelp._slot_0_Notice:GetSizeY() + 30 )
			else
				uiHelp._slot_0_Notice:SetShow(false)
			end
		end
	else
		Panel_Tooltip_Item_Show_GeneralNormal( index, type, isMouseOn )
	end
end

-- 
function IsReadyToReapirMaxEndurance()
	local	self	= fixEquip
	if	(nil == self.slotMain.slotNo)	then
		return(false)
	end
	
	if	(nil == self.slotSub.slotNo)	then
		return(false)
	end
	
	return(true)
end

-- 아이템 배치
function Panel_FixEquip_InteractortionFromInventory( slotNo, itemWrapper, count, inventoryType )
	local self = fixEquip

	local	itemWrapper	= getInventoryItemByType(inventoryType, slotNo)
	if( nil == itemWrapper )	then
		return
	end
	
	if	(self.slotMain.empty)	then
		-- 들어오는대로 이펙트를 뿌려준다
		-- if ( self.slotMain.icon ) then
			-- self.slotMain.icon:AddEffect( "UI_Button_Hide", false, 0, 0 )
		-- end

		self.slotMain:setItem( itemWrapper )
		
		self.slotMain.empty		= false
		self.slotMain.whereType	= inventoryType
		self.slotMain.slotNo	= slotNo
		self.slotMain.itemKey	= itemWrapper:get():getKey()
		
		-- INVENTORY_FILTER ON ENCHANT_SUB_ITEM
		Inventory_SetFunctor( FixEquip_InvenFiler_SubItem, Panel_FixEquip_InteractortionFromInventory, FixEquip_Close, nil )
		
	elseif	(self.slotSub.empty)	then
	
		-- _enchantEffect:AddEffect( "fUI_Gauge_Blue", true, 0, 0 )
		-- self.slotSub.icon:EraseAllEffect()
		-- self.slotSub.icon:AddEffect( "fUI_DarkstoneAura02", false, 0, 0 )
		-- self.slotSub.icon:AddEffect( "UI_Button_Hide", false, 0, 0 )
		-- checked_EnchantItemType = 0
		
		self.slotSub:setItem( itemWrapper )
		
		self.slotSub.empty		= false
		self.slotSub.whereType	= inventoryType
		self.slotSub.slotNo		= slotNo

	else
		-- _enchantEffect:EraseAllEffect()
		UI.ASSERT( false, 'Client data, UI data is Mismatch!!!!!' )
		return
	end

	local isReady = IsReadyToReapirMaxEndurance()
	if ( isReady == true ) then
		self.control.buttonApply:AddEffect( "UI_Equip_Repair", true, 0, -1 )
		self.control.buttonApply:SetIgnore( false )
		self.control.buttonApply:SetMonoTone( false )
		self.control.buttonApply:SetEnable( true )
		self.control.buttonApply:SetAlpha( 1.0 )
		self.control.buttonApply:addInputEvent( "Mouse_LUp", "FixEquip_ApplyButton()" )
		
	else
		self.control.buttonApply:EraseAllEffect()
		self.control.buttonApply:SetIgnore( true )
		self.control.buttonApply:SetMonoTone( true )
		self.control.buttonApply:SetEnable( false )
		self.control.buttonApply:SetAlpha( 0.85 )
		self.control.buttonApply:addInputEvent( "Mouse_LUp", "" )
	end
	FixEquip_MouseEvent_OutSlots_Done( true )		-- 슬롯에 있던 아이템을 우클릭으로 뺀다!
end

-----------------------------------------------------------------------------------------
-- 					
-----------------------------------------------------------------------------------------
function FixEquip_ApplyButton()
	local self = fixEquip
	-- _enchantEffect:EraseAllEffect()
	
	--{
		local dontFix = function()
			closeFix()
			return
		end
	
		local closeFix = function()
			self.control.buttonApply:EraseAllEffect()
			FixEquip_clearData()
			Inventory_SetFunctor( FixEquip_InvenFiler_MainItem, Panel_FixEquip_InteractortionFromInventory, FixEquip_CloseButton, nil  )
		end
		
		local doFixEquipMaxEndurance = function()
		repair_MaxEndurance( self.slotMain.whereType, self.slotMain.slotNo, self.slotSub.whereType, self.slotSub.slotNo )
		closeFix()
		return
	end
	--}
	
	local self = fixEquip
	if ( nil ~= self.slotMain.slotNo and nil ~= self.slotSub.slotNo ) then

		local titleString	= "알  림"
		local contentString	= "최대 내구도 복구 시 재료로 사용된 아이템은 파괴됩니다.\n이대로 진행하시겠습니까?"
		local messageboxData= { title = titleString
							, content = contentString, functionYes = doFixEquipMaxEndurance, functionCancel = dontFix, priority = CppEnums.PAUIMB_PRIORITY.PAUIMB_PRIORITY_LOW}
		MessageBox.showMessageBox(messageboxData)
	else
		closeFix()
	end
	
	
end

function FixEquip_InvenFiler_MainItem( slotNo, itemWrapper )
	if nil == itemWrapper then
		return true
	end

	local isAble = itemWrapper:checkToRepairItemMaxEndurance();	-- 민우씨 이부분을 수정해야 합니다.
	return (not isAble);

end

-- return true will be grayscale and disable!
function	FixEquip_InvenFiler_SubItem( slotNo, itemWrapper, count, inventoryType )
	if nil == itemWrapper then
		return true
	end

	local self = fixEquip
	local isAble = false;
	if( self.slotMain.itemKey:getItemKey() == itemWrapper:get():getKey():getItemKey() ) then
		if( self.slotMain.slotNo ~= slotNo or self.slotMain.whereType ~= inventoryType ) then
			isAble = true
		end
	end
	return( not isAble )
end

function FixEquip_GetMainSlotNo()
	return fixEquip.slotMain.slotNo
end

function FixEquip_GetSubSlotNo()
	return fixEquip.slotSub.slotNo
end

-----------------------------------------------------------------------------------------
--							우클릭으로 아이템을 뺐다!
-----------------------------------------------------------------------------------------
function FixEquip_OutSlots()
	FixEquip_clearData()								-- 데이터 클리어
	Inventory_SetFunctor( FixEquip_InvenFiler_MainItem, Panel_FixEquip_InteractortionFromInventory, FixEquip_CloseButton, nil  )			-- INVENTORY_FILTER ON ENCHANT_MAIN_ITEM
end


-----------------------------------------------------------------------------------------
--								최대 내구도 수리
-----------------------------------------------------------------------------------------
function FixEquip_Show()
	FixEquip_clearData()
	if ( Panel_FixEquip:IsShow() == false ) then
		Inventory_SetFunctor( FixEquip_InvenFiler_MainItem, Panel_FixEquip_InteractortionFromInventory, FixEquip_CloseButton, nil  )
		Panel_FixEquip:SetShow(true, false)
		InventoryWindow_Show();

		audioPostEvent_SystemUi(01,00)
	else
		FixEquip_Close()
	end
	
end

function FixEquip_Close()

	-- 꺼준다
	if ( false == Panel_FixEquip:IsShow() ) then		
		return ;
	end
		
	Panel_FixEquip:SetShow( false, true )
	Inventory_SetFunctor( nil, nil, nil, nil )
	
	FixEquip_clearData()

end

function FixEquip_HideAni()
	UIAni.AlphaAnimation( 0, Panel_FixEquip, 0.0, 0.15 ):SetHideAtEnd(true)
	audioPostEvent_SystemUi(01,01)
end

function FixEquip_GetSlotNo(slotType)
	if (1 == slotType) then
		return fixEquip.slotSub.slotNo
	else
		return fixEquip.slotMain.slotNo
	end
end


-----------------------------------------------------------------------------------------
--								취소 버튼
-----------------------------------------------------------------------------------------
function FixEquip_CancelButton()
	FixEquip_clearData()								-- 데이터 클리어
	Inventory_SetFunctor( FixEquip_InvenFiler_MainItem, Panel_FixEquip_InteractortionFromInventory, FixEquip_CloseButton, nil  )			-- INVENTORY_FILTER ON ENCHANT_MAIN_ITEM
end

function FixEquipItemBtn_LUp()
	
	if( true == Panel_FixEquip:GetShow() ) then
		FixEquip_Close()
	else
		FixEquip_Show()
	end

end


-----------------------------------------------------------------------------------------
--								일단 초기화 시켜주자
-----------------------------------------------------------------------------------------
FixEquip_createControl()


------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------
------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------



