Panel_Window_StableFunction:SetShow(false, false)
Panel_Window_StableFunction:setMaskingChild(true)
Panel_Window_StableFunction:ActiveMouseEventEffect(true)
--Panel_Window_StableFunction:setGlassBackground(true)
Panel_Window_StableFunction:RegisterShowEventFunc( true, '' )
Panel_Window_StableFunction:RegisterShowEventFunc( false, '' )

local _stableBG = UI.getChildControl( Panel_Window_StableFunction, 	"Static_StableTitle" )
_stableBG:setGlassBackground(true)

local UI_ANI_ADV 	= CppEnums.PAUI_ANIM_ADVANCE_TYPE
local UI_color 		= Defines.Color
local IM			= CppEnums.EProcessorInputMode
local	stableFunction	= {
	config	=
	{
		
	},
	
	_buttonRegister	= UI.getChildControl( Panel_Window_StableFunction,	"Button_RegisterByItem"	),	-- 등록( 마패 )
	_textRegist		= UI.getChildControl( Panel_Window_StableFunction,	"StaticText_Purpose"	),	-- 등록 시 텍스트
	
	_buttonMating	= UI.getChildControl( Panel_Window_StableFunction, 	"Button_ListMating"		),	-- 교배소 보기
	_buttonMarket	= UI.getChildControl( Panel_Window_StableFunction, 	"Button_ListMarket"		),	-- 마시장 보기
	_buttonExit		= UI.getChildControl( Panel_Window_StableFunction,	"Button_Exit"			),	-- 나가기 버튼
}
----------------------------------------------------------------------------------------------------

-- Init Function
function	stableFunction:init()
	stableFunction._textRegist:SetText( "<PAColor0xFFFFCE22>마패<PAOldColor> 또는 <PAColor0xFFFFCE22>등록증<PAOldColor>을 우클릭해 축사에 등록해주세요" )
	stableFunction._textRegist:SetShow(false)
end

function stableFunction:registEventHandler()
	self._buttonRegister:addInputEvent(	"Mouse_LUp",	"StableFunction_Button_RegisterReady()"	)
	self._buttonMating:addInputEvent(	"Mouse_LUp",	"StableFunction_Button_Mating()"		)
	self._buttonMarket:addInputEvent(	"Mouse_LUp",	"StableFunction_Button_Market()"		)
	self._buttonExit:addInputEvent(		"Mouse_LUp",	"StableFunction_Close()"				)
end

function	stableFunction:registMessageHandler()
	registerEvent("onScreenResize",				"StableFunction_Resize" )
	registerEvent("FromClient_ServantUpdate",	"StableFunction_RegisterAck")
end

function	StableFunction_Resize()
	local	self	= stableFunction
	
	local	screenX	= getScreenSizeX()
	local	screenY	= getScreenSizeY()

	Panel_Window_StableFunction:SetSize(screenX, Panel_Window_StableFunction:GetSizeY() )
	_stableBG:SetSize(screenX, Panel_Window_StableFunction:GetSizeY() )
	
	Panel_Window_StableFunction:ComputePos()
	_stableBG:ComputePos()
	self._buttonRegister:ComputePos()
	self._buttonMating:ComputePos()
	self._buttonMarket:ComputePos()
	self._buttonExit:ComputePos()
	self._textRegist:ComputePos()
	self._textRegist:SetSpanSize( 0, - screenY * 3 / 4 )
end

----------------------------------------------------------------------------------------------------
-- Button Function
function	StableFunction_Button_RegisterReady( slotNo )
	Inventory_SetFunctor( InvenFiler_Mapae, StableFunction_Button_Register, Servant_InventoryClose, nil )
	Inventory_ShowToggle()
	
	audioPostEvent_SystemUi(00,00)
end

function	StableFunction_Button_Register( slotNo, itemWrapper, count_s64, inventoryType )
	StableRegister_OpenByInventory( inventoryType, slotNo )
end

function	StableFunction_Button_Mating()
	audioPostEvent_SystemUi(00,00)
	StableList_ButtonClose()

	audioPostEvent_SystemUi(01,00)
	StableMating_Open( CppEnums.AuctionType.AuctionGoods_ServantMating )
end

function	StableFunction_Button_Market()
	audioPostEvent_SystemUi(00,00)
	StableList_ButtonClose()

	audioPostEvent_SystemUi(01,00)
	StableMarket_Open()
end

----------------------------------------------------------------------------------------------------
-- FromClient Function
function	StableFunction_RegisterAck()
	Inventory_SetFunctor( nil )
	InventoryWindow_Close()
	
	StableRegister_Close()
	
	local	self	= stableFunction
	self._buttonRegister:EraseAllEffect()
end

----------------------------------------------------------------------------------------------------
-- Window Open/Close
function	StableFunction_Open()
	if	( not stable_doHaveRegisterItem() )	then
		stableFunction._textRegist:SetShow( false )
	end

	if	( Panel_Window_StableFunction:GetShow() )	then
		return
	end

	-- ♬ 마구간이 열릴때
	
	Servant_SceneOpen( Panel_Window_StableFunction )
	
	StableList_Open()
	
	stableFunction._textRegist:SetShow( false )
	
	local	self	= stableFunction
	self._buttonMating:SetShow(false)
	self._buttonMarket:SetShow(false)	
	if	( stable_isMating() )	then
		self._buttonMating:SetShow(true)
	end
	if	( stable_isMarket() )	then
		self._buttonMarket:SetShow(true)
	end
	
	if	( stable_doHaveRegisterItem() )	then
		local	messageboxTitle	= PAGetString(Defines.StringSheet_GAME, "LUA_ALERT_DEFAULT_TITLE")
		local	messageboxMemo	= PAGetString(Defines.StringSheet_GAME, "LUA_SERVANT_STABEL_REGISTERITEM_MSG")
		local	messageboxData	= { title = messageboxTitle, content = messageboxMemo, functionApply = FGlobal_NeedStableRegistItem_Print, priority = CppEnums.PAUIMB_PRIORITY.PAUIMB_PRIORITY_LOW}
		MessageBox.showMessageBox(messageboxData)
		-- UI.Set_ProcessorInputMode(IM.eProcessorInputMode_UiMode)

		stableFunction._buttonRegister:EraseAllEffect()
		stableFunction._buttonRegister:AddEffect("UI_ArrowMark01", true, 25, -38)
	else
		stableFunction._buttonRegister:EraseAllEffect()
	end
end

function FGlobal_NeedStableRegistItem_Print()
	if	( stable_doHaveRegisterItem() )	then
		stableFunction._textRegist:SetShow( true )
	else
		stableFunction._textRegist:SetShow( false )
	end
end

function	StableFunction_Close()
	-- ♬ 마구간이 닫힐 때
	audioPostEvent_SystemUi(00,00)

	local	self	= stableFunction
	self._buttonRegister:EraseAllEffect()

	InventoryWindow_Close()
	StableList_Close()
	--StableInfoWindow_Close()
	--StableEquipInfoWindow_Hide()
	--StableRegister_Close()
	StableShop_Close()
	StableMating_Close()
	StableMarket_Close()
	
	if	( not Panel_Window_StableFunction:GetShow() )	then
		return
	end
	
	Servant_SceneClose( Panel_Window_StableFunction )
	Dialog_updateButtons( true )			-- 마패를 사용한 후 다시 마패 있는지 체크해서 마굿간 버튼에 이펙트 부여 여부 결정
end

stableFunction:init()
stableFunction:registEventHandler()
stableFunction:registMessageHandler()

StableFunction_Resize()