Panel_Window_StableInfo:SetShow(false, false)
Panel_Window_StableInfo:setMaskingChild(true)
Panel_Window_StableInfo:ActiveMouseEventEffect(true)
Panel_Window_StableInfo:SetDragEnable( true )

Panel_Window_StableInfo:RegisterShowEventFunc( true,	'StableInfoShowAni()' )
Panel_Window_StableInfo:RegisterShowEventFunc( false,	'StableInfoHideAni()' )

local UI_ANI_ADV 	= CppEnums.PAUI_ANIM_ADVANCE_TYPE
local UI_color 		= Defines.Color

UI.getChildControl( Panel_Window_StableInfo, "Stable_Info_Ability"):setGlassBackground(true)
UI.getChildControl( Panel_Window_StableInfo, "Panel_Skill"):setGlassBackground(true)

function	StableInfoShowAni()
	Panel_Window_StableInfo:SetShow(true, false)

	UIAni.fadeInSCR_Right(Panel_Window_StableInfo)
	local aniInfo3 = Panel_Window_StableInfo:addColorAnimation( 0.0, 0.20, UI_ANI_ADV.PAUI_ANIM_ADVANCE_COS_HALF_PI)
	aniInfo3:SetStartColor( UI_color.C_00FFFFFF )
	aniInfo3:SetEndColor( UI_color.C_FFFFFFFF )
	aniInfo3.IsChangeChild = false
end

function	StableInfoHideAni()
	Panel_Window_StableInfo:SetShowWithFade(CppEnums.PAUI_SHOW_FADE_TYPE.PAUI_ANI_TYPE_FADE_OUT)
	local aniInfo1 = Panel_Window_StableInfo:addColorAnimation( 0.0, 0.22, UI_ANI_ADV.PAUI_ANIM_ADVANCE_SIN_HALF_PI)
	aniInfo1:SetStartColor( UI_color.C_FFFFFFFF )
	aniInfo1:SetEndColor( UI_color.C_00FFFFFF )
	aniInfo1:SetStartIntensity( 3.0 )
	aniInfo1:SetEndIntensity( 1.0 )
	aniInfo1.IsChangeChild = true
	aniInfo1:SetHideAtEnd(true)
	aniInfo1:SetDisableWhileAni(true)

	-- local aniInfo2 = Panel_Window_StableInfo:addScaleAnimation( 0.0, 0.22, UI_ANI_ADV.PAUI_ANIM_ADVANCE_SIN_HALF_PI)
	-- aniInfo2:SetStartScale(1.0)
	-- aniInfo2:SetEndScale(0.97)
	-- aniInfo2.AxisX = 200
	-- aniInfo2.AxisY = 295
	-- aniInfo2.IsChangeChild = true
end

local stableInfo	=
{
	_config	=
	{
		slot	=
		{
			startX			= 5,
			startY			= 5,
			startBGX		= 10,
			startBGY		= 38,
			startScrollX	= 319,
			startScrollY	= 13,
			
			gapY			= 66,
			
			count			= 4,
		},
		
		skill	=
		{
			startIconX	= 5,
			startIconY	= 7,
			startNameX	= 59,
			startNameY	= 7,
			startDecX	= 59,
			startDecY	= 28,
			startExpBGX	= 0,
			startExpBGY	= 2,
			startExpX	= 2,
			startExpY	= 4,
			startButtonX= 251,
			startButtonY= 4,			
		},
	},
	----------------------------------------------------------------------
	-- 기본 정보
	_maleIcon						= UI.getChildControl( Panel_Window_StableInfo,	"Static_MaleIcon"					),	-- 수컷 아이콘
	_femaleIcon						= UI.getChildControl( Panel_Window_StableInfo,	"Static_FemaleIcon"					),	-- 암컷 아이콘
								
	_staticName						= UI.getChildControl(Panel_Window_StableInfo,	"StaticText_Name"					),
	_staticLevel					= UI.getChildControl(Panel_Window_StableInfo,	"Static_Text_Level"					),
							
	_staticHpGauge					= UI.getChildControl(Panel_Window_StableInfo,	"HP_GaugeBar"						),
	_staticMpGauge					= UI.getChildControl(Panel_Window_StableInfo,	"MP_GaugeBar"						),
	_staticExpGauge					= UI.getChildControl(Panel_Window_StableInfo,	"EXP_GaugeBar"						),
	_staticWeightGauge				= UI.getChildControl(Panel_Window_StableInfo,	"Weight_GaugeBar"					),

	_staticHPTitle					= UI.getChildControl(Panel_Window_StableInfo,	"HP"								),
	_staticMPTitle					= UI.getChildControl(Panel_Window_StableInfo,	"MP"								),
	
	_staticHP						= UI.getChildControl( Panel_Window_StableInfo,	"HP_CountData"						),
	_staticMP						= UI.getChildControl( Panel_Window_StableInfo,	"MP_CountData"						),
	_staticEXP						= UI.getChildControl( Panel_Window_StableInfo,	"EXP_CountData"						),
	_staticWeight					= UI.getChildControl( Panel_Window_StableInfo,	"WHT_CountData"						),

	_staticTitleMaxMoveSpeed		= UI.getChildControl( Panel_Window_StableInfo,	"MaxMoveSpeed"						),
	_staticTitleAcceleration		= UI.getChildControl( Panel_Window_StableInfo,	"Acceleration"						),
	_staticTitleCorneringSpeed		= UI.getChildControl( Panel_Window_StableInfo,	"CorneringSpeed"					),
	_staticTitleBrakeSpeed			= UI.getChildControl( Panel_Window_StableInfo,	"BrakeSpeed"						),
					
	_staticMoveSpeed				= UI.getChildControl(Panel_Window_StableInfo,	"MaxMoveSpeedValue"					),
	_staticAcceleration				= UI.getChildControl(Panel_Window_StableInfo,	"AccelerationValue"					),
	_staticCornering				= UI.getChildControl(Panel_Window_StableInfo,	"CorneringSpeedValue"				),
	_staticBrakeSpeed				= UI.getChildControl(Panel_Window_StableInfo,	"BrakeSpeedValue"					),
	
	_staticMatingCount				= UI.getChildControl( Panel_Window_StableInfo,	"Static_MatingCount"				),
	_staticMatingCountValue			= UI.getChildControl( Panel_Window_StableInfo,	"Static_MatingCountValue"			),
	_staticMatingtime				= UI.getChildControl( Panel_Window_StableInfo,	"Static_MatingTime"					),
	_staticMatingtimeValue			= UI.getChildControl( Panel_Window_StableInfo,	"Static_MatingTimeValue"			),
	_btnMatingImmediately			= UI.getChildControl( Panel_Window_StableInfo,	"Button_MatingImmediately"			),
	_staticLife						= UI.getChildControl( Panel_Window_StableInfo,	"Static_LifeCount"					),
	_staticLifeValue				= UI.getChildControl( Panel_Window_StableInfo,	"Static_LifeCountValue"				),
	_staticImprint					= UI.getChildControl( Panel_Window_StableInfo,	"Static_Imprint"					),
	_staticImprintValue				= UI.getChildControl( Panel_Window_StableInfo,	"Static_ImprintValue"				),
	
	_staticSkillPanel				= UI.getChildControl( Panel_Window_StableInfo,	"Panel_Skill"						),

	_deadCount						= UI.getChildControl( Panel_Window_StableInfo,	"StaticText_DeadCount"				),
	_deadCountValue					= UI.getChildControl( Panel_Window_StableInfo,	"StaticText_DeadCountValue"			),
	
	panel_abillity					= UI.getChildControl( Panel_Window_StableInfo,	"Stable_Info_Ability"				),
	--_staticSkillTitle				= UI.getChildControl( Panel_Window_StableInfo,	"Skill_Title"						),
	--_staticSkillBG				= UI.getChildControl( Panel_Window_StableInfo,	"Static_SkillBG"					),
	--_staticSkillChangeEffectPanel	= UI.getChildControl( Panel_Window_StableInfo,	"Static_SkillIChange_EffectPanel"	),
	--_scrollSkill					= UI.getChildControl( Panel_Window_StableInfo,	"Scroll_Skill"						),
		
	_startSlotIndex					= 0,
	_temporaySlotCount				= 0,
	_temporayLearnSkillCount		= 0,
	currentSlotNo					= 0,
	_skill							= Array.new(),
	
	-- 스킬 슬롯 번호 임시 저장 변수 초기화
	_beforeSkillKey					= 0,
}

function	stableInfo:init()

	self._staticSkillTitle	= UI.createAndCopyBasePropertyControl( Panel_Window_StableInfo,	"Skill_Title",						self._staticSkillPanel,	"StableInfo_SkillTitle"		)
	self._staticSkillBG		= UI.createAndCopyBasePropertyControl( Panel_Window_StableInfo,	"Static_SkillBG",					self._staticSkillPanel,	"StableInfo_SkillBG"		)	
	self._scrollSkill		= UI.createAndCopyBasePropertyControl( Panel_Window_StableInfo,	"Scroll_Skill",						self._staticSkillBG,	"StableInfo_SkillScroll"	)
	
	local	slotConfig	= self._config.slot
	self._staticSkillBG:SetPosX(slotConfig.startBGX		)
	self._staticSkillBG:SetPosY(slotConfig.startBGY		)
	self._scrollSkill:SetPosX(	slotConfig.startScrollX	)
	self._scrollSkill:SetPosY(	slotConfig.startScrollY	)
	
	self._staticSkillBG:addInputEvent(	"Mouse_UpScroll",		"StableInfo_ScrollEvent( true )"	)
	self._staticSkillBG:addInputEvent(	"Mouse_DownScroll",		"StableInfo_ScrollEvent( false )"	)
	
	for ii=0, (self._config.slot.count-1)	do
		local slot	= {}
		
		slot.base			= UI.createAndCopyBasePropertyControl( Panel_Window_StableInfo,	"Button_Skill",						self._staticSkillBG,	"StableInfo_Skill_"			.. ii )
		slot.expBG			= UI.createAndCopyBasePropertyControl( Panel_Window_StableInfo,	"Static_SkillExpBG",				slot.base,				"StableInfo_SkillExpBG_"	.. ii )
		slot.exp			= UI.createAndCopyBasePropertyControl( Panel_Window_StableInfo,	"Gauge_SkillExp",					slot.base,				"StableInfo_SkillExp_"		.. ii )
		slot.icon			= UI.createAndCopyBasePropertyControl( Panel_Window_StableInfo,	"Static_SkillIcon",					slot.base,				"StableInfo_SkillIcon"		.. ii )
		slot.expStr			= UI.createAndCopyBasePropertyControl( Panel_Window_StableInfo,	"SkillLearn_PercentString",			slot.base,				"StableInfo_SkillExpStr_"	.. ii )
		slot.name			= UI.createAndCopyBasePropertyControl( Panel_Window_StableInfo,	"Static_Text_SkillName",			slot.base,				"StableInfo_SkillName_"		.. ii )
		slot.dec			= UI.createAndCopyBasePropertyControl( Panel_Window_StableInfo,	"Static_Text_SkillCondition",		slot.base,				"StableInfo_SkillDec_"		.. ii )
		slot.button			= UI.createAndCopyBasePropertyControl( Panel_Window_StableInfo,	"Button_SkillChange",				slot.base,				"StableInfo_SkillButton_"	.. ii )
					
		
		slot.base:SetPosX( slotConfig.startX )
		slot.base:SetPosY( slotConfig.startY + slotConfig.gapY * ii )
		
		local	skillConfig	= self._config.skill
		slot.icon	:SetPosX(	skillConfig.startIconX	)
		slot.icon	:SetPosY(	skillConfig.startIconY	)
		slot.name	:SetPosX(	skillConfig.startNameX	)
		slot.name	:SetPosY(	skillConfig.startNameY	)
		slot.dec	:SetPosX(	skillConfig.startDecX	)
		slot.dec	:SetPosY(	skillConfig.startDecY	)
		slot.expBG	:SetPosX(	skillConfig.startExpBGX	)
		slot.expBG	:SetPosY(	skillConfig.startExpBGY	)
		slot.exp	:SetPosX(	skillConfig.startExpX	)
		slot.exp	:SetPosY(	skillConfig.startExpY	)
		slot.expStr	:SetPosX(	(skillConfig.startIconX) + 10	)
		slot.expStr	:SetPosY(	(skillConfig.startIconY) + 30	)
		slot.button	:SetPosX(skillConfig.startButtonX)
		slot.button	:SetPosY(skillConfig.startButtonY)
		
		slot.base:addInputEvent(	"Mouse_UpScroll",		"StableInfo_ScrollEvent( true )"	)
		slot.base:addInputEvent(	"Mouse_DownScroll",		"StableInfo_ScrollEvent( false )"	)
		slot.button:addInputEvent(	"Mouse_LUp",			"Button_ChangeSkill("..ii..")"		)
		
		slot.key	= 0
		self._skill[ii]	= slot
	end
	-- 스킬을 덮어야 하기 때문에 아래서 선언함.
	self._staticSkillEffect	= UI.createAndCopyBasePropertyControl( Panel_Window_StableInfo,	"Static_SkillIChange_EffectPanel",	self._staticSkillBG,	"StableInfo_SkillEffect"	)
end

function	stableInfo:update()
	local	servantInfo		= stable_getServant( StableList_SelectSlotNo() )
	if	( nil == servantInfo )	then
		return
	end

	self._staticName:SetText(	servantInfo:getName()																)
	self._staticLevel:SetText(	"Lv."..tostring(servantInfo:getLevel())												)

	self._staticHP:SetText(		makeDotMoney(servantInfo:getHp()).. " / " ..makeDotMoney(servantInfo:getMaxHp())				)
	self._staticMP:SetText(		makeDotMoney(servantInfo:getMp()).. " / " ..makeDotMoney(servantInfo:getMaxMp())				)
	self._staticWeight:SetText(	makeDotMoney(servantInfo:getMaxWeight_s64() / Defines.s64_const.s64_10000)				)
	self._staticEXP:SetText(	makeDotMoney(servantInfo:getExp_s64()).." / "..makeDotMoney(servantInfo:getNeedExp_s64())	)
	
	self._staticHpGauge:SetSize(250 / 100 * (( servantInfo:getHp() / servantInfo:getMaxHp())*100)	,6)
	self._staticMpGauge:SetSize(250 / 100 * (( servantInfo:getMp() / servantInfo:getMaxMp())*100)	,6)
	-- 경험치
	local	s64_exp			= servantInfo:getExp_s64()
	local	s64_needexp		= servantInfo:getNeedExp_s64()
	local	s64_exp_percent	= Defines.s64_const.s64_0
	if	Defines.s64_const.s64_0 < s64_exp	then
		s64_exp_percent	= ( 250 / 100 ) * ( (Int64toInt32(s64_exp) / Int64toInt32(s64_needexp)) * 100 )
	end
	self._staticExpGauge:SetSize( s64_exp_percent, 6 )
	
	-- 스텟 입력
	-- if ( servantInfo:getVehicleType() == CppEnums.VehicleType.Type_Horse ) then
		self._staticMoveSpeed:SetText(		string.format( "%.1f",((servantInfo:getStat(CppEnums.ServantStatType.Type_MaxMoveSpeed))/10000))	.. "%" )	-- 속도
		self._staticAcceleration:SetText(	string.format( "%.1f",((servantInfo:getStat(CppEnums.ServantStatType.Type_Acceleration))/10000))	.. "%" )	-- 가속도
		self._staticCornering:SetText(		string.format( "%.1f",((servantInfo:getStat(CppEnums.ServantStatType.Type_CorneringSpeed))/10000))	.. "%" )	-- 코너링
		self._staticBrakeSpeed:SetText(		string.format( "%.1f",((servantInfo:getStat(CppEnums.ServantStatType.Type_BrakeSpeed))/10000))		.. "%" )	-- 브레이크
		self._staticTitleMaxMoveSpeed:SetShow( true )
		self._staticTitleAcceleration:SetShow( true )
		self._staticTitleCorneringSpeed:SetShow( true )
		self._staticTitleBrakeSpeed:SetShow( true )
		self._staticMoveSpeed:SetShow( true )
		self._staticAcceleration:SetShow( true )
		self._staticCornering:SetShow( true )
		self._staticBrakeSpeed:SetShow( true )
	-- else
		-- self._staticMoveSpeed:SetText("")
		-- self._staticAcceleration:SetText("")
		-- self._staticCornering:SetText("")
		-- self._staticBrakeSpeed:SetText("")
		-- self._staticTitleMaxMoveSpeed:SetShow( false )
		-- self._staticTitleAcceleration:SetShow( false )
		-- self._staticTitleCorneringSpeed:SetShow( false )
		-- self._staticTitleBrakeSpeed:SetShow( false )
		-- self._staticMoveSpeed:SetShow( false )
		-- self._staticAcceleration:SetShow( false )
		-- self._staticCornering:SetShow( false )
		-- self._staticBrakeSpeed:SetShow( false )
	-- end

	-- 죽은 횟수
	self._deadCount:SetShow( false )
	self._deadCountValue:SetShow( false )

	self._deadCount:SetShow( true )
	self._deadCountValue:SetShow( true )

	local deadCount = servantInfo:getDeadCount()		
	if servantInfo:getVehicleType() == CppEnums.VehicleType.Type_Horse or servantInfo:getVehicleType() == CppEnums.VehicleType.Type_Camel or servantInfo:getVehicleType() == CppEnums.VehicleType.Type_Donkey or servantInfo:getVehicleType() == CppEnums.VehicleType.Type_Elephant then
		self._deadCount:SetText("죽은 횟수")
	elseif servantInfo:getVehicleType() == CppEnums.VehicleType.Type_Carriage or servantInfo:getVehicleType() == CppEnums.VehicleType.Type_CowCarriage then
		self._deadCount:SetText("파괴 횟수")
	elseif servantInfo:getVehicleType() == CppEnums.VehicleType.Type_Boat or servantInfo:getVehicleType() == CppEnums.VehicleType.Type_Raft or servantInfo:getVehicleType() == CppEnums.VehicleType.Type_FishingBoat or servantInfo:getVehicleType() == CppEnums.VehicleType.Type_SailingBoat then
		self._deadCount:SetText("파괴 횟수")
	end

	if servantInfo:doClearCountByDead() then
		deadCount = deadCount .. " (초기화 가능)"
	else
		deadCount = deadCount .. " (초기화 불가)"
	end
	self._deadCountValue:SetText( deadCount )

	-- 수명 입력
	if	( servantInfo:isPeriodLimit() )	then
		self._staticLifeValue:SetText( convertStringFromDatetime(servantInfo:getExpiredTime()) )
	else
		self._staticLifeValue:SetText( PAGetString(Defines.StringSheet_RESOURCE, "STABLE_INFO_TEXT_LIFEVALUE") )
	end	
	
	if ( servantInfo:getVehicleType() == CppEnums.VehicleType.Type_Carriage ) or ( servantInfo:getVehicleType() == CppEnums.VehicleType.Type_CowCarriage ) then
		self._staticHPTitle:SetText( PAGetString(Defines.StringSheet_GAME, "LUA_SERVANTINFO_DURABILITY") )
		self._staticMPTitle:SetText( PAGetString(Defines.StringSheet_GAME, "LUA_SERVANTINFO_LIFE") )
		self._staticLife:SetText( PAGetString(Defines.StringSheet_GAME, "LUA_SERVANTINFO_PERIOD") )
	else
		self._staticMPTitle:SetText( PAGetString(Defines.StringSheet_GAME, "LUA_SERVANTINFO_STAMINA") )
	end
	
	-- 교배 정보
	--{
		self._maleIcon:SetShow(false)
		self._femaleIcon:SetShow(false)
		self._staticMatingCount:SetShow(false)
		self._staticMatingCountValue:SetShow(false)
		self._staticMatingtime:SetShow(false)
		self._staticMatingtimeValue:SetShow(false)
		self._btnMatingImmediately:SetShow(false)

		if	servantInfo:doMating() then		
			-- 암/수 아이콘 출력(마차, 우마차, 나룻배, 뗏목 제외)
			if	( servantInfo:isMale() )	then
				self._maleIcon:SetShow(true)
			else
				self._femaleIcon:SetShow(true)
			end
			
			-- 교배 남은 횟수
			local	matingCount	= servantInfo:getMatingCount()
			if servantInfo:doClearCountByMating() then
				matingCount = matingCount .. " (초기화 가능)"
			else
				matingCount = matingCount .. " (초기화 불가)"
			end
			self._staticMatingCountValue:SetText( matingCount )
			self._staticMatingCount:SetShow(true)
			self._staticMatingCountValue:SetShow( true )

			-- 즉시 완료
			if	( CppEnums.ServantStateType.Type_Mating == servantInfo:getStateType() )	then
				if	( not servantInfo:isMatingComplete() )	then
					self._staticMatingtimeValue:SetText( convertStringFromDatetime( servantInfo:getMatingTime() ) )
					self._staticMatingtime:SetShow( true )
					self._staticMatingtimeValue:SetShow( true )
					if	( FGlobal_IsCommercialService() )	then
						if	( not servantInfo:isMale() )	then
							self._btnMatingImmediately:SetShow( true )
						end
					end
				end
			end
			
			-- 교배 표시 여부에 따라 '각인' 텍스트 위치 조정
			self._staticImprint:SetSpanSize( -10, 220 )
			self._staticImprintValue:SetTextHorizonRight()
			self._staticImprintValue:SetSpanSize( 50, 220 )
		else
			self._staticImprint:SetSpanSize( -215, 220 )
			self._staticImprintValue:SetTextHorizonLeft()
			self._staticImprintValue:SetSpanSize( -117, 220 )
		end
	--}
	
	-- 각인 여부(생명력 있는 탑승물만 각인 가능함.)
	if (servantInfo:getVehicleType() == CppEnums.VehicleType.Type_Horse) or (servantInfo:getVehicleType() == CppEnums.VehicleType.Type_Camel) or (servantInfo:getVehicleType() == CppEnums.VehicleType.Type_Donkey) or (servantInfo:getVehicleType() == CppEnums.VehicleType.Type_Elephant) then
		stableInfo.panel_abillity:SetSize( 350, 250 )
	else
		stableInfo.panel_abillity:SetSize( 350, 225 )
	end

	self._staticImprint:SetShow( false )
	self._staticImprintValue:SetShow( false )
	if ( servantInfo:isImprint() ) then
		self._staticImprint:SetShow( true )
		self._staticImprintValue:SetShow( true )
		self._staticImprintValue:SetText( "사용중" )
		--Panel_Window_StableInfo:SetSpanSize(  )
	elseif	( servantInfo:doImprint() )	then
		self._staticImprint:SetShow( true )
		self._staticImprintValue:SetShow( true )
		self._staticImprintValue:SetText( "가능" )
		--Panel_Window_StableInfo:SetSpanSize(  )
	end

	-- to_do 공격력 방어력 둘다 표시안되고 있음	
	
	-- 스킬
	self:updateSkill()	
end

function FGlobal_StableInfoUpdate()
	-- if stableIdx == 1 then
	-- 	stable_recovery( StableList_SelectSlotNo() )
	-- elseif stableIdx == 2 then
	-- 	stable_revive( StableList_SelectSlotNo() )
	-- end

	local self = stableInfo
	local servantInfo		= stable_getServant( StableList_SelectSlotNo() )
	
	self._staticHP:SetText(		tostring(servantInfo:getHp()).. " / " ..tostring(servantInfo:getMaxHp()) )
	self._staticMP:SetText(		tostring(servantInfo:getMp()).. " / " ..tostring(servantInfo:getMaxMp()) )
	self._staticHpGauge:SetSize(250 / 100 * (( servantInfo:getHp() / servantInfo:getMaxHp())*100) ,6)
	self._staticMpGauge:SetSize(250 / 100 * (( servantInfo:getMp() / servantInfo:getMaxMp())*100) ,6)
end

function	stableInfo:updateSkill()
	local	servantInfo		= stable_getServant( StableList_SelectSlotNo() )
	if	nil == servantInfo	then
		return
	end
	
	for ii=0, (self._config.slot.count-1)	do
		local	slot	= self._skill[ii]
		slot.base:SetShow(false)
	end
	
	if	( not servantInfo:doHaveVehicleSkill() )	then
		return
	end

	-- 업데이트
	local	temporarySlotIndex		= 0
	local	slotNo					= 0
	self._temporayLearnSkillCount	= 0	--배운 스킬 갯수

	self._temporaySlotCount			= servantInfo:getSkillCount()

	for	ii=1, (self._temporaySlotCount - 1)	do
		local	skillWrapper= servantInfo:getSkill(ii)
		if	nil ~=	skillWrapper	then								--스킬이있으면?
			if	slotNo < self._config.slot.count	then
				if	self._startSlotIndex <= temporarySlotIndex	then

					local expTxt = tonumber(string.format( "%.0f", (servantInfo:getSkillExp(ii) / (skillWrapper:getMaxExp() / 100)) ) )

					if 100 <= expTxt then
						expTxt = 100
					end

					local	slot		= self._skill[slotNo]
					slot.key			= ii
					slot.icon:ChangeTextureInfoName( "Icon/" .. skillWrapper:getIconPath() )
					slot.name:SetText( skillWrapper:getName() )
					slot.dec:SetText( skillWrapper:getDescription() )
					slot.exp:SetProgressRate( servantInfo:getSkillExp(ii) / (skillWrapper:getMaxExp() / 100) ) -- 숙련도
					slot.exp:SetAniSpeed(0.0)
					slot.expStr:SetText( expTxt .. "%" )
					
					if	( (not servantInfo:isSkillLock(ii)) and FGlobal_IsCommercialService() )	then
						slot.button:SetEnable(true)
						slot.button:SetText( PAGetString(Defines.StringSheet_GAME, "LUA_SERVANT_STABEL_SKILLCHANGE") ) -- 변경
					else
						slot.button:SetEnable(false)
						slot.button:SetText( PAGetString(Defines.StringSheet_GAME, "LUA_SERVANT_STABEL_DONTSKILLCHANGE") ) -- 변경 불가
					end
					
					slot.base:SetShow(true)

					slotNo	 = slotNo + 1
				end
				temporarySlotIndex	 = temporarySlotIndex + 1
			end
			self._temporayLearnSkillCount	= self._temporayLearnSkillCount + 1		-- 스킬 갯수 증가
		end
	end

	if	( 0 < self._temporayLearnSkillCount )	then
		self._staticSkillPanel:SetShow(true)

		UIScroll.SetButtonSize( self._scrollSkill, self._config.slot.count, self._temporayLearnSkillCount )
	end
end

function	stableInfo:registEventHandler()
	self._staticSkillPanel:addInputEvent(			"Mouse_UpScroll",	"StableInfo_ScrollEvent( true )"	)
	self._staticSkillPanel:addInputEvent(			"Mouse_DownScroll",	"StableInfo_ScrollEvent( false )"	)
	self._btnMatingImmediately		:addInputEvent( "Mouse_LUp",		"StableInfo_MatingImmediately_Confirm()" )
	UIScroll.InputEvent( self._scrollSkill,								"StableInfo_ScrollEvent"			)
end

function	stableInfo:registMessageHandler()
	registerEvent( "onScreenResize",					"StableInfo_Resize"				)
	registerEvent( "FromClient_ServantChangeSkill",		"ServantChangeSkill_Complete"	)		-- 스킬이 변경 되었을 때, FromClient_ServantChangeSkill( oldSkillKey, newSkillKey )
end

function	StableInfo_Resize()
	-- screenX = getScreenSizeX()
	-- screenY = getScreenSizeY()

	Panel_Window_StableInfo:SetSpanSize( 20, 30 )
	Panel_Window_StableInfo:ComputePos()
end
----------------------------------------------------------------------------------------------------
-- Button Function
function	Button_ChangeSkill( slotNo )
	-- 스킬 슬롯 번호 임시 변수에 담기
	local	self		= stableInfo
	self._beforeSkillKey= self._skill[slotNo].key
	
	local	servantInfo		= stable_getServant( StableList_SelectSlotNo() )
	if	nil == servantInfo	then
		return
	end
	
	local	skillWrapper	= servantInfo:getSkill( self._beforeSkillKey )
	if	nil ==	skillWrapper	then								--스킬이있으면?
		return
	end

	-- 확인창 시작	
	local	titleString       = PAGetString(Defines.StringSheet_GAME, "LUA_ALERT_DEFAULT_TITLE")
	local	contentString     = PAGetStringParam1( Defines.StringSheet_GAME, "LUA_SERVANT_STABEL_SKILLCHANGE_MSG", "skillname", skillWrapper:getName() )
	local	messageboxData    = { title = titleString, content = contentString, functionYes = Button_ChangeSkillXXX, functionCancel = MessageBox_Empty_function, priority = CppEnums.PAUIMB_PRIORITY.PAUIMB_PRIORITY_LOW}
	MessageBox.showMessageBox(messageboxData)
end

function Button_ChangeSkillXXX()
	audioPostEvent_SystemUi(03,00)

	local	self		= stableInfo
	stable_changeSkill( StableList_SelectSlotNo(), self._beforeSkillKey )
end

function	StableInfo_ScrollEvent( isScrollUp )
	local	self		= stableInfo
	self._startSlotIndex= UIScroll.ScrollEvent( self._scrollSkill, isScrollUp, self._config.slot.count, self._temporayLearnSkillCount, self._startSlotIndex, 1 )
	self:update( self.currentSlotNo )
end

----------------------------------------------------------------------------------------------------
-- MatingImmediately
function	StableInfo_MatingImmediately_Confirm()
	local	self		= stableInfo
	
	local	servantInfo	= stable_getServant( StableList_SelectSlotNo() )
	if	nil == servantInfo	then
		return
	end
	
	-- 확인창 시작	
	local	titleString       = PAGetString(Defines.StringSheet_GAME, "LUA_IMMDEDIATELY_MSGBOX_TITLE") -- "즉시 완료"
	local	contentString     = PAGetStringParam1( Defines.StringSheet_GAME, "LUA_IMMDEDIATELY_MSGBOX_SERVANT_MEMO", "pearl", tostring( servantInfo:getCompleteMatingFromPearl_s64() ) ) -- tostring( servantInfo:getCompleteMatingFromPearl_s64() ) .. "펄이 소모됩니다"
	local	messageboxData    = { title = titleString, content = contentString, functionYes = StableInfo_MatingImmediatelyYes, functionCancel = MessageBox_Empty_function, priority = CppEnums.PAUIMB_PRIORITY.PAUIMB_PRIORITY_LOW}
	MessageBox.showMessageBox(messageboxData)
end

function	StableInfo_MatingImmediatelyYes()
	local	self		= stableInfo
	local	servantInfo	= stable_getServant( StableList_SelectSlotNo() )
	if	nil == servantInfo	then
		return
	end
	stable_requestCompleteServantMating( StableList_SelectSlotNo(), servantInfo:getCompleteMatingFromPearl_s64() )
end

-- From Client Call Function
function	ServantChangeSkill_Complete( oldSkillKey, newSkillKey )
	local	self	= stableInfo
	
	Panel_StableInfo_EffectFunc()
		
	self:update()
end

function	Panel_StableInfo_EffectFunc()
	local	self	= stableInfo
	self._staticSkillEffect:EraseAllEffect()
	self._staticSkillEffect:AddEffect("UI_Horse_SkillChangeEffect01",false,195,-172)
end

----------------------------------------------------------------------------------------------------
-- Window Open / Close
function StableInfo_Open()	
	self	= stableInfo
	self._scrollSkill:SetControlPos( 0 )	-- 맨 위로 올림!
	self:update()
	
	if	( Panel_Window_StableInfo:GetShow() )	then
		return
	end
	Panel_Window_StableInfo:SetShow(true)	
end

function	StableInfo_Close()
	if	( not Panel_Window_StableInfo:GetShow() )	then
		return
	end
	
	Panel_Window_StableInfo:SetShow(false)
end
----------------------------------------------------------------------------------------------------
-- Init
stableInfo:init()
stableInfo:registEventHandler()
stableInfo:registMessageHandler()
StableInfo_Resize()