Panel_Window_StableList:SetShow(false, false)
Panel_Window_StableList:setMaskingChild(true)
Panel_Window_StableList:ActiveMouseEventEffect(true)
Panel_Window_StableList:setGlassBackground(true)

Panel_Window_StableList:RegisterShowEventFunc( true,	'StableListShowAni()' )
Panel_Window_StableList:RegisterShowEventFunc( false,	'StableListHideAni()' )

local UI_ANI_ADV 	= CppEnums.PAUI_ANIM_ADVANCE_TYPE
local UI_color 		= Defines.Color
local servantInvenAlert = PAGetString(Defines.StringSheet_GAME, "LUA_SERVANT_SELL_WITHITEM_MSG")
-- "\n\n<PAColor0xFFDB2B2B>(※해당 탈것의 가방 안에 있는 아이템은<PAOldColor>\n<PAColor0xFFDB2B2B>모두 사라집니다.)<PAOldColor>"

function	StableListShowAni()
	local isShow	= Panel_Window_StableList:IsShow()
	
	if	( isShow )	then
	-- 꺼준다
		Panel_Window_StableList:SetShowWithFade(CppEnums.PAUI_SHOW_FADE_TYPE.PAUI_ANI_TYPE_FADE_OUT)
		local aniInfo1 = Panel_Window_StableList:addColorAnimation( 0.0, 0.22, UI_ANI_ADV.PAUI_ANIM_ADVANCE_SIN_HALF_PI)
		aniInfo1:SetStartColor( UI_color.C_FFFFFFFF )
		aniInfo1:SetEndColor( UI_color.C_00FFFFFF )
		aniInfo1:SetStartIntensity( 3.0 )
		aniInfo1:SetEndIntensity( 1.0 )
		aniInfo1.IsChangeChild = true
		aniInfo1:SetHideAtEnd(true)
		aniInfo1:SetDisableWhileAni(true)

		-- local aniInfo2 = Panel_Window_StableList:addScaleAnimation( 0.0, 0.22, UI_ANI_ADV.PAUI_ANIM_ADVANCE_SIN_HALF_PI)
		-- aniInfo2:SetStartScale(1.0)
		-- aniInfo2:SetEndScale(0.97)
		-- aniInfo2.AxisX = 200
		-- aniInfo2.AxisY = 295
		-- aniInfo2.IsChangeChild = true
		-- aniInfo2:SetDisableWhileAni(true)
	else
		UIAni.fadeInSCR_Down(Panel_Window_StableList)
		Panel_Window_StableList:SetShow(true, false)
	end
end

function	StableListHideAni()
	Inventory_SetFunctor( nil )
	Panel_Window_StableList:SetShowWithFade(CppEnums.PAUI_SHOW_FADE_TYPE.PAUI_ANI_TYPE_FADE_OUT)
	local aniInfo1 = Panel_Window_StableList:addColorAnimation( 0.0, 0.22, UI_ANI_ADV.PAUI_ANIM_ADVANCE_SIN_HALF_PI)
	aniInfo1:SetStartColor( UI_color.C_FFFFFFFF )
	aniInfo1:SetEndColor( UI_color.C_00FFFFFF )
	aniInfo1:SetStartIntensity( 3.0 )
	aniInfo1:SetEndIntensity( 1.0 )
	aniInfo1.IsChangeChild = true
	aniInfo1:SetHideAtEnd(true)
	aniInfo1:SetDisableWhileAni(true)

	-- local aniInfo2 = Panel_Window_StableList:addScaleAnimation( 0.0, 0.22, UI_ANI_ADV.PAUI_ANIM_ADVANCE_SIN_HALF_PI)
	-- aniInfo2:SetStartScale(1.0)
	-- aniInfo2:SetEndScale(0.97)
	-- aniInfo2.AxisX = 200
	-- aniInfo2.AxisY = 295
	-- aniInfo2.IsChangeChild = true
	-- aniInfo2:SetDisableWhileAni(true)
end

local	stableList	= {
	_const	=
	{
		eTypeSealed		= 0,
		eTypeUnsealed	= 1,
		eTypeTaming		= 2,
	},
	_config	=
	{
		slot	=
		{
			startX		= 15,
			startY		= 15,
			gapY		= 158,
		},
		
		icon	=
		{
			startX			= 0,
			startY			= 0,
			startNameX		= 5,
			startNameY		= 120,
			startEffectX	= -1,
			startEffectY	= -1,
			startSexIconX	= 0,
			startSexIconY	= 0,
			startStateX		= 0,
			startStateY		= 0,
		},
		
		unseal	=
		{
			startX		= 230,
			startY		= 0,
			startTitleX	= -15,
			startTitleY	= 0,
			startButtonX= 25,
			startButtonY= 25,
			startIconX	= 25,
			startIconY	= 35,
		},
		
		taming	=
		{
			startX		= 230,
			startY		= 50,
			startTitleX	= 30,
			startTitleY	= 0,
			startButtonX= 25,
			startButtonY= 25,
			startIconX	= 25,
			startIconY	= 35,
		},
		
		button	=
		{
			startX		= 180,
			startY		= 0,
			startButtonX= 15,
			startButtonY= 10,
			gapY		= 40,
			sizeY		= 40,
			sizeYY		= 10,
		},
		
		slotCount		= 4,
	},
		
	_staticListBG			= UI.getChildControl( Panel_Window_StableList, 	"Static_ListBG"				),	
	_staticButtonListBG		= UI.getChildControl( Panel_Window_StableList, 	"Static_PopupBG"			),
	
	_staticNotice			= UI.getChildControl( Panel_Window_StableList, 	"StaticText_Notice" 		),
	_staticSlotCount		= UI.getChildControl( Panel_Window_StableList, 	"StaticText_Slot_Count"		),		-- 슬롯개수
	
	_scroll					= UI.getChildControl( Panel_Window_StableList,	"Scroll_Slot_List"			),

	_slots					= Array.new(),
	_selectSlotNo			= nil,																				-- 선택된 슬롯 번호
	_startSlotIndex			= 0,																				-- 현재 스크롤 시작 번호.	
	_selectSceneIndex		= -1,
	_unseal					= {},																				-- 찾은 탈것
	_taming					= {},																				-- 길들인 탈것
}

local sellCheck = true

----------------------------------------------------------------------------------------------------
-- Init Function
function	stableList:init()
	
	for	ii = 0, (self._config.slotCount-1)	do
		local	slot		= {}
		slot.slotNo			= ii
		slot.panel			= Panel_Window_StableList
			
		slot.button			= UI.createAndCopyBasePropertyControl( Panel_Window_StableList, "Static_Button",				self._staticListBG,	"StableList_Slot_"					.. ii )
		slot.effect			= UI.createAndCopyBasePropertyControl( Panel_Window_StableList, "Static_Button_Effect",			slot.button,		"StableList_Slot_Effect_"			.. ii )
		slot.icon			= UI.createAndCopyBasePropertyControl( Panel_Window_StableList, "Static_Icon",					slot.button,		"StableList_Slot_Icon_"				.. ii )
		slot.name			= UI.createAndCopyBasePropertyControl( Panel_Window_StableList, "Static_Name",					slot.button,		"StableList_Slot_Name_"				.. ii )
		slot.maleIcon		= UI.createAndCopyBasePropertyControl( Panel_Window_StableList, "Static_MaleIcon",				slot.button,		"StableList_Slot_IconMale_"			.. ii )
		slot.femaleIcon		= UI.createAndCopyBasePropertyControl( Panel_Window_StableList, "Static_FemaleIcon",			slot.button,		"StableList_Slot_IconFemale_"		.. ii )
		
		slot.registerMating	= UI.createAndCopyBasePropertyControl( Panel_Window_StableList, "StaticText_RegisterMating",	slot.button,		"ServantList_Slot_RegisterMating_"	.. ii )
		slot.registerMarket	= UI.createAndCopyBasePropertyControl( Panel_Window_StableList, "StaticText_RegisterMarket",	slot.button,		"ServantList_Slot_RegisterMarket_"	.. ii )
		slot.coma			= UI.createAndCopyBasePropertyControl( Panel_Window_StableList, "StaticText_Coma",				slot.button,		"ServantList_Slot_Coma_"			.. ii )
		slot.mating			= UI.createAndCopyBasePropertyControl( Panel_Window_StableList, "StaticText_Mating",			slot.button,		"ServantList_Slot_Mating_"			.. ii )
		slot.matingComplete	= UI.createAndCopyBasePropertyControl( Panel_Window_StableList, "StaticText_MatingComplete",	slot.button,		"ServantList_Slot_MatingCompletes_"	.. ii )
		slot.isSeized		= UI.createAndCopyBasePropertyControl( Panel_Window_StableList, "StaticText_Attachment",		slot.button,		"ServantList_Slot_Seized"			.. ii )
		
		-- 좌표 설정.
		local	slotConfig	= self._config.slot
		slot.button:SetPosX( 		slotConfig.startX )
		slot.button:SetPosY( 		slotConfig.startY + slotConfig.gapY * ii )
		
		local	iconConfig	= self._config.icon
		slot.icon:SetPosX(			iconConfig.startX )
		slot.icon:SetPosY(			iconConfig.startY )
		slot.name:SetPosX(			iconConfig.startNameX )
		slot.name:SetPosY(			iconConfig.startNameY )
		slot.effect:SetPosX(		iconConfig.startEffectX )
		slot.effect:SetPosY(		iconConfig.startEffectY )
		slot.maleIcon:SetPosX(		iconConfig.startSexIconX )
		slot.maleIcon:SetPosY(		iconConfig.startSexIconY )
		slot.femaleIcon:SetPosX(	iconConfig.startSexIconX )
		slot.femaleIcon:SetPosY(	iconConfig.startSexIconY )
		
		slot.registerMating:SetPosX(iconConfig.startStateX )
		slot.registerMating:SetPosY(iconConfig.startStateY )
		slot.registerMarket:SetPosX(iconConfig.startStateX )
		slot.registerMarket:SetPosY(iconConfig.startStateY )
		slot.coma:SetPosX(			iconConfig.startStateX )
		slot.coma:SetPosY(			iconConfig.startStateY )		
		slot.mating:SetPosX(		iconConfig.startStateX )
		slot.mating:SetPosY(		iconConfig.startStateY )
		slot.matingComplete:SetPosX(iconConfig.startStateX )
		slot.matingComplete:SetPosY(iconConfig.startStateY )
		slot.isSeized:SetPosX(		iconConfig.startStateX )
		slot.isSeized:SetPosY(		iconConfig.startStateY )
		
		slot.icon:ActiveMouseEventEffect(true)
		
		slot.button:addInputEvent( "Mouse_LUp",		"StableList_SlotSelect(" .. (ii) .. ")"	)
	
		UIScroll.InputEventByControl( slot.button,	"StableList_ScrollEvent"				)

		self._slots[ii]	= slot
	end

	-- 찾은 탈것 정보
	--{
		self._unseal._bg		= UI.createAndCopyBasePropertyControl(	Panel_Window_StableList, "Static_BG",			Panel_Window_StableList,	"StableList_Unseal_BG"		)
		self._unseal._title		= UI.createAndCopyBasePropertyControl(	Panel_Window_StableList, "StaticText_SubTitle",	self._unseal._bg,			"StableList_Unseal_Title"	)	
		self._unseal._button	= UI.createAndCopyBasePropertyControl(	Panel_Window_StableList, "Static_Button",		self._unseal._bg,			"StableList_Unseal_Button"	)
		self._unseal._icon		= UI.createAndCopyBasePropertyControl(	Panel_Window_StableList, "Static_Icon",			self._unseal._bg,			"StableList_Unseal_Icon"	)	
		
		self._unseal._title:SetText( PAGetString( Defines.StringSheet_GAME, "LUA_STABLELIST_NOW_VEHICLE") )
		
		-- 좌표 설정.
		local	unsealConfig	= self._config.unseal
		self._unseal._bg:SetPosX(		unsealConfig.startX			)
		self._unseal._bg:SetPosY(		unsealConfig.startY			)
		self._unseal._title:SetPosX(	unsealConfig.startTitleX	)
		self._unseal._title:SetPosY(	unsealConfig.startTitleY	)
		self._unseal._button:SetPosX(	unsealConfig.startButtonX	)
		self._unseal._button:SetPosY(	unsealConfig.startButtonY	)
		self._unseal._icon:SetPosX(		unsealConfig.startIconX		)
		self._unseal._icon:SetPosY(		unsealConfig.startIconY		)
		
		self._unseal._button:addInputEvent( "Mouse_LUp",	"StableList_ButtonOpen( 1, 0 )" )
	--}
	
	-- 길들인말 정보
	--{
		self._taming._bg		= UI.createAndCopyBasePropertyControl(	Panel_Window_StableList, "Static_BG",			Panel_Window_StableList,	"StableList_Taming_BG"		)
		self._taming._title		= UI.createAndCopyBasePropertyControl(	Panel_Window_StableList, "StaticText_SubTitle",	self._taming._bg,			"StableList_Taming_Title"	)	
		self._taming._button	= UI.createAndCopyBasePropertyControl(	Panel_Window_StableList, "Static_Button",		self._taming._bg,			"StableList_Taming_Button"	)
		self._taming._icon		= UI.createAndCopyBasePropertyControl(	Panel_Window_StableList, "Static_Icon",			self._taming._bg,			"StableList_Taming_Icon"	)
		
		self._taming._title:SetText( PAGetString( Defines.StringSheet_GAME, "LUA_STABLELIST_TAME_VEHICLE") )
		
		local	taminglConfig	= self._config.taming
		self._taming._bg:SetPosX(		taminglConfig.startX		)
		self._taming._bg:SetPosY(		taminglConfig.startY		)
		self._taming._title:SetPosX(	taminglConfig.startTitleX	)
		self._taming._title:SetPosY(	taminglConfig.startTitleY	)
		self._taming._button:SetPosX(	taminglConfig.startButtonX	)
		self._taming._button:SetPosY(	taminglConfig.startButtonY	)
		self._taming._icon:SetPosX(		taminglConfig.startIconX	)
		self._taming._icon:SetPosY(		taminglConfig.startIconY	)
		
		self._taming._button:addInputEvent( "Mouse_LUp",	"StableList_ButtonOpen( 2, 0 )" )
	--}
	
	-- 버튼
	--{
		self._buttonRegister		= UI.createAndCopyBasePropertyControl( Panel_Window_StableList, "Button_Register",				self._staticButtonListBG,	"StableList_Button_Register"					)
					
		self._buttonSeal			= UI.createAndCopyBasePropertyControl( Panel_Window_StableList, "Button_Seal",					self._staticButtonListBG,	"StableList_Button_Seal"						)
		self._buttonCompulsionSeal	= UI.createAndCopyBasePropertyControl( Panel_Window_StableList, "Button_CompulsionSeal",		self._staticButtonListBG,	"StableList_Button_CompulsionSeal"				)
		self._buttonRecoveryUnseal	= UI.createAndCopyBasePropertyControl( Panel_Window_StableList, "Button_RecoveryUnseal",		self._staticButtonListBG,	"StableList_Button_RecoveryUnseal"				)
		self._buttonRepairUnseal	= UI.createAndCopyBasePropertyControl( Panel_Window_StableList, "Button_RepairUnseal",			self._staticButtonListBG,	"StableList_Button_RepairUnseal"				)
		self._buttonUnseal			= UI.createAndCopyBasePropertyControl( Panel_Window_StableList, "Button_Unseal",				self._staticButtonListBG,	"StableList_Button_Unseal"						)
		self._buttonRepair			= UI.createAndCopyBasePropertyControl( Panel_Window_StableList, "Button_Repair",				self._staticButtonListBG,	"StableList_Button_Repair"						)
		self._buttonRecovery		= UI.createAndCopyBasePropertyControl( Panel_Window_StableList, "Button_Recovery",				self._staticButtonListBG,	"StableList_Button_Recovery"					)
		self._buttonSell			= UI.createAndCopyBasePropertyControl( Panel_Window_StableList, "Button_Sell",					self._staticButtonListBG,	"StableList_Button_Sell"						)
		self._buttonRelease			= UI.createAndCopyBasePropertyControl( Panel_Window_StableList, "Button_Release",				self._staticButtonListBG,	"StableList_Button_Release"						)
		self._buttonChangeName		= UI.createAndCopyBasePropertyControl( Panel_Window_StableList, "Button_ChangeName",			self._staticButtonListBG,	"StableList_Button_ChangeName"					)
		self._buttonRegisterMating	= UI.createAndCopyBasePropertyControl( Panel_Window_StableList, "Button_RegisterMating",		self._staticButtonListBG,	"StableList_Button_RegisterMating"				)
		self._buttonRegisterMarket	= UI.createAndCopyBasePropertyControl( Panel_Window_StableList, "Button_RegisterMarket",		self._staticButtonListBG,	"StableList_Button_RegisterMarket"				)
		self._buttonReceiveChild	= UI.createAndCopyBasePropertyControl( Panel_Window_StableList, "Button_ReceiveChildServant",	self._staticButtonListBG,	"StableList_Button_ReceiveChildServant"			)
		self._buttonReturnMale		= UI.createAndCopyBasePropertyControl( Panel_Window_StableList, "Button_ReturnMating",			self._staticButtonListBG,	"StableList_Button_ReturnMating"				)
		self._buttonClearDeadCount	= UI.createAndCopyBasePropertyControl( Panel_Window_StableList, "Button_KillReset",				self._staticButtonListBG,	"StableList_Button_DeadCountReset"				)
		self._buttonClearMatingCount= UI.createAndCopyBasePropertyControl( Panel_Window_StableList, "Button_IncreaseMatingCount",	self._staticButtonListBG,	"StableList_Button_MatingCountReset"			)
		self._buttonImprint			= UI.createAndCopyBasePropertyControl( Panel_Window_StableList, "Button_Stamping",				self._staticButtonListBG,	"StableList_Button_Imprint"						)
	--}	
	self._scroll:SetControlPos( 0 )	-- 맨 위로 올림!
	
	-- 우선 순위 설정
	Panel_Window_StableList:SetChildIndex( self._staticButtonListBG	:GetKey(), 9999)
end

function	stableList:update()
	local	servantCount	= stable_count()
	
	-- 비어있으면 notice 출력.
	if 0 == servantCount then
		stableList._staticNotice:SetShow(true)
	else
		stableList._staticNotice:SetShow(false)
	end
	
	-- 축사 슬롯 개수 표시
	self._staticSlotCount:SetText( stable_currentSlotCount() .. " / " .. stable_maxSlotCount() )
	
	--전체 disable
	for ii = 0, self._config.slotCount-1	do
		local slot	= self._slots[ii]
		slot.index	= -1
		slot.button:SetShow(false)
	end
	
	local	slotNo	= 0
	for ii = self._startSlotIndex, (servantCount-1)	do
		local	servantInfo		= stable_getServant( ii )
		if	nil ~= servantInfo	then
			if	(slotNo <= self._config.slotCount-1)	then
				local slot	= self._slots[slotNo]
				slot.name:SetText( servantInfo:getName(ii) .. '\n(' .. servantInfo:getRegionName(ii) .. ')' )
				slot.icon:ChangeTextureInfoName( servantInfo:getIconPath1() )
				
				-- 성별
				slot.maleIcon:SetShow(false)
				slot.femaleIcon:SetShow(false)
				if	servantInfo:doMating()	then
					if	( servantInfo:isMale() )	then
						slot.maleIcon:SetShow(true)
					else
						slot.femaleIcon:SetShow(true)
					end
				end
				
				-- 상태
				slot.isSeized:SetShow(false)
				slot.registerMating:SetShow(false)
				slot.registerMarket:SetShow(false)
				slot.coma:SetShow(false)
				slot.mating:SetShow(false)
				slot.matingComplete:SetShow(false)
				if	( servantInfo:isSeized() )	then
					slot.isSeized:SetShow(true)
				elseif	( CppEnums.ServantStateType.Type_RegisterMarket == servantInfo:getStateType() )	then
					slot.registerMarket:SetShow(true)
				elseif	( CppEnums.ServantStateType.Type_RegisterMating == servantInfo:getStateType() )	then
					slot.registerMating:SetShow(true)
				elseif	( CppEnums.ServantStateType.Type_Mating == servantInfo:getStateType() )	then
					if	( servantInfo:isMatingComplete() )	then
						slot.matingComplete:SetShow(true)
					else
						slot.mating:SetShow(true)
					end
				elseif	( CppEnums.ServantStateType.Type_Coma == servantInfo:getStateType() )	then
					slot.coma:SetShow(true)
				end
				
				slot.button:SetShow(true)
				slot.index	= ii
				slotNo		= slotNo + 1
			end	
		end
	end
	
	-- 찾은 탈것
	self._unseal._bg:SetShow(false)
	local temporaryWrapper = getTemporaryInformationWrapper()
	local	servantInfo	= temporaryWrapper:getUnsealVehicle( stable_getServantType() )
	if(	nil ~= servantInfo )	then
		self._unseal._icon:ChangeTextureInfoName( servantInfo:getIconPath1() )
		self._unseal._bg:SetShow(true)
	end
	
	-- 길들인 탈것
	self._taming._bg:SetShow(false)
	local	characterKey	= stable_getTamingServantCharacterKey()	-- 길들인 말이 있으면, 길들인 말 창을 띄운다.
	if	(nil ~= characterKey)	then
		local	servantInfo	= stable_getServantByCharacterKey( characterKey, 1 )
		if(	nil ~= servantInfo )	then
			self._taming._icon:ChangeTextureInfoName( servantInfo:getIconPath1() )
			self._taming._bg:SetShow(true)
			if self._unseal._bg:GetShow() then
				self._taming._bg:SetPosY(self._config.taming.startButtonY+self._unseal._bg:GetSizeY() + 10)
			else
				self._taming._bg:SetPosY(self._config.taming.startButtonY)
			end
		end
	end
	
	-- scroll 설정
	UIScroll.SetButtonSize( self._scroll, self._config.slotCount, servantCount )
	FGlobal_NeedStableRegistItem_Print()
end

function	stableList:registEventHandler()
	UIScroll.InputEvent( self._scroll,			"StableList_ScrollEvent"								)
	Panel_Window_StableList:addInputEvent(		"Mouse_UpScroll",	"StableList_ScrollEvent( true )"	)
	Panel_Window_StableList:addInputEvent(		"Mouse_DownScroll",	"StableList_ScrollEvent( false )"	)
	
	self._buttonRegister:addInputEvent(			"Mouse_LUp",		"StableList_RegisterFromTaming()"	)
		
	self._buttonSeal:addInputEvent(				"Mouse_LUp",		"StableList_Seal( false )"			)
	self._buttonCompulsionSeal:addInputEvent(	"Mouse_LUp",		"StableList_Seal( true )"			)
		
	self._buttonUnseal:addInputEvent(			"Mouse_LUp",		"StableList_Unseal()"				)
	self._buttonRepair:addInputEvent(			"Mouse_LUp",		"StableList_Recovery()"				)
	self._buttonRecoveryUnseal:addInputEvent(	"Mouse_LUp",		"StableList_RecoveryUnseal()" 		)
	self._buttonRepairUnseal:addInputEvent(		"Mouse_LUp",		"StableList_RecoveryUnseal()"		)
	self._buttonRecovery:addInputEvent(			"Mouse_LUp",		"StableList_Recovery()" 			)
	self._buttonSell:addInputEvent(				"Mouse_LUp",		"StableList_SellToNpc()" 			)
	self._buttonRelease:addInputEvent(			"Mouse_LUp",		"StableList_Release()" 				)
	self._buttonChangeName:addInputEvent(		"Mouse_LUp",		"StableList_ChangeName()" 			)
	self._buttonRegisterMating:addInputEvent(	"Mouse_LUp",		"StableList_RegisterMating()"		)
	self._buttonRegisterMarket:addInputEvent(	"Mouse_LUp",		"StableList_RegisterMarket()"		)
	self._buttonReceiveChild:addInputEvent(		"Mouse_LUp",		"StableList_ReceiveChildServant()"	)
	self._buttonReturnMale:addInputEvent(		"Mouse_LUp",		"StableList_RegisterCancel()" 		)
	self._buttonClearDeadCount:addInputEvent(	"Mouse_LUp",		"StableList_ClearDeadCount()" 		)
	self._buttonClearMatingCount:addInputEvent(	"Mouse_LUp",		"StableList_ClearMatingCount()" 	)
	self._buttonImprint:addInputEvent(	"Mouse_LUp",				"StableList_Imprint()" 				)
end

function	stableList:registMessageHandler()
	registerEvent("onScreenResize",							"StableList_Resize" )
	registerEvent("FromClient_ServantRegisterToAuction",	"StableList_UpdateSlotData")
	registerEvent("FromClient_ServantUpdate",				"StableList_UpdateSlotData")
	registerEvent("FromClient_ServantTaming",				"StableList_UpdateSlotData")
	registerEvent("FromClient_GroundMouseClick",			"StableList_ButtonClose")
	registerEvent("FromClient_RegisterServantFail",			"StableList_PopMessageBox")
	registerEvent("FromClient_ServantSeal",					"FromClient_ServantSeal")				-- 말을 맡겼을 때
	registerEvent("FromClient_ServantUnseal",				"FromClient_ServantUnseal")				-- 찾기 시 호출
	registerEvent("FromClient_ServantToReward",				"FromClient_ServantToReward")			-- 판매 or 놓아주기
	registerEvent("FromClient_ServantRecovery",				"FromClient_ServantRecovery")			-- 회복시 호출
	registerEvent("FromClient_ServantChangeName",			"FromClient_ServantChangeName")			-- 이름 변경
	registerEvent("FromClient_ServantRegisterAuction",		"FromClient_ServantRegisterAuction")	-- 교배 및 거래시장 등록
	registerEvent("FromClient_ServantCancelAuction",		"FromClient_ServantCancelAuction")		-- 교배 및 거래시장 취소
	registerEvent("FromClient_ServantReceiveAuction",		"FromClient_ServantReceiveAuction")		-- 교배 및 거래시장 수령
	registerEvent("FromClient_ServantBuyMarket",			"FromClient_ServantBuyMarket")			-- 거래시장 구매
	registerEvent("FromClient_ServantStartMating",			"FromClient_ServantStartMating")		-- 교배시장 시작
	registerEvent("FromClient_ServantChildMating",			"FromClient_ServantChildMating")		-- 교배시장 말 수령
	registerEvent("FromClient_ServantClearDeadCount",		"FromClient_ServantClearDeadCount")		-- 마구간에서 사망 회수 초기화를 성공적으로 마쳤을 때.
	registerEvent("FromClient_ServantImprint",				"FromClient_ServantImprint")			-- 탑승물(말)을 각인 시켜서 성공했을 때
	registerEvent("FromClient_ServantClearMatingCount",		"FromClient_ServantClearMatingCount")	-- 탑승물(말)의 교배 횟수를 초기화 시켜서 성공했을 때.
end

function	StableList_Resize()
	local	screenX	= getScreenSizeX()
	local	screenY	= getScreenSizeY()
	local	self	= stableList
	
	local	panelSize	= 0
	local	panelBGSize	= 0
	local	scrollSize	= 0
	local	slotCount	= 4
	if	( 1000 < screenY )	then
		panelSize	= 700
		panelBGSize	= 660
		scrollSize	= 660
		slotCount	= 4
		if (nil ~= self._slots[3]) then
			self._slots[3].button:SetShow(true)
		end
	else
		panelSize	= 540
		panelBGSize	= 500
		scrollSize	= 500
		slotCount	= 3
		if (nil ~= self._slots[3]) then
			self._slots[3].button:SetShow(false)
		end
	end
	
	Panel_Window_StableList:SetSize(Panel_Window_StableList:GetSizeX(), panelSize)
	
	self._staticListBG:SetSize(self._staticListBG:GetSizeX(), panelBGSize)
	self._scroll:SetSize(self._scroll:GetSizeX(), scrollSize)
	self._config.slotCount	= slotCount
end
----------------------------------------------------------------------------------------------------
-- Popup Function
function	StableList_ButtonOpen( eType, slotNo )
	local	self		= stableList
	
	self._buttonRegister:SetShow(false)
	
	self._buttonSeal:SetShow(false)
	self._buttonCompulsionSeal:SetShow(false)
	self._buttonRecoveryUnseal:SetShow(false)
	self._buttonRepairUnseal:SetShow(false)
	
	self._buttonUnseal:SetShow(false)
	self._buttonRepair:SetShow(false)
	self._buttonSell:SetShow(false)
	self._buttonChangeName:SetShow(false)
	self._buttonRecovery:SetShow(false)
	self._buttonRelease:SetShow(false)
	self._buttonRegisterMating:SetShow(false)
	self._buttonRegisterMarket:SetShow(false)
	self._buttonReceiveChild:SetShow(false)
	self._buttonReturnMale:SetShow(false)
	self._buttonClearDeadCount:SetShow(false)
	self._buttonClearMatingCount:SetShow(false)
	self._buttonImprint:SetShow(false)
	
	local	buttonList		= {}
	local	buttonConfig	= self._config.button
	local	positionX		= 0
	local	positionY		= 0
	local	buttonSlotNo	= 0
	if	( eType == self._const.eTypeSealed )	then
		audioPostEvent_SystemUi(01,00)
		
		local	index		= StableList_SelectSlotNo()
		local	servantInfo	= stable_getServant( index )
		if	nil == servantInfo	then
			return
		end
		local	vehicleType	= servantInfo:getVehicleType()
		local	getState	= servantInfo:getStateType()
		local	nowMating	= CppEnums.ServantStateType.Type_Mating
		local	regMarket	= CppEnums.ServantStateType.Type_RegisterMarket
		local	regMating	= CppEnums.ServantStateType.Type_RegisterMating
		
		if (CppEnums.VehicleType.Type_Horse == vehicleType) or (CppEnums.VehicleType.Type_Donkey == vehicleType) then
			if nowMating ~= getState and regMarket~= getState and regMating ~= getState then
				buttonList[buttonSlotNo]	= self._buttonUnseal
				buttonSlotNo	= buttonSlotNo + 1
				buttonList[buttonSlotNo]	= self._buttonSell
				buttonSlotNo	= buttonSlotNo + 1
				buttonList[buttonSlotNo]	= self._buttonRelease
				buttonSlotNo	= buttonSlotNo + 1
			end
		else
			buttonList[buttonSlotNo]	= self._buttonUnseal
			buttonSlotNo	= buttonSlotNo + 1
			buttonList[buttonSlotNo]	= self._buttonSell
			buttonSlotNo	= buttonSlotNo + 1
		end
		
		if	( servantInfo:getHp() < servantInfo:getMaxHp() ) or ( servantInfo:getMp() < servantInfo:getMaxMp() )	then
			if ((CppEnums.VehicleType.Type_Horse == vehicleType) or (CppEnums.VehicleType.Type_Donkey == vehicleType) or (CppEnums.VehicleType.Type_Camel == vehicleType) or (CppEnums.VehicleType.Type_MountainGoat == vehicleType)) and ( not servantInfo:isMatingComplete() ) and nowMating ~= getState and regMarket ~= getState and regMating ~= getState then
				buttonList[buttonSlotNo]	= self._buttonRecovery
				buttonSlotNo	= buttonSlotNo + 1
			else
			end
		end
		if ( servantInfo:getHp() < servantInfo:getMaxHp() ) then
			if ( CppEnums.VehicleType.Type_Carriage == vehicleType ) or ( CppEnums.VehicleType.Type_CowCarriage == vehicleType ) then
				buttonList[buttonSlotNo]	= self._buttonRepair
				buttonSlotNo	= buttonSlotNo + 1
			end
		end
		
		if	( servantInfo:isMatingComplete() and (not servantInfo:isMale()) )	then
			buttonList[buttonSlotNo]	= self._buttonReceiveChild
			buttonSlotNo	= buttonSlotNo + 1
		end
		
		if	( stable_isMarket() ) and nowMating ~= getState and regMarket ~= getState and regMating ~= getState then
			if	( (CppEnums.VehicleType.Type_Horse == vehicleType) or (CppEnums.VehicleType.Type_Donkey == vehicleType) ) then
				buttonList[buttonSlotNo]	= self._buttonRegisterMarket
				buttonSlotNo	= buttonSlotNo + 1
			end
		end
		
		if	( stable_isMating() and servantInfo:doMating() and servantInfo:isMale() ) and nowMating ~= getState and regMarket ~= getState and regMating ~= getState then
			if	( CppEnums.ServantStateType.Type_Stable == servantInfo:getStateType() )	then
				buttonList[buttonSlotNo]	= self._buttonRegisterMating
				buttonSlotNo	= buttonSlotNo + 1
			end
		end
		
		if (nowMating ~= getState) and (regMarket~= getState) and (regMating ~= getState) and FGlobal_IsCommercialService() then
			buttonList[buttonSlotNo]	= self._buttonChangeName
			buttonSlotNo	= buttonSlotNo + 1
		end

		-- 사망 회수 초기화
		--{
			if servantInfo:getVehicleType() == CppEnums.VehicleType.Type_Horse or servantInfo:getVehicleType() == CppEnums.VehicleType.Type_Camel or servantInfo:getVehicleType() == CppEnums.VehicleType.Type_Donkey or servantInfo:getVehicleType() == CppEnums.VehicleType.Type_Elephant then
				self._buttonClearDeadCount:SetText("죽은 횟수 초기화")
			elseif servantInfo:getVehicleType() == CppEnums.VehicleType.Type_Carriage or servantInfo:getVehicleType() == CppEnums.VehicleType.Type_CowCarriage then
				self._buttonClearDeadCount:SetText("파괴 횟수 초기화")
			elseif servantInfo:getVehicleType() == CppEnums.VehicleType.Type_Boat or servantInfo:getVehicleType() == CppEnums.VehicleType.Type_Raft or servantInfo:getVehicleType() == CppEnums.VehicleType.Type_FishingBoat or servantInfo:getVehicleType() == CppEnums.VehicleType.Type_SailingBoat then
				self._buttonClearDeadCount:SetText("파괴 횟수 초기화")
			end
			if	nowMating ~= getState and regMarket ~= getState and regMating ~= getState then
				buttonList[buttonSlotNo]	= self._buttonClearDeadCount		
				buttonSlotNo	= buttonSlotNo + 1
			end
		--}
		
		-- 교배 회수 초기화
		--{
		if ( servantInfo:doClearCountByMating() ) and servantInfo:getVehicleType() == CppEnums.VehicleType.Type_Horse then
			buttonList[buttonSlotNo]	= self._buttonClearMatingCount
			buttonSlotNo	= buttonSlotNo + 1
		end
		--}
		
		-- 각인
		--{
		if ( servantInfo:doImprint() ) then
			buttonList[buttonSlotNo]	= self._buttonImprint
			buttonSlotNo	= buttonSlotNo + 1
		end
		--}
		
		positionX	= self._slots[slotNo].button:GetPosX() + buttonConfig.startX
		positionY	= self._slots[slotNo].button:GetPosY() + buttonConfig.startY
	elseif	( eType == self._const.eTypeUnsealed )	then

		local temporaryWrapper	= getTemporaryInformationWrapper()
		local unSealServantInfo		= temporaryWrapper:getUnsealVehicle( stable_getServantType() )

		local	vehicleType	= unSealServantInfo:getVehicleType()
		local	getState	= unSealServantInfo:getStateType()
		local	nowMating	= CppEnums.ServantStateType.Type_Mating
		local	regMarket	= CppEnums.ServantStateType.Type_RegisterMarket
		local	regMating	= CppEnums.ServantStateType.Type_RegisterMating

		buttonList[buttonSlotNo]	= self._buttonSeal
		buttonSlotNo	= buttonSlotNo + 1
		
		buttonList[buttonSlotNo]	= self._buttonCompulsionSeal
		buttonSlotNo	= buttonSlotNo + 1

		if	( unSealServantInfo:getHp() < unSealServantInfo:getMaxHp() ) or ( unSealServantInfo:getMp() < unSealServantInfo:getMaxMp() )	then
			if ((CppEnums.VehicleType.Type_Horse == vehicleType) or (CppEnums.VehicleType.Type_Donkey == vehicleType) or (CppEnums.VehicleType.Type_Camel == vehicleType) or (CppEnums.VehicleType.Type_MountainGoat == vehicleType)) and ( not unSealServantInfo:isMatingComplete() ) and nowMating ~= getState and regMarket ~= getState and regMating ~= getState then
				buttonList[buttonSlotNo]	= self._buttonRecoveryUnseal
				buttonSlotNo	= buttonSlotNo + 1
			end
		end
		if ( unSealServantInfo:getHp() < unSealServantInfo:getMaxHp() ) then
			if ( CppEnums.VehicleType.Type_Carriage == vehicleType ) or ( CppEnums.VehicleType.Type_CowCarriage == vehicleType )  then
				buttonList[buttonSlotNo]	= self._buttonRepairUnseal
				buttonSlotNo	= buttonSlotNo + 1
			end
		end
		
		positionX	= self._unseal._bg:GetPosX() + buttonConfig.startX
		positionY	= self._unseal._bg:GetPosY() + buttonConfig.startY
	
	else
		buttonList[buttonSlotNo]	= self._buttonRegister
		buttonSlotNo	= buttonSlotNo + 1
		
		positionX	= self._taming._bg:GetPosX() + buttonConfig.startX
		positionY	= self._taming._bg:GetPosY() + buttonConfig.startY
	end
	
	local	sizeX	= self._staticButtonListBG:GetSizeX()
	local	sizeY	= buttonConfig.sizeYY
	for index, button in pairs(buttonList) do
		button:SetShow( true )
		button:SetPosX( buttonConfig.startButtonX								)
		button:SetPosY( buttonConfig.startButtonY + buttonConfig.gapY * index	)
		sizeY	= sizeY + buttonConfig.sizeY
	end
	if 0 ~= buttonSlotNo then 
		self._staticButtonListBG:SetPosX( positionX	)
		self._staticButtonListBG:SetPosY( positionY	)
		self._staticButtonListBG:SetSize( sizeX, sizeY )
		self._staticButtonListBG:SetShow(true)
	else
		self._staticButtonListBG:SetShow(false)
	end
end

function	StableList_ButtonClose()
	local	self	= stableList
	if	( not self._staticButtonListBG:GetShow() )	then
		return
	end
	
	self._staticButtonListBG:SetShow(false)
end
----------------------------------------------------------------------------------------------------
-- Slot Function
function	StableList_SlotSelect( slotNo )
	if	nil == slotNo	then
		return
	end
	
	audioPostEvent_SystemUi(00,00)
	--audioPostEvent_SystemUi(01,00)

	local	self	= stableList
	
	-- effect 초기화
	for ii = 0, self._config.slotCount-1	do
		self._slots[ii].effect:SetShow(false)
	end
	
	if	-1 == self._slots[slotNo].index	then
		return
	end
	
	self._slots[slotNo].effect:SetShow(true)
	self._selectSlotNo		= self._slots[slotNo].index
	self._selectSceneIndex	= Servant_ScenePushObject( StableList_SelectSlotNo(), self._selectSceneIndex )
	
	StableInfo_Open()
	-- StableEquipInfo_Open() -- 14.12.04 요청으로 인하여 꺼줌.
	StableList_ButtonOpen( self._const.eTypeSealed, slotNo )
end

----------------------------------------------------------------------------------------------------
-- Button Function
function	StableList_Seal( isCompulsion )
	StableList_ButtonClose()
	audioPostEvent_SystemUi(00,00)
	
	stable_seal( isCompulsion )
end

function	StableList_Unseal()
	StableList_ButtonClose()

	-- ♬ 말을 맡긴다.
	audioPostEvent_SystemUi(00,00)
	
	stable_unseal( StableList_SelectSlotNo() )

	-- 말을 바꾸면, 말 피격시 이팩트 출력을 위한 _servant_BeforHP 값을 새로 바꿔준다.
	local	servantInfo		= stable_getServant( StableList_SelectSlotNo() )
	if	nil == servantInfo	then
		return
	end
	reset_ServantHP( servantInfo:getHp() )
	stableList._scroll:SetControlTop()
	_startSlotIndex = 0
end

function	StableList_RecoveryUnseal()
	StableList_ButtonClose()
	local	temporaryWrapper= getTemporaryInformationWrapper()
	local	servantWrapper	= temporaryWrapper:getUnsealVehicle( CppEnums.ServantType.Type_Vehicle )
	if	( nil == servantWrapper )	then
		return
	end

	local	imprintMoney	= makeDotMoney( servantWrapper:getRecoveryOriginalCost_s64() )
	local	needMoney		= makeDotMoney( servantWrapper:getRecoveryCost_s64() )
	if( servantWrapper:getRecoveryOriginalCost_s64() <= Defines.s64_const.s64_1 )	then
		return
	end
	
	if servantWrapper:isImprint() then
		Imprint_Notify_Title = PAGetStringParam1( Defines.StringSheet_GAME, "LUA_SERVANT_STABEL_RECOVERY_NOTIFY_MSG", "needMoney", imprintMoney ) .. "\n\n각인되어 <PAColor0xFF00C0D7>" .. needMoney .. "<PAOldColor> 은화로 회복됩니다."
	else
		if (servantWrapper:getVehicleType() == CppEnums.VehicleType.Type_Horse) or (servantWrapper:getVehicleType() == CppEnums.VehicleType.Type_Camel) or (servantWrapper:getVehicleType() == CppEnums.VehicleType.Type_Donkey) or (servantWrapper:getVehicleType() == CppEnums.VehicleType.Type_Elephant) then
			Imprint_Notify_Title = PAGetStringParam1( Defines.StringSheet_GAME, "LUA_SERVANT_STABEL_RECOVERY_NOTIFY_MSG", "needMoney", imprintMoney ) .. "\n\n각인이 되지 않아 할인율이 적용되지 않습니다."
		else
			Imprint_Notify_Title = PAGetStringParam1( Defines.StringSheet_GAME, "LUA_SERVANT_STABEL_RECOVERY_NOTIFY_MSG", "needMoney", imprintMoney )
		end
	end

	local	vehicleType	= servantWrapper:getVehicleType()
		Servant_Confirm( PAGetString(Defines.StringSheet_GAME, "LUA_SERVANT_STABEL_RECOVERY_NOTIFY_TITLE"), Imprint_Notify_Title, StableList_RecoveryUnsealXXX, MessageBox_Empty_function )
	stableList._scroll:SetControlTop()
	_startSlotIndex = 0
end

function	StableList_RecoveryUnsealXXX()
	audioPostEvent_SystemUi(05,07)
	stable_recoveryUnseal()
end

function	StableList_Recovery()
	StableList_ButtonClose()

	local	servantInfo		= stable_getServant( StableList_SelectSlotNo() )
	if	( nil == servantInfo )	then
		return
	end

	local	needMoney		= 0
	local	confirmFunction	= nil
	local	vehicleType	= servantInfo:getVehicleType()
	if	0 == servantInfo:getHp()	then
		imprintMoney	= makeDotMoney( servantInfo:getReviveOriginalCost_s64() )
		needMoney		= makeDotMoney( servantInfo:getReviveCost_s64() )
		confirmFunction	= StableList_ReviveXXX
	else
		imprintMoney	= makeDotMoney( servantInfo:getRecoveryOriginalCost_s64() )
		needMoney		= makeDotMoney( servantInfo:getRecoveryCost_s64() )
		confirmFunction	= StableList_RecoveryXXX
	end

	if servantInfo:isImprint() then
		Imprint_Notify_Title = PAGetStringParam1( Defines.StringSheet_GAME, "LUA_SERVANT_STABEL_RECOVERY_NOTIFY_MSG", "needMoney", imprintMoney ) .. "\n\n각인되어 <PAColor0xFF00C0D7>" .. needMoney .. "<PAOldColor> 은화로 회복됩니다."
	else
		if (servantInfo:getVehicleType() == CppEnums.VehicleType.Type_Horse) or (servantInfo:getVehicleType() == CppEnums.VehicleType.Type_Camel) or (servantInfo:getVehicleType() == CppEnums.VehicleType.Type_Donkey) or (servantInfo:getVehicleType() == CppEnums.VehicleType.Type_Elephant) then
			Imprint_Notify_Title = PAGetStringParam1( Defines.StringSheet_GAME, "LUA_SERVANT_STABEL_RECOVERY_NOTIFY_MSG", "needMoney", imprintMoney ) .. "\n\n각인이 되지 않아 할인율이 적용되지 않습니다."
		else
			Imprint_Notify_Title = PAGetStringParam1( Defines.StringSheet_GAME, "LUA_SERVANT_STABEL_RECOVERY_NOTIFY_MSG", "needMoney", imprintMoney )
		end
	end

	local Recovery_Notify_Title = PAGetString(Defines.StringSheet_GAME, "LUA_SERVANT_STABEL_RECOVERY_NOTIFY_TITLE")


	if ( CppEnums.VehicleType.Type_Carriage == vehicleType ) or ( CppEnums.VehicleType.Type_CowCarriage == vehicleType ) or ( CppEnums.VehicleType.Type_Boat == vehicleType ) or ( CppEnums.VehicleType.Type_Raft == vehicleType ) then
		-- Servant_Confirm( "탈 것 회복", "해당 탑승물의 HP와 스태미너 회복에 총"..needMoney.."실버가 필요합니다.\n회복 하시겠습니까?", confirmFunction, MessageBox_Empty_function )
		Servant_Confirm( Recovery_Notify_Title, PAGetStringParam1( Defines.StringSheet_GAME, "LUA_SERVANT_STABEL_CARRIAGE_RECOVERY_NOTIFY_MSG", "needMoney", needMoney ), confirmFunction, MessageBox_Empty_function )
	else
		Servant_Confirm( Recovery_Notify_Title, Imprint_Notify_Title, confirmFunction, MessageBox_Empty_function )
	end
end

function	StableList_RecoveryXXX()
	audioPostEvent_SystemUi(05,07)
	stable_recovery( StableList_SelectSlotNo() )
	-- FGlobal_StableInfoUpdate()
	StableInfo_Open()
end

function	StableList_ReviveXXX()
	audioPostEvent_SystemUi(05,07)
	stable_revive( StableList_SelectSlotNo() )
	-- FGlobal_StableInfoUpdate()
	StableInfo_Open()
end

function	StableList_SellToNpc()
	StableList_ButtonClose()
	
	local	servantInfo		= stable_getServant( StableList_SelectSlotNo() )
	if	nil == servantInfo	then
		return
	end
	
	local	resultMoney		= makeDotMoney(servantInfo:getSellCost_s64())
	Servant_Confirm( PAGetString(Defines.StringSheet_GAME, "LUA_SERVANT_STABEL_SELL_NOTIFY_TITLE"), PAGetStringParam1( Defines.StringSheet_GAME, "LUA_SERVANT_STABEL_SELL_NOTIFY_MSG", "resultMoney", resultMoney ) .. servantInvenAlert, StableList_SellToNpcXXX, MessageBox_Empty_function )
end

function	StableList_SellToNpcXXX()
	stable_changeToReward( StableList_SelectSlotNo(), CppEnums.ServantToRewardType.Type_Money )
	sellCheck = true
end

function	StableList_Release()
	StableList_ButtonClose()
	
	local	servantInfo		= stable_getServant( StableList_SelectSlotNo() )
	if	nil == servantInfo	then
		return
	end
	
	Servant_Confirm( PAGetString(Defines.StringSheet_GAME, "LUA_SERVANT_STABEL_RELEASE_NOTIFY_TITLE"), PAGetString(Defines.StringSheet_GAME, "LUA_SERVANT_STABEL_RELEASE_NOTIFY_MSG") .. servantInvenAlert .. PAGetString(Defines.StringSheet_GAME, "LUA_SERVANT_SELL_LETOUT_MSG"), StableList_ReleaseXXX, MessageBox_Empty_function )
end

function	StableList_ReleaseXXX()
	stable_changeToReward( StableList_SelectSlotNo(), CppEnums.ServantToRewardType.Type_Experience )
	sellCheck = false
end

function	StableList_ChangeName()
	StableList_ButtonClose()
	
	StableRegister_OpenByEventType( CppEnums.ServantRegist.eEventType_ChangeName )
end

function	StableList_RegisterMating()
	StableList_ButtonClose()
	audioPostEvent_SystemUi(00,00)
		
	Servant_Confirm( PAGetString(Defines.StringSheet_GAME, "LUA_SERVANT_STABEL_REGISTERMATING_NOTIFY_TITLE"), PAGetString(Defines.StringSheet_GAME, "LUA_SERVANT_STABEL_REGISTERMATING_NOTIFY_MSG"), StableList_RegisterMatingXXX, MessageBox_Empty_function )
end

function	StableList_RegisterMatingXXX()	
	local	slotNo		= StableList_SelectSlotNo()
	local	servantInfo	= stable_getServant( slotNo )
	if	nil == servantInfo	then
		return
	end
	
	StableRegister_OpenByEventType( CppEnums.ServantRegist.eEventType_RegisterMating )
	--local	characterKey= CharacterKey( servantInfo:getCharacterKeyRaw() )
	--local	minPice_s64	= servantInfo:getMinRegisterPrice_s64()
	--Panel_NumberPad_Show_Min(  true, minPice_s64, slotNo, StableList_RegisterMatingXXXXX )
end

function	StableList_RegisterMatingXXXXX( s64_inputNumber, slotNo )
	stable_registerServantToSomeWhereElse( StableList_SelectSlotNo(), CppEnums.AuctionType.AuctionGoods_ServantMating, s64_inputNumber )
end

function	StableList_RegisterMarket()
	StableList_ButtonClose()
	audioPostEvent_SystemUi(00,00)
	
	Servant_Confirm( PAGetString(Defines.StringSheet_GAME, "LUA_SERVANT_STABEL_REGISTERMARKET_NOTIFY_TITLE"), PAGetString(Defines.StringSheet_GAME, "LUA_SERVANT_STABEL_REGISTERMARKET_NOTIFY_MSG") .. "\n해당 탑승물이 각인 상태라면\n마시장에 등록되지 않습니다.", StableList_RegisterMarketXXX, MessageBox_Empty_function )
end

function	StableList_RegisterMarketXXX()
	local	slotNo		= StableList_SelectSlotNo()
	local	servantInfo	= stable_getServant( slotNo )
	if	nil == servantInfo	then
		return
	end
	
	StableRegister_OpenByEventType( CppEnums.ServantRegist.eEventType_RegisterMarket )
	--local	characterKey= CharacterKey( servantInfo:getCharacterKeyRaw() )
	--local	minPice_s64	= servantInfo:getMinRegisterPrice_s64()	
	--Panel_NumberPad_Show_Min(  true, minPice_s64, slotNo, StableList_RegisterMarketXXXXXX )
end

function	StableList_RegisterMarketXXXXXX( s64_inputNumber, slotNo )
	stable_registerServantToSomeWhereElse( StableList_SelectSlotNo(), CppEnums.AuctionType.AuctionGoods_ServantMarket, s64_inputNumber )
end

function	StableList_RegisterCancel()
	StableList_ButtonClose()
	
	StableMating_Cancel( StableList_SelectSlotNo() )
end

function	StableList_RegisterFromTaming()
	StableList_ButtonClose()
	audioPostEvent_SystemUi(00,00)
	
	StableRegister_OpenByTaming()
	
	Panel_FrameLoop_Widget:SetShow(false)
end

function	StableList_ReceiveChildServant()
	StableList_ButtonClose()
	
	stable_getServantMatingChildInfo( StableList_SelectSlotNo() )
end

function StableList_ClearDeadCount()
	StableList_ButtonClose()
	audioPostEvent_SystemUi(00,00)

	local clearDeadCountDo = function()
		stable_clearDeadCount( StableList_SelectSlotNo() )
	end

	local messageBoxMemo	= "이 탑승물의 죽은 횟수를 초기화 하시겠습니까? 초기화와 함께 탑승물의 생명력과 기력이 회복됩니다."
	local messageBoxData	= { title = "알 림", content = messageBoxMemo, functionYes = clearDeadCountDo, functionNo = MessageBox_Empty_function, priority = CppEnums.PAUIMB_PRIORITY.PAUIMB_PRIORITY_LOW}
	MessageBox.showMessageBox(messageBoxData)
end

function	StableList_ClearMatingCount()
	StableList_ButtonClose()
	audioPostEvent_SystemUi(00,00)

	local clearMatingCountDo = function()
		stable_clearMatingCount( StableList_SelectSlotNo() )
	end

	local messageBoxMemo	= "이 탑승물의 교배 횟수를 초기화 하시겠습니까?"
	local messageBoxData	= { title = "알 림", content = messageBoxMemo, functionYes = clearMatingCountDo, functionNo = MessageBox_Empty_function, priority = CppEnums.PAUIMB_PRIORITY.PAUIMB_PRIORITY_LOW}
	MessageBox.showMessageBox(messageBoxData)
end

function	StableList_Imprint()
	StableList_ButtonClose()
	audioPostEvent_SystemUi(00,00)

	local imprint = function()
		stable_imprint( StableList_SelectSlotNo() )
	end

	local messageBoxMemo	= "탑승물을 각인시키면 부활 및 회복 시 비용이 줄어듭니다.\n이 탑승물을 각인시키겠습니까?"
	local messageBoxData	= { title = "알 림", content = messageBoxMemo, functionYes = imprint, functionNo = MessageBox_Empty_function, priority = CppEnums.PAUIMB_PRIORITY.PAUIMB_PRIORITY_LOW}
	MessageBox.showMessageBox(messageBoxData)
end

----------------------------------------------------------------------------------------------------
-- Common Function
function	StableList_SelectSlotNo()
	local	self	= stableList
	return( self._selectSlotNo )
end

function	StableList_ScrollEvent( isScrollUp )
	local	self		= stableList
	local	servantCount= stable_count()
	
	self._startSlotIndex= UIScroll.ScrollEvent( self._scroll, isScrollUp, self._config.slotCount, servantCount, self._startSlotIndex, 1 )
	
	self:update()
	
	StableList_ButtonClose()
end

function	Stable_SlotSound(slotNo)
	if isFirstSlot == true then
		StableList_SlotLClick(slotNo)
		isFirstSlot = false
	else
		audioPostEvent_SystemUi(01,00)
		StableList_SlotLClick(slotNo)
	end
end

----------------------------------------------------------------------------------------------------
-- From Client Function
function	StableList_UpdateSlotData()
	if	(not Panel_Window_StableList:GetShow() )	then
		return
	end
	local	self	= stableList
	self:update()
	--StableList_ScrollEvent( false )
	StableList_SlotSelect( StableList_SelectSlotNo() )
end

function	StableList_PopMessageBox( possibleTime_s64 )
	local	stringText		= convertStringFromDatetime( possibleTime_s64 )
	local	messageBoxMemo	= stringText .. ' 후에 등록 가능합니다.'
	local	messageBoxData	= { title = '알림', content = messageBoxMemo, functionApply = MessageBox_Empty_function, priority = CppEnums.PAUIMB_PRIORITY.PAUIMB_PRIORITY_LOW}
	MessageBox.showMessageBox(messageBoxData)
end

function	FromClient_ServantSeal( servantNo ) -- 맡기기 시 호출
	local	servantInfo		= stable_getServantByServantNo( servantNo )
	if nil == servantInfo then
		return
	end

	Proc_ShowMessage_Ack("탑승물을 맡겼습니다.")
end

function FromClient_ServantUnseal( servantNo )
	local servantInfo = stable_getServantByServantNo( servantNo )
	if nil == servantInfo then
		return
	end

	Proc_ShowMessage_Ack("탑승물을 찾았습니다.")
end

function FromClient_ServantToReward( servantNo )
	local servantInfo = stable_getServantByServantNo( servantNo )

	if sellCheck == true then
		Proc_ShowMessage_Ack("탑승물을 판매하였습니다.")
	else
		Proc_ShowMessage_Ack("탑승물을 놓아주었습니다.")
	end
end

function FromClient_ServantRecovery( servantNo )
	local servantInfo = stable_getServantByServantNo( servantNo )
	if nil == servantInfo then
		return
	end
	if ( servantInfo:getVehicleType() == CppEnums.VehicleType.Type_Horse ) or ( servantInfo:getVehicleType() == CppEnums.VehicleType.Type_Camel ) or ( servantInfo:getVehicleType() == CppEnums.VehicleType.Type_Donkey ) or ( servantInfo:getVehicleType() == CppEnums.VehicleType.Type_Elephant ) or ( servantInfo:getVehicleType() == CppEnums.VehicleType.Type_MountainGoat ) then
		Proc_ShowMessage_Ack("탑승물이 회복되었습니다.")
	elseif ( servantInfo:getVehicleType() == CppEnums.VehicleType.Type_Carriage) or ( servantInfo:getVehicleType() == CppEnums.VehicleType.Type_Boat) or ( servantInfo:getVehicleType() == CppEnums.VehicleType.Type_CowCarriage) or ( servantInfo:getVehicleType() == CppEnums.VehicleType.Type_Raft) or ( servantInfo:getVehicleType() == CppEnums.VehicleType.Type_FishingBoat) or ( servantInfo:getVehicleType() == CppEnums.VehicleType.Type_SailingBoat)	then
		Proc_ShowMessage_Ack("탑승물이 수리되었습니다.")
	end
end

function FromClient_ServantChangeName( servantNo )
	local servantInfo = stable_getServantByServantNo( servantNo )
	if nil == servantInfo then
		return
	end

	Proc_ShowMessage_Ack("탑승물의 이름을 변경하였습니다.")
end

function FromClient_ServantRegisterAuction( servantNo )
	local servantInfo = stable_getServantByServantNo( servantNo )
	if nil == servantInfo then
		return
	end

	Proc_ShowMessage_Ack("시장에 탑승물을 등록하였습니다.")
end

function FromClient_ServantCancelAuction( servantNo )
	local servantInfo = stable_getServantByServantNo( servantNo )
	if nil == servantInfo then
		return
	end

	Proc_ShowMessage_Ack("시장에 탑승물 등록을 취소하였습니다.")
end

function FromClient_ServantReceiveAuction( servantNo )
	local servantInfo = stable_getServantByServantNo( servantNo )
	if nil == servantInfo then
		return
	end

	Proc_ShowMessage_Ack("시장에서 탑승물을 수령하였습니다.")
end

function FromClient_ServantBuyMarket()
	Proc_ShowMessage_Ack("탑승물을 구매하였습니다.")
end

function FromClient_ServantStartMating( servantNo )
	local servantInfo = stable_getServantByServantNo( servantNo )
	if nil == servantInfo then
		return
	end

	Proc_ShowMessage_Ack("교배가 시작되었습니다.")
end

function FromClient_ServantChildMating( servantNo )
	local servantInfo = stable_getServantByServantNo( servantNo )
	if nil == servantInfo then
		return
	end

	Proc_ShowMessage_Ack("망아지를 수령하였습니다.")
end

function FromClient_ServantClearDeadCount()
	Proc_ShowMessage_Ack("죽은 횟수가 초기화 됐습니다.")
end

function FromClient_ServantImprint( servantNo )
	local servantInfo = stable_getServantByServantNo( servantNo )
	if nil == servantInfo then
		return
	end

	Proc_ShowMessage_Ack("탑승물을 각인하였습니다.")
end

function FromClient_ServantClearMatingCount( servantNo )
	local servantInfo = stable_getServantByServantNo( servantNo )
	if nil == servantInfo then
		return
	end

	Proc_ShowMessage_Ack("교배 횟수를 초기화였습니다.")
end

	-- ( "FromClient_ServantUnseal" )					-- 찾기 시 호출
	-- ( "FromClient_ServantToReward" )					-- 판매 or 놓아주기
	-- ( "FromClient_ServantRecovery" )					-- 회복시 호출
	-- ( "FromClient_ServantChangeName" )				-- 이름 변경
	-- ( "FromClient_ServantRegisterAuction" )			-- 교배 및 거래시장 등록
	-- ( "FromClient_ServantCancelAuction" )			-- 교배 및 거래시장 취소
	-- ( "FromClient_ServantReceiveAuction" )			-- 교배 및 거래시장 수령
	-- ( "FromClient_ServantBuyMarket" )				-- 거래시장 구매
	-- ( "FromClient_ServantStartMating" )				-- 교배시장 시작
	-- ( "FromClient_ServantChildMating" )				-- 교배시장 말 수령
----------------------------------------------------------------------------------------------------
-- Window Open/Close
function	StableList_Open()
	local	self		= stableList	
	self._selectSlotNo	= nil
	self._startSlotIndex= 0
	self:update()
	
	UIAni.fadeInSCR_Down(Panel_Window_StableList)
	
	-- StableList_SlotSelect(0)
	for ii = 0, self._config.slotCount-1	do
		self._slots[ii].effect:SetShow(false)
	end
	
	if	( not Panel_Window_StableList:GetShow() )	then
		Panel_Window_StableList:SetShow(true)
	end

	-- 찾은 말이 있다면! 버튼을 오픈한다.
	local temporaryWrapper = getTemporaryInformationWrapper()
	local	servantInfo	= temporaryWrapper:getUnsealVehicle( stable_getServantType() )
	if(	nil ~= servantInfo )	then
		StableList_ButtonOpen( self._const.eTypeUnsealed, 0 )
	end
end

function	StableList_Close()
	if	( not Panel_Window_StableList:GetShow() )	then
		return
	end
	
	local	self		= stableList	
	
	Servant_ScenePopObject( self._selectSceneIndex )
	
	self._scroll:SetControlTop()
	_startSlotIndex = 0
	StableInfo_Close()
	StableEquipInfo_Close()
	StableRegister_Close()
	StableMarketInput_Close()
	StableList_ButtonClose()
	Panel_Window_StableList:SetShow(false)
end

----------------------------------------------------------------------------------------------------
-- Window Open/Close
stableList:init()
stableList:registEventHandler()
stableList:registMessageHandler()

StableList_Resize()