Panel_Window_Warehouse:SetShow( false, false )
Panel_Window_Warehouse:setMaskingChild(true)
Panel_Window_Warehouse:ActiveMouseEventEffect(true)
Panel_Window_Warehouse:setGlassBackground(true)

Panel_Window_Warehouse:RegisterShowEventFunc( true, 'WarehouseShowAni()' )
Panel_Window_Warehouse:RegisterShowEventFunc( false, 'WarehouseHideAni()' )

local UI_ANI_ADV 	= CppEnums.PAUI_ANIM_ADVANCE_TYPE
local UI_color 		= Defines.Color
local UI_PUCT 		= CppEnums.PA_UI_CONTROL_TYPE
local UI_TM = CppEnums.TextMode

function WarehouseShowAni()
	Panel_Window_Warehouse:SetAlpha( 0 )
	UIAni.AlphaAnimation( 1, Panel_Window_Warehouse, 0.0, 0.15 )
	audioPostEvent_SystemUi(01,00)
end

function WarehouseHideAni()
	Panel_Window_Warehouse:SetShowWithFade(CppEnums.PAUI_SHOW_FADE_TYPE.PAUI_ANI_TYPE_FADE_OUT)
	local aniInfo1 = Panel_Window_Warehouse:addColorAnimation( 0.0, 0.15, UI_ANI_ADV.PAUI_ANIM_ADVANCE_SIN_HALF_PI)
	aniInfo1:SetStartColor( UI_color.C_FFFFFFFF )
	aniInfo1:SetEndColor( UI_color.C_00FFFFFF )
	aniInfo1:SetStartIntensity( 3.0 )
	aniInfo1:SetEndIntensity( 1.0 )
	aniInfo1.IsChangeChild = true
	aniInfo1:SetHideAtEnd(true)
	aniInfo1:SetDisableWhileAni(true)
	
	audioPostEvent_SystemUi(01,00)
end
	
local effectScene = {
	newItem = {}
}

local _wareHouse_HelpMovie 			= UI.createControl( CppEnums.PA_UI_CONTROL_TYPE.PA_UI_CONTROL_WEBCONTROL, Panel_Window_Warehouse, 'Static_ClassMovie' )
local _wareHouse_HelpMovie_Btn		= UI.getChildControl( Panel_Window_Warehouse, "Static_MoviePlayButton" )
local _wareHouseHelp				= UI.getChildControl( Panel_Window_Warehouse, "StaticText_LoaderHelp" )

local warehouse = {
	slotConfig =
	{
		-- 일단 아이콘, 테두리, 카운트숫자) 만 적용한다!
		createIcon			= true,
		createBorder		= true,
		createCount			= true,
		createEnchant		= true,
		createCash			= true,
		createEnduranceIcon = true,
	},
	
	config = 
	{
		-- 이 값들은 추후에 메시지로 빼어내어 세팅해야 한다!
		slotCount	= 72,		--UI 크기에 맞췄다
		slotCols	= 8,
		slotRows	= 0,		-- 계산되는 값	
		slotStartX	= 19,		--10
		slotStartY	= 64,		--64
		slotGapX	= 47,		--47
		slotGapY	= 47,		--47
	},
	
	-- 컨트롤들
	blankSlots		= Array.new(),
	slots			= Array.new(),
	
	staticTitle		= UI.getChildControl( Panel_Window_Warehouse, "Static_Text_Title"			),
	staticCapacity	= UI.getChildControl( Panel_Window_Warehouse, "Static_Text_Capacity"		),
	staticWeight	= UI.getChildControl( Panel_Window_Warehouse, "Static_Text_Weight"			),
	staticMoney		= UI.getChildControl( Panel_Window_Warehouse, "Static_Text_Money"			),
	buttonMoney		= UI.getChildControl( Panel_Window_Warehouse, "Button_Money"				),
	buttonClose		= UI.getChildControl( Panel_Window_Warehouse, "Button_Win_Close"			),
	buttonQuestion 	= UI.getChildControl( Panel_Window_Warehouse, "Button_Question"				),	-- 물음표 버튼
	checkSort		= UI.getChildControl( Panel_Window_Warehouse, "CheckButton_ItemSort"		),
	_scroll			= UI.getChildControl( Panel_Window_Warehouse, "Scroll_WareHouse"			),
	_buttonDelivery	= UI.getChildControl( Panel_Window_Warehouse, "Button_DeliveryInformation"	),
	
	_currentWaypointKey			= 0,															--현재 마을 키
	_currentRegionName			= 'None',														--현재 마을 이름
	_fromType					= CppEnums.WarehoouseFromType.eWarehoouseFromType_Worldmap,		--창고를 접근한 타입 ( 월드, npc, 설치물 )
	_installationActorKeyRaw	= 0,															--창고를 접근한 설치물 ActorKeyRaw
	_targetActorKeyRaw			= nil,															--이동 할 ActorKey ( 탈것 or 플레이어 )
	_deleteSlotNo				= nil,
	_s64_deleteCount			= Defines.s64_const.s64_0,
	_startSlotIndex				= 0,
	_tooltipSlotNo				= nil,
}

----------------------------------------------------------------------------
--	Init
----------------------------------------------------------------------------
function	warehouse:init()
	_wareHouse_HelpMovie_Btn:addInputEvent( "Mouse_On",		"Panel_WareHouse_MovieHelpFunc( true )"	)
	_wareHouse_HelpMovie_Btn:addInputEvent( "Mouse_Out",	"Panel_WareHouse_MovieHelpFunc( false )")

	self.config.slotRows	= self.config.slotCount / self.config.slotCols

	for ii = 0, self.config.slotCount-1 do
		local	slotNo	= ii+1
		local	slot	= {}

		slot.empty	= UI.createAndCopyBasePropertyControl( Panel_Window_Warehouse, "Static_Slot",			Panel_Window_Warehouse,	"Warehouse_Slot_Base_"		.. ii )
		slot.lock	= UI.createAndCopyBasePropertyControl( Panel_Window_Warehouse, "Static_LockedSlot",		Panel_Window_Warehouse,	"Warehouse_Slot_Lock_"		.. ii )

		-- position Set
		local row	= math.floor( ii / self.config.slotCols )
		local column= ii % self.config.slotCols
		
		slot.empty:SetPosX( self.config.slotStartX	+ self.config.slotGapX * column	)
		slot.empty:SetPosY( self.config.slotStartY	+ self.config.slotGapY * row	)
		slot.lock:SetPosX( self.config.slotStartX	+ self.config.slotGapX * column	)
		slot.lock:SetPosY( self.config.slotStartY	+ self.config.slotGapY * row	)
		
		slot.empty:SetShow( false )
		slot.lock:SetShow( true )

		self.blankSlots[ii] = slot
	end

	for ii = 0, self.config.slotCount-1 do
		local	slot	= {}

		SlotItem.new( slot, 'ItemIcon_' .. ii, ii, Panel_Window_Warehouse, self.slotConfig )
		slot:createChild()
		-- Panel_Window_Warehouse:SetChildIndex(slot.empty:GetKey(), 9990 )
		-- Panel_Window_Warehouse:SetChildIndex(slot.lock:GetKey(), 9990 )
		-- Panel_Window_Warehouse:SetChildIndex(slot.useless:GetKey(), 9990 )
		-- Panel_Window_Warehouse:SetChildIndex(slot.icon:GetKey(), 9999 )

		-- position Set
		local row	= math.floor( ii / self.config.slotCols )
		local column= ii % self.config.slotCols
		slot.icon:SetPosX( self.config.slotStartX	+ self.config.slotGapX * column	)
		slot.icon:SetPosY( self.config.slotStartY	+ self.config.slotGapY * row	)
		
		slot.icon:SetEnableDragAndDrop(true)
		slot.icon:SetAutoDisableTime( 1.0 )
		
		slot.icon:addInputEvent("Mouse_RUp",		"HandleClickedWarehouseItem("	.. ii .. ")"	)
		slot.icon:addInputEvent("Mouse_LUp",		"Warehouse_DropHandler("		.. ii .. ")"	)
		slot.icon:addInputEvent("Mouse_PressMove",	"Warehouse_SlotDrag("			.. ii .. ")"	)
		slot.icon:addInputEvent("Mouse_On",			"Warehouse_IconOver("			.. ii .. ")"	)
		slot.icon:addInputEvent("Mouse_Out",		"Warehouse_IconOut("			.. ii .. ")"	)
		
		UIScroll.InputEventByControl(	slot.icon,	"Warehouse_Scroll"	)
			
		Panel_Tooltip_Item_SetPosition( ii, slot, "WareHouse" )
		
		self.slots[ii] = slot	
	end
	
	self._scroll:SetShow( true )
	--_wareHouse_HelpMovie:SetUrl(320, 240, "coui://UI_Data/UI_Html/UI_Guide_Movie.html")
	_wareHouse_HelpMovie:SetSize(320, 240)
	_wareHouse_HelpMovie:SetSpanSize(-1,0)
	_wareHouse_HelpMovie:SetShow(false)	
end

function	warehouse:update()
	local	warehouseWrapper	= self:getWarehouse()
	if	( nil == warehouseWrapper )	then
		return
	end
	
	local	useStartSlot= 1	--inventorySlotNoUserStart()
	local	itemCount	= warehouseWrapper:getSize()						-- 아이템 갯수
	local	useMaxCount	= warehouseWrapper:getUseMaxCount() 				-- 최대 (현재 뚫려있는) 슬롯 개수 -1(돈)
	local	freeCount	= warehouseWrapper:getFreeCount()					-- 넣을 수 있는 아이템 개수
	local	money_s64	= warehouseWrapper:getMoney_s64()
	local	maxCount	= warehouseWrapper:getMaxCount()					-- 최대 뚫을 수 있는 슬롯 개수 -1(돈)
	
	-- 개수 설정
	--	창고에  소지한 아이템 갯수가 최대치를 넘어서면 붉은 색으로 바꾼다.
	--{
		if	( (useMaxCount - useStartSlot) < itemCount )	then
			self.staticCapacity:SetText( PAGetStringParam2( Defines.StringSheet_GAME, "Lua_WareHouse_OverCapacity",	"HaveCount", tostring(itemCount), "FullCount", tostring(useMaxCount - useStartSlot) ) )
		else
			self.staticCapacity:SetText( PAGetStringParam2( Defines.StringSheet_GAME, "Lua_WareHouse_Capacity",		"HaveCount", tostring(itemCount), "FullCount", tostring(useMaxCount - useStartSlot) ) )
		end
		self.staticMoney:SetText( makeDotMoney(money_s64) )
	--}
	
	--{
		local	slotNoList	= Array.new()
		slotNoList:fill( useStartSlot, maxCount - 1 )
	--}

	-- 아이템 정렬
	--{
		if self.checkSort:IsCheck() then
			local	sortList	= Array.new()
			sortList:fill( useStartSlot , useMaxCount - 1 )	-- 2 ~ 17
			sortList:quicksort( Warehouse_ItemComparer )
			
			for	ii = 1, useMaxCount - 1	do
				slotNoList[ii]	= sortList[ii]
			end
		end
	--}
	
	
	--Empty & Lock Slot
	--{
		for	ii = 0, self.config.slotCount -1	do
			local	slot	= self.blankSlots[ii]
			
			slot.empty:SetShow( false )
			slot.lock:SetShow( false )
			
			if( ii < (useMaxCount - useStartSlot - self._startSlotIndex) )	then
				slot.empty:SetShow( true )
			else
				slot.lock:SetShow( true )
			end
		end
	--}

	-- 스크롤
	--{
		UIScroll.SetButtonSize( self._scroll, self.config.slotCount, (maxCount - useStartSlot) )
	--}
	
	--{
		for ii = 0, self.config.slotCount-1	do
			local	slot	= self.slots[ii]
			
			slot:clearItem()
			slot.icon:SetEnable( true )
			slot.icon:SetMonoTone( true )
		end
	--}

	--{
		for ii = 0, self.config.slotCount-1	do
			local	slot	= self.slots[ii]
			local	slotNo	= slotNoList[1 + ii + self._startSlotIndex ]
			slot.slotNo	= slotNo
			
			-- position Set
			local	row		= math.floor( ii / self.config.slotCols )
			local	column	= ii % self.config.slotCols
			slot.icon:SetPosX( self.config.slotStartX + self.config.slotGapX * column	)
			slot.icon:SetPosY( self.config.slotStartY + self.config.slotGapY * row		)
			
			slot.icon:SetMonoTone(false)
			slot.count:SetShow(false)
			
			local	itemExist	= false
			local	itemWrapper	= warehouseWrapper:getItem( slotNo )
			if	nil ~= itemWrapper	then
				slot:setItem( itemWrapper )
				
				local	packingCount_s64 = delivery_getPackItemCount( slotNo )
				if	(Defines.s64_const.s64_0 == itemWrapper:get():getCount_s64() )	then -- 운송 시킨 아이템이 1개라도 있으면.
					slot.icon:SetMonoTone( true )
				else
					slot.count:SetShow( true )
				end
				
				itemExist = true
			end
			
			if not itemExist then
				slot:clearItem()
				slot.icon:SetEnable( true )
				slot.icon:SetMonoTone( true )
			end
		end
	--}
end

function	warehouse:isNpc()
	return( CppEnums.WarehoouseFromType.eWarehoouseFromType_Npc == self._fromType )
end

function	warehouse:isInstallation()
	return( CppEnums.WarehoouseFromType.eWarehoouseFromType_Installation == self._fromType )
end

function	warehouse:isWorldMapNode()
	return( CppEnums.WarehoouseFromType.eWarehoouseFromType_Worldmap == self._fromType )
end

function	warehouse:isGuildHouse()
	return( CppEnums.WarehoouseFromType.eWarehoouseFromType_GuildHouse == self._fromType )
end

function	warehouse:isDeliveryWindow()
	return( Panel_Window_Delivery_Request:GetShow() )
end

function	warehouse:getWarehouse()
	local	warehouseWrapper	= nil
	if( warehouse:isGuildHouse() ) then
		warehouseWrapper	= warehouse_getGuild()
	else
		warehouseWrapper	= warehouse_get( self._currentWaypointKey )
	end
	
	return(warehouseWrapper)
end

----------------------------------------------------------------------------
--							영상 설명 전용 함수
----------------------------------------------------------------------------
function Panel_WareHouse_MovieHelpFunc( isOn )
	_wareHouse_HelpMovie:SetPosX(Panel_Window_Warehouse:GetSizeX() )
	_wareHouse_HelpMovie:SetPosY( 70 )
	_wareHouseHelp:SetPosX( _wareHouse_HelpMovie:GetPosX() )
	_wareHouseHelp:SetPosY( _wareHouse_HelpMovie:GetPosY() - _wareHouseHelp:GetSizeY() )
	
	if ( isOn == true ) then
		_wareHouseHelp:SetShow( true )
		-- _wareHouseHelp:SetAutoResize( true )
		_wareHouseHelp:SetSize( 320, 40 )
		_wareHouseHelp:SetTextMode( UI_TM.eTextMode_AutoWrap )
		_wareHouseHelp:SetText(PAGetString(Defines.StringSheet_GAME, "LUA_WINDOW_WAREHOUSE_HELP" )) -- <PAColor0xFFFFD649>적재소<PAOldColor>가 늘어날수록 창고 슬롯이 더 많이 개방됩니다.
		
		_wareHouse_HelpMovie:SetShow( true )
		_wareHouse_HelpMovie:TriggerEvent( "PlayMovie", "coui://UI_Movie/Movie_Guide/WareHouse_AddSlot_KR.webm" )
	else
		_wareHouseHelp:SetShow( false )
		_wareHouse_HelpMovie:SetShow( false )
	end
end



----------------------------------------------------------------------------
--	FromClient 이벤트
----------------------------------------------------------------------------
function	warehouse:registMessageHandler()
	registerEvent("FromClient_WarehouseOpenByInstallation",	"FromClient_WarehouseOpenByInstallation")
	registerEvent("EventWarehouseUpdate",					"FromClient_WarehouseUpdate")
	registerEvent("FromClient_WarehouseClose",				"FromClient_WarehouseClose")
	registerEvent("EventGuildWarehouseUpdate",				"FromClient_GuildWarehouseUpdate")
end

----------------------------------------------------------------------------
-- Control 이벤트
----------------------------------------------------------------------------
function warehouse:registEventHandler()
	UIScroll.InputEvent(			self._scroll,			"Warehouse_Scroll"	)
	UIScroll.InputEventByControl(	Panel_Window_Warehouse,	"Warehouse_Scroll"	)
	self.buttonClose:addInputEvent(				"Mouse_LUp",		"Warehouse_Close()" 				)
	self.buttonMoney:addInputEvent(				"Mouse_LUp",		"HandleClickedWarehousePopMoney()"	)
		
	self.buttonQuestion:addInputEvent(			"Mouse_LUp",		"Panel_WebHelper_ShowToggle( \"WareHouse\" )" )	-- 물음표 좌클릭
	self.buttonQuestion:addInputEvent(			"Mouse_On",			"HelpMessageQuestion_Show( \"WareHouse\", \"true\")" )	-- 물음표 마우스오버
	self.buttonQuestion:addInputEvent(			"Mouse_Out",		"HelpMessageQuestion_Show( \"WareHouse\", \"false\")" )	-- 물음표 마우스아웃	
	self._buttonDelivery:addInputEvent(			"Mouse_LUp",		"Warehouse_OpenDelivery()" )
	self.checkSort:addInputEvent(				"Mouse_LUp",		"Warehouse_CheckSort()" )
	--UI.debugMessage( "등록" )
end

----------------------------------------------------------------------------
--	Global Function
----------------------------------------------------------------------------
function	FGlobal_Warehouse_IsMoveItem()
	local	self	= warehouse
	if self:isNpc() or self:isInstallation() or not self:isWorldMapNode() or self:isDeliveryWindow() or self:isGuildHouse() then
		return(true)
	end
	
	return(false)
end

function	FromClient_WarehouseUpdate()
	if	not Panel_Window_Warehouse:GetShow()	then
		return
	end
	
	local	self	= warehouse
	self:update()
end

function	FromClient_WarehouseClose()
	Warehouse_Close()
end

function FromClient_GuildWarehouseUpdate( bForcedOpen, bForcedClose )
	-- 길드 상점이 열려있는 경우 물건을 팔면 길드 창고의 길드 자금으로 들어오기에 이 함수가 호출이 된다.
	if Panel_Window_NpcShop:IsShow() then
		NpcShop_UpdateContent();
		return;
	end
	
	if( false == bForcedOpen ) then
		if(  false == Panel_Window_Warehouse:GetShow() ) then
			return;
		end
	end
	
	if( true == bForcedClose ) then
		Warehouse_Close()
		return;
	end
	
	local	self	= warehouse
	self._currentWaypointKey	= 0
	self._fromType				= CppEnums.WarehoouseFromType.eWarehoouseFromType_GuildHouse;
	self._currentRegionName		= PAGetString(Defines.StringSheet_GAME, "Lua_WareHouse_CurrentRegionName") -- '길드 하우스의 창고'
	self.staticTitle:SetText( self._currentRegionName )

	self:update()
	
	if	FGlobal_Warehouse_IsMoveItem()	then
		self.buttonMoney:SetIgnore(false)
	else
		self.buttonMoney:SetIgnore(true)
	end
	
	-- if	not Panel_Window_Warehouse:GetShow()	then
		Panel_Window_Warehouse:ChangeSpecialTextureInfoName("")
		Panel_Window_Warehouse:SetAlphaExtraChild(1)
		Panel_Window_Warehouse:SetShow( true, true )
	-- end
	
	Warehouse_OpenWithInventory()
end

----------------------------------------------------------------------------
--	Control Function
----------------------------------------------------------------------------
function	Warehouse_ItemComparer( ii, jj )
	return	Global_ItemComparer( ii, jj, Warehouse_GetItem )
end

function	Warehouse_CheckSort()
	-- ♬ SORT 버튼을 눌렀을 때 사운드 추가 (XML에서 CLICKSOUND가 동작하지 않음)
	local self = warehouse
	audioPostEvent_SystemUi(00,00)
	
	local isSorted	= self.checkSort:IsCheck()
	ToClient_SetSortedWarehouse( isSorted )
	
	FromClient_WarehouseUpdate()
end

function	Warehouse_OpenDelivery()
	local	self			= warehouse
	DeliveryInformation_OpenPanelFromWorldmap( self._currentWaypointKey )
end

function	HandleClickedWarehousePopMoney()
	local	self		= warehouse
	local	slotNo		= getMoneySlotNo()
	if	(not FGlobal_Warehouse_IsMoveItem() )	then
		return
	end
	
	HandleClickedWarehouseItemXXX( slotNo )
end

function	HandleClickedWarehouseItem( index )
	if	( Warehouse_DropHandler(index) )	then
		return
	end
	
	if	(not FGlobal_Warehouse_IsMoveItem() )	then
		return
	end

	local	self			= warehouse
	local	slotNo			= self.slots[index].slotNo
	
	HandleClickedWarehouseItemXXX( slotNo )
end
	
function	HandleClickedWarehouseItemXXX( slotNo )
	local	self			= warehouse
	local	warehouseWrapper= self:getWarehouse()
	local	itemWrapper		= warehouseWrapper:getItem( slotNo )
	if	(nil == itemWrapper)	then
		return
	end

	if Defines.s64_const.s64_0 == itemWrapper:get():getCount_s64() then
		return
	end
	
	FGlobal_PopupMoveItem_Init( nil, slotNo, CppEnums.MoveItemToType.Type_Warehouse, nil, true )
end

----------------------------------------------------------------------------
-- Item Push Function
----------------------------------------------------------------------------
function	Warehouse_PushFromInventoryItem( s64_count, whereType, slotNo, fromActorKeyRaw )

	local	self			= warehouse
	self._targetActorKeyRaw	= fromActorKeyRaw
	
	Panel_NumberPad_Show( true, s64_count, slotNo, Warehouse_PushFromInventoryItemXXX, nil, whereType )
end

function	Warehouse_PushFromInventoryItemXXX( s64_count, slotNo, whereType )
	local	self		= warehouse
	
	-- _PA_LOG( "luadebug", "Warehouse_PushFromInventoryItemXXX 11 " );
		
	if( self:isNpc() )	then
		-- _PA_LOG( "luadebug", "Warehouse_PushFromInventoryItemXXX 11 " );
		warehouse_pushFromInventoryItemByNpc(whereType, slotNo, s64_count, self._targetActorKeyRaw)	
	
	elseif( self:isInstallation() )	then
		-- _PA_LOG( "luadebug", "Warehouse_PushFromInventoryItemXXX 22 " );
		warehouse_pushFromInventoryItemByInstallation( self._installationActorKeyRaw, whereType, slotNo, s64_count, self._targetActorKeyRaw )

	elseif( self:isGuildHouse() ) then	
	
		-- _PA_LOG( "luadebug", "Warehouse_PushFromInventoryItemXXX 33 " );
		warehouse_pushFromInventoryItemByGuildHouse(whereType, slotNo, s64_count, self._targetActorKeyRaw)	
	end
end

----------------------------------------------------------------------------
-- Item Pop Function
----------------------------------------------------------------------------
function	Warehouse_PopToSomewhere( s64_count, slotNo, toActorKeyRaw )
	local	self			= warehouse
	self._targetActorKeyRaw	= toActorKeyRaw
	
	Panel_NumberPad_Show( true, s64_count, slotNo, Warehouse_PopToSomewhereXXX )
end

function	Warehouse_PopToSomewhereXXX( s64_count, slotNo )
	local	self		= warehouse
	
	if	Panel_Window_Inventory:GetShow()	then
		if( self:isNpc() )	then
			warehouse_popToInventoryByNpc(slotNo, s64_count, self._targetActorKeyRaw)
		elseif( self:isInstallation() )	then
			warehouse_popToInventoryByInstallation( self._installationActorKeyRaw, slotNo, s64_count, self._targetActorKeyRaw )
		elseif( self:isGuildHouse() ) then	
			warehouse_popToInventoryByGuildHouse(slotNo, s64_count, self._targetActorKeyRaw)	
		end
	elseif	Panel_Window_Delivery_Request:GetShow()	then
		DeliveryRequest_PushPackingItem(slotNo, s64_count)
	end
end	
----------------------------------------------------------------------------
-- Control Event
----------------------------------------------------------------------------
function	Warehouse_Scroll( isUp )
	local	self				= warehouse
	local	useStartSlot		= 1	--inventorySlotNoUserStart()
	local	warehouseWrapper	= self:getWarehouse()
	if	( nil == warehouseWrapper )	then
		return
	end
	
	local	maxSize				= warehouseWrapper:getMaxCount() - useStartSlot
	self._startSlotIndex		= UIScroll.ScrollEvent( self._scroll, isUp, self.config.slotRows, maxSize, self._startSlotIndex, self.config.slotCols )
	
	self:update()
end

----------------------------------------------------------------------------
-- Drag 관련 함수
----------------------------------------------------------------------------
function	Warehouse_SlotDrag( index )
	local	self			= warehouse
	local	slotNo			= self.slots[index].slotNo
	local	warehouseWrapper= self:getWarehouse()
	local	itemWrapper		= warehouseWrapper:getItem( slotNo )
	if	(nil == itemWrapper)	then
		return
	end
	
	if Defines.s64_const.s64_0 == itemWrapper:get():getCount_s64() then
		return
	end

	DragManager:setDragInfo( Panel_Window_Warehouse, nil, slotNo, "Icon/" .. itemWrapper:getStaticStatus():getIconPath(), Warehouse_GroundClick, nil )
end

function	Warehouse_DropHandler( index )
	local	self	= warehouse
	if nil == DragManager.dragStartPanel then
		return(false)
	end
	
	return( DragManager:itemDragMove( CppEnums.MoveItemToType.Type_Warehouse, nil ) )
end

function	Warehouse_GroundClick( whereType, slotNo ) 
	if	(false == Panel_Window_Warehouse:GetShow()) then
		return
	end

	local	self			= warehouse
	local	warehouseWrapper= self:getWarehouse()
	local	itemWrapper		= warehouseWrapper:getItem( slotNo )
	if	(nil == itemWrapper)	then
		return
	end
	
	s64_count	= itemWrapper:get():getCount_s64()
	itemName	= itemWrapper:getStaticStatus():getName()
	if( Defines.s64_const.s64_1 == s64_count ) then
		Warehouse_GroundClick_Message( Defines.s64_const.s64_1, slotNo)
	else
		Panel_NumberPad_Show(  true, s64_count, slotNo, Warehouse_GroundClick_Message) 
	end

end

function Warehouse_GroundClick_Message(s64_count, slotNo )
	local	self			= warehouse
	self._deleteSlotNo		= slotNo
	self._s64_deleteCount	= s64_count

	local luaDeleteItemMsg	= PAGetStringParam2( Defines.StringSheet_GAME, "LUA_INVENTORY_TEXT_DELETEITEM_MSG", "itemName", itemName, "itemCount", tostring(s64_count) )
	local luaDelete			= PAGetString( Defines.StringSheet_GAME, "LUA_INVENTORY_TEXT_DELETE")
	
	local messageContent	= luaDeleteItemMsg
	local messageboxData	= { title = luaDelete, content = messageContent, functionYes = Warehouse_Delete_Yes, functionNo = Warehouse_Delete_No, priority = CppEnums.PAUIMB_PRIORITY.PAUIMB_PRIORITY_LOW}
	MessageBox.showMessageBox( messageboxData )
end


function	Warehouse_Delete_Yes()
	local	self			= warehouse
	if	(nil == self._deleteSlotNo)	then
		return
	end
	
	local	warehouseWrapper= self:getWarehouse()
	local	itemWrapper		= warehouseWrapper:getItem( self._deleteSlotNo )
	if	(nil == itemWrapper)	then
		return
	end
	
	if	( itemWrapper:isCash() )	then
		PaymentPassword( Warehouse_Delete_YesXXX )
		return
	end
	
	Warehouse_Delete_YesXXX()
end

function	Warehouse_Delete_YesXXX()
	local	self	= warehouse
	if( self:isNpc() )	then
		warehouse_deleteItemByNpc(self._deleteSlotNo, self._s64_deleteCount)
	elseif( self:isInstallation() )	then
		warehouse_deleteItemByInstallation( self._installationActorKeyRaw, self._deleteSlotNo, self._s64_deleteCount )
	end
	
	self._deleteSlotNo		= nil
	self._s64_deleteCount	= Defines.s64_const.s64_0
end

function	Warehouse_Delete_No()
	local	self			= warehouse
	self._deleteSlotNo		= nil
	self._s64_deleteCount	= Defines.s64_const.s64_0
end

----------------------------------------------------------------------------
-- 툴팁
----------------------------------------------------------------------------
function	Warehouse_IconOver( index )
	local	self	= warehouse
	local	slot	= self.slots[index]
	
	slot.icon:EraseAllEffect()
	slot.icon:AddEffect( "UI_Inventory_EmptySlot", false, -1.5, -1.5 )
	
	self._tooltipSlotNo	= slot.slotNo

	Panel_Tooltip_Item_Show_GeneralNormal(index, "WareHouse", true)
end

function	Warehouse_IconOut( index )
	local	self	= warehouse
	local	slot	= self.slots[index]
	
	self._tooltipSlotNo		= nil
	
	Panel_Tooltip_Item_Show_GeneralNormal( index, "WareHouse", false)
end

function	Warehouse_GetToopTipItem()
	local	self				= warehouse
	local	warehouseWrapper	= self:getWarehouse()
	if	( nil == warehouseWrapper )	then
		return(nil)
	end

	if	( nil == self._tooltipSlotNo )	then
		return(nil)
	end
	
	return( warehouseWrapper:getItem( self._tooltipSlotNo ) )
end

function	Warehouse_GetItem( slotNo )
	local	self				= warehouse
	local	warehouseWrapper	= self:getWarehouse()
	if	( nil == warehouseWrapper )	then
		return(nil)
	end

	return( warehouseWrapper:getItem( slotNo ) )
end
------------------------------------------------------------
-- 					실버 버튼 막는 함수
------------------------------------------------------------
function Warehouse_SetIgnoreMoneyButton( setIgnore )
	local	self	= warehouse
	if ( setIgnore == true ) then
		self.buttonMoney:SetIgnore( true )
		--self.buttonMoney:SetColor( UI_color.C_FFD20000 )
		--self.buttonMoney:SetFontColor( UI_color.C_FFF26A6A )
			-- _PA_LOG("LUA", "여기가 버튼 막는 곳")
	else
		self.buttonMoney:SetIgnore( false )
		--self.buttonMoney:SetColor( UI_color.C_FFFFFFFF )
		--self.buttonMoney:SetFontColor( UI_color.C_FFC4BEBE )
			-- _PA_LOG("LUA", "버튼 다시 풀어주기")
	end
end

----------------------------------------------------------------------------
--	Window Open / Close
--	월드맵에서 접근시 < 확인 >
--	설치물 or Npc를 통해 접근시에는 <확인, 이동>
----------------------------------------------------------------------------
function	FromClient_WarehouseOpenByInstallation( actorKeyRaw, waypointKey )
	local	self					= warehouse
	self._installationActorKeyRaw	= actorKeyRaw
	
	Warehouse_OpenPanel( waypointKey, CppEnums.WarehoouseFromType.eWarehoouseFromType_Installation )
	
	Warehouse_OpenWithInventory()
	Warehouse_SetIgnoreMoneyButton( false )
end

function	Warehouse_OpenPanelFromDialog()
	local	self					= warehouse
	Warehouse_OpenPanel( getCurrentWaypointKey(), CppEnums.WarehoouseFromType.eWarehoouseFromType_Npc )
	
	if( UseNewWorldMap ) then
		if not ToClient_WorldMapIsShow() then
			Panel_Window_Warehouse:SetVerticalMiddle()
			Panel_Window_Warehouse:SetHorizonCenter()
			Panel_Window_Warehouse:SetSpanSize(100,0)
		end
	else
		if not Panel_Win_Worldmap:GetShow() then
			Panel_Window_Warehouse:SetVerticalMiddle()
			Panel_Window_Warehouse:SetHorizonCenter()
			Panel_Window_Warehouse:SetSpanSize(100,0)
		end
	end
	
	Warehouse_OpenWithInventory()
end

function	Warehouse_OpenPanelFromDialogWithoutInventory( waypointKey, fromType )
	local	self					= warehouse
	Warehouse_OpenPanel( waypointKey, fromType )
	
	if( false == UseNewWorldMap ) then
			if not Panel_Win_Worldmap:GetShow() then
				Panel_Window_Warehouse:SetVerticalMiddle()
				Panel_Window_Warehouse:SetHorizonCenter()
				Panel_Window_Warehouse:SetSpanSize(100,0)
			end
	else
			if( ToClient_WorldMapIsShow() ) then
				Panel_Window_Warehouse:SetVerticalMiddle()
				Panel_Window_Warehouse:SetHorizonCenter()
				Panel_Window_Warehouse:SetSpanSize(100,0)
			end
	end

end

function	Warehouse_OpenPanelFromWorldmap( waypointKey, fromType )
	local	self	=	warehouse

	if( UseNewWorldMap ) then
		if ToClient_WorldMapIsShow() then	
			Panel_Window_Warehouse:SetHorizonRight()
			Panel_Window_Warehouse:SetVerticalBottom()
		end
	else
		if Panel_Win_Worldmap:GetShow() then
			Panel_Window_Warehouse:SetHorizonRight()
			Panel_Window_Warehouse:SetVerticalBottom()
		end
	end
	
	Warehouse_OpenPanel( waypointKey, fromType )

	--창고 관리 눌렀을떄!
	if( not FGlobal_Warehouse_IsMoveItem() )	then
		DeliveryRequestWindow_Close()
		DeliveryInformationWindow_Close()
	end
end

function	Warehouse_OpenPanel( waypointKey, fromType )
	local	self	= warehouse
	self._currentWaypointKey	= waypointKey
	self._fromType				= fromType
	self._currentRegionName		= getRegionNameByWaypointKey( self._currentWaypointKey )
	self.staticTitle:SetText( self._currentRegionName )
	
	local isSorted = ToClient_IsSortedWarehouse()
	self.checkSort:SetCheck( isSorted )
	
	self._buttonDelivery:SetShow( false )
	if( self:isWorldMapNode() )	then
		self._buttonDelivery:SetShow( true )
	end

	clearDeliveryPack()
	
	self:update()
	
	if	FGlobal_Warehouse_IsMoveItem()	then
		self.buttonMoney:SetIgnore(false)
	else
		self.buttonMoney:SetIgnore(true)
	end
	
	-- if	not Panel_Window_Warehouse:GetShow()	then
		Panel_Window_Warehouse:ChangeSpecialTextureInfoName("")
		Panel_Window_Warehouse:SetAlphaExtraChild(1)
		Panel_Window_Warehouse:SetShow( true, true )
	-- end
	
	warehouse_requestInfo(self._currentWaypointKey)
end

function	Warehouse_OpenWithInventory()
	Inventory_SetFunctor( nil, FGlobal_PopupMoveItem_InitByInventory, Warehouse_Close, nil )
	InventoryWindow_Show()
	
	ServantInventory_OpenAll()
end

function	Warehouse_Close()
	local	self	= warehouse
	self._fromType	= CppEnums.WarehoouseFromType.eWarehoouseFromType_Worldmap
	
	if Panel_Window_Warehouse:GetShow() then
		if Panel_Window_Delivery_Information:GetShow() then
			DeliveryInformationWindow_Close()
		end
		if Panel_Window_Delivery_Request:GetShow() then
			DeliveryRequestWindow_Close()
	end
		if Panel_Window_Inventory:GetShow() then
			InventoryWindow_Close()
		end
	end
	
	Panel_Window_Warehouse:ChangeSpecialTextureInfoName("")
	Panel_Window_Warehouse:SetShow( false, false )
	ServantInventory_Close()
end

----------------------------------------------------------------------------
-- 초기화
----------------------------------------------------------------------------
warehouse:init()
warehouse:registEventHandler()
warehouse:registMessageHandler()
