local _staticFishBack		= UI.getChildControl ( Panel_FishEncyclopedia, "Static_FishBG" )
local _staticFishImage		= UI.getChildControl ( Panel_FishEncyclopedia, "Static_FishImage" )
local _staticFishRating1	= UI.getChildControl ( Panel_FishEncyclopedia, "Static_FishRating1" )
local _staticFishRating2	= UI.getChildControl ( Panel_FishEncyclopedia, "Static_FishRating2" )
local _staticFishRating3	= UI.getChildControl ( Panel_FishEncyclopedia, "Static_FishRating3" )
local _staticFishRating4	= UI.getChildControl ( Panel_FishEncyclopedia, "Static_FishRating4" )
local _staticFishRating5	= UI.getChildControl ( Panel_FishEncyclopedia, "Static_FishRating5" )
local _textFishName			= UI.getChildControl ( Panel_FishEncyclopedia, "StaticText_FishName" )
local _textFishRarity		= UI.getChildControl ( Panel_FishEncyclopedia, "StaticText_Rarity" )
local _staticTopLine		= UI.getChildControl ( Panel_FishEncyclopedia, "Static_TopLine" )
local _staticDescBack		= UI.getChildControl ( Panel_FishEncyclopedia, "Static_ExplanationBG" )
local _textDesc				= UI.getChildControl ( Panel_FishEncyclopedia, "StaticText_FishExplanation" )
local _staticBottomLine		= UI.getChildControl ( Panel_FishEncyclopedia, "Static_BottomLine" )
local _staticInforBack		= UI.getChildControl ( Panel_FishEncyclopedia, "Static_InfoBG" )
local _textFishArea			= UI.getChildControl ( Panel_FishEncyclopedia, "StaticText_FishArea" )
local _buttonFishPosition	= UI.getChildControl ( Panel_FishEncyclopedia, "Button_FishLocation" )
local _textFishCount		= UI.getChildControl ( Panel_FishEncyclopedia, "StaticText_FishCount" )
local _textFishCountNum		= UI.getChildControl ( Panel_FishEncyclopedia, "StaticText_FishCountNumber" )
local _textFishSize			= UI.getChildControl ( Panel_FishEncyclopedia, "StaticText_FishMaxSize" )
local _textFishSizeNum		= UI.getChildControl ( Panel_FishEncyclopedia, "StaticText_FishMaxSizeNumber" )
local _radioFishType		= UI.getChildControl ( Panel_FishEncyclopedia, "RadioButton_FishType" )


local FishEncyclopedia = 
{
	_FISH_COUNT_FOR_PAGE		= 4,
	
	_fishList					= {},
	_radioButton				= {},
	
	_closeButton				= UI.getChildControl ( Panel_FishEncyclopedia, "Button_Win_Close" ),
	_pageLeftButton				= UI.getChildControl ( Panel_FishEncyclopedia, "Button_List_Left" ),
	_pageRightButton			= UI.getChildControl ( Panel_FishEncyclopedia, "Button_List_Right" ),
	_pageStaticText				= UI.getChildControl ( Panel_FishEncyclopedia, "StaticText_ListCount" ),
	_acquireRatePrograss		= UI.getChildControl ( Panel_FishEncyclopedia, "Progress2_FishProgress" ),
	_acquireRateStaticText		= UI.getChildControl ( Panel_FishEncyclopedia, "StaticText_PercentCount" ),
	
	_currentCategoryParamIndex	= CppEnums.FishEncyclopediaCategory.eFishEncyclopediaCategory_FreshWaterFish,
	_currentPage				= 0,
	_currentTotalPage			= 0,
}

function FishEncyclopedia:createSlot(index)
	local FishInfo = {}
	FishInfo._staticFishBack	= UI.createControl ( CppEnums.PA_UI_CONTROL_TYPE.PA_UI_CONTROL_STATIC, Panel_FishEncyclopedia, "Static_FishBG_"..index )
	CopyBaseProperty( _staticFishBack, FishInfo._staticFishBack )
	
	FishInfo._textFishName		= UI.createControl ( CppEnums.PA_UI_CONTROL_TYPE.PA_UI_CONTROL_STATICTEXT, FishInfo._staticFishBack, "StaticText_FishName_"..index )
	CopyBaseProperty( _textFishName, FishInfo._textFishName )
	FishInfo._textFishName:SetPosX(21)
	FishInfo._textFishName:SetPosY(11)
	
	FishInfo._textFishRarity	= UI.createControl ( CppEnums.PA_UI_CONTROL_TYPE.PA_UI_CONTROL_STATICTEXT, FishInfo._staticFishBack, "StaticText_Rarity_"..index )
	CopyBaseProperty( _textFishRarity, FishInfo._textFishRarity )	
	FishInfo._textFishRarity:SetPosX(20)
	FishInfo._textFishRarity:SetPosY(44)
	
	FishInfo._staticFishImage	= UI.createControl ( CppEnums.PA_UI_CONTROL_TYPE.PA_UI_CONTROL_STATIC, FishInfo._staticFishBack, "Static_FishImage_"..index )
	CopyBaseProperty( _staticFishImage, FishInfo._staticFishImage )
	FishInfo._staticFishImage:SetPosX(274)
	FishInfo._staticFishImage:SetPosY(42)
	
	FishInfo._staticFishRating = {}
	FishInfo._staticFishRating[0]	= UI.createControl ( CppEnums.PA_UI_CONTROL_TYPE.PA_UI_CONTROL_STATIC, FishInfo._staticFishBack, "Static_FishRating1_"..index )
	CopyBaseProperty( _staticFishRating1, FishInfo._staticFishRating[0] )
	FishInfo._staticFishRating[0]:SetPosX(140)
	FishInfo._staticFishRating[0]:SetPosY(48)
	
	FishInfo._staticFishRating[1]	= UI.createControl ( CppEnums.PA_UI_CONTROL_TYPE.PA_UI_CONTROL_STATIC, FishInfo._staticFishBack, "Static_FishRating2_"..index )
	CopyBaseProperty( _staticFishRating2, FishInfo._staticFishRating[1] )
	FishInfo._staticFishRating[1]:SetPosX(160)
	FishInfo._staticFishRating[1]:SetPosY(48)
	
	FishInfo._staticFishRating[2]	= UI.createControl ( CppEnums.PA_UI_CONTROL_TYPE.PA_UI_CONTROL_STATIC, FishInfo._staticFishBack, "Static_FishRating3_"..index )
	CopyBaseProperty( _staticFishRating3, FishInfo._staticFishRating[2] )
	FishInfo._staticFishRating[2]:SetPosX(180)
	FishInfo._staticFishRating[2]:SetPosY(48)
	
	FishInfo._staticFishRating[3]	= UI.createControl ( CppEnums.PA_UI_CONTROL_TYPE.PA_UI_CONTROL_STATIC, FishInfo._staticFishBack, "Static_FishRating4_"..index )
	CopyBaseProperty( _staticFishRating4, FishInfo._staticFishRating[3] )
	FishInfo._staticFishRating[3]:SetPosX(200)
	FishInfo._staticFishRating[3]:SetPosY(48)
	
	FishInfo._staticFishRating[4]	= UI.createControl ( CppEnums.PA_UI_CONTROL_TYPE.PA_UI_CONTROL_STATIC, FishInfo._staticFishBack, "Static_FishRating5_"..index )
	CopyBaseProperty( _staticFishRating5, FishInfo._staticFishRating[4] )
	FishInfo._staticFishRating[4]:SetPosX(220)
	FishInfo._staticFishRating[4]:SetPosY(48)
		
	FishInfo._staticTopLine		= UI.createControl ( CppEnums.PA_UI_CONTROL_TYPE.PA_UI_CONTROL_STATIC, FishInfo._staticFishBack, "Static_TopLine_"..index )
	CopyBaseProperty( _staticTopLine, FishInfo._staticTopLine )		
	FishInfo._staticTopLine:SetPosX(16)
	FishInfo._staticTopLine:SetPosY(67)
	
	FishInfo._staticDescBack	= UI.createControl ( CppEnums.PA_UI_CONTROL_TYPE.PA_UI_CONTROL_STATIC, FishInfo._staticFishBack, "Static_ExplanationBG_"..index )
	CopyBaseProperty( _staticDescBack, FishInfo._staticDescBack )	
	FishInfo._staticDescBack:SetPosX(18)
	FishInfo._staticDescBack:SetPosY(79)
	
	FishInfo._textDesc			= UI.createControl ( CppEnums.PA_UI_CONTROL_TYPE.PA_UI_CONTROL_STATICTEXT, FishInfo._staticFishBack, "StaticText_FishExplanation_"..index )
	CopyBaseProperty( _textDesc, FishInfo._textDesc )				
	FishInfo._textDesc:SetPosX(25)
	FishInfo._textDesc:SetPosY(86)
	FishInfo._textDesc:SetSize(FishInfo._staticDescBack:GetSizeX() - 14, FishInfo._staticDescBack:GetSizeY() - 14)
	FishInfo._textDesc:SetTextMode ( CppEnums.TextMode.eTextMode_Limit_AutoWrap )
	FishInfo._textDesc:SetAutoResize ( true )
	FishInfo._textDesc:SetLineCount(4)
	
	FishInfo._staticBottomLine	= UI.createControl ( CppEnums.PA_UI_CONTROL_TYPE.PA_UI_CONTROL_STATIC, FishInfo._staticFishBack, "Static_BottomLine_"..index )
	CopyBaseProperty( _staticBottomLine, FishInfo._staticBottomLine )		
	FishInfo._staticBottomLine:SetPosX(15)
	FishInfo._staticBottomLine:SetPosY(164)
	
	FishInfo._staticInforBack	= UI.createControl ( CppEnums.PA_UI_CONTROL_TYPE.PA_UI_CONTROL_STATIC, FishInfo._staticFishBack, "Static_InfoBG_"..index )
	CopyBaseProperty( _staticInforBack, FishInfo._staticInforBack )			
	FishInfo._staticInforBack:SetPosX(19)
	FishInfo._staticInforBack:SetPosY(176)
	
	FishInfo._textFishArea		= UI.createControl ( CppEnums.PA_UI_CONTROL_TYPE.PA_UI_CONTROL_STATICTEXT, FishInfo._staticFishBack, "StaticText_FishArea_"..index )
	CopyBaseProperty( _textFishArea, FishInfo._textFishArea )		
	FishInfo._textFishArea:SetPosX(25)
	FishInfo._textFishArea:SetPosY(182)
	
	FishInfo._buttonFishPosition= UI.createControl ( CppEnums.PA_UI_CONTROL_TYPE.PA_UI_CONTROL_BUTTON, FishInfo._staticFishBack, "Button_FishLocation_"..index )
	CopyBaseProperty( _buttonFishPosition, FishInfo._buttonFishPosition )		
	FishInfo._buttonFishPosition:SetPosX(175)
	FishInfo._buttonFishPosition:SetPosY(178)
	
	FishInfo._textFishPosition	= UI.createControl ( CppEnums.PA_UI_CONTROL_TYPE.PA_UI_CONTROL_STATICTEXT, FishInfo._staticFishBack, "StaticText_FishPosition_"..index )
	CopyBaseProperty( _textFishCountNum, FishInfo._textFishPosition )
	FishInfo._textFishPosition:SetPosX(187)
	FishInfo._textFishPosition:SetPosY(178)
	
	FishInfo._textFishCount		= UI.createControl ( CppEnums.PA_UI_CONTROL_TYPE.PA_UI_CONTROL_STATICTEXT, FishInfo._staticFishBack, "StaticText_FishCount_"..index )
	CopyBaseProperty( _textFishCount, FishInfo._textFishCount )			
	FishInfo._textFishCount:SetPosX(25)
	FishInfo._textFishCount:SetPosY(205)
	
	FishInfo._textFishCountNum	= UI.createControl ( CppEnums.PA_UI_CONTROL_TYPE.PA_UI_CONTROL_STATICTEXT, FishInfo._staticFishBack, "StaticText_FishCountNumber_"..index )
	CopyBaseProperty( _textFishCountNum, FishInfo._textFishCountNum )		
	FishInfo._textFishCountNum:SetPosX(187)
	FishInfo._textFishCountNum:SetPosY(201)

	FishInfo._textFishSize		= UI.createControl ( CppEnums.PA_UI_CONTROL_TYPE.PA_UI_CONTROL_STATICTEXT, FishInfo._staticFishBack, "StaticText_FishMaxSize_"..index )
	CopyBaseProperty( _textFishSize, FishInfo._textFishSize )				
	FishInfo._textFishSize:SetPosX(25)
	FishInfo._textFishSize:SetPosY(229)
	
	FishInfo._textFishSizeNum	= UI.createControl ( CppEnums.PA_UI_CONTROL_TYPE.PA_UI_CONTROL_STATICTEXT, FishInfo._staticFishBack, "StaticText_FishMaxSizeNumber_"..index )
	CopyBaseProperty( _textFishSizeNum, FishInfo._textFishSizeNum )
	FishInfo._textFishSizeNum:SetPosX(187)
	FishInfo._textFishSizeNum:SetPosY(224)
	
	function FishInfo:setPosition(x, y)
		FishInfo._staticFishBack:SetPosX(43 + x)
		FishInfo._staticFishBack:SetPosY(115 + y)
	end
	
	return	FishInfo
end

function FishEncyclopedia:createRadioButton(index, paramIndex, strLabel)
	local radioButton = UI.createControl ( CppEnums.PA_UI_CONTROL_TYPE.PA_UI_CONTROL_RADIOBUTTON, Panel_FishEncyclopedia, "RadioButton_FishType_" .. index )
	CopyBaseProperty( _radioFishType, radioButton )
	radioButton:addInputEvent( "Mouse_LUp", "HandleClicked_FishEncyclopedia_SelectedCategory(" .. paramIndex .. ")" )
	radioButton:SetText(strLabel)
	radioButton:SetPosX(34 + (index * 96))
	radioButton:SetPosY(68)
	
	return radioButton
end

function FishEncyclopedia:deleteStyleUI()
	UI.deleteControl( _staticFishBack )
	UI.deleteControl( _staticFishImage )
	UI.deleteControl( _staticFishRating1 )
	UI.deleteControl( _staticFishRating2 )
	UI.deleteControl( _staticFishRating3 )
	UI.deleteControl( _staticFishRating4 )
	UI.deleteControl( _staticFishRating5 )
	UI.deleteControl( _textFishName )
	UI.deleteControl( _textFishRarity )
	UI.deleteControl( _staticTopLine )
	UI.deleteControl( _staticDescBack )
	UI.deleteControl( _textDesc )
	UI.deleteControl( _staticBottomLine )
	UI.deleteControl( _staticInforBack )
	UI.deleteControl( _textFishArea )
	UI.deleteControl( _buttonFishPosition )
	UI.deleteControl( _textFishCount )
	UI.deleteControl( _textFishCountNum )
	UI.deleteControl( _textFishSize )
	UI.deleteControl( _textFishSizeNum )
	UI.deleteControl( _radioFishType )
end

function HandleClicked_FishEncyclopedia_SelectedCategory( categoryParamIndex )
	FishEncyclopedia._currentCategoryParamIndex = categoryParamIndex
	FishEncyclopedia._currentPage				= 0
	
	local fishCount = ToClient_GetFishCountByCategory( categoryParamIndex )
	local totalPage = math.floor(fishCount / FishEncyclopedia._FISH_COUNT_FOR_PAGE) + 1
	if 0 == fishCount % FishEncyclopedia._FISH_COUNT_FOR_PAGE then
		totalPage = totalPage - 1
	end
	FishEncyclopedia._currentTotalPage			= totalPage
	
	local pageStr = tostring(FishEncyclopedia._currentPage + 1) .. "/" .. tostring(totalPage)
	FishEncyclopedia._pageStaticText:SetText(pageStr)
	
	changePageButtonEnable()
	updateFishList()
end

function updateFishList()
	local startIndex 	= FishEncyclopedia._currentPage * FishEncyclopedia._FISH_COUNT_FOR_PAGE
	local endIndex		= startIndex + FishEncyclopedia._FISH_COUNT_FOR_PAGE - 1
	local maxIndex		= ToClient_GetFishCountByCategory( FishEncyclopedia._currentCategoryParamIndex )
	local index = 0
	clearFishList()
	
	for ii = startIndex, endIndex, 1 do
		local FishInfo = FishEncyclopedia._fishList[index]
		if nil ~= FishInfo then
			if maxIndex - 1 < ii then
				FishInfo._staticFishBack:SetShow( false )
			else
				setFishSlot(ii, index)
			end
		end
		index = index + 1
	end
end

function setFishSlot(dataIndex, slotIndex)
	local fishInfo = ToClient_GetFishAt( FishEncyclopedia._currentCategoryParamIndex, dataIndex )
	local FishSlot = FishEncyclopedia._fishList[slotIndex]
	if nil == FishSlot then
		return
	end
	
	if nil == fishInfo then
		return
	end
	
	local isAcquire = fishInfo:isAcquire()
	
	if isAcquire then
		local fishName = fishInfo:getName()
		FishSlot._textFishName:SetText(fishName)
		
		local fishDesc = fishInfo:getDesc()
		FishSlot._textDesc:SetText(fishDesc)
		
		local fishRareness = fishInfo:getRareness()
		-- _PA_LOG("구수현", "fishRareness : " .. tostring(fishRareness))
		for ii = 0, fishRareness-1, 1 do
			FishSlot._staticFishRating[4-ii]:SetShow( true )
		end
		
		local fishCount = fishInfo:getCount()
		FishSlot._textFishCountNum:SetText(fishCount)
	
		local fishValue = fishInfo:getMaxValue()
		FishSlot._textFishSizeNum:SetText(fishValue)
		
		local fishImage = fishInfo:getImagePath()
		FishSlot._staticFishImage:ChangeTextureInfoName( fishImage )
		
		--FishSlot._buttonFishPosition:SetShow( true )
		FishSlot._textFishPosition:SetShow( true )
	end
end

function clearFishList()
	for ii = 0, FishEncyclopedia._FISH_COUNT_FOR_PAGE -1, 1 do
		clearFishSlot(ii)
	end
end

function clearFishSlot(index)
	local FishInfo = FishEncyclopedia._fishList[index]
	if nil == FishInfo then
		return
	end
	
	FishInfo._staticFishBack:SetShow( true ) -- BG
	
	FishInfo._textFishName:SetText("???")
	
	FishInfo._staticFishImage:ChangeTextureInfoName("UI_Artwork/Encyclopedia/Fish_undiscover.dds") -- 발견 안된 어류 이미지
	
	for ii = 0, 4, 1 do
		FishInfo._staticFishRating[ii]:SetShow( false )
	end
	
	FishInfo._textDesc:SetText("???")	
	
	FishInfo._buttonFishPosition:SetShow( false )
	FishInfo._textFishPosition:SetShow( true )
	FishInfo._textFishPosition:SetText("...")
	
	FishInfo._textFishCountNum:SetText("...")
	FishInfo._textFishSizeNum:SetText("...")
end

function FishEncyclopedia:initialize()
	self._fishList[0] = self:createSlot(0)
	self._fishList[0]:setPosition(0,0)
	self._fishList[1] = self:createSlot(1)
	self._fishList[1]:setPosition(462,0)
	self._fishList[2] = self:createSlot(2)
	self._fishList[2]:setPosition(0,276)
	self._fishList[3] = self:createSlot(3)
	self._fishList[3]:setPosition(462,276)
	
	self._radioButton[0] = self:createRadioButton(0, CppEnums.FishEncyclopediaCategory.eFishEncyclopediaCategory_FreshWaterFish, 	"민물고기")
	self._radioButton[1] = self:createRadioButton(1, CppEnums.FishEncyclopediaCategory.eFishEncyclopediaCategory_SeaFish, 			"바다물고기")
	self._radioButton[2] = self:createRadioButton(2, CppEnums.FishEncyclopediaCategory.eFishEncyclopediaCategory_Crustacea, 		"갑각류")
	self._radioButton[3] = self:createRadioButton(3, CppEnums.FishEncyclopediaCategory.eFishEncyclopediaCategory_Etc, 				"기타")
	
	self._radioButton[0]:SetCheck(true)
	HandleClicked_FishEncyclopedia_SelectedCategory(CppEnums.FishEncyclopediaCategory.eFishEncyclopediaCategory_FreshWaterFish)
	
	self._pageLeftButton:addInputEvent("Mouse_LUp",		"HandleClicked_FishEncyclopedia_PageMoveButton(true)")
	self._pageRightButton:addInputEvent("Mouse_LUp",	"HandleClicked_FishEncyclopedia_PageMoveButton(false)")
	
	self._closeButton:addInputEvent("Mouse_LUp",		"HandleClicked_FishEncyclopedia_CloseButton()")
	
	self:deleteStyleUI()
end

function changePageButtonEnable()
	if (FishEncyclopedia._currentPage <= 0) then
		FishEncyclopedia._pageLeftButton:SetIgnore( true )
	else
		FishEncyclopedia._pageLeftButton:SetIgnore( false )
	end
	
	if (FishEncyclopedia._currentTotalPage <= (FishEncyclopedia._currentPage + 1)) then
		FishEncyclopedia._pageRightButton:SetIgnore( true )
	else
		FishEncyclopedia._pageRightButton:SetIgnore( false )
	end
end

function HandleClicked_FishEncyclopedia_PageMoveButton(isLeft)
	if isLeft then
		FishEncyclopedia._currentPage = FishEncyclopedia._currentPage - 1
	else
		FishEncyclopedia._currentPage = FishEncyclopedia._currentPage + 1
	end
	
	local pageStr = tostring(FishEncyclopedia._currentPage + 1) .. "/" .. tostring(FishEncyclopedia._currentTotalPage)
	FishEncyclopedia._pageStaticText:SetText(pageStr)
	
	changePageButtonEnable()
	updateFishList()
end

function updateFishAcquireRate()
	local totalFishCount 	= ToClient_GetTotalFishCount()
	local acquireFishCount 	= ToClient_GetAcquireFishCount()
	local rate				= acquireFishCount / totalFishCount * 100
	FishEncyclopedia._acquireRatePrograss:SetProgressRate( rate )
	local rateText			= math.floor(rate)
	
	-- _PA_LOG("구수현", "rate : " .. tostring(rate) .. ", rateText : " .. rateText)
	FishEncyclopedia._acquireRateStaticText:SetText(rateText .. "%")
end

function HandleClicked_FishEncyclopedia_CloseButton()
	FGlobal_FishEncyclopedia_Close()
end

function FGlobal_FishEncyclopedia_Open()
	audioPostEvent_SystemUi(01,42)
	Panel_FishEncyclopedia:SetShow( true )
end

function FGlobal_FishEncyclopedia_Close()
	Panel_FishEncyclopedia:SetShow( false )
end

FishEncyclopedia:initialize()
updateFishAcquireRate()
