local nodeIconName = UI.getChildControl( Panel_WorldMap_Tooltip, "StaticText_IconName") ;
local nodeResultIconName = UI.getChildControl( Panel_WorldMap_Tooltip, "StaticText_IconName_ResultName");
local nodeResultIconBG = UI.getChildControl( Panel_WorldMap_Tooltip, "StaticText_IconName_ResultIconBG");
local nodeResultIcon = UI.getChildControl( Panel_WorldMap_Tooltip, "StaticText_IconName_ResultIcon");
local nodeHelpBG = UI.getChildControl( Panel_WorldMap_Tooltip, "StaticText_NodeIconHelp_BG");
local nodeHelpMouseL = UI.getChildControl( Panel_WorldMap_Tooltip, "Static_Help_MouseL");
local nodeHelpMouseR = UI.getChildControl( Panel_WorldMap_Tooltip, "Static_Help_MouseR");

local sizeGap = 10;
-- 공통 옵션 --
function FromClient_WorldmapIconTooltipInit( commonOverUI )
		--[[
	overUI = commonOverUI:FromClient_getNodeNameBG();
	nodeIconName = commonOverUI:FromClient_getNodeIconName();
	nodeResultIconName = commonOverUI:FromClient_getNodeResultIconName();
	nodeResultIconBG = commonOverUI:FromClient_getNodeResultIconBG();
	nodeResultIcon = commonOverUI:FromClient_getNodeResultIcon();
	nodeHelpBG 	   = commonOverUI:FromClient_getNodeHelpBG();
	nodeHelpMouseL = commonOverUI:FromClient_getNodeHelpMouseL();
	nodeHelpMouseR = commonOverUI:FromClient_getNodeHelpMouseR();
]]--
	nodeIconName:SetAutoResize();
	nodeResultIconName:SetAutoResize();
end

function FGlobal_ClearWorldmapIconTooltip()
	Panel_WorldMap_Tooltip:SetShow(false);
	nodeIconName:SetShow(false);
	nodeResultIconName:SetShow(false);
	nodeResultIconBG:SetShow(false);
	nodeResultIcon:SetShow(false);
	nodeHelpBG:SetShow(false);
	nodeHelpMouseL:SetShow(false);
	nodeHelpMouseR:SetShow(false);
end
--[[ 노드 메뉴 툴팁 ]]--
local On_waypointKey = nil
function FromClient_OnWorldMapNode( nodeBtn )
	FGlobal_ClearWorldmapIconTooltip()
	local nodeInfo 			= nodeBtn:FromClient_getExplorationNodeInClient()
	local plantKey 			= nodeInfo:getPlantKey()
	local exploreLevel		= nodeInfo:getLevel()
	local plant				= getPlant(plantKey)
	local waypointKey 		= plantKey:getWaypointKey()
	On_plantKey				= waypointKey
	local houseCountObject 	= ToClient_getHouseCountObject( waypointKey );
	
	local nodeName = "";

	nodeName = ToClient_getNodeName( nodeInfo );

	if( nil ~= houseCountObject ) then
		nodeName = nodeName .. "<PAColor0xFFe6e0c6> (" .. houseCountObject:getCurrentCount() .."/" .. houseCountObject:getMaxCount() ..")<PAOldColor>";
	end
	
	local nodeX = nodeBtn:GetPosX();
	local nodeY = nodeBtn:GetPosY();
	local sizeX = nodeBtn:GetSizeX();
	local sizeY = nodeBtn:GetSizeY();

	nodeIconName:SetText( nodeName );

	local tooltipSizeX = nodeIconName:GetPosX() + nodeIconName:GetTextSizeX();
	local tooltipSizeY = nodeIconName:GetPosY() + nodeIconName:GetSizeY();
	if exploreLevel > -1 and plant ~= nil and plant:getType() == CppEnums.PlantType.ePlantType_Zone then
		local workCnt = ToClinet_getPlantWorkListCount(waypointKey, 0)

		if( 0 < workCnt ) then
			local itemSS = ToClient_getPlantWorkableItemExchangeByIndex( plantKey, 0 );
			local itemStatic = itemSS:getFirstDropGroup():getItemStaticStatus();

			local workName = getItemName( itemStatic );
			local itemPath = "icon/"..getItemIconPath( itemStatic );

			nodeResultIconName:SetText( workName );
			nodeResultIcon:ChangeTextureInfoName( itemPath );

			nodeResultIconName:SetShow( true );
			nodeResultIcon:SetShow(true);
			nodeResultIconBG:SetShow(true);
			
			local totalSizeX = nodeResultIconName:GetPosX() + nodeResultIconName:GetTextSizeX();
			local totalSizeY = nodeResultIconName:GetPosY() + nodeResultIconName:GetSizeY();

			--	nodeResultIconBG:SetSize( totalSizeX, totalSizeY );

			if( tooltipSizeX < totalSizeX ) then
				tooltipSizeX = totalSizeX;
			end

			if( tooltipSizeY < totalSizeY ) then
				tooltipSizeY = totalSizeY;
			end
		end
	end
	Panel_WorldMap_Tooltip:SetSize( tooltipSizeX + sizeGap, tooltipSizeY + sizeGap );

	local overUISizeX = Panel_WorldMap_Tooltip:GetSizeX()
	local overUIPosX = nodeX + ( sizeX - overUISizeX ) / 2;
	local overUIPosY = nodeY -  Panel_WorldMap_Tooltip:GetSizeY() - sizeGap;

	if( overUIPosX + overUISizeX > getScreenSizeX() ) then
		overUIPosX = getScreenSizeX() - overUISizeX;
	end

	Panel_WorldMap_Tooltip:SetPosX( overUIPosX );
	Panel_WorldMap_Tooltip:SetPosY( overUIPosY ); 

	Panel_WorldMap_Tooltip:SetShow( true );
	nodeIconName:SetShow(true);

	-- 노드 오버시 마우스 툴팁 노출
	nodeHelpBG:SetShow( true )
	nodeHelpMouseL:SetShow( true )
	nodeHelpMouseR:SetShow( true )
	nodeHelpBG:SetPosX( nodeBtn:GetSizeX() )
	nodeHelpBG:SetPosY( nodeBtn:GetSizeY() )
	nodeHelpMouseL:SetPosX( nodeHelpBG:GetPosX() )
	nodeHelpMouseL:SetPosY( nodeHelpBG:GetPosY() + 2 ) 
	nodeHelpMouseR:SetPosX( nodeHelpBG:GetPosX() )
	nodeHelpMouseR:SetPosY( nodeHelpMouseL:GetPosY() + nodeHelpMouseL:GetSizeY() + 2 )
end

function FromClient_OutWorldMapNode( nodeBtn  )
	local nodeInfo 			= nodeBtn:FromClient_getExplorationNodeInClient()
	local plantKey 			= nodeInfo:getPlantKey()
	local waypointKey 		= plantKey:getWaypointKey()
	
	if On_plantKey ~= waypointKey then
		return
	end
	FGlobal_ClearWorldmapIconTooltip();
end

-- 파티 툴팁 --
function WorldMapWindow_PartyIcon_OnShowTooltip( nodeBtn,  index )
	if ( isShow ) then
		local memberData = RequestParty_getPartyMemberAt(index)
		if ( nil == memberData ) then
			return
		end

		WorldMap_IconName.save_partyIndex = index
		WorldMap_IconName.tooltipType = eTooltipType.party
		WorldMap_IconName.text_Name = memberData:name()
		WorldMap_IconName:Set_Name()
	else
	end
end

function FromClient_PartyIconTooltipHide()
	FGlobal_ClearWorldmapIconTooltip()
end

-- 집 툴팁 --
local houseKey_ToolTip = nil
function FromClient_OnWorldMapHouse( houseBtn, commonOverUI )
	FGlobal_ClearWorldmapIconTooltip();
	houseKey_ToolTip = houseBtn:FromClient_getStaticStatus():getHouseKey()
	local houseInClientWrapper = houseBtn:FromClient_getStaticStatus();
	nodeIconName:SetText( houseInClientWrapper:getName() );

	local nodeX = houseBtn:GetPosX();
	local nodeY = houseBtn:GetPosY();
	local sizeX = houseBtn:GetSizeX();
	local sizeY = houseBtn:GetSizeY();	

	local tooltipSizeX = nodeIconName:GetTextSizeX() + 10;
	local tooltipSizeY = nodeIconName:GetTextSizeY() + 5;
	
	Panel_WorldMap_Tooltip:SetSize( tooltipSizeX + sizeGap, tooltipSizeY + sizeGap );
	
	local overUISizeX = Panel_WorldMap_Tooltip:GetSizeX()
	local overUIPosX = nodeX + ( sizeX - overUISizeX ) / 2;
	local overUIPosY = nodeY -  Panel_WorldMap_Tooltip:GetSizeY() - sizeGap;

	if( overUIPosX + overUISizeX > getScreenSizeX() ) then
		overUIPosX = getScreenSizeX() - overUISizeX;
	end

	Panel_WorldMap_Tooltip:SetPosX( overUIPosX );
	Panel_WorldMap_Tooltip:SetPosY( overUIPosY ); 	
	nodeIconName:SetShow(true);
	Panel_WorldMap_Tooltip:SetShow(true)
	houseBtn:setRenderTexture( houseBtn:getOnTexture() );
end

function FromClient_OutWorldMapHouse( houseBtn, commonOverUI )
	if houseKey_ToolTip ~= houseBtn:FromClient_getStaticStatus():getHouseKey() then
		return
	end
	FGlobal_ClearWorldmapIconTooltip();	
	houseBtn:setRenderTexture( houseBtn:getBaseTexture() );
	houseKey_ToolTip = nil
end

function FromClient_WorldMapGuildHouseOn( guildHouseBtn, commonOverUI )
	FGlobal_ClearWorldmapIconTooltip();
	local guildHouseWrapper = guildHouseBtn:FromClient_getGuildHouseInfoWrapper()
	
	if nil == guildHouseWrapper then
		return
	end

	local guildOwner = guildHouseWrapper:getOwnerGuildName();

	local houseName = guildHouseWrapper:getHouseName()

	if( nil ~= guildOwner ) then
		houseName =	houseName .. " - " ..guildOwner
	end
	nodeIconName:SetText( houseName );

	local nodeX = guildHouseBtn:GetPosX();
	local nodeY = guildHouseBtn:GetPosY();
	local sizeX = guildHouseBtn:GetSizeX();
	local sizeY = guildHouseBtn:GetSizeY();	

	local tooltipSizeX = nodeIconName:GetTextSizeX() + 10;
	local tooltipSizeY = nodeIconName:GetTextSizeY() + 5;
	
	Panel_WorldMap_Tooltip:SetSize( tooltipSizeX + sizeGap, tooltipSizeY + sizeGap );
	
	local overUISizeX = Panel_WorldMap_Tooltip:GetSizeX()
	local overUIPosX = nodeX + ( sizeX - overUISizeX ) / 2;
	local overUIPosY = nodeY -  Panel_WorldMap_Tooltip:GetSizeY() - sizeGap;

	if( overUIPosX + overUISizeX > getScreenSizeX() ) then
		overUIPosX = getScreenSizeX() - overUISizeX;
	end

	Panel_WorldMap_Tooltip:SetPosX( overUIPosX );
	Panel_WorldMap_Tooltip:SetPosY( overUIPosY ); 	
	nodeIconName:SetShow(true);
	Panel_WorldMap_Tooltip:SetShow(true)
end

function FromClient_WorldMapGuildHouseOut()
	FGlobal_ClearWorldmapIconTooltip();
end

function FromClient_WorldMapGuildHouseRClick( guildHouseBtn )
	local houseHoldWrapper = guildHouseBtn:FromClient_getGuildHouseInfoWrapper();

	if( nil == houseHoldWrapper ) then
		return;
	end

	FromClient_RClickWorldmapPanel( houseHoldWrapper:getPosition(), true );
end

function FromClient_RClickActorIcon( actorIcon, pos3D )
	FromClient_RClickWorldmapPanel( pos3D, true );
end

--[[
function FromClient_OnBuildingNode( buildingBtn, commonOverUI )
	FGlobal_ClearWorldmapIconTooltip();
	if( nil == buildingBtn ) then
		return;
	end

	local buildingName = ToClient_getBuildingName( buildingBtn:ToClient_getBuildingStaticStatus() );
	nodeIconName:SetText( buildingName );

	local nodeX = buildingBtn:GetPosX();
	local nodeY = buildingBtn:GetPosY();
	local sizeX = buildingBtn:GetSizeX();
	local sizeY = buildingBtn:GetSizeY();	

	local tooltipSizeX = nodeIconName:GetTextSizeX();
	local tooltipSizeY = nodeIconName:GetTextSizeY();
	
	Panel_WorldMap_Tooltip:SetSize( tooltipSizeX + sizeGap, tooltipSizeY + sizeGap );
	
	local overUISizeX = Panel_WorldMap_Tooltip:GetSizeX()
	local overUIPosX = nodeX + ( sizeX - overUISizeX ) / 2;
	local overUIPosY = nodeY -  Panel_WorldMap_Tooltip:GetSizeY() - sizeGap;

	if( overUIPosX + overUISizeX > getScreenSizeX() ) then
		overUIPosX = getScreenSizeX() - overUISizeX;
	end

	Panel_WorldMap_Tooltip:SetPosX( overUIPosX );
	Panel_WorldMap_Tooltip:SetPosY( overUIPosY ); 	
	nodeIconName:SetShow(true);
	Panel_WorldMap_Tooltip:SetShow(true)
end

function FromClient_OutBuildingNode( buildingBtn, overUI )
	FGlobal_ClearWorldmapIconTooltip()
end
]]--
function FromClient_LClickDeliveryVehicle( deliveryIcon )

	local objectID = deliveryIcon:FromClient_GetObjectID( )
	-- _PA_LOG("최대호", tostring(objectID) )
	DeliveryCarriageInformationWindow_Open( objectID )
end


function FromClient_SetTownModeToActorTooltip()
		Panel_WorldMap_Tooltip:SetShow(false);
end

registerEvent("FromClient_OnWorldMapNode",				"FromClient_OnWorldMapNode")
registerEvent("FromClient_OutWorldMapNode",				"FromClient_OutWorldMapNode")
registerEvent("FromClient_WorldmapIconTooltipInit",		"FromClient_WorldmapIconTooltipInit")
registerEvent("FromClient_OnWorldMapHouse",				"FromClient_OnWorldMapHouse")
registerEvent("FromClient_OutWorldMapHouse",			"FromClient_OutWorldMapHouse");
--registerEvent("FromClient_OnBuildingNode",				"FromClient_OnBuildingNode");
--registerEvent("FromClient_OutBuildingNode",				"FromClient_OutBuildingNode");
registerEvent("FromClient_WorldMapGuildHouseOn",		"FromClient_WorldMapGuildHouseOn");
registerEvent("FromClient_WorldMapGuildHouseOut",		"FromClient_WorldMapGuildHouseOut");
registerEvent("FromClient_WorldMapGuildHouseRClick",	"FromClient_WorldMapGuildHouseRClick");
registerEvent("FromClient_RClickActorIcon",				"FromClient_RClickActorIcon");
registerEvent("FromClient_LClickDeliveryVehicle",		"FromClient_LClickDeliveryVehicle");
registerEvent("FromClient_SetTownMode",					"FromClient_SetTownModeToActorTooltip")
