------------------------------------------------------------------------------------------------------
-- 로컬 변수 선언
local UI_color 			= Defines.Color
local UI_ST				= CppEnums.SpawnType
local UI_TM				= CppEnums.TextMode
local UI_ANI_ADV		= CppEnums.PAUI_ANIM_ADVANCE_TYPE
local UI_AV				= CppEnums.PA_UI_ALIGNVERTICAL
local UI_TT				= CppEnums.PAUI_TEXTURE_TYPE

local eWorldmapState = CppEnums.WorldMapState;
local worldMapState = {
	[eWorldmapState.eWMS_EXPLORE_PLANT] 			= UI.getChildControl( Panel_WorldMap, "Static_3DMap_UIMode_Change_default" ),
	[eWorldmapState.eWMS_REGION] 					= UI.getChildControl( Panel_WorldMap, "Static_3DMap_UIMode_Change_NoUI" ),
	[eWorldmapState.eWMS_LOCATION_INFO_WATER] 		= UI.getChildControl( Panel_WorldMap, "Static_3DMap_UIMode_Change_Water" ),
	[eWorldmapState.eWMS_LOCATION_INFO_CELCIUS] 	= UI.getChildControl( Panel_WorldMap, "Static_3DMap_UIMode_Change_Celcius" ),
	[eWorldmapState.eWMS_LOCATION_INFO_HUMIDITY] 	= UI.getChildControl( Panel_WorldMap, "Static_3DMap_UIMode_Change_Humility" )
}

local checkBoxBG					= UI.getChildControl( Panel_WorldMap, "Static_GuideBG");

local eCheckState = CppEnums.WorldMapCheckState; 
local worldMapCheckList = {
	[eCheckState.eCheck_Quest] 		= UI.getChildControl( Panel_WorldMap, "CheckButton_Quest" ),
	[eCheckState.eCheck_Knowledge] 	= UI.getChildControl( Panel_WorldMap, "CheckButton_Knowledge" ),
	[eCheckState.eCheck_FishnChip] 	= UI.getChildControl( Panel_WorldMap, "CheckButton_Fishnchip" ),
	[eCheckState.eCheck_Node] 		= UI.getChildControl( Panel_WorldMap, "CheckButton_Node" ),
	[eCheckState.eCheck_Trade] 		= UI.getChildControl( Panel_WorldMap, "CheckButton_Trade" ),
	[eCheckState.eCheck_Way] 		= UI.getChildControl( Panel_WorldMap, "CheckButton_WayGuide" ),
	[eCheckState.eCheck_Postions] 	= UI.getChildControl( Panel_WorldMap, "CheckButton_Positions" ),
	[eCheckState.eCheck_Wagon] 		= UI.getChildControl( Panel_WorldMap, "CheckButton_Carriage" )
}

local worldMapMovieList = {
	_playButton		= UI.getChildControl( Panel_WorldMap, "Button_MovieTooltip" ),
	
	_panel 			= UI.getChildControl( Panel_WorldMap, "Static_MovieToolTipPanel" ),
	_title 			= UI.getChildControl( Panel_WorldMap, "StaticText_MovieTitle" ),
	_panelBG 		= UI.getChildControl( Panel_WorldMap, "Static_MovieToolTipPanel_BG" ),
	_btn_Close	 	= UI.getChildControl( Panel_WorldMap, "Button_Close" ),
		
	_btn_Movie_1 	= UI.getChildControl( Panel_WorldMap, "Button_Movie_0" ),
	_btn_Movie_2 	= UI.getChildControl( Panel_WorldMap, "Button_Movie_1" ),
	_btn_Movie_3 	= UI.getChildControl( Panel_WorldMap, "Button_Movie_2" ),
	_btn_Movie_4 	= UI.getChildControl( Panel_WorldMap, "Button_Movie_3" ),
}

if getEnableSimpleUI() then
	worldMapMovieList._playButton:SetShow(false);
	worldMapMovieList._panel:SetShow(false);
end

worldMapMovieList._playButton:addInputEvent( "Mouse_LUp", "Panel_Worldmap_MovieGuide_Func()" )
worldMapMovieList._btn_Close:addInputEvent( "Mouse_LUp", "Panel_Worldmap_MovieGuide_Close()" )
	
-----------------------------------------------------------------------------------------------
-- 									영상 가이드 전용 함수
-----------------------------------------------------------------------------------------------
function Panel_Worldmap_MovieGuide_Close()
	if ( worldMapMovieList._panel:GetShow() == true ) then
		worldMapMovieList._panel:SetShow( false )
		FGlobal_Panel_MovieTheater640_WindowClose()
	else
		worldMapMovieList._panel:SetShow( true )
		Panel_MovieTheater640_Initialize()
	end
end

function Panel_Worldmap_MovieGuide_Func()
	worldMapMovieList._panel:SetPosX( 425 )
	worldMapMovieList._panel:SetPosY( 70 )

	worldMapMovieList._btn_Movie_1:addInputEvent( "Mouse_LUp", "Panel_MovieTheater640_GameGuide_Func(" .. 11 .. ")" )
	worldMapMovieList._btn_Movie_2:addInputEvent( "Mouse_LUp", "Panel_MovieTheater640_GameGuide_Func(" .. 12 .. ")" )
	worldMapMovieList._btn_Movie_3:addInputEvent( "Mouse_LUp", "Panel_MovieTheater640_GameGuide_Func(" .. 15 .. ")" )
	worldMapMovieList._btn_Movie_4:addInputEvent( "Mouse_LUp", "Panel_MovieTheater640_GameGuide_Func(" .. 20 .. ")" )

	Panel_Worldmap_MovieGuide_Close()
end

function Panel_Worldmap_MovieGuide_Init()
	worldMapMovieList._panel:AddChild ( worldMapMovieList._title 	   )
	worldMapMovieList._panel:AddChild ( worldMapMovieList._btn_Close   )
	worldMapMovieList._panel:AddChild ( worldMapMovieList._panelBG     )
	worldMapMovieList._panel:AddChild ( worldMapMovieList._btn_Movie_1 )
	worldMapMovieList._panel:AddChild ( worldMapMovieList._btn_Movie_2 )
	worldMapMovieList._panel:AddChild ( worldMapMovieList._btn_Movie_3 )
	worldMapMovieList._panel:AddChild ( worldMapMovieList._btn_Movie_4 )
	
	Panel_WorldMap:RemoveControl ( worldMapMovieList._title 	  )
	Panel_WorldMap:RemoveControl ( worldMapMovieList._btn_Close   )
	Panel_WorldMap:RemoveControl ( worldMapMovieList._panelBG     )
	Panel_WorldMap:RemoveControl ( worldMapMovieList._btn_Movie_1 )
	Panel_WorldMap:RemoveControl ( worldMapMovieList._btn_Movie_2 )
	Panel_WorldMap:RemoveControl ( worldMapMovieList._btn_Movie_3 )
	Panel_WorldMap:RemoveControl ( worldMapMovieList._btn_Movie_4 )
	
	worldMapMovieList._btn_Movie_1:addInputEvent( "Mouse_LUp", "Panel_MovieTheater640_GameGuide_Func(" .. 11 .. ")" )
	worldMapMovieList._btn_Movie_2:addInputEvent( "Mouse_LUp", "Panel_MovieTheater640_GameGuide_Func(" .. 12 .. ")" )
	worldMapMovieList._btn_Movie_3:addInputEvent( "Mouse_LUp", "Panel_MovieTheater640_GameGuide_Func(" .. 15 .. ")" )
	worldMapMovieList._btn_Movie_4:addInputEvent( "Mouse_LUp", "Panel_MovieTheater640_GameGuide_Func(" .. 20 .. ")" )
	
	worldMapMovieList._panel:SetPosX( 425 )
	worldMapMovieList._panel:SetPosY( 70 )
	
	Panel_MovieTheater640_Initialize()

	worldMapMovieList._panel:SetShow( true )
	if getEnableSimpleUI() then
		worldMapMovieList._panel:SetShow( false )
		FGlobal_Panel_MovieTheater640_WindowClose()
	end
end

function WorldmapMovieGuide_EnableSimpleUI()
	worldMapMovieList._panel:SetShow( false )
	worldMapMovieList._playButton:SetShow( false );
	FGlobal_Panel_MovieTheater640_WindowClose()
end
function WorldmapMovieGuide_DisableSimpleUI()
	worldMapMovieList._panel:SetShow( true )
	worldMapMovieList._playButton:SetShow( true );
	Panel_MovieTheater640_Initialize()
end
registerEvent( "EventSimpleUIEnable",			"WorldmapMovieGuide_EnableSimpleUI")
registerEvent( "EventSimpleUIDisable",			"WorldmapMovieGuide_DisableSimpleUI")


Panel_Worldmap_MovieGuide_Init()
	
local btnCtrl_Exit 			= UI.getChildControl( Panel_WorldMap, "Button_Exit" )
local static_ExOutLine		= UI.getChildControl( Panel_WorldMap, "Static_ExplorePoint_OutLine")
local static_ExBG			= UI.getChildControl( Panel_WorldMap, "Static_ExplorePoint_BG")
local txtCtrl_ExPoint 		= UI.getChildControl( Panel_WorldMap, "StaticText_info_ExplorePoint" )
local progress_ExPoint 		= UI.getChildControl( Panel_WorldMap, "Progress_ExplorePoint" )
local btn_FishEncyclopedia	= UI.getChildControl( Panel_WorldMap, "Button_FishEncyclopedia" )
local btn_DelyveryInfo		= UI.getChildControl( Panel_WorldMap, "Button_DelyveryInfo" )

btn_FishEncyclopedia:SetShow(false)
local static_ContributeBG	= UI.getChildControl( Panel_WorldMap, "Static_ContributeBG" )

-- 로컬 변수 설정 끝
-----------------------------------------------------------------------------------------------------

-----------------------------------------------------------------------------------------------------
-- 컨트롤 이벤트 등록
-----------------------------------------------------------------------------------------------------
-- 렌더 모드 변경
worldMapState[eWorldmapState.eWMS_EXPLORE_PLANT]			:addInputEvent( "Mouse_LUp", "WorldMapStateChange("..eWorldmapState.eWMS_EXPLORE_PLANT..")" )
worldMapState[eWorldmapState.eWMS_REGION]					:addInputEvent( "Mouse_LUp", "WorldMapStateChange("..eWorldmapState.eWMS_REGION..")" )
worldMapState[eWorldmapState.eWMS_LOCATION_INFO_WATER]		:addInputEvent( "Mouse_LUp", "WorldMapStateChange("..eWorldmapState.eWMS_LOCATION_INFO_WATER..")")
worldMapState[eWorldmapState.eWMS_LOCATION_INFO_CELCIUS]	:addInputEvent( "Mouse_LUp", "WorldMapStateChange("..eWorldmapState.eWMS_LOCATION_INFO_CELCIUS..")")
worldMapState[eWorldmapState.eWMS_LOCATION_INFO_HUMIDITY]	:addInputEvent( "Mouse_LUp", "WorldMapStateChange("..eWorldmapState.eWMS_LOCATION_INFO_HUMIDITY..")")

-- 체크 리스트
worldMapCheckList[eCheckState.eCheck_Quest]		:addInputEvent( "Mouse_LUp", "WorldMapCheckListChange("..eCheckState.eCheck_Quest..")")
worldMapCheckList[eCheckState.eCheck_Knowledge]	:addInputEvent( "Mouse_LUp", "WorldMapCheckListChange("..eCheckState.eCheck_Knowledge..")")
worldMapCheckList[eCheckState.eCheck_FishnChip]	:addInputEvent( "Mouse_LUp", "WorldMapCheckListChange("..eCheckState.eCheck_FishnChip..")")
worldMapCheckList[eCheckState.eCheck_Node]		:addInputEvent( "Mouse_LUp", "WorldMapCheckListChange("..eCheckState.eCheck_Node..")")
worldMapCheckList[eCheckState.eCheck_Trade]		:addInputEvent( "Mouse_LUp", "WorldMapCheckListChange("..eCheckState.eCheck_Trade..")")
worldMapCheckList[eCheckState.eCheck_Way]		:addInputEvent( "Mouse_LUp", "WorldMapCheckListChange("..eCheckState.eCheck_Way..")")
worldMapCheckList[eCheckState.eCheck_Postions]	:addInputEvent( "Mouse_LUp", "WorldMapCheckListChange("..eCheckState.eCheck_Postions..")")
worldMapCheckList[eCheckState.eCheck_Wagon]		:addInputEvent( "Mouse_LUp", "WorldMapCheckListChange("..eCheckState.eCheck_Wagon..")")

-- 체크 리스트 툴팁
worldMapCheckList[eCheckState.eCheck_Quest]		:addInputEvent( "Mouse_On", "WorldMapCheckListToolTips( true, 0 )"	)
worldMapCheckList[eCheckState.eCheck_Quest]		:addInputEvent( "Mouse_Out","WorldMapCheckListToolTips( false )"	)
worldMapCheckList[eCheckState.eCheck_Knowledge]	:addInputEvent( "Mouse_On", "WorldMapCheckListToolTips( true, 1 )"	)
worldMapCheckList[eCheckState.eCheck_Knowledge]	:addInputEvent( "Mouse_Out","WorldMapCheckListToolTips( false )"	)
worldMapCheckList[eCheckState.eCheck_FishnChip]	:addInputEvent( "Mouse_On", "WorldMapCheckListToolTips( true, 2 )"	)
worldMapCheckList[eCheckState.eCheck_FishnChip]	:addInputEvent( "Mouse_Out","WorldMapCheckListToolTips( false )"	)
worldMapCheckList[eCheckState.eCheck_Node]		:addInputEvent( "Mouse_On", "WorldMapCheckListToolTips( true, 3 )"	)
worldMapCheckList[eCheckState.eCheck_Node]		:addInputEvent( "Mouse_Out","WorldMapCheckListToolTips( false )"	)
worldMapCheckList[eCheckState.eCheck_Trade]		:addInputEvent( "Mouse_On", "WorldMapCheckListToolTips( true, 4 )"	)
worldMapCheckList[eCheckState.eCheck_Trade]		:addInputEvent( "Mouse_Out","WorldMapCheckListToolTips( false )"	)
worldMapCheckList[eCheckState.eCheck_Way]		:addInputEvent( "Mouse_On", "WorldMapCheckListToolTips( true, 5 )"	)
worldMapCheckList[eCheckState.eCheck_Way]		:addInputEvent( "Mouse_Out","WorldMapCheckListToolTips( false )"	)
worldMapCheckList[eCheckState.eCheck_Postions]	:addInputEvent( "Mouse_On", "WorldMapCheckListToolTips( true, 6 )"	)
worldMapCheckList[eCheckState.eCheck_Postions]	:addInputEvent( "Mouse_Out","WorldMapCheckListToolTips( false )"	)

static_ContributeBG								:addInputEvent( "Mouse_On", "WorldMapCheckListToolTips( true, 7 )"	)
static_ContributeBG								:addInputEvent( "Mouse_Out","WorldMapCheckListToolTips( false )"	)

worldMapCheckList[eCheckState.eCheck_Quest]		:SetDisableColor( true )
worldMapCheckList[eCheckState.eCheck_Knowledge]	:SetDisableColor( true )
worldMapCheckList[eCheckState.eCheck_FishnChip]	:SetDisableColor( true )
worldMapCheckList[eCheckState.eCheck_Node]		:SetDisableColor( true )
worldMapCheckList[eCheckState.eCheck_Trade]		:SetDisableColor( true )
worldMapCheckList[eCheckState.eCheck_Way]		:SetDisableColor( true )
worldMapCheckList[eCheckState.eCheck_Postions]	:SetDisableColor( true )
worldMapCheckList[eCheckState.eCheck_Wagon]		:SetDisableColor( true )

-- 버튼
btnCtrl_Exit			:addInputEvent( "Mouse_LUp", "FromClient_WorldMapPanelClose()" )
-- btn_FishEncyclopedia	:addInputEvent( "Mouse_LUp", "FGlobal_FishEncyclopedia_Open()" )
btn_DelyveryInfo		:addInputEvent( "Mouse_LUp", "DeliveryInformationView_Open()" )

-----------------------------------------------------------------------------------------------
-- 월드맵 패널 애니메이션
-----------------------------------------------------------------------------------------------

-- 월드맵 켤 때 애니메이션
Panel_WorldMap:RegisterShowEventFunc( true, 'FGlobal_WorldmapPanelShowAni()' )
Panel_WorldMap:RegisterShowEventFunc( false, 'FGlobal_WorldmapPanelHideAni()' )

function FGlobal_WorldmapPanelShowAni()
	Panel_WorldMap:SetAlpha(0)
	Panel_WorldMap:ResetVertexAni();
	Panel_WorldMap:SetShowWithFade(CppEnums.PAUI_SHOW_FADE_TYPE.PAUI_ANI_TYPE_FADE_IN)
	local aniInfo = Panel_WorldMap:addColorAnimation( 0.0, 1.0, UI_ANI_ADV.PAUI_ANIM_ADVANCE_LINEAR)
	aniInfo:SetStartColor( UI_color.C_00FFFFFF )
	aniInfo:SetEndColor( UI_color.C_FFFFFFFF )
	aniInfo.IsChangeChild = false
end


--	월드맵 끌 때 애니메이션
function FGlobal_WorldmapPanelHideAni()
	Panel_WorldMap:ResetVertexAni();
	Panel_WorldMap:SetShowWithFade(CppEnums.PAUI_SHOW_FADE_TYPE.PAUI_ANI_TYPE_FADE_OUT)

	local aniInfo = Panel_WorldMap:addColorAnimation( 0.0, 1.0, UI_ANI_ADV.PAUI_ANIM_ADVANCE_LINEAR)
	aniInfo:SetStartColor( UI_color.C_FFFFFFFF )
	aniInfo:SetEndColor( UI_color.C_00FFFFFF )
	aniInfo.IsChangeChild = false
	aniInfo:SetHideAtEnd(true)
	aniInfo:SetDisableWhileAni(true)
	Panel_WorldMap:SetAlpha(0)
end

-- 컨트롤 이벤트 등록 끝
------------------------------------------------------------------------------------------------------

------------------------------------------------------------------------------------------------------
-- 클라이언트 이벤트 등록

registerEvent("FromClient_WorldMapOpen",	"FromClient_WorldMapPanelOpen" )
registerEvent("FromClient_ExitWorldMap",	"FromClient_WorldMapPanelClose")
registerEvent("FromClient_SetTownMode",		"FromClient_SetTownModeToPanel")
registerEvent("FromClient_resetTownMode",	"FromClient_resetTownModeToPanel")
registerEvent("FromClient_UpdateExplorePointParam",		"FromClient_updateExplorePointParam")

 -- 클라이언트 이벤트 등록 끝
 -----------------------------------------------------------------------------------------------------
 
 -----------------------------------------------------------------------------------------------------
 -- 지역 함수 등록
 
 local setWorldmapCHeckUseAble = function()
	worldMapCheckList[eCheckState.eCheck_Quest]		:SetEnable( true )
	worldMapCheckList[eCheckState.eCheck_Knowledge]	:SetEnable( true )
	worldMapCheckList[eCheckState.eCheck_FishnChip]	:SetEnable( true )
	worldMapCheckList[eCheckState.eCheck_Node]		:SetEnable( true )
	worldMapCheckList[eCheckState.eCheck_Trade]		:SetEnable( true )
	worldMapCheckList[eCheckState.eCheck_Way]		:SetEnable( true )
	worldMapCheckList[eCheckState.eCheck_Postions]	:SetEnable( true )
	worldMapCheckList[eCheckState.eCheck_Wagon]		:SetEnable( true )

	worldMapCheckList[eCheckState.eCheck_Quest]		:SetCheck( ToClient_isWorldmapCheckState(eCheckState.eCheck_Quest		) )
	worldMapCheckList[eCheckState.eCheck_Knowledge]	:SetCheck( ToClient_isWorldmapCheckState(eCheckState.eCheck_Knowledge	) )
	worldMapCheckList[eCheckState.eCheck_FishnChip]	:SetCheck( ToClient_isWorldmapCheckState(eCheckState.eCheck_FishnChip	) )
	worldMapCheckList[eCheckState.eCheck_Node]		:SetCheck( ToClient_isWorldmapCheckState(eCheckState.eCheck_Node		) )
	worldMapCheckList[eCheckState.eCheck_Trade]		:SetCheck( ToClient_isWorldmapCheckState(eCheckState.eCheck_Trade		) )
	worldMapCheckList[eCheckState.eCheck_Way]		:SetCheck( ToClient_isWorldmapCheckState(eCheckState.eCheck_Way			) )
	worldMapCheckList[eCheckState.eCheck_Postions]	:SetCheck( ToClient_isWorldmapCheckState(eCheckState.eCheck_Postions	) )	
	worldMapCheckList[eCheckState.eCheck_Wagon]		:SetCheck( ToClient_isWorldmapCheckState(eCheckState.eCheck_Wagon		) )	
 end

 local setWorldmapCheckDisable = function()
 	worldMapCheckList[eCheckState.eCheck_Quest]		:SetEnable( false )
	worldMapCheckList[eCheckState.eCheck_Knowledge]	:SetEnable( false )
	worldMapCheckList[eCheckState.eCheck_FishnChip]	:SetEnable( false )
	worldMapCheckList[eCheckState.eCheck_Node]		:SetEnable( false )
	worldMapCheckList[eCheckState.eCheck_Trade]		:SetEnable( false )
	worldMapCheckList[eCheckState.eCheck_Way]		:SetEnable( false )
	worldMapCheckList[eCheckState.eCheck_Postions]	:SetEnable( false )
	worldMapCheckList[eCheckState.eCheck_Wagon]		:SetEnable( false )
 end
 
 -----------------------------------------------------------------------------------------------------
 -- 전역 함수 등록
 
--[[
	 @Date 		2014/11/2014
	 @Author 	who1310
	 @Breif 	월드맵의 렌더 상태가 변경 됨
]]--
local WORLDMAP_RENDERTYPE  = CppEnums.WorldMapState
function WorldMapStateChange( state )
	ToClient_WorldmapStateChange( state )
	if( WORLDMAP_RENDERTYPE.eWMS_EXPLORE_PLANT == state ) then
		setWorldmapCHeckUseAble();

	else
		setWorldmapCheckDisable()
--	elseif( WORLDMAP_RENDERTYPE.eWMS_REGION == state ) then
--	elseif( WORLDMAP_RENDERTYPE.eWMS_LOCATION_INFO_WATER == state ) then
--	elseif( WORLDMAP_RENDERTYPE.eWMS_LOCATION_INFO_CELCIUS == state ) then
--	elseif( WORLDMAP_RENDERTYPE.eWMS_LOCATION_INFO_HUMIDITY == state ) then
	end

end

--[[
	 @Date 		2014/11/2014
	 @Author 	who1310
	 @Breif 		월드맵의 Check 상태 변경
]]--
function WorldMapCheckListChange( checkState )
	-- _PA_LOG("최대호", tostring( checkState ) )
	ToClient_WorldmapCheckState(checkState, worldMapCheckList[checkState]:IsCheck() )
end

function FromClient_SetTownModeToPanel()
	setWorldmapCheckDisable()
	FGlobal_SetShowCheckBox( false );
	FromClient_WorldMap_HouseNaviShow(true)
	FGlobal_AlignExplorePointInfo()
end

function FromClient_resetTownModeToPanel()
	setWorldmapCHeckUseAble()
	FGlobal_SetShowCheckBox( true );
	FromClient_WorldMap_HouseNaviShow(false)
	FGlobal_AlignExplorePointInfo()
end

-- 전역 함수 끝
-------------------------------------------------------------------------------------------------------

-------------------------------------------------------------------------------------------------------
-- 클라이언트 호출 함수 등록
--
function FromClient_updateExplorePointParam( explorePoint )
	if( nil == explorePoint ) then
		txtCtrl_ExPoint:SetText("");
		progress_ExPoint:SetProgressRate(0);
	end
	
	local nowExplorePoint = explorePoint:getRemainedPoint()
	local maxExplorePoint = explorePoint:getAquiredPoint()
	local explorePointPercent = nowExplorePoint / maxExplorePoint * 100

	txtCtrl_ExPoint:SetText( PAGetString( Defines.StringSheet_GAME, "MAINSTATUS_CONTRIBUTE" ) .. " " .. nowExplorePoint .. " / " .. maxExplorePoint)
	progress_ExPoint:SetProgressRate( explorePointPercent );
end

--[[
	 @Date 		2014/11/2014
	 @Author 	who1310
	 @Breif		클라이언트에서 월드맵이 열렸을때 호출된다
]]--
function FromClient_WorldMapPanelOpen()
	Panel_WorldMap:SetShow( true );
	setWorldmapCHeckUseAble();
	worldMapState[eWorldmapState.eWMS_EXPLORE_PLANT]:SetCheck(true)
	worldMapState[eWorldmapState.eWMS_REGION]:SetCheck(false)
	worldMapState[eWorldmapState.eWMS_LOCATION_INFO_WATER]:SetCheck(false)
	worldMapState[eWorldmapState.eWMS_LOCATION_INFO_CELCIUS]:SetCheck(false)
	worldMapState[eWorldmapState.eWMS_LOCATION_INFO_HUMIDITY]:SetCheck(false)

	worldMapCheckList[eCheckState.eCheck_Quest]		:SetCheck( ToClient_isWorldmapCheckState(eCheckState.eCheck_Quest		) )
	worldMapCheckList[eCheckState.eCheck_Knowledge]	:SetCheck( ToClient_isWorldmapCheckState(eCheckState.eCheck_Knowledge	) )
	worldMapCheckList[eCheckState.eCheck_FishnChip]	:SetCheck( ToClient_isWorldmapCheckState(eCheckState.eCheck_FishnChip	) )
	worldMapCheckList[eCheckState.eCheck_Node]		:SetCheck( ToClient_isWorldmapCheckState(eCheckState.eCheck_Node		) )
	worldMapCheckList[eCheckState.eCheck_Trade]		:SetCheck( ToClient_isWorldmapCheckState(eCheckState.eCheck_Trade		) )
	worldMapCheckList[eCheckState.eCheck_Way]		:SetCheck( ToClient_isWorldmapCheckState(eCheckState.eCheck_Way			) )
	worldMapCheckList[eCheckState.eCheck_Postions]	:SetCheck( ToClient_isWorldmapCheckState(eCheckState.eCheck_Postions	) )
	worldMapCheckList[eCheckState.eCheck_Wagon]		:SetCheck( ToClient_isWorldmapCheckState(eCheckState.eCheck_Wagon		) )
	
	TownFunctionalbeNpc_WorldMapShow()
	
	btnCtrl_Exit:SetSpanSize( Panel_WorldMap:GetSizeX() - getScreenSizeX() + 6, Panel_WorldMap:GetSizeY() - getScreenSizeY() + 6 )
	FGlobal_SetShowCheckBox(true)
	FGlobal_AlignExplorePointInfo()
end

--[[
	 @Date 		2014/11/2014
	 @Author 	who1310
	 @Breif		클라이언트에서 월드맵이 닫혔을때 호출된다
]]--

function FromClient_WorldMapPanelClose()
	Panel_WorldMap:SetShow(false)
	FromClient_ExitWorldMap()
end


--[[
	@Dat3		2014/12/32
	@Author		who1310
	@Brief		체크 박스를 켜고 끈다
]]--
function FGlobal_SetShowCheckBox( isShow )
	checkBoxBG:SetShow( isShow )
	for i, checkBox in pairs( worldMapCheckList ) do
		checkBox:SetShow( isShow )	
	end
end

function FGlobal_AlignExplorePointInfo()
	local baseCtrl = nil
	if( checkBoxBG:GetShow() ) then
		baseCtrl = checkBoxBG
	else
		baseCtrl = Panel_NodeHouseFilter
	end
	

	static_ContributeBG:SetPosX( baseCtrl:GetSizeX() + 10 )
	local basePosX = static_ContributeBG:GetPosX();

	static_ExBG:SetPosX( basePosX + 136 )
	txtCtrl_ExPoint:SetPosX( basePosX + 20 )
	static_ExOutLine:SetPosX( basePosX + 135 )
	progress_ExPoint:SetPosX( basePosX + 137 )
end
------------------------------------------------------------------------------
-- 월드맵 Npc 아이콘 내비
------------------------------------------------------------------------------
local npcType =
{
	[UI_ST.eSpawnType_SkillTrainer]		= {},	--	1, 스킬 트레이너(O)
	[UI_ST.eSpawnType_ItemRepairer]		= {},	--	2, 수리(O)
	[UI_ST.eSpawnType_ShopMerchant]		= {},	--	3, 일반 상점(O)
	[UI_ST.eSpawnType_ImportantNpc]		= {},	--	4, 중요 대화
	[UI_ST.eSpawnType_TradeMerchant]	= {},	--	5, 무역 상점(O)
	[UI_ST.eSpawnType_WareHouse]		= {},	--	6, 창고(O)
	[UI_ST.eSpawnType_Stable]			= {},	--	7, 마굿간(O)
	[UI_ST.eSpawnType_Wharf]			= {},	--	8, 선착장(O)
	[UI_ST.eSpawnType_transfer]			= {},	--	9, 운송
	[UI_ST.eSpawnType_intimacy]			= {},	--	10, 이야기교류
	[UI_ST.eSpawnType_guild]			= {},	--	11, 길드(O)
	[UI_ST.eSpawnType_explorer]			= {},	--	12, 탐험
	[UI_ST.eSpawnType_inn]				= {},	--	13, 여관
	[UI_ST.eSpawnType_auction]			= {},	--	14, 경매(O)
	[UI_ST.eSpawnType_mating]			= {},	--	15, 상단 행수
	
    [UI_ST.eSpawnType_Potion]			= {},	--  16, 물약상인(O)
    [UI_ST.eSpawnType_Weapon]			= {},	--  17, 무기상인(O)
    [UI_ST.eSpawnType_Jewel]			= {},	--  18, 보석상인(O)
    [UI_ST.eSpawnType_Furniture]		= {},	--  19, 가구상인
    [UI_ST.eSpawnType_Collect]			= {},	--  20, 재료상인(O)
    [UI_ST.eSpawnType_Fish]	    		= {},	--  21, 물고기상인(O)
    [UI_ST.eSpawnType_Worker]		    = {},	--  22, 작업감독관(O)
    [UI_ST.eSpawnType_Alchemy]		    = {},	--  23, 연금술사

	[UI_ST.eSpawnType_GuildShop]		= {},	--	24, 길드 상점
	[UI_ST.eSpawnType_ItemMarket]		= {},	--	25, 아이템 거래소(O)
	[UI_ST.eSpawnType_TerritorySupply]	= {},	--	26, 황실납품(O)
	[UI_ST.eSpawnType_TerritoryTrade]	= {},	--	27, 황실무역(O)
	[UI_ST.eSpawnType_Cook]				= {},	--	28, 요리상인(O)
	[UI_ST.eSpawnType_Grocery]			= {},	--	29, 잡화상인(O)
}

local npcTypeText =
{
	[UI_ST.eSpawnType_SkillTrainer]		= "기술 교관",
	[UI_ST.eSpawnType_ItemRepairer]		= "수리",
	[UI_ST.eSpawnType_ShopMerchant]		= "일반 상점",
	[UI_ST.eSpawnType_ImportantNpc]		= "중요 대화",
	[UI_ST.eSpawnType_TradeMerchant]	= "무역관리인",
	[UI_ST.eSpawnType_WareHouse]		= "창고",
	[UI_ST.eSpawnType_Stable]			= "마굿간",
	[UI_ST.eSpawnType_Wharf]			= "선착장",
	[UI_ST.eSpawnType_transfer]			= "수송",
	[UI_ST.eSpawnType_intimacy]			= "이야기교류",
	[UI_ST.eSpawnType_guild]			= "길드",
	[UI_ST.eSpawnType_explorer]			= "탐험",
	[UI_ST.eSpawnType_inn]				= "여관",
	[UI_ST.eSpawnType_auction]			= "경매",
	[UI_ST.eSpawnType_mating]			= "상단 행수",
	
    [UI_ST.eSpawnType_Potion]			= "물약 상인",
    [UI_ST.eSpawnType_Weapon]			= "무기 상인",
    [UI_ST.eSpawnType_Jewel]			= "보석 상인",
    [UI_ST.eSpawnType_Furniture]		= "가구 상인",
    [UI_ST.eSpawnType_Collect]			= "재료 상인",
    [UI_ST.eSpawnType_Fish]	    		= "낚시 상인",
    [UI_ST.eSpawnType_Worker]		    = "작업 감독관",
    [UI_ST.eSpawnType_Alchemy]		    = "연금술사",

	[UI_ST.eSpawnType_GuildShop]		= "길드 상점",
	[UI_ST.eSpawnType_ItemMarket]		= "아이템 거래소",
	[UI_ST.eSpawnType_TerritorySupply]	= "황실 납품",
	[UI_ST.eSpawnType_TerritoryTrade]	= "황실 무역",
	[UI_ST.eSpawnType_Cook]				= "요리 상인",
	[UI_ST.eSpawnType_Grocery]			= "잡화 상인",
}

local iconTexture =
{
	[UI_ST.eSpawnType_SkillTrainer]		= { 2, 2, 38, 38, 2, 39, 38, 75, 2, 76, 38, 112 },						-- 스킬
	[UI_ST.eSpawnType_ItemRepairer]		= { 39, 2, 75, 38, 39, 39, 75, 75, 39, 76, 75, 112 },					-- 수리
	[UI_ST.eSpawnType_ShopMerchant]		= { 76, 2, 112, 38, 76, 39, 112, 75, 76, 76, 112, 112 },				-- 일반 상점
	[UI_ST.eSpawnType_TradeMerchant]	= { 113, 2, 149, 38, 113, 39, 149, 75, 113, 76, 149, 112 },				-- 무역
	[UI_ST.eSpawnType_WareHouse]		= { 150, 2, 186, 38, 150, 39, 186, 75, 150, 76, 186, 112 },				-- 창고
	[UI_ST.eSpawnType_Stable]			= { 187, 2, 223, 38, 187, 39, 223, 75, 187, 76, 223, 112 },				-- 마굿간
	[UI_ST.eSpawnType_Wharf]			= { 224, 2, 260, 38, 224, 39, 260, 75, 224, 76, 260, 112 },				-- 선착장
	[UI_ST.eSpawnType_guild]			= { 261, 2, 297, 38, 261, 39, 297, 75, 261, 76, 297, 112 },				-- 길드
	[UI_ST.eSpawnType_auction]			= { 298, 2, 334, 38, 298, 39, 334, 75, 298, 76, 334, 112 },				-- 경매
	[UI_ST.eSpawnType_Potion]			= { 2, 113, 38, 149, 2, 150, 38, 186, 2, 187, 38, 223 },				-- 물약
	[UI_ST.eSpawnType_Weapon]			= { 39, 113, 75, 149, 39, 150, 75, 186, 39, 187, 75, 223 },				-- 무기상인(수리)
	[UI_ST.eSpawnType_Jewel]			= { 76, 113, 112, 149, 76, 150, 112, 186, 76, 187, 112, 223 },			-- 보석
	[UI_ST.eSpawnType_Collect]			= { 113, 113, 149, 149, 113, 150, 149, 186, 113, 187, 149, 223 },		-- 재료상인
	[UI_ST.eSpawnType_Fish]	    		= { 150, 113, 186, 149, 150, 150, 186, 186, 150, 187, 186, 223 },		-- 낚싯대
	[UI_ST.eSpawnType_Worker]		    = { 187, 113, 223, 149, 187, 150, 223, 186, 187, 187, 223, 223 },		-- 작업감독관
	[UI_ST.eSpawnType_ItemMarket]		= { 224, 113, 260, 149, 224, 150, 260, 186, 224, 187, 260, 223 },		-- 거래소
	[UI_ST.eSpawnType_TerritorySupply]	= { 261, 113, 297, 149, 261, 150, 297, 186, 261, 287, 297, 223 },		-- 황실 납품
	[UI_ST.eSpawnType_TerritoryTrade]	= { 298, 113, 334, 149, 298, 150, 334, 186, 298, 187, 334, 223 },		-- 황실 무역
	[UI_ST.eSpawnType_Cook]				= { 2, 224, 38, 260, 2, 261, 38, 297, 2, 298, 38, 334 },				-- 요리상인
	[UI_ST.eSpawnType_Furniture]		= { 39, 224 , 75, 260, 39, 261, 75, 297, 39, 298, 75, 334 },				-- 가구 상인
	[UI_ST.eSpawnType_transfer]			= { 76, 224, 112, 260, 76, 261, 112, 297, 76, 298, 112, 334 },				-- 가구 상인
}

local iconBg	= UI.getChildControl( Panel_WorldMap, "Static_NpcNaviIconBg" )
local npcIcon	= UI.getChildControl( Panel_WorldMap, "Static_TownNpcNavi_Icon" )
local iconTooltip = UI.getChildControl( Panel_WorldMap, "StaticText_WorldMapNpcIcon_ToolTip" )
-- iconTooltip:SetTextMode( UI_TM.eTextMode_AutoWrap )
-- iconTooltip:SetAutoResize( true )
iconTooltip:SetShow(false)
iconBg:AddChild( iconTooltip )
Panel_WorldMap:RemoveControl( iconTooltip )

local iconSize	= npcIcon:GetSizeX()

local _spawnType = nil
local _isAuto = nil
local _isCheck = false
function HandleClicked_TownNpcIcon_WorldMapNaviStart( spawnType, isAuto )
	local player	= getSelfPlayer()
	if nil == player then
		return
	end
	
	if nil == isAuto then
		isAuto = false
	end
	
	audioPostEvent_SystemUi(00,00)
	
	ToClient_DeleteNaviGuideByGroup(0);
	if _spawnType == spawnType and _isAuto == isAuto and true == _isCheck then
		_isCheck = false
		return
	else
		_spawnType = spawnType
		_isAuto = isAuto
		_isCheck = true
	end

	local position		= player:get3DPos() -- 기준이 되는 위치
	local nearNpcInfo 	= getNearNpcInfoByType( spawnType, position )
	
	if nil == nearNpcInfo then
		return
	end
	
	local curChannelData	= getCurrentChannelServerData()
	if ( 0 ~= curChannelData._serverNo ) and ( UI_ST.eSpawnType_TerritorySupply == spawnType ) then
		NotifyDisplay( "황실 납품 NPC는 1채널에서만 볼 수 있습니다." )
		return
	elseif ( 0 ~= curChannelData._serverNo ) and ( UI_ST.eSpawnType_TerritoryTrade == spawnType ) then
		NotifyDisplay( "황실 무역 NPC는 1채널에서만 볼 수 있습니다." )
		return
	end

	local isSpawnNearNpc = nearNpcInfo:isTimeSpawn()			-- 가장 가까운 npc의 스폰(출/퇴근) 여부
	local pos = nearNpcInfo:getPosition()
	local npcNaviKey = ToClient_WorldMapNaviStart( pos, NavigationGuideParam(), isAuto, isAuto )
	audioPostEvent_SystemUi(00,14)
	
	local selfPlayer = getSelfPlayer():get()
	selfPlayer:setNavigationMovePath(npcNaviKey)
	selfPlayer:checkNaviPathUI(npcNaviKey)
	if false == isSpawnNearNpc then								-- 퇴근했으면 메시지 띄운다
		NotifyDisplay( PAGetString(Defines.StringSheet_GAME, "NPCNAVIGATION_REST_AVAILABLE" ))
	end
end

local npcIconChangeTexture = function( icon, spawnType )
	if nil == iconTexture[spawnType] then
		spawnType = UI_ST.eSpawnType_ShopMerchant
	end

	icon:ChangeTextureInfoName ( "New_UI_Common_forLua/Default/NpcIcon_00.dds" )
	local x1, y1, x2, y2 = setTextureUV_Func( icon, iconTexture[spawnType][1], iconTexture[spawnType][2], iconTexture[spawnType][3], iconTexture[spawnType][4] )
	icon:getBaseTexture():setUV(  x1, y1, x2, y2 )
	icon:setRenderTexture(icon:getBaseTexture())

	icon:ChangeOnTextureInfoName ( "New_UI_Common_forLua/Default/NpcIcon_00.dds" )
	local x1, y1, x2, y2 = setTextureUV_Func( icon, iconTexture[spawnType][5], iconTexture[spawnType][6], iconTexture[spawnType][7], iconTexture[spawnType][8] )
	icon:getOnTexture():setUV(  x1, y1, x2, y2 )

	icon:ChangeClickTextureInfoName ( "New_UI_Common_forLua/Default/NpcIcon_00.dds" )
	local x1, y1, x2, y2 = setTextureUV_Func( icon, iconTexture[spawnType][9], iconTexture[spawnType][10], iconTexture[spawnType][11], iconTexture[spawnType][12] )
	icon:getClickTexture():setUV(  x1, y1, x2, y2 )

end

local npcNaviIcon = {}
local iconTypeCount = 0
local halfCount = 0
function TownFunctionalbeNpc_WorldMapShow()
	if 10 >= getSelfPlayer():get():getLevel() then
		iconBg:SetShow( false )
		return
	else
		iconBg:SetShow( true )
	end
	
	halfCount = 0
	iconTypeCount = UI_ST.eSpawnType_Count - 1
	local spawnType = {}
	for index = 1, UI_ST.eSpawnType_Count -1 do
	

		local pushTownNpcIcon = function( i, index )
			if nil ~= npcNaviIcon[i] then
				UI.deleteControl( npcNaviIcon[i] )
			end

			local tempIcon = UI.createControl( CppEnums.PA_UI_CONTROL_TYPE.PA_UI_CONTROL_STATIC, iconBg, "WorldMap_NpcNavi_Icon_" .. index )
			CopyBaseProperty ( npcIcon, tempIcon )
			npcNaviIcon[i] = tempIcon
			
			npcNaviIcon[i]:SetShow( true )
			npcIconChangeTexture( npcNaviIcon[i], index )
		end
		
		if UI_ST.eSpawnType_SkillTrainer == index then
			spawnType[0] = index
			pushTownNpcIcon( 0, index )
		elseif UI_ST.eSpawnType_ItemRepairer == index then
			spawnType[1] = index
			pushTownNpcIcon( 1, index )
		elseif UI_ST.eSpawnType_ShopMerchant == index then
			spawnType[11] = index
			pushTownNpcIcon( 11, index )		
		elseif UI_ST.eSpawnType_TradeMerchant == index then
			spawnType[8] = index
			pushTownNpcIcon( 8, index )		
		elseif UI_ST.eSpawnType_WareHouse == index then
			spawnType[2] = index
			pushTownNpcIcon( 2, index )		
		elseif UI_ST.eSpawnType_Stable == index then
			spawnType[4] = index
			pushTownNpcIcon( 4, index )		
		elseif UI_ST.eSpawnType_Wharf == index then
			spawnType[5] = index
			pushTownNpcIcon( 5, index )		
		elseif UI_ST.eSpawnType_guild == index then
			spawnType[6] = index
			pushTownNpcIcon( 6, index )		
		elseif UI_ST.eSpawnType_auction == index then
			spawnType[7] = index
			pushTownNpcIcon( 7, index )		
		elseif UI_ST.eSpawnType_Potion == index then
			spawnType[12] = index
			pushTownNpcIcon( 12, index )		
		elseif UI_ST.eSpawnType_Weapon == index then
			spawnType[13] = index
			pushTownNpcIcon( 13, index )		
		elseif UI_ST.eSpawnType_Jewel == index then
			spawnType[14] = index
			pushTownNpcIcon( 14, index )		
		elseif UI_ST.eSpawnType_Collect == index then
			spawnType[16] = index
			pushTownNpcIcon( 16, index )		
		elseif UI_ST.eSpawnType_Fish == index then
			spawnType[17] = index
			pushTownNpcIcon( 17, index )		
		elseif UI_ST.eSpawnType_Worker == index then
			spawnType[19] = index
			pushTownNpcIcon( 19, index )		
		elseif UI_ST.eSpawnType_ItemMarket == index then
			spawnType[20] = index
			pushTownNpcIcon( 20, index )		
		elseif UI_ST.eSpawnType_TerritorySupply == index then
			spawnType[9] = index
			pushTownNpcIcon( 9, index )		
		elseif UI_ST.eSpawnType_TerritoryTrade == index then
			spawnType[10] = index
			pushTownNpcIcon( 10, index )		
		elseif UI_ST.eSpawnType_Cook == index then
			spawnType[18] = index
			pushTownNpcIcon( 18, index )		
		elseif UI_ST.eSpawnType_Furniture == index then
			spawnType[15] = index
			pushTownNpcIcon( 15, index )		
		elseif UI_ST.eSpawnType_transfer == index then
			spawnType[3] = index
			pushTownNpcIcon( 3, index )		
		else
			iconTypeCount = iconTypeCount - 1
		end
	end
	
	if 0 < (iconTypeCount/2)%1 then
		halfCount = (iconTypeCount/2) - (iconTypeCount/2)%1 + 1
	else
		halfCount = (iconTypeCount/2) - (iconTypeCount/2)%1
	end
	
	iconBg:SetSize( halfCount * ( iconSize + 5 ) - 20, iconSize * 2 + 23 )
	iconBg:SetSpanSize( Panel_WorldMap:GetSizeX() - getScreenSizeX() + 10, 6 )
	-- FGlobal_WorldMap_TownNpcIcon_Repos()

	-- 편의상 컨트롤 생성 후 다시 한 번 자리를 잡아준다.
	for ii = 0, iconTypeCount -1 do
		if  halfCount <= ii then
			npcNaviIcon[ii]:SetPosX( iconBg:GetSizeX() - ( iconSize * (ii- halfCount)) - iconSize - 7 )
			npcNaviIcon[ii]:SetPosY( iconSize + 16 )
		else
			npcNaviIcon[ii]:SetPosX( iconBg:GetSizeX() - iconSize * ii - iconSize - 7 )
			npcNaviIcon[ii]:SetPosY( 6 )
		end

		npcNaviIcon[ii]:addInputEvent( "Mouse_On", "HandleOn_WorldMap_NaviIconSizeUp(" .. ii .. ", " .. halfCount .. ", " .. spawnType[ii] .. ")" )
		npcNaviIcon[ii]:addInputEvent( "Mouse_Out", "HandleOn_WorldMap_NaviIconSizeUp()" )
		npcNaviIcon[ii]:addInputEvent( "Mouse_LUp", "HandleClicked_TownNpcIcon_WorldMapNaviStart(".. spawnType[ii] .. ")" )
		npcNaviIcon[ii]:addInputEvent( "Mouse_RUp", "HandleClicked_TownNpcIcon_WorldMapNaviStart(".. spawnType[ii] .. ", " .. "true)" )

	end
end

function HandleOn_WorldMap_NaviIconSizeUp( index, _halfCount, spawnType )
	if nil == index then
		for i = 0, iconTypeCount - 1 do
			npcNaviIcon[i]:SetSize( iconSize, iconSize )
			if halfCount <= i then
				npcNaviIcon[i]:SetPosX( iconBg:GetSizeX() - ( npcNaviIcon[i]:GetSizeX() * (i-halfCount)) - iconSize - 7 )
			else
				npcNaviIcon[i]:SetPosX( iconBg:GetSizeX() - ( npcNaviIcon[i]:GetSizeX() * i) - iconSize - 7 )
			end
		end
		Worldmap_TownNpcIcon_Tooltip()
	else
		npcNaviIcon[index]:SetPosX( npcNaviIcon[index]:GetPosX() - iconSize*0.3 )
		npcNaviIcon[index]:SetSize( iconSize * 1.3, iconSize * 1.3 )
		npcNaviIcon[index]:SetEnableArea( 7, 0, iconSize * 1.3, iconSize * 1.3 )
		
		if _halfCount <= index then
			local _count = 0
			for i = index+1, iconTypeCount-1 do
				npcNaviIcon[i]:SetPosX(npcNaviIcon[index]:GetPosX() - (iconSize + npcNaviIcon[i]:GetSizeX() * _count) - 7 )
				_count = _count + 1
			end
		else
			local _count = 0
			for i = index+1, _halfCount -1 do
				npcNaviIcon[i]:SetPosX(npcNaviIcon[index]:GetPosX() - (iconSize + npcNaviIcon[i]:GetSizeX() * _count) - 7 )
				_count = _count + 1
			end
		end
		Worldmap_TownNpcIcon_Tooltip( index, spawnType )
	end
end

function Worldmap_TownNpcIcon_Tooltip( index, spawnType )
	if nil == index then
		iconTooltip:SetShow( false )
		return
	end

	iconTooltip:SetShow( true )
	iconTooltip:SetText( npcTypeText[spawnType] )
	iconTooltip:SetSize( iconTooltip:GetTextSizeX() + 10, iconTooltip:GetTextSizeY() + 5 )
	iconBg:SetChildIndex( iconTooltip:GetKey(), 9999 )
	
	iconTooltip:SetPosX( npcNaviIcon[index]:GetPosX() + npcNaviIcon[index]:GetSizeX() - iconTooltip:GetSizeX())

	if halfCount <= index then
		iconTooltip:SetPosY( npcNaviIcon[index]:GetPosY() - iconTooltip:GetSizeY() - 5 )
	else
		iconTooltip:SetPosY( npcNaviIcon[index]:GetPosY() + npcNaviIcon[index]:GetSizeY() + 5 )
	end
end

function WorldMapCheckListToolTips( isShow, checkType )
	local _contributeBubbleText = ""
	local _contributeUsePoint =
	{
		[0] = PAGetString( Defines.StringSheet_GAME, "LUA_EXPGUAGE_CONTRIBUTE_VALUE_1" ),	--"집 구입",
		[1] = PAGetString( Defines.StringSheet_GAME, "LUA_EXPGUAGE_CONTRIBUTE_VALUE_2" ),	--"거점 투자",
		[2] = PAGetString( Defines.StringSheet_GAME, "LUA_EXPGUAGE_CONTRIBUTE_VALUE_3" )	--"아이템 대여"
	}

	for i = 0, 2 do
		if 0 < ToClient_UsedExplorePoint(i) then
			if ( "" == _contributeBubbleText ) then
				_contributeBubbleText = _contributeUsePoint[i] .. " " .. ToClient_UsedExplorePoint(i)
			else
				_contributeBubbleText = _contributeBubbleText .. " | " .. _contributeUsePoint[i] .. " " .. ToClient_UsedExplorePoint(i)
			end
		end
	end
	
	if ( "" == _contributeBubbleText ) then
		_contributeBubbleText = PAGetString( Defines.StringSheet_GAME, "LUA_EXPGUAGE_CONTRIBUTE_VALUE_4" )
	else
		_contributeBubbleText = PAGetStringParam1( Defines.StringSheet_GAME, "LUA_EXPGUAGE_CONTRIBUTE_VALUE_5", "_contributeBubbleText", _contributeBubbleText )
	end

	if checkType == 0 then
		name = "의뢰"
		desc = "월드맵에서의 의뢰 지역 정보를 켜고 끌 수 있습니다."
		uiControl = worldMapCheckList[eCheckState.eCheck_Quest]
	elseif checkType == 1 then
		name = "지식"
		desc = "월드맵에서의 지식, NPC 위치를 켜고 끌 수 있습니다."
		uiControl = worldMapCheckList[eCheckState.eCheck_Knowledge]
	elseif checkType == 2 then
		name = "낚시/채집 지식"
		desc = "월드맵에서의 낚시/채집 지식 위치를 켜고 끌 수 있습니다."
		uiControl = worldMapCheckList[eCheckState.eCheck_FishnChip]
	elseif checkType == 3 then
		name = "거점"
		desc = "월드맵에서의 거점 연결 지역 위치를 켜고 끌 수 있습니다."
		uiControl = worldMapCheckList[eCheckState.eCheck_Node]
	elseif checkType == 4 then
		name = "무역"
		desc = "월드맵에서의 무역 정보를 켜고 끌 수 있습니다."
		uiControl = worldMapCheckList[eCheckState.eCheck_Trade]
	elseif checkType == 5 then
		name = "방향 정보"
		desc = "월드맵에서의 방향 정보를 켜고 끌 수 있습니다."
		uiControl = worldMapCheckList[eCheckState.eCheck_Way]
	elseif checkType == 6 then
		name = "위치 아이콘"
		desc = "월드맵에서의 도적, 탑승물 등의 위치 정보를 켜고 끌 수 있습니다."
		uiControl = worldMapCheckList[eCheckState.eCheck_Postions]
	elseif checkType == 7 then
		name = "공헌도"
		desc = PAGetString( Defines.StringSheet_GAME,  "MAINSTATUS_DESC_EXPLORE" ) .. "\n" .. _contributeBubbleText
		uiControl = static_ContributeBG
	end

	if true == isShow then
		TooltipSimple_Show( uiControl, name, desc )
	else
		TooltipSimple_Hide()
	end
end

function FGlobal_WorldMap_TownNpcIcon_Repos()
	if Panel_manageWorker:GetShow() then
		iconBg:SetSpanSize( Panel_WorldMap:GetSizeX() - getScreenSizeX() + Panel_manageWorker:GetSizeX() + 10, 10 )
	else
		iconBg:SetSpanSize( Panel_WorldMap:GetSizeX() - getScreenSizeX() + 10, 6 )
	end
end
