Panel_Working_Progress:setMaskingChild(true)
Panel_Working_Progress:setGlassBackground(true)
Panel_Working_Progress:TEMP_UseUpdateListSwap(true)

--[[
getPlantByRawKey( plantKeyRaw ) -- 숫자(raw) ==>> plant


plant:getType()  -- 제대로 작동할지 ...( 의문 )
    - 0 : 타운
    - 1 : 존
    - 2 : 하우스
    

getWorkingList( plant )
	- 일하고있는 일꾼 숫자 반환 ( 먼저 콜해야됨 )
	
getWorkingByIndex(index)  ==>> "NpcWorkerWorking"   .workerNo 있음
	
	local count = getWorkingList()
	for index =  ... 
	    local workingWorker = getWorkingByIndex( index )


getWorkingIcon( workerNo ) -- 일하고있는 아이콘 패스
getWorkingProgress( workerNo ) --일하고있는 진행률 ( 0~1 ) 잘못된 데이터 입력시 -1반환

]]

local UI_TM 		= CppEnums.TextMode
local VCK 			= CppEnums.VirtualKeyCode

local isFale_Init = false

eWorkType = 
{
	plant				= 1,
	craft				= 2,
	changeHouseUseType	= 3,
}

local WorkingProgress =
{
	_itemicon 			= UI.getChildControl( Panel_Working_Progress, "Static_Resource_Icon" ),
	_itemicon_BG		= UI.getChildControl( Panel_Working_Progress, "Static_IconBG" ),
	_progressGauge 		= UI.getChildControl( Panel_Working_Progress, "Progress2_H_Cons_Gauge" ),
	_progressText	 	= UI.getChildControl( Panel_Working_Progress, "StaticText_Progress" ),
	_remainTimeText	 	= UI.getChildControl( Panel_Working_Progress, "StaticText_leftTime_Vlaue" ),	
	_txt_WorkName	 	= UI.getChildControl( Panel_Working_Progress, "StaticText_WorkName" ),
	_btnClose		 	= UI.getChildControl( Panel_Working_Progress, "Button_Close" ),
	_btnCancelWork	 	= UI.getChildControl( Panel_Working_Progress, "Button_cancelWork" ),
	
	_workType			= nil,
	_worker				= nil,
	_workerNo			= nil,
	_nodekey			= 0,
	_saveProgress		= 0,
	_saveIcon			= nil,
	_workingProgress	= 0,
	_remainTime			= 0,
	_updateCount 		= 0,
	
	_itemKey_Tooltip	= nil,
}

WorkingProgress._txt_WorkName:SetTextMode( UI_TM.eTextMode_LimitText )

WorldMapWindow.progressPanelStack = WorldMapWindow.popupManager:createStackWindowDefault( Panel_Working_Progress, false, 3 )
function WorldMapWindow.progressPanelStack:updateFirst__()
	Panel_manageWorker:SetShow(false)
	Panel_Window_Warehouse:SetShow(false)
end

function WorldMapWindow.progressPanelStack:postHideUpdate__()
	HideWorkingProgress()
	WorldMapWindow_OnClearClickAnimation()
end

function WorkingProgress_Init()
	local nodeKey = WorkingProgress._nodekey
	local workType = WorkingProgress._workType
	local workingcnt = -1

	if ( eWorkType.plant == workType ) then
		local plantByRawKey = getPlantByRawKey( nodeKey )
		workingcnt = getWorkingList( plantByRawKey )
	elseif ( eWorkType.craft == workType ) then
		local houseInfo 		= housing_getHouseInfo(nodeKey - 1)
		local houseKey			= houseInfo:getHouseCharacterKey()
		workingcnt 		= getWorkingListAtRentHouse( houseKey )
	end
		
	if workingcnt == 0 then
		isFale_Init = true
	end
		
	for idx = 0 , workingcnt - 1 , 1 do
		local worker = getWorkingByIndex( idx ).workerNo
		local workerNo = worker:get_s64()
		local workingIcon = getWorkingIcon( workerNo )		
		local workName 	= getWorkableExchangeDescriptionByIndex(idx)

		WorkingProgress._itemicon			:ChangeTextureInfoName("icon/" .. workingIcon)
		WorkingProgress._saveIcon = workingIcon	
		WorkingProgress._worker = worker		
		WorkingProgress._workerNo = workerNo
		
		if ( eWorkType.plant == workType ) then
			local esSS		= getWorkableExchangeByIndex(idx)
			WorkingProgress._txt_WorkName		:SetText(workName)
			WorkingProgress._itemKey_Tooltip = esSS:getFirstDropGroup()._itemKey			

			WorkingProgress._itemicon			:addInputEvent("Mouse_On","Plant_Tooltip_Item_Show()")
			WorkingProgress._itemicon			:addInputEvent("Mouse_Out","Panel_Tooltip_Item_hideTooltip()")
		elseif ( eWorkType.craft == workType ) then

			WorkingProgress._txt_WorkName		:SetText(workName)
			WorkingProgress._itemicon			:addInputEvent("Mouse_On","Craft_Show_Tooltip_Work(" .. idx .. ")")
			WorkingProgress._itemicon			:addInputEvent("Mouse_Out","Craft_Hide_Tooltip_Work(" .. idx .. ")")
		end
	end		
end

function WorkingProgressUpdate()
	local nodeKey = WorkingProgress._nodekey
	local workType = WorkingProgress._workType
	local workingcnt = -1
	WorkingProgress._updateCount = WorkingProgress._updateCount + 1

	if ( eWorkType.plant == workType ) then
		local plantByRawKey = getPlantByRawKey( nodeKey )
		workingcnt = getWorkingList( plantByRawKey )

	elseif ( eWorkType.craft == workType ) then
		local houseInfo 		= housing_getHouseInfo(nodeKey - 1)
		local houseKey			= houseInfo:getHouseCharacterKey()
		workingcnt 		= getWorkingListAtRentHouse( houseKey )
	else
		WorldMapWindow_CloseNodeMenu()
		return
	end
	
	if isFale_Init == true and workingcnt > 0 then
		WorkingProgress_Init()
		isFale_Init = false
	end
	
	WorldMap_NodeIcon_WorkProgress_Hide(nodeKey)
	
	if ( 0 == nodeKey ) then
		WorldMapWindow_CloseNodeMenu()
		return
	end

	if	( 0 == workingcnt) and ( 0 ~= WorkingProgress._saveProgress) then
		local complete = 100
		WorkingProgress._progressText		:SetText(string.format("%3.1f%%", complete  ));
		WorkingProgress._progressGauge		:SetProgressRate(complete);
		WorkingProgress._itemicon			:ChangeTextureInfoName("icon/" .. WorkingProgress._saveIcon);	
		WorkingProgress._txt_WorkName		:SetText();	
		WorkingProgress._remainTimeText		:SetText( "--" );
		return
	elseif ( 0 == workingcnt) and ( 0 == WorkingProgress._saveProgress) then
		if ( 10 < WorkingProgress._updateCount ) then
			WorldMapWindow_CloseNodeMenu()
		end		
		return
	elseif ( 5 > WorkingProgress._updateCount ) then  -- 초기 workingcnt 가 쓰레기 값으로 1이 들어간 경우를 걸러낸다.
		return
	end
	
	for idx = 0 , workingcnt - 1 , 1 do
		local worker = getWorkingByIndex( idx ).workerNo
		local workerNo = worker:get_s64()
		-- local staticStatusWrapper = getItemEnchantStaticStatus( staticStatusKey._key )
		
		WorkingProgress._workingProgress = getWorkingProgress( workerNo ) * 100000	 	-- 작업 시작 시 받는 getWorkingProgress() 값은 항상 쓰레기 값이 온다! (Fix가 필요함!)
		WorkingProgress._remainTime = Util.Time.timeFormatting( ToClient_getWorkingTime( workerNo ) )

		WorkingProgress._progressText		:SetText(string.format("%3.1f%%", WorkingProgress._workingProgress  ) )
		WorkingProgress._progressGauge		:SetProgressRate(WorkingProgress._workingProgress)
		WorkingProgress._remainTimeText		:SetText( WorkingProgress._remainTime )
				
		WorkingProgress._saveProgress = WorkingProgress._workingProgress			
	end	
end

function Plant_Tooltip_Item_Show()
	local itemKey = WorkingProgress._itemKey_Tooltip
	if itemKey == nil then
		return
	end
	local staticStatusWrapper = getItemEnchantStaticStatus( itemKey )
	local uiBase = WorkingProgress._itemicon_BG
	Panel_Tooltip_Item_Show(staticStatusWrapper, uiBase, true, false)
end

function Craft_Show_Tooltip_Work(idx)
	if isKeyPressed( VCK.KeyCode_CONTROL ) then
		Keep_Tooltip_Work = true
		return
	end
	local workIndex = idx
	local uiBase = WorkingProgress._itemicon_BG
	FGlobal_Show_Tooltip_Work(workIndex, uiBase)
end

function Craft_Hide_Tooltip_Work(idx)
	if isKeyPressed( VCK.KeyCode_CONTROL ) then
		return
	end
	FGlobal_Hide_Tooltip_Work(idx, false)
end


function WorkingProgress_CancelWork()
	local isSuccess = requestStopPlantWorking(WorkingProgress._worker)
	if ( false == isSuccess ) then
	    Proc_ShowMessage_Ack( PAGetString(Defines.StringSheet_GAME, "Lua_RentHouseNoWorkingByWorkerNotSelect") )
	end
end
	    
function WorkingProgress_After_CancelWork(workerNo, isUserRequest)
	if WorkingProgress._workerNo ~= workerNo or false == isUserRequest or false == Panel_Working_Progress:GetShow() then
		return
	end
	
	local key = WorkingProgress._nodekey
	local workType = WorkingProgress._workType

	HideWorkingProgress()
	if workType == eWorkType.plant then	-- 취소한 일꾼은 리스트에 표시가 안된다. (Refresh 하는 Event가 필요하다!)
		local exploreLevel	= WorldMapWindow.nodeDataList[key]:getLevel()
		local plantKey	= WorldMapWindow.nodeDataList[key]:getPlantKey()
		local plant		= getPlant(plantKey)
		local PlantType = CppEnums.PlantType
		if exploreLevel > 0 and plant ~= nil and plant:getType() == PlantType.ePlantType_Zone then
			WorldMapWindow_WorkManage_Open()		
		end
	elseif workType == eWorkType.craft then
		WorldMapWindow.popupManager:pop()
		WorldMapWindow_OnHouseholdClick(key, true)	
		handleClickedHouseControlDoWorkHouse()
	end
end

function ShowWorkingProgress(infoNodeKey, workType)
		
	if ( 0 == infoNodeKey ) then
		return
	end
	
	Panel_Working_Progress:SetShow(true,false)
	
	WorkingProgress._nodekey = infoNodeKey
	WorkingProgress._workingProgress = 0
	WorkingProgress._saveProgress = 0	
	WorkingProgress._updateCount = 0	
	WorkingProgress._workType = workType	

	if WorkingProgress._workType == eWorkType.plant or WorkingProgress._workType == eWorkType.craft then
		WorkingProgress._btnCancelWork:SetShow(true)
	elseif WorkingProgress._workType == eWorkType.changeHouseUseType then
		WorkingProgress._btnCancelWork:SetShow(false)
	end
	
	isFale_Init = false
	
	WorkingProgress_Init()
	WorkingProgressUpdate()
end

function HideWorkingProgress()
	Panel_Working_Progress					:SetShow(false)
	WorkingProgress._workType = nil
	WorkingProgress._itemKey_Tooltip = nil
	WorkingProgress._nodekey = 0
	WorkingProgress._saveProgress = 0
	WorkingProgress._updateCount = 0
	isFale_Init = false
end

WorkingProgress._btnClose		:addInputEvent("Mouse_LUp","WorldMapWindow_CloseNodeMenu()");
WorkingProgress._btnCancelWork	:addInputEvent("Mouse_LUp","WorkingProgress_CancelWork()");
Panel_Working_Progress			:RegisterUpdateFunc("WorkingProgressUpdate")
registerEvent("WorldMap_StopWorkerWorking",			"WorkingProgress_After_CancelWork")