local IM 			= CppEnums.EProcessorInputMode
local UI_ANI_ADV 	= CppEnums.PAUI_ANIM_ADVANCE_TYPE
local ENT 			= CppEnums.ExplorationNodeType
local UI_color 		= Defines.Color
local UI_TYPE		= CppEnums.PA_UI_CONTROL_TYPE
local UI_TM 		= CppEnums.TextMode
local VCK 			= CppEnums.VirtualKeyCode

local _Util_Math = Util.Math

local _worldMap_KeyGuide = UI.getChildControl ( Panel_Win_Worldmap, "StaticText_KeyGuide" )
local worldMap_GuideUI = {
	-- _txt_Title 			= UI.getChildControl ( Panel_Win_Worldmap, "StaticText_CheckTitle" ),
	_btn_Quest 					= UI.getChildControl ( Panel_Win_Worldmap, "CheckButton_Quest" ),
	_btn_Knowledge 				= UI.getChildControl ( Panel_Win_Worldmap, "CheckButton_Knowledge" ),
	_btn_Fishes 				= UI.getChildControl ( Panel_Win_Worldmap, "CheckButton_Fishnchip" ),
	_btn_Node 					= UI.getChildControl ( Panel_Win_Worldmap, "CheckButton_Node" ),
	_btn_WayGuide 				= UI.getChildControl ( Panel_Win_Worldmap, "CheckButton_WayGuide" ),
	_btn_Position 				= UI.getChildControl ( Panel_Win_Worldmap, "CheckButton_Positions" ),
	_ExplorePoint 				= UI.getChildControl ( Panel_Win_Worldmap, "StaticText_info_ExplorePoint" ),
	_Progress_ExplorePointBG	= UI.getChildControl ( Panel_Win_Worldmap, "Static_ExplorePoint_BG" ),
	_Progress_ExplorePoint		= UI.getChildControl ( Panel_Win_Worldmap, "Progress_ExplorePoint" ),
}

local _math_sqrt = math.sqrt
local _math_sqrt_x2_y2 = function( x, y )
	return _math_sqrt( x * x + y * y )
end

if nil == WorldMapWindow then
	WorldMapWindow = {};
end
-- WorldMapWindow._OnDrag_L = false

WorldMapWindow.RenderType = {
	WMS_GLOBAL					= 0,
	WMS_EXPLORE_PLANT			= 1,
	WMS_REGION					= 2,
	WMS_LOCATION_INFO_WATER		= 3,
	WMS_LOCATION_INFO_CELCIUS	= 4,
	WMS_LOCATION_INFO_HUMILITY	= 5,
}


WorldMapWindow.EnumInfoNodeKeyType = {
	eInfoNodeKeyType_Waypoint 			= 0;
	eInfoNodeKeyType_HouseListIdx		= 1;
	eInfoNodeKeyType_Region				= 2;
	eInfoNodeKeyType_FixedHouseListIdx 	= 3;
};

function WorldMapWindow_ClearNode()
	WorldMapWindow.nodeDataList = {};
end

function WorldMapWindow_DeleteNode( plantKey )
	WorldMapWindow.nodeDataList[plantKey] = nil
end

function WorldMapWindow_Update_ExplorePoint()
	-- local currentExplorePoint = ToClient_RequestGetMyExploredPoint()
	local territoryKeyRaw 			= getDefaultTerritoryKey()
	local explorePoint				= getExplorePointByTerritoryRaw( territoryKeyRaw )
	if (nil == explorePoint) then
		worldMap_GuideUI._ExplorePoint:SetText("")
		worldMap_GuideUI._Progress_ExplorePoint:SetProgressRate(0)
		return
	end

	local nowExplorePoint = explorePoint:getRemainedPoint()
	local maxExplorePoint = explorePoint:getAquiredPoint()
	local explorePointPercent = nowExplorePoint / maxExplorePoint * 100

	worldMap_GuideUI._ExplorePoint:SetText( PAGetString( Defines.StringSheet_GAME, "MAINSTATUS_CONTRIBUTE" ) .. " " .. nowExplorePoint .. " / " .. maxExplorePoint )
	worldMap_GuideUI._Progress_ExplorePoint:SetProgressRate( explorePointPercent )
end
------------------------------------------------------------------------
--				descBG의 하단 위치를 알기위한 함수
------------------------------------------------------------------------
local posYgap = 0
local getBottom = 0

local GetBottomPos = function(control)
	if ( nil == control ) then
		UI.ASSERT(false, "GetBottomPos(control) , control nil")
		return
	end
	return control:GetPosY() + control:GetSizeY()
end
---
local _initFilter = false
---

local init = function()
	local scrX = getScreenSizeX()
	local scrY = getScreenSizeY()
	
	WorldMapWindow.PanelUIAlways = UI.getChildControl( Panel_Win_Worldmap, "Static_3DMap");
	WorldMapWindow.uiList = {}
	WorldMapWindow.uiList[WorldMapWindow.RenderType.WMS_GLOBAL]					= UI.getChildControl( Panel_Win_Worldmap, "Static_3DMap_UI_Global") 
	WorldMapWindow.uiList[WorldMapWindow.RenderType.WMS_EXPLORE_PLANT]			= UI.getChildControl( Panel_Win_Worldmap, "Static_3DMap_UI_Explore") 
	WorldMapWindow.uiList[WorldMapWindow.RenderType.WMS_REGION] 				= UI.getChildControl( Panel_Win_Worldmap, "Static_3DMap_UI_Region") 
	WorldMapWindow.uiList[WorldMapWindow.RenderType.WMS_LOCATION_INFO_WATER] 	= UI.getChildControl( Panel_Win_Worldmap, "Static_3DMap_UI_Water") 
	WorldMapWindow.uiList[WorldMapWindow.RenderType.WMS_LOCATION_INFO_CELCIUS] 	= UI.getChildControl( Panel_Win_Worldmap, "Static_3DMap_UI_Celcius") 
	WorldMapWindow.uiList[WorldMapWindow.RenderType.WMS_LOCATION_INFO_HUMILITY] = UI.getChildControl( Panel_Win_Worldmap, "Static_3DMap_UI_Humidity") 

	WorldMapWindow_ClearNode()
	WorldMapWindow.regionDataList = {}

	-- DetailMode 에서는 Actor 들이 나오고, Node 들은 사라진다!
	WorldMapWindow.ViewDetailMode = false
	WorldMapWindow.ViewDetailModeNodeAlpha = 0.0	-- ActorIcon 의 Alpha 는 (1 - ViewDetailModeNodeAlpha)
	WorldMapWindow.ViewDetailModeNodeShow = true
	WorldMapWindow.ViewDetailModeIconShow = false

	WorldMapWindow.isFullScreen = true;
	WorldMapWindow.posX = 0;
	WorldMapWindow.posY = 0;
	WorldMapWindow.sizeX = 823;
	WorldMapWindow.sizeY = 580;
	WorldMapWindow.alpha = 0.5;

	WorldMapWindow.EnableNodeKey = nil;


	WorldMapWindow.infoNodeKeyType = WorldMapWindow.EnumInfoNodeKeyType.eInfoNodeKeyType_Waypoint;
	WorldMapWindow.infoMenuDuplicator = 0;
	WorldMapWindow.currentSubPanel = nil;
	WorldMapWindow.currentSubPanelShadow = UI.createControl( UI_TYPE.PA_UI_CONTROL_STATIC, WorldMapWindow.PanelUIAlways, "Static_SubPanelShadow" );
	WorldMapWindow.currentSubPanelShadow:ChangeTextureInfoName("new_ui_common_forlua/default/window_sample_blackPanel.dds");
	WorldMapWindow.currentSubPanelShadow:SetMonoTone(true);
	WorldMapWindow.currentSubPanelShadow:SetShow(false);

	WorldMapWindow.openPosition = float3(0,0,0);

	Panel_Win_Worldmap:SetShow(false, false);
	Panel_Win_Worldmap:setFlushAble(false)
	Panel_Win_Worldmap:setMaskingChild(true)
	Panel_Win_Worldmap:ActiveMouseEventEffect( false )
	Panel_Win_Worldmap:setGlassBackground(true)

	-- Panel_Win_Worldmap:TEMP_UseUpdateListSwap(true);

	WorldMapWindow.world3DMapStatic		= UI.getChildControl( Panel_Win_Worldmap, "Static_3DMap" );
	WorldMapWindow.world3DMapStatic:SetTexturePreload(true);
	-- WorldMapWindow.world3DMapStatic:SetIgnore(true);
	WorldMapWindow.world3DMapStatic:ActiveMouseEventEffect( false );
	WorldMapWindow.world3DMapStatic:addInputEvent("Mouse_LDown",		"WorldMapWindow_OnPressStart()");
	WorldMapWindow.world3DMapStatic:addInputEvent("Mouse_LDClick",		"WorldMapWindow_OnPressStartDClick()");
	WorldMapWindow.world3DMapStatic:addInputEvent("Mouse_LUp",			"WorldMapWindow_OnPressEnd_Default()");
	WorldMapWindow.world3DMapStatic:addInputEvent("Mouse_RDown",		"WorldMapWindow_OnRPressStart()");
	WorldMapWindow.world3DMapStatic:addInputEvent("Mouse_RUp",			"WorldMapWindow_OnRPressEnd()");
	WorldMapWindow.world3DMapStatic:addInputEvent("Mouse_LPress",		"WorldMapWindow_OnCameraMove()");
	WorldMapWindow.world3DMapStatic:addInputEvent("Mouse_RPress",		"WorldMapWindow_OnCameraRotate()");
	WorldMapWindow.world3DMapStatic:addInputEvent("Mouse_UpScroll",		"WorldMapWindow_OnUpScroll()");
	WorldMapWindow.world3DMapStatic:addInputEvent("Mouse_DownScroll",	"WorldMapWindow_OnDownScroll()");
	WorldMapWindow.world3DMapStatic:SetDepth(100.0);

	WorldMapWindow.resizeButton			= UI.getChildControl( Panel_Win_Worldmap, "Button_Resize" );
	-- WorldMapWindow.resizeButton:ActiveMouseEventEffect( true );
	-- WorldMapWindow.resizeButton:addInputEvent("Mouse_LPress",	"WorldMapWindow_OnResizeDrag()");
	WorldMapWindow.resizeButton:SetShow(false)

	-- 전체화면
	WorldMapWindow.fullScreenButton		= UI.getChildControl( Panel_Win_Worldmap, "Button_Switch_Window" );
	-- WorldMapWindow.fullScreenButton:ActiveMouseEventEffect( true );
	-- WorldMapWindow.fullScreenButton:addInputEvent("Mouse_LUp",	"WorldMapWindow_OnFullScreenToggle()");
	WorldMapWindow.fullScreenButton:SetShow(false)

	-- 지도 표시 Check Panel
	local sizeY = ( worldMap_GuideUI._btn_Quest:GetSizeY() + 10 )
	local sizeX = 10
	WorldMapWindow._guideCheck_BG = UI.getChildControl ( Panel_Win_Worldmap, "Static_GuideBG" )	
	
	worldMap_GuideUI._btn_Quest    :SetEnableArea( 0, 0, worldMap_GuideUI._btn_Quest:GetSizeX() + worldMap_GuideUI._btn_Quest:GetTextSizeX() + 15 , 23 )
	worldMap_GuideUI._btn_Quest    :SetSpanSize( sizeX , 5 )	
	sizeX = sizeX + worldMap_GuideUI._btn_Quest:GetSizeX() + worldMap_GuideUI._btn_Quest:GetTextSizeX() + 30
	
	worldMap_GuideUI._btn_Knowledge:SetEnableArea( 0, 0, worldMap_GuideUI._btn_Knowledge:GetSizeX() + worldMap_GuideUI._btn_Knowledge:GetTextSizeX() + 15, 23 )
	worldMap_GuideUI._btn_Knowledge:SetSpanSize( sizeX , 5)
	sizeX = sizeX + worldMap_GuideUI._btn_Knowledge:GetSizeX() + worldMap_GuideUI._btn_Knowledge:GetTextSizeX() + 30
	
	worldMap_GuideUI._btn_Fishes   :SetEnableArea( 0, 0, worldMap_GuideUI._btn_Fishes:GetSizeX() + worldMap_GuideUI._btn_Fishes:GetTextSizeX() + 15, 23 )
	worldMap_GuideUI._btn_Fishes   :SetSpanSize( sizeX , 5)
	sizeX = sizeX + worldMap_GuideUI._btn_Fishes:GetSizeX() + worldMap_GuideUI._btn_Fishes:GetTextSizeX() + 30
	
	worldMap_GuideUI._btn_Node     :SetEnableArea( 0, 0, worldMap_GuideUI._btn_Node:GetSizeX() + worldMap_GuideUI._btn_Node:GetTextSizeX() + 15, 23 )
	worldMap_GuideUI._btn_Node     :SetSpanSize( sizeX , 5)
	sizeX = sizeX + worldMap_GuideUI._btn_Node:GetSizeX() + worldMap_GuideUI._btn_Node:GetTextSizeX() + 30
	
	worldMap_GuideUI._btn_WayGuide :SetEnableArea( 0, 0, worldMap_GuideUI._btn_WayGuide:GetSizeX() + worldMap_GuideUI._btn_WayGuide:GetTextSizeX() + 15, 23 )
	worldMap_GuideUI._btn_WayGuide :SetSpanSize( sizeX , 5)
	sizeX = sizeX + worldMap_GuideUI._btn_WayGuide:GetSizeX() + worldMap_GuideUI._btn_WayGuide:GetTextSizeX() + 30
	
	worldMap_GuideUI._btn_Position :SetEnableArea( 0, 0, worldMap_GuideUI._btn_Position:GetSizeX() + worldMap_GuideUI._btn_Position:GetTextSizeX() + 15, 23 )
	worldMap_GuideUI._btn_Position :SetSpanSize( sizeX , 5)		
	sizeX = sizeX + worldMap_GuideUI._btn_Position:GetSizeX() + worldMap_GuideUI._btn_Position:GetTextSizeX() + 35

	worldMap_GuideUI._ExplorePoint:SetSpanSize( sizeX , 8)
	worldMap_GuideUI._Progress_ExplorePointBG:SetSpanSize( worldMap_GuideUI._ExplorePoint:GetPosX() + worldMap_GuideUI._ExplorePoint:GetTextSizeX() , 13)
	worldMap_GuideUI._Progress_ExplorePoint:SetSpanSize( worldMap_GuideUI._ExplorePoint:GetPosX() + worldMap_GuideUI._ExplorePoint:GetTextSizeX() + 1 , 15)
	sizeX = sizeX + worldMap_GuideUI._ExplorePoint:GetSizeX() + worldMap_GuideUI._ExplorePoint:GetTextSizeX() + 25

	-- WorldMapWindow._guideCheck_BG:AddChild( worldMap_GuideUI._txt_Title     )
	WorldMapWindow._guideCheck_BG:AddChild( worldMap_GuideUI._btn_Quest     )
	WorldMapWindow._guideCheck_BG:AddChild( worldMap_GuideUI._btn_Knowledge )
	WorldMapWindow._guideCheck_BG:AddChild( worldMap_GuideUI._btn_Fishes 	)
	WorldMapWindow._guideCheck_BG:AddChild( worldMap_GuideUI._btn_Node      )
	WorldMapWindow._guideCheck_BG:AddChild( worldMap_GuideUI._btn_WayGuide  )
	WorldMapWindow._guideCheck_BG:AddChild( worldMap_GuideUI._btn_Position  )
	WorldMapWindow._guideCheck_BG:AddChild( worldMap_GuideUI._ExplorePoint  )
	WorldMapWindow._guideCheck_BG:AddChild( worldMap_GuideUI._Progress_ExplorePointBG  )
	WorldMapWindow._guideCheck_BG:AddChild( worldMap_GuideUI._Progress_ExplorePoint  )
	
	-- 나중에 이부분은 저장이 되어 상태복구가 이루어져야함 - 대일
	
	if( _initFilter == false ) then	
		worldMap_GuideUI._btn_Quest:SetCheck( true )	
		worldMap_GuideUI._btn_Knowledge:SetCheck( true )	
		worldMap_GuideUI._btn_Fishes:SetCheck( true )	
		worldMap_GuideUI._btn_Node:SetCheck( true )	
		worldMap_GuideUI._btn_WayGuide:SetCheck( true )	
		worldMap_GuideUI._btn_Position:SetCheck( true )		
		
		WorldMapWindow._btn_Quest_Check = true
		WorldMapWindow._btn_Knowledge_Check = true
		WorldMapWindow._btn_Fishes_Check = true
		WorldMapWindow._btn_Node_Check = true
		WorldMapWindow._btn_WayGuide_Check = true
		WorldMapWindow._btn_Position_Check = true
		
		_initFilter = true
	else
		worldMap_GuideUI._btn_Quest:SetCheck( WorldMapWindow._btn_Quest_Check )	
		worldMap_GuideUI._btn_Knowledge:SetCheck( WorldMapWindow._btn_Knowledge_Check )	
		worldMap_GuideUI._btn_Fishes:SetCheck( WorldMapWindow._btn_Fishes_Check )	
		worldMap_GuideUI._btn_Node:SetCheck( WorldMapWindow._btn_Node_Check )	
		worldMap_GuideUI._btn_WayGuide:SetCheck( WorldMapWindow._btn_WayGuide_Check )	
		worldMap_GuideUI._btn_Position:SetCheck( WorldMapWindow._btn_Position_Check )				
	end
	
	
	worldMap_GuideUI._btn_Quest:addInputEvent("Mouse_LUp", "Panel_Worldmap_Filter_ShowToggle(0)" )
	worldMap_GuideUI._btn_Knowledge:addInputEvent("Mouse_LUp", "Panel_Worldmap_Filter_ShowToggle(1)" )
	worldMap_GuideUI._btn_Fishes:addInputEvent("Mouse_LUp", "Panel_Worldmap_Filter_ShowToggle(2)" )
	worldMap_GuideUI._btn_Node:addInputEvent("Mouse_LUp", "Panel_Worldmap_Filter_ShowToggle(3)" )
	worldMap_GuideUI._btn_WayGuide:addInputEvent("Mouse_LUp", "Panel_Worldmap_Filter_ShowToggle(4)" )
	worldMap_GuideUI._btn_Position:addInputEvent("Mouse_LUp", "Panel_Worldmap_Filter_ShowToggle(5)" )
	
	--WorldMapWindow._guideCheck_BG:SetCheck( true )
	
	-- Panel_Win_Worldmap:RemoveControl( worldMap_GuideUI._txt_Title     )
	Panel_Win_Worldmap:RemoveControl( worldMap_GuideUI._btn_Quest     )
	Panel_Win_Worldmap:RemoveControl( worldMap_GuideUI._btn_Knowledge )
	Panel_Win_Worldmap:RemoveControl( worldMap_GuideUI._btn_Fishes	  )
	Panel_Win_Worldmap:RemoveControl( worldMap_GuideUI._btn_Node      )
	Panel_Win_Worldmap:RemoveControl( worldMap_GuideUI._btn_WayGuide  )
	Panel_Win_Worldmap:RemoveControl( worldMap_GuideUI._btn_Position  )
	Panel_Win_Worldmap:RemoveControl( worldMap_GuideUI._ExplorePoint  )
	Panel_Win_Worldmap:RemoveControl( worldMap_GuideUI._Progress_ExplorePointBG  )
	Panel_Win_Worldmap:RemoveControl( worldMap_GuideUI._Progress_ExplorePoint  )

	
	WorldMapWindow._guideCheck_BG:SetSize( worldMap_GuideUI._Progress_ExplorePoint:GetSizeX() + worldMap_GuideUI._Progress_ExplorePoint:GetPosX() + 15, sizeY )
	WorldMapWindow._guideCheck_BG:SetSpanSize( 7, 5 )
	WorldMapWindow._guideCheck_BG:SetShow( true )
		
	-- worldMap_GuideUI._txt_Title    :SetSpanSize( 0 , 10 )
	
	WorldMapWindow.renderingAlpha = 0


	--지도모드 바꾸는 Control 셋팅
	------------------------------------------------------------------------------------------
	--								왼쪽 상단 메뉴판들 
	------------------------------------------------------------------------------------------
	WorldMapWindow.menuBubbleHelp_0		= UI.getChildControl( Panel_Win_Worldmap, "StaticText_MenuHelp_0" )
	WorldMapWindow.menuBubbleHelp_1		= UI.getChildControl( Panel_Win_Worldmap, "StaticText_MenuHelp_1" )
	WorldMapWindow.menuBubbleHelp_2		= UI.getChildControl( Panel_Win_Worldmap, "StaticText_MenuHelp_2" )
	WorldMapWindow.menuBubbleHelp_3		= UI.getChildControl( Panel_Win_Worldmap, "StaticText_MenuHelp_3" )
	WorldMapWindow.menuBubbleHelp_4		= UI.getChildControl( Panel_Win_Worldmap, "StaticText_MenuHelp_4" )
	
	--------------------------------------------
	--				메뉴판들
	WorldMapWindow._panel_Information	= UI.getChildControl( Panel_Win_Worldmap, "Static_InformationBG" )
	WorldMapWindow._panel_Information	:SetSpanSize( 135, WorldMapWindow._guideCheck_BG:GetPosY() + WorldMapWindow._guideCheck_BG:GetSizeY() + 5 )
	
	WorldMapWindow._infoDesc_Title		= UI.getChildControl( Panel_Win_Worldmap, "StaticText_InfoDesc_Title" )	
	WorldMapWindow._infoDesc_Title		:SetSpanSize(0, 30)
	WorldMapWindow._infoDesc_BG			= UI.getChildControl( Panel_Win_Worldmap, "Static_InfoDesc_BG" )
	WorldMapWindow._infoDesc_BG			:SetSpanSize(7, 36)
	WorldMapWindow._infoDesc			= UI.getChildControl( Panel_Win_Worldmap, "StaticText_InfoDesc" )
	WorldMapWindow._infoDesc			:SetSpanSize(14, 39)
	
	WorldMapWindow._landInfo_Graph_0	= UI.getChildControl( Panel_Win_Worldmap, "Static_Graph_0" )
	WorldMapWindow._landInfo_Graph_0	:SetSpanSize(15, 90)
	WorldMapWindow._landInfo_Graph_1	= UI.getChildControl( Panel_Win_Worldmap, "Static_Graph_1" )
	WorldMapWindow._landInfo_Graph_1	:SetSpanSize(15, 90)
	WorldMapWindow._landInfo_Graph_2	= UI.getChildControl( Panel_Win_Worldmap, "Static_Graph_2" )
	WorldMapWindow._landInfo_Graph_2	:SetSpanSize(15, 90)
	
	WorldMapWindow._gaugeWater			= UI.getChildControl( Panel_Win_Worldmap, "Static_Gauge_Water" )
	WorldMapWindow._gaugeWater			:SetSpanSize(35, 90)
	WorldMapWindow._gaugeTemper			= UI.getChildControl( Panel_Win_Worldmap, "Static_Gauge_Temperature" )
	WorldMapWindow._gaugeTemper			:SetSpanSize(35, 90)
	WorldMapWindow._gague_Humidity		= UI.getChildControl( Panel_Win_Worldmap, "Static_Gauge_Humidity" )
	WorldMapWindow._gague_Humidity		:SetSpanSize(35, 90)
	
	WorldMapWindow._txt_Low				= UI.getChildControl( Panel_Win_Worldmap, "StaticText_Low" )
	WorldMapWindow._txt_Low				:SetSpanSize(10, 98)
	WorldMapWindow._txt_High			= UI.getChildControl( Panel_Win_Worldmap, "StaticText_High" )
	WorldMapWindow._txt_High			:SetSpanSize(140, 98)
	
	WorldMapWindow._nod_City 			= UI.getChildControl( Panel_Win_Worldmap, "StaticText_Info_Node_City" )
	WorldMapWindow._nod_City 			:SetSpanSize(12, 0)
	WorldMapWindow._nod_Village			= UI.getChildControl( Panel_Win_Worldmap, "StaticText_Info_Node_Village" )
	WorldMapWindow._nod_Village			:SetSpanSize(100, 0)
	WorldMapWindow._nod_Gate			= UI.getChildControl( Panel_Win_Worldmap, "StaticText_Info_Node_Gate" )
	WorldMapWindow._nod_Gate			:SetSpanSize(12, 24)
	WorldMapWindow._nod_Trade			= UI.getChildControl( Panel_Win_Worldmap, "StaticText_Info_Node_Trade" )
	WorldMapWindow._nod_Trade			:SetSpanSize(100, 24)
	WorldMapWindow._nod_Dangerous		= UI.getChildControl( Panel_Win_Worldmap, "StaticText_Info_Node_Dangerous" )
	WorldMapWindow._nod_Dangerous		:SetSpanSize(12, 48)
	WorldMapWindow._nod_Empty			= UI.getChildControl( Panel_Win_Worldmap, "StaticText_Info_Node_Empty" )
	WorldMapWindow._nod_Empty			:SetSpanSize(100, 48)
	
	-- WorldMapWindow._ExplorePoint		= UI.getChildControl( Panel_Win_Worldmap, "StaticText_info_ExplorePoint" )
	-- WorldMapWindow._ExplorePoint		:SetSpanSize(15, 77)
	
	WorldMapWindow._panel_Information:AddChild( WorldMapWindow._infoDesc_Title )
	WorldMapWindow._panel_Information:AddChild( WorldMapWindow._infoDesc_BG )
	WorldMapWindow._panel_Information:AddChild( WorldMapWindow._infoDesc )
	WorldMapWindow._panel_Information:AddChild( WorldMapWindow._landInfo_Graph_0 )
	WorldMapWindow._panel_Information:AddChild( WorldMapWindow._landInfo_Graph_1 )
	WorldMapWindow._panel_Information:AddChild( WorldMapWindow._landInfo_Graph_2 )
	WorldMapWindow._panel_Information:AddChild( WorldMapWindow._gaugeWater )
	WorldMapWindow._panel_Information:AddChild( WorldMapWindow._gaugeTemper )
	WorldMapWindow._panel_Information:AddChild( WorldMapWindow._gague_Humidity )
	WorldMapWindow._panel_Information:AddChild( WorldMapWindow._txt_Low )
	WorldMapWindow._panel_Information:AddChild( WorldMapWindow._txt_High )
	WorldMapWindow._panel_Information:AddChild( WorldMapWindow._nod_City )
	WorldMapWindow._panel_Information:AddChild( WorldMapWindow._nod_Village )
	WorldMapWindow._panel_Information:AddChild( WorldMapWindow._nod_Gate )
	WorldMapWindow._panel_Information:AddChild( WorldMapWindow._nod_Trade )
	WorldMapWindow._panel_Information:AddChild( WorldMapWindow._nod_Dangerous )
	WorldMapWindow._panel_Information:AddChild( WorldMapWindow._nod_Empty )
	-- WorldMapWindow._panel_Information:AddChild( WorldMapWindow._ExplorePoint )

	Panel_Win_Worldmap:RemoveControl( WorldMapWindow._infoDesc_Title )
	Panel_Win_Worldmap:RemoveControl( WorldMapWindow._infoDesc_BG )
	Panel_Win_Worldmap:RemoveControl( WorldMapWindow._infoDesc )
	Panel_Win_Worldmap:RemoveControl( WorldMapWindow._landInfo_Graph_0 )
	Panel_Win_Worldmap:RemoveControl( WorldMapWindow._landInfo_Graph_1 )
	Panel_Win_Worldmap:RemoveControl( WorldMapWindow._landInfo_Graph_2 )
	Panel_Win_Worldmap:RemoveControl( WorldMapWindow._gaugeWater )
	Panel_Win_Worldmap:RemoveControl( WorldMapWindow._gaugeTemper )
	Panel_Win_Worldmap:RemoveControl( WorldMapWindow._gague_Humidity )
	Panel_Win_Worldmap:RemoveControl( WorldMapWindow._txt_Low )
	Panel_Win_Worldmap:RemoveControl( WorldMapWindow._txt_High )
	Panel_Win_Worldmap:RemoveControl( WorldMapWindow._nod_City )
	Panel_Win_Worldmap:RemoveControl( WorldMapWindow._nod_Village )
	Panel_Win_Worldmap:RemoveControl( WorldMapWindow._nod_Gate )
	Panel_Win_Worldmap:RemoveControl( WorldMapWindow._nod_Trade )
	Panel_Win_Worldmap:RemoveControl( WorldMapWindow._nod_Dangerous )
	Panel_Win_Worldmap:RemoveControl( WorldMapWindow._nod_Empty )
	-- Panel_Win_Worldmap:RemoveControl( WorldMapWindow._ExplorePoint )
	
	--------------------------------------------
	--				메뉴 버튼들
	
	-- Close 버튼
	WorldMapWindow.buttonBG				= UI.getChildControl( Panel_Win_Worldmap, "Static_ButtonBG" )
	WorldMapWindow.buttonBG				:SetSpanSize( 7, WorldMapWindow._guideCheck_BG:GetPosY() + WorldMapWindow._guideCheck_BG:GetSizeY() + 5 )
	
	WorldMapWindow.closeButton			= UI.getChildControl( Panel_Win_Worldmap, "Button_Exit" )
	WorldMapWindow.closeButton			:ActiveMouseEventEffect( true )
	WorldMapWindow.closeButton			:addInputEvent("Mouse_LUp",	"WorldMapWindow_OnClose()")
	
	WorldMapWindow.uichange_default		= UI.getChildControl( Panel_Win_Worldmap, "Static_3DMap_UIMode_Change_default" )
	WorldMapWindow.uichange_default		:addInputEvent("Mouse_LUp",	"Panel_Win_Worldmap_StateChange(WorldMapWindow.RenderType.WMS_EXPLORE_PLANT)")
	WorldMapWindow.uichange_default		:addInputEvent("Mouse_On",	"Panel_Worldmap_Tooltip_ShowToggle( 0, true )")
	WorldMapWindow.uichange_default		:addInputEvent("Mouse_Out",	"Panel_Worldmap_Tooltip_ShowToggle( 0, false )")
	
	WorldMapWindow.uichange_noUI		= UI.getChildControl( Panel_Win_Worldmap, "Static_3DMap_UIMode_Change_NoUI" )
	WorldMapWindow.uichange_noUI		:addInputEvent("Mouse_LUp",	"Panel_Win_Worldmap_StateChange(WorldMapWindow.RenderType.WMS_REGION)")
	WorldMapWindow.uichange_noUI		:addInputEvent("Mouse_On",	"Panel_Worldmap_Tooltip_ShowToggle( 1, true )")
	WorldMapWindow.uichange_noUI		:addInputEvent("Mouse_Out",	"Panel_Worldmap_Tooltip_ShowToggle( 1, false )")
	
	WorldMapWindow.uichange_water		= UI.getChildControl( Panel_Win_Worldmap, "Static_3DMap_UIMode_Change_Water" )
	WorldMapWindow.uichange_water		:addInputEvent("Mouse_LUp",	"Panel_Win_Worldmap_StateChange(WorldMapWindow.RenderType.WMS_LOCATION_INFO_WATER)")
	WorldMapWindow.uichange_water		:addInputEvent("Mouse_On",	"Panel_Worldmap_Tooltip_ShowToggle( 2, true )")
	WorldMapWindow.uichange_water		:addInputEvent("Mouse_Out",	"Panel_Worldmap_Tooltip_ShowToggle( 2, false )")
	
	WorldMapWindow.uichange_celius		= UI.getChildControl( Panel_Win_Worldmap, "Static_3DMap_UIMode_Change_Celcius" )
	WorldMapWindow.uichange_celius		:addInputEvent("Mouse_LUp",	"Panel_Win_Worldmap_StateChange(WorldMapWindow.RenderType.WMS_LOCATION_INFO_CELCIUS)")
	WorldMapWindow.uichange_celius		:addInputEvent("Mouse_On",	"Panel_Worldmap_Tooltip_ShowToggle( 3, true )")
	WorldMapWindow.uichange_celius		:addInputEvent("Mouse_Out",	"Panel_Worldmap_Tooltip_ShowToggle( 3, false )")
	
	WorldMapWindow.uichange_humility	= UI.getChildControl( Panel_Win_Worldmap, "Static_3DMap_UIMode_Change_Humility" )
	WorldMapWindow.uichange_humility	:addInputEvent("Mouse_LUp",	"Panel_Win_Worldmap_StateChange(WorldMapWindow.RenderType.WMS_LOCATION_INFO_HUMILITY)")
	WorldMapWindow.uichange_humility	:addInputEvent("Mouse_On",	"Panel_Worldmap_Tooltip_ShowToggle( 4, true )")
	WorldMapWindow.uichange_humility	:addInputEvent("Mouse_Out",	"Panel_Worldmap_Tooltip_ShowToggle( 4, false )")
	
	WorldMapWindow.uichange_title		= UI.getChildControl( Panel_Win_Worldmap, "StaticText_Title" )
	
	WorldMapWindow.buttonBG:AddChild( WorldMapWindow.uichange_title )
	WorldMapWindow.buttonBG:AddChild( WorldMapWindow.uichange_default )
	WorldMapWindow.buttonBG:AddChild( WorldMapWindow.uichange_noUI )
	WorldMapWindow.buttonBG:AddChild( WorldMapWindow.uichange_water )
	WorldMapWindow.buttonBG:AddChild( WorldMapWindow.uichange_celius )
	WorldMapWindow.buttonBG:AddChild( WorldMapWindow.uichange_humility )
	WorldMapWindow.buttonBG:AddChild( WorldMapWindow.closeButton )

	Panel_Win_Worldmap:RemoveControl( WorldMapWindow.uichange_title )
	Panel_Win_Worldmap:RemoveControl( WorldMapWindow.uichange_default )
	Panel_Win_Worldmap:RemoveControl( WorldMapWindow.uichange_noUI )
	Panel_Win_Worldmap:RemoveControl( WorldMapWindow.uichange_water )
	Panel_Win_Worldmap:RemoveControl( WorldMapWindow.uichange_celius )
	Panel_Win_Worldmap:RemoveControl( WorldMapWindow.uichange_humility )
	Panel_Win_Worldmap:RemoveControl( WorldMapWindow.closeButton )
	
	WorldMapWindow.startMousePosX	= 0
	WorldMapWindow.startMousePosY	= 0
	WorldMapWindow.lastMousePosX	= 0
	WorldMapWindow.lastMousePosY	= 0

	WorldMapWindow.isHouseMode		= false
	
	
end

--local aState = 0
--function Panel_worldmap_TEST()
--	--local aState = ToClient_worldmap_getRenderState()
--	aState = aState +1
--	if ( 4 < aState ) then
--		aState = 0
--	end
--	Panel_Win_Worldmap_StateChange(aState)
--end


init()

Panel_Win_Worldmap:RegisterShowEventFunc( true, 'Panel_Win_Worldmap_ShowAni()' )
Panel_Win_Worldmap:RegisterShowEventFunc( false, 'Panel_Win_Worldmap_HideAni()' )

--------------------------------------------------------
--		메뉴 클릭할 때마다 범례의 설명을 바꿔주자
--------------------------------------------------------
local changeStateTooltip = function( newState )
	if ( newState == 1 ) then
		WorldMapWindow._gaugeWater:SetShow( false )
		WorldMapWindow._gaugeTemper:SetShow( false )
		WorldMapWindow._gague_Humidity:SetShow( false )
		WorldMapWindow._txt_Low:SetShow( false )
		WorldMapWindow._txt_High:SetShow( false )
		WorldMapWindow._landInfo_Graph_0:SetShow( false )
		WorldMapWindow._landInfo_Graph_1:SetShow( false )
		WorldMapWindow._landInfo_Graph_2:SetShow( false )
		WorldMapWindow._nod_City:SetShow( true )
		WorldMapWindow._nod_Village:SetShow( true )
		WorldMapWindow._nod_Gate:SetShow( true )
		WorldMapWindow._nod_Trade:SetShow( true )
		WorldMapWindow._nod_Dangerous:SetShow( true )
		WorldMapWindow._nod_Empty:SetShow( true )
		-- WorldMapWindow._ExplorePoint:SetShow( true )
		
		WorldMapWindow_Update_ExplorePoint()
		WorldMapWindow._infoDesc		:SetTextMode( UI_TM.eTextMode_AutoWrap )
		WorldMapWindow._infoDesc		:SetAutoResize( true )
		WorldMapWindow._infoDesc		:SetText( PAGetString( Defines.StringSheet_GAME, "LUA_WORLDMAP_MENU_INFO_0" ) )	-- 플레이어가 탐험한 지역과 노드의 정보, 퀘스트 정보가 표시된다
		WorldMapWindow._infoDesc		:SetSize( WorldMapWindow._infoDesc:GetSizeX(), WorldMapWindow._infoDesc:GetSizeY() )
		WorldMapWindow._infoDesc_BG		:SetSize( WorldMapWindow._infoDesc_BG:GetSizeX(), WorldMapWindow._infoDesc:GetSizeY() + 7 )
			getBottom = WorldMapWindow._infoDesc_BG:GetSpanSize().y + WorldMapWindow._infoDesc_BG:GetSizeY() + 5
		WorldMapWindow._nod_City 		:SetSpanSize( WorldMapWindow._nod_City:GetSpanSize().x, getBottom)
		WorldMapWindow._nod_Village 	:SetSpanSize( WorldMapWindow._nod_Village:GetSpanSize().x, getBottom)
		WorldMapWindow._nod_Gate 		:SetSpanSize( WorldMapWindow._nod_Gate:GetSpanSize().x, getBottom + 24)
		WorldMapWindow._nod_Trade 		:SetSpanSize( WorldMapWindow._nod_Trade:GetSpanSize().x, getBottom + 24)
		WorldMapWindow._nod_Dangerous 	:SetSpanSize( WorldMapWindow._nod_Dangerous:GetSpanSize().x, getBottom + 48)
		WorldMapWindow._nod_Empty 		:SetSpanSize( WorldMapWindow._nod_Empty:GetSpanSize().x, getBottom + 48)		
		-- WorldMapWindow._ExplorePoint	:SetSpanSize( WorldMapWindow._ExplorePoint:GetSpanSize().x, getBottom + 77)		
			getBottom = WorldMapWindow._nod_Empty:GetSpanSize().y + WorldMapWindow._nod_Empty:GetSizeY()
		WorldMapWindow._panel_Information:SetSize( WorldMapWindow._panel_Information:GetSizeX(), getBottom + 10 )
		
		WorldMapWindow_Toggle_MainNodeIcon (0, true, true)

	elseif ( newState == 2 ) then
		getBottom = 0
		WorldMapWindow._gaugeWater:SetShow( false )
		WorldMapWindow._gaugeTemper:SetShow( false )
		WorldMapWindow._gague_Humidity:SetShow( false )
		WorldMapWindow._txt_Low:SetShow( false )
		WorldMapWindow._txt_High:SetShow( false )
		WorldMapWindow._landInfo_Graph_0:SetShow( true )
		WorldMapWindow._landInfo_Graph_1:SetShow( true )
		WorldMapWindow._landInfo_Graph_2:SetShow( true )
		WorldMapWindow._nod_City:SetShow( false )
		WorldMapWindow._nod_Village:SetShow( false )
		WorldMapWindow._nod_Gate:SetShow( false )
		WorldMapWindow._nod_Trade:SetShow( false )
		WorldMapWindow._nod_Dangerous:SetShow( false )
		WorldMapWindow._nod_Empty:SetShow( false )
		-- WorldMapWindow._ExplorePoint:SetShow( false )
			
		WorldMapWindow._infoDesc:SetTextMode( UI_TM.eTextMode_AutoWrap )
		WorldMapWindow._infoDesc:SetAutoResize( true )
		WorldMapWindow._infoDesc:SetText( PAGetString( Defines.StringSheet_GAME, "LUA_WORLDMAP_MENU_INFO_1" ) )	-- 각 영지 지역별 자원 및 민심의 정보가 그래프로 표시된다
		WorldMapWindow._infoDesc:SetSize( WorldMapWindow._infoDesc:GetSizeX(), WorldMapWindow._infoDesc:GetSizeY() )
		WorldMapWindow._infoDesc_BG:SetSize( WorldMapWindow._infoDesc_BG:GetSizeX(), WorldMapWindow._infoDesc:GetSizeY() + 7 )
			getBottom = WorldMapWindow._infoDesc_BG:GetSpanSize().y + WorldMapWindow._infoDesc_BG:GetSizeY()
				
		WorldMapWindow._landInfo_Graph_0:SetSpanSize( WorldMapWindow._landInfo_Graph_0:GetSpanSize().x, getBottom + 10 )
			getBottom = getBottom + 10 + WorldMapWindow._landInfo_Graph_0:GetSizeY()
		WorldMapWindow._landInfo_Graph_1:SetSpanSize( WorldMapWindow._landInfo_Graph_1:GetSpanSize().x, getBottom + 10 )
			getBottom = getBottom + 10 + WorldMapWindow._landInfo_Graph_1:GetSizeY()
		WorldMapWindow._landInfo_Graph_2:SetSpanSize( WorldMapWindow._landInfo_Graph_2:GetSpanSize().x, getBottom + 10 )
			getBottom = getBottom + 10 + WorldMapWindow._landInfo_Graph_2:GetSizeY()
		WorldMapWindow._panel_Information:SetSize( WorldMapWindow._panel_Information:GetSizeX(), getBottom + 15)

	elseif ( newState == 3 ) then
		getBottom = 0
		WorldMapWindow._gaugeWater:SetShow( true )
		WorldMapWindow._gaugeTemper:SetShow( false )
		WorldMapWindow._gague_Humidity:SetShow( false )
		WorldMapWindow._txt_Low:SetShow( true )
		WorldMapWindow._txt_High:SetShow( true )
		WorldMapWindow._landInfo_Graph_0:SetShow( false )
		WorldMapWindow._landInfo_Graph_1:SetShow( false )
		WorldMapWindow._landInfo_Graph_2:SetShow( false )
		WorldMapWindow._nod_City:SetShow( false )
		WorldMapWindow._nod_Village:SetShow( false )
		WorldMapWindow._nod_Gate:SetShow( false )
		WorldMapWindow._nod_Trade:SetShow( false )
		WorldMapWindow._nod_Dangerous:SetShow( false )
		WorldMapWindow._nod_Empty:SetShow( false )
		-- WorldMapWindow._ExplorePoint:SetShow( false )
		
		WorldMapWindow._infoDesc:SetTextMode( UI_TM.eTextMode_AutoWrap )
		WorldMapWindow._infoDesc:SetAutoResize( true )
		WorldMapWindow._infoDesc:SetText( PAGetString( Defines.StringSheet_GAME, "LUA_WORLDMAP_MENU_INFO_2" ) )	-- 땅 밑에 매장되어 있는 지하수량의 범위를 표시한다
		WorldMapWindow._infoDesc:SetSize( WorldMapWindow._infoDesc:GetSizeX(), WorldMapWindow._infoDesc:GetSizeY() )
		WorldMapWindow._infoDesc_BG:SetSize( WorldMapWindow._infoDesc_BG:GetSizeX(), WorldMapWindow._infoDesc:GetSizeY() + 7 )
			getBottom = WorldMapWindow._infoDesc_BG:GetSpanSize().y + WorldMapWindow._infoDesc_BG:GetSizeY()
				
		WorldMapWindow._gaugeWater:SetSpanSize( WorldMapWindow._gaugeWater:GetSpanSize().x, getBottom + 7 )
			getBottom = getBottom + 7 + WorldMapWindow._gaugeWater:GetSizeY()
		WorldMapWindow._txt_Low:SetSpanSize( WorldMapWindow._txt_Low:GetSpanSize().x, getBottom + 2 )
		WorldMapWindow._txt_High:SetSpanSize( WorldMapWindow._txt_High:GetSpanSize().x, getBottom + 2 )
			getBottom = getBottom + 2 + WorldMapWindow._txt_Low:GetSizeY()
		WorldMapWindow._panel_Information:SetSize( WorldMapWindow._panel_Information:GetSizeX(), getBottom + 5 )
			
	elseif ( newState == 4 ) then
		getBottom = 0
		WorldMapWindow._gaugeWater:SetShow( false )
		WorldMapWindow._gaugeTemper:SetShow( true )
		WorldMapWindow._gague_Humidity:SetShow( false )
		WorldMapWindow._txt_Low:SetShow( true )
		WorldMapWindow._txt_High:SetShow( true )
		WorldMapWindow._landInfo_Graph_0:SetShow( false )
		WorldMapWindow._landInfo_Graph_1:SetShow( false )
		WorldMapWindow._landInfo_Graph_2:SetShow( false )
		WorldMapWindow._nod_City:SetShow( false )
		WorldMapWindow._nod_Village:SetShow( false )
		WorldMapWindow._nod_Gate:SetShow( false )
		WorldMapWindow._nod_Trade:SetShow( false )
		WorldMapWindow._nod_Dangerous:SetShow( false )
		WorldMapWindow._nod_Empty:SetShow( false )
		-- WorldMapWindow._ExplorePoint:SetShow( false )
		
		WorldMapWindow._infoDesc:SetTextMode( UI_TM.eTextMode_AutoWrap )
		WorldMapWindow._infoDesc:SetAutoResize( true )
		WorldMapWindow._infoDesc:SetText( PAGetString( Defines.StringSheet_GAME, "LUA_WORLDMAP_MENU_INFO_3" ) )	-- 각 지역의 온도차를 범위화 하여 표시한다
		WorldMapWindow._infoDesc:SetSize( WorldMapWindow._infoDesc:GetSizeX(), WorldMapWindow._infoDesc:GetSizeY() )
		WorldMapWindow._infoDesc_BG:SetSize( WorldMapWindow._infoDesc_BG:GetSizeX(), WorldMapWindow._infoDesc:GetSizeY() + 7 )
			getBottom = WorldMapWindow._infoDesc_BG:GetSpanSize().y + WorldMapWindow._infoDesc_BG:GetSizeY()
				
		WorldMapWindow._gaugeTemper:SetSpanSize( WorldMapWindow._gaugeTemper:GetSpanSize().x, getBottom + 7 )
			getBottom = getBottom + 7 + WorldMapWindow._gaugeTemper:GetSizeY()
		WorldMapWindow._txt_Low:SetSpanSize( WorldMapWindow._txt_Low:GetSpanSize().x, getBottom + 2 )
		WorldMapWindow._txt_High:SetSpanSize( WorldMapWindow._txt_High:GetSpanSize().x, getBottom + 2 )
			getBottom = getBottom + 2 + WorldMapWindow._txt_Low:GetSizeY()
		WorldMapWindow._panel_Information:SetSize( WorldMapWindow._panel_Information:GetSizeX(), getBottom + 5)
			
	elseif ( newState == 5 ) then
		getBottom = 0
		WorldMapWindow._gaugeWater:SetShow( false )
		WorldMapWindow._gaugeTemper:SetShow( false )
		WorldMapWindow._gague_Humidity:SetShow( true )
		WorldMapWindow._txt_Low:SetShow( true )
		WorldMapWindow._txt_High:SetShow( true )
		WorldMapWindow._landInfo_Graph_0:SetShow( false )
		WorldMapWindow._landInfo_Graph_1:SetShow( false )
		WorldMapWindow._landInfo_Graph_2:SetShow( false )
		WorldMapWindow._nod_City:SetShow( false )
		WorldMapWindow._nod_Village:SetShow( false )
		WorldMapWindow._nod_Gate:SetShow( false )
		WorldMapWindow._nod_Trade:SetShow( false )
		WorldMapWindow._nod_Dangerous:SetShow( false )
		WorldMapWindow._nod_Empty:SetShow( false )
		-- WorldMapWindow._ExplorePoint:SetShow( false )
		
		WorldMapWindow._infoDesc:SetTextMode( UI_TM.eTextMode_AutoWrap )
		WorldMapWindow._infoDesc:SetAutoResize( true )
		WorldMapWindow._infoDesc:SetText( PAGetString( Defines.StringSheet_GAME, "LUA_WORLDMAP_MENU_INFO_4" ) )	-- 각 지역의 습도량을 범위화 하여 표시한다
		WorldMapWindow._infoDesc:SetSize( WorldMapWindow._infoDesc:GetSizeX(), WorldMapWindow._infoDesc:GetSizeY() )
		WorldMapWindow._infoDesc_BG:SetSize( WorldMapWindow._infoDesc_BG:GetSizeX(), WorldMapWindow._infoDesc:GetSizeY() + 7 )
			getBottom = WorldMapWindow._infoDesc_BG:GetSpanSize().y + WorldMapWindow._infoDesc_BG:GetSizeY()
				
		WorldMapWindow._gague_Humidity:SetSpanSize( WorldMapWindow._gague_Humidity:GetSpanSize().x, getBottom + 7 )
			getBottom = getBottom + 7 + WorldMapWindow._gague_Humidity:GetSizeY()
		WorldMapWindow._txt_Low:SetSpanSize( WorldMapWindow._txt_Low:GetSpanSize().x, getBottom + 2 )
		WorldMapWindow._txt_High:SetSpanSize( WorldMapWindow._txt_High:GetSpanSize().x, getBottom + 2 )
			getBottom = getBottom + 2 + WorldMapWindow._txt_Low:GetSizeY()
		WorldMapWindow._panel_Information:SetSize( WorldMapWindow._panel_Information:GetSizeX(), getBottom + 5 )

	end
end


------------------------------------------------------------
--				상태 초기화 함수
------------------------------------------------------------
function Panel_Win_WorldMap_StateInit()
	for key, value in pairs(WorldMapWindow.uiList) do
		if ( key ~= WorldMapWindow.RenderType.WMS_GLOBAL ) then
			value:SetShow(false, false)
		end
	end

	local newState = WorldMapWindow.RenderType.WMS_EXPLORE_PLANT
	ToClient_worldmap_setRenderState( newState )
	if ( WorldMapWindow.uiList[newState] ) then
		WorldMapWindow.uiList[newState]:SetShow(true)
	end
	
	if ( WorldMapWindow.ShowRunList[newState] ) then
		WorldMapWindow.ShowRunList[newState]()
	end
	
	WorldMapWindow.uichange_default		:SetCheck(true)
	WorldMapWindow.uichange_noUI		:SetCheck(false)
	WorldMapWindow.uichange_water		:SetCheck(false)
	WorldMapWindow.uichange_celius		:SetCheck(false)
	WorldMapWindow.uichange_humility	:SetCheck(false)
	changeStateTooltip(newState)
end


------------------------------------------------------------
--				메뉴 클릭시 이벤트 함수
------------------------------------------------------------
function Panel_Win_Worldmap_StateChange( state )
	local prevState = ToClient_worldmap_getRenderState()
	if ( prevStae == state ) then
		return
	end

	ToClient_worldmap_setRenderState( state )
	local newState = ToClient_worldmap_getRenderState()
		
	if ( prevState == newState ) then
		return false
	end
	
	if ( WorldMapWindow.uiList[prevState] ) then
		WorldMapWindow.uiList[prevState]:SetShow(false)
	end

	if ( WorldMapWindow.uiList[newState] ) then
		WorldMapWindow.uiList[newState]:SetShow(true)
	end
	
	if ( WorldMapWindow.ShowRunList[newState] ) then
		WorldMapWindow.ShowRunList[newState]()
	end

	getSelfPlayer():get():getWorldMapHouseLineWrapper():close()
	WorldMapWindow_NodeButton_UpdateShowable()
	WorldMapWindow_RefreshPosition_NodeButtonList()

	changeStateTooltip(newState)
	
	WorldMapWindow_CloseAllSubPanel()
	WorldMapWindow_NodeButton_UpdateShowable()
end


------------------------------------------------------------
--				월드맵 켤 때 애니메이션
------------------------------------------------------------
function Panel_Win_Worldmap_ShowAni()
	Panel_Win_Worldmap:ResetVertexAni()
	Panel_Win_Worldmap:SetShowWithFade(CppEnums.PAUI_SHOW_FADE_TYPE.PAUI_ANI_TYPE_FADE_IN)
	local aniInfo = WorldMapWindow.world3DMapStatic:addColorAnimation( 0.0, 1.0, UI_ANI_ADV.PAUI_ANIM_ADVANCE_LINEAR)
	aniInfo:SetStartColor( UI_color.C_00FFFFFF )
	aniInfo:SetEndColor( UI_color.C_FFFFFFFF )
	aniInfo.IsChangeChild = false

	WorldMapWindow.world3DMapStatic:SetAlpha(0)
end


------------------------------------------------------------
--				월드맵 끌 때 애니메이션
------------------------------------------------------------
function Panel_Win_Worldmap_HideAni()
	Panel_Win_Worldmap:ResetVertexAni()
	Panel_Win_Worldmap:SetShowWithFade(CppEnums.PAUI_SHOW_FADE_TYPE.PAUI_ANI_TYPE_FADE_OUT)

	local aniInfo = WorldMapWindow.world3DMapStatic:addColorAnimation( 0.0, 1.0, UI_ANI_ADV.PAUI_ANIM_ADVANCE_LINEAR)
	aniInfo:SetStartColor( UI_color.C_FFFFFFFF )
	aniInfo:SetEndColor( UI_color.C_00FFFFFF )
	aniInfo.IsChangeChild = false
	aniInfo:SetHideAtEnd(true)
	aniInfo:SetDisableWhileAni(true)
end

function WorldMapWindow_GetDepthFromPos3D( camera, position )
	return _Util_Math.calculateDistance(camera, position) / 100000.0;
end

function WorldMapWindow_UpdateDepthSort()
	if Panel_Win_Worldmap:IsShow() then
		Panel_Win_Worldmap:SetDepthSort();
	end
end

function WorldMapWindow_PanelSnap( panel, width, height )
	local screenSizeX = getScreenSizeX()
	local screenSizeY = getScreenSizeY()

	if panel:GetPosX() + width > screenSizeX then
		panel:SetPosX( screenSizeX - width );
	elseif panel:GetPosX() < 0 then
		panel:SetPosX(0);
	end
	if panel:GetPosY() + height > screenSizeY then
		panel:SetPosY( screenSizeY - height );
	elseif panel:GetPosY() < 0 then
		panel:SetPosY(0);
	end
end

function WorldMapWindow_RefreshSubPanel()
	if WorldMapWindow:IsSubPanelSnaped() then
		local currentSubPanel = WorldMapWindow.currentSubPanel
		
		if WorldMapWindow.infoNodeKeyType == WorldMapWindow.EnumInfoNodeKeyType.eInfoNodeKeyType_Region then
			PanelMenu = Panel_Lord_Controller;
		elseif WorldMapWindow.infoNodeKeyType == WorldMapWindow.EnumInfoNodeKeyType.eInfoNodeKeyType_FixedHouseListIdx then
			PanelMenu = Panel_HouseControl;
		else
			PanelMenu = Panel_NodeMenu;
		end
		
		currentSubPanel:SetPosX( PanelMenu:GetPosX() + PanelMenu:GetSizeX() )
		currentSubPanel:SetPosY( PanelMenu:GetPosY() )

		WorldMapWindow_PanelSnap(currentSubPanel, currentSubPanel:GetSizeX(), currentSubPanel:GetSizeY())
		WorldMapWindow.subPanelSnapedPosX = currentSubPanel:GetPosX()
		WorldMapWindow.subPanelSnapedPosY = currentSubPanel:GetPosY()
	end
end

-- WorldMapWindow_IsSubPanelSnaped
function WorldMapWindow:IsSubPanelSnaped()
	local currentSubPanel = self.currentSubPanel
	if self.infoNodeKey ~= nil and currentSubPanel ~= nil and currentSubPanel:GetShow() == true then
		local currentPositionX = currentSubPanel:GetPosX();
		local currentPositionY = currentSubPanel:GetPosY();

		local NodeMenuRect = {}
		NodeMenuRect.left	= Panel_NodeMenu:GetPosX()
		NodeMenuRect.top	= Panel_NodeMenu:GetPosY()
		NodeMenuRect.right	= NodeMenuRect.left + Panel_NodeMenu:GetSizeX()
		NodeMenuRect.bottom	= NodeMenuRect.top + Panel_NodeMenu:GetSizeY()

		local dx = currentPositionX - self.subPanelSnapedPosX
		local dy = currentPositionY - self.subPanelSnapedPosY
		if _math_sqrt_x2_y2(dx,dy) < 20 then
			return true;
		end

		dx = currentPositionX - NodeMenuRect.right
		dy = currentPositionY - NodeMenuRect.top
		if _math_sqrt_x2_y2(dx,dy) < 20 then
			return true;
		end

		-- dx = currentPositionX - NodeMenuRect.right
		dy = currentPositionY - NodeMenuRect.bottom
		if _math_sqrt_x2_y2(dx,dy) < 20 then
			return true;
		end

		if	(NodeMenuRect.top < currentPositionY) and (currentPositionY < NodeMenuRect.bottom) and
			(NodeMenuRect.left < currentPositionX) and (currentPositionX < NodeMenuRect.right + 20) then
			return true;
		end
	end

	return false;
end

function WorldMapWindow_CloseAllSubPanel()
	--WorldMapWindow_CloseUpgradePanel();
	WorldMapWindow_CloseWorkManage();
	Warehouse_Close();
	WorldMapWindow_CloseWaitWorkerManage();
	HideWorkingProgress();
	WorldMapWindow.popupManager:clear();
	ToClient_worldmap_resetTownMode();
	WorldMapWindow.currentSubPanel = nil;
end

function WorldMapWindow:SetSubPanel( subPanel )
	if self.infoNodeKey ~= nil then
		if subPanel ~= self.currentSubPanel then
			WorldMapWindow_CloseAllSubPanel();
			subPanel:SetShow(true);

			self.isSubPanelSnaped = true;
			self.currentSubPanel = subPanel;

			self.subPanelSnapedPosX = subPanel:GetPosX();
			self.subPanelSnapedPosY = subPanel:GetPosY();
			WorldMapWindow_RefreshSubPanel();
		end
		return true;
	end
	return false;
end

-- function WorldMapWindow_OnFullScreenToggle()
	-- WorldMapWindow:SetFullScreen(WorldMapWindow.isFullScreen == false);
-- end

function WorldMapWindow_OnPressStart()
	WorldMapWindow.startMousePosX = getMousePosX()
	WorldMapWindow.startMousePosY = getMousePosY()
	WorldMapWindow.lastMousePosX = getMousePosX()
	WorldMapWindow.lastMousePosY = getMousePosY()
	FGlobal_RequestSendPositionGuide(false)
	FGlobal_ClosePositionGuideMenu()
end

function WorldMapWindow_OnPressStartDClick()
	FGlobal_RequestSendPositionGuide(true)
end

function WorldMapWindow_OnPressEnd()
	local dragLength = (WorldMapWindow.startMousePosX - WorldMapWindow.lastMousePosX) * (WorldMapWindow.startMousePosX - WorldMapWindow.lastMousePosX);
	dragLength = dragLength + (WorldMapWindow.startMousePosY - WorldMapWindow.lastMousePosY) * (WorldMapWindow.startMousePosY - WorldMapWindow.lastMousePosY);

	dragLength = math.sqrt(dragLength);

	if dragLength < 5 then
		return false;
	end	
	return true;
end

function WorldMapWindow_OnPressEnd_Default()
	if ( false == WorldMapWindow_OnPressEnd() ) then
		--WorldMapWindow_CloseAllSubPanel()
    	--WorldMapWindow_NodeButton_UpdateShowable()
		--WorldMapWindow_CloseNodeMenu()
		--마차 클릭 확인하기
		local	objectID	= worldmap_getObjectIDByPosition( WorldMapWindow.lastMousePosX , WorldMapWindow.lastMousePosY )
		DeliveryCarriageInformationWindow_Open( objectID )
		
		if ( ToClient_worldmap_getRenderState() == WorldMapWindow.RenderType.WMS_REGION) then
			local destPos = worldmap_navigatorpickPos(WorldMapWindow.world3DMapStatic:GetSizeX(), WorldMapWindow.world3DMapStatic:GetSizeY(), float2(getMousePosX(), getMousePosY()))
			local regionWrapper = ToClient_getRegionInfoWrapperByPosition(destPos)
			if ( nil ~= regionWrapper ) then
				ToClient_worldmap_setSelectedRegionInfo( regionWrapper:getRegionGroupKey() )
			else
				ToClient_worldmap_resetSelectedRegionInfo()
			end
		end
	end	

	-- if _OnDrag_L then
		-- _OnDrag_L = false
	-- elseif not ( ToClient_DeleteNaviGuideByGroup(0) ) then
		-- worldmap_clearNavigatePath()
		-- -- ♬ 빛 기둥 끌 때
		-- audioPostEvent_SystemUi(00,15)
	-- end
	
end

function WorldMapWindow_InnerControlCheck(control)
	if not (control:GetPosX() < WorldMapWindow.lastMousePosX and WorldMapWindow.lastMousePosX < control:GetPosX() + control:GetSizeX()) then
		return false
	end
	if not (control:GetPosY() < WorldMapWindow.lastMousePosY and WorldMapWindow.lastMousePosY < control:GetPosY() + control:GetSizeY()) then
		return false
	end
	return true
end


function WorldMapWindow_OnRPressStart()
	WorldMapWindow.startMousePosX = getMousePosX();
	WorldMapWindow.startMousePosY = getMousePosY();
	WorldMapWindow.lastMousePosX = getMousePosX();
	WorldMapWindow.lastMousePosY = getMousePosY();
	FGlobal_ClosePositionGuideMenu()
end

function WorldMapWindow_OnRPressEnd()

	local dragLength = (WorldMapWindow.startMousePosX - WorldMapWindow.lastMousePosX) * (WorldMapWindow.startMousePosX - WorldMapWindow.lastMousePosX);
	dragLength = dragLength + (WorldMapWindow.startMousePosY - WorldMapWindow.lastMousePosY) * (WorldMapWindow.startMousePosY - WorldMapWindow.lastMousePosY);

	dragLength = math.sqrt(dragLength);

	if dragLength < 5 then
	
		if ( WorldMapWindow.isHouseMode == true ) then
			WorldMapWindow_CloseNodeMenu()
		else
			local destPos = worldmap_navigatorpickPos(WorldMapWindow.world3DMapStatic:GetSizeX(), WorldMapWindow.world3DMapStatic:GetSizeY(), float2(getMousePosX(), getMousePosY()));
			if ( ToClient_IsShowNaviGuideGroup(0) ) then
				ToClient_DeleteNaviGuideByGroup(0);
				-- ♬ 빛 기둥 끌 때
				audioPostEvent_SystemUi(00,15)
			else
				worldmapNavigatorStart(destPos, NavigationGuideParam(), false, true)
				-- ♬ 빛 기둥 찍을때
				audioPostEvent_SystemUi(00,14)
			end
		end
		
		return false;
	end
	return true;
end

function WorldMapWindow_OnCameraMove()
	worldmapSceneCameraMove( WorldMapWindow.world3DMapStatic:GetSizeX(), WorldMapWindow.world3DMapStatic:GetSizeY(), float2(WorldMapWindow.lastMousePosX - getMousePosX(), WorldMapWindow.lastMousePosY - getMousePosY()));

	if ( WorldMapWindow.lastMousePosX ~= getMousePosX() ) or ( WorldMapWindow.lastMousePosY ~= getMousePosY() )then	
		WorldMapWindow.lastMousePosX = getMousePosX();
		WorldMapWindow.lastMousePosY = getMousePosY();
		-- _OnDrag_L = true
	end
	
	-- 이 함수는 대부분 UI Event 에 의해 호출된다.
	-- UIManager Update 이후에 Camera Pos 를 비교해서 'WorldMap_CameraPosChange' 이벤트가 발생한다.
	-- 따라서 WorldMapWindow_RefreshOnUpdateCamera() 를 직접 호출해주지 않아도, 자동으로 호출된다.
	-- WorldMapWindow_RefreshOnUpdateCamera();
end

function WorldMapWindow_OnCameraRotate()
	worldmapSceneCameraRotate( WorldMapWindow.world3DMapStatic:GetSizeX(), WorldMapWindow.world3DMapStatic:GetSizeY(), float2(WorldMapWindow.lastMousePosX - getMousePosX(), WorldMapWindow.lastMousePosY - getMousePosY()));
	WorldMapWindow.lastMousePosX = getMousePosX();
	WorldMapWindow.lastMousePosY = getMousePosY();
	
	-- 이 함수는 대부분 UI Event 에 의해 호출된다.
	-- UIManager Update 이후에 Camera Pos 를 비교해서 'WorldMap_CameraPosChange' 이벤트가 발생한다.
	-- 따라서 WorldMapWindow_RefreshOnUpdateCamera() 를 직접 호출해주지 않아도, 자동으로 호출된다.
	-- WorldMapWindow_RefreshOnUpdateCamera();
end

function WorldMapWindow_OnUpScroll()
	worldmapSceneCameraScale(true);

	-- 이 함수는 대부분 UI Event 에 의해 호출된다.
	-- UIManager Update 이후에 Camera Pos 를 비교해서 'WorldMap_CameraPosChange' 이벤트가 발생한다.
	-- 따라서 WorldMapWindow_RefreshOnUpdateCamera() 를 직접 호출해주지 않아도, 자동으로 호출된다.
	-- WorldMapWindow_RefreshOnUpdateCamera();
end

function WorldMapWindow_OnDownScroll()
	worldmapSceneCameraScale(false);

	-- 이 함수는 대부분 UI Event 에 의해 호출된다.
	-- UIManager Update 이후에 Camera Pos 를 비교해서 'WorldMap_CameraPosChange' 이벤트가 발생한다.
	-- 따라서 WorldMapWindow_RefreshOnUpdateCamera() 를 직접 호출해주지 않아도, 자동으로 호출된다.
	-- WorldMapWindow_RefreshOnUpdateCamera();
end

function WorldMapWindow_OnViewModeUpdate()
	WorldMapWindow.ViewDetailMode = ToClient_worldmap_isTownMode()
end


--------------------------------------------
-- Show / Hide
--------------------------------------------
function Panel_Worldmap_Tooltip_ShowToggle( menuNo, isOn )
	-- _PA_LOG("LUA", "asdfasdfasdfasdfa")
	local mouse_posX = getMousePosX()
	local mouse_posY = getMousePosY()
	
	local panel_posX = Panel_Win_Worldmap:GetPosX()
	local panel_posY = Panel_Win_Worldmap:GetPosY()
	
	if ( menuNo == 0 ) then
		if ( isOn == true ) then
			WorldMapWindow.menuBubbleHelp_0:SetShow( true )
			WorldMapWindow.menuBubbleHelp_0:SetText( PAGetString( Defines.StringSheet_GAME, "LUA_WORLDMAP_MENU_TITLE_0" ) )	-- 일반 정보
			WorldMapWindow.menuBubbleHelp_0:SetAlpha( 0 )
			WorldMapWindow.menuBubbleHelp_0:SetFontAlpha( 0 )
			WorldMapWindow.menuBubbleHelp_0:ResetVertexAni()
			local AniInfo = UIAni.AlphaAnimation( 1, WorldMapWindow.menuBubbleHelp_0, 0.0, 0.2 )
			WorldMapWindow.menuBubbleHelp_0:SetShow( true )
			
			WorldMapWindow.menuBubbleHelp_0:SetPosX( mouse_posX - panel_posX - 5 )
			WorldMapWindow.menuBubbleHelp_0:SetPosY( mouse_posY - panel_posY + 15 )
		else
			local AniInfo = UIAni.AlphaAnimation( 0, WorldMapWindow.menuBubbleHelp_0, 0.0, 0.2 )
			AniInfo:SetHideAtEnd( true )
		end

	elseif ( menuNo == 1 ) then
		if ( isOn == true ) then
			WorldMapWindow.menuBubbleHelp_1:SetShow( true )
			WorldMapWindow.menuBubbleHelp_1:SetText( PAGetString( Defines.StringSheet_GAME, "LUA_WORLDMAP_MENU_TITLE_1" ) )	-- 영지 자원 정보
			WorldMapWindow.menuBubbleHelp_1:SetAlpha( 0 )
			WorldMapWindow.menuBubbleHelp_1:SetFontAlpha( 0 )
			WorldMapWindow.menuBubbleHelp_1:ResetVertexAni()
			local AniInfo = UIAni.AlphaAnimation( 1, WorldMapWindow.menuBubbleHelp_1, 0.0, 0.2 )
			WorldMapWindow.menuBubbleHelp_1:SetShow( true )
			
			WorldMapWindow.menuBubbleHelp_1:SetPosX( mouse_posX - panel_posX - 5 )
			WorldMapWindow.menuBubbleHelp_1:SetPosY( mouse_posY - panel_posY + 15 )
		else
			local AniInfo = UIAni.AlphaAnimation( 0, WorldMapWindow.menuBubbleHelp_1, 0.0, 0.2 )
			AniInfo:SetHideAtEnd( true )
		end
		
	elseif ( menuNo == 2 ) then
		if ( isOn == true ) then
			WorldMapWindow.menuBubbleHelp_2:SetShow( true )
			WorldMapWindow.menuBubbleHelp_2:SetText( PAGetString( Defines.StringSheet_GAME, "LUA_WORLDMAP_MENU_TITLE_2" ) )	-- 지하수 정보
			WorldMapWindow.menuBubbleHelp_2:SetAlpha( 0 )
			WorldMapWindow.menuBubbleHelp_2:SetFontAlpha( 0 )
			WorldMapWindow.menuBubbleHelp_2:ResetVertexAni()
			local AniInfo = UIAni.AlphaAnimation( 1, WorldMapWindow.menuBubbleHelp_2, 0.0, 0.2 )
			WorldMapWindow.menuBubbleHelp_2:SetShow( true )
			
			WorldMapWindow.menuBubbleHelp_2:SetPosX( mouse_posX - panel_posX - 5 )
			WorldMapWindow.menuBubbleHelp_2:SetPosY( mouse_posY - panel_posY + 15 )
		else
			local AniInfo = UIAni.AlphaAnimation( 0, WorldMapWindow.menuBubbleHelp_2, 0.0, 0.2 )
			AniInfo:SetHideAtEnd( true )
		end
		
	elseif ( menuNo == 3 ) then
		if ( isOn == true ) then
			WorldMapWindow.menuBubbleHelp_3:SetShow( true )
			WorldMapWindow.menuBubbleHelp_3:SetText( PAGetString( Defines.StringSheet_GAME, "LUA_WORLDMAP_MENU_TITLE_3" ) )	-- 온도 정보
			WorldMapWindow.menuBubbleHelp_3:SetAlpha( 0 )
			WorldMapWindow.menuBubbleHelp_3:SetFontAlpha( 0 )
			WorldMapWindow.menuBubbleHelp_3:ResetVertexAni()
			local AniInfo = UIAni.AlphaAnimation( 1, WorldMapWindow.menuBubbleHelp_3, 0.0, 0.2 )
			WorldMapWindow.menuBubbleHelp_3:SetShow( true )
			
			WorldMapWindow.menuBubbleHelp_3:SetPosX( mouse_posX - panel_posX - 5 )
			WorldMapWindow.menuBubbleHelp_3:SetPosY( mouse_posY - panel_posY + 15 )
		else
			local AniInfo = UIAni.AlphaAnimation( 0, WorldMapWindow.menuBubbleHelp_3, 0.0, 0.2 )
			AniInfo:SetHideAtEnd( true )
		end
		
	elseif ( menuNo == 4 ) then
		if ( isOn == true ) then
			WorldMapWindow.menuBubbleHelp_4:SetShow( true )
			WorldMapWindow.menuBubbleHelp_4:SetText( PAGetString( Defines.StringSheet_GAME, "LUA_WORLDMAP_MENU_TITLE_4" ) )	-- 습도 정보
			WorldMapWindow.menuBubbleHelp_4:SetAlpha( 0 )
			WorldMapWindow.menuBubbleHelp_4:SetFontAlpha( 0 )
			WorldMapWindow.menuBubbleHelp_4:ResetVertexAni()
			local AniInfo = UIAni.AlphaAnimation( 1, WorldMapWindow.menuBubbleHelp_4, 0.0, 0.2 )
			WorldMapWindow.menuBubbleHelp_4:SetShow( true )
			
			WorldMapWindow.menuBubbleHelp_4:SetPosX( mouse_posX - panel_posX - 5 )
			WorldMapWindow.menuBubbleHelp_4:SetPosY( mouse_posY - panel_posY + 15 )
		else
			local AniInfo = UIAni.AlphaAnimation( 0, WorldMapWindow.menuBubbleHelp_4, 0.0, 0.2 )
			AniInfo:SetHideAtEnd( true )
		end
	end
end

function Panel_Worldmap_Filter_ShowToggle( menuNo )	
	
	if ( menuNo == 0 ) then		
		WorldMapWindow._btn_Quest_Check = worldMap_GuideUI._btn_Quest:IsCheck()	
		WorldMapWindow_QuestPosition()
		if false == worldMap_GuideUI._btn_Quest:IsCheck() then
			ToClient_clearAllDecal()
		else
			WorldMapWindow_QuestListChanged()
		end

	elseif( menuNo == 1 ) then	
		WorldMapWindow._btn_Knowledge_Check = worldMap_GuideUI._btn_Knowledge:IsCheck()							 
	elseif( menuNo == 2 ) then	
		WorldMapWindow._btn_Fishes_Check = worldMap_GuideUI._btn_Fishes:IsCheck()
	elseif( menuNo == 3 ) then	
		WorldMapWindow._btn_Node_Check = worldMap_GuideUI._btn_Node:IsCheck()	
		
		if( WorldMapWindow._btn_Node_Check ) then
			worldmap_refleshLine()
		else
			worldmap_clearExploreLine()
		end
	elseif( menuNo == 4 ) then	
		WorldMapWindow._btn_WayGuide_Check = worldMap_GuideUI._btn_WayGuide:IsCheck()							 
	elseif( menuNo == 5 ) then	
		WorldMapWindow._btn_Position_Check = worldMap_GuideUI._btn_Position:IsCheck()							 
	end

end


local onShowHandlerList = Array.new()
local onHideHandlerList = Array.new()

function WorldMapWindow_Set_OnShowHide_Handler( isShow, func )
	if isShow then
		onShowHandlerList:push_back( func )
	else
		onHideHandlerList:push_back( func )
	end
end


function WorldMapWindow_OnClose()
	if Panel_Win_Worldmap:IsShow() then
		getSelfPlayer():get():getWorldMapHouseLineWrapper():close()
		if ( ToClient_worldmap_isTownMode() ) then
			ToClient_worldmap_resetTownMode();
		end
		SetUIMode( Defines.UIMode.eUIMode_Default )	-- 더 좋은 방법이 있기 전까지는 여기에서 UI Mode 를 변경해준다! - 성경
		
		FGlobal_CloseGetthePointPositionGuide()
		WorldMapWindow.EnableNodeKey = nil

		setFullSizeMode( false )
		worldmapSceneClose();
		WorldMapWindow_ClearSattleteLineData()
		Panel_Win_Worldmap:SetShow(false, false)
		audioPostEvent_SystemUi(01,03)
		WorldMapWindow.popupManager:clear()
		WorldMapWindow_CloseNodeMenu()
		
		WorldMapWindow_ClearNode();
		WorldMapWindow_CloseAllSubPanel()
		QuestInfoData.questDescHideWindow()
		FGlobal_Hide_Tooltip_Work_Copy(-1, true)

		-- Call Hide Handler!!!!!!!!!!
		for _,onHideHandler in ipairs(onHideHandlerList) do
			onHideHandler()
		end

		-- 숨긴 UI 들을 복원한다!
		UI.restoreFlushedUI()
		-- NpcNavi_ShowRequestOuter(true)
		FGlobal_NpcNavi_ShowRequestOuter()

		FGlobal_HideDialog()
		setShowLine(true)
		collectgarbage("collect");
	end
end

function WorldMapWindow_OnShow()
	-- 다른 UI 를 다 숨겨준다!
	local isShow = worldmapSceneOpen( WorldMapWindow.world3DMapStatic )
	if ( false == isShow ) then
	    return
	end
	
	if( _initFilter and WorldMapWindow._btn_Node_Check == false ) then
		worldmap_clearExploreLine()
	end

	Panel_Tooltip_Item_hideTooltip()
	
	SetUIMode( Defines.UIMode.eUIMode_WorldMap )	-- 더 좋은 방법이 있기 전까지는 여기에서 UI Mode 를 변경해준다! - 성경
	UI.flushAndClearUI();

	--state를 초기화 시켜준다. ( NpcNavi_ShowRequestOuter 때무조건 0 으로 가기때문이다. )
	Panel_Win_WorldMap_StateInit()
	 --월드맵이 켜질때 같이 켜진다.
	-- NpcNavi_ShowRequestOuter(true)
	FGlobal_NpcNavi_ShowRequestOuter()

	Panel_Win_Worldmap:SetShow(true, true)
	audioPostEvent_SystemUi(01,02)
	
	setFullSizeMode( true, FullSizeMode.fullSizeModeEnum.Worldmap )
	
	local selfPlayerWrapper = getSelfPlayer()
	if nil ~= selfPlayerWrapper then
		WorldMapWindow.openPosition = float3(selfPlayerWrapper:get():getPositionX(), 0, selfPlayerWrapper:get():getPositionZ())
	end

    -- Call Show Handler!!!!!!!!!!
	for _,onShowHandler in ipairs(onShowHandlerList) do
		onShowHandler()
	end
	WorldMapWindow.isInterActionCall = false
	
	WorldMap_ChildNode_List()
	-- _OnDrag_L = false
end

function WorldMapWindow_BuyHouseModeShow()
	WorldMapWindow_OnShow()
	WorldMapWindow.isInterActionCall = true
end

function WorldMapWindow_ElementShow()
end

function WorldMapWindow_OnResizeDrag()
	local newSizeX = getMousePosX() - Panel_Win_Worldmap:GetPosX();
	local newSizeY = getMousePosY() - Panel_Win_Worldmap:GetPosY();

	if newSizeX < 700 then
		newSizeX = 700;
	end
	if newSizeY < 450 then
		newSizeY = 450;
	end

	WorldMapWindow.sizeX = newSizeX;
	WorldMapWindow.sizeY = newSizeY;
	WorldMapWindow_OnResize();
end

function WorldMapWindow_OnResize()
	local scrX = getScreenSizeX()
	local scrY = getScreenSizeY()
	
	if WorldMapWindow.isFullScreen == false then
		local newSizeX = WorldMapWindow.sizeX
		local newSizeY = WorldMapWindow.sizeY
		Panel_Win_Worldmap:SetSize(newSizeX, newSizeY)
		WorldMapWindow.world3DMapStatic:SetSize(newSizeX - 20, newSizeY - 20)
	else
		Panel_Win_Worldmap:SetPosX(0)
		Panel_Win_Worldmap:SetPosY(0)
		Panel_Win_Worldmap:SetSize(scrX, scrY)
	end

	-- Display 환산 위치 계산
	if WorldMapWindow_RefreshOnUpdateCamera ~= nil then
		WorldMapWindow_RefreshOnUpdateCamera()
	end

	WorldMapWindow.resizeButton:ComputePos()
	WorldMapWindow.fullScreenButton:ComputePos()
	WorldMapWindow.world3DMapStatic:ComputePos()
	-- WorldMapWindow.closeButton:SetPosX( scrX - WorldMapWindow.closeButton:GetSizeX() - 10 )
	-- WorldMapWindow.closeButton:SetPosY( scrY - WorldMapWindow.closeButton:GetSizeY() - 5 )
	
	-- WorldMapWindow._guideCheck_BG:SetPosX( ( ( scrX - WorldMapWindow._guideCheck_BG:GetSizeX() ) / 2 )- 15 )
	-- WorldMapWindow._guideCheck_BG:SetPosY( scrY - WorldMapWindow._guideCheck_BG:GetSizeY() - 10 )
end


function WorldMapWindow:SetFullScreen( isFullScreen )
	WorldMapWindow.isFullScreen = isFullScreen
	worldmapSceneToggleFullScreen(isFullScreen)

	if isFullScreen == true then
		-- UI.debugMessage(1);
		Panel_Win_Worldmap:SetAlphaChild(1.0)
		Panel_Win_Worldmap:SetPosX(0)
		Panel_Win_Worldmap:SetPosY(0)
		Panel_Win_Worldmap:SetSize(getScreenSizeX(), getScreenSizeY())
		Panel_Win_Worldmap:SetDragEnable( false )

		WorldMapWindow.world3DMapStatic:SetPosX(0, 0)
		WorldMapWindow.world3DMapStatic:SetSize(getScreenSizeX(), getScreenSizeY())
		WorldMapWindow.world3DMapStatic:SetEnableArea(0,0,getScreenSizeX(), getScreenSizeY())

		WorldMapWindow.resizeButton:SetShow(false)
		WorldMapWindow.fullScreenButton:SetText( PAGetString( Defines.StringSheet_GAME, "LUA_WORLD_MAP_WINDOW" ) )
	else
		-- UI.debugMessage(2);
		Panel_Win_Worldmap:SetAlphaChild(WorldMapWindow.alpha)
		Panel_Win_Worldmap:SetPosX(WorldMapWindow.posX)
		Panel_Win_Worldmap:SetPosY(WorldMapWindow.posY)

		Panel_Win_Worldmap:SetSize(WorldMapWindow.sizeX, WorldMapWindow.sizeY)
		Panel_Win_Worldmap:SetDragEnable( true )

		WorldMapWindow.world3DMapStatic:SetPosX(10)
		WorldMapWindow.world3DMapStatic:SetPosY(10)
		WorldMapWindow.world3DMapStatic:SetSize(WorldMapWindow.sizeX, WorldMapWindow.sizeY)
		WorldMapWindow.world3DMapStatic:SetEnableArea(WorldMapWindow.posX,WorldMapWindow.posY,WorldMapWindow.sizeX, WorldMapWindow.sizeY)

		WorldMapWindow.resizeButton:SetShow(true)
		WorldMapWindow.fullScreenButton:SetText( PAGetString( Defines.StringSheet_GAME, "LUA_WORLD_MAP_FULLSCREEN" ) )
	end

	WorldMapWindow.fullScreenButton:SetSize(WorldMapWindow.fullScreenButton:GetTextSizeX() + 10 + 20, WorldMapWindow.fullScreenButton:GetTextSizeY() + 13)
	WorldMapWindow_OnResize()
end


function WorldMapWindow_Show( isLuaCall )
	Dialog_clickExitReq(true)
    WorldMapWindow.isLuaCall = (true == isLuaCall)
	UI.Set_ProcessorInputMode(IM.eProcessorInputMode_UiMode)
	worldmapSceneToggleFullScreen(WorldMapWindow.isFullScreen);
	WorldMapWindow.EnableNodeKey = nil;
	WorldMapWindow_OnShow();
	WorldMapWindow_OnResize();
	FGlobal_Hide_Tooltip_Work_Copy(-1, true)
	FGlobal_Reset_WorldMap_IconName()
	Panel_Npc_Dialog:SetShow(false)
end

function WorldMapWindow_NewNode(node)
	local nodeKey		= node:getStaticStatus()._waypointKey;
	if nil == WorldMapWindow.nodeDataList[nodeKey] then
		WorldMapWindow.nodeDataList[nodeKey] = node;
		WorldMapWindow_NodeButton_UpdateShowable()
		WorldMapWindow_CloseHouseMode()

	elseif 	WorldMapWindow.infoNodeKeyType == WorldMapWindow.EnumInfoNodeKeyType.eInfoNodeKeyType_Waypoint and (nil ~= WorldMapWindow.popupManager:get_if_infoNodeKey(nodeKey)) then
		-- 같은 노드가 추가되었다는 것은, 해당 노드의 탐험정보가 갱신되었다는 것이다.
		-- 따라서 인포메뉴를 갱신해준다.
		WorldMapWindow_CloseAllSubPanel()
		WorldMapWindow_NodeButton_UpdateShowable()
		WorldMapWindow_CloseHouseMode()
	end
end

function WorldMapWindow_NewRegion(regionGroupInfo)
	local regionGroupKey		= regionGroupInfo:getKeyRaw();
	if nil == WorldMapWindow.regionDataList[regionGroupKey] then
		WorldMapWindow.regionDataList[regionGroupKey] = regionGroupInfo;
	elseif 	WorldMapWindow.infoNodeKeyType == WorldMapWindow.EnumInfoNodeKeyType.eInfoNodeKeyType_Region and (nil ~= WorldMapWindow.popupManager:get_if_infoNodeKey(regionGroupKey)) then
		-- 같은 노드가 추가되었다는 것은, 해당 노드의 탐험정보가 갱신되었다는 것이다.
		-- 따라서 인포메뉴를 갱신해준다.
		WorldMapWindow_CloseAllSubPanel()
	end
end

function WorldMapWindow_OnScreenResize()
	if WorldMapWindow.isFullScreen == true then
		Panel_Win_Worldmap:SetSize(getScreenSizeX(), getScreenSizeY() + 10);
		WorldMapWindow.world3DMapStatic:SetPosX(0, 0);
		WorldMapWindow.world3DMapStatic:SetSize(getScreenSizeX(), getScreenSizeY());
		WorldMapWindow.world3DMapStatic:SetEnableArea(0,0,getScreenSizeX(), getScreenSizeY());

		for index, value in pairs(WorldMapWindow.uiList) do
			value:SetSize(getScreenSizeX(), getScreenSizeY())
		end

	end
end


-- 노드와 actor Icon 의 Alpha 값 변경을 해주는 Ani 업데이트 함수.
function WorldMapWindow_Update_NodeAlphaChangeAnimation( doUpdateForce )
	if ( false == Panel_Win_Worldmap:GetShow() ) then
		WorldMapWindow.ViewDetailModeNodeAlpha = 0
		return
	end
	if ( WorldMapWindow.rendering == true ) then
	-- doUpdateForce = nil 이면, false 로 바꿔준다!
		local needToSetShowUpdate = doUpdateForce or false
		local needToAlphaUpdate = doUpdateForce or false

		local detailMode = WorldMapWindow.ViewDetailMode

		local nodeAlpha = WorldMapWindow.ViewDetailModeNodeAlpha
		local iconShow = WorldMapWindow.ViewDetailModeIconShow
		local nodeShow = WorldMapWindow.ViewDetailModeNodeShow

		if not needToSetShowUpdate then
			needToSetShowUpdate = not ((detailMode and 0 == nodeAlpha and iconShow) or (not detailMode and 1 == nodeAlpha and nodeShow))
		end
		if not needToAlphaUpdate then
			needToAlphaUpdate = (detailMode and 0 ~= nodeAlpha) or (not detailMode and 1 ~= nodeAlpha)
		end
		
		-- 변경할 Alpha 값을 계산!
		if needToAlphaUpdate then
			if detailMode then
				nodeAlpha = nodeAlpha - 0.1
				if nodeAlpha <= 0 then		-- 값 범위 보정
					nodeAlpha = 0
				end
			else
				nodeAlpha = nodeAlpha + 0.1
				if 1 <= nodeAlpha then		-- 값 범위 보정
					nodeAlpha = 1.0
				end
			end
		end

		-- Alpha 값이 변경되었으니, 다시 한번 SetShow 를 변경해야 하는지 확인해야 한다!
		if not needToSetShowUpdate then
			needToSetShowUpdate = not ((detailMode and 0 == nodeAlpha and iconShow) or (not detailMode and 1 == nodeAlpha and nodeShow))
		end

		if not needToSetShowUpdate and not needToAlphaUpdate then
			return;
		end

		-- 변경해야 한다면, 변경할 SetShow 값을 계산!
		if needToSetShowUpdate then
			iconShow = 1 ~= nodeAlpha
			nodeShow = 0 ~= nodeAlpha
		end

		WorldMapWindow.ViewDetailModeIconShow = iconShow
		WorldMapWindow.ViewDetailModeNodeShow = nodeShow
		WorldMapWindow.ViewDetailModeNodeAlpha = nodeAlpha
		local iconAlpha = 1 - nodeAlpha

		-- 알파값, SetShow 상태등을 변경!
		-- Territory Line 도 같이 Alpha 를 적용하기가 힘들다! 그냥 바로 꺼버린다!
		-- if nil ~= WorldMapWindow_ExploreText_AlphaChangeAnimation then
			-- WorldMapWindow_ExploreText_AlphaChangeAnimation( needToAlphaUpdate, needToSetShowUpdate, nodeAlpha, nodeShow )
		-- end
		if nil ~= WorldMapWindow_NodeButton_AlphaChangeAnimation then
			WorldMapWindow_NodeButton_AlphaChangeAnimation( needToAlphaUpdate, needToSetShowUpdate, nodeAlpha, nodeShow )
		end

		-- Actor들의 아이콘  Alpha Animation 을 처리해주는 함수!
		if nil ~= WorldMapWindow_ActorIcon_AlphaChangeAnimation then
			WorldMapWindow_ActorIcon_AlphaChangeAnimation( needToAlphaUpdate, needToSetShowUpdate, iconAlpha, iconShow )
		end

		-- 고정집 아이콘들의 Alpha Animation 을 처리해주는 함수!
		if nil ~= WorldMapWindow_HouseholdIcon_AlphaChangeAnimation then
			WorldMapWindow_HouseholdIcon_AlphaChangeAnimation( needToAlphaUpdate, needToSetShowUpdate, iconAlpha, iconShow, true )
		end

		if nil ~= WorldMapWindow_HouseholdIcon_AlphaChangeAnimation then
			WorldMapWindow_HouseholdIcon_AlphaChangeAnimation( needToAlphaUpdate, needToSetShowUpdate, nodeAlpha, nodeShow, false )
		end
	else
		--WorldMapWindow.renderingAlpha = WorldMapWindow.renderingAlpha + 0.03
		--if ( 1 < WorldMapWindow.renderingAlpha ) then
		--	WorldMapWindow.renderingAlpha = 1
		--end
		WorldMapWindow.ViewDetailModeNodeAlpha = WorldMapWindow.ViewDetailModeNodeAlpha + 0.1
		if ( 1 < WorldMapWindow.ViewDetailModeNodeAlpha ) then
			WorldMapWindow.ViewDetailModeNodeAlpha = 1
		end

		if nil ~= WorldMapWindow_NodeButton_AlphaChangeAnimation then
			WorldMapWindow_NodeButton_AlphaChangeAnimation( true, true, WorldMapWindow.ViewDetailModeNodeAlpha, true )
		end

		-- Actor들의 아이콘  Alpha Animation 을 처리해주는 함수!
		if nil ~= WorldMapWindow_ActorIcon_AlphaChangeAnimation then
			WorldMapWindow_ActorIcon_AlphaChangeAnimation( true, true, 0, false )
		end

		-- 고정집 아이콘들의 Alpha Animation 을 처리해주는 함수!
		if nil ~= WorldMapWindow_HouseholdIcon_AlphaChangeAnimation then
			WorldMapWindow_HouseholdIcon_AlphaChangeAnimation( true, true, 0, true )
		end

		-- 고정집 아이콘들의 Alpha Animation 을 처리해주는 함수!
		if nil ~= WorldMapWindow_HouseholdIcon_AlphaChangeAnimation then
			WorldMapWindow_HouseholdIcon_AlphaChangeAnimation( true, true, WorldMapWindow.ViewDetailModeNodeAlpha, true, false )
		end

		if nil ~= WorldMapWindow_HouseholdIcon_AlphaChangeAnimation then
			WorldMapWindow_HouseholdIcon_AlphaChangeAnimation( true, true, 0, true, true )
		end
	end
end
-- 처음 한번 초기화 할때는 강제로 업데이트 해준다!
WorldMapWindow_Update_NodeAlphaChangeAnimation( true )

local WMRS_NOT_RENDER = 0
local WMRS_RENDER = 1
local WMRS_FADE_IN = 2
local WMRS_FADE_OUT = 3
local WMRS_RENDER_DEBUG = 4

function WorldMapWindow_ChangeState( prevState, nextState )
	if ( prevState == WMRS_NOT_RENDER ) and ( nextState == WMRS_FADE_IN ) then
		WorldMapWindow.renderingAlpha = 0.0
		WorldMapWindow.ViewDetailModeNodeAlpha = 0
	elseif ( prevState == WMRS_FADE_IN ) and ( nextState == WMRS_RENDER ) then
		WorldMapWindow.rendering = true
		WorldMapWindow.renderingAlpha = 1
		if (true ~= WorldMapWindow.isLuaCall) then
			if ( 0 < getWorldMapOpenWaypointKeyCount() ) then
    			local nodeKey = getWorldMapOpenWaypointKey(0)
    			WorldMapWindow_OnNodeClick(nodeKey, true, false)
			end
		end
		if ( WorldMapWindow.isInterActionCall ) then
			local actor = interaction_getInteractable()
			if ( actor:get():isHouseHold() ) then
				local houseInfoWrapper = ToClient_GetHouseInfoStaticStatusWrapper(actor:getCharacterKeyRaw())
				if ( nil == houseInfoWrapper ) then
					return
				end
				WorldMapWindow_OnNodeClick(houseInfoWrapper:getParentNodeKey(), true, false)
				WorldMapWindow_OnOpenHouseholdByCharacterKey( actor:getCharacterKeyRaw() )
			end
		end
	elseif ( prevState == WMRS_RENDER ) and ( nextState == WMRS_FADE_OUT ) then
		WorldMapWindow.rendering = false
	end
end


function Panel_Win_Worldmap_KeyGuide_ShowFunc()
	local posX = getMousePosX()
	local posY = getMousePosY()
	
	_worldMap_KeyGuide:SetShow( false )
	_worldMap_KeyGuide:SetText( PAGetString(Defines.StringSheet_GAME, "LUA_WORLDMAP_TEXT_KEYGUIDE") ) -- "CTRL : 길드원에게 위치 알리기\nALT : 파티원에게 위치 알리기"
	_worldMap_KeyGuide:SetSize( _worldMap_KeyGuide:GetTextSizeX() + 10, _worldMap_KeyGuide:GetTextSizeY() + 10 )

	_worldMap_KeyGuide:SetPosX( posX + 30 )
	_worldMap_KeyGuide:SetPosY( posY + 15 )
end


------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------
------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------

Panel_Win_Worldmap:RegisterUpdateFunc( "Panel_Win_Worldmap_KeyGuide_ShowFunc" )