local _Util_Math = Util.Math
local UI_TYPE		= CppEnums.PA_UI_CONTROL_TYPE

-------------------------------------------------------------
-- Self Player Icon
-------------------------------------------------------------
-- 내 텐트가 있느냐 없느냐 체크하는 변수!
MyHouseNavi_ExistSelfTent = false

local icon_SelfPlayer		= UI.getChildControl( Panel_Win_Worldmap, "Static_Icon_Char_User" );
WorldMapWindow.uiList[0]:AddChild(icon_SelfPlayer)
Panel_Win_Worldmap:RemoveControl(icon_SelfPlayer)

local selfArrowSize = {
	width	= icon_SelfPlayer:GetSizeX(),
	height	= icon_SelfPlayer:GetSizeY()
};
icon_SelfPlayer:SetShow(true);

local WorldMapWindow_SelfPlayerIcon_UpdatePosition = function()
	if not Panel_Win_Worldmap:GetShow() then
		return;
	end

	local cameraPos = getWorldMapCameraPos();

	local selfPos = float3(getSelfPlayer():get():getPositionX(), getSelfPlayer():get():getPositionY(), getSelfPlayer():get():getPositionZ());
	local pos2D = worldmapScenetoScreenPosition(selfPos.x, selfPos.y, selfPos.z);

	pos2D.x 		= pos2D.x * WorldMapWindow.world3DMapStatic:GetSizeX();
	pos2D.y 		= pos2D.y * WorldMapWindow.world3DMapStatic:GetSizeY();

	local nodeSize = _Util_Math.calculateDepthScaler( selfPos, selfArrowSize );

	icon_SelfPlayer:SetSize(nodeSize.width, nodeSize.height);
	icon_SelfPlayer:SetPosX(pos2D.x - icon_SelfPlayer:GetSizeX() / 2);
	icon_SelfPlayer:SetPosY(pos2D.y - icon_SelfPlayer:GetSizeY() + (math.sin(getTickCount32() / 1000 * math.pi * 2) + 1) * 2);
	icon_SelfPlayer:SetDepth(WorldMapWindow_GetDepthFromPos3D(cameraPos, selfPos));
end

-------------------------------------------------------------
-- My Vehicle Icon X 2 ( 지상, 육지 )
-------------------------------------------------------------

local	baseicon_MyVehicle	= UI.getChildControl( Panel_Win_Worldmap, "Static_VehiclePosition" )
local	baseicon_MyNauticalVehicle	= UI.getChildControl( Panel_Win_Worldmap, "Static_ShipPosition" )
local	icon_MyLandVehicle	= UI.createControl( CppEnums.PA_UI_CONTROL_TYPE.PA_UI_CONTROL_STATIC, WorldMapWindow.uiList[WorldMapWindow.RenderType.WMS_EXPLORE_PLANT], "Static_LandVehicle" )
local	icon_MySeaVehicle	= UI.createControl( CppEnums.PA_UI_CONTROL_TYPE.PA_UI_CONTROL_STATIC, WorldMapWindow.uiList[WorldMapWindow.RenderType.WMS_EXPLORE_PLANT], "Static_SeaVehicle" )

CopyBaseProperty( baseicon_MyVehicle,	icon_MyLandVehicle )
CopyBaseProperty( baseicon_MyNauticalVehicle,	icon_MySeaVehicle )

local myVehicleArrowSize = {
	width	= baseicon_MyVehicle:GetSizeX(),
	height	= baseicon_MyVehicle:GetSizeY()
};

icon_MyLandVehicle:SetShow(false)
icon_MySeaVehicle:SetShow(false)

-------------------------------------------------------------
-- My Horse Icon
-------------------------------------------------------------
function	WorldMapWindow_MyHorseIcon_UpdatePosition()
	local	servantType	= CppEnums.ServantType.Type_Vehicle
	WorldMapWindow_MyVehicleIcon_UpdatePosition( servantType, icon_MyLandVehicle )
end

-------------------------------------------------------------
-- My Ship(Boat) Icon
-------------------------------------------------------------

function	WorldMapWindow_MyShipIcon_UpdatePosition()
	local	servantType	= CppEnums.ServantType.Type_Ship
	WorldMapWindow_MyVehicleIcon_UpdatePosition( servantType, icon_MySeaVehicle )
end

-------------------------------------------------------------
-- My Vehicle Icon XXX
-------------------------------------------------------------
function	WorldMapWindow_MyVehicleIcon_UpdatePosition( servantType, icon )
	local	temporaryWrapper= getTemporaryInformationWrapper()
	if	(nil == temporaryWrapper)	then
		icon:SetShow(false)
		return
	end
	
	local	servantInfo	= temporaryWrapper:getUnsealVehicle( servantType )
	if	( nil == servantInfo )	then
		icon:SetShow(false)
		return
	end
	
	local position = float3(servantInfo:getPositionX(), servantInfo:getPositionY(), servantInfo:getPositionZ());
	pos2D = worldmapScenetoScreenPosition(position.x, position.y, position.z);
	pos2D.x 		= pos2D.x * WorldMapWindow.world3DMapStatic:GetSizeX();
	pos2D.y 		= pos2D.y * WorldMapWindow.world3DMapStatic:GetSizeY();

	local cameraPos = getWorldMapCameraPos();

	nodeSize = _Util_Math.calculateDepthScaler( position, myVehicleArrowSize );
	
	if ( true == ToClient_worldmap_isTownMode() ) then
		nodeSize.width = nodeSize.width * 0.2
		nodeSize.height = nodeSize.height * 0.2
	end
	
	if ( nodeSize.width > myVehicleArrowSize.width) then
		nodeSize.width = myVehicleArrowSize.width
		nodeSize.height = myVehicleArrowSize.height
	end	
	
	icon:SetSize(nodeSize.width, nodeSize.height);
	icon:SetPosX(pos2D.x - icon:GetSizeX() / 2);
	icon:SetPosY(pos2D.y - icon:GetSizeY() + (math.sin(getTickCount32() / 1000 * math.pi * 2) + 1) * 2);
	icon:SetShow(true);

	icon:SetDepth(0);
	
	if( WorldMapWindow._btn_Position_Check == false ) then	
		icon:SetShow(false);
	end
end
-------------------------------------------------------------
-- My Tent Icon
-------------------------------------------------------------
local icon_MyTent	= UI.getChildControl( Panel_Win_Worldmap, "Static_TentPosition" )
WorldMapWindow.uiList[WorldMapWindow.RenderType.WMS_EXPLORE_PLANT]:AddChild( icon_MyTent )
Panel_Win_Worldmap:RemoveControl(icon_MyTent		)
icon_MyTent:SetIgnore(false)
icon_MyTent:addInputEvent( "Mouse_On", "Panel_Worldmap_TentInfo_Update( true )" )
icon_MyTent:addInputEvent( "Mouse_Out", "Panel_Worldmap_TentInfo_Update( false )" )

local myTentArrowSize = {
	width	= icon_MyTent:GetSizeX(),
	height	= icon_MyTent:GetSizeY()
}
icon_MyTent:SetShow(false)
Panel_Worldmap_TentInfo:SetShow( false )
Panel_Worldmap_TentInfo:RegisterUpdateFunc( "Panel_Worldmap_TentInfo_UpdateFrame" )

----------------------------------------------------------------
--					텃밭 위치를 박아줍시다
----------------------------------------------------------------
local WorldMapWindow_MyTentIcon_UpdatePosition = function()
	local	temporaryWrapper= getTemporaryInformationWrapper()
	if	(nil ~= temporaryWrapper) and temporaryWrapper:isSelfTent()	then
		local tentPos = float3(temporaryWrapper:getSelfTentPositionX(), temporaryWrapper:getSelfTentPositionY(), temporaryWrapper:getSelfTentPositionZ());
		pos2D = worldmapScenetoScreenPosition(tentPos.x, tentPos.y, tentPos.z)
		pos2D.x 		= pos2D.x * WorldMapWindow.world3DMapStatic:GetSizeX()
		pos2D.y 		= pos2D.y * WorldMapWindow.world3DMapStatic:GetSizeY()

		local cameraPos = getWorldMapCameraPos();

		nodeSize = _Util_Math.calculateDepthScaler( tentPos, myTentArrowSize );
		
		if ( true == ToClient_worldmap_isTownMode() ) then
			nodeSize.width = nodeSize.width * 0.2
			nodeSize.height = nodeSize.height * 0.2
		end
		
		if ( nodeSize.width > myTentArrowSize.width) then
			nodeSize.width = myTentArrowSize.width
			nodeSize.height = myTentArrowSize.height
		end
		icon_MyTent:SetSize(nodeSize.width, nodeSize.height);
		icon_MyTent:SetPosX(pos2D.x - icon_MyTent:GetSizeX() / 2);
		icon_MyTent:SetPosY(pos2D.y - icon_MyTent:GetSizeY() + (math.sin(getTickCount32() / 1000 * math.pi * 2) + 1) * 2);
		icon_MyTent:SetShow(true)
		MyHouseNavi_ExistSelfTent = true

		icon_MyTent:SetDepth(0)
	else
		icon_MyTent:SetShow(false)
		Panel_Worldmap_TentInfo:SetShow( false )
		MyHouseNavi_ExistSelfTent = false
	end
	
	if( WorldMapWindow._btn_Position_Check == false ) then	
		icon_MyTent:SetShow(false)
		Panel_Worldmap_TentInfo:SetShow( false )
	end
end


----------------------------------------------------------------
--				텃밭 정보 창을 열어주는 곳
----------------------------------------------------------------
local _tentTitle = UI.getChildControl ( Panel_Worldmap_TentInfo, "StaticText_Title" )
local _remainTime = UI.getChildControl ( Panel_Worldmap_TentInfo, "StaticText_V_RemainTime" )
local _workingDataBg = UI.getChildControl ( Panel_Worldmap_TentInfo, "Static_HouseControl_BG" )
local _workingListBg = UI.getChildControl ( Panel_Worldmap_TentInfo, "Static_C_BG" )
local _workingText = UI.getChildControl ( Panel_Worldmap_TentInfo, "StaticText_T_ProCount" )


local workingRawSizeY = 0
local defaultWorkingListSize = 0
local defaultWorkingDataSizeWithoutList = 0
local defaultWorkingPanelSizeWithoutList = 0

local template = {
	_iconSlot	= UI.getChildControl ( Panel_Worldmap_TentInfo, "Static_C_IconSlot" ),
	_icon		= UI.getChildControl ( Panel_Worldmap_TentInfo, "Static_C_Icon" ),
	_itemName	= UI.getChildControl ( Panel_Worldmap_TentInfo, "StaticText_C_ItemName" ),
	_gageBg		= UI.getChildControl ( Panel_Worldmap_TentInfo, "Static_C_GaugeBG" ),
	_progress	= UI.getChildControl ( Panel_Worldmap_TentInfo, "Progress2_C_Gauge" ),
	_percent	= UI.getChildControl ( Panel_Worldmap_TentInfo, "StaticText_C_Percent" ),
}

local createList = {}
	-- key : index
	-- value : { _iconSlot, _icon, _itemName, _gageBg, _progress, _percent,  }

local initTentInfo = function()
	for _, value in pairs(template) do
		workingRawSizeY = math.max(workingRawSizeY, value:GetSizeY() )
		value:SetShow(false)
	end
	workingRawSizeY = workingRawSizeY + 1

	defaultWorkingListSize = _workingListBg:GetSizeY() - workingRawSizeY
	defaultWorkingDataSizeWithoutList = _workingDataBg:GetSizeY() - _workingListBg:GetSizeY()
	defaultWorkingPanelSizeWithoutList = Panel_Worldmap_TentInfo:GetSizeY() - _workingListBg:GetSizeY()

	local maxCount = ToClient_GetMaxHarvestCount()
	local pushYValue = 0
	for index = 0, maxCount -1 do
		local dataGroup = {}
		dataGroup._iconSlot = UI.createControl( UI_TYPE.PA_UI_CONTROL_STATIC, Panel_Worldmap_TentInfo, 'Static_C_IconSlot_' .. index)
		CopyBaseProperty( template._iconSlot, dataGroup._iconSlot )
		dataGroup._iconSlot:SetPosY( template._iconSlot:GetPosY() + pushYValue )

		dataGroup._icon = UI.createControl( UI_TYPE.PA_UI_CONTROL_STATIC, Panel_Worldmap_TentInfo, 'Static_C_Icon_' .. index)
		CopyBaseProperty( template._icon, dataGroup._icon )
		dataGroup._icon:SetPosY( template._icon:GetPosY() + pushYValue )

		dataGroup._itemName = UI.createControl( UI_TYPE.PA_UI_CONTROL_STATICTEXT, Panel_Worldmap_TentInfo, 'StaticText_C_ItemName_' .. index)
		CopyBaseProperty( template._itemName, dataGroup._itemName )
		dataGroup._itemName:SetPosY( template._itemName:GetPosY() + pushYValue )

		dataGroup._gageBg = UI.createControl( UI_TYPE.PA_UI_CONTROL_STATIC, Panel_Worldmap_TentInfo, 'Static_C_GaugeBG_' .. index)
		CopyBaseProperty( template._gageBg, dataGroup._gageBg )
		dataGroup._gageBg:SetPosY( template._gageBg:GetPosY() + pushYValue )
		
		dataGroup._progress = UI.createControl( UI_TYPE.PA_UI_CONTROL_PROGRESS2, Panel_Worldmap_TentInfo, 'Progress2_C_Gauge_' .. index)
		CopyBaseProperty( template._progress, dataGroup._progress )
		dataGroup._progress:SetPosY( template._progress:GetPosY() + pushYValue )

		dataGroup._percent = UI.createControl( UI_TYPE.PA_UI_CONTROL_STATICTEXT, Panel_Worldmap_TentInfo, 'StaticText_C_Percent_' .. index)
		CopyBaseProperty( template._percent, dataGroup._percent )
		dataGroup._percent:SetPosY( template._percent:GetPosY() + pushYValue )


		createList[index] = dataGroup

		pushYValue = pushYValue + workingRawSizeY
	end
end

function Panel_Worldmap_TentInfo_Update( isOn )
	local temporaryWrapper= getTemporaryInformationWrapper()	
	if	(nil == temporaryWrapper) or false == temporaryWrapper:isSelfTent()	then
		Panel_Worldmap_TentInfo:SetShow( false )
		return
	end

	local expireTime = temporaryWrapper:getSelfTentExpiredTime_64();
	local lefttimeText = convertStringFromDatetime(getLeftSecond_TTime64(temporaryWrapper:getSelfTentExpiredTime_64()));
		
	_remainTime:SetText( lefttimeText )
	if ( isOn == true ) then
		local temporaryWrapper= getTemporaryInformationWrapper()	
		if	(nil == temporaryWrapper) or false == temporaryWrapper:isSelfTent()	then
			Panel_Worldmap_TentInfo:SetShow( false )
			return
		end

	
		local maxCount = ToClient_GetMaxHarvestCount()
		local count = temporaryWrapper:getSelfHarvestCount()

		for index = 0, maxCount -1 do
			local dataGroup = createList[index]
			if ( index < count ) then
				local harvestCharacterSSW = temporaryWrapper:getSelfHarvest(index)
				local percent = math.min(temporaryWrapper:getSelfHarvestCompleteRate(index) * 100, 100)

				local objectSSW = harvestCharacterSSW:getObjectStaticStatus()

				local iconPath = objectSSW:getHouseScreenShotPath(0)
			
				if ( nil ~= iconPath ) and ( "" ~= iconPath ) then
					dataGroup._icon:SetShow(true)
					dataGroup._icon:ChangeTextureInfoName(iconPath)
				else
					dataGroup._icon:SetShow(false)
				end
				dataGroup._itemName:SetText( harvestCharacterSSW:getName() )
				dataGroup._progress:SetProgressRate( percent )
				dataGroup._percent:SetText(math.floor(percent) .. "%")

				dataGroup._iconSlot	:SetShow(true)
				dataGroup._itemName	:SetShow(true)
				dataGroup._gageBg	:SetShow(true)
				dataGroup._progress	:SetShow(true)
				dataGroup._percent	:SetShow(true)
			else
				dataGroup._iconSlot	:SetShow(false)
				dataGroup._icon		:SetShow(false)
				dataGroup._itemName	:SetShow(false)
				dataGroup._gageBg	:SetShow(false)
				dataGroup._progress	:SetShow(false)
				dataGroup._percent	:SetShow(false)
			end
		end

		if ( count <= 0 ) then
			_workingListBg:SetShow(false)
			_workingText:SetShow(false)
		else
			_workingListBg:SetShow(true)
			_workingText:SetShow(true)

			_workingListBg:SetSize( _workingListBg:GetSizeX(), workingRawSizeY * ( count ) + defaultWorkingListSize )
			_workingDataBg:SetSize( _workingDataBg:GetSizeX() , defaultWorkingDataSizeWithoutList + _workingListBg:GetSizeY() )
			Panel_Worldmap_TentInfo:SetSize( Panel_Worldmap_TentInfo:GetSizeX() , defaultWorkingPanelSizeWithoutList + _workingListBg:GetSizeY() )
		end

        if ( false == Panel_Worldmap_TentInfo:IsShow() ) then
    		Panel_Worldmap_TentInfo:SetPosX( icon_MyTent:GetPosX() - ( ( Panel_Worldmap_TentInfo:GetSizeX() / 2 ) - ( icon_MyTent:GetSizeX() / 2 ) ) )
    		Panel_Worldmap_TentInfo:SetPosY( icon_MyTent:GetPosY() - Panel_Worldmap_TentInfo:GetSizeY() )
		end
		Panel_Worldmap_TentInfo:SetShow( true )
	else
		Panel_Worldmap_TentInfo:SetShow( false )
	end

	
end

function Panel_Worldmap_TentInfo_UpdateFrame( deltaTime )
	local temporaryWrapper = getTemporaryInformationWrapper()	
	if	(nil == temporaryWrapper) or false == temporaryWrapper:isSelfTent()	then
		Panel_Worldmap_TentInfo:SetShow( false )
		return
	end

	
	local maxCount = ToClient_GetMaxHarvestCount()
	local count = temporaryWrapper:getSelfHarvestCount()

	for index = 0, maxCount -1 do
		local dataGroup = createList[index]
		if ( index < count ) then
			local harvestCharacterSSW = temporaryWrapper:getSelfHarvest(index)
			local percent = math.min(temporaryWrapper:getSelfHarvestCompleteRate(index) * 100, 100)

			dataGroup._progress:SetProgressRate( percent )
			dataGroup._percent:SetText(math.floor(percent) .. "%")
		end
	end

	Panel_Worldmap_TentInfo:SetPosX( icon_MyTent:GetPosX() - ( ( Panel_Worldmap_TentInfo:GetSizeX() / 2 ) - ( icon_MyTent:GetSizeX() / 2 ) ) )
	Panel_Worldmap_TentInfo:SetPosY( icon_MyTent:GetPosY() - Panel_Worldmap_TentInfo:GetSizeY() )
end

initTentInfo()

-------------------------------------------------------------
-- DeadBody Icon
-------------------------------------------------------------

local template_MyDeadBody	= UI.getChildControl( Panel_Win_Worldmap, "Static_DeadPosition" );
local myDeadBodyArrowSize = {
	width	= template_MyDeadBody:GetSizeX(),
	height	= template_MyDeadBody:GetSizeY()
};
template_MyDeadBody:SetShow(false);

local deadBodyControl = {}

local clearDeadBodyControl = function()
	for idx,control in ipairs (deadBodyControl) do
		if nil ~= control then
			UI.deleteControl( control )
		end
	end	
	
	deadBodyControl = {}
end


local WorldMapWindow_MyDeadBodyIcon_UpdatePosition = function()
	clearDeadBodyControl()
	local	temporaryWrapper = getTemporaryInformationWrapper()
	if	(nil ~= temporaryWrapper)	then
		local deadBodyCount = temporaryWrapper:getSelfDeadBodyCount()
		if (0 < deadBodyCount) then
			for deadbodyIndex = 1, deadBodyCount, 1 do
				local icon_MyDeadBody = UI.createControl( UI_TYPE.PA_UI_CONTROL_STATIC, WorldMapWindow.uiList[WorldMapWindow.RenderType.WMS_EXPLORE_PLANT], 'SelfDeadBody_' .. deadbodyIndex)
				deadBodyControl[deadbodyIndex] = icon_MyDeadBody
				CopyBaseProperty( template_MyDeadBody, icon_MyDeadBody )
				local deadBodyPositionX = temporaryWrapper:getSelfDeadBodyPosition(deadbodyIndex-1, 1);
				local deadBodyPositionY = temporaryWrapper:getSelfDeadBodyPosition(deadbodyIndex-1, 2);
				local deadBodyPositionZ = temporaryWrapper:getSelfDeadBodyPosition(deadbodyIndex-1, 3);
				local deadBodyPos = float3(deadBodyPositionX, deadBodyPositionY, deadBodyPositionZ);
				pos2D = worldmapScenetoScreenPosition(deadBodyPos.x, deadBodyPos.y, deadBodyPos.z);
				pos2D.x 		= pos2D.x * WorldMapWindow.world3DMapStatic:GetSizeX();
				pos2D.y 		= pos2D.y * WorldMapWindow.world3DMapStatic:GetSizeY();

				local cameraPos = getWorldMapCameraPos();

				nodeSize = _Util_Math.calculateDepthScaler( deadBodyPos, myDeadBodyArrowSize );
				icon_MyDeadBody:SetSize(nodeSize.width, nodeSize.height);
				icon_MyDeadBody:SetPosX(pos2D.x - icon_MyDeadBody:GetSizeX() / 2);
				icon_MyDeadBody:SetPosY(pos2D.y - icon_MyDeadBody:GetSizeY() + (math.sin(getTickCount32() / 1000 * math.pi * 2) + 1) * 2);
				icon_MyDeadBody:SetShow(true);
				icon_MyDeadBody:SetDepth(0);
				
				if( WorldMapWindow._btn_Position_Check == false ) then	
					icon_MyDeadBody:SetShow(false);
				end
			end
		end	
	end
end

-------------------------------------------------------------
-- Party Icon
-------------------------------------------------------------

local	baseicon_Party	= UI.getChildControl( Panel_Win_Worldmap, "Static_PartyPosition" )
local	icon_PartyList	= {}

local 	icon_Party = nil
for ii=0, _maxPartyMemberCount-1 do
	icon_Party = UI.createControl( CppEnums.PA_UI_CONTROL_TYPE.PA_UI_CONTROL_STATIC, WorldMapWindow.uiList[WorldMapWindow.RenderType.WMS_EXPLORE_PLANT], "Static_PartyPosition_"..ii )
	CopyBaseProperty( baseicon_Party,	icon_Party )
	icon_Party:SetShow(false)
	icon_Party:addInputEvent("Mouse_On","WorldMapWindow_PartyIcon_OnShowTooltip(" .. ii .. ",true)")
	icon_Party:addInputEvent("Mouse_Out","WorldMapWindow_PartyIcon_OnShowTooltip(" .. ii .. ",false)")

	icon_PartyList[ii] = icon_Party;
end

function WorldMapWindow_PartyIcon_GetPartyIcon( index )
	return icon_PartyList[index]
end

function WorldMapWindow_PartyIcon_OnShowTooltip( index, isShow )
	if ( isShow ) then
		local memberData = RequestParty_getPartyMemberAt(index)
		if ( nil == memberData ) then
			return
		end

		WorldMap_IconName.save_partyIndex = index
		WorldMap_IconName.tooltipType = eTooltipType.party
		WorldMap_IconName.text_Name = memberData:name()
		WorldMap_IconName:Set_Name()
	else
		if ( WorldMap_IconName.save_partyIndex == index ) and ( eTooltipType.party == WorldMap_IconName.tooltipType ) then
			WorldMap_IconName.text_Name = nil
			WorldMap_IconName.save_partyIndex = nil
			WorldMap_IconName.control_Frame:SetShow(false)
			WorldMap_IconName.control_Name:SetShow(false)
			WorldMap_IconName.tooltipType = eTooltipType.count
		end
	end
end

local partyArrowSize = {
	width	= baseicon_Party:GetSizeX(),
	height	= baseicon_Party:GetSizeY()
}

function	WorldMapWindow_PartyIcon_UpdatePosition()
	if not Panel_Win_Worldmap:GetShow() then
		return;
	end
	
	local partyMemberCount = RequestParty_getPartyMemberCount()
	if (partyMemberCount < 1) then
		for ii=0, _maxPartyMemberCount-1 do
			icon_PartyList[ii]:SetShow(false)	
		end
		return
	end
	
	local memberData, position, cameraPos, pos2D = nil
	for index=0, partyMemberCount-1 do
		memberData = RequestParty_getPartyMemberAt(index)
		if (nil == memberData) then
			break
		end
		
		if (memberData:getActorKey() ~= getSelfPlayer():getActorKey() ) then
			local playerActorProxyWrapper = getPlayerActor(memberData:getActorKey())
			
			position 	= float3(memberData:getPositionX(), memberData:getPositionY(), memberData:getPositionZ() )
			pos2D 		= worldmapScenetoScreenPosition(position.x, position.y, position.z);
			pos2D.x 	= pos2D.x * WorldMapWindow.world3DMapStatic:GetSizeX();
			pos2D.y 	= pos2D.y * WorldMapWindow.world3DMapStatic:GetSizeY();
		
			cameraPos 	= getWorldMapCameraPos();
			
			nodeSize 	= _Util_Math.calculateDepthScaler( position, partyArrowSize );
			icon_PartyList[index]:SetSize(nodeSize.width/2, nodeSize.height/2);
			icon_PartyList[index]:SetPosX(pos2D.x - icon_PartyList[index]:GetSizeX() / 2);
			icon_PartyList[index]:SetPosY(pos2D.y - icon_PartyList[index]:GetSizeY() + (math.sin(getTickCount32() / 1000 * math.pi * 2) + 1) * 2);
			icon_PartyList[index]:SetShow(true);

			icon_PartyList[index]:SetDepth(0);
			
			if( WorldMapWindow._btn_Position_Check == false ) then	
				icon_PartyList[index]:SetShow(false);
			end
		end	
	end
end

-------------------------------------------------------------
-- Common - Actor Position Update
-------------------------------------------------------------

function WorldMapWindow_SpecialActorIcon_PositionUpdate()
	if not Panel_Win_Worldmap:GetShow() then
		return;
	end

	WorldMapWindow_SelfPlayerIcon_UpdatePosition()
	WorldMapWindow_MyHorseIcon_UpdatePosition()
	WorldMapWindow_MyShipIcon_UpdatePosition()
	WorldMapWindow_MyTentIcon_UpdatePosition()
	WorldMapWindow_MyDeadBodyIcon_UpdatePosition()
	WorldMapWindow_PartyIcon_UpdatePosition()
end

-------------------------------------------------------------
-- Worker Icon
-------------------------------------------------------------

local WorkerActorList = {};
local WorkerIconOriginal = UI.getChildControl( Panel_Win_Worldmap, "Static_IconWorking" );

function WorldMapWindow_MyWorkerUpdate(workerNo, workerStaticStatusKey, workerState, posX, posY, posZ)
	if not Panel_Win_Worldmap:GetShow() then
		return;
	end
	
	local workerKey = Int64toInt32(workerNo);

	if WorkerActorList[workerKey] == nil then
		WorkerActorList[workerKey] = UI.createControl( UI_TYPE.PA_UI_CONTROL_STATIC, WorldMapWindow.uiList[WorldMapWindow.RenderType.WMS_EXPLORE_PLANT], "Static_WorkerActorIcon_" .. tostring(workerNo) );
		CopyBaseProperty( WorkerIconOriginal, WorkerActorList[workerKey]);
		--WorkerActorList[workerKey]:SetShow(true);
	end

	--이동중에만 보이는것으로 수정함.	
	if ( CppEnums.NpcWorkerState.NWS_GOWORK == workerState ) or ( CppEnums.NpcWorkerState.NWS_GOHOME == workerState ) then
		WorkerActorList[workerKey]:SetShow(true)
	else
		WorkerActorList[workerKey]:SetShow(false)
		return
	end

	local pos2D = worldmapScenetoScreenPosition(posX, posY, posZ);

	pos2D.x 		= pos2D.x * WorldMapWindow.world3DMapStatic:GetSizeX();
	pos2D.y 		= pos2D.y * WorldMapWindow.world3DMapStatic:GetSizeY();

	WorkerActorList[workerKey]:SetDepth(WorldMapWindow_GetDepthFromPos3D(getWorldMapCameraPos(), float3(posX, posY, posZ)));

	WorkerActorList[workerKey]:SetPosX(pos2D.x - WorkerIconOriginal:GetSizeX() / 2);
	WorkerActorList[workerKey]:SetPosY(pos2D.y - WorkerIconOriginal:GetSizeY() / 2);
end

function WorldMapWindow_StopMyWorkerWorking(workerNo, isUserRequest)
	local workerKey = Int64toInt32(workerNo);
	local workerIcon = WorkerActorList[workerKey]

	if nil ~= workerIcon then
		UI.deleteControl( workerIcon )
		WorkerActorList[workerKey] = nil
	end
end

local WorldMapWindow_MyWorkerClear = function()
	for idx, panel in pairs(WorkerActorList) do
		WorldMapWindow_StopMyWorkerWorking(idx, false);
	end
	WorkerActorList = {};
end

-------------------------------------------------------------
-- Actor icons
-------------------------------------------------------------
local actorIcons = {}
--[[
_icon : Static
_type : Template:GetID
_worldPos : float3
]]
local actorIconPool = ControlPool.createPool( Panel_Win_Worldmap )
local actorIconDrawable = false

-- Pool 에 반납해야 한다!
local WorldMapWindow_ActorIcon_Hide = function()
	for _,actorInfo in pairs(actorIcons) do
		actorIconPool:returnToPool( actorInfo._type, actorInfo._icon )
	end
	actorIcons = {}
end

-- Alpha Animation 을 적용
function WorldMapWindow_ActorIcon_AlphaChangeAnimation( needToAlphaUpdate, needToSetShowUpdate, iconAlpha, iconShow )
	-- 호출자에서 needToAlphaUpdate, needToSetShowUpdate 둘다 false 일경우는 호출해주지 않았다!
	for _,actorInfo in pairs(actorIcons) do
		if needToAlphaUpdate then
			actorInfo._icon:SetAlpha( iconAlpha )
		end
		if needToSetShowUpdate then
			actorInfo._icon:SetShow( iconShow )
		end
	end
end

-- Actor Icon 의 위치와 크기를 계산
local ActorIcon_UpdatePos = function(icon, worldPos)
	local nodePosition2D = worldmapScenetoScreenPosition(worldPos.x, worldPos.y , worldPos.z)

	-- 화면 범위를 벗어남
	if (nodePosition2D.x < 0) or (nodePosition2D.y < 0) or (1 < nodePosition2D.x) or (1 < nodePosition2D.y) then
		icon:SetShow( false )
		return
	end
	if (nodePosition2D.z < 0) or (1 < nodePosition2D.z) then
		icon:SetShow( false )
		return
	end

	local sizeValue = { width=3, height=3 }
	sizeValue = _Util_Math.calculateDepthScaler(worldPos, sizeValue);

	nodePosition2D.x 	= nodePosition2D.x * WorldMapWindow.world3DMapStatic:GetSizeX() - sizeValue.width / 2
	nodePosition2D.y 	= nodePosition2D.y * WorldMapWindow.world3DMapStatic:GetSizeY() - sizeValue.height / 2

	icon:SetDepth(WorldMapWindow_GetDepthFromPos3D(getWorldMapCameraPos(), worldPos));
	icon:SetSize(sizeValue.width, sizeValue.height)
	icon:SetPosX(nodePosition2D.x)
	icon:SetPosY(nodePosition2D.y)
end

-- 매 프레임 호출되는 함수!
function WorldMapWindow_ActorIcon_PositionUpdate()
	if not Panel_Win_Worldmap:GetShow() or not WorldMapWindow.ViewDetailModeIconShow then
		return;
	end

	for _,actorInfo in pairs(actorIcons) do
		ActorIcon_UpdatePos( actorInfo._icon, actorInfo._worldPos )
	end
end

-- 아이콘 위치 및 종류 갱신(매 프레임, Actor 마다 호출된다. ActorProxyFactor 를 iteration 돈다)
function WorldMapWindow_ActorIcon_AddOrUpdate( actorProxyWrapper, worldPos, actorData )
	if not Panel_Win_Worldmap:GetShow() or not WorldMapWindow.ViewDetailModeIconShow or not actorIconDrawable then
		return;
	end


	if nil == actorProxyWrapper then
		UI.ASSERT(false,"actorProxy is nil critical!!!")
		return
	end
	if actorProxyWrapper:get():isSelfPlayer() then
		return
	end

	local actorKeyRaw = actorProxyWrapper:getActorKey()
	local actorInfo = actorIcons[actorKeyRaw]

	-- 이전에는 존재하지 않는 Actor 정보였다! 새로 생성한다!
	if nil == actorInfo then
		-- Actor 에 해당하는 아이콘 Template 을 찾는다.
		local template = getActorIcon( actorProxyWrapper, actorData )
		if nil == template then
			return			-- 해당 아이콘이 없는 것들은 표시하지 않는 것들이다!
		end

		local categoryID = template:GetID()		-- template 의 ID 를 caterogy 이름으로 사용한다!
		if not actorIconPool:hasCategory( categoryID ) then
			actorIconPool:addCategory( categoryID, UI_TYPE.PA_UI_CONTROL_STATIC, template, 'Static_Icon_' .. categoryID )
		end
		
		local icon = actorIconPool:getOrCreateControl( categoryID )
		-- _PA_ASSERT( nil ~= icon, '컨트롤 생성에 실패했다니!!!!!' )
		icon:SetIgnore( true )
		icon:SetShow( false )

		actorInfo =
		{
			_icon = icon,
			_type = categoryID,
			_worldPos = float3( worldPos.x, worldPos.y, worldPos.z )
		}
		actorIcons[actorKeyRaw] = actorInfo
	else
		-- World Pos Update!!!!
		actorInfo._worldPos.x = worldPos.x
		actorInfo._worldPos.y = worldPos.y
		actorInfo._worldPos.z = worldPos.z
	end
end

-- 사용하지 않을 Static 을 반납하고, Actor 정보를 지운다.
function WorldMapWindow_ActorIcon_Delete( actorKeyRaw )
	local actorInfo = actorIcons[actorKeyRaw]

	if nil ~= actorInfo then
		actorIconPool:returnToPool( actorInfo._type, actorInfo._icon )
		actorIcons[actorKeyRaw] = nil
	end
end

-------------------------------------------------------------
-- Common - WorldMap Show / Hide
-------------------------------------------------------------
local WorldMapWindow_OnShow = function()
	WorldMapWindow_ActorIcon_Hide()
	actorIconDrawable = true
end

local WorldMapWindow_OnHide = function()
	WorldMapWindow_MyWorkerClear()
	WorldMapWindow_ActorIcon_Hide()
	actorIconDrawable = false
end

WorldMapWindow_Set_OnShowHide_Handler( true, WorldMapWindow_OnShow )
WorldMapWindow_Set_OnShowHide_Handler( false, WorldMapWindow_OnHide )

