local UI_TYPE		= CppEnums.PA_UI_CONTROL_TYPE
local ENT 			= CppEnums.ExplorationNodeType
local _Util_Math 	= Util.Math
local UI_color		= Defines.Color
local UI_TM 		= CppEnums.TextMode

local template =
{
	LocationVillage			= UI.getChildControl( Panel_Win_Worldmap, "StaticText_LocationVillage" ),
	ExplorePanelTitle		= UI.getChildControl( Panel_Win_Worldmap, "StaticText_ExploreTerritory" ),
	SupportPanelPoint		= UI.getChildControl( Panel_Win_Worldmap, "StaticText_SupportPoint" ),
	ImagePanel				= UI.getChildControl( Panel_Win_Worldmap, "StaticText_Image" ),
	AffiliatedUserRate		= UI.getChildControl( Panel_Win_Worldmap, "StaticText_AffiliatedUserRate" ),
	AffiliatedTerritory		= UI.getChildControl( Panel_Win_Worldmap, "StaticText_AffiliatedTerritory" ),
	AffiliatedTerritoryMark	= UI.getChildControl( Panel_Win_Worldmap, "Static_AffiliatedTerritoryMark" ),
	
	_hint_que 	= UI.getChildControl ( Panel_Win_Worldmap, "Static_MentalCard_Que" ),
	_hint 		= UI.getChildControl ( Panel_Win_Worldmap, "StaticText_MentalCard_Hint" ),
	_human 		= UI.getChildControl ( Panel_Win_Worldmap, "Static_Mental_Human" ),
	_territory 	= UI.getChildControl ( Panel_Win_Worldmap, "Static_Mental_Territory" ),
	_object 	= UI.getChildControl ( Panel_Win_Worldmap, "Static_Mental_Object" ),
}

local villageTextList = {}
local territoryLine_Controls = {}

local CircleLineIdx = {}
CircleLineIdx[0] = -1
CircleLineIdx[1] = -1
CircleLineIdx[2] = -1
CircleLineIdx[3] = -1
CircleLineIdx[4] = -1

local CircleLineCenterPos = {}
CircleLineCenterPos[0] = float3(10000, 0, 10000)
CircleLineCenterPos[1] = float3(10000, 0, 10000)
CircleLineCenterPos[2] = float3(10000, 0, 10000)

local CircleLineCenterRadius = {}
CircleLineCenterRadius[0] =  40000
CircleLineCenterRadius[1] = 120000
CircleLineCenterRadius[2] = 200000

-- 원 3개 높이.
local circleLineHeight = {}
circleLineHeight[1] = 10000
circleLineHeight[2] = 20000
circleLineHeight[3] = 30000


local loc =
{
	LocationN = 0,
	LocationE = 1,
	LocationS = 2,
	LocationW = 3,
}

local LocationNEWSRotation = 0

local SunIconStatic		= UI.getChildControl( Panel_Win_Worldmap, "Static_Weather_Sun" )
local MoonIconStatic	= UI.getChildControl( Panel_Win_Worldmap, "Static_Weather_Moon" )
local SunTimeText		= UI.getChildControl( Panel_Win_Worldmap, "StaticText_SunTime" )
	
local locationText = {}
locationText[loc.LocationN]		= UI.getChildControl( Panel_Win_Worldmap, "StaticText_LocationN" )
locationText[loc.LocationE]		= UI.getChildControl( Panel_Win_Worldmap, "StaticText_LocationE" )
locationText[loc.LocationS]		= UI.getChildControl( Panel_Win_Worldmap, "StaticText_LocationS" )
locationText[loc.LocationW]		= UI.getChildControl( Panel_Win_Worldmap, "StaticText_LocationW" )
local init = function()
	WorldMapWindow.uiList[WorldMapWindow.RenderType.WMS_EXPLORE_PLANT]:AddChild(SunIconStatic	)
	WorldMapWindow.uiList[WorldMapWindow.RenderType.WMS_EXPLORE_PLANT]:AddChild(MoonIconStatic	)
	WorldMapWindow.uiList[WorldMapWindow.RenderType.WMS_EXPLORE_PLANT]:AddChild(SunTimeText		)
	Panel_Win_Worldmap:RemoveControl(SunIconStatic		)
	Panel_Win_Worldmap:RemoveControl(MoonIconStatic		)
	Panel_Win_Worldmap:RemoveControl(SunTimeText		)

	WorldMapWindow.uiList[WorldMapWindow.RenderType.WMS_EXPLORE_PLANT]:AddChild(locationText[loc.LocationN])
	WorldMapWindow.uiList[WorldMapWindow.RenderType.WMS_EXPLORE_PLANT]:AddChild(locationText[loc.LocationE])
	WorldMapWindow.uiList[WorldMapWindow.RenderType.WMS_EXPLORE_PLANT]:AddChild(locationText[loc.LocationS])
	WorldMapWindow.uiList[WorldMapWindow.RenderType.WMS_EXPLORE_PLANT]:AddChild(locationText[loc.LocationW])
	Panel_Win_Worldmap:RemoveControl(locationText[loc.LocationN])
	Panel_Win_Worldmap:RemoveControl(locationText[loc.LocationE])
	Panel_Win_Worldmap:RemoveControl(locationText[loc.LocationS])
	Panel_Win_Worldmap:RemoveControl(locationText[loc.LocationW])
end
init()

------------------------------------------------------
-- Circle Line - 원 3개
------------------------------------------------------
function WorldMapWindow_Refresh_CircleLine()
	if not Panel_Win_Worldmap:GetShow() then
		return
	end

	local cameraPosition = WorldMapWindow.openPosition -- getWorldMapCameraLookAt() // 화면 따라다님
	local cameraDistance = getWorldMapCameraDistance()
	
	if cameraDistance > 300000 then
		cameraDistance = 300000
	end
	

	local lineHeightMax = { 10000, 20000, 30000 }
	for idx,_lineHeight in pairs(lineHeightMax) do		 
		circleLineHeight[idx] = _Util_Math.Lerp( 10000, _lineHeight, cameraDistance / 600000 )
	end

	local lineRadiusMinMax =
	{
		{ 2000, 100000 },
		{ 6000, 300000 },
		{ 10000, 500000 },
	}
	local lineRadius = {}
	for idx,radiusMinMax in pairs(lineRadiusMinMax) do		
		lineRadius[idx] = _Util_Math.Lerp( radiusMinMax[1], radiusMinMax[2],cameraDistance / 600000 )		
	end

	local lerpFactor = { 0.3, 0.45, 0.6 } -- 0.3 / (i / 2+1)

	local _math_lerpVector = _Util_Math.LerpVector
	local _math_calcDistance = _Util_Math.calculateDistance

	local _worldmap_circleline_center_pos = CircleLineCenterPos
	local _worldmap_circleline_center_radius = CircleLineCenterRadius

	for i = 0, 2, 1 do
		if (_worldmap_circleline_center_pos[i] == nil) then
			_worldmap_circleline_center_radius[i] = lineRadius[i+1]
			_worldmap_circleline_center_pos[i] = cameraPosition
		else
			local toPosition = _math_lerpVector(_worldmap_circleline_center_pos[i], cameraPosition, lerpFactor[i+1] )
			_worldmap_circleline_center_radius[i] = lineRadius[i+1] / (_math_calcDistance(toPosition, _worldmap_circleline_center_pos[i]) / 10000 + 1)
			_worldmap_circleline_center_pos[i] = toPosition
		end

		local lineDataBuffer = worldmapGetLine(WorldMapWindow.RenderType.WMS_EXPLORE_PLANT, CircleLineIdx[i], 100)
		if lineDataBuffer == nil then
			CircleLineIdx[i] = worldmapInsertCircleLine(WorldMapWindow.RenderType.WMS_EXPLORE_PLANT, float3(0,0,0), float4(1,1,1,1), 1.0, 1.0, 100, CppEnums.InstantLineRenderType.InstantLineRenderType_AllwaysShow )
			lineDataBuffer = worldmapGetLine(WorldMapWindow.RenderType.WMS_EXPLORE_PLANT, CircleLineIdx[i], 100)
		end
		lineDataBuffer._position	= float3(_worldmap_circleline_center_pos[i].x, circleLineHeight[i+1], _worldmap_circleline_center_pos[i].z)
		lineDataBuffer._scale		= float3(_worldmap_circleline_center_radius[i], 1, _worldmap_circleline_center_radius[i])
		
		if( WorldMapWindow._btn_WayGuide_Check == false ) then		
			lineDataBuffer._isRender = false
		else 
			lineDataBuffer._isRender = true
		end
		
		
	end
end

------------------------------------------------------
-- Sun & Moon -- Icon & Line
------------------------------------------------------
function WorldMapWindow_Refresh_SunIcon()
	if not Panel_Win_Worldmap:GetShow() then
		return
	end
	
	if( WorldMapWindow._btn_WayGuide_Check == false ) then
		SunIconStatic:SetShow(false)
		MoonIconStatic:SetShow(false)
		SunTimeText:SetShow(false)
		return
	end

	if getSelfPlayer() == nil then
		return
	end

	local posSelf = CircleLineCenterPos[2]

	local dayCycle = 24 * 60
	local inGameMinuteRate	= getIngameTime_minute_rate()
	local inGameMinute		= math.floor(inGameMinuteRate)
	if ( dayCycle < inGameMinute ) then
		inGameMinute		= inGameMinute % dayCycle
		inGameMinuteRate	= inGameMinuteRate - inGameMinute * dayCycle
	end

	local isNight = (22 * 60 < inGameMinute)
	local inGameDayRate = 0

	if isNight then
		inGameDayRate = (inGameMinuteRate - (22 * 60)) / (2 * 60)
	else
		inGameDayRate = inGameMinuteRate / (22 * 60) -- 0.0 ~ 1.0
	end

	
	local startPoint
	local endPoint
	local spinRadius
	local spinAngle
	if isNight then
		spinRadius = CircleLineCenterRadius[2] * 0.4
		spinAngle = 0.7
		startPoint	= _Util_Math.calculateNormalVector({ x = -1.5, y = 0, z =    1 })
		endPoint	= _Util_Math.calculateNormalVector({ x =    1, y = 0, z = -0.8 })
	else
		spinRadius = CircleLineCenterRadius[2] * 0.5
		spinAngle = 0.8
		startPoint	= _Util_Math.calculateNormalVector({ x = -1, y = 0, z =  1 })
		endPoint	= _Util_Math.calculateNormalVector({ x =  1, y = 0, z = -1 })
	end
	startPoint = _Util_Math.MulNumberToVector(startPoint, CircleLineCenterRadius[2])
	endPoint = _Util_Math.MulNumberToVector(endPoint, CircleLineCenterRadius[2])


	local currentSunPoint = _Util_Math.calculateSinCurve(startPoint, endPoint, { x = 0, y = 0, z = 0 }, spinRadius, spinAngle, inGameDayRate)
	
	currentSunPoint.y = currentSunPoint.y + circleLineHeight[3]
	
	local finalSunPos = { x = posSelf.x + currentSunPoint.x, y = currentSunPoint.y, z = posSelf.z + currentSunPoint.z }

	local sun2DPoint = worldmapScenetoScreenPosition(finalSunPos.x, finalSunPos.y, finalSunPos.z)
	sun2DPoint.x 		= sun2DPoint.x * WorldMapWindow.world3DMapStatic:GetSizeX()
	sun2DPoint.y 		= sun2DPoint.y * WorldMapWindow.world3DMapStatic:GetSizeY()

	local isShowSun = ( 0 < sun2DPoint.z ) and (  sun2DPoint.z <= 1 )


	local tickCount = {
		(getTickCount32() % 2000) / 2000,
		(getTickCount32() % 3000) / 3000,
		(getTickCount32() % 4000) / 4000,
		(getTickCount32() % 5000) / 5000,
		(getTickCount32() % 3500) / 3500,
		(getTickCount32() % 2500) / 2500
	}

	local cameraPos = getWorldMapCameraPos()

	if ( WorldMapWindow.isHouseMode ) then
		SunIconStatic:SetShow(false)
		MoonIconStatic:SetShow(false)
		SunTimeText:SetShow(false)
		return
	end
	SunIconStatic:SetShow(true)
	MoonIconStatic:SetShow(true)
	SunTimeText:SetShow(true)

	if isNight then
		SunIconStatic:SetShow(false)

		MoonIconStatic:SetSize(50, 50)
		MoonIconStatic:SetPosX(sun2DPoint.x - MoonIconStatic:GetSizeX() / 2)
		MoonIconStatic:SetPosY(sun2DPoint.y - MoonIconStatic:GetSizeY() / 2)
		MoonIconStatic:SetShow(isShowSun)

		local SunTimeTextIsOver = 	MoonIconStatic:GetPosX() < getMousePosX() and getMousePosX() < MoonIconStatic:GetPosX() + MoonIconStatic:GetSizeX() and
									MoonIconStatic:GetPosY() < getMousePosY() and getMousePosY() < MoonIconStatic:GetPosY() + MoonIconStatic:GetSizeY();	
									
		SunTimeText:SetText(Util.Time.inGameTimeFormatting(inGameMinute))
		SunTimeText:SetSize(SunTimeText:GetTextSizeX(), SunTimeText:GetTextSizeY())
		SunTimeText:SetPosX(MoonIconStatic:GetPosX() + MoonIconStatic:GetSizeX() + 10)
		SunTimeText:SetPosY(MoonIconStatic:GetPosY())
		SunTimeText:SetShow(SunTimeTextIsOver and isShowSun)

		MoonIconStatic:SetDepth(WorldMapWindow_GetDepthFromPos3D(cameraPos, finalSunPos))
		SunTimeText:SetDepth(WorldMapWindow_GetDepthFromPos3D(cameraPos, finalSunPos))
	else
		MoonIconStatic:SetShow(false)

		SunIconStatic:SetSize(50, 50)
		SunIconStatic:SetPosX(sun2DPoint.x - SunIconStatic:GetSizeX() / 2)
		SunIconStatic:SetPosY(sun2DPoint.y - SunIconStatic:GetSizeX() / 2)
		SunIconStatic:SetShow(isShowSun)

		local SunTimeTextIsOver = 	SunIconStatic:GetPosX() < getMousePosX() and getMousePosX() < SunIconStatic:GetPosX() + SunIconStatic:GetSizeX() and
									SunIconStatic:GetPosY() < getMousePosY() and getMousePosY() < SunIconStatic:GetPosY() + SunIconStatic:GetSizeY();	
	
		SunTimeText:SetText(Util.Time.inGameTimeFormatting(inGameMinute))
		SunTimeText:SetSize(SunTimeText:GetTextSizeX(), SunTimeText:GetTextSizeY())
		SunTimeText:SetPosX(SunIconStatic:GetPosX() + SunIconStatic:GetSizeX() + 10)
		SunTimeText:SetPosY(SunIconStatic:GetPosY())
		SunTimeText:SetShow(SunTimeTextIsOver and isShowSun)

		SunIconStatic:SetDepth(WorldMapWindow_GetDepthFromPos3D(cameraPos, finalSunPos))
		SunTimeText:SetDepth(WorldMapWindow_GetDepthFromPos3D(cameraPos, finalSunPos))
	end
end

function WorldMapWindow_Refresh_SunLine()
	local lineList_SunMoon =
	{
		{
			startPoint	= _Util_Math.calculateNormalVector(float3(-1.5, 0,	1)),
			endPoint	= _Util_Math.calculateNormalVector(float3(	1, 0,-0.8)),
			angle		= 0.7
		},
		{
			startPoint	= _Util_Math.calculateNormalVector(float3(-1, 0, 1)),
			endPoint	= _Util_Math.calculateNormalVector(float3( 1, 0,-1)),
			angle		= 0.8
		}
	}
	local startPoint
	local endPoint

	local SignHeight = { 0.4, 0.5 }

	
	local dayCycle = 24 * 60
	local inGameMinuteRate	= getIngameTime_minute_rate()
	local inGameMinute		= math.floor(inGameMinuteRate)
	if ( dayCycle < inGameMinute ) then
		inGameMinute		= inGameMinute % dayCycle
		inGameMinuteRate	= inGameMinuteRate - inGameMinute * dayCycle
	end

	local isNight = (22 * 60 < inGameMinute)
	
	local i
	for i = 1, 2, 1 do
		local lineDataBuffer = worldmapGetLine(WorldMapWindow.RenderType.WMS_EXPLORE_PLANT, CircleLineIdx[2+i], 100)
		if lineDataBuffer ~= nil then
			lineDataBuffer._isRender = false
		end
	end	
	
	
	if isNight == true then
		i = 1
	else
		i = 2
	end
	
	-- for i = 1, 2, 1 do
		startPoint	= lineList_SunMoon[i].startPoint
		endPoint	= lineList_SunMoon[i].endPoint
		startPoint.y = 0
		endPoint.y = 0

		local lineDataBuffer = worldmapGetLine(WorldMapWindow.RenderType.WMS_EXPLORE_PLANT, CircleLineIdx[2+i], 100)
		if lineDataBuffer == nil then
			local lineStream = LineDataWrapper()
			local lineVertexList = _Util_Math.calculateSinCurveList(startPoint, endPoint, float3(0,0,0), SignHeight[i], lineList_SunMoon[i].angle, 200)
			lineStream:reserve(200)
			for j = 0, 200, 1 do
				lineStream:push_back(lineVertexList[j])
			end

			CircleLineIdx[2 + i] = worldmapInsertLineData(WorldMapWindow.RenderType.WMS_EXPLORE_PLANT, lineStream, float4(1,1,1,1), 1.0, 100, CppEnums.InstantLineRenderType.InstantLineRenderType_AllwaysShow)
			lineDataBuffer = worldmapGetLine(WorldMapWindow.RenderType.WMS_EXPLORE_PLANT, CircleLineIdx[2+i], 100)
		end
		lineDataBuffer._position	= float3(CircleLineCenterPos[2].x, circleLineHeight[3], CircleLineCenterPos[2].z)
		lineDataBuffer._scale		= float3(CircleLineCenterRadius[2], CircleLineCenterRadius[2], CircleLineCenterRadius[2])
		lineDataBuffer._isRender	= true
	-- end
	
	if( WorldMapWindow._btn_WayGuide_Check == false ) then
		SunIconStatic:SetShow(false)
		MoonIconStatic:SetShow(false)
		SunTimeText:SetShow(false)
		
		for i = 1, 2, 1 do
			local lineDataBuffer = worldmapGetLine(WorldMapWindow.RenderType.WMS_EXPLORE_PLANT, CircleLineIdx[2+i], 100)
			if lineDataBuffer ~= nil then
				lineDataBuffer._isRender = false
			end
		end
		
		return
	end

		
	
end

------------------------------------------------------
-- Circle Line - N, E, W, S Icon
------------------------------------------------------
function WorldMapWindow_Refresh_NEWS_Position()
	if not Panel_Win_Worldmap:GetShow() then
		return
	end	

	if getSelfPlayer() == nil then
		return
	end

	local posSelf = CircleLineCenterPos[2]

	local cameraPos = getWorldMapCameraPos()
	local cameraLookAt = getWorldMapCameraLookAt()
	local cameraDir = _Util_Math.calculateDirection(cameraPos, cameraLookAt)
	if ( ( _Util_Math.calculateLength(cameraDir) < 1.1 and _Util_Math.calculateLength(cameraDir) > -0.1 ) == false ) then
		-- _PA_LOG("news", "fire in the hole! - "..tostring(cameraDir.x)..","..tostring(cameraDir.y)..","..tostring(cameraDir.z) .. " : len - " .. tostring(_Util_Math.calculateLength(cameraDir)))
		return
	end

	cameraDir.y = 0
	cameraDir = _Util_Math.calculateNormalVector(cameraDir)
	local cameraCross = _Util_Math.calculateCross(cameraDir, float3(0,1,0))

	local posNEWS = {}
	for i = loc.LocationN, loc.LocationW, 1 do
		local relativePos = {}
		local newsDir = _Util_Math.convertRotationToDirection(i * math.pi / 2)
		relativePos.x = cameraDir.x * newsDir.x + cameraCross.x * newsDir.z
		relativePos.z = cameraDir.z * newsDir.x + cameraCross.z * newsDir.z

		local relativeRadian		= _Util_Math.convertDirectionToRotation(relativePos)

		if (i == 0) then
			local absoluteNorthRadian	= _Util_Math.convertDirectionToRotation( float3(0,0,1) ) + i * math.pi / 2

			local deltaAngle = 0
			local candidate = {}
			candidate[0] = (absoluteNorthRadian 				- _Util_Math.radianFix(relativeRadian + LocationNEWSRotation))
			candidate[1] = (absoluteNorthRadian + 2 * math.pi	- _Util_Math.radianFix(relativeRadian + LocationNEWSRotation))

			if (math.abs(candidate[0]) < math.abs(candidate[1])) then
				deltaAngle = candidate[0] 
			else
				deltaAngle = candidate[1]
			end

			if deltaAngle > math.pi then
				deltaAngle = 2 * math.pi - deltaAngle
			end
			LocationNEWSRotation = (LocationNEWSRotation + deltaAngle * 0.1)
		end
		relativeRadian = _Util_Math.radianFix(relativeRadian + LocationNEWSRotation)

		relativePos = _Util_Math.convertRotationToDirection(relativeRadian)

		relativePos.x = relativePos.x * CircleLineCenterRadius[1]
		relativePos.z = relativePos.z * CircleLineCenterRadius[1]

		posNEWS[i] = float3(posSelf.x + relativePos.x, circleLineHeight[2], posSelf.z + relativePos.z)
	end

	for i = loc.LocationN, loc.LocationW, 1 do
		local posDirection = posNEWS[i]
		local nodePosition = worldmapScenetoScreenPosition( posDirection.x, posDirection.y, posDirection.z )
		nodePosition.x 		= nodePosition.x * WorldMapWindow.world3DMapStatic:GetSizeX()
		nodePosition.y 		= nodePosition.y * WorldMapWindow.world3DMapStatic:GetSizeY()

		local isShowNEWS = ( 0 < nodePosition.z ) and (  nodePosition.z <= 1 )
		local locationText = locationText[i]
		if ( WorldMapWindow.isHouseMode ) then
			locationText:SetShow(false)
		else
			locationText:SetPosX(nodePosition.x - locationText:GetSizeX() / 2)
			locationText:SetPosY(nodePosition.y - locationText:GetSizeY() / 2)
			locationText:SetDepth(WorldMapWindow_GetDepthFromPos3D(cameraPos, posDirection))
			locationText:SetShow(isShowNEWS)
		end
		
		if( WorldMapWindow._btn_WayGuide_Check == false ) then		
			locationText:SetShow(false)
		end
	end
end

------------------------------------------------------
-- Circle Line - Village Name
------------------------------------------------------
function WorldMapWindow_Refresh_CircleLine_VillageNameList()
	if not Panel_Win_Worldmap:GetShow() then
		return
	end
	for _,node in pairs(WorldMapWindow.nodeDataList) do
		if nil ~= node then
			WorldMapWindow_Refresh_CircleLine_VillageName(node)
		end
	end
end

function WorldMapWindow_Refresh_CircleLine_VillageName(node)
	if not Panel_Win_Worldmap:GetShow() then
		return
	end

	if getSelfPlayer() == nil then
		return
	end

	local nodeKey = node:getStaticStatus()._waypointKey
	local villageData = villageTextList[nodeKey]
	if ( (nil == villageData) or (nil == villageData.control) ) then
		return
	end

	if ( WorldMapWindow.isHouseMode ) then
		villageData.control:SetShow( false )
		villageData.arrowControl:SetShow( false )
		return
	end
	
	if( WorldMapWindow._btn_WayGuide_Check == false ) then		
		villageData.control:SetShow( false )
		villageData.arrowControl:SetShow( false )
		return
	end

	villageData.control:SetShow( true )
	villageData.arrowControl:SetShow( true )
	local cameraPos = getWorldMapCameraPos()
	local cameraLookAt = getWorldMapCameraLookAt()
	local cameraDir = _Util_Math.calculateDirection(cameraPos, cameraLookAt)
	if ( ( _Util_Math.calculateLength(cameraDir) < 1.1 and _Util_Math.calculateLength(cameraDir) > -0.1 ) == false ) then
		-- _PA_LOG("news", "fire in the hole! - "..tostring(cameraDir.x)..","..tostring(cameraDir.y)..","..tostring(cameraDir.z) .. " : len - " .. tostring(_Util_Math.calculateLength(cameraDir)))
		return
	end

	cameraDir = _Util_Math.calculateNormalVector(cameraDir)


	local nodePosition		= node:getStaticStatus():getPosition()

	local posSelf
	if (_Util_Math.calculateDistance(CircleLineCenterPos[0], nodePosition) > CircleLineCenterRadius[1] ) then
		posSelf = CircleLineCenterPos[1]
	else
		posSelf = CircleLineCenterPos[0]
	end
	posSelf.y = 0


	local directionPos		= _Util_Math.calculateDirection(posSelf, nodePosition)
	directionPos.y = 0
	local directionNormal	= _Util_Math.calculateNormalVector(directionPos)

	local cameraRadian	= _Util_Math.convertDirectionToRotation(cameraDir)
	local targetRadian	= _Util_Math.convertDirectionToRotation(directionNormal) - cameraRadian

	local deltaAngle = 0
	local candidate = {}
	candidate[0] = (targetRadian 				- villageData.radianFix)
	candidate[1] = (targetRadian + 2 * math.pi	- villageData.radianFix)
	candidate[2] = (targetRadian - 2 * math.pi	- villageData.radianFix)

	if (math.abs(candidate[0]) < math.abs(candidate[1])) then
		deltaAngle = candidate[0] 
	else
		deltaAngle = candidate[1]
	end
	if (math.abs(candidate[2]) < math.abs(deltaAngle)) then
		deltaAngle = candidate[2] 
	end

	local isNearCircle = _Util_Math.calculateDistance(posSelf, nodePosition) < CircleLineCenterRadius[1]
	local sensitivity
	if isNearCircle then
		sensitivity = 0.25
	else
		sensitivity = 0.18
	end

	villageData.radianFix = _Util_Math.radianFix(villageData.radianFix + deltaAngle * sensitivity)

	directionNormal = _Util_Math.convertRotationToDirection(villageData.radianFix + cameraRadian)

	local resultPos = {}
	local resultCenterPos = {}
	if ( isNearCircle ) then
		resultCenterPos.x = posSelf.x
		resultCenterPos.y = circleLineHeight[1]
		resultCenterPos.z = posSelf.z
	
		resultPos.x = posSelf.x + directionNormal.x * CircleLineCenterRadius[0]
		resultPos.y = circleLineHeight[1]
		resultPos.z = posSelf.z + directionNormal.z * CircleLineCenterRadius[0]
	else
		resultCenterPos.x = posSelf.x
		resultCenterPos.y = circleLineHeight[2]
		resultCenterPos.z = posSelf.z
		
		resultPos.x = posSelf.x + directionNormal.x * CircleLineCenterRadius[1]
		resultPos.y = circleLineHeight[2]
		resultPos.z = posSelf.z + directionNormal.z * CircleLineCenterRadius[1]
	end

	local nodeCenterPosition2D	= worldmapScenetoScreenPosition(resultCenterPos.x, resultCenterPos.y, resultCenterPos.z)	
	nodeCenterPosition2D.x	= nodeCenterPosition2D.x * WorldMapWindow.world3DMapStatic:GetSizeX()
	nodeCenterPosition2D.y	= nodeCenterPosition2D.y * WorldMapWindow.world3DMapStatic:GetSizeY()
	local nodePosition2D	= worldmapScenetoScreenPosition(resultPos.x, resultPos.y, resultPos.z)	
	nodePosition2D.x 		= nodePosition2D.x * WorldMapWindow.world3DMapStatic:GetSizeX()
	nodePosition2D.y 		= nodePosition2D.y * WorldMapWindow.world3DMapStatic:GetSizeY()

	local controlDepth = WorldMapWindow_GetDepthFromPos3D(cameraPos, resultPos)
	
	local dx = nodeCenterPosition2D.x - nodePosition2D.x
	local dy = nodePosition2D.y - nodeCenterPosition2D.y
	local radian = math.atan2( dx, dy )
	villageData.arrowControl:SetDepth(controlDepth)
	villageData.arrowControl:SetRotate( radian )
	villageData.arrowControl:SetPosX(nodePosition2D.x - villageData.arrowControl:GetSizeX() / 2 )
	villageData.arrowControl:SetPosY(nodePosition2D.y - villageData.arrowControl:GetSizeY() / 2 )
	villageData.arrowControl:SetShow( (0 < nodePosition2D.z) and (nodePosition2D.z <=1) )

	local isShowName = 	isNearCircle or
						(	
							villageData.arrowControl:GetPosX() < getMousePosX() and getMousePosX() < villageData.arrowControl:GetPosX() + villageData.arrowControl:GetSizeX() and
							villageData.arrowControl:GetPosY() < getMousePosY() and getMousePosY() < villageData.arrowControl:GetPosY() + villageData.arrowControl:GetSizeY()	
						);
	isShowName 		 =	isShowName and ((0 < nodePosition2D.z) and (nodePosition2D.z <=1));
						
	villageData.control:SetShow( isShowName )
	if isShowName then
		villageData.control:SetDepth(controlDepth)
		villageData.control:SetPosX(nodePosition2D.x - villageData.control:GetSizeX() / 2 )
		villageData.control:SetPosY(nodePosition2D.y - villageData.control:GetSizeY() / 2 )
	end
end

function WorldMapWindow_Insert_CircleLine_VillageName(node)
	local nodeType = node:getStaticStatus()._nodeType
	if nodeType ~= ENT.eExplorationNodeType_Viliage and nodeType ~= ENT.eExplorationNodeType_City then
		return
	end

	local posSelf = {}
	posSelf.x = getSelfPlayer():get():getPositionX()
	posSelf.y = 0
	posSelf.z = getSelfPlayer():get():getPositionZ()

	local nodeStaticStatus = node:getStaticStatus()
	local nodeKey = nodeStaticStatus._waypointKey

	local targetArrow = UI.createControl( UI_TYPE.PA_UI_CONTROL_STATIC,  WorldMapWindow.uiList[WorldMapWindow.RenderType.WMS_EXPLORE_PLANT], "Static_village_Arrow_" .. tostring(nodeKey) )
	CopyBaseProperty( template.AffiliatedTerritoryMark, targetArrow)
	targetArrow:SetShow(true)
	
	local target = UI.createControl( UI_TYPE.PA_UI_CONTROL_STATICTEXT, WorldMapWindow.uiList[WorldMapWindow.RenderType.WMS_EXPLORE_PLANT], "Static_village_" .. tostring(nodeKey) )
	CopyBaseProperty( template.LocationVillage, target)
	target:SetText(getExploreNodeName(nodeStaticStatus))

	local villageData =
	{
		control = target,
		arrowControl = targetArrow,
		radianFix = _Util_Math.radianFix( math.random(0, 100000) / 100000 * math.pi * 2 )
	}
	villageTextList[nodeKey] = villageData
end


------------------------------------------------------
-- Territory Name And Exploration Point
------------------------------------------------------
local territoryKeyList = {}
function WorldMapWindow_TerritoryNameAndExplorationPoint_PositionUpdate()
	if not Panel_Win_Worldmap:GetShow() then
		return
	end

	if WorldMapWindow.ViewDetailMode then
		return
	end

	local cameraPosition = getWorldMapCameraPos()
	
	--audioPostEvent_SystemUi(00,01)

	local fMousePosX = getMousePosX();
	local fMousePosY = getMousePosY();
	
	local idx = 1
	for territoryKeyRaw, controls in pairs(territoryLine_Controls) do
		local lineData			= ToClient_worldmapGetTerritoryLineByRawKey(territoryKeyRaw)
		if lineData ~= nil then
			local nodeTopPosition	= lineData:getLinePositionByIndex(1)

			local nodeTopPosition2D		= worldmapScenetoScreenPosition(nodeTopPosition.x, nodeTopPosition.y, nodeTopPosition.z)
			nodeTopPosition2D.x 		= nodeTopPosition2D.x * WorldMapWindow.world3DMapStatic:GetSizeX()
			nodeTopPosition2D.y 		= nodeTopPosition2D.y * WorldMapWindow.world3DMapStatic:GetSizeY()

			local nodeExploreTitle				= controls.nodeExploreTitle	
			local nodeSupportPoint				= controls.nodeSupportPoint	
			local nodeImage						= controls.nodeImage		
			local nodeAffiliatedUserRate		= controls.nodeAffiliatedUserRate
			local nodeAffiliatedTerritory   	= controls.nodeAffiliatedTerritory
			local nodeAffiliatedTerritoryMark 	= controls.nodeAffiliatedTerritoryMark
			local guildMark						= controls.guildMark

			local isShow = (0 < nodeTopPosition2D.z) and (nodeTopPosition2D.z <=1)
			nodeExploreTitle			:SetShow( isShow )
			nodeSupportPoint			:SetShow( isShow )
			nodeImage					:SetShow( isShow )
			nodeAffiliatedUserRate		:SetShow( isShow )
			guildMark					:SetShow( isShow )
		
			local temporaryWrapper = getTemporaryInformationWrapper()
			local affiliatedTerritoryKey = temporaryWrapper:getAffiliatedTerritoryKeyRaw()
			if (tostring(territoryKeyRaw) == tostring(affiliatedTerritoryKey)) then
				nodeAffiliatedTerritory		:SetShow( isShow )
				nodeAffiliatedTerritoryMark	:SetShow( isShow )
			else	
				nodeAffiliatedTerritory		:SetShow( false )
				nodeAffiliatedTerritoryMark	:SetShow( false )
			end			
			
			lineData._isRender = true
			
			if( WorldMapWindow._btn_Node_Check == false ) then
				nodeExploreTitle			:SetShow( false )
				nodeSupportPoint			:SetShow( false )
				nodeImage					:SetShow( false )
				nodeAffiliatedUserRate		:SetShow( false )
				guildMark					:SetShow( false )
				nodeAffiliatedTerritory		:SetShow( false )
				nodeAffiliatedTerritoryMark :SetShow( false )
				lineData._isRender = false
			end
			

			local depth = WorldMapWindow_GetDepthFromPos3D(cameraPosition, nodeTopPosition)
			nodeExploreTitle			:SetDepth(depth)
			nodeSupportPoint			:SetDepth(depth)
			nodeImage					:SetDepth(depth)
			nodeAffiliatedUserRate		:SetDepth(depth)
			nodeAffiliatedTerritory 	:SetDepth(depth)
			nodeAffiliatedTerritoryMark	:SetDepth(depth)
			guildMark					:SetDepth(depth - 0.1)
			local pointCenter = (nodeTopPosition2D.x ) -- - nodeSupportPoint:GetSizeX() / 2

			nodeImage:SetPosX(pointCenter - nodeImage:GetSizeX() / 2 )
			nodeImage:SetPosY(nodeTopPosition2D.y - nodeImage:GetSizeY() - 10 )

			guildMark:SetPosX( (nodeImage:GetSizeX() - guildMark:GetSizeX()) / 2 + nodeImage:GetPosX() )
			guildMark:SetPosY( (nodeImage:GetSizeY() - guildMark:GetSizeY()) / 2 + nodeImage:GetPosY() )
	
			nodeAffiliatedTerritoryMark:SetPosX(pointCenter - nodeAffiliatedTerritoryMark:GetSizeX() / 2 )
			nodeAffiliatedTerritoryMark:SetPosY( nodeImage:GetPosY() - nodeAffiliatedTerritoryMark:GetSizeY() )
			nodeAffiliatedTerritory:SetPosX(pointCenter - nodeAffiliatedTerritory:GetSizeX() / 2 )
			nodeAffiliatedTerritory:SetPosY( nodeAffiliatedTerritoryMark:GetPosY() - nodeAffiliatedTerritory:GetSizeY() )
			
			local isOverControl = 	nodeImage:GetPosX() < fMousePosX and fMousePosX < nodeImage:GetPosX() + nodeImage:GetSizeX() and
									nodeImage:GetPosY() < fMousePosY and fMousePosY < nodeImage:GetPosY() + nodeImage:GetSizeY();
			nodeAffiliatedUserRate:SetShow(isOverControl);
			nodeSupportPoint:SetShow(isOverControl);
			nodeExploreTitle:SetShow(isOverControl);
			if (isOverControl) then
				nodeExploreTitle:SetPosX(nodeImage:GetPosX() - nodeExploreTitle:GetSizeX() )
				nodeExploreTitle:SetPosY(nodeImage:GetPosY())
				
				nodeSupportPoint:SetPosX(nodeImage:GetPosX() - nodeSupportPoint:GetSizeX() )
				nodeSupportPoint:SetPosY(nodeImage:GetPosY() + 40)
				
				nodeAffiliatedUserRate:SetPosX(nodeImage:GetPosX() - nodeAffiliatedUserRate:GetSizeX() )
				nodeAffiliatedUserRate:SetPosY( nodeSupportPoint:GetPosY() + 20 )
			end

			territoryKeyList[idx] = territoryKeyRaw	 	
			--nodeImage:addInputEvent("Mouse_RDown", "WorldMapWindow_Update_AffiliatedTerritory("..idx..")")
			idx = idx + 1
		end
	end
end

local WorldMapWindow_Clear_TerritoryNameAndExplorationPoint = function()
	for idx, controls in pairs(territoryLine_Controls) do
		UI.deleteControl( controls.nodeExploreTitle	 			)
		UI.deleteControl( controls.nodeSupportPoint	 			)
		UI.deleteControl( controls.nodeImage		 			)
		UI.deleteControl( controls.nodeAffiliatedUserRate		)
		UI.deleteControl( controls.nodeAffiliatedTerritory		)
		UI.deleteControl( controls.nodeAffiliatedTerritoryMark	)
		UI.deleteControl( controls.guildMark					)
	end
	territoryLine_Controls = {}
end

function WorldMapWindow_Invalid_TerritoryNameAndExplorationPoint()
	-- contributePoint_UpdateFunc()		-- 공헌도 업데이트
	-- wpPoint_UpdateFunc()				-- 기운 업데이트
	WorldMapWindow_Clear_TerritoryNameAndExplorationPoint()

	local territoryIdx = getTerritoryList()
	for i = 1, territoryIdx do
		local territoryKey = getTerritoryByIndex(i-1)
		local territoryKeyRaw = territoryKey:get()
		
		--[[ 공헌도 관련
		local explorePoint			= getExplorePointByTerritory(territoryKey)
		local expRate = (100 * Int64toInt32(explorePoint:getExperience_s64()) ) / Int64toInt32(getRequireExplorationExperience_s64())
		local strExpRate = string.format( "%d", expRate )
		]]
		
		local supportPoint			= getSurportPointByTerritory(territoryKey)
		local s64_exploreRequireExp	= getRequireExperienceToExplorePointByTerritory_s64(territoryKey)
		local territoryName			= getTerritoryNameByKey(territoryKey)

		local controls = territoryLine_Controls[territoryKeyRaw]
		local nodeExploreTitle, nodeSupportPoint, nodeImage, nodeAffiliatedUserRate, guildMark, nodeAffiliatedTerritory, nodeAffiliatedTerritoryMark

		if ( controls == nil) then
			controls = {}
			nodeExploreTitle 			= UI.createControl( UI_TYPE.PA_UI_CONTROL_STATICTEXT, 	WorldMapWindow.uiList[WorldMapWindow.RenderType.WMS_GLOBAL], "Static_ExploreName_" .. tostring(territoryKeyRaw) )
			nodeSupportPoint 			= UI.createControl( UI_TYPE.PA_UI_CONTROL_STATICTEXT, 	WorldMapWindow.uiList[WorldMapWindow.RenderType.WMS_GLOBAL], "Static_SupportPoint_" .. tostring(territoryKeyRaw) )
			nodeImage		 			= UI.createControl( UI_TYPE.PA_UI_CONTROL_STATIC, 		WorldMapWindow.uiList[WorldMapWindow.RenderType.WMS_GLOBAL], "Static_Image_" .. tostring(territoryKeyRaw) )
			nodeAffiliatedUserRate		= UI.createControl( UI_TYPE.PA_UI_CONTROL_STATICTEXT, 	WorldMapWindow.uiList[WorldMapWindow.RenderType.WMS_GLOBAL], "Static_AffiliatedUserRate_" .. tostring(territoryKeyRaw) )
			nodeAffiliatedTerritory 	= UI.createControl( UI_TYPE.PA_UI_CONTROL_STATICTEXT, 	WorldMapWindow.uiList[WorldMapWindow.RenderType.WMS_GLOBAL], "Static_AffiliatedTerritory_" .. tostring(territoryKeyRaw) )
			nodeAffiliatedTerritoryMark = UI.createControl( UI_TYPE.PA_UI_CONTROL_STATIC, 		WorldMapWindow.uiList[WorldMapWindow.RenderType.WMS_GLOBAL], "Static_AffiliatedTerritoryMark_" .. tostring(territoryKeyRaw) )
			guildMark					= UI.createControl( UI_TYPE.PA_UI_CONTROL_STATICTEXT,	WorldMapWindow.uiList[WorldMapWindow.RenderType.WMS_GLOBAL], "Static_GuildMark_" .. tostring(territoryKeyRaw) )
	

			controls.nodeExploreTitle		 		= nodeExploreTitle
			controls.nodeSupportPoint		 		= nodeSupportPoint
			controls.nodeImage				 		= nodeImage
			controls.nodeAffiliatedUserRate  		= nodeAffiliatedUserRate
			controls.nodeAffiliatedTerritory 		= nodeAffiliatedTerritory
			controls.nodeAffiliatedTerritoryMark	= nodeAffiliatedTerritoryMark
			controls.guildMark				 		= guildMark

			CopyBaseProperty( template.ExplorePanelTitle,			nodeExploreTitle			)
			CopyBaseProperty( template.SupportPanelPoint,			nodeSupportPoint			)
			CopyBaseProperty( template.ImagePanel,					nodeImage					)
			CopyBaseProperty( template.AffiliatedUserRate,			nodeAffiliatedUserRate 		)
			CopyBaseProperty( template.AffiliatedTerritory,			nodeAffiliatedTerritory 	)
			CopyBaseProperty( template.AffiliatedTerritoryMark,		nodeAffiliatedTerritoryMark )
			nodeImage:addInputEvent("Mouse_On"		, "WorldMapWindow_OnTerritoryTooltipShow("..territoryKeyRaw..")")
			nodeImage:addInputEvent("Mouse_Out"		, "WorldMapWindow_OnTerritoryTooltipHide("..territoryKeyRaw..")")
			nodeImage:SetIgnore(false)
		
			nodeSupportPoint:SetAlpha(0)
		
			guildMark:SetSize( 32, 32 )
			guildMark:ChangeTextureInfoName("New_UI_Common_forLua/Default/BlankGuildMark.dds")
			guildMark:SetSpanSize( 0, 118 )
			guildMark:SetHorizonCenter()
			guildMark:SetVerticalTop()
			guildMark:SetIgnore(true)
			guildMark:SetShow(false)
			guildMark:SetTexturePreload(false)


			nodeExploreTitle				:SetShow(true)
			nodeSupportPoint				:SetShow(true)
			nodeImage						:SetShow(true)
			nodeAffiliatedUserRate			:SetShow(true)
			guildMark						:SetShow(true)
			
			territoryLine_Controls[territoryKeyRaw] = controls
		else
			nodeExploreTitle 			= controls.nodeExploreTitle
			nodeSupportPoint 			= controls.nodeSupportPoint
			nodeImage		 			= controls.nodeImage
			nodeAffiliatedUserRate 		= controls.nodeAffiliatedUserRate
			nodeAffiliatedTerritory 	= controls.nodeAffiliatedTerritory
			nodeAffiliatedTerritoryMark	= controls.nodeAffiliatedTerritoryMark
			guildMark					= controls.guildMark
		end
		
		nodeExploreTitle:SetText( territoryName )
		
		local supportPointText = "temp"
		local supportRequireExp	= Int64toInt32( getRequireSupportExperience_s64(territoryKey) )
		local supportCurrentExp = Int64toInt32( supportPoint:getExperience_s64() )
		local supportExpRate = supportCurrentExp / supportRequireExp * 100
		local supportPoint = supportPoint:getRemainedPoint()
		
		if ( 0 == supportPoint ) then
			supportPointText = "<PAColor0xAAFFBB88>" .. PAGetString( Defines.StringSheet_GAME, "LUA_WORLD_MAP_GUIDE_ROOKIE" ) .. " " .. PAGetString( Defines.StringSheet_GAME, "LUA_WORLD_MAP_GUIDE_ADVENTURER" ) .. "<PAOldColor>"
		elseif ( 1 == supportPoint ) then
			supportPointText = "<PAColor0xAAFFBB88>" .. PAGetString( Defines.StringSheet_GAME, "LUA_WORLD_MAP_GUIDE_STRANGE" ) .. " " .. PAGetString( Defines.StringSheet_GAME, "LUA_WORLD_MAP_GUIDE_ADVENTURER" ) .. "<PAOldColor>"
		elseif ( 2 == supportPoint ) then
			supportPointText = "<PAColor0xAAFFBB88>" .. PAGetString( Defines.StringSheet_GAME, "LUA_WORLD_MAP_GUIDE_CLOSE" ) .. " " .. PAGetString( Defines.StringSheet_GAME, "LUA_WORLD_MAP_GUIDE_ADVENTURER" ) .. "<PAOldColor>"
		elseif ( 3 == supportPoint ) then
			supportPointText = "<PAColor0xAAFFBB88>" .. PAGetString( Defines.StringSheet_GAME, "LUA_WORLD_MAP_GUIDE_RELIABLE" ) .. " " .. PAGetString( Defines.StringSheet_GAME, "LUA_WORLD_MAP_GUIDE_ADVENTURER" ) .. "<PAOldColor>"
		elseif ( 4 <= supportPoint ) then
			supportPointText = "<PAColor0xAAFFBB88>" .. PAGetString( Defines.StringSheet_GAME, "LUA_WORLD_MAP_GUIDE_FAMOUS" ) .. " " .. PAGetString( Defines.StringSheet_GAME, "LUA_WORLD_MAP_GUIDE_ADVENTURER" ) .. "<PAOldColor>"
		end

		nodeSupportPoint:SetText( PAGetString( Defines.StringSheet_GAME, "LUA_WORLD_MAP_GUIDE_FAME" ) .. " : " .. supportPointText .. " ("..string.format( "%d", supportExpRate).."%)")
		-- 텍스트 비교를 통해서 연산이 이루어지면 안됨~

		local territoryInfoWrapper = nil
		if ( nil ~= territoryKey ) then
			territoryInfoWrapper = getTerritoryInfoWrapper(territoryKeyRaw)
		end

		if ( nil == territoryInfoWrapper ) then
			nodeImage:SetAlpha(0)
		else
			nodeImage:ChangeTextureInfoName(territoryInfoWrapper:getTerritoryImage())
		end
		
		local siegeWrapper = ToClient_GetSiegeWrapper(territoryKeyRaw)
		local affiliatedUserRate = siegeWrapper:getAffiliatedUserRate()
		local affiliatedUserRateStr 	= PAGetString ( Defines.StringSheet_GAME, "LUA_WORLD_MAP_GUIDE_POPULATIONDENSITY")
		
		if (0 <= affiliatedUserRate and affiliatedUserRate <= 20) then
			affiliatedUserRateStr 	= affiliatedUserRateStr.." <PAColor0xFFFF4C4C>"..PAGetString ( Defines.StringSheet_GAME, "LUA_LORDMENU_POPULATIONDENSITY_LACK").."<PAOldColor> ("..string.format( "%d", affiliatedUserRate).."%)"
		elseif (20 < affiliatedUserRate and affiliatedUserRate <= 40) then
			affiliatedUserRateStr 	= affiliatedUserRateStr.." <PAColor0xFFFF874C>"..PAGetString ( Defines.StringSheet_GAME, "LUA_LORDMENU_POPULATIONDENSITY_LOW").."<PAOldColor> ("..string.format( "%d", affiliatedUserRate).."%)"
		elseif (40 < affiliatedUserRate and affiliatedUserRate <= 60) then
			affiliatedUserRateStr 	= affiliatedUserRateStr.." <PAColor0xFFAEFF9B>"..PAGetString ( Defines.StringSheet_GAME, "LUA_LORDMENU_POPULATIONDENSITY_NORMAL").."<PAOldColor> ("..string.format( "%d", affiliatedUserRate).."%)"
		elseif (60 < affiliatedUserRate and affiliatedUserRate <= 80) then
			affiliatedUserRateStr 	= affiliatedUserRateStr.." <PAColor0xFF9B9BFF>"..PAGetString ( Defines.StringSheet_GAME, "LUA_LORDMENU_POPULATIONDENSITY_HIGH").."<PAOldColor> ("..string.format( "%d", affiliatedUserRate).."%)"
		elseif (80 < affiliatedUserRate and affiliatedUserRate <= 100) then
			affiliatedUserRateStr 	= affiliatedUserRateStr.." <PAColor0xFF8737FF>"..PAGetString ( Defines.StringSheet_GAME, "LUA_LORDMENU_POPULATIONDENSITY_EXPLOSION").."<PAOldColor> ("..string.format( "%d", affiliatedUserRate).."%)"
		end
		
		nodeAffiliatedUserRate:SetText(affiliatedUserRateStr)
		
		local temporaryWrapper = getTemporaryInformationWrapper()
		local affiliatedTerritoryKey = temporaryWrapper:getAffiliatedTerritoryKeyRaw()
		if ( tostring(territoryKeyRaw) == tostring(affiliatedTerritoryKey) ) then
			nodeAffiliatedTerritory		:SetShow(true)
			nodeAffiliatedTerritory		:SetAlpha(0)
			nodeAffiliatedTerritoryMark	:SetShow(true)
		else
			nodeAffiliatedTerritory		:SetShow(false)
			nodeAffiliatedTerritoryMark	:SetShow(false)
		end
		
	
		local isSet = setGuildTextureByGuildNo( siegeWrapper:getGuildNo(), guildMark )
		if ( false == isSet ) then
			guildMark			:ChangeTextureInfoName("New_UI_Common_forLua/Default/BlankGuildMark.dds")
			guildMark			:SetTexturePreload(false)
			guildMark			:SetAlpha(0)
		else
			guildMark			:SetAlpha(1)
		end

	end

	-- 어짜피 매 프레임 호출되고 있다! 굳이 명시적으로 호출해줄 필요는 없다!
	-- WorldMapWindow_TerritoryNameAndExplorationPoint_PositionUpdate()
end

function WorldMapWindow_Update_TerritoryNameAndExplorationPoint()
	if not Panel_Win_Worldmap:GetShow() then
		return
	end

	-- 이 모드에서는 랜더링을 하지 않는다!
	if WorldMapWindow.ViewDetailMode then
		for territoryKeyRaw, controls in pairs(territoryLine_Controls) do
			local lineData			= ToClient_worldmapGetTerritoryLineByRawKey(territoryKeyRaw)
			if (lineData ~= nil) then
				controls.nodeExploreTitle		 		:SetShow( false )
				controls.nodeSupportPoint		 		:SetShow( false )
				controls.nodeImage				 		:SetShow( false )
				controls.nodeAffiliatedUserRate  		:SetShow( false )
				controls.nodeAffiliatedTerritory 		:SetShow( false ) 
				controls.nodeAffiliatedTerritoryMark	:SetShow( false )
				controls.guildMark				 		:SetShow( false )
				lineData._isRender = false
			end
		end
		return
	end

	local cameraDistance = getWorldMapCameraDistance()
	local st_height = _Util_Math.Lerp( 10000, 150000, cameraDistance / 600000 )

	for territoryKeyRaw, controls in pairs(territoryLine_Controls) do
		local lineData			= ToClient_worldmapGetTerritoryLineByRawKey(territoryKeyRaw)
		if (lineData ~= nil) then
			lineData:setLineHeight_ForWorldMapTerritotyLine( st_height )
			controls.nodeExploreTitle				:SetShow( true )
			controls.nodeSupportPoint				:SetShow( true )
			controls.nodeImage						:SetShow( true )
			controls.nodeAffiliatedUserRate			:SetShow( true )
			controls.guildMark						:SetShow( true )
			lineData._isRender = true
		end
	end
end


------------------------------------------------------
-- Territory GuildImage
------------------------------------------------------
function WorldMapWindow_GuildInfoChange( guildNo )

	_PA_LOG("luadebug", "WorldMapWindow_GuildInfoChange");

	for territoryKeyRaw, controls in pairs(territoryLine_Controls) do
		local siegeWrapper = ToClient_GetSiegeWrapper(territoryKeyRaw)
		if ( nil ~= siegeWrapper ) and ( guildNo == siegeWrapper:getGuildNo() ) then
			local isSet = setGuildTextureByGuildNo( guildNo, controls.guildMark )
			if ( false == isSet ) then
				controls.guildMark:ChangeTextureInfoName("New_UI_Common_forLua/Default/BlankGuildMark.dds")
				controls.guildMark:SetTexturePreload(false)
			end
		end
	end

end


------------------------------------------------------
-- Territory Tooltip
------------------------------------------------------
local tooltip =
{
	panel			= Panel_CastleInfo,
	castleName		= UI.getChildControl( Panel_CastleInfo, "StaticText_CastleName" ),
	guildName		= UI.getChildControl( Panel_CastleInfo, "StaticText_CastleGuild" ),
	masterName		= UI.getChildControl( Panel_CastleInfo, "StaticText_CastleMaster" ),
	castleTime		= UI.getChildControl( Panel_CastleInfo, "StaticText_CastleTime" ),
	notice			= UI.getChildControl( Panel_CastleInfo, "StaticText_Notice" ),
}

function WorldMapWindow_OnTerritoryTooltipShow(territoryKeyRaw)
	local siegeWrapper = ToClient_GetSiegeWrapper(territoryKeyRaw)
	local controls = territoryLine_Controls[territoryKeyRaw]	
	--getTerritoryInfoWrapper
	local background = controls.nodeImage
	if ( nil ~= siegeWrapper ) and ( nil ~= background )then
		if ( false == siegeWrapper:doOccupantExist() ) then
			return
		end
		local float2Pos = float2( background:GetPosX() + background:GetSizeX() / 2 , background:GetPosY() + background:GetSizeY() / 2 )

		local paDate = siegeWrapper:getOccupyingDate()
		--local regionInfoWrapper = getRegionInfoWrapper(castleData.childRegionKey)

		tooltip.panel:SetPosX( float2Pos.x )
		tooltip.panel:SetPosY( float2Pos.y )
		tooltip.castleName:SetText( siegeWrapper:getRegionAreaName() )--regionInfoWrapper:getAreaName() )
		tooltip.guildName:SetText( PAGetString( Defines.StringSheet_GAME, "LUA_WORLD_MAP_SIEGE_GUILD" ).. " : " .. siegeWrapper:getGuildName() )
		tooltip.masterName:SetText( PAGetString( Defines.StringSheet_GAME, "LUA_WORLD_MAP_SIEGE_MASTER" ).. " : " .. siegeWrapper:getGuildMasterName() )
		local year = PAGetStringParam1( Defines.StringSheet_GAME, "LUA_WORLD_MAP_SIEGE_YEAR", "year", tostring(paDate:GetMonth()) )
		local month = PAGetStringParam1( Defines.StringSheet_GAME, "LUA_WORLD_MAP_SIEGE_MONTH", "month", tostring(paDate:GetDay()) )
		local day = PAGetStringParam1( Defines.StringSheet_GAME, "LUA_WORLD_MAP_SIEGE_DAY", "day", tostring(paDate:GetDay()) )
		local hour = PAGetStringParam1( Defines.StringSheet_GAME, "LUA_WORLD_MAP_SIEGE_HOUR", "hour", tostring(paDate:GetHour()) )
		tooltip.castleTime:SetText( PAGetString( Defines.StringSheet_GAME, "LUA_WORLD_MAP_SIEGE_TIME" ).. " : " .. year .. month .. day .. hour )
		tooltip.notice:SetTextMode(CppEnums.TextMode.eTextMode_AutoWrap)
		
		local temporaryWrapper = getTemporaryInformationWrapper()
		local affiliatedTerritoryKey = temporaryWrapper:getAffiliatedTerritoryKeyRaw()
		if (tostring(territoryKeyRaw) == tostring(affiliatedTerritoryKey)) then
			tooltip.notice:SetText(PAGetString( Defines.StringSheet_GAME, "LUA_WORLD_MAP_SIEGE_NOTICE"))
			tooltip.notice:SetShow(true)
			tooltip.notice:SetFontColor(Defines.Color.C_FFFFEF82)
			tooltip.panel:SetSize(280,180)	
		else
			tooltip.notice:SetShow(false)
			tooltip.panel:SetSize(280,140)	
		end	
		
	end
	tooltip.panel:SetShow(true)
end

function WorldMapWindow_OnTerritoryTooltipHide(territoryKeyRaw)
	tooltip.panel:SetShow(false)
end


------------------------------------------------------
-- GrapeUI
------------------------------------------------------
local grapePercentsUI = {}
function WorldMapWindow_Refresh_GrapePercents()
	if ( false == WorldMapWindow.uiList[WorldMapWindow.RenderType.WMS_REGION]:GetShow() ) then
		return
	end 
	local count = ToClient_worldmap_grapeCount()
	local maxCount = ToClient_worldmap_grapeMaxCount()
	for index = 0, count -1 do
		local position = ToClient_worldmap_grapePosition(index)
		local position2D		= worldmapScenetoScreenPosition(position.x, position.y, position.z)
		
		grapePercentsUI[index]:SetText( string.format("%d%%", ToClient_worldmap_grapePercent(index) ) )
		grapePercentsUI[index]:SetPosX(position2D.x * WorldMapWindow.world3DMapStatic:GetSizeX() - grapePercentsUI[index]:GetSizeX() / 2)
		grapePercentsUI[index]:SetPosY(position2D.y * WorldMapWindow.world3DMapStatic:GetSizeY() - grapePercentsUI[index]:GetSizeY() / 2)
		--grapePercentsUI[index]:SetText( string.format("%d%%", ToClient_worldmap_grapePercent(index) ) )
		grapePercentsUI[index]:SetFontAlpha(0.8)
		grapePercentsUI[index]:SetShow(true)
	end
	for index = count , (maxCount -1) * 3 do
		grapePercentsUI[index]:SetShow(false)
	end
end

function WorldMapWindow_Create_GrapePercents()
	local count = ToClient_worldmap_grapeMaxCount() 
	for index = 0, (count -1) * 3 do
		grapePercentsUI[index] = UI.createControl( UI_TYPE.PA_UI_CONTROL_STATICTEXT,  WorldMapWindow.uiList[WorldMapWindow.RenderType.WMS_REGION], "Static_grapePercent_" .. tostring(index) )
		CopyBaseProperty( template.SupportPanelPoint, grapePercentsUI[index])
		--grapePercentsUI[index]:SetFontAlpha(0.8)
		grapePercentsUI[index]:SetShow(false)
	end
end

WorldMapWindow_Create_GrapePercents()




------------------------------------------------------
-- mentalCardInformationUI
------------------------------------------------------
local mentalCardInformationUI = {}
local mentalCardInformationUI_Hint_Que = {}
local mentalCardInformationUI_Hint = {}

local mentalCardInformationIndex = {}
local mentalCardInformation_Hint_Que_Index = {}

local mentalCardInformationOverIndex = -1

----------------------------------------------------
-- 			물음표(사람)에 마우스를 올렸을 때
----------------------------------------------------
function WorldMapWindow_OnMentalCardInformationUIShow(index)
	local realIndex = mentalCardInformation_Hint_Que_Index[index]
	if ( nil == realIndex ) then
		return
	end

	local mentalCardStaticWrapper = ToClinet_getMentalCardByIndex(realIndex)
	if ( nil == mentalCardStaticWrapper ) then
		return
	end

	mentalCardInformationUI_Hint[index]:SetShow( true )
	mentalCardInformationUI_Hint_Que[index]:SetAlpha( 0 )
	
	mentalCardInformationOverIndex = index
end


----------------------------------------------------
-- 			물음표(사람)에서 마우스를 뗏을 때
----------------------------------------------------
function WorldMapWindow_OnMentalCardInformationUIHide(index)
	local realIndex = mentalCardInformation_Hint_Que_Index[index]
	if ( nil == realIndex ) then
		return
	end

	local mentalCardStaticWrapper = ToClinet_getMentalCardByIndex(realIndex)
	if ( nil == mentalCardStaticWrapper ) then
		return
	end

	mentalCardInformationUI_Hint[index]:SetShow( false )
	mentalCardInformationUI_Hint_Que[index]:SetAlpha( 1 )
	---------------------------------
	-- 			지식이 있다
	if ( mentalCardStaticWrapper:isHasCard() ) then
		mentalCardInformationUI[index]:SetColor( UI_color.C_FF00C0D7 )
		
		
		----------------------------------------------------
		-- 지식이 있으면 물음표 두루마리 텍스쳐를 바꿔준다
		mentalCardInformationUI_Hint_Que[index]:ChangeTextureInfoName( "New_UI_Common_ForLua/Default/Default_Etc_00.dds" )
		
		local x1, y1, x2, y2 = setTextureUV_Func( mentalCardInformationUI_Hint_Que[index], 102, 60, 110, 68 )
		mentalCardInformationUI_Hint_Que[index]:getBaseTexture():setUV(  x1, y1, x2, y2  )
		mentalCardInformationUI_Hint_Que[index]:setRenderTexture(mentalCardInformationUI_Hint_Que[index]:getBaseTexture())
		
	---------------------------------
	-- 			지식이 없다
	else

		----------------------------------------------------
		-- 지식이 없으면 물음표 두루마리 텍스쳐로 바꿔준다		
		mentalCardInformationUI_Hint_Que[index]:ChangeTextureInfoName( "New_UI_Common_ForLua/Widget/WorldMap/WorldMap_Etc_00.dds" )
		
		local x1, y1, x2, y2 = setTextureUV_Func( mentalCardInformationUI_Hint_Que[index], 130, 128, 156, 163 )
		mentalCardInformationUI_Hint_Que[index]:getBaseTexture():setUV(  x1, y1, x2, y2  )
		
	end
	
	if ( mentalCardInformationOverIndex == index ) then
		mentalCardInformationOverIndex = -1
	end
end


----------------------------------------------------
--			클릭하면 길찾기를 시전한다?
----------------------------------------------------
function WorldMapWindow_OnMentalCardInformationUIClick(index)
	-- ♬ 빛 기둥 나올 때 사운드 추가
	audioPostEvent_SystemUi(00,14)
	local realIndex = mentalCardInformation_Hint_Que_Index[index]
	if ( nil == realIndex ) then
		return
	end

	ToClient_DeleteNaviGuideByGroup(0);
	local mentalCardStaticWrapper = ToClinet_getMentalCardByIndex(realIndex)
	if nil ~= mentalCardStaticWrapper then
		local pos = mentalCardStaticWrapper:getPosition()
		local lineKey = worldmapNavigatorStart( pos, NavigationGuideParam(), false, false)
	end
end


-----------------------------------------------
-- 			지식 정보 위치 만들기
local createMentalCardInformationUI = function( index )
	mentalCardInformationUI[index] = UI.createControl( UI_TYPE.PA_UI_CONTROL_STATIC,  WorldMapWindow.uiList[WorldMapWindow.RenderType.WMS_EXPLORE_PLANT], "Static_mentalCardInformation_" .. tostring(index) )
	CopyBaseProperty( template._human, mentalCardInformationUI[index])

	mentalCardInformationUI_Hint_Que[index] = UI.createControl( UI_TYPE.PA_UI_CONTROL_STATIC,  mentalCardInformationUI[index], "Static_mentalCardInfo_HintQue_" .. tostring(index) )
	CopyBaseProperty( template._hint_que, mentalCardInformationUI_Hint_Que[index])

	mentalCardInformationUI_Hint[index] = UI.createControl( UI_TYPE.PA_UI_CONTROL_STATICTEXT,  mentalCardInformationUI_Hint_Que[index], "Static_mentalCardInfo_Hint_" .. tostring(index) )
	CopyBaseProperty( template._hint, mentalCardInformationUI_Hint[index])

	mentalCardInformationUI[index]:SetShow( false )
	mentalCardInformationUI[index]:SetIgnore( true )
	mentalCardInformationUI_Hint_Que[index]:SetShow( true )
	mentalCardInformationUI_Hint_Que[index]:SetIgnore( false )
	mentalCardInformationUI_Hint_Que[index]:SetAlpha( 1 )
	mentalCardInformationUI_Hint[index]:SetShow( false )
	
	mentalCardInformationUI_Hint_Que[index]:SetEnableArea( 0, 0, 26, 70 )
	mentalCardInformationUI_Hint_Que[index]:addInputEvent("Mouse_On"	, "WorldMapWindow_OnMentalCardInformationUIShow("..index..")")
	mentalCardInformationUI_Hint_Que[index]:addInputEvent("Mouse_Out"	, "WorldMapWindow_OnMentalCardInformationUIHide("..index..")")
	mentalCardInformationUI_Hint_Que[index]:addInputEvent("Mouse_RUp"	, "WorldMapWindow_OnMentalCardInformationUIClick("..index..")")
end

local existMentalInfo = {
	[1] 	= { _text = "New_UI_Common_ForLua/Widget/WorldMap/WorldMap_Etc_00.dds", x1 = 38, y1 = 197, x2 = 74, y2 = 233, _knowledge = true, },		-- 인물
	[5001] 	= { _text = "New_UI_Common_ForLua/Widget/WorldMap/WorldMap_Etc_00.dds", x1 = 1, y1 = 197, x2 = 37, y2 = 233, _knowledge = true, }, 		-- 지형
	[10001]	= { _text = "New_UI_Common_ForLua/Widget/WorldMap/WorldMap_Etc_00.dds", x1 = 75, y1 = 197, x2 = 111, y2 = 233, _knowledge = true, }, 	-- 생태
	[20001] = { _text = "New_UI_Common_ForLua/Widget/WorldMap/WorldMap_Etc_00.dds", x1 = 75, y1 = 197, x2 = 111, y2 = 233, _knowledge = true, }, 	-- 모험일지
	[25001] = { _text = "New_UI_Common_ForLua/Widget/WorldMap/WorldMap_Etc_00.dds", x1 = 75, y1 = 197, x2 = 111, y2 = 233, _knowledge = true, }, 	-- 학문
	[30001] = { _text = "New_UI_Common_ForLua/Widget/WorldMap/WorldMap_Etc_00.dds", x1 = 112, y1 = 197, x2 = 148, y2 = 233, _knowledge = false, }, 	-- 생활
}

local extraMentalInfo = {
	-- [2] = { _text = "New_UI_Common_ForLua/Widget/WorldMap/WorldMap_Etc_00.dds", x1 = 35, y1 = 100, x2 = 51, y2 = 116, _knowledge = true, }, 		-- 질다 (재료상인)
	[4] = { _text = "New_UI_Common_ForLua/Widget/WorldMap/WorldMap_Etc_00.dds", x1 = 475, y1 = 38, x2 = 511, y2 = 74, _knowledge = true, }, 		-- 클로린스(물약)
	[9] = { _text = "New_UI_Common_ForLua/Widget/WorldMap/WorldMap_Etc_00.dds", x1 = 475, y1 = 65, x2 = 511, y2 = 37, _knowledge = true, }, 		-- 타크로스(기술교관)
	[45] = { _text = "New_UI_Common_ForLua/Widget/WorldMap/WorldMap_Etc_00.dds", x1 = 475, y1 = 38, x2 = 511, y2 = 74, _knowledge = true, }, 		-- 에일린(물약)
	[43] = { _text = "New_UI_Common_ForLua/Widget/WorldMap/WorldMap_Etc_00.dds", x1 = 475, y1 = 38, x2 = 511, y2 = 74, _knowledge = true, }, 		-- 라니(물약)
	[61] = { _text = "New_UI_Common_ForLua/Widget/WorldMap/WorldMap_Etc_00.dds", x1 = 475, y1 = 38, x2 = 511, y2 = 74, _knowledge = true, }, 		-- 키나(물약)
	[16] = { _text = "New_UI_Common_ForLua/Widget/WorldMap/WorldMap_Etc_00.dds", x1 = 475, y1 = 75, x2 = 511, y2 = 111, _knowledge = true, }, 		-- 로렌조(마구간)
	
	[38] = { _text = "New_UI_Common_ForLua/Widget/WorldMap/WorldMap_Etc_00.dds", x1 = 475, y1 = 65, x2 = 511, y2 = 37, _knowledge = true, }, 		-- 암스트롱(기술교관)
	[34] = { _text = "New_UI_Common_ForLua/Widget/WorldMap/WorldMap_Etc_00.dds", x1 = 475, y1 = 38, x2 = 511, y2 = 74, _knowledge = true, }, 		-- 헤센베일(물약)
	[60] = { _text = "New_UI_Common_ForLua/Widget/WorldMap/WorldMap_Etc_00.dds", x1 = 475, y1 = 75, x2 = 511, y2 = 111, _knowledge = true, }, 		-- 사무엘(마구간)
	
	[386] = { _text = "New_UI_Common_ForLua/Widget/WorldMap/WorldMap_Etc_00.dds", x1 = 475, y1 = 65, x2 = 511, y2 = 37, _knowledge = true, }, 		-- 크록서스(기술교관)
	[388] = { _text = "New_UI_Common_ForLua/Widget/WorldMap/WorldMap_Etc_00.dds", x1 = 475, y1 = 38, x2 = 511, y2 = 74, _knowledge = true, }, 	-- 릴리아(물약)
	
	[109] = { _text = "New_UI_Common_ForLua/Widget/WorldMap/WorldMap_Etc_00.dds", x1 = 475, y1 = 65, x2 = 511, y2 = 37, _knowledge = true, }, 		-- 크루혼 웜스베인(기술교관)
	[103] = { _text = "New_UI_Common_ForLua/Widget/WorldMap/WorldMap_Etc_00.dds", x1 = 475, y1 = 38, x2 = 511, y2 = 74, _knowledge = true, }, 	-- 카레스토 폰티(물약)
	[104] = { _text = "New_UI_Common_ForLua/Widget/WorldMap/WorldMap_Etc_00.dds", x1 = 475, y1 = 38, x2 = 511, y2 = 74, _knowledge = true, }, 	-- 라라(물약)
	[116] = { _text = "New_UI_Common_ForLua/Widget/WorldMap/WorldMap_Etc_00.dds", x1 = 475, y1 = 75, x2 = 511, y2 = 111, _knowledge = true, }, 	-- 바나실(마구간)
	[127] = { _text = "New_UI_Common_ForLua/Widget/WorldMap/WorldMap_Etc_00.dds", x1 = 475, y1 = 75, x2 = 511, y2 = 111, _knowledge = true, }, 	-- 이자우로(마구간)
	
	[139] = { _text = "New_UI_Common_ForLua/Widget/WorldMap/WorldMap_Etc_00.dds", x1 = 475, y1 = 38, x2 = 511, y2 = 74, _knowledge = true, }, 	-- 모니쿠(물약)
	[150] = { _text = "New_UI_Common_ForLua/Widget/WorldMap/WorldMap_Etc_00.dds", x1 = 475, y1 = 38, x2 = 511, y2 = 74, _knowledge = true, }, 	-- 세이레인(물약)
	[181] = { _text = "New_UI_Common_ForLua/Widget/WorldMap/WorldMap_Etc_00.dds", x1 = 475, y1 = 75, x2 = 511, y2 = 111, _knowledge = true, }, 	-- 엘라(마구간)
	[153] = { _text = "New_UI_Common_ForLua/Widget/WorldMap/WorldMap_Etc_00.dds", x1 = 475, y1 = 75, x2 = 511, y2 = 111, _knowledge = true, }, 	-- 암브로시아(마구간)

	[155] = { _text = "New_UI_Common_ForLua/Widget/WorldMap/WorldMap_Etc_00.dds", x1 = 475, y1 = 65, x2 = 511, y2 = 37, _knowledge = true, }, 		-- 체이사르(기술교관)
	[156] = { _text = "New_UI_Common_ForLua/Widget/WorldMap/WorldMap_Etc_00.dds", x1 = 475, y1 = 75, x2 = 511, y2 = 111, _knowledge = true, }, 	-- 로레나(마구간)
	[166] = { _text = "New_UI_Common_ForLua/Widget/WorldMap/WorldMap_Etc_00.dds", x1 = 475, y1 = 75, x2 = 511, y2 = 111, _knowledge = true, }, 	-- 올리비에로(마구간)
	[167] = { _text = "New_UI_Common_ForLua/Widget/WorldMap/WorldMap_Etc_00.dds", x1 = 475, y1 = 75, x2 = 511, y2 = 111, _knowledge = true, }, 	-- 푸블리오(마구간)
	[169] = { _text = "New_UI_Common_ForLua/Widget/WorldMap/WorldMap_Etc_00.dds", x1 = 475, y1 = 75, x2 = 511, y2 = 111, _knowledge = true, }, 	-- 델모(마구간)
	
	[344] = { _text = "New_UI_Common_ForLua/Widget/WorldMap/WorldMap_Etc_00.dds", x1 = 475, y1 = 38, x2 = 511, y2 = 74, _knowledge = true, }, 	-- 알쳄(물약)
	[354] = { _text = "New_UI_Common_ForLua/Widget/WorldMap/WorldMap_Etc_00.dds", x1 = 475, y1 = 75, x2 = 511, y2 = 111, _knowledge = true, }, 	-- 게이브릴(마구간)
	[351] = { _text = "New_UI_Common_ForLua/Widget/WorldMap/WorldMap_Etc_00.dds", x1 = 475, y1 = 75, x2 = 511, y2 = 111, _knowledge = true, }, 	-- 브리스만(마구간)
	[399] = { _text = "New_UI_Common_ForLua/Widget/WorldMap/WorldMap_Etc_00.dds", x1 = 475, y1 = 75, x2 = 511, y2 = 111, _knowledge = true, }, 	-- 디만토르(마구간)
	[400] = { _text = "New_UI_Common_ForLua/Widget/WorldMap/WorldMap_Etc_00.dds", x1 = 475, y1 = 75, x2 = 511, y2 = 111, _knowledge = true, }, 	-- 아쉬로그(마구간)
	[482] = { _text = "New_UI_Common_ForLua/Widget/WorldMap/WorldMap_Etc_00.dds", x1 = 475, y1 = 65, x2 = 511, y2 = 37, _knowledge = true, }, 		-- 레날두스(기술교관)
	[483] = { _text = "New_UI_Common_ForLua/Widget/WorldMap/WorldMap_Etc_00.dds", x1 = 475, y1 = 65, x2 = 511, y2 = 37, _knowledge = true, }, 		-- 폰 마렌(기술교관)
	[484] = { _text = "New_UI_Common_ForLua/Widget/WorldMap/WorldMap_Etc_00.dds", x1 = 475, y1 = 65, x2 = 511, y2 = 37, _knowledge = true, }, 		-- 프세보르(기술교관)
	
	[350] = { _text = "New_UI_Common_ForLua/Widget/WorldMap/WorldMap_Etc_00.dds", x1 = 475, y1 = 75, x2 = 511, y2 = 111, _knowledge = true, }, 	-- 로마리오(마구간)
	[337] = { _text = "New_UI_Common_ForLua/Widget/WorldMap/WorldMap_Etc_00.dds", x1 = 475, y1 = 38, x2 = 511, y2 = 74, _knowledge = true, }, 	-- 스텔라(물약)
	[340] = { _text = "New_UI_Common_ForLua/Widget/WorldMap/WorldMap_Etc_00.dds", x1 = 475, y1 = 65, x2 = 511, y2 = 37, _knowledge = true, }, 		-- 폴리니(기술교관)
	[333] = { _text = "New_UI_Common_ForLua/Widget/WorldMap/WorldMap_Etc_00.dds", x1 = 475, y1 = 75, x2 = 511, y2 = 111, _knowledge = true, }, 	-- 헤르아르(마구간)
	
	[465] = { _text = "New_UI_Common_ForLua/Widget/WorldMap/WorldMap_Etc_00.dds", x1 = 475, y1 = 38, x2 = 511, y2 = 74, _knowledge = true, }, 	-- 피리아(물약)
	[467] = { _text = "New_UI_Common_ForLua/Widget/WorldMap/WorldMap_Etc_00.dds", x1 = 475, y1 = 65, x2 = 511, y2 = 37, _knowledge = true, }, 		-- 테레시오 카폰(기술교관)
	[470] = { _text = "New_UI_Common_ForLua/Widget/WorldMap/WorldMap_Etc_00.dds", x1 = 475, y1 = 75, x2 = 511, y2 = 111, _knowledge = true, }, 	-- 파누치(마구간)
	
	[414] = { _text = "New_UI_Common_ForLua/Widget/WorldMap/WorldMap_Etc_00.dds", x1 = 475, y1 = 38, x2 = 511, y2 = 74, _knowledge = true, }, 	-- 칸트(물약)
	[419] = { _text = "New_UI_Common_ForLua/Widget/WorldMap/WorldMap_Etc_00.dds", x1 = 475, y1 = 65, x2 = 511, y2 = 37, _knowledge = true, }, 		-- 릴바노스(기술교관)
	[430] = { _text = "New_UI_Common_ForLua/Widget/WorldMap/WorldMap_Etc_00.dds", x1 = 475, y1 = 75, x2 = 511, y2 = 111, _knowledge = true, }, 	-- 파르투스(마구간)
	[440] = { _text = "New_UI_Common_ForLua/Widget/WorldMap/WorldMap_Etc_00.dds", x1 = 475, y1 = 75, x2 = 511, y2 = 111, _knowledge = true, }, 	-- 라하론(마구간)
	
	[444] = { _text = "New_UI_Common_ForLua/Widget/WorldMap/WorldMap_Etc_00.dds", x1 = 475, y1 = 38, x2 = 511, y2 = 74, _knowledge = true, }, 	-- 고프란트(물약)
	[451] = { _text = "New_UI_Common_ForLua/Widget/WorldMap/WorldMap_Etc_00.dds", x1 = 475, y1 = 75, x2 = 511, y2 = 111, _knowledge = true, }, 	-- 베벨(마구간)
	
	[454] = { _text = "New_UI_Common_ForLua/Widget/WorldMap/WorldMap_Etc_00.dds", x1 = 475, y1 = 38, x2 = 511, y2 = 74, _knowledge = true, }, 	-- 옌센(물약)
	[458] = { _text = "New_UI_Common_ForLua/Widget/WorldMap/WorldMap_Etc_00.dds", x1 = 475, y1 = 38, x2 = 511, y2 = 74, _knowledge = true, }, 	-- 크리에(물약)
	[461] = { _text = "New_UI_Common_ForLua/Widget/WorldMap/WorldMap_Etc_00.dds", x1 = 475, y1 = 65, x2 = 511, y2 = 37, _knowledge = true, }, 		-- 넬리도르민(기술교관)
	[457] = { _text = "New_UI_Common_ForLua/Widget/WorldMap/WorldMap_Etc_00.dds", x1 = 475, y1 = 75, x2 = 511, y2 = 111, _knowledge = true, }, 	-- 스피그(마구간)
	
	[314] = { _text = "New_UI_Common_ForLua/Widget/WorldMap/WorldMap_Etc_00.dds", x1 = 475, y1 = 38, x2 = 511, y2 = 74, _knowledge = true, }, 	-- 말릭(물약)
	[327] = { _text = "New_UI_Common_ForLua/Widget/WorldMap/WorldMap_Etc_00.dds", x1 = 475, y1 = 38, x2 = 511, y2 = 74, _knowledge = true, }, 	-- 루이보(물약)
	[329] = { _text = "New_UI_Common_ForLua/Widget/WorldMap/WorldMap_Etc_00.dds", x1 = 475, y1 = 75, x2 = 511, y2 = 111, _knowledge = true, }, 	-- 스피그(마구간)
	
	[183] = { _text = "New_UI_Common_ForLua/Widget/WorldMap/WorldMap_Etc_00.dds", x1 = 475, y1 = 112, x2 = 511, y2 = 148, _knowledge = true, }, 	-- 에르닐(창고)
	-- [183] = { _text = "New_UI_Common_ForLua/Widget/WorldMap/WorldMap_Etc_00.dds", x1 = 475, y1 = 112, x2 = 511, y2 = 148, _knowledge = true, }, 	-- 바오리(창고)
	[113] = { _text = "New_UI_Common_ForLua/Widget/WorldMap/WorldMap_Etc_00.dds", x1 = 475, y1 = 112, x2 = 511, y2 = 148, _knowledge = true, }, 	-- 아메리고(창고)
	[182] = { _text = "New_UI_Common_ForLua/Widget/WorldMap/WorldMap_Etc_00.dds", x1 = 475, y1 = 112, x2 = 511, y2 = 148, _knowledge = true, }, 	-- 프레닐(창고)
	-- [464] = { _text = "New_UI_Common_ForLua/Widget/WorldMap/WorldMap_Etc_00.dds", x1 = 475, y1 = 112, x2 = 511, y2 = 148, _knowledge = true, }, 	-- 라팔로(창고)
	[464] = { _text = "New_UI_Common_ForLua/Widget/WorldMap/WorldMap_Etc_00.dds", x1 = 475, y1 = 112, x2 = 511, y2 = 148, _knowledge = true, }, 	-- 파비노 그레코(창고)
	[421] = { _text = "New_UI_Common_ForLua/Widget/WorldMap/WorldMap_Etc_00.dds", x1 = 475, y1 = 112, x2 = 511, y2 = 148, _knowledge = true, }, 	-- 크리스틴 세서리(창고)
	[450] = { _text = "New_UI_Common_ForLua/Widget/WorldMap/WorldMap_Etc_00.dds", x1 = 475, y1 = 112, x2 = 511, y2 = 148, _knowledge = true, }, 	-- 랑구스(창고)
	[456] = { _text = "New_UI_Common_ForLua/Widget/WorldMap/WorldMap_Etc_00.dds", x1 = 475, y1 = 112, x2 = 511, y2 = 148, _knowledge = true, }, 	-- 리케 베어(창고)
	
	-- [000] = { _text = "New_UI_Common_ForLua/Widget/WorldMap/WorldMap_Etc_00.dds", x1 = 438, y1 = 1, 		x2 = 474, y2 = 37, _knowledge = true, }, 	-- (보석)
	-- [000] = { _text = "New_UI_Common_ForLua/Widget/WorldMap/WorldMap_Etc_00.dds", x1 = 438, y1 = 38, 	x2 = 474, y2 = 74, _knowledge = true, }, 	-- (가구)
	-- [000] = { _text = "New_UI_Common_ForLua/Widget/WorldMap/WorldMap_Etc_00.dds", x1 = 438, y1 = 75, 	x2 = 474, y2 = 111, _knowledge = true, }, 	-- (재료)
	-- [000] = { _text = "New_UI_Common_ForLua/Widget/WorldMap/WorldMap_Etc_00.dds", x1 = 438, y1 = 112, 	x2 = 474, y2 = 148, _knowledge = true, }, 	-- (물고기)
	-- [000] = { _text = "New_UI_Common_ForLua/Widget/WorldMap/WorldMap_Etc_00.dds", x1 = 401, y1 = 1, 		x2 = 437, y2 = 37, _knowledge = true, }, 	-- (작업감독)
	-- [000] = { _text = "New_UI_Common_ForLua/Widget/WorldMap/WorldMap_Etc_00.dds", x1 = 401, y1 = 38, 	x2 = 437, y2 = 74, _knowledge = true, }, 	-- (연금술)
}

function WorldMapWindow_Init_MentalCardInformationUI()
	mentalCardInformationIndex = {}
	mentalCardInformation_Hint_Que_Index = {}
	mentalCardInformation_Hint_Index = {}
	
	for key, value in pairs( mentalCardInformationUI ) do
		value:SetShow(false)
	end
	for key, value in pairs( mentalCardInformationUI_Hint_Que ) do
		value:SetShow(false)
	end
	for key, value in pairs( mentalCardInformationUI_Hint ) do
		value:SetShow(false)
	end

	ToClinet_updateMentalCardFoundLevel()

	local count = ToClinet_getMentalCardCount()
	local uiIndex = 0
	for index = 0, count -1 do
		
		local mentalCardStaticWrapper = ToClinet_getMentalCardByIndex(index)
		if nil ~= mentalCardStaticWrapper then
			
			if ( mentalCardStaticWrapper:isHintShowable(ToClinet_getMentalCardFoundLevel(mentalCardStaticWrapper:getRegionKeyRaw()) ) ) then
				local ui = mentalCardInformationUI[uiIndex]
				local ui_HintQue = mentalCardInformationUI_Hint_Que[uiIndex]
				local ui_Hint = mentalCardInformationUI_Hint[uiIndex]
				
				if ( nil == ui ) and ( nil == ui_HintQue ) and ( nil == ui_Hint ) then
					createMentalCardInformationUI(uiIndex)
					
					ui = mentalCardInformationUI[uiIndex]
					ui_HintQue = mentalCardInformationUI_Hint_Que[uiIndex]
					ui_Hint = mentalCardInformationUI_Hint[uiIndex]
				else
					ui:SetScaleChild(1,1)
				end
				
				mentalCardInformationIndex[uiIndex] = index
				mentalCardInformation_Hint_Que_Index[uiIndex] = index
				mentalCardInformation_Hint_Index[uiIndex] = index
        
				mentalCardInformationUI_Hint[uiIndex]:SetShow( false )
				
				----------------------------------------------------
				-- 컨텐츠 별 아이콘 바꿔준다
				local textureData = existMentalInfo[mentalCardStaticWrapper:getMainThemeKeyRaw()]
				if ( nil == textureData ) then
					textureData = existMentalInfo[1] -- 새로운키가 등록되면 무조건 인물로 보여줌.
				end				
				
				local extraTextureData = extraMentalInfo[ mentalCardStaticWrapper:getKey() ]

				if( nil ~= extraTextureData ) then
					textureData = extraTextureData
				end
				
				
				mentalCardInformationUI[uiIndex]:ChangeTextureInfoName( textureData._text )
				
				local x1, y1, x2, y2 = setTextureUV_Func( mentalCardInformationUI[uiIndex], textureData.x1, textureData.y1, textureData.x2, textureData.y2 )
				mentalCardInformationUI[uiIndex]:getBaseTexture():setUV(  x1, y1, x2, y2  )
				mentalCardInformationUI[uiIndex]:setRenderTexture(mentalCardInformationUI[uiIndex]:getBaseTexture())
				
				---------------------------------
				-- 			지식이 있다
				if ( mentalCardStaticWrapper:isHasCard() ) then
					mentalCardInformationUI[uiIndex]:SetColor( UI_color.C_FF40D7FD )
					mentalCardInformationUI_Hint_Que[uiIndex]:SetAlpha( 1 )
					
					----------------------------------------------------
					-- 지식이 있으면 물음표 두루마리 텍스쳐를 바꿔준다
					mentalCardInformationUI_Hint_Que[uiIndex]:ChangeTextureInfoName( "New_UI_Common_ForLua/Default/Default_Etc_00.dds" )
					
					local x1, y1, x2, y2 = setTextureUV_Func( mentalCardInformationUI_Hint_Que[uiIndex], 102, 60, 110, 68 )
					mentalCardInformationUI_Hint_Que[uiIndex]:getBaseTexture():setUV(  x1, y1, x2, y2  )
					mentalCardInformationUI_Hint_Que[uiIndex]:setRenderTexture(mentalCardInformationUI_Hint_Que[uiIndex]:getBaseTexture())
			
					mentalCardInformationUI_Hint[uiIndex]:SetText( mentalCardStaticWrapper:getName() )
				---------------------------------
				-- 			지식이 없다					
				else
					mentalCardInformationUI[uiIndex]:SetColor( UI_color.C_FFFFFFFF )
					mentalCardInformationUI_Hint_Que[uiIndex]:SetAlpha( 1 )
					
					----------------------------------------------------
					-- 지식이 없으면 물음표 두루마리 텍스쳐로 바꿔준다		
					mentalCardInformationUI_Hint_Que[uiIndex]:ChangeTextureInfoName( "New_UI_Common_ForLua/Widget/WorldMap/WorldMap_Etc_00.dds" )
					
					local x1, y1, x2, y2 = setTextureUV_Func( mentalCardInformationUI_Hint_Que[uiIndex], 130, 128, 156, 163 )
					mentalCardInformationUI_Hint_Que[uiIndex]:getBaseTexture():setUV(  x1, y1, x2, y2  )
					mentalCardInformationUI_Hint_Que[uiIndex]:setRenderTexture(mentalCardInformationUI_Hint_Que[uiIndex]:getBaseTexture())

					mentalCardInformationUI_Hint[uiIndex]:SetText( mentalCardStaticWrapper:getKeyword() )
				end

				mentalCardInformationUI_Hint[uiIndex]:SetSize ( mentalCardInformationUI_Hint[uiIndex]:GetTextSizeX() + 40, mentalCardInformationUI_Hint[uiIndex]:GetSizeY() )
				mentalCardInformationUI_Hint[uiIndex]:ComputePos()
				
				uiIndex = uiIndex +1
			end
		end
	end	
end


function WorldMapWindow_Refresh_MentalCardInformationUI()
	local position2D = float3()
	local ui = nil
	local mentalCardStaticWrapper = nil
	local position = nil
	local cameraPos = getWorldMapCameraPos()
	local depthValue = 0

	
	for uiIndex, clientIndex in pairs(mentalCardInformationIndex) do
		mentalCardStaticWrapper = ToClinet_getMentalCardByIndex(clientIndex)
		
		if nil ~= mentalCardStaticWrapper then
			local textureData = existMentalInfo[mentalCardStaticWrapper:getMainThemeKeyRaw()]
			ui = mentalCardInformationUI[uiIndex]
			if( textureData._knowledge ) and ( WorldMapWindow._btn_Knowledge_Check == false ) then
				ui:SetShow(false)
			elseif( textureData._knowledge == false ) and ( WorldMapWindow._btn_Fishes_Check == false ) then
				ui:SetShow(false)
			else
				----------------------------------------------------------------------------------------------------
				------------------------------- Camera 상태에 따라 Icon 위치 조정 ----------------------------------
				----------------------------------------------------------------------------------------------------
				position = mentalCardStaticWrapper:getPosition()
			
			
				worldmap_toScreenPositionInOut(position, position2D)
				mentalCardInformationUI_Hint_Que[uiIndex]:SetShow(true)
			
				if ( 0 < position2D.z ) and ( position2D.z <= 1 ) then
				
					depthValue = WorldMapWindow_GetDepthFromPos3D(cameraPos, position)
					local depthScale = math.max(0, math.min(1, 1 - depthValue * 0.7) )
					if ( depthScale <= 0.1 ) then
						ui:SetShow(false)
					else
						if ( mentalCardInformationOverIndex == uiIndex ) then
							ui:SetDepth(0)
						else
							ui:SetDepth(depthValue)
						end
						ui:SetScaleChild( depthScale, depthScale )

						ui:SetPosX(position2D.x * WorldMapWindow.world3DMapStatic:GetSizeX() - ui:GetSizeX() / 2)
						ui:SetPosY(position2D.y * WorldMapWindow.world3DMapStatic:GetSizeY() - ui:GetSizeY() / 2)
						ui:SetShow(true)
					end
				else
					ui:SetShow(false)
				end
			end

		end
	end
end



function WorldMapWindow_Create_mentalCardInformation()
	local count = 100 --ToClinet_getMentalCardCount()
	for index = 0, count -1 do
		createMentalCardInformationUI(index)
	end
end



------------------------------------------------------
-- 
------------------------------------------------------







local WorldMapWindow_OnShow = function()
	CircleLineCenterPos[0] = float3(10000, 0, 10000)
	CircleLineCenterPos[1] = float3(10000, 0, 10000)
	CircleLineCenterPos[2] = float3(10000, 0, 10000)
	
	LocationNEWSRotation = 0

	for i = loc.LocationN, loc.LocationW do
		locationText[i]:SetShow(true)
	end
end

local WorldMapWindow_OnHide = function()
	for i = 0, 4, 1 do
		worldmapDeleteLine(WorldMapWindow.RenderType.WMS_EXPLORE_PLANT, CircleLineIdx[i], 100)
		CircleLineIdx[i] = -1
	end

	for i = loc.LocationN, loc.LocationW do
		locationText[i]:SetShow(false)
	end

	for idx, villageTextData in pairs(villageTextList) do
		UI.deleteControl( villageTextData.control )
		UI.deleteControl( villageTextData.arrowControl )
	end
	villageTextList = {}

	WorldMapWindow_Clear_TerritoryNameAndExplorationPoint()

	contributePoint_UpdateFunc()
	
end


local selectedIdx = nil
function WorldMapWindow_Update_AffiliatedTerritory(idx)
	local temporaryWrapper = getTemporaryInformationWrapper()
	local affiliatedTerritoryKey = temporaryWrapper:getAffiliatedTerritoryKeyRaw()
	local territoryKeyRaw = territoryKeyList[idx]
	
	if(tostring(affiliatedTerritoryKey) == tostring(territoryKeyRaw)) then
		return
	end
	 
	local messageTitle		= "<PAColor0xFFFFCE22>"..PAGetString ( Defines.StringSheet_GAME, "LUA_WORLD_MAP_GUIDE_CHANGEATERRITORY_TITLE").."<PAOldColor>"
	local messageContents	= "\n\n<PAColor0xFF797979>"..PAGetString ( Defines.StringSheet_GAME, "LUA_WORLD_MAP_GUIDE_CHANGEATERRITORY_CONTENT").."<PAOldColor>\n"

	local affiliatedTerritoryInfoWrapper = getTerritoryInfoWrapper(affiliatedTerritoryKey)
	if ( nil ~= affiliatedTerritoryInfoWrapper ) then
		messageContents = messageContents.."\n"..PAGetString ( Defines.StringSheet_GAME, "LUA_WORLD_MAP_GUIDE_CURRENT_ATERRITORY").."<PAColor0xFF797979>"..affiliatedTerritoryInfoWrapper:getTerritoryName().."<PAOldColor>"
	end
	
	local territoryInfoWrapper = getTerritoryInfoWrapper(territoryKeyRaw)
	if ( nil ~= territoryInfoWrapper ) then
		messageContents = messageContents.."\n"..PAGetString ( Defines.StringSheet_GAME, "LUA_WORLD_MAP_GUIDE_CHANGE_ATERRITORY").."<PAColor0xFFFFD46D>"..territoryInfoWrapper:getTerritoryName().."<PAOldColor>"
	end
	
	messageContents	= messageContents.."\n\n<PAColor0xFFF26A6A>".. PAGetString ( Defines.StringSheet_GAME, "LUA_WORLD_MAP_GUIDE_CHANGEATERRITORY_ALERT").."<PAOldColor>"
	
	local messageboxData = { title = messageTitle, content = messageContents, functionApply = WorldMapWindow_Update_AffiliatedTerritoryDone, functionCancel = MessageBox_Empty_function, priority = CppEnums.PAUIMB_PRIORITY.PAUIMB_PRIORITY_LOW}
	MessageBox.showMessageBox(messageboxData, "top")
	
	selectedIdx = idx
end

function WorldMapWindow_Update_AffiliatedTerritoryDone()
	local territoryKeyRaw = territoryKeyList[selectedIdx]
	local temporaryWrapper = getTemporaryInformationWrapper()
	
	--월드맵에서 소속영지를 바꾸지 않는다, 주거지를 바꿀시, 해당 지역으로 바뀐다.(20140503:흥신)
	--temporaryWrapper:changeAffiliatedTerritoryKeyRaw(territoryKeyRaw)
end

WorldMapWindow_Set_OnShowHide_Handler( true, WorldMapWindow_OnShow )
WorldMapWindow_Set_OnShowHide_Handler( false, WorldMapWindow_OnHide )
