local UI_TYPE		= CppEnums.PA_UI_CONTROL_TYPE
local ENT 			= CppEnums.ExplorationNodeType
local _Util_Math = Util.Math

local template =
{
	LocationVillage			= UI.getChildControl( Panel_Loading, "StaticText_LocationVillage" ),
	ExplorePanelTitle		= UI.getChildControl( Panel_Loading, "StaticText_ExploreTerritory" ),
	ExplorePanelPoint		= UI.getChildControl( Panel_Loading, "StaticText_ExplorePoint" ),
	SupportPanelPoint		= UI.getChildControl( Panel_Loading, "StaticText_SupportPoint" ),
	ImagePanel				= UI.getChildControl( Panel_Loading, "StaticText_Image" ),
}

RenderType = {
	WMS_EXPLORE_PLANT			= 0,
	WMS_REGION					= 1,
	WMS_LOCATION_INFO_WATER		= 2,
	WMS_LOCATION_INFO_CELCIUS	= 3,
	WMS_LOCATION_INFO_HUMILITY	= 4,
}

local sortLoadingUI = {};
local sortLoadingUICount = 8;
local _bgImage			= UI.getChildControl( Panel_Loading, "Static_BG_Image" )

sortLoadingUI[0] = UI.getChildControl( Panel_Loading, "Static_BG_1" );
sortLoadingUI[1] = UI.getChildControl( Panel_Loading, "Static_BG_2" );
sortLoadingUI[2] = UI.getChildControl( Panel_Loading, "StaticText_RegionName" );
sortLoadingUI[3] = UI.getChildControl( Panel_Loading, "Static_Progress_Back" );
sortLoadingUI[4] = UI.getChildControl( Panel_Loading, "Progress2_Loading" );
sortLoadingUI[5] = UI.getChildControl( Panel_Loading, "Static_knowImage" );
sortLoadingUI[6] = UI.getChildControl( Panel_Loading, "StaticText_knowTitle" );
sortLoadingUI[7] = UI.getChildControl( Panel_Loading, "StaticText_knowDesc" );
sortLoadingUI[8] = UI.getChildControl( Panel_Loading, "Static_GoblinRun" );



local villageTextList = {}
local territoryLine_Controls = {}

local CircleLineIdx = {};
CircleLineIdx[0] = -1;
CircleLineIdx[1] = -1;
CircleLineIdx[2] = -1;
CircleLineIdx[3] = -1;
CircleLineIdx[4] = -1;

local CircleLineCenterPos = {};
CircleLineCenterPos[0] = float3(10000, 0, 10000);
CircleLineCenterPos[1] = float3(10000, 0, 10000);
CircleLineCenterPos[2] = float3(10000, 0, 10000);

local CircleLineCenterRadius = {};
CircleLineCenterRadius[0] =  20000;
CircleLineCenterRadius[1] =  60000;
CircleLineCenterRadius[2] = 100000;

-- 원 3개 높이.
local circleLineHeight = {}
circleLineHeight[1] = 10000
circleLineHeight[2] = 20000
circleLineHeight[3] = 30000


local loc =
{
	LocationN = 0,
	LocationE = 1,
	LocationS = 2,
	LocationW = 3,
}

local LocationNEWSRotation = 0;

local SunIconStatic = UI.getChildControl( Panel_Loading, "Static_Weather_Sun" );
local MoonIconStatic = UI.getChildControl( Panel_Loading, "Static_Weather_Moon" );

local SunTimeText	= UI.getChildControl( Panel_Loading, "StaticText_SunTime" );

local nodeDataList = {};

local locationText = {};
locationText[loc.LocationN]		= UI.getChildControl( Panel_Loading, "StaticText_LocationN" );
locationText[loc.LocationE]		= UI.getChildControl( Panel_Loading, "StaticText_LocationE" );
locationText[loc.LocationS]		= UI.getChildControl( Panel_Loading, "StaticText_LocationS" );
locationText[loc.LocationW]		= UI.getChildControl( Panel_Loading, "StaticText_LocationW" );

function WorldMapWindow_GetDepthFromPos3D( camera, position )
	return _Util_Math.calculateDistance(camera, position) / 100000.0;
end

------------------------------------------------------
-- Circle Line - 원 3개
------------------------------------------------------
function WorldMapWindow_Refresh_CircleLine()
	if not Panel_Loading:GetShow() then
		return;
	end

	local cameraPosition = getWorldMapCameraLookAt();
	local cameraDistance = getWorldMapCameraDistance()
	
	if cameraDistance > 300000 then
		cameraDistance = 300000
	end
	

	local lineHeightMax = { 10000, 20000, 30000 }
	for idx,_lineHeight in pairs(lineHeightMax) do		 
		circleLineHeight[idx] = _Util_Math.Lerp( 10000, _lineHeight, cameraDistance / 600000 )
	end

	local lineRadiusMinMax =
	{
		{ 2000, 100000 },
		{ 6000, 300000 },
		{ 10000, 500000 },
	}
	local lineRadius = {}
	for idx,radiusMinMax in pairs(lineRadiusMinMax) do		
		lineRadius[idx] = _Util_Math.Lerp( radiusMinMax[1], radiusMinMax[2],cameraDistance / 600000 )		
	end

	local lerpFactor = { 0.1, 0.35, 0.6 }; -- 0.3 / (i / 2+1)

	local _math_lerpVector = _Util_Math.LerpVector
	local _math_calcDistance = _Util_Math.calculateDistance

	local _worldmap_circleline_center_pos = CircleLineCenterPos
	local _worldmap_circleline_center_radius = CircleLineCenterRadius

	for i = 0, 2, 1 do
		if (_worldmap_circleline_center_pos[i] == nil) then
			-- _worldmap_circleline_center_radius[i] = lineRadius[i+1];
			_worldmap_circleline_center_pos[i] = cameraPosition;
		else
			local toPosition = _math_lerpVector(_worldmap_circleline_center_pos[i], cameraPosition, lerpFactor[i+1] );
			-- _worldmap_circleline_center_radius[i] = lineRadius[i+1]; -- / (_math_calcDistance(toPosition, _worldmap_circleline_center_pos[i]) / 10000 + 1);
			_worldmap_circleline_center_pos[i] = toPosition;
		end

		local lineDataBuffer = worldmapGetLine(RenderType.WMS_EXPLORE_PLANT, CircleLineIdx[i], 100);
		if lineDataBuffer == nil then
			CircleLineIdx[i] = worldmapInsertCircleLine( RenderType.WMS_EXPLORE_PLANT, float3(0,0,0), float4(1,1,1,1), 1.0, 1.0, 100, CppEnums.InstantLineRenderType.InstantLineRenderType_AllwaysShow );
			lineDataBuffer = worldmapGetLine( RenderType.WMS_EXPLORE_PLANT, CircleLineIdx[i], 100);
		end
		lineDataBuffer._position	= float3(_worldmap_circleline_center_pos[i].x, circleLineHeight[i+1], _worldmap_circleline_center_pos[i].z);
		lineDataBuffer._scale		= float3(_worldmap_circleline_center_radius[i], 1, _worldmap_circleline_center_radius[i]);
	end
end

------------------------------------------------------
-- Sun & Moon -- Icon & Line
------------------------------------------------------
function WorldMapWindow_Refresh_SunIcon()
	if not Panel_Loading:GetShow() then
		return;
	end

	local posSelf = CircleLineCenterPos[2];

	local dayCycle = 24 * 60
	local inGameMinuteRate	= getIngameTime_minute_rate();
	local inGameMinute		= math.floor(inGameMinuteRate);
	if ( dayCycle < inGameMinute ) then
		inGameMinute		= inGameMinute % dayCycle;
		inGameMinuteRate	= inGameMinuteRate - inGameMinute * dayCycle;
	end

	local isNight = (22 * 60 < inGameMinute);
	local inGameDayRate = 0;

	if isNight then
		inGameDayRate = (inGameMinuteRate - (22 * 60)) / (2 * 60);
	else
		inGameDayRate = inGameMinuteRate / (22 * 60); -- 0.0 ~ 1.0
	end

	
	local startPoint;
	local endPoint;
	local spinRadius;
	local spinAngle;
	if isNight then
		spinRadius = CircleLineCenterRadius[2] * 0.4;
		spinAngle = 0.7;
		startPoint	= _Util_Math.calculateNormalVector({ x = -1.5, y = 0, z =    1 });
		endPoint	= _Util_Math.calculateNormalVector({ x =    1, y = 0, z = -0.8 });
	else
		spinRadius = CircleLineCenterRadius[2] * 0.5;
		spinAngle = 0.8;
		startPoint	= _Util_Math.calculateNormalVector({ x = -1, y = 0, z =  1 });
		endPoint	= _Util_Math.calculateNormalVector({ x =  1, y = 0, z = -1 });
	end
	startPoint = _Util_Math.MulNumberToVector(startPoint, CircleLineCenterRadius[2]);
	endPoint = _Util_Math.MulNumberToVector(endPoint, CircleLineCenterRadius[2]);


	local currentSunPoint = _Util_Math.calculateSinCurve(startPoint, endPoint, { x = 0, y = 0, z = 0 }, spinRadius, spinAngle, inGameDayRate);
	
	currentSunPoint.y = currentSunPoint.y + circleLineHeight[3];
	
	local finalSunPos = { x = posSelf.x + currentSunPoint.x, y = currentSunPoint.y, z = posSelf.z + currentSunPoint.z };

	local sun2DPoint = worldmapScenetoScreenPosition(finalSunPos.x, finalSunPos.y, finalSunPos.z);
	sun2DPoint.x 		= sun2DPoint.x * _bgImage:GetSizeX();
	sun2DPoint.y 		= sun2DPoint.y * _bgImage:GetSizeY();

	local isShowSun = ( 0 < sun2DPoint.z ) and (  sun2DPoint.z <= 1 )


	local tickCount = {
		(getTickCount32() % 2000) / 2000,
		(getTickCount32() % 3000) / 3000,
		(getTickCount32() % 4000) / 4000,
		(getTickCount32() % 5000) / 5000,
		(getTickCount32() % 3500) / 3500,
		(getTickCount32() % 2500) / 2500
	};

	local cameraPos = getWorldMapCameraPos();

	if isNight then
		SunIconStatic:SetShow(false);

		local offset	= { width = 120, height = 120 };
		offset = _Util_Math.calculateDepthScaler(finalSunPos, offset);
		MoonIconStatic:SetSize(50, 50);
		MoonIconStatic:SetPosX(sun2DPoint.x - MoonIconStatic:GetSizeX() / 2);
		MoonIconStatic:SetPosY(sun2DPoint.y - MoonIconStatic:GetSizeY() / 2);
		MoonIconStatic:SetShow(isShowSun)

		SunTimeText:SetText(Util.Time.inGameTimeFormatting(inGameMinute));
		SunTimeText:SetSize(SunTimeText:GetTextSizeX(), SunTimeText:GetTextSizeY());
		SunTimeText:SetPosX(MoonIconStatic:GetPosX() + MoonIconStatic:GetSizeX() + 10);
		SunTimeText:SetPosY(MoonIconStatic:GetPosY());
		SunTimeText:SetShow(isShowSun);

		MoonIconStatic:SetDepth(WorldMapWindow_GetDepthFromPos3D(cameraPos, finalSunPos));
		SunTimeText:SetDepth(WorldMapWindow_GetDepthFromPos3D(cameraPos, finalSunPos));
	else
		MoonIconStatic:SetShow(false);

		local offset	= { width = 120, height = 120 };
		offset = _Util_Math.calculateDepthScaler(finalSunPos, offset);
		SunIconStatic:SetSize(50, 50);
		SunIconStatic:SetPosX(sun2DPoint.x - SunIconStatic:GetSizeX() / 2);
		SunIconStatic:SetPosY(sun2DPoint.y - SunIconStatic:GetSizeX() / 2);
		SunIconStatic:SetShow(isShowSun)

		SunTimeText:SetText(Util.Time.inGameTimeFormatting(inGameMinute));
		SunTimeText:SetSize(SunTimeText:GetTextSizeX(), SunTimeText:GetTextSizeY());
		SunTimeText:SetPosX(SunIconStatic:GetPosX() + SunIconStatic:GetSizeX() + 10);
		SunTimeText:SetPosY(SunIconStatic:GetPosY());
		SunTimeText:SetShow(isShowSun);

		SunIconStatic:SetDepth(WorldMapWindow_GetDepthFromPos3D(cameraPos, finalSunPos));
		SunTimeText:SetDepth(WorldMapWindow_GetDepthFromPos3D(cameraPos, finalSunPos));
	end
end

function WorldMapWindow_Refresh_SunLine()
	local lineList_SunMoon =
	{
		{
			startPoint	= _Util_Math.calculateNormalVector(float3(-1.5, 0,	1)),
			endPoint	= _Util_Math.calculateNormalVector(float3(	1, 0,-0.8)),
			angle		= 0.7
		},
		{
			startPoint	= _Util_Math.calculateNormalVector(float3(-1, 0, 1)),
			endPoint	= _Util_Math.calculateNormalVector(float3( 1, 0,-1)),
			angle		= 0.8
		}
	};
	local startPoint;
	local endPoint;

	local SignHeight = { 0.4, 0.5 };

	
	local dayCycle = 24 * 60
	local inGameMinuteRate	= getIngameTime_minute_rate();
	local inGameMinute		= math.floor(inGameMinuteRate);
	if ( dayCycle < inGameMinute ) then
		inGameMinute		= inGameMinute % dayCycle;
		inGameMinuteRate	= inGameMinuteRate - inGameMinute * dayCycle;
	end

	local isNight = (22 * 60 < inGameMinute);
	
	local i;
	for i = 1, 2, 1 do
		local lineDataBuffer = worldmapGetLine(RenderType.WMS_EXPLORE_PLANT, CircleLineIdx[2+i], 100);
		if lineDataBuffer ~= nil then
			lineDataBuffer._isRender = false;
		end
	end
	
	if isNight == true then
		i = 1;
	else
		i = 2;
	end
	
	-- for i = 1, 2, 1 do
		startPoint	= lineList_SunMoon[i].startPoint;
		endPoint	= lineList_SunMoon[i].endPoint;
		startPoint.y = 0;
		endPoint.y = 0;

		local lineDataBuffer = worldmapGetLine(RenderType.WMS_EXPLORE_PLANT, CircleLineIdx[2+i], 100);
		if lineDataBuffer == nil then
			local lineStream = LineDataWrapper();
			local lineVertexList = _Util_Math.calculateSinCurveList(startPoint, endPoint, float3(0,0,0), SignHeight[i], lineList_SunMoon[i].angle, 200);
			lineStream:reserve(200);
			for j = 0, 200, 1 do
				lineStream:push_back(lineVertexList[j]);
			end

			CircleLineIdx[2 + i] = worldmapInsertLineData(RenderType.WMS_EXPLORE_PLANT, lineStream, float4(1,1,1,1), 1.0, 100, CppEnums.InstantLineRenderType.InstantLineRenderType_AllwaysShow);
			lineDataBuffer = worldmapGetLine(RenderType.WMS_EXPLORE_PLANT, CircleLineIdx[2+i], 100)
		end
		lineDataBuffer._position	= float3(CircleLineCenterPos[2].x, circleLineHeight[3], CircleLineCenterPos[2].z);
		lineDataBuffer._scale		= float3(CircleLineCenterRadius[2], CircleLineCenterRadius[2], CircleLineCenterRadius[2]);
		lineDataBuffer._isRender	= true;
	-- end
end

------------------------------------------------------
-- Circle Line - N, E, W, S Icon
------------------------------------------------------
function WorldMapWindow_Refresh_NEWS_Position()
	if not Panel_Loading:GetShow() then
		return;
	end

	local posSelf = CircleLineCenterPos[2];

	local cameraPos = getWorldMapCameraPos();
	local cameraLookAt = getWorldMapCameraLookAt();
	local cameraDir = _Util_Math.calculateDirection(cameraPos, cameraLookAt);
	if ( ( _Util_Math.calculateLength(cameraDir) < 1.1 and _Util_Math.calculateLength(cameraDir) > -0.1 ) == false ) then
		-- _PA_LOG("news", "fire in the hole! - "..tostring(cameraDir.x)..","..tostring(cameraDir.y)..","..tostring(cameraDir.z) .. " : len - " .. tostring(_Util_Math.calculateLength(cameraDir)));
		return;
	end

	cameraDir.y = 0;
	cameraDir = _Util_Math.calculateNormalVector(cameraDir);
	local cameraCross = _Util_Math.calculateCross(cameraDir, float3(0,1,0));

	local posNEWS = {};
	for i = loc.LocationN, loc.LocationW, 1 do
		local relativePos = {};
		local newsDir = _Util_Math.convertRotationToDirection(i * math.pi / 2);
		relativePos.x = cameraDir.x * newsDir.x + cameraCross.x * newsDir.z;
		relativePos.z = cameraDir.z * newsDir.x + cameraCross.z * newsDir.z;

		local relativeRadian		= _Util_Math.convertDirectionToRotation(relativePos);

		if (i == 0) then
			local absoluteNorthRadian	= _Util_Math.convertDirectionToRotation( float3(0,0,1) ) + i * math.pi / 2;

			local deltaAngle = 0;
			local candidate = {};
			candidate[0] = (absoluteNorthRadian 				- _Util_Math.radianFix(relativeRadian + LocationNEWSRotation));
			candidate[1] = (absoluteNorthRadian + 2 * math.pi	- _Util_Math.radianFix(relativeRadian + LocationNEWSRotation));

			if (math.abs(candidate[0]) < math.abs(candidate[1])) then
				deltaAngle = candidate[0] ;
			else
				deltaAngle = candidate[1];
			end

			if deltaAngle > math.pi then
				deltaAngle = 2 * math.pi - deltaAngle;
			end
			LocationNEWSRotation = (LocationNEWSRotation + deltaAngle * 0.1);
		end
		relativeRadian = _Util_Math.radianFix(relativeRadian + LocationNEWSRotation);

		relativePos = _Util_Math.convertRotationToDirection(relativeRadian);

		relativePos.x = relativePos.x * CircleLineCenterRadius[1];
		relativePos.z = relativePos.z * CircleLineCenterRadius[1];

		posNEWS[i] = float3(posSelf.x + relativePos.x, circleLineHeight[2], posSelf.z + relativePos.z);
	end

	for i = loc.LocationN, loc.LocationW, 1 do
		local posDirection = posNEWS[i]
		local nodePosition = worldmapScenetoScreenPosition( posDirection.x, posDirection.y, posDirection.z );
		nodePosition.x 		= nodePosition.x * _bgImage:GetSizeX();
		nodePosition.y 		= nodePosition.y * _bgImage:GetSizeY();

		local isShowNEWS = ( 0 < nodePosition.z ) and (  nodePosition.z <= 1 )
		local locationText = locationText[i]
		locationText:SetPosX(nodePosition.x - locationText:GetSizeX() / 2);
		locationText:SetPosY(nodePosition.y - locationText:GetSizeY() + 5);
		locationText:SetDepth(WorldMapWindow_GetDepthFromPos3D(cameraPos, posDirection));
		locationText:SetShow(isShowNEWS);
	end
end

------------------------------------------------------
-- Circle Line - Village Name
------------------------------------------------------
function WorldMapWindow_Refresh_CircleLine_VillageNameList()
	if not Panel_Loading:GetShow() then
		return;
	end
	for _,node in pairs(nodeDataList) do
		if nil ~= node then
			WorldMapWindow_Refresh_CircleLine_VillageName(node);
		end
	end
end

function WorldMapWindow_Refresh_CircleLine_VillageName(node)
	if not Panel_Loading:GetShow() then
		return;
	end

	local nodeKey = node:getStaticStatus()._waypointKey
	local villageData = villageTextList[nodeKey]
	if ( (nil == villageData) or (nil == villageData.control) ) then
		return
	end

	local cameraPos = getWorldMapCameraPos();
	local cameraLookAt = getWorldMapCameraLookAt();
	local cameraDir = _Util_Math.calculateDirection(cameraPos, cameraLookAt);
	if ( ( _Util_Math.calculateLength(cameraDir) < 1.1 and _Util_Math.calculateLength(cameraDir) > -0.1 ) == false ) then
		-- _PA_LOG("news", "fire in the hole! - "..tostring(cameraDir.x)..","..tostring(cameraDir.y)..","..tostring(cameraDir.z) .. " : len - " .. tostring(_Util_Math.calculateLength(cameraDir)));
		return;
	end

	cameraDir = _Util_Math.calculateNormalVector(cameraDir);


	local nodePosition		= node:getStaticStatus():getPosition();

	local posSelf;
	if (_Util_Math.calculateDistance(CircleLineCenterPos[0], nodePosition) > CircleLineCenterRadius[1] ) then
		posSelf = CircleLineCenterPos[1];
	else
		posSelf = CircleLineCenterPos[0];
	end
	posSelf.y = 0;


	local directionPos		= _Util_Math.calculateDirection(posSelf, nodePosition)
	directionPos.y = 0
	local directionNormal	= _Util_Math.calculateNormalVector(directionPos)

	local cameraRadian	= _Util_Math.convertDirectionToRotation(cameraDir);
	local targetRadian	= _Util_Math.convertDirectionToRotation(directionNormal) - cameraRadian;

	local deltaAngle = 0;
	local candidate = {};
	candidate[0] = (targetRadian 				- villageData.radianFix)
	candidate[1] = (targetRadian + 2 * math.pi	- villageData.radianFix)
	candidate[2] = (targetRadian - 2 * math.pi	- villageData.radianFix)

	if (math.abs(candidate[0]) < math.abs(candidate[1])) then
		deltaAngle = candidate[0] ;
	else
		deltaAngle = candidate[1];
	end
	if (math.abs(candidate[2]) < math.abs(deltaAngle)) then
		deltaAngle = candidate[2] ;
	end

	local isNearCircle = _Util_Math.calculateDistance(posSelf, nodePosition) < CircleLineCenterRadius[1];
	local sensitivity;
	if isNearCircle then
		sensitivity = 0.25;
	else
		sensitivity = 0.18;
	end

	villageData.radianFix = _Util_Math.radianFix(villageData.radianFix + deltaAngle * sensitivity);

	directionNormal = _Util_Math.convertRotationToDirection(villageData.radianFix + cameraRadian);

	local resultPos = {}
	if ( isNearCircle ) then
		resultPos.x = posSelf.x + directionNormal.x * CircleLineCenterRadius[0]
		resultPos.y = circleLineHeight[1]
		resultPos.z = posSelf.z + directionNormal.z * CircleLineCenterRadius[0]
	else
		resultPos.x = posSelf.x + directionNormal.x * CircleLineCenterRadius[1]
		resultPos.y = circleLineHeight[2]
		resultPos.z = posSelf.z + directionNormal.z * CircleLineCenterRadius[1]
	end

	local nodePosition2D	= worldmapScenetoScreenPosition(resultPos.x, resultPos.y, resultPos.z)	;
	nodePosition2D.x 		= nodePosition2D.x * _bgImage:GetSizeX();
	nodePosition2D.y 		= nodePosition2D.y * _bgImage:GetSizeY();

	villageData.control:SetDepth(WorldMapWindow_GetDepthFromPos3D(cameraPos, resultPos));

	villageData.control:SetPosX(nodePosition2D.x - villageData.control:GetSizeX() / 2 )
	villageData.control:SetPosY(nodePosition2D.y - villageData.control:GetSizeY() + 5 )
	villageData.control:SetShow( (0 < nodePosition2D.z) and (nodePosition2D.z <=1) )
end

function WorldMapWindow_Insert_CircleLine_VillageName(node)
	nodeDataList[node:getStaticStatus()._waypointKey] = node;

	local nodeType = node:getStaticStatus()._nodeType
	if nodeType ~= ENT.eExplorationNodeType_Viliage and nodeType ~= ENT.eExplorationNodeType_City then
		return
	end

	local posSelf = {}
	posSelf.x = getSelfPlayer():get():getPositionX();
	posSelf.y = 0
	posSelf.z = getSelfPlayer():get():getPositionZ();

	local nodeStaticStatus = node:getStaticStatus();
	local nodeKey = nodeStaticStatus._waypointKey;

	local target = UI.createControl( UI_TYPE.PA_UI_CONTROL_STATICTEXT, Panel_Loading, "Static_village_" .. tostring(nodeKey) );
	CopyBaseProperty( template.LocationVillage, target);
	target:SetText(getExploreNodeName(nodeStaticStatus))

	WorldmapWindow_OnLoadingSortBG();
	
	local villageData =
	{
		control = target,
		radianFix = _Util_Math.radianFix( math.random(0, 100000) / 100000 * math.pi * 2 )
	}
	villageTextList[nodeKey] = villageData
end


------------------------------------------------------
-- Territory Name And Exploration Point
------------------------------------------------------
function WorldMapWindow_TerritoryNameAndExplorationPoint_PositionUpdate()
	if not Panel_Loading:GetShow() then
		return;
	end

	local cameraPosition = getWorldMapCameraPos();

	for territoryKeyRaw, controls in pairs(territoryLine_Controls) do
		local lineData			= worldmapGetTerritoryLine(territoryKeyRaw)
		if lineData ~= nil then
			local nodeTopPosition	= lineData:getLinePositionByIndex(1)

			local nodeTopPosition2D		= worldmapScenetoScreenPosition(nodeTopPosition.x, nodeTopPosition.y, nodeTopPosition.z);
			nodeTopPosition2D.x 		= nodeTopPosition2D.x * _bgImage:GetSizeX();
			nodeTopPosition2D.y 		= nodeTopPosition2D.y * _bgImage:GetSizeY();

			local nodeExploreTitle	= controls[1]
			local nodeExplorePoint	= controls[2]
			local nodeSupportPoint	= controls[3]
			local nodeImage			= controls[4]

			local isShow = (0 < nodeTopPosition2D.z) and (nodeTopPosition2D.z <=1)
			nodeExploreTitle:SetShow( isShow );
			nodeExplorePoint:SetShow( isShow );
			nodeSupportPoint:SetShow( isShow );
			nodeImage		:SetShow( isShow );

			-- nodeExplorePoint:SetDepth(WorldMapWindow_GetDepthFromPos3D(cameraPosition, lineData._position));
			local depth = WorldMapWindow_GetDepthFromPos3D(cameraPosition, nodeTopPosition)
			nodeExploreTitle:SetDepth(depth)
			nodeExplorePoint:SetDepth(depth)
			nodeSupportPoint:SetDepth(depth)
			nodeImage		:SetDepth(depth)

			local pointTextSize = nodeExplorePoint:GetTextSizeX() / 2

			nodeExplorePoint:SetPosX(nodeTopPosition2D.x - 5)
			nodeExplorePoint:SetPosY(nodeTopPosition2D.y - 20)
			nodeExplorePoint:SetTextSpan( -pointTextSize, -nodeExplorePoint:GetTextSizeY() )

			nodeSupportPoint:SetPosX(nodeExplorePoint:GetPosX())
			nodeSupportPoint:SetPosY(nodeTopPosition2D.y + 5)

			nodeExploreTitle:SetPosX(nodeTopPosition2D.x - nodeExploreTitle:GetTextSizeX() / 2 - 5 )
			nodeExploreTitle:SetPosY(nodeExplorePoint:GetPosY() - nodeExplorePoint:GetTextSizeY() - 30)

			nodeImage:SetPosX(nodeTopPosition2D.x - nodeImage:GetSizeX() / 2 - 5 )
			nodeImage:SetPosY(nodeExploreTitle:GetPosY() - nodeImage:GetSizeY() )
		end
	end
end

local WorldMapWindow_Clear_TerritoryNameAndExplorationPoint = function()
	for idx, controls in pairs(territoryLine_Controls) do
		UI.deleteControl( controls[1] );
		UI.deleteControl( controls[2] );
		UI.deleteControl( controls[3] );
		UI.deleteControl( controls[4] );
	end
	territoryLine_Controls = {};
end

function WorldMapWindow_Invalid_TerritoryNameAndExplorationPoint()
	WorldMapWindow_Clear_TerritoryNameAndExplorationPoint();

	local territoryIdx = getTerritoryList();
	for i = 1, territoryIdx do
		local territoryKeyRaw = getTerritoryByIndex(i-1);

		local explorePoint			= getExplorePointByTerritory(territoryKeyRaw)
		local supportPoint			= getSurportPointByTerritory(territoryKeyRaw)
		local s64_supportRequireExp	= getRequireSupportExperience_s64(territoryKeyRaw)
		local s64_exploreRequireExp	= getRequireExperienceToExplorePointByTerritory_s64(territoryKeyRaw)
		local territoryName			= getTerritoryNameByKey(territoryKeyRaw)

		local controls = territoryLine_Controls[territoryKeyRaw]
		local nodeExploreTitle, nodeExplorePoint, nodeSupportPoint, nodeImage

		if ( controls == nil) then
			controls = {};
			nodeExploreTitle = UI.createControl( UI_TYPE.PA_UI_CONTROL_STATICTEXT, Panel_Loading, "Static_ExploreName_" .. tostring(territoryKeyRaw) );
			nodeExplorePoint = UI.createControl( UI_TYPE.PA_UI_CONTROL_STATICTEXT, Panel_Loading, "Static_ExplorePoint_" .. tostring(territoryKeyRaw) );
			nodeSupportPoint = UI.createControl( UI_TYPE.PA_UI_CONTROL_STATICTEXT, Panel_Loading, "Static_SupportPoint_" .. tostring(territoryKeyRaw) );
			nodeImage		 = UI.createControl( UI_TYPE.PA_UI_CONTROL_STATIC, Panel_Loading, "Static_Image_" .. tostring(territoryKeyRaw) );
			controls[1] = nodeExploreTitle
			controls[2] = nodeExplorePoint
			controls[3] = nodeSupportPoint
			controls[4] = nodeImage

			CopyBaseProperty( template.ExplorePanelTitle,	nodeExploreTitle);
			CopyBaseProperty( template.ExplorePanelPoint,	nodeExplorePoint);
			CopyBaseProperty( template.SupportPanelPoint,	nodeSupportPoint);
			CopyBaseProperty( template.ImagePanel,			nodeImage		);
			
			nodeExploreTitle:SetShow(true)
			nodeExplorePoint:SetShow(true)
			nodeSupportPoint:SetShow(true)
			nodeImage		:SetShow(true)

			territoryLine_Controls[territoryKeyRaw] = controls
		else
			nodeExploreTitle = controls[1]
			nodeExplorePoint = controls[2]
			nodeSupportPoint = controls[3]
			nodeImage		 = controls[4]
		end

		local supportPointText = PAGetString( Defines.StringSheet_GAME, "LUA_WORLD_MAP_GUIDE_ROOKIE" )
		local supportPoint = supportPoint:getRemainedPoint()
		if ( 1 == supportPoint ) then
			supportPointText = PAGetString( Defines.StringSheet_GAME, "LUA_WORLD_MAP_GUIDE_STRANGE" )
		elseif ( 2 == supportPoint ) then
			supportPointText = PAGetString( Defines.StringSheet_GAME, "LUA_WORLD_MAP_GUIDE_CLOSE" )
		elseif ( 3 == supportPoint ) then
			supportPointText = PAGetString( Defines.StringSheet_GAME, "LUA_WORLD_MAP_GUIDE_RELIABLE" )
		elseif ( 4 <= supportPoint ) then
			supportPointText = PAGetString( Defines.StringSheet_GAME, "LUA_WORLD_MAP_GUIDE_FAMOUS" )
		end

		nodeExploreTitle:SetText( territoryName );
		nodeExplorePoint:SetText( PAGetString( Defines.StringSheet_GAME, "LUA_WORLD_MAP_GUIDE_CONTRIBUTIVENESS" ) .. " : " .. tostring(explorePoint:getRemainedPoint()));
		nodeSupportPoint:SetText( PAGetString( Defines.StringSheet_GAME, "LUA_WORLD_MAP_GUIDE_FAME" ) .. " : " .. supportPointText .. PAGetString( Defines.StringSheet_GAME, "LUA_WORLD_MAP_GUIDE_ADVENTURER" ))
		-- 텍스트 비교를 통해서 연산이 이루어지면 안됨~
		if ( territoryName == PAGetString( Defines.StringSheet_GAME, "LUA_WORLD_MAP_GUIDE_SERENDIA" ) ) then
			nodeImage:ChangeTextureInfoName("New_UI_Common_forLua/Widget/WorldMap/territory/territorymark_selendia_large.dds")
		elseif ( territoryName == PAGetString( Defines.StringSheet_GAME, "LUA_WORLD_MAP_GUIDE_BALENOS" ) ) then
			nodeImage:ChangeTextureInfoName("New_UI_Common_forLua/Widget/WorldMap/territory/territorymark_valenos_large.dds")
		elseif ( territoryName == PAGetString( Defines.StringSheet_GAME, "LUA_WORLD_MAP_GUIDE_CALPHEON" ) ) then
			nodeImage:ChangeTextureInfoName("New_UI_Common_forLua/Widget/WorldMap/territory/territorymark_calpheon_large.dds")
		else
			nodeImage:SetAlpha(0)
		end


		-- local textSizeX = nodeExploreTitle:GetTextSizeX()
		-- local textSizeY = nodeExploreTitle:GetTextSizeY()

		-- nodeExploreTitle:SetSize(textSizeX, textSizeY);
	end
	
	WorldmapWindow_OnLoadingSortBG();

	-- 어짜피 매 프레임 호출되고 있다! 굳이 명시적으로 호출해줄 필요는 없다!
	-- WorldMapWindow_TerritoryNameAndExplorationPoint_PositionUpdate();
end

function WorldMapWindow_Update_TerritoryNameAndExplorationPoint()
	if not Panel_Loading:GetShow() then
		return;
	end

	-- 이 모드에서는 랜더링을 하지 않는다!

	local cameraDistance = getWorldMapCameraDistance()
	local st_height = _Util_Math.Lerp( 10000, 150000, cameraDistance / 600000 )

	for territoryKeyRaw, controls in pairs(territoryLine_Controls) do
		local lineData			= worldmapGetTerritoryLine(territoryKeyRaw)
		if (lineData ~= nil) then
			lineData:setLineHeight_ForWorldMapTerritotyLine( st_height )
			controls[1]:SetShow( true )
			controls[2]:SetShow( true )
			controls[3]:SetShow( true )
			controls[4]:SetShow( true )
			lineData._isRender = true
		end
	end
end

--[[
-- Territory Line 도 같이 Alpha 를 적용하기가 힘들다! 그냥 바로 꺼버린다!
function WorldMapWindow_ExploreText_AlphaChangeAnimation( needToAlphaUpdate, needToSetShowUpdate, nodeAlpha, nodeShow )
	for territoryKeyRaw, controls in pairs(territoryLine_Controls) do
		if needToAlphaUpdate then
			controls[1]:SetFontAlpha( nodeAlpha )
			controls[2]:SetFontAlpha( nodeAlpha )
		end
		if needToSetShowUpdate then
			controls[1]:SetShow( nodeShow )
			controls[2]:SetShow( nodeShow )
		end
	end
end
]]



function WorldMapWindow_OnLoadingShow()
	CircleLineCenterPos[0] = float3(10000, 0, 10000);
	CircleLineCenterPos[1] = float3(10000, 0, 10000);
	CircleLineCenterPos[2] = float3(10000, 0, 10000);
	
	LocationNEWSRotation = 0

	for i = loc.LocationN, loc.LocationW do
		locationText[i]:SetShow(true);
	end
end

function WorldMapWindow_OnLoadingHide()
	for i = 0, 4, 1 do
		worldmapDeleteLine(RenderType.WMS_EXPLORE_PLANT, CircleLineIdx[i], 100);
		CircleLineIdx[i] = -1;
	end

	for i = loc.LocationN, loc.LocationW do
		locationText[i]:SetShow(false);
	end

	for idx, villageTextData in pairs(villageTextList) do
		UI.deleteControl( villageTextData.control );
	end
	villageTextList = {}

	WorldMapWindow_Clear_TerritoryNameAndExplorationPoint()
end

function WorldmapWindow_OnLoadingSortBG()
	for ii = 0, sortLoadingUICount, 1 do
		Panel_Loading:SetChildIndex(sortLoadingUI[ii]:GetKey(), Panel_Loading:GetChildSize());
	end
end