local UI_TYPE		= CppEnums.PA_UI_CONTROL_TYPE


if nil == WorldMapWindow then
	WorldMapWindow = {};
end




--------------------------------------------------------------------
-- default Stack Window
--------------------------------------------------------------------

-- stackWindowList ־ ϴ Լ

-- updatePosition : ġ Ʈ
-- hide :  
-- updateFirst : stackList  ù Ʈ

local stackWindow = {}
stackWindow.__index = stackWindow
stackWindow._panel = nil
--stackWindow._shadowPanel = nil
stackWindow._infoNodeKey = nil
stackWindow._isSnap = false

--------------------------------------------------------------------
-- ܺο  ̵ ϸ ȵ˴ϴ.
function stackWindow:new( panel, isSnap, key )
	stackCopy = {}
	setmetatable( stackCopy, stackWindow )
	stackCopy:create(panel, isSnap, key)
	return stackCopy
end

function stackWindow:create( panel, isSnap, key )
	self._panel = panel
	self:createShadow(key)
	self._isSnap = isSnap
end

function stackWindow:updateFirst()
	--self._shadowPanel:SetShow(true,false)
	self:updatePosition(0)
	self:updateFirst__()
	self._panel:SetShow(true, false)
end

function stackWindow:updatePosition(deltaTime)
	self:updatePosition__(deltaTime)
	self:updateShadow()
end

function stackWindow:update(deltaTime)
	self:update__(deltaTime)
end

function stackWindow:updateSnap(deltaTime, posX, posY)
	self._panel:SetPosX(posX)
	self._panel:SetPosY(posY)
	self:updateShadow()

	self:updatePosition__()
	return self._panel:GetSizeX()
end

function stackWindow:hide()
	self._panel:SetShow(false, false)
	self.postHideUpdate__()
	self._infoNodeKey = nil
	--self._shadowPanel:SetShow(false, false)
end

function stackWindow:destory()
	--ui.deleteControl(self._shadowPanel)
	--self._shadowPanel = nil
	self._panel = nil
end

function stackWindow:convert3Dto2D( position3 )
	local nodePosition2D	= worldmapScenetoScreenPosition(position3.x, position3.y, position3.z);
	nodePosition2D.x 		= nodePosition2D.x * WorldMapWindow.world3DMapStatic:GetSizeX()
	nodePosition2D.y 		= nodePosition2D.y * WorldMapWindow.world3DMapStatic:GetSizeY()
	return nodePosition2D
end

--------------------------------------------------------------------
-- ̵ ϴ Լ
function stackWindow:updatePosition__(deltaTime)
	-- self._panel:ComputePos()
end

function stackWindow:update__(deltaTime)
	
end

function stackWindow:updateFirst__()

end

function stackWindow:postHideUpdate__()

end

function stackWindow:stackingBack__()
end


--------------------------------------------------------------------
-- Ʒ ܺο Ⱦ Լ..

function stackWindow:createShadow(key)
	--self._shadowPanel = UI.createControl( UI_TYPE.PA_UI_CONTROL_STATIC, WorldMapWindow.PanelUIAlways, "Static_SubPanelShadow" .. tostring(key) );
	--self._shadowPanel:ChangeTextureInfoName("new_ui_common_forlua/default/window_sample.dds");
	--self._shadowPanel:SetMonoTone(true);
	--self._shadowPanel:SetShow(false);
	--self._shadowPanel:SetColor(2147483648)
	--self._shadowPanel:SetIgnore(true)
	--
	--Panel_Win_Worldmap:SetChildIndex(self._shadowPanel:GetKey(), Panel_Win_Worldmap:GetChildSize())
end

function stackWindow:updateShadow()
	--self._shadowPanel:SetSize( self._panel:GetSizeX(), self._panel:GetSizeY() )
	--self._shadowPanel:SetPosX( self._panel:GetPosX() + 10 )
	--self._shadowPanel:SetPosY( self._panel:GetPosY() + 10 )
end





--------------------------------------------------------------------
-- popup Manager
--------------------------------------------------------------------
local snap = function(snapList, maxX, maxY, deltaTime)
	local posX = ( getScreenSizeX() - getScreenSizeX() ) + 7
	local posY = ( getScreenSizeY() - maxY ) / 2
	
	for index = 1, #snapList do
		posX = posX + snapList[index]:updateSnap(deltaTime, posX, posY)
	end
end


WorldMapWindow.popupManager = {
	stackWindowList = Array.new(),
}

function WorldMapWindow.popupManager:update(deltaTime)
	local snapList = Array.new()
	local maxX = 0
	local maxY = 0

	--̸ Ͽ ׾Ƽ  ѹ ѷش.
	for index = 1 , self.stackWindowList:length() do
		local stackWindow = self.stackWindowList[index]
		if ( stackWindow._isSnap ) then
			snapList:push_back( stackWindow )
				
			maxX = maxX + stackWindow._panel:GetSizeX()
			maxY = math.max(maxY, stackWindow._panel:GetSizeY())
		else
			-- ƴѼ ±   ó
			snap(snapList, maxX, maxY, deltaTime)
			snapList = Array.new()
			maxX = 0
			maxY = 0

			stackWindow:updatePosition(deltaTime)
		end
		stackWindow:update(deltaTime)
	end
	snap(snapList, maxX, maxY, deltaTime)
end


function WorldMapWindow.popupManager:clear()
	for index = 1 , self.stackWindowList:length() do
		self.stackWindowList[index]:hide()
	end
	self.stackWindowList = Array.new()

end


function WorldMapWindow.popupManager:push( stackWindow )
	for key, value in pairs(self.stackWindowList) do
		if ( stackWindow._panel == value._panel ) then
			return
		end
		value:stackingBack__()
	end
	
	self.stackWindowList:push_back( stackWindow )
	stackWindow:updateFirst()
end


function WorldMapWindow.popupManager:pop()
	if ( 0 ~= self.stackWindowList:length() ) then
		local stackWindow = self.stackWindowList[self.stackWindowList:length()]
		stackWindow:hide()

		self.stackWindowList:pop_back()
	end
end

function WorldMapWindow.popupManager:popTo(stack)
	local isPop = false
	for key, value in pairs( self.stackWindowList ) do
		if ( value == stack ) then
			isPop = true
		end
		if ( isPop ) then
			self.stackWindowList[key]:hide()
			self.stackWindowList[key] = nil
		end
	end
end

function WorldMapWindow.popupManager:get( index )
	return self.stackWindowList[index]
end

function WorldMapWindow.popupManager:get_if( functor )
	for key, value in pairs( self.stackWindowList ) do
		if ( functor(value) ) then
			return value
		end
	end
	return nil
end

function WorldMapWindow.popupManager:get_if_infoNodeKey( infoNodeKey )
	return self:get_if( function( stack ) 
		return stack._infoNodeKey == infoNodeKey
	end)
end

function WorldMapWindow.popupManager:count()
	return self.stackWindowList:length()
end


function WorldMapWindow.popupManager:createStackWindowDefault( panel, isSnap, key )
	return stackWindow:new( panel, isSnap, key )
end
