-----------------------------------------------------------
-- Local 변수 설정
-----------------------------------------------------------
local VCK 			= CppEnums.VirtualKeyCode
local UI_PUCT		= CppEnums.PA_UI_CONTROL_TYPE
local _Util_Math 	= Util.Math
local PGAT			= CppEnums.PositionGuideActorType

local _keyGuide		= UI.getChildControl ( Panel_Win_Worldmap, "StaticText_KeyGuide" )
_keyGuide:SetShow( false )

local PositionGuideMenuUI = 
{
	_pinMenu		= UI.getChildControl( Panel_Win_Worldmap, "Static_PinMenu" )
	,_buttonSignal	= UI.getChildControl( Panel_Win_Worldmap, "Button_Signal" )
	,_buttonFindWay	= UI.getChildControl( Panel_Win_Worldmap, "Button_FindWay" )
	,_buttonCancel	= UI.getChildControl( Panel_Win_Worldmap, "Button_Cancel" )
}
-----------------------------------------------------------
-- Pool 설정
-----------------------------------------------------------
local PositionGuideListPool = 
{
	_guildMine		= UI.getChildControl( Panel_Win_Worldmap, "Static_Pin_GuildMine" )
	,_partyMine		= UI.getChildControl( Panel_Win_Worldmap, "Static_Pin_PartyMine" )
	,_guildMaster	= UI.getChildControl( Panel_Win_Worldmap, "Static_GuildMaster" )
	
	,_listGetthePoint		= {}
	,_listGetthePointInfo	= {}
	,_listPinGuild			= {}
	, _listPinParty			= {}
	, _listPinBubble		= {}
	, _listPinId			= {}
	, _listPositionGuide	= {}
	
	, _countGetthePoint		= 0, _maxcountGetthePoint	= 40
	, _countPinGuild		= 0, _maxcountPinGuild 		= 40
	, _countPinParty		= 0, _maxcountPinParty 		= 4
	, _countPinBubble		= 0, _maxcountPinBubble 	= 40
	, _countPinId			= 0, _maxcountPinId			= 40
	
	,_sizeGuildMine 	= { width = 0 , height = 0}
	,_sizePartyMine 	= { width = 0 , height = 0}
	,_sizeGuildMaster 	= { width = 0 , height = 0}
	,_sizeGetthePoint 	= { width = 0 , height = 0}
	,_sizeGetthePoint 	= { width = 0 , height = 0}
	,_sizeGetthePoint 	= { width = 0 , height = 0}
	,_sizePinGuild 		= { width = 0 , height = 0}
	,_sizePinParty 		= { width = 0 , height = 0}
	,_sizePinBubble 	= { width = 0 , height = 0}
	,_sizePinId 		= { width = 0 , height = 0}
}

function PositionGuideListPool:prepareControl(Panel, parantControl, createdControlList, controlType, controlName, initSizeName, createCount)
	local styleUI = UI.getChildControl(Panel, controlName)
	 for index = 0, createCount, 1 do		
		createdControlList[index]	= UI.createControl( controlType, parantControl, controlName .. index)
		CopyBaseProperty(styleUI, createdControlList[index])
		createdControlList[index]:SetShow(true)
	 end
	initSizeName.width 		=  styleUI:GetSizeX()
	initSizeName.height 	=  styleUI:GetSizeY()
end

function PositionGuideListPool:initialize(stylePanel, parantControl)
	PositionGuideListPool:prepareControl(stylePanel,	parantControl,	self._listGetthePoint,	UI_PUCT.PA_UI_CONTROL_STATIC, 		"Static_GetthePoint",	self._sizeGetthePoint, 	self._maxcountGetthePoint	)
	
	PositionGuideListPool:prepareControl(stylePanel,	parantControl,	self._listPinGuild,		UI_PUCT.PA_UI_CONTROL_STATIC, 		"Static_Pin_Guild",		self._sizePinGuild,		self._maxcountPinGuild		)
	PositionGuideListPool:prepareControl(stylePanel,	parantControl,	self._listPinParty,		UI_PUCT.PA_UI_CONTROL_STATIC,		"Static_Pin_Party",		self._sizePinParty,		self._maxcountPinParty		)
	PositionGuideListPool:prepareControl(stylePanel,	parantControl,	self._listPinBubble,	UI_PUCT.PA_UI_CONTROL_STATIC, 		"Static_Pin_Bubble", 	self._sizePinBubble,	self._maxcountPinBubble		)
	PositionGuideListPool:prepareControl(stylePanel,	parantControl,	self._listPinId,		UI_PUCT.PA_UI_CONTROL_STATICTEXT, 	"StaticText_Pin_ID", 	self._sizePinId,		self._maxcountPinId			)
	
	self._sizeGuildMine.width 		=  self._guildMine:GetSizeX()
	self._sizeGuildMine.height 		=  self._guildMine:GetSizeY()
	self._sizePartyMine.width 		=  self._partyMine:GetSizeX()
	self._sizePartyMine.height 		=  self._partyMine:GetSizeY()
	self._sizeGuildMaster.width 	=  self._guildMaster:GetSizeX()
	self._sizeGuildMaster.height 	=  self._guildMaster:GetSizeY()
	
	self._guildMine:addInputEvent("Mouse_RUp", "ShowPositionGuideMenu("..PGAT.ePositionGuideActorType_isGuildMine..",0)")
	self._partyMine:addInputEvent("Mouse_RUp", "ShowPositionGuideMenu("..PGAT.ePositionGuideActorType_isPartyMine..",0)")
	self._guildMaster:addInputEvent("Mouse_RUp", "ShowPositionGuideMenu("..PGAT.ePositionGuideActorType_isGuildMaster..",0)")
	
	self._guildMine:ActiveMouseEventEffect( true )
	self._partyMine:ActiveMouseEventEffect( true )
	self._guildMaster:ActiveMouseEventEffect( true )
	
	PositionGuideListPool:clear()
end


-----------------------------------------------------------
-- 오브젝트 생성
-----------------------------------------------------------
function PositionGuideListPool:newGetthePoint(position, isForGuild)
	if (self._maxcountGetthePoint < self._countGetthePoint) then
		self._countGetthePoint = 0
	end
	local control = self._listGetthePoint[self._countGetthePoint]
	control:EraseAllEffect()
	
	local guideParam = NavigationGuideParam();
	
	if isForGuild then
		control:AddEffect( "UI_WorldMap_Ping01", false, 0, 0 )

		guideParam._color		= float4(1.0, 0.8, 0.6, 1.0);
		guideParam._bgColor		= float4(0.6, 0.2, 0.2, 0.3);
		guideParam._beamColor	= float4(0.4, 0.15, 0.15, 1.0);
	else
		control:AddEffect( "UI_WorldMap_Ping02", false, 0, 0 )

		guideParam._color		= float4(1.0, 0.8, 0.6, 1.0);
		guideParam._bgColor		= float4(0.6, 0.2, 0.2, 0.3);
		guideParam._beamColor	= float4(0.4, 0.15, 0.15, 1.0);
	end
	
	worldmap_addNavigationBeam( position, guideParam, true );

	self._countGetthePoint = self._countGetthePoint + 1 
	return control, 	self._sizeGetthePoint
end
function PositionGuideListPool:newPinGuild()
	if (self._maxcountPinGuild < self._countPinGuild) then
		self._countPinGuild = 0
	end
	local control = self._listPinGuild[self._countPinGuild]
	control:ActiveMouseEventEffect( true )
	control:addInputEvent("Mouse_RUp", "ShowPositionGuideMenu("..PGAT.ePositionGuideActorType_isGuildMember..","..self._countPinGuild..")")
	self._countPinGuild = self._countPinGuild + 1 
	return control, 		self._sizePinGuild
end
function PositionGuideListPool:newPinParty()
	if (self._maxcountPinParty < self._countPinParty) then
		self._countPinParty = 0
	end
	local control = self._listPinParty[self._countPinParty]
	control:ActiveMouseEventEffect( true )
	control:addInputEvent("Mouse_RUp", "ShowPositionGuideMenu("..PGAT.ePositionGuideActorType_isPartyMember..","..self._countPinParty..")")
	self._countPinParty = self._countPinParty + 1 
	return control, 		self._sizePinParty
end
function PositionGuideListPool:newPinBubble()
	if (self._maxcountPinBubble < self._countPinBubble) then
		self._countPinBubble = 0
	end
	self._countPinBubble = self._countPinBubble + 1 
	return self._listPinBubble[self._countPinBubble - 1], 		self._sizePinBubble
end
function PositionGuideListPool:newPinId()
	if (self._maxcountPinId < self._countPinId) then
		self._countPinId = 0
	end
	self._countPinId = self._countPinId + 1 
	return self._listPinId[self._countPinId - 1], 				self._sizePinId
end


-----------------------------------------------------------
-- 버튼 초기화
-----------------------------------------------------------
function PositionGuideListPool:clear()
	self._countPinGuild			= 0
	self._countPinParty			= 0
	self._countPinBubble		= 0
	self._countPinId			= 0	
	PositionGuideListPool:hideNotUse()
	self._listPositionGuide		= {}
end

-----------------------------------------------------------
-- (사용하지 않는) 버튼 숨김
-----------------------------------------------------------
function PositionGuideListPool:hideNotUse()
	self._guildMine:SetShow(false)
	self._partyMine:SetShow(false)
	self._guildMaster:SetShow(false)

	for index = self._countPinGuild, 	self._maxcountPinGuild, 	1 do
		self._listPinGuild[index]:SetShow(false)
	end
	for index = self._countPinParty, 	self._maxcountPinParty, 	1 do
		self._listPinParty[index]:SetShow(false)
	end
	for index = self._countPinBubble, 	self._maxcountPinBubble, 	1 do
		self._listPinBubble[index]:SetShow(false)
	end
	for index = self._countPinId, 		self._maxcountPinId, 		1 do
		self._listPinId[index]:SetShow(false)
	end
end

-----------------------------------------------------------
-- UI 초기화
-----------------------------------------------------------
PositionGuideListPool:initialize(Panel_Win_Worldmap, Panel_Win_Worldmap)
-----------------------------------------------------------------------------------------------------------------
-----------------------------------------------------------------------------------------------------------------

------------ 키 입력시 길드나 파티원에게 위치 정보 전송  ----------------------------
function  FGlobal_RequestSendPositionGuide(isPermanent)
	if isKeyPressed( VCK.KeyCode_SHIFT ) then
		local destPos = worldmap_navigatorpickPos(WorldMapWindow.world3DMapStatic:GetSizeX(), WorldMapWindow.world3DMapStatic:GetSizeY(), float2(getMousePosX(), getMousePosY()));
		ToClient_RequestSendPositionGuide(true, isPermanent, destPos)	
	elseif isKeyPressed( VCK.KeyCode_MENU ) then
		local destPos = worldmap_navigatorpickPos(WorldMapWindow.world3DMapStatic:GetSizeX(), WorldMapWindow.world3DMapStatic:GetSizeY(), float2(getMousePosX(), getMousePosY()));
		ToClient_RequestSendPositionGuide(false, isPermanent, destPos)	
	end
end

local updatePositionGuide = function(controlUI, controlSize, position, addPosY)
	local pos2D = worldmapScenetoScreenPosition(position.x, position.y, position.z);
	pos2D.x 		= pos2D.x * WorldMapWindow.world3DMapStatic:GetSizeX();
	pos2D.y 		= pos2D.y * WorldMapWindow.world3DMapStatic:GetSizeY();

	local cameraPos = getWorldMapCameraPos();

	local nodeSize = _Util_Math.calculateDepthScaler( position, controlSize );
	
	if ( controlUI == pinIdControlUI ) then
		controlUI:SetPosX(pos2D.x - controlUI:GetSizeX() / 2)
		controlUI:SetPosY(pos2D.y - controlUI:GetSizeY() / 2 - addPosY - 2 )
	elseif ( controlUI == bubbleControlUI ) then
		controlUI:SetPosX(pos2D.x - controlUI:GetSizeX() / 2)
		controlUI:SetPosY(pos2D.y - controlUI:GetSizeY() / 2 - addPosY)
	else
		controlUI:SetSize(nodeSize.width, nodeSize.height)
		controlUI:SetPosX(pos2D.x - controlUI:GetSizeX() / 2)
		controlUI:SetPosY(pos2D.y - controlUI:GetSizeY() / 2 - addPosY)
	end

	controlUI:SetDepth( 0 )
	controlUI:SetShow( true )
end

-- 잠깐 깜빡이며 위치를 알려줌
local showFlickerPositionGuide = function(position, isForGuild)
	local self 						= PositionGuideListPool
	local controlUI, controlSize 	= PositionGuideListPool:newGetthePoint(position, isForGuild)
	updatePositionGuide(controlUI, controlSize, position, 0)
	
	if (nil == self._listGetthePointInfo[self._countGetthePoint - 1]) then
		self._listGetthePointInfo[self._countGetthePoint - 1] = {}
	end	
	self._listGetthePointInfo[self._countGetthePoint - 1].controlUI = controlUI
	self._listGetthePointInfo[self._countGetthePoint - 1].position = position
end

------------ 위치 알림 Pin Update  ----------------------------
local updateFlickerPositionGuide = function()
	local self 					= PositionGuideListPool
	for idx, value in pairs(self._listGetthePointInfo) do
		if(value.controlUI:GetShow()) then
			updatePositionGuide(value.controlUI, self._sizeGetthePoint, value.position, 0)
		end
	end
end

local updatePermanentPositionGuide = function()
	local self 					= PositionGuideListPool
	local positionGuideCount 	= ToClient_RequestGetPositionGuideCount()
	local controlUI, controlSize, positionGuide	= nil
	PositionGuideListPool:clear()
	
	if positionGuideCount < 1 then
		return
	end
	
	for ii = 0, positionGuideCount - 1, 1 do
		if ii == 0 then
			positionGuide = ToClient_RequestGetBeginPositionGuide(ii)
		else
			positionGuide = ToClient_RequestGetNextPositionGuide()
		end
		
		if nil ~= positionGuide then
			if nil == self._listPositionGuide[ii] then
				self._listPositionGuide[ii] = {}
			end
			self._listPositionGuide[ii].actorKey		= positionGuide._actorKey
			if positionGuide._positionGuideActorType == PGAT.ePositionGuideActorType_isGuildMember then
				pinControlUI, pinControlSize 			= PositionGuideListPool:newPinGuild()
				self._listPositionGuide[ii].isForGuild	= true
			elseif positionGuide._positionGuideActorType == PGAT.ePositionGuideActorType_isGuildMaster then
				pinControlUI							= self._guildMaster
				pinControlSize							= self._sizeGuildMaster
				self._listPositionGuide[ii].isForGuild	= true
			elseif positionGuide._positionGuideActorType == PGAT.ePositionGuideActorType_isGuildMine then
				pinControlUI							= self._guildMine
				pinControlSize							= self._sizeGuildMine
				self._listPositionGuide[ii].isForGuild	= true
			elseif positionGuide._positionGuideActorType == PGAT.ePositionGuideActorType_isPartyMine then
				pinControlUI							= self._partyMine
				pinControlSize							= self._sizePartyMine
				self._listPositionGuide[ii].isForGuild	= false				
			elseif positionGuide._positionGuideActorType == PGAT.ePositionGuideActorType_isPartyMember then
				pinControlUI, pinControlSize 			= PositionGuideListPool:newPinParty()
				self._listPositionGuide[ii].isForGuild	= false
			end
			
			updatePositionGuide(pinControlUI, pinControlSize, positionGuide._position, 0)
			
			bubbleControlUI, bubbleControlSize 	= PositionGuideListPool:newPinBubble()
			updatePositionGuide(bubbleControlUI, bubbleControlSize, positionGuide._position, pinControlUI:GetSizeY() / 2)
			
			pinIdControlUI, pinIdControlSize 	= PositionGuideListPool:newPinId()
			pinIdControlUI:SetText(positionGuide:getCharacterName())
			updatePositionGuide(pinIdControlUI, pinIdControlSize, positionGuide._position, pinControlUI:GetSizeY() / 2)
		end	
	end
end

------------ 위치 알림 Pin에 대한 응답  ----------------------------
function  FromClient_ResponseSendPositionGuide(positionGuideInfo)
	if Panel_Radar:GetShow() then
		return
	end
	
	if positionGuideInfo._isPermanent then
		updatePermanentPositionGuide()
	else
		showFlickerPositionGuide(positionGuideInfo._position, positionGuideInfo._isForGuild)
	end
end

-- 주기적으로 PositionGuide Update
function WorldMapWindow_PositionGuidePin_PositionUpdate()
	if not Panel_Win_Worldmap:GetShow() then
		return;
	end
	
	updatePermanentPositionGuide()
	updateFlickerPositionGuide()
end

-- 메뉴 창 열기
function ShowPositionGuideMenu(actorType, index)
	local self = PositionGuideListPool
	local posX, posY, sizeX, sizeY
	
	if (actorType == PGAT.ePositionGuideActorType_isGuildMember) then
		sizeX 	= self._listPinGuild[index]:GetSizeX()
		sizeY 	= self._listPinGuild[index]:GetSizeY()
		posX 	= self._listPinGuild[index]:GetPosX()
		posY 	= self._listPinGuild[index]:GetPosY()
	elseif (actorType == PGAT.ePositionGuideActorType_isGuildMaster) then	
		sizeX 	= self._guildMaster:GetSizeX()
		sizeY 	= self._guildMaster:GetSizeY()
		posX 	= self._guildMaster:GetPosX()
		posY 	= self._guildMaster:GetPosY()
	elseif (actorType == PGAT.ePositionGuideActorType_isGuildMine) then	
		sizeX 	= self._guildMine:GetSizeX() 
		sizeY 	= self._guildMine:GetSizeY()
		posX 	= self._guildMine:GetPosX()
		posY 	= self._guildMine:GetPosY()
	elseif (actorType == PGAT.ePositionGuideActorType_isPartyMine) then
		sizeX 	= self._partyMine:GetSizeX()
		sizeY 	= self._partyMine:GetSizeY()	
		posX 	= self._partyMine:GetPosX()
		posY 	= self._partyMine:GetPosY()
	else
		sizeX 	= self._listPinParty[index]:GetSizeX()
		sizeY 	= self._listPinParty[index]:GetSizeY()
		posX 	= self._listPinParty[index]:GetPosX()
		posY 	= self._listPinParty[index]:GetPosY()
	end
	
	PositionGuideMenuUI._pinMenu:SetPosX(posX + sizeX)
	PositionGuideMenuUI._pinMenu:SetPosY(posY)
	PositionGuideMenuUI._pinMenu:SetShow(true)
	PositionGuideMenuUI._buttonSignal:SetPosX(posX + sizeX + 27)
	PositionGuideMenuUI._buttonSignal:SetPosY(posY + 10)
	PositionGuideMenuUI._buttonSignal:SetShow(true)
	PositionGuideMenuUI._buttonSignal:addInputEvent("Mouse_LDown", "FGlobal_RequestReSendPositionGuide("..(posX + (sizeX/2))..", "..(posY+(sizeY/2))..")")
	
	PositionGuideMenuUI._buttonFindWay:SetPosX(posX + sizeX + 27)
	PositionGuideMenuUI._buttonFindWay:SetPosY(posY + PositionGuideMenuUI._buttonSignal:GetSizeY() + 15)
	PositionGuideMenuUI._buttonFindWay:SetShow(true)
	PositionGuideMenuUI._buttonFindWay:addInputEvent("Mouse_LDown", "FGlobal_RequestFindPositionGuideWay("..(posX + (sizeX/2))..", "..(posY+(sizeY/2))..")")
	
	PositionGuideMenuUI._buttonCancel:SetPosX(posX + sizeX + 27)
	PositionGuideMenuUI._buttonCancel:SetPosY(posY + PositionGuideMenuUI._buttonSignal:GetSizeY() + PositionGuideMenuUI._buttonFindWay:GetSizeY() + 20)
	PositionGuideMenuUI._buttonCancel:SetShow(true)
	PositionGuideMenuUI._buttonCancel:addInputEvent("Mouse_LDown", "FGlobal_RequestDeletePositionGuide("..index..")")
end

-------- 길드나 파티원에게 위치 재전송 
function  FGlobal_RequestReSendPositionGuide(positionX, positionY)
	local destPos = worldmap_navigatorpickPos(WorldMapWindow.world3DMapStatic:GetSizeX(), WorldMapWindow.world3DMapStatic:GetSizeY(), float2(positionX, positionY));
	ToClient_RequestSendPositionGuide(true, false, destPos)	
end

-------- 길드나 파티원이 제공한 위치에 Navi 설정
function FGlobal_RequestFindPositionGuideWay(positionX, positionY)
	local destPos = worldmap_navigatorpickPos(WorldMapWindow.world3DMapStatic:GetSizeX(), WorldMapWindow.world3DMapStatic:GetSizeY(), float2(positionX, positionY));
	
	-- 네비 초기화
	ToClient_DeleteNaviGuideByGroup(0);
	-- ♬ 빛 기둥 나올 때 사운드 추가
	audioPostEvent_SystemUi(00,14)
	-- 네비 찍기
	worldmapNavigatorStart( destPos, NavigationGuideParam(), false, true)
end

-------- 길드나 파티원의 위치 삭제 
function  FGlobal_RequestDeletePositionGuide(index)
	local self 	= PositionGuideListPool
	ToClient_RequestDeletePositionGuide(self._listPositionGuide[index].actorKey, self._listPositionGuide[index].isForGuild)	
	FGlobal_ClosePositionGuideMenu()
end


-- 메뉴 창 닫기
function FGlobal_ClosePositionGuideMenu()
	PositionGuideMenuUI._pinMenu:SetShow(false)
	PositionGuideMenuUI._buttonSignal:SetShow(false)
	PositionGuideMenuUI._buttonFindWay:SetShow(false)
	PositionGuideMenuUI._buttonCancel:SetShow(false)
end

-- 반짝이고 위치를 알려주는 Guide 삭제
function FGlobal_CloseGetthePointPositionGuide()
	local self 	= PositionGuideListPool

	self._countGetthePoint			= 0
	for idx, value in pairs(self._listGetthePoint) do
		value:SetShow(false)
	end
	self._listGetthePointInfo 		= {}	
end


function Panel_Worldmap_KeyGuide_Show()
	local isPressedCtrl = isKeyPressed( VCK.KeyCode_CONTROL )
	
	if ( 1 < WorldMapWindow.popupManager:count() ) or Panel_Farm_ManageWork:GetShow() then
		return
	end
	
	if ( isKeyPressed( VCK.KeyCode_CONTROL ) ) then
		_keyGuide:SetShow( true )
		_keyGuide:SetPosX( getMousePosX() + 30 )
		_keyGuide:SetPosY( getMousePosY() + 30 )
		
		_keyGuide:SetSize( _keyGuide:GetTextSizeX() + 15, _keyGuide:GetTextSizeY() + 10 )
	elseif ( isKeyPressed( VCK.KeyCode_MENU ) ) then
		_keyGuide:SetShow( true )
		_keyGuide:SetPosX( getMousePosX() + 30 )
		_keyGuide:SetPosY( getMousePosY() + 30 )
		
		_keyGuide:SetSize( _keyGuide:GetTextSizeX() + 15, _keyGuide:GetTextSizeY() + 10 )
	else
		_keyGuide:SetShow( false )
	end
	
end

Panel_Win_Worldmap:RegisterUpdateFunc( "Panel_Worldmap_KeyGuide_Show" )
registerEvent("FromClient_ResponseSendPositionGuide", "FromClient_ResponseSendPositionGuide")
