local _Util_Math = Util.Math
local UI_QuestType	= CppEnums.QuestType
local UI_TM			= CppEnums.TextMode

local _questIconCount = 50
local questDataList = {}

-- 테두리 사이즈
local questBorderDefaultSize =
{
	width = UI.getChildControl( Panel_Win_Worldmap, "Static_QuestList_Border" ):GetSizeX(),
	height = UI.getChildControl( Panel_Win_Worldmap, "Static_QuestList_Border" ):GetSizeY()
}
local questBorderMaxSize =
{
	width = questBorderDefaultSize.width * 1.5,
	height = questBorderDefaultSize.height * 1.5,
}

-- 이미지 사이즈
local questImageDefaultSize =
{
	width = UI.getChildControl( Panel_Win_Worldmap, "Static_QuestList_Image" ):GetSizeX(),
	height = UI.getChildControl( Panel_Win_Worldmap, "Static_QuestList_Image" ):GetSizeY()
}
local questImageMaxSize =
{
	width = UI.getChildControl( Panel_Win_Worldmap, "Static_QuestList_Image" ):GetSizeX(),
	height = UI.getChildControl( Panel_Win_Worldmap, "Static_QuestList_Image" ):GetSizeY()
}

local worldMapQuestNotice = UI.getChildControl( Panel_Win_Worldmap, "StaticText_Notice" )

-- 퀘스트 오프셋 기본 위치
local questOffsetDefaultPos = { width = 0, height = 0 };

local questList_updater = function()
	WorldMapWindow_QuestListChanged()
end

local getquestData = function( index )
	if ( nil ~= questDataList[index] ) then
		return questDataList[index]
	end

	questDataList[index] =
	{
		icon = {},
		border = {},
		bottom = {},
		isShow = false,
		positionCount = 0,
		worldPos = {},		-- float3
		isGuideQuest = {}
	}
	return questDataList[index]
end

local questList_dataClear = function()
	for index = 1, _questIconCount do
		local questData = getquestData(index)
		for index2 = 0, questData.positionCount-1 do
			questData.bottom[index2] = nil
		end
	end
end

local init = function()
	for index = 1, _questIconCount do
		getquestData(index)
	end
	WorldMapWindow_Set_OnShowHide_Handler(true, questList_updater)
	WorldMapWindow_Set_OnShowHide_Handler(false, questList_dataClear)
end

init()

local questAnimationAlpha = 0
local questAnimationAlpha_variable = 0.1

function WorldMapWindow_QuestAnimation()
	if not Panel_Win_Worldmap:GetShow() then
		return;
	end
	
	questAnimationAlpha = questAnimationAlpha + questAnimationAlpha_variable

	if ( 1 < questAnimationAlpha ) then
		questAnimationAlpha = 1
		questAnimationAlpha_variable = questAnimationAlpha_variable * -1
	elseif ( questAnimationAlpha < 0 ) then
		questAnimationAlpha = 0
		questAnimationAlpha_variable = questAnimationAlpha_variable * -1
	end

	for _,questData in pairs(questDataList) do
		if questData.isShow then
			for index2 = 0, questData.positionCount-1 do
				if (nil ~= questData.bottom[index2]) then
					local circleData = worldmapGetCircle(WorldMapWindow.RenderType.WMS_EXPLORE_PLANT, questData.bottom[index2], 20)
					if (nil ~= circleData) then
						circleData._color.w = questAnimationAlpha

						if( WorldMapWindow._btn_Quest_Check == false )then
							circleData._color.w = 0
						end
					end
				end	
			end	
		end
	end
end

function WorldMapWindow_QuestListChanged()
	ToClient_clearAllDecal()
	-- WorldMapWindow_QuestDecal_Clear(true)

	local cameraPosition	= getWorldMapCameraPos()
	local questCount		= questList_getCheckedProgressQuestCount()
	local doGuideQuestCount = questList_getDoGuideQuestCount()
	
	-- UI.debugMessage('Quest List Changed' .. questCount )

	for _, questData in pairs(questDataList) do
		for _, value in pairs( questData.icon ) do
			value:SetShow(false)
		end
		for _, value in pairs( questData.border ) do
			value:SetShow(false)
		end
	end
	
	--WorldMapWindow
	
	-- if not WorldMapWindow._btn_Quest_Check then
		-- WorldMapWindow_QuestPosition()
		-- return;
	-- end

	--audioPostEvent_SystemUi(00,01)	
	
	
	-- if( WorldMapWindow._btn_Quest_Check == false )then
	--if( WorldMapWindow._btn_Quest_Check == false )then	
	
	-- if( true )then	
		-- WorldMapWindow_QuestPosition()
		-- return
	-- end
	
	--if( false ) then
	-- if( true ) then
		-- WorldMapWindow_QuestPosition()
		-- return;
	-- end

	local idx = 0
	for index = 1, questCount do
		-- UI.debugMessage('Quest Data Set ' .. index )
		if _questIconCount < index then
			break
		end

		local progressQuest = questList_getCheckedProgressQuestAt(index - 1)
		_PA_ASSERT(nil ~= progressQuest, '이런 일이 일어나서는 안되는데!!!')

		local questData = getquestData(index)
		
		questData.positionCount = progressQuest:getQuestPositionCount()
		local isShow = 0 ~= questData.positionCount
		if not progressQuest:isSatisfied() then
			for index2 = 0, questData.positionCount-1 do
				local questIcon = questData.icon[index2]
				if (nil == questIcon) then
					-- 퀘스트 아이콘 이미지
					questIcon = UI.createControl( CppEnums.PA_UI_CONTROL_TYPE.PA_UI_CONTROL_STATIC, WorldMapWindow.uiList[WorldMapWindow.RenderType.WMS_EXPLORE_PLANT], 'Static_QuestList_Image_' .. index .. index2)
					questIcon:SetSize(96,96)
					questIcon:SetShow(false)
					questData.icon[index2] = questIcon
				end	

				local questBorder = questData.border[index2]
				if (nil == questBorder) then
					-- 퀘스트 아이콘 테두리
					questBorder = UI.createControl( CppEnums.PA_UI_CONTROL_TYPE.PA_UI_CONTROL_STATIC, questIcon, 'Static_QuestList_Border_' .. index .. index2)
					questBorder:SetSize(100,130)
					questBorder:SetShow(false)
					questBorder:ChangeTextureInfoName( "New_UI_Common_forLua/Widget/Quest/Quests_00.dds" )
						local x1, y1, x2, y2 = setTextureUV_Func( questBorder, 311, 184, 511, 444 )
						questBorder:getBaseTexture():setUV(  x1, y1, x2, y2  )
						questBorder:setRenderTexture(questBorder:getBaseTexture())

					questBorder:addInputEvent("Mouse_LDown",		"WorldMapWindow_OnPressStart()");
					questBorder:addInputEvent("Mouse_LUp",			"WorldMapWindow_OnPressEnd_Default()");
					questBorder:addInputEvent("Mouse_RDown",		"WorldMapWindow_OnPressStart()");
					questBorder:addInputEvent("Mouse_LPress",		"WorldMapWindow_OnCameraMove()");
					questBorder:addInputEvent("Mouse_RPress",		"WorldMapWindow_OnCameraRotate()");
					questBorder:addInputEvent("Mouse_UpScroll",		"WorldMapWindow_OnUpScroll()");
					questBorder:addInputEvent("Mouse_DownScroll",	"WorldMapWindow_OnDownScroll()");

					questData.border[index2] = questBorder
				end	
				
				questIcon:SetShow(isShow)
				questBorder:SetShow(isShow)
				questData.isShow = isShow
				questData.isGuideQuest[index2] = false

				if isShow then
					local questPosition = progressQuest:getQuestPositionAt(index2)
					questData.worldPos[index2] = float3(questPosition._position.x, 0, questPosition._position.z)
					questIcon:ChangeTextureInfoName( progressQuest:getIconPath() )				-- 퀘스트 아이콘 넣어주기

					-- 퀘스트 아래 데칼 표시
					if nil == questData.bottom[index2] then
						questData.bottom[index2] = ToClient_insertVolumeDecal( "worldmapDecal.dds", float3(questPosition._position.x, 1, questPosition._position.z), float4(1, 1, 1, 1), 5000, 3 )
					else
						-- questData.bottom[index2] = ToClient_insertVolumeDecal( "worldmapDecal.dds", float3(questPosition._position.x, 1, questPosition._position.y), float4(1, 1, 1, 1), 5000, 3 )
					end

					--[[ 퀘스트 정보 표시!! ]]--
					questBorder:addInputEvent("Mouse_On",		"QuestInfoData.questDescShowWindow(" ..(index - 1).. ")")
					questBorder:addInputEvent("Mouse_Out",		"QuestInfoData.questDescHideWindow()")
				end	
			end
		end

		idx = index
	end
	
	for index = 1, doGuideQuestCount do
		if _questIconCount < index then
			break
		end

		local doGuideQuest = questList_getDoGuideQuestAt(index - 1)
		_PA_ASSERT(nil ~= doGuideQuest, '이런 일이 일어나서는 안되는데!!!')

		if(questList_isSelectQuest(doGuideQuest:getSelectType())) then
			local questData = getquestData(index + questCount)
			
			questData.positionCount = 1
			local isShow = 0 ~= questData.positionCount
			
			local index2 = 0
			local questIcon = questData.icon[index2]
			if (nil == questIcon) then
				-- 퀘스트 아이콘 이미지
				questIcon = UI.createControl( CppEnums.PA_UI_CONTROL_TYPE.PA_UI_CONTROL_STATIC, WorldMapWindow.uiList[WorldMapWindow.RenderType.WMS_EXPLORE_PLANT], 'Static_QuestList_Image_' .. (index+questCount) .. index2)
				questIcon:SetSize(48,48)
				questIcon:SetShow(false)
				questData.icon[index2] = questIcon
			end	

			local questBorder = questData.border[index2]
			if (nil == questBorder) then
				-- 퀘스트 아이콘 테두리
				questBorder = UI.createControl( CppEnums.PA_UI_CONTROL_TYPE.PA_UI_CONTROL_STATIC, questIcon, 'Static_QuestList_Border_' .. (index+questCount) .. index2)
				questBorder:SetSize(50,65)
				questBorder:SetShow(false)
				questBorder:ChangeTextureInfoName( "New_UI_Common_forLua/Widget/Quest/Quests_00.dds" )
					local x1, y1, x2, y2 = setTextureUV_Func( questBorder, 311, 184, 511, 444 )
					questBorder:getBaseTexture():setUV(  x1, y1, x2, y2  )
					questBorder:setRenderTexture(questBorder:getBaseTexture())

				questBorder:addInputEvent("Mouse_LDown",		"WorldMapWindow_OnPressStart()");
				questBorder:addInputEvent("Mouse_LUp",			"WorldMapWindow_OnPressEnd_Default()");
				questBorder:addInputEvent("Mouse_RDown",		"WorldMapWindow_OnPressStart()");
				questBorder:addInputEvent("Mouse_LPress",		"WorldMapWindow_OnCameraMove()");
				questBorder:addInputEvent("Mouse_RPress",		"WorldMapWindow_OnCameraRotate()");
				questBorder:addInputEvent("Mouse_UpScroll",		"WorldMapWindow_OnUpScroll()");
				questBorder:addInputEvent("Mouse_DownScroll",	"WorldMapWindow_OnDownScroll()");

				questData.border[index2] = questBorder
			end	
			
			questIcon:SetShow(isShow)
			questBorder:SetShow(isShow)
			questData.isShow = isShow
			questData.isGuideQuest[index2] = true

			if isShow then
				local spawnData = npcByCharacterKey_getNpcInfo(doGuideQuest:getAccecptNpc(), doGuideQuest:getAccecptDialogIndex())
				
				if(nil ~= spawnData) then
					local npcPosition = spawnData:getPosition()
					questData.worldPos[index2] = float3(npcPosition.x, npcPosition.y, npcPosition.z)
					questIcon:ChangeTextureInfoName( "New_UI_Common_forLua/Widget/Quest/Quest_Guide.dds" )				-- 퀘스트 아이콘 넣어주기
				else
					questData.worldPos[index2] = float3(0, 0, 0)
				end	
				
				--[[ 퀘스트 정보 표시!! ]]--
				questBorder:addInputEvent("Mouse_On",		"QuestInfoData.questDescShowWindow(" ..(index - 1).. ", " .. UI_QuestType.QuestType_DoGuide .. " )")
				questBorder:addInputEvent("Mouse_Out",		"QuestInfoData.questDescHideWindow()")
			end	
			

			idx = idx + index
		end	
	end

	for idx2 = idx + 1, _questIconCount do
		-- UI.debugMessage('Quest Data Clear ' .. idx2 )

		local questData = questDataList[idx2]
		for index2 = 0, questData.positionCount-1 do
			local questIcon = questData.icon[index2]
			if nil ~= questIcon then
				questIcon:SetShow( false )
			end

			local questBorder = questData.border[index2]
			if nil ~= questBorder then
				questBorder:SetShow( false )
			end
		end	
	end

	-- 퀘스트 목록이 변경되면, 즉시 강제로 위치를 갱신하는 함수를 한번 호출해준다!
	WorldMapWindow_QuestPosition()
end

function WorldMapWindow_ShowGuideQuestNotice()
	local posX  = getMousePosX()
	local posY  = getMousePosY() + 25
	
	worldMapQuestNotice:SetShow( true )
	worldMapQuestNotice:SetSize( 220, 28 )
	worldMapQuestNotice:SetTextMode( UI_TM.eTextMode_AutoWrap )
	worldMapQuestNotice:SetText( PAGetString( Defines.StringSheet_GAME,  "LUA_WORLDMAP_QUEST_GUIDEQUEST_NOTICE") )
	worldMapQuestNotice:SetSize ( worldMapQuestNotice:GetTextSizeX() + 10, worldMapQuestNotice:GetSizeY() )
	worldMapQuestNotice:SetPosX( posX )
	worldMapQuestNotice:SetPosY( posY )
end

function WorldMapWindow_HideGuideQuestNotice()
	worldMapQuestNotice:SetShow( false )
end


function WorldMapWindow_QuestPosition()
	if not Panel_Win_Worldmap:GetShow() then
		return
	end
	
	--audioPostEvent_SystemUi(00,01)		
	--return;
	
	-- if( WorldMapWindow._btn_Quest_Check == false )then
		-- audioPostEvent_SystemUi(00,01)	
	-- end

	local cameraPosition	= getWorldMapCameraPos()

	-- 최대, 최소 Scale 을 적용한다!!!!
	local scaleMin = 0.2
	local scaleMax = 1.5

	for _,questData in pairs(questDataList) do
		if questData.isShow then
			for index2 = 0, questData.positionCount-1 do
				local questIcon		= questData.icon[index2]
				local questBorder	= questData.border[index2]
				local questPosition	= questData.worldPos[index2]
				if ( WorldMapWindow.isHouseMode or WorldMapWindow._btn_Quest_Check == false ) then
					questIcon		:SetShow(false)
					questBorder		:SetShow(false)
				else
					questIcon		:SetShow(true)
					questBorder		:SetShow(true)
					local pos2D = worldmapScenetoScreenPosition(questPosition.x, 0, questPosition.z)
					pos2D.x = pos2D.x * WorldMapWindow.world3DMapStatic:GetSizeX()
					pos2D.y = pos2D.y * WorldMapWindow.world3DMapStatic:GetSizeY()

					-- 테두리 사이즈
					local questBorderSize = _Util_Math.calculateDepthScalerWithLimit( questPosition, questBorderDefaultSize, scaleMin, scaleMax )
					if (questData.isGuideQuest[index2]) then
						questBorder:SetSize(questBorderSize.width/4, questBorderSize.height/4)
					else
						questBorder:SetSize(questBorderSize.width/2, questBorderSize.height/2)
					end
					-- 이미지 사이즈
					local questImageSize = _Util_Math.calculateDepthScalerWithLimit( questPosition, questImageDefaultSize, scaleMin, scaleMax )
					if (questData.isGuideQuest[index2]) then
						questIcon:SetSize(questImageSize.width/4, questImageSize.height/4)
					else
						questIcon:SetSize(questImageSize.width/2, questImageSize.height/2)
					end
					local questOffset = _Util_Math.calculateDepthScalerWithLimit( questPosition, questOffsetDefaultPos, scaleMin, scaleMax )

					questBorder:SetPosX(questOffset.width);
					questBorder:SetPosY(questOffset.height);

					questIcon:SetPosX(pos2D.x - questIcon:GetSizeX() / 2)
					questIcon:SetPosY(pos2D.y - questIcon:GetSizeY())

					questIcon:SetDepth(WorldMapWindow_GetDepthFromPos3D(cameraPosition, questPosition));

					local worldmapAlpha = WorldMapWindow.world3DMapStatic:GetAlpha()
					if ( WorldMapWindow.rendering ) then
						worldmapAlpha = 1
					end
					questBorder:SetAlpha(worldmapAlpha)
					questIcon:SetAlpha(worldmapAlpha)					

					questBorder:addInputEvent("Mouse_RUp", "WorldMapWindow_Quest_Navi(".. questPosition.x .. ", " .. questPosition.y .. ", " .. questPosition.z .." )")
				end
			end	
		end
	end
end

function WorldMapWindow_Quest_Navi(x, y, z)
	-- 네비 초기화
	ToClient_DeleteNaviGuideByGroup(0);
	-- ♬ 빛 기둥 나올 때 사운드 추가
	audioPostEvent_SystemUi(00,14)
	-- 네비 찍기
	worldmapNavigatorStart( float3(x, y, z), NavigationGuideParam(), false, true)
end

function WorldMapWindow_QuestDecal_Clear( isClear )
	local questCount		= questList_getCheckedProgressQuestCount()
	for index = 1, questCount do
		local progressQuest = questList_getCheckedProgressQuestAt(index - 1)
		local questData = getquestData(index)
		questData.positionCount = progressQuest:getQuestPositionCount()
		for index2 = 0, questData.positionCount-1 do
			if nil ~= questData.bottom[index2] then
			--모든데이터가 지워진 다음에 들어오는거라 다시지울필요 없습니다.
				if ( true == isClear ) then
					ToClient_destroyVolumeDecal( questData.bottom[index2], 1 )
				end
				questData.bottom[index2] = nil
			end
		end
	end
end
ToClient_clearAllDecal()
registerEvent("FromClient_cleanWorldMapVolumeDecal", "WorldMapWindow_QuestDecal_Clear")