Panel_QuestInfo:RegisterShowEventFunc( true, 'questInfoAniShow()' )
Panel_QuestInfo:RegisterShowEventFunc( false, 'questDescHideAni()' )

Panel_QuestInfo:setMaskingChild(true)
Panel_QuestInfo:setGlassBackground(true)

local UI_ANI_ADV = CppEnums.PAUI_ANIM_ADVANCE_TYPE
local UI_TM = CppEnums.TextMode
local UI_color 		= Defines.Color
local UI_QuestType	= CppEnums.QuestType

-- Panel_QuestInfo:SetShow( false, true )
local _questDescList = {}
local _questTitleCreate={}
local _questConditionCreate = {}
local _questDescCreate = {}
local _questIconCreate ={}

QuestInfoData = {}

local _questTooltipTitle	= UI.getChildControl ( Panel_QuestInfo, "StaticText_QuestDescPanelTitle" )
local _questTitle			= UI.getChildControl ( Panel_QuestInfo, "StaticText_QuestTitle" )
local _questCondition 		= UI.getChildControl ( Panel_QuestInfo, "StaticText_QuestCondition" )
local _questDesc 			= UI.getChildControl ( Panel_QuestInfo, "StaticText_QuestDesc" )
local _questIcon 			= UI.getChildControl ( Panel_QuestInfo, "Static_QuestIcon" )
local _questIconBG			= UI.getChildControl ( Panel_QuestInfo, "Static_IconBackground" )

local sizeX = Panel_QuestInfo:GetSizeX()
local sizeY = Panel_QuestInfo:GetSizeY()

-- 나오고 꺼지고 알파
function questInfoAniShow()
	Panel_QuestInfo:SetAlpha(0)
	UIAni.AlphaAnimation( 1, Panel_QuestInfo, 0.0, 0.1 )
end

function questDescHideAni()
	Panel_QuestInfo:SetShowWithFade(CppEnums.PAUI_SHOW_FADE_TYPE.PAUI_ANI_TYPE_FADE_OUT)
	local aniInfo = UIAni.AlphaAnimation( 0, Panel_QuestInfo, 0.0, 0.01 )
	aniInfo:SetDisableWhileAni(true)
	aniInfo:SetHideAtEnd(true)
end


isQuestDescShow = false
QuestInfoData.questDescShowWindow = function( index, questType )
	local posX  = getMousePosX()
	local posY  = getMousePosY()
	
	local progressQuest
	if (UI_QuestType.QuestType_Sub_Cleared == questType ) then
		progressQuest = questList_getClearedSubQuestAt(index)
	elseif (UI_QuestType.QuestType_Normal_Cleared == questType ) then
		progressQuest = questList_getClearedNormalQuestAt(index)
	elseif (UI_QuestType.QuestType_DoGuide == questType ) then
		progressQuest = questList_getDoGuideQuestAt(index)
	else
		progressQuest = questList_getCheckedProgressQuestAt(index)
	end
	
	local demandCount = progressQuest:getDemadCount()
	
	local demandString = '' ;
	for demandIndex = 0, demandCount-1,1 do
		local demand = progressQuest:getDemandAt(demandIndex);
		demandString = demandString .. demand._desc .. '\n'
	end
	
	local questDesc = {_title="", _desc=""}
	questDesc._title =  progressQuest:getTitle()
	questDesc._desc = progressQuest:getDesc()
	
	_questTooltipTitle:SetText( PAGetString(Defines.StringSheet_GAME, "LUA_QUESTTOOLTIP_TITLE_0") )
	_questTitle:SetText ( tostring ( questDesc._title ) )
	_questCondition:SetTextMode( UI_TM.eTextMode_AutoWrap )
	_questCondition:SetAutoResize( true )
	_questCondition:SetText ( tostring ( demandString ) )
	_questDesc:SetTextMode( UI_TM.eTextMode_AutoWrap )
	_questDesc:SetAutoResize( true )
	_questDesc:SetText ( tostring ( questDesc._desc ) )
	_questDesc:SetSize ( _questDesc:GetSizeX(), _questDesc:GetSizeY() + 10 )
	
	_questIcon:ChangeTextureInfoName( progressQuest:getIconPath() )
	
	local conditionSizeY = _questCondition:GetSizeY() + _questCondition:GetPosY()

	_questDesc:SetPosX( 10 )
	_questDesc:SetPosY( conditionSizeY + 5)
	_questDesc:ComputePos()
	
	Panel_QuestInfo:SetShow( true, true )
	
	Panel_QuestInfo:SetSize( sizeX, _questDesc:GetPosY() + _questDesc:GetSizeY() + 10 )
	Panel_QuestInfo:SetPosX( posX )
	Panel_QuestInfo:SetPosY( posY )
	-- questInfoAniShow()
	Panel_QuestInfo:setFlushAble( false )
	isQuestDescShow = true
end


QuestInfoData.questCheckDescShowWindow = function( questGroupIndex, questIndex, checked )
	local posX  = getMousePosX() + 10
	local posY  = getMousePosY()
	local questListInfo = ToClient_GetQuestList()
	local questGroupInfo = nil

	if true == checked then
		questGroupInfo = questListInfo:getQuestCheckedGroupAt( questGroupIndex )
	else
		questGroupInfo = questListInfo:getQuestGroupAt( questGroupIndex )
	end
	local uiQuestInfo = questGroupInfo:getQuestAt( questIndex )

	local demandCount = uiQuestInfo:getDemandCount()
	
	local demandString = '' ;
	for demandIndex = 0, demandCount-1,1 do
		local demand = uiQuestInfo:getDemandAt(demandIndex);
		demandString = demandString .. demand._desc .. '\n'
	end

	_questTooltipTitle:SetShow( true )
	_questTitle:SetShow( true )
	_questTitle:SetText( uiQuestInfo:getTitle() )

	_questCondition:SetShow( true )
	_questCondition:SetTextMode( UI_TM.eTextMode_AutoWrap )
	_questCondition:SetAutoResize( true )
	_questCondition:SetText ( tostring ( demandString ) )

	_questDesc:SetShow( true )
	_questDesc:SetTextMode( UI_TM.eTextMode_AutoWrap )
	_questDesc:SetAutoResize( true )
	_questDesc:SetText ( tostring ( uiQuestInfo:getDesc() ) )
	_questDesc:SetSize ( _questDesc:GetSizeX(), _questDesc:GetSizeY() + 10 )

	local conditionSizeY = _questCondition:GetSizeY() + _questCondition:GetPosY()

	_questDesc:SetPosX( 10 )
	_questDesc:SetPosY( conditionSizeY + 5)
	_questDesc:ComputePos()

	_questIcon:SetShow( true )
	_questIcon:ChangeTextureInfoName( uiQuestInfo:getIconPath() )

	_questIconBG:SetShow( true )

	Panel_QuestInfo:SetSize( sizeX, _questDesc:GetPosY() + _questDesc:GetSizeY() + 10 )
	Panel_QuestInfo:SetPosX( posX )
	Panel_QuestInfo:SetPosY( posY )
	Panel_QuestInfo:SetShow( true, true )
	Panel_QuestInfo:setFlushAble( false )

end


QuestInfoData.questCheckDescShowWindow2 = function( questGroupIndex, questIndex )
	local posX  = getMousePosX() + 10
	local posY  = getMousePosY()
	

	local uiQuestInfo = questList_getQuestStatic( questGroupIndex, questIndex )
	-- local uiQuestInfo = questGroupInfo:getQuestAt( questIndex )

	local demandCount = uiQuestInfo:getDemadCount()
	
	local demandString = '' ;
	for demandIndex = 0, demandCount-1,1 do
		local demand = uiQuestInfo:getDemandAt(demandIndex);
		demandString = demandString .. demand._desc .. '\n'
	end

	_questTooltipTitle:SetShow( true )
	_questTitle:SetShow( true )
	_questTitle:SetText( uiQuestInfo:getTitle() )

	_questCondition:SetShow( true )
	_questCondition:SetTextMode( UI_TM.eTextMode_AutoWrap )
	_questCondition:SetAutoResize( true )
	_questCondition:SetText ( tostring ( demandString ) )

	_questDesc:SetShow( true )
	_questDesc:SetTextMode( UI_TM.eTextMode_AutoWrap )
	_questDesc:SetAutoResize( true )
	_questDesc:SetText ( tostring ( uiQuestInfo:getDesc() ) )
	_questDesc:SetSize ( _questDesc:GetSizeX(), _questDesc:GetSizeY() + 10 )

	local conditionSizeY = _questCondition:GetSizeY() + _questCondition:GetPosY()

	_questDesc:SetPosX( 10 )
	_questDesc:SetPosY( conditionSizeY + 5)
	_questDesc:ComputePos()

	_questIcon:SetShow( true )
	_questIcon:ChangeTextureInfoName( uiQuestInfo:getIconPath() )

	_questIconBG:SetShow( true )

	Panel_QuestInfo:SetSize( sizeX, _questDesc:GetPosY() + _questDesc:GetSizeY() + 10 )
	Panel_QuestInfo:SetPosX( posX - Panel_QuestInfo:GetSizeX() )
	Panel_QuestInfo:SetPosY( posY )
	Panel_QuestInfo:SetShow( true, true )
	Panel_QuestInfo:setFlushAble( false )

end


-- 길드 퀘스트 용 ---------------------------------------------------------
local constQuestConditionSizeX = _questCondition:GetSizeX()
QuestInfoData.guildQuestDescShowWindow = function()
	local posX  = getMousePosX()
	local posY  = getMousePosY()
	
	local demandCount = ToClient_getCurrentGuildQuestConditionCount()
	
	local demandString = ''
	
	local conditionSizeX = 0
	local maxLen = 0
	for demandIndex = 0, demandCount-1,1 do
		local demand = ToClient_getCurrentGuildQuestConditionAt(demandIndex)
		local stringLen = string.len(demand._desc .. "( "..demand._currentCount.." / "..demand._destCount.." )")
		if maxLen < stringLen then
			maxLen = stringLen
		end
		if 50 < maxLen then
			conditionSizeX = (maxLen - 50) * 4
		end
		demandString = demandString .. demand._desc .. "( "..demand._currentCount.." / "..demand._destCount.." )".."\n"
	end
	
	local questDesc = {_title="", _desc=""}
	questDesc._title =  ToClient_getCurrentGuildQuestName()
	questDesc._desc = ToClient_getCurrentGuildQuestDesc()
	
	_questTooltipTitle:SetText( PAGetString(Defines.StringSheet_GAME, "LUA_QUESTTOOLTIP_TITLE_1") )
	_questTitle:SetTextMode( UI_TM.eTextMode_LimitText )
	_questTitle:SetText ( tostring ( questDesc._title ) )
	_questCondition:SetSize(constQuestConditionSizeX + conditionSizeX, _questCondition:GetSizeY())
	_questCondition:SetTextMode( UI_TM.eTextMode_AutoWrap )
	_questCondition:SetText ( tostring ( demandString ) )
	_questDesc:SetTextMode( UI_TM.eTextMode_AutoWrap )
	_questDesc:SetAutoResize( true )
	_questDesc:SetText ( tostring ( questDesc._desc ) )
	_questDesc:SetSize ( _questDesc:GetSizeX(), _questDesc:GetSizeY() + 10 )
	
	_questIcon:ChangeTextureInfoName( ToClient_getCurrentGuildQuestIconPath() )
	
	local conditionSizeY = _questCondition:GetTextSizeY() + _questCondition:GetPosY()

	_questDesc:SetPosX( 10 )
	_questDesc:SetPosY( conditionSizeY )
	_questDesc:ComputePos()

	Panel_QuestInfo:SetShow( true, true )
	
	Panel_QuestInfo:SetSize( sizeX, _questDesc:GetPosY() + _questDesc:GetSizeY() + 10 )
	Panel_QuestInfo:SetPosX( posX )
	Panel_QuestInfo:SetPosY( posY )
	-- questInfoAniShow()
	Panel_QuestInfo:setFlushAble( false )
end
-----------------------------------------------------------------------------------

QuestInfoData.questDescShowWindowForLeft = function( index )
	local posX  = getMousePosX();
	local posY  = getMousePosY();
	
	Panel_QuestInfo:SetPosX( posX - Panel_QuestInfo:GetSizeX()  )
	Panel_QuestInfo:SetPosY( posY )
	Panel_QuestInfo:SetShow( true, true )
	-- questInfoAniShow()
	
	local progressQuest = questList_getCheckedProgressQuestAt(index);
	local demandCount = progressQuest:getDemadCount()
	
	local demandString = '' ;
	for demandIndex = 0, demandCount-1,1 do
		local demand = progressQuest:getDemandAt(demandIndex);
		demandString = demandString .. demand._desc .. '\n'
	end
	
	local questDesc = {_title="", _desc=""}
	questDesc._title =  progressQuest:getTitle()
	questDesc._desc = progressQuest:getDesc()
	
	_questTooltipTitle:SetText( PAGetString(Defines.StringSheet_GAME, "LUA_QUESTTOOLTIP_TITLE_0") )
	-- _questTitle:SetPosX(constQuestTitlePosX)
	_questTitle:SetText ( tostring ( questDesc._title ) )
	_questCondition:SetTextMode( UI_TM.eTextMode_AutoWrap )
	_questCondition:SetText ( tostring ( demandString ) )
	_questDesc:SetTextMode( UI_TM.eTextMode_AutoWrap )
	_questDesc:SetAutoResize( true )
	_questDesc:SetText ( tostring ( questDesc._desc ) )
	_questDesc:SetSize ( _questDesc:GetSizeX(), _questDesc:GetSizeY() + 10 )
	
	_questIcon:ChangeTextureInfoName( progressQuest:getIconPath() )
	
	local conditionSizeY = _questCondition:GetTextSizeY() + _questCondition:GetPosY()

	_questDesc:SetPosX( 10 )
	_questDesc:SetPosY( conditionSizeY )
	Panel_QuestInfo:SetSize( sizeX, _questDesc:GetPosY() + _questDesc:GetSizeY() + 10 )

end


QuestInfoData.questDescShowWindowForStatic = function( index, questGroupQuestNo, questType )
	local posX  = getMousePosX();
	local posY  = getMousePosY();
	local progressQuest
	if (UI_QuestType.QuestType_Sub_Cleared == questType ) then
		progressQuest = questList_getClearedSubQuestAt(index);
	elseif (UI_QuestType.QuestType_Normal_Cleared == questType ) then
		progressQuest = questList_getClearedNormalQuestAt(index);
	else
		progressQuest = questList_getCheckedProgressQuestAt(index);
	end
	
	local questData = progressQuest:getQuestGroupQuestAt(questGroupQuestNo)
	local demandCount = questData:getDemadCount()
	local demandString = '' ;
	for demandIndex = 1, demandCount, 1 do
		local demand = questData:getDemandAt(demandIndex-1);
		demandString = demandString .. demand._desc .. '\n'
	end
	
	local questDesc = {_title="", _desc=""}
	questDesc._title =  questData:getTitle()
	questDesc._desc = questData:getDesc()
	
	_questTooltipTitle:SetText( PAGetString(Defines.StringSheet_GAME, "LUA_QUESTTOOLTIP_TITLE_0") )
	-- _questTitle:SetPosX(constQuestTitlePosX)
	_questTitle:SetText ( tostring ( questDesc._title ) )
	_questCondition:SetTextMode( UI_TM.eTextMode_AutoWrap )
	_questCondition:SetText ( tostring ( demandString ) )
	_questDesc:SetTextMode( UI_TM.eTextMode_AutoWrap )
	-- _questDesc:SetAutoResize( true )
	_questDesc:SetText ( tostring ( questDesc._desc ) )
	_questIcon:ChangeTextureInfoName( questData:getIconPath() )
	
	local conditionSizeY = _questCondition:GetTextSizeY() + _questCondition:GetPosY()
	
	_questDesc:SetPosX( 10 )
	_questDesc:SetPosY( conditionSizeY + 10 )
	_questDesc:ComputePos()

	Panel_QuestInfo:SetShow( true, true )
	
	Panel_QuestInfo:SetSize( sizeX, _questDesc:GetPosY() + _questDesc:GetSizeY() + 10 )
	Panel_QuestInfo:SetPosX( posX )
	Panel_QuestInfo:SetPosY( posY )
	-- questInfoAniShow()
	Panel_QuestInfo:setFlushAble( false )
end

QuestInfoData.questDescHideWindow = function()
	--if ( Panel_QuestInfo:IsShow() ) then
		Panel_QuestInfo:SetShow( false, true )
		isQuestDescShow = false
	--end
end



--초기화 함수 실행
--Panel_QuestInfo.init ();