Panel_manageWorker:setMaskingChild(true)
Panel_manageWorker:setGlassBackground(true)

local UI_TYPE 	= CppEnums.PA_UI_CONTROL_TYPE
local UI_TM 	= CppEnums.TextMode
local UI_PP 	= CppEnums.PAUIMB_PRIORITY

if nil == WorldMapWindow then
	WorldMapWindow = {}
end

WorldMapWindow.manageWorkerPanel_infoNodeKey = nil

local Control_WorkerList = {}
local Control_RestoreItem = {}
local Worker_Table = {}
local RestoreItem_Table = {}
local WorkerTooltip_Index = nil
local ItemTooltip_Index = nil

eWorkerStateType = 
{
	waiting				= 0,
	working				= 1,
	transfer				= 2,
}

local defaul_Control =
{	
	_Title					= UI.getChildControl(Panel_manageWorker, "titlebar_manageWorker"),
		
	_List_BG 				= UI.getChildControl(Panel_manageWorker, "Static_WorkerList_BG"),
	_List_Scroll 			= UI.getChildControl(Panel_manageWorker, "WorkerList_ScrollBar"),
		
	_worker_BG	 			= UI.getChildControl(Panel_manageWorker, "Static_workerBG"),
	_worker_CheckBox		= UI.getChildControl(Panel_manageWorker, "button_workerList_checkBox"),
	_worker_Name			= UI.getChildControl(Panel_manageWorker, "workerManage_workerName"),
	_worker_State			= UI.getChildControl(Panel_manageWorker, "Button_workerState"),
	_worker_RestorePoint	= UI.getChildControl(Panel_manageWorker, "Progress2_RestorePoint"),
	_worker_CurrentPoint	= UI.getChildControl(Panel_manageWorker, "Progress2_CurrentPoint"),
	_List_Empty				= UI.getChildControl(Panel_manageWorker, "StaticText_EmptySlot"),
		
	_buttonQuestion 		= UI.getChildControl( Panel_manageWorker, "Button_Question"),
	_closeButton 			= UI.getChildControl( Panel_manageWorker, "Button_Close"),
		
	_Item_BG	 			= UI.getChildControl( Panel_manageWorker, "Static_Restore_Item_BG"),
	_Item_Slider 			= UI.getChildControl( Panel_manageWorker, "Slider_Restore_Item"),
	_Item_SliderBG 			= UI.getChildControl( Panel_manageWorker, "Static_Item_SliderBG"),
	_Btn_CloseItem 			= UI.getChildControl( Panel_manageWorker, "Button_Close_Item"),
	_Item_IconBG 			= UI.getChildControl( Panel_manageWorker, "Static_Restore_Item_Icone_BG"),
	_Item_Icone 			= UI.getChildControl( Panel_manageWorker, "Static_Restore_Item_Icone"),
	_Item_Count 			= UI.getChildControl( Panel_manageWorker, "StaticText_Item_Count"),
	_Item_RestoreValue		= UI.getChildControl( Panel_manageWorker, "StaticText_Item_Restore_Value"),
	
	_Guide_Restore			= UI.getChildControl( Panel_manageWorker, "StaticText_Guide_Restore"),
		
	_Slot_MaxCount			= 5,
	_Slot_MinCount			= 3,
	_Slot_GapY				= 33,
	_Scroll_GapX			= 7,
		
	_Item_MaxCount			= 5,
	_Item_GapX				= 49,
}

local btnControl =
{
	_Fire 		= UI.getChildControl( Panel_manageWorker, "button_doWorkerFire"),
}


local scroll_Param =
{
	_offsetIndex 	= 0,
	_offsetMax 		= 0,	
	_slotMax 		= 0,	
	_contentCount	= 0,	
}

local slider_Param =
{
	_offsetIndex 	= 0,
	_offsetMax 		= 0,	
	_slotMax 		= 0,	
	_contentCount	= 0,	
}

local default_Size_Pos =
{
	_Panel_SizeX 	= 0,
	_Panel_SizeY 	= 0,
	_Title_SizeX 	= 0,
	_List_BG_SpanX 	= 0,
	_List_BG_SpanY 	= 0,
	_List_BG_SizeY 	= 0,
	
	_Item_BG_SpanX = 0,
	_Item_BG_SpanY = 0,
}

function default_Size_Pos:Init()
	self._Panel_SizeX 	= Panel_manageWorker:GetSizeX()
	self._Panel_SizeY 	= Panel_manageWorker:GetSizeY()
	self._Title_SizeX 	= defaul_Control._Title:GetSizeX()
	self._List_BG_SpanX = defaul_Control._List_BG:GetSpanSize().x
	self._List_BG_SpanY = defaul_Control._List_BG:GetSpanSize().y
	self._List_BG_SizeY = defaul_Control._List_BG:GetSizeY()
	self._Item_BG_SpanX = defaul_Control._Item_BG:GetSpanSize().x
	self._Item_BG_SpanY	= defaul_Control._Item_BG:GetSpanSize().y
	
	defaul_Control._scroll_Button 		= UI.getChildControl(defaul_Control._List_Scroll,	 "Frame_ScrollBar_thumb")
end
default_Size_Pos:Init()

function defaul_Control:hide()
	self._worker_BG	 			:SetShow(false)
	self._worker_CheckBox		:SetShow(false)
	self._worker_Name			:SetShow(false)
	self._worker_State			:SetShow(false)
	self._worker_RestorePoint	:SetShow(false)
	self._worker_CurrentPoint	:SetShow(false)
	self._List_Empty			:SetShow(false)
	
	self._Item_BG	 			:SetShow(false)
	self._Item_SliderBG 		:SetShow(false)
	self._Btn_CloseItem 		:SetShow(false)
	self._Item_IconBG 	    	:SetShow(false)
	self._Item_Icone 	    	:SetShow(false)
	self._Item_Count 	    	:SetShow(false)
	self._Item_RestoreValue 	:SetShow(false)
end

function WorldMapWindow_WaitWorkerFire()
	for index, checkBox in pairs(Control_WorkerList._worker_CheckBox) do
		if checkBox:IsCheck() then
			local workerIndex = scroll_Param._offsetIndex + index
			local workerNo = Worker_Table[workerIndex]._WorkerNo
			requestDeleteMyWorker(workerNo);
		end
	end
end

function Control_WorkerList:Init()

	defaul_Control._List_BG			:addInputEvent ( "Mouse_UpScroll",		"Control_Scroll(true, false)" )
	defaul_Control._List_BG			:addInputEvent ( "Mouse_DownScroll",	"Control_Scroll(false, false)" )
	defaul_Control._List_Scroll		:addInputEvent ( "Mouse_UpScroll",		"Control_Scroll(true, false)" )
	defaul_Control._List_Scroll		:addInputEvent ( "Mouse_DownScroll",	"Control_Scroll(false, false)" )	
	defaul_Control._List_Scroll		:addInputEvent ( "Mouse_LDown",			"Control_ScrollOnClick(false)" )
	defaul_Control._List_Scroll		:addInputEvent ( "Mouse_LUp",			"Control_ScrollOnClick(false)" )
	defaul_Control._scroll_Button	:addInputEvent ( "Mouse_LPress",		"Control_ScrollOnClick(false)" )
	
	defaul_Control._closeButton		:addInputEvent( "Mouse_LUp", 	"WorldMapWindow_CloseWaitWorkerManage()" )
	defaul_Control._buttonQuestion	:addInputEvent( "Mouse_LUp", 	"Panel_WebHelper_ShowToggle( \"PanelWorldMapTownWorkerManage\" )" )
	defaul_Control._buttonQuestion	:addInputEvent( "Mouse_On", 	"HelpMessageQuestion_Show( \"PanelWorldMapTownWorkerManage\", \"true\")" )
	defaul_Control._buttonQuestion	:addInputEvent( "Mouse_Out", 	"HelpMessageQuestion_Show( \"PanelWorldMapTownWorkerManage\", \"false\")" )
		
	btnControl._Fire				:addInputEvent("Mouse_LUp",	"WorldMapWindow_WaitWorkerFire()")
	
	self._worker_BG 			= {}
	self._worker_CheckBox 		= {}
	self._worker_Name 			= {}
	self._worker_State 			= {}
	self._List_Empty 			= {}
	self._worker_RestorePoint	= {}
	self._worker_CurrentPoint	= {}
	
	for idx = 0, defaul_Control._Slot_MaxCount -1 do
		self._worker_RestorePoint[idx] 	= UI.createControl(UI_TYPE.PA_UI_CONTROL_PROGRESS2,		defaul_Control._List_BG, "Worker_RestorePoint_".. tostring(idx))
		self._worker_CurrentPoint[idx] 	= UI.createControl(UI_TYPE.PA_UI_CONTROL_PROGRESS2,		defaul_Control._List_BG, "Worker_CurrentPoint_".. tostring(idx))
		self._worker_BG[idx] 			= UI.createControl(UI_TYPE.PA_UI_CONTROL_STATIC,		defaul_Control._List_BG, "Worker_BG_".. tostring(idx))
		self._worker_CheckBox[idx] 		= UI.createControl(UI_TYPE.PA_UI_CONTROL_CHECKBUTTON,	defaul_Control._List_BG, "Worker_CheckBox_".. tostring(idx))
		self._worker_Name[idx] 			= UI.createControl(UI_TYPE.PA_UI_CONTROL_STATICTEXT,	defaul_Control._List_BG, "Worker_Name_".. tostring(idx))
		self._worker_State[idx] 		= UI.createControl(UI_TYPE.PA_UI_CONTROL_BUTTON,		defaul_Control._List_BG, "Worker_State_".. tostring(idx))
		self._List_Empty[idx] 			= UI.createControl(UI_TYPE.PA_UI_CONTROL_STATICTEXT,	defaul_Control._List_BG, "Worker_Empty_".. tostring(idx))
		
		CopyBaseProperty( defaul_Control._worker_BG	 			, self._worker_BG[idx])
		CopyBaseProperty( defaul_Control._worker_CheckBox		, self._worker_CheckBox[idx])
		CopyBaseProperty( defaul_Control._worker_Name			, self._worker_Name[idx])
		CopyBaseProperty( defaul_Control._worker_State			, self._worker_State[idx])
		CopyBaseProperty( defaul_Control._worker_RestorePoint	, self._worker_RestorePoint[idx])
		CopyBaseProperty( defaul_Control._worker_CurrentPoint	, self._worker_CurrentPoint[idx])
		CopyBaseProperty( defaul_Control._List_Empty			, self._List_Empty[idx])
		
		self._worker_BG[idx] 			:SetSpanSize(self._worker_BG[idx] 			:GetSpanSize().x - default_Size_Pos._List_BG_SpanX, self._worker_BG[idx] 			:GetSpanSize().y - default_Size_Pos._List_BG_SpanY + defaul_Control._Slot_GapY*idx)
		self._worker_CheckBox[idx] 		:SetSpanSize(self._worker_CheckBox[idx] 	:GetSpanSize().x - default_Size_Pos._List_BG_SpanX, self._worker_CheckBox[idx]		:GetSpanSize().y - default_Size_Pos._List_BG_SpanY + defaul_Control._Slot_GapY*idx)
		self._worker_Name[idx] 			:SetSpanSize(self._worker_Name[idx] 		:GetSpanSize().x - default_Size_Pos._List_BG_SpanX, self._worker_Name[idx] 			:GetSpanSize().y - default_Size_Pos._List_BG_SpanY + defaul_Control._Slot_GapY*idx)
		self._worker_State[idx] 		:SetSpanSize(self._worker_State[idx] 		:GetSpanSize().x - default_Size_Pos._List_BG_SpanX, self._worker_State[idx] 		:GetSpanSize().y - default_Size_Pos._List_BG_SpanY + defaul_Control._Slot_GapY*idx)
		self._worker_RestorePoint[idx] 	:SetSpanSize(self._worker_RestorePoint[idx] :GetSpanSize().x - default_Size_Pos._List_BG_SpanX, self._worker_RestorePoint[idx] 	:GetSpanSize().y - default_Size_Pos._List_BG_SpanY + defaul_Control._Slot_GapY*idx)
		self._worker_CurrentPoint[idx] 	:SetSpanSize(self._worker_CurrentPoint[idx] :GetSpanSize().x - default_Size_Pos._List_BG_SpanX, self._worker_CurrentPoint[idx] 	:GetSpanSize().y - default_Size_Pos._List_BG_SpanY + defaul_Control._Slot_GapY*idx)
		self._List_Empty[idx] 			:SetSpanSize(self._List_Empty[idx] 			:GetSpanSize().x - default_Size_Pos._List_BG_SpanX, self._List_Empty[idx] 			:GetSpanSize().y - default_Size_Pos._List_BG_SpanY + defaul_Control._Slot_GapY*idx)				
		
		self._worker_BG[idx] 		:addInputEvent ( "Mouse_UpScroll", 		"Control_Scroll(true, false)" )
		self._worker_BG[idx] 		:addInputEvent ( "Mouse_DownScroll",	"Control_Scroll(false, false)" )
		self._worker_State[idx] 	:addInputEvent ( "Mouse_UpScroll", 		"Control_Scroll(true, false)" )
		self._worker_State[idx] 	:addInputEvent ( "Mouse_DownScroll",	"Control_Scroll(false, false)" )
		self._List_Empty[idx] 		:addInputEvent ( "Mouse_UpScroll",		"Control_Scroll(true, false)" )
		self._List_Empty[idx] 		:addInputEvent ( "Mouse_DownScroll",	"Control_Scroll(false, false)" )
		self._List_Empty[idx] 		:addInputEvent ( "Mouse_Out",			"HandleOut_WorkerTooltip(" .. idx .. ", false)" )
	end
	
	defaul_Control._Guide_Restore		:SetTextMode( UI_TM.eTextMode_AutoWrap )
	defaul_Control._Guide_Restore		:SetText(PAGetString( Defines.StringSheet_GAME, "LUA_WORLD_MAP_TOWN_WORKER_RESTOREGUIDE" ))
end
Control_WorkerList:Init()

function Control_RestoreItem:Init()
	self._Item_BG 				= UI.createControl(UI_TYPE.PA_UI_CONTROL_STATIC,		defaul_Control._List_BG, "Item_SliderBG")
	CopyBaseProperty( defaul_Control._Item_BG	 		, self._Item_BG)
	self._Item_BG				:SetSpanSize(self._Item_BG:GetSpanSize().x - default_Size_Pos._List_BG_SpanX, self._Item_BG	:GetSpanSize().y - default_Size_Pos._List_BG_SpanY)
	self._Item_BG				:addInputEvent("Mouse_UpScroll", 	"Control_Scroll(true, true)" )
	self._Item_BG				:addInputEvent("Mouse_DownScroll", 	"Control_Scroll(false, true)" )
	self._Item_BG				:AddChild(defaul_Control._Item_Slider)
	Panel_manageWorker			:RemoveControl( defaul_Control._Item_Slider )
	
	self._Item_Slider	 		= defaul_Control._Item_Slider
	self._Btn_CloseItem 		= UI.createControl(UI_TYPE.PA_UI_CONTROL_BUTTON,		self._Item_BG, 		"Btn_CloseItem")
	self._Item_SliderBG 		= UI.createControl(UI_TYPE.PA_UI_CONTROL_STATIC,		self._Item_BG, 		"Item_SliderBG")
	
	CopyBaseProperty( defaul_Control._Btn_CloseItem	 		, self._Btn_CloseItem)
	CopyBaseProperty( defaul_Control._Item_SliderBG	 		, self._Item_SliderBG)
	
	self._Item_Slider	:SetSpanSize(self._Item_Slider:GetSpanSize().x - default_Size_Pos._Item_BG_SpanX,	self._Item_Slider	:GetSpanSize().y - default_Size_Pos._Item_BG_SpanY)
	self._Item_SliderBG	:SetSpanSize(self._Item_SliderBG:GetSpanSize().x - default_Size_Pos._Item_BG_SpanX, self._Item_SliderBG	:GetSpanSize().y - default_Size_Pos._Item_BG_SpanY)
	self._Btn_CloseItem	:SetSpanSize(self._Btn_CloseItem:GetSpanSize().x - default_Size_Pos._Item_BG_SpanX, self._Btn_CloseItem	:GetSpanSize().y - default_Size_Pos._Item_BG_SpanY)
	self._Btn_CloseItem	:addInputEvent("Mouse_LUp",	"Control_RestoreItem_Reset()")
	
	self._Item_Slider_Button = UI.getChildControl(self._Item_Slider,	 "Slider_Restore_Item_Button")
	
	self._Item_Slider 			:addInputEvent("Mouse_UpScroll", 	"Control_Scroll(true, true)" )
	self._Item_Slider			:addInputEvent("Mouse_DownScroll", 	"Control_Scroll(false, true)" )
	self._Item_Slider_Button	:addInputEvent("Mouse_UpScroll", 	"Control_Scroll(true, true)" )
	self._Item_Slider_Button	:addInputEvent("Mouse_DownScroll", 	"Control_Scroll(false, true)" )
	self._Item_Slider			:addInputEvent("Mouse_LDown",		"Control_ScrollOnClick(true)" )
	self._Item_Slider			:addInputEvent("Mouse_LUp",			"Control_ScrollOnClick(true)" )
	self._Item_Slider_Button	:addInputEvent("Mouse_LPress",		"Control_ScrollOnClick(true)" )

	self._Item_IconBG ={}
	self._Item_Icone ={}
	self._Item_Count ={}
	self._Item_RestoreValue ={}
	
	for idx = 0, defaul_Control._Item_MaxCount -1 do
		self._Item_IconBG[idx] 			= UI.createControl(UI_TYPE.PA_UI_CONTROL_STATIC,		self._Item_BG, "Item_Icon_BG_".. tostring(idx))
		self._Item_Icone[idx] 			= UI.createControl(UI_TYPE.PA_UI_CONTROL_STATIC,		self._Item_BG, "Item_Icon_".. tostring(idx))
		self._Item_Count[idx] 			= UI.createControl(UI_TYPE.PA_UI_CONTROL_STATICTEXT,	self._Item_BG, "Item_Count_".. tostring(idx))
		self._Item_RestoreValue[idx]	= UI.createControl(UI_TYPE.PA_UI_CONTROL_STATICTEXT,	self._Item_BG, "Item_RestoreValue_".. tostring(idx))
		
		CopyBaseProperty( defaul_Control._Item_IconBG	 		, self._Item_IconBG[idx])
		CopyBaseProperty( defaul_Control._Item_Icone	 		, self._Item_Icone[idx])
		CopyBaseProperty( defaul_Control._Item_Count	 		, self._Item_Count[idx])
		CopyBaseProperty( defaul_Control._Item_RestoreValue	 	, self._Item_RestoreValue[idx])
		
		self._Item_IconBG[idx]		 :SetSpanSize(self._Item_IconBG[idx]	   :GetSpanSize().x - default_Size_Pos._Item_BG_SpanX + defaul_Control._Item_GapX * idx, 	self._Item_IconBG[idx]		:GetSpanSize().y - default_Size_Pos._Item_BG_SpanY)
		self._Item_Icone[idx] 		 :SetSpanSize(self._Item_Icone[idx]		   :GetSpanSize().x - default_Size_Pos._Item_BG_SpanX + defaul_Control._Item_GapX * idx, 	self._Item_Icone[idx]		:GetSpanSize().y - default_Size_Pos._Item_BG_SpanY)
		self._Item_Count[idx] 		 :SetSpanSize(self._Item_Count[idx]		   :GetSpanSize().x - default_Size_Pos._Item_BG_SpanX + defaul_Control._Item_GapX * idx, 	self._Item_Count[idx]		:GetSpanSize().y - default_Size_Pos._Item_BG_SpanY)
		self._Item_RestoreValue[idx] :SetSpanSize(self._Item_RestoreValue[idx] :GetSpanSize().x - default_Size_Pos._Item_BG_SpanX + defaul_Control._Item_GapX * idx, 	self._Item_RestoreValue[idx]:GetSpanSize().y - default_Size_Pos._Item_BG_SpanY)
		
		self._Item_Icone[idx] 				:addInputEvent("Mouse_RUp",			"HandleClick_RestoreItem(" .. idx .. ")" )
		self._Item_Icone[idx] 				:addInputEvent("Mouse_On", 			"HandleOn_RestoreItemTooltip(" .. idx .. ")" )
		self._Item_Icone[idx] 				:addInputEvent("Mouse_Out", 		"HandleOut_RestoreItemTooltip(" .. idx .. ")" )
		self._Item_Icone[idx] 				:addInputEvent("Mouse_UpScroll", 	"Control_Scroll(true, true)" )
		self._Item_Icone[idx] 				:addInputEvent("Mouse_DownScroll", 	"Control_Scroll(false, true)" )
	end	
	
	self._saveIndex = nil
	self._Item_BG:SetShow(false)
end
Control_RestoreItem:Init()
defaul_Control:hide()

function Control_WorkerList:SetControl(waitWorkerCount, maxWorkerCount)	
	defaul_Control._Title:SetText( PAGetString( Defines.StringSheet_GAME, "LUA_WORLD_MAP_TOWN_WORKER_MANAGE" )..' (' .. waitWorkerCount .. '/' .. maxWorkerCount .. ')')

	scroll_Param._offsetIndex	= 0
	scroll_Param._contentCount 	= maxWorkerCount
	scroll_Param._offsetMax		= maxWorkerCount - defaul_Control._Slot_MaxCount
	if scroll_Param._offsetMax < 0 then
		scroll_Param._offsetMax = 0
		scroll_Param._slotMax 	= maxWorkerCount
	else
		scroll_Param._slotMax 	= defaul_Control._Slot_MaxCount
	end
	
	local list_SizeY_Add = 0
	local panel_SizeX_Add = 0
	if ( maxWorkerCount > defaul_Control._Slot_MaxCount ) then
		list_SizeY_Add 	= defaul_Control._Slot_GapY * ( defaul_Control._Slot_MaxCount - defaul_Control._Slot_MinCount )
		panel_SizeX_Add = defaul_Control._Scroll_GapX
	elseif ( maxWorkerCount == defaul_Control._Slot_MaxCount ) then
		list_SizeY_Add 	= defaul_Control._Slot_GapY * ( defaul_Control._Slot_MaxCount - defaul_Control._Slot_MinCount )
	elseif ( maxWorkerCount < defaul_Control._Slot_MaxCount ) and ( maxWorkerCount > defaul_Control._Slot_MinCount ) then
		list_SizeY_Add = defaul_Control._Slot_GapY * ( maxWorkerCount - defaul_Control._Slot_MinCount )
	end
	
	Panel_manageWorker			:SetSize(default_Size_Pos._Panel_SizeX + panel_SizeX_Add, 	default_Size_Pos._Panel_SizeY + list_SizeY_Add)
	defaul_Control._List_BG		:SetSize(defaul_Control._List_BG:GetSizeX(), 				default_Size_Pos._List_BG_SizeY + list_SizeY_Add)
	defaul_Control._Title		:SetSize(default_Size_Pos._Title_SizeX + panel_SizeX_Add, 	defaul_Control._Title:GetSizeY())
	defaul_Control._List_Scroll	:SetSize(defaul_Control._List_Scroll:GetSizeX(), 			defaul_Control._List_BG:GetSizeY())
	
	btnControl._Fire				:ComputePos()
	defaul_Control._buttonQuestion	:ComputePos()
	defaul_Control._closeButton 	:ComputePos()
	Panel_manageWorker				:ComputePos()
end

function Control_RestoreItem_Reset()
	Control_RestoreItem._Item_BG	:SetShow(false)
	Control_RestoreItem._Item_Slider:SetShow(false)
	defaul_Control._Guide_Restore	:SetShow(false)
	btnControl._Fire				:SetShow(true)
	
	Control_WorkerList:UpdateSlot (0, false)
	Control_RestoreItem._saveIndex = nil
end

function Control_RestoreItem:InsertControl(idx, isRefresh)
	if slider_Param._contentCount == 0 then
		if self._Item_BG:GetShow() then
			Control_RestoreItem_Reset()
			Control_WorkerList._worker_State[idx]		:SetText("<PAColor0xff8cdc00>" .. PAGetString( Defines.StringSheet_GAME, "LUA_WORLD_MAP_TOWN_WORKER_WAIT" ).."<PAOldColor>")
			return
		else
			Proc_ShowMessage_Ack( PAGetString(Defines.StringSheet_GAME, "LUA_WORLD_MAP_TOWN_WORKER_NOITEM") )
			return
		end
	end
	if self._Item_BG:GetShow() and true ~= isRefresh then
		if idx == self._saveIndex then
			Control_RestoreItem_Reset()
			Control_WorkerList._worker_State[idx]		:SetText("<PAColor0xfffeff99>" .. PAGetString( Defines.StringSheet_GAME, "LUA_WORLD_MAP_TOWN_WORKER_RESTORE" ).."<PAOldColor>")
			return
		elseif idx > self._saveIndex then
			idx = idx - 2
		end
		Control_RestoreItem_Reset()
	elseif true == isRefresh then
		Control_WorkerList:UpdateSlot (0, false)
	end
	
	if ( idx + 2 ) > ( scroll_Param._slotMax - 1 ) then
		local adjust = idx + 3 - scroll_Param._slotMax
		scroll_Param._offsetIndex = scroll_Param._offsetIndex + adjust
		idx = idx - adjust
		Control_WorkerList:UpdateSlot (0, false)		
		Control_WorkerList:clear(idx + 1)
	elseif ( idx + 2 ) < ( scroll_Param._slotMax - 1 ) then
		Control_WorkerList:UpdateSlot (idx + 3, true)
	else
		Control_WorkerList:clear(idx + 1)
	end
	Control_WorkerList._worker_State[idx]		:SetText("<PAColor0xfffeff99>" .. PAGetString( Defines.StringSheet_GAME, "LUA_WORLD_MAP_TOWN_WORKER_RESTORE" ).."<PAOldColor>")
	Control_RestoreItem.Index = idx
	self._saveIndex = idx
	self._Item_BG:SetSpanSize(self._Item_BG:GetSpanSize().x, Control_WorkerList._worker_BG[idx + 1]:GetSpanSize().y)
	self._Item_BG:SetShow(true)
	defaul_Control._Guide_Restore	:SetShow(true)
	btnControl._Fire				:SetShow(false)
	defaul_Control._Guide_Restore	:ComputePos()
	
	self:UpdateItemList()
end

function Worker_Table_Set(infoNodeKey)
	WorldMapWindow.manageWorkerPanel_infoNodeKey = infoNodeKey
	Worker_Table = {}
	
	local plantKey	= WorldMapWindow.nodeDataList[infoNodeKey]:getPlantKey()
	local plant		= getPlant(plantKey)
	
	if ( nil == plant ) or ( CppEnums.PlantType.ePlantType_Town ~= plant:getType() ) then
		return 
	end

	local waitWorkerCount = getPlantWaitWorkerList(plant, 0)
	local maxWorkerCount = getTownWorkerMaxCapacity(plant)
	
	for workerIndex = 0 , maxWorkerCount - 1  do
		Worker_Table[workerIndex] = {}
		if workerIndex < waitWorkerCount then
			Worker_Table[workerIndex]._isEmpty = false
			local workerData = getWaitWorkerByIndex(workerIndex)
			local workerStaticStatus = workerData:getWorkerStaticStatus()
			
			Worker_Table[workerIndex]._WorkerNo = workerData:getWorkerNo()	
			Worker_Table[workerIndex]._Name = getWorkerName(workerStaticStatus)
			Worker_Table[workerIndex]._MaxPoint = workerStaticStatus._actionPoint
			Worker_Table[workerIndex]._CurrentPoint = workerData:getActionPoint()
		
			if isWaitWorker(workerData) == true then
				Worker_Table[workerIndex]._State_Text = "<PAColor0xff8cdc00>" .. PAGetString( Defines.StringSheet_GAME, "LUA_WORLD_MAP_TOWN_WORKER_WAIT" ).."<PAOldColor>"
				Worker_Table[workerIndex]._State = eWorkerStateType.waiting -- 대기중
			else
				if isTransferWorker(workerData) == true then
					Worker_Table[workerIndex]._State_Text = "<PAColor0xffff8400>" .. PAGetString( Defines.StringSheet_GAME, "LUA_WORLD_MAP_TOWN_WORKER_TRANSFERING" ).."<PAOldColor>"
					Worker_Table[workerIndex]._State = eWorkerStateType.transfer -- 전출 중
				else
					Worker_Table[workerIndex]._State_Text = "<PAColor0xffde8585>" .. PAGetString( Defines.StringSheet_GAME, "LUA_WORLD_MAP_TOWN_WORKER_WORKING" ).."<PAOldColor>"
					Worker_Table[workerIndex]._State = eWorkerStateType.working -- 작업중
				end
			end
		else
			Worker_Table[workerIndex]._isEmpty = true
		end
	end
		
	Control_WorkerList:SetControl(waitWorkerCount, maxWorkerCount)
	Control_WorkerList:UpdateSlot (0, false)
end

function RestoreItem_Table_Set()
	local Cnt_RestoreItem = getNpcRecoveryItemList()
	
	for idx = 0, Cnt_RestoreItem - 1 do
		RestoreItem_Table[idx] = {}
		local NpcRecoveryItem = getNpcRecoveryItemByIndex(idx)
		
		RestoreItem_Table[idx]._slotNo = NpcRecoveryItem._slotNo
		RestoreItem_Table[idx]._itemKey = NpcRecoveryItem._itemEnchantKey
		RestoreItem_Table[idx]._itemCnt = NpcRecoveryItem._itemCount_s64
		RestoreItem_Table[idx]._restore = NpcRecoveryItem._contentsEventParam1
		local itemStatic = NpcRecoveryItem:getItemStaticStatus()
		RestoreItem_Table[idx]._itemIcon	= "icon/" .. getItemIconPath( itemStatic )
	end

	slider_Param._offsetIndex	= 0
	slider_Param._contentCount 	= Cnt_RestoreItem
	slider_Param._offsetMax		= Cnt_RestoreItem - defaul_Control._Item_MaxCount
	if slider_Param._offsetMax < 0 then
		slider_Param._offsetMax = 0
		slider_Param._slotMax 	= Cnt_RestoreItem
	else
		slider_Param._slotMax 	= defaul_Control._Item_MaxCount
	end
end

function Control_RestoreItem:clear()
	for key, value in pairs (Control_RestoreItem._Item_IconBG) do
		value:SetShow(false)
	end
	for key, value in pairs (Control_RestoreItem._Item_Icone) do
		value:SetShow(false)
	end
	for key, value in pairs (Control_RestoreItem._Item_Count) do
		value:SetShow(false)
	end
	for key, value in pairs (Control_RestoreItem._Item_RestoreValue) do
		value:SetShow(false)
	end
end

function UISlider_SetButtonSize( scroll, configSlotCount, contentsCount)
	if	configSlotCount < contentsCount	then
		local	size		= configSlotCount / contentsCount
		scroll:GetControlButton():SetSize( scroll:GetSizeX() * size, scroll:GetControlButton():GetSizeY() )
		scroll:SetShow(true)
	else
		scroll:SetShow(false)
	end
end

function Control_RestoreItem:UpdateItemList()

	self:clear()
 
	for idx = 0, slider_Param._slotMax - 1 do
		local itemIndex = slider_Param._offsetIndex + idx 
		self._Item_Icone[idx] 			:ChangeTextureInfoName(RestoreItem_Table[itemIndex]._itemIcon)
		self._Item_Count[idx] 			:SetText(tostring(RestoreItem_Table[itemIndex]._itemCnt))
		self._Item_RestoreValue[idx]    :SetText("+" .. tostring(RestoreItem_Table[itemIndex]._restore))
		self._Item_IconBG[idx] 			:SetShow(true)
		self._Item_Icone[idx] 			:SetShow(true)
		self._Item_Count[idx] 			:SetShow(true)
		self._Item_RestoreValue[idx]    :SetShow(true)
	end
	UISlider_SetButtonSize( Control_RestoreItem._Item_Slider, defaul_Control._Item_MaxCount, slider_Param._contentCount )
	local _offsetMax = slider_Param._offsetMax
	if _offsetMax == 0 then
		_offsetMax = 1
	end
	Control_RestoreItem._Item_Slider:SetControlPos( slider_Param._offsetIndex / _offsetMax * 100 )
end

function Control_WorkerList:clear(idx)
	for key, value in pairs (self._worker_BG) do
		if key >= idx then
			value:SetShow(false)
		end
	end
	for key, value in pairs (self._worker_CheckBox) do
		if key >= idx then
			value:SetShow(false)
			value:SetCheck(false)
		end
	end
	for key, value in pairs (self._worker_Name) do
		if key >= idx then
			value:SetShow(false)
		end
	end
	for key, value in pairs (self._worker_State) do
		if key >= idx then
			value:SetShow(false)
		end
	end
	for key, value in pairs (self._List_Empty) do
		if key >= idx then
			value:SetShow(false)
		end
	end
	for key, value in pairs (self._worker_RestorePoint) do
		if key >= idx then
			value:SetShow(false)
		end
	end
	for key, value in pairs (self._worker_CurrentPoint) do
		if key >= idx then
			value:SetShow(false)
		end
	end
end

function Control_WorkerList:UpdateSlot (_Index, isAdjust)
	local adjust = 0
	local index = 0
	if isAdjust then
		adjust = 2
		index = _Index
	end
	self:clear(index - adjust)
 
	for idx = index, scroll_Param._slotMax - 1 do
		local workerIndex = scroll_Param._offsetIndex + idx - adjust

		if false == Worker_Table[workerIndex]._isEmpty then
			local progressRate = ( Worker_Table[workerIndex]._CurrentPoint / Worker_Table[workerIndex]._MaxPoint ) * 100
						
			self._worker_BG[idx]			:SetShow(true)			
			self._worker_CheckBox[idx]		:SetShow(true)
			self._worker_Name[idx]			:SetText(Worker_Table[workerIndex]._Name)
			self._worker_Name[idx]			:SetShow(true)
			self._worker_RestorePoint[idx]	:SetProgressRate(progressRate)
			self._worker_RestorePoint[idx]	:SetShow(true)
			self._worker_CurrentPoint[idx]	:SetProgressRate(progressRate)
			self._worker_CurrentPoint[idx]	:SetShow(true)
			self._worker_State[idx]			:SetText(Worker_Table[workerIndex]._State_Text)
			self._worker_State[idx]			:SetShow(true)
			self._worker_State[idx]			:addInputEvent("Mouse_LUp", "HandleLClick_WorkerState_Button(" .. workerIndex .. ", " .. idx .. ")")
			self._worker_State[idx]			:addInputEvent("Mouse_On", "HandleOn_WorkerState_Button(" .. workerIndex .. ", " .. idx .. ")")
			self._worker_State[idx]			:addInputEvent("Mouse_Out", "HandleOut_WorkerState_Button(" .. workerIndex .. ", " .. idx .. ")")
			self._worker_BG[idx]			:addInputEvent("Mouse_LUp", "HandleLClick_WorkerState_Button(" .. workerIndex .. ", " .. idx .. ")")
			self._worker_BG[idx]			:addInputEvent("Mouse_On", "HandleOn_WorkerState_Button(" .. workerIndex .. ", " .. idx .. ")")
			self._worker_BG[idx]			:addInputEvent("Mouse_Out", "HandleOut_WorkerState_Button(" .. workerIndex .. ", " .. idx .. ")")
		else
			self._List_Empty[idx]		:SetShow(true)
		end
	end
	UIScroll.SetButtonSize( defaul_Control._List_Scroll, defaul_Control._Slot_MaxCount, scroll_Param._contentCount )
	local _offsetMax = scroll_Param._offsetMax
	if _offsetMax == 0 then
		_offsetMax = 1
	end
	defaul_Control._List_Scroll:SetControlPos( scroll_Param._offsetIndex / _offsetMax)
end

local workerIndex_CancelWork = nil
function WorkerManage_CancelWork(workerIndex)
	workerIndex_CancelWork = workerIndex
	local _workerNo = Worker_Table[workerIndex]._WorkerNo:get_s64()
	local esSSW = ToClient_getItemExchangeSourceStaticStatusWrapperByWorker(_workerNo)
	local workName 	= esSSW:getDescription()
	
	local cancelWorkContent = PAGetStringParam1(Defines.StringSheet_GAME, "LUA_HOUSECONTROL_CANCELWORK_CONTENT", "workName", workName)
	local messageboxData = { title = PAGetString(Defines.StringSheet_GAME, "LUA_HOUSECONTROL_CANCELWORK_TITLE" ), content = cancelWorkContent , functionYes = WorkerManage_CancelWork_Continue, functionCancel = MessageBox_Empty_function, priority = UI_PP.PAUIMB_PRIORITY_LOW }
	MessageBox.showMessageBox(messageboxData, "top")
end

function WorkerManage_CancelWork_Continue()
	local _workerNo = Worker_Table[workerIndex_CancelWork]._WorkerNo
	local isSuccess = ToClient_requestStopPlantWorking(_workerNo)
	if ( false == isSuccess ) then
	    Proc_ShowMessage_Ack( PAGetString(Defines.StringSheet_GAME, "Lua_RentHouseNoWorkingByWorkerNotSelect") )
	end
end

function HandleLClick_WorkerState_Button(workerIndex, idx)
	if Worker_Table[workerIndex]._State == eWorkerStateType.waiting then
		RestoreItem_Table_Set()
		Control_RestoreItem:InsertControl(idx, false)		
		Control_RestoreItem.workerIndex = workerIndex
	elseif Worker_Table[workerIndex]._State == eWorkerStateType.working then
		WorkerManage_CancelWork(workerIndex)
	elseif Worker_Table[workerIndex]._State == eWorkerStateType.transfer then
		-- 일단 아무것도 안함
	end
end

function HandleOn_WorkerState_Button(workerIndex, idx)
	if false == Panel_Worker_Tooltip:GetShow() then
		HandleOn_WorkerTooltip(idx)
	end
	if Worker_Table[workerIndex]._State == eWorkerStateType.waiting then
		Control_WorkerList._worker_State[idx]		:SetText("<PAColor0xfffeff99>" .. PAGetString( Defines.StringSheet_GAME, "LUA_WORLD_MAP_TOWN_WORKER_RESTORE" ).."<PAOldColor>")
	elseif Worker_Table[workerIndex]._State == eWorkerStateType.working then
		Control_WorkerList._worker_State[idx]		:SetText("<PAColor0xffde3900>" .. PAGetString( Defines.StringSheet_GAME, "LUA_WORLD_MAP_TOWN_WORKER_CANCELWORK" ).."<PAOldColor>")
	elseif Worker_Table[workerIndex]._State == eWorkerStateType.transfer then
	
	end	
end

function HandleOut_WorkerState_Button(workerIndex, idx)
	if Panel_Worker_Tooltip:GetShow() then
		HandleOut_WorkerTooltip(idx, false)
	end
	if Worker_Table[workerIndex]._State == eWorkerStateType.waiting or Worker_Table[workerIndex]._State == eWorkerStateType.working then
		if Control_RestoreItem._saveIndex == idx then
			return
		end
		Control_WorkerList._worker_State[idx]		:SetText(Worker_Table[workerIndex]._State_Text)
	elseif Worker_Table[workerIndex]._State == eWorkerStateType.transfer then
	
	end	
end

function Control_Scroll(isUp, isSlider)
	if Control_RestoreItem._Item_BG:GetShow() and false == isSlider then
		Control_RestoreItem_Reset()
	end
	
	local self = scroll_Param
	if true == isSlider then
		self = slider_Param
	end
	
	if self._offsetIndex == 0 and self._offsetMax == 0 then
		return
	end
	
	local save_offset = self._offsetIndex 
	
	if ( true == isUp ) then
		self._offsetIndex = self._offsetIndex - 1
		if self._offsetIndex < 0 then
			self._offsetIndex = 0
		end		
	else
		self._offsetIndex = self._offsetIndex + 1
		if self._offsetIndex > self._offsetMax then
			self._offsetIndex = self._offsetMax
		end
	end
	
	if save_offset ~= self._offsetIndex then
		if false == isSlider then
			Control_WorkerList:UpdateSlot (0, false)	
			if WorkerTooltip_Index ~= nil and Panel_Worker_Tooltip:GetShow() then
				HandleOn_WorkerTooltip(WorkerTooltip_Index)
			end
		elseif true == isSlider then
			Control_RestoreItem:UpdateItemList()
			if ItemTooltip_Index ~= nil and Panel_Tooltip_Item:GetShow() then
				HandleOn_RestoreItemTooltip(ItemTooltip_Index)
			end
		end
	end	
end

function Control_ScrollOnClick(isSlider)
	if Control_RestoreItem._Item_BG:GetShow() and false == isSlider then
		Control_RestoreItem_Reset()
	end
	
	local _scrollSize = defaul_Control._List_Scroll:GetSizeY() 
	local _buttonSize = defaul_Control._scroll_Button:GetSizeY() 
	local _buttonPos = defaul_Control._scroll_Button:GetPosY()
	local self = scroll_Param
	
	if true == isSlider then
		_scrollSize = Control_RestoreItem._Item_Slider:GetSizeX() 
		_buttonSize = Control_RestoreItem._Item_Slider_Button:GetSizeX() 
		_buttonPos = Control_RestoreItem._Item_Slider_Button:GetPosX()
		self = slider_Param
	end	
	
	local namnunSize = _scrollSize - _buttonSize
	local namnunPercents = _buttonPos / namnunSize
	if namnunPercents > 1 then
		namnunPercents = 1
	end
	self._offsetIndex = math.floor(namnunPercents * self._offsetMax)
		
	if false == isSlider then
		Control_WorkerList:UpdateSlot (0, false)
	elseif true == isSlider then
		Control_RestoreItem:UpdateItemList()
	end
end

function WorldMapWindow_OpenWaitWorkerManage( infoNodeKey )
	Worker_Table_Set(infoNodeKey)
	Panel_manageWorker:SetShow(true);
end

function WorldMapWindow_WorkerManage_Refresh()	
	if (false == Panel_manageWorker:GetShow() ) then
		return
	end
	
	if (false == Panel_Win_Worldmap:GetShow() ) then
		return
	end
	
	local _saveIndex = nil
	local infoNodeKey = WorldMapWindow.manageWorkerPanel_infoNodeKey
	if Control_RestoreItem._Item_BG:GetShow() then
		_saveIndex = Control_RestoreItem._saveIndex
	end
	WorldMapWindow_CloseWaitWorkerManage()
	WorldMapWindow_OpenWaitWorkerManage( infoNodeKey )
	if _saveIndex ~= nil then
		Control_RestoreItem:InsertControl(_saveIndex, true)
	end
end

function FromClient_WorldMap_StopWorkerWorking(workerNo, isUserRequest)	
	for key, value in pairs (Worker_Table) do
		if nil ~= Worker_Table[key]._WorkerNo then
			if Worker_Table[key]._WorkerNo:get_s64() == workerNo then
				WorldMapWindow_WorkerManage_Refresh()
				return
			end
		end		
	end
end

function WorldMapWindow_CloseWaitWorkerManage()
	Panel_manageWorker:SetShow(false);	
	Control_RestoreItem_Reset()
	FGlobal_InitWorkerTooltip()
end

-- 문제가 있다!!!!
-- WorkerNo 로 해결할 것이 아니라, WaypointKey 로 비교해야 할 듯 하다!
function WorldMapWindow_WaitWorkerListUpdate( plantKey )
	-- UI.debugMessage(tostring(workerNo:get()) .. "를 찾아서!");
	if Panel_manageWorker:GetShow() == true and WorldMapWindow.manageWorkerPanel_infoNodeKey == plantKey:getWaypointKey() then	
		if false == Control_RestoreItem._Item_BG:GetShow() then
			WorldMapWindow_CloseWaitWorkerManage()
			WorldMapWindow_OpenWaitWorkerManage(plantKey:getWaypointKey())
		elseif Control_RestoreItem._Item_BG:GetShow() then
			RestoreItem_Table_Set()
			Worker_Table_Set(WorldMapWindow.manageWorkerPanel_infoNodeKey)	 
			Control_RestoreItem:InsertControl(Control_RestoreItem._saveIndex, true)
		end
	end
end

function HandleOn_WorkerTooltip(idx)
	local adjust = 0
	if Control_RestoreItem._Item_BG:GetShow() and idx > Control_RestoreItem._saveIndex then
		adjust = 2
	end
	local infoNodeKey = WorldMapWindow.manageWorkerPanel_infoNodeKey
	local workerIndex = scroll_Param._offsetIndex + idx - adjust
	local uiBase = Control_WorkerList._worker_BG[idx]
	if Worker_Table[workerIndex]._isEmpty then
		HandleOut_WorkerTooltip(idx, true)
	else
		HandleOnWorkerTooltip(infoNodeKey, workerIndex, uiBase )
		WorkerTooltip_Index = idx
	end	
end

function HandleOut_WorkerTooltip(idx, isReset)
	local MousePosX = getMousePosX()
	local MousePosY = getMousePosY()
	if WorkerTooltip_Index == idx then
		local uiBase = Control_WorkerList._worker_BG[idx]
		local checkX = MousePosX - uiBase:GetParentPosX()
		local checkY = MousePosY - uiBase:GetParentPosY()
		if 0 < checkX and 0 < checkY and checkX < uiBase:GetSizeX() and checkY < uiBase:GetSizeY() and false == isReset then
			return
		end
		HandleOutWorkerTooltip(uiBase)
		WorkerTooltip_Index = nil
	end
end

function HandleOn_RestoreItemTooltip(idx)
	local itemIndex = slider_Param._offsetIndex + idx 
	local staticStatusKey = RestoreItem_Table[itemIndex]._itemKey
	local staticStatusWrapper = getItemEnchantStaticStatus( staticStatusKey )
	local uiBase = Control_RestoreItem._Item_IconBG[idx]
	Panel_Tooltip_Item_Show(staticStatusWrapper, uiBase, true, false)
	ItemTooltip_Index = idx
	
	local itemIndex = slider_Param._offsetIndex + idx 
	local workerIndex = Control_RestoreItem.workerIndex
	local index = Control_RestoreItem.Index
	local restorePoint = RestoreItem_Table[itemIndex]._restore
	local progressRate = ( ( Worker_Table[workerIndex]._CurrentPoint + restorePoint ) / Worker_Table[workerIndex]._MaxPoint ) * 100
	Control_WorkerList._worker_RestorePoint[index]:SetProgressRate(progressRate)
end

function HandleOut_RestoreItemTooltip(idx)
	if ItemTooltip_Index == idx then
		Panel_Tooltip_Item_hideTooltip()
		local workerIndex = Control_RestoreItem.workerIndex
		local index = Control_RestoreItem.Index
		local progressRate = ( Worker_Table[workerIndex]._CurrentPoint / Worker_Table[workerIndex]._MaxPoint ) * 100
		Control_WorkerList._worker_RestorePoint[index]:SetProgressRate(progressRate)
	end
end

function HandleClick_RestoreItem(idx)
	local index = slider_Param._offsetIndex + idx
	local workerIndex = Control_RestoreItem.workerIndex
	local workerNo = Worker_Table[workerIndex]._WorkerNo
	local slotNo = RestoreItem_Table[index]._slotNo
		
	if Worker_Table[workerIndex]._MaxPoint == Worker_Table[workerIndex]._CurrentPoint then
		Proc_ShowMessage_Ack( PAGetString(Defines.StringSheet_GAME, "LUA_WORLD_MAP_TOWN_WORKER_RESTORE_MAX") )
		return
	end
	requestRecoveryWorker(workerNo, slotNo)
end

----------------------

registerEvent("FromClient_AppliedChangeUseType", 	"WorldMapWindow_WorkerManage_Refresh")
registerEvent("WorldMap_StopWorkerWorking", 		"FromClient_WorldMap_StopWorkerWorking")
