local IM 			= CppEnums.EProcessorInputMode
local UI_ANI_ADV 	= CppEnums.PAUI_ANIM_ADVANCE_TYPE
local ENT 			= CppEnums.ExplorationNodeType
local UI_color 		= Defines.Color
local UI_TYPE		= CppEnums.PA_UI_CONTROL_TYPE
local UI_TM 		= CppEnums.TextMode
local VCK 			= CppEnums.VirtualKeyCode

local _selectSlotNo = -1

local _workerPicture 			= UI.getChildControl ( Panel_Window_WorkerRandomSelect, "Static_WorkerPicture" )		-- 일꾼 사진

-- value 값
local _workerValue 				= UI.getChildControl ( Panel_Window_WorkerRandomSelect, "StaticText_WorkerPrice" )		-- 일꾼의 가치
local _workerActionCount		= UI.getChildControl ( Panel_Window_WorkerRandomSelect, "StaticText_ActionValue" )		-- 행동력
local _workerMoveSpeed 			= UI.getChildControl ( Panel_Window_WorkerRandomSelect, "StaticText_MoveSpeedValue" )	-- 이속
local _workerWorkingSpeed 		= UI.getChildControl ( Panel_Window_WorkerRandomSelect, "StaticText_WorkSpeedValue" )	-- 작업 속도
local _workerLucky				= UI.getChildControl ( Panel_Window_WorkerRandomSelect, "StaticText_LuckyValue" )		-- 행운
local _workerPrice				= UI.getChildControl ( Panel_Window_WorkerRandomSelect, "StaticText_WorkerPriceValue" ) -- 일꾼 가격
local _workerRandomName			= UI.getChildControl ( Panel_Window_WorkerRandomSelect, "StaticText_WokerRandomSelectName1" )	-- 일꾼 이름

local _workerCountEmployment	= UI.getChildControl ( Panel_Window_WorkerRandomSelect, "StaticText_WorkerEmployment" )	-- 현재 고용 가능한 일꾼
local _workerCountValue			= UI.getChildControl ( Panel_Window_WorkerRandomSelect, "StaticText_WorkerEmploymentValue")  -- 현재 고용 가능한 일꾼 수 
-- _workerCountEmployment:SetShow( false )

local _workerInventoryMoney				= UI.getChildControl ( Panel_Window_WorkerRandomSelect, "StaticText_MyMoney" )		-- 보유 금액
local _workerWareHouseInventoryMoney 	= UI.getChildControl ( Panel_Window_WorkerRandomSelect, "StaticText_MyWareHouseMoney" )		-- 창고 금액

local _workerButtonReSelect		= UI.getChildControl ( Panel_Window_WorkerRandomSelect, "Button_WorkerReSelect" )					-- 다시 뽑기
local _workerButtonSelect		= UI.getChildControl ( Panel_Window_WorkerRandomSelect, "Button_WorkerSelect" )						-- 일꾼 고용하기

local _workerInventoryMoneyButton			= UI.getChildControl( Panel_Window_WorkerRandomSelect, "CheckButton_Inventory" ) -- 인벤토리 소지 금액
local _workerWareHouseInventoryMoneyButton	= UI.getChildControl( Panel_Window_WorkerRandomSelect, "CheckButton_WareHouse" ) -- 창고 소지 금액

_workerInventoryMoneyButton:SetCheck( true )
_workerWareHouseInventoryMoneyButton:SetCheck( false )

function workerRandomShopShow( workerShopSlotNo )
	local sellCount = npcShop_getBuyCount()

	local selfPlayer = getSelfPlayer()
	local pcPosition = selfPlayer:get():getPosition()
	local regionInfo = getRegionInfoByPosition(pcPosition)
	local MyWp = selfPlayer:getWp()

	local regionPlantKey = regionInfo:getPlantKeyByWaypointKey()
	local waitWorkerCount = ToClient_getPlantWaitWorkerListCount(regionPlantKey, 0)
	local maxWorkerCount = ToClient_getTownWorkerMaxCapacity(regionPlantKey)

UI.debugMessage( MyWp )
	for ii = 0, sellCount - 1 do
		local itemwrapper = npcShop_getItemBuy(ii)			-- 고용일꾼은 현재 하나의 캐릭터만 구매할 수 있다.
		--local itemStatus = itemwrapper:getStaticStatus()

		local shopItem = itemwrapper:get()

		--_PA_LOG( "EEE", "shopItem.shopSlotNo : " .. tostring ( shopItem.shopSlotNo ) )
		if workerShopSlotNo == shopItem.shopSlotNo then
			_selectSlotNo = shopItem.shopSlotNo
			plantWorkerSS = itemwrapper:getPlantWorkerStaticStatus()
			efficiency = plantWorkerSS:getEfficiency( 2, ItemExchangeKey(0) )

			if nil ~= plantWorkerSS then
				local workerIconPath = getWorkerIcon( plantWorkerSS )
				_workerPicture:ChangeTextureInfoName(workerIconPath)
				_workerActionCount:SetText( plantWorkerSS._actionPoint )
				_workerLucky:SetText( plantWorkerSS._luck / 10000 )
				_workerMoveSpeed:SetText( plantWorkerSS._moveSpeed )
				_workerWorkingSpeed:SetText( efficiency / 1000000 )
				_workerPrice:SetText( makeDotMoney(shopItem.price_s64) )
				_workerRandomName:SetText( getWorkerName( plantWorkerSS ) )
				local myInvenMoney		= Int64toInt32(selfPlayer:get():getInventory():getMoney_s64())
				local myWareHouseMoney	= Int64toInt32(warehouse_moneyFromNpcShop_s64())
				
				_workerInventoryMoney:SetText( tostring( makeDotMoney( myInvenMoney ) ) )
				_workerWareHouseInventoryMoney:SetText( tostring( makeDotMoney( myWareHouseMoney ) ) )

				--_PA_LOG( "BBB", "myInvenMoney : " .. tostring( myInvenMoney ) .. "myWareHouseMoney : " .. tostring( myWareHouseMoney ) .. "region._waypointKey : " .. tostring(region._waypointKey) .. "waitWorkerCount : " .. waitWorkerCount .. " / " .. maxWorkerCount )
			end				
		end
	end

	_workerCountValue:SetText( maxWorkerCount - waitWorkerCount .. " 명" ) -- 고용 가능한 일꾼 수
	--_PA_LOG( "AAA", "sellCount : " .. sellCount .. " name : " .. itemStatus:getName() .. "plantWorkerSS:_actionPoint : " .. plantWorkerSS._actionPoint ) -- .. "shopItem._contentsEventParam1 : " .. shopItem._contentsEventParam1
	if MyWp < 10 then
		_workerButtonReSelect:SetEnable( false )
		_workerButtonReSelect:SetMonoTone( true )
	else
		_workerButtonReSelect:SetEnable( true )
		_workerButtonReSelect:SetMonoTone( false )
	end

	workerRandomSelectShow()
end

-- 일꾼 상점 열기
function workerRandomSelectShow()
	Panel_Window_WorkerRandomSelect:SetShow( true )
end

function workerRandomSelectHide()
	Panel_Window_WorkerRandomSelect:SetShow( false )
end

-- 일꾼 랜덤 다시 돌리기
function click_WorkerReSelect()
	local pcPosition = getSelfPlayer():get():getPosition()
	local regionInfo = getRegionInfoByPosition(pcPosition)
	
	local region = regionInfo:get()

	local regionPlantKey = regionInfo:getPlantKeyByWaypointKey()
	local waitWorkerCount = ToClient_getPlantWaitWorkerListCount(regionPlantKey, 0)
	local maxWorkerCount = ToClient_getTownWorkerMaxCapacity(regionPlantKey)

	if waitWorkerCount == maxWorkerCount then
		local messageboxData = { title = PAGetString( Defines.StringSheet_GAME, "Lua_WorkerShop_ReSelect"), content = PAGetString( Defines.StringSheet_GAME, "Lua_WorkerShop_Cant_Employ" ),  functionApply = MessageBox_Empty_function, priority = CppEnums.PAUIMB_PRIORITY.PAUIMB_PRIORITY_LOW }
		MessageBox.showMessageBox( messageboxData )
		return
	end


	local contentString	= PAGetString( Defines.StringSheet_GAME, "Lua_WorkerShop_ReSelect_Question") .. "\n현재 기운 : " .. getSelfPlayer():getWp()

	local messageboxData = { title = PAGetString( Defines.StringSheet_GAME, "Lua_WorkerShop_ReSelect"), content = contentString, functionYes = Worker_RequestShopList,  functionCancel = MessageBox_Empty_function, priority = CppEnums.PAUIMB_PRIORITY.PAUIMB_PRIORITY_LOW }
	MessageBox.showMessageBox( messageboxData )
end

-- 다시 요청한다는 것은 상점을 다시 열도록 하자
function Worker_RequestShopList()
	local myWp = getSelfPlayer():getWp()

	if myWp < 5 then
		Proc_ShowMessage_Ack( "기운이 부족합니다." )
		workerRandomSelectHide()
	else
		npcShop_requestList( CppEnums.ContentsType.Contents_Shop )
		if myWp < 5 then -- 일꾼뽑기 창을 띄울때 소모되는 wp가 소모된채로 오지 않고 그대로 넘어와서 +5한 수치로 계산하였음.
			_workerButtonReSelect:SetEnable( false )
			_workerButtonReSelect:SetMonoTone( true )
		else
			_workerButtonReSelect:SetEnable( true )
			_workerButtonReSelect:SetMonoTone( false )
		end
	end
end

-- 선택한 아이템을 구매 요청하자
function click_WorkerSelect()
	local messageboxData = { title = PAGetString( Defines.StringSheet_GAME, "Lua_WorkerShop_Employ"), content = PAGetString( Defines.StringSheet_GAME, "Lua_WorkerShop_Employ_Question"), functionYes = Worker_RequestDoBuy,  functionCancel = MessageBox_Empty_function, priority = CppEnums.PAUIMB_PRIORITY.PAUIMB_PRIORITY_LOW }
	MessageBox.showMessageBox( messageboxData )
end

function Worker_RequestDoBuy()
	local	fromWhereType	= 0
	if( _workerWareHouseInventoryMoneyButton:IsCheck() )	then
		fromWhereType	= 2
	end

	npcShop_doBuy( _selectSlotNo, 1, fromWhereType, 0 )
	_selectSlotNo = -1
	Panel_Window_WorkerRandomSelect:SetShow( false )
	--FGlobal_HideDialog()
end

function workerShop_GuildCheckByBuy()
	local isPass = true
	local myGuildInfo	= ToClient_GetMyGuildInfoWrapper()
	if( nil == myGuildInfo ) then
		Proc_ShowMessage_Ack( PAGetString(Defines.StringSheet_GAME, "LUA_DIALOGUE_NPCSHOP_GUILD1") )-- "길드가 없습니다.")
		isPass = false
	end
	local guildGrade	= myGuildInfo:getGuildGrade()
	if 0 == guildGrade then
		Proc_ShowMessage_Ack( PAGetString(Defines.StringSheet_GAME, "LUA_DIALOGUE_NPCSHOP_GUILD2") )-- "길드 등급만 이용할 수 있습니다.")
		isPass = false
	end
	local isGuildMaster		= getSelfPlayer():get():isGuildMaster()
	local isGuildSubMaster	= getSelfPlayer():get():isGuildSubMaster()

	if not isGuildMaster and not isGuildSubMaster then
		Proc_ShowMessage_Ack( PAGetString(Defines.StringSheet_GAME, "LUA_DIALOGUE_NPCSHOP_GUILD3") )-- "길드 대장 혹은 부대장만 이용할 수 있습니다.")
		isPass = false
	end

	return isPass
end

function workerShop_registEventHandler()
	_workerButtonReSelect:addInputEvent( "Mouse_LUp", "click_WorkerReSelect()" )
	_workerButtonSelect:addInputEvent( "Mouse_LUp", "click_WorkerSelect()" )
	_workerInventoryMoneyButton				:addInputEvent(	"Mouse_LUp",	"WorkerShop_CheckFromMoney( 0 )" )
	_workerWareHouseInventoryMoneyButton	:addInputEvent(	"Mouse_LUp",	"WorkerShop_CheckFromMoney( 1 )" )
end

function	WorkerShop_CheckFromMoney( check )
	if(	0 == check)	then
		if	( _workerInventoryMoneyButton:IsCheck() )	then
			_workerWareHouseInventoryMoneyButton:SetCheck(false)
		else
			_workerWareHouseInventoryMoneyButton:SetCheck(true)
		end
	else
		if( _workerWareHouseInventoryMoneyButton:IsCheck() )	then
			_workerInventoryMoneyButton:SetCheck(false)
		else
			_workerInventoryMoneyButton:SetCheck(true)
		end
	end
end

function FromClient_EventRandomShopShow_Worker( shoType, slotNo )
	-- local dialogData = ToClient_GetCurrentDialogData()
	-- if (nil == dialogData) then
	-- 	return
	-- end

	-- local shopType = dialogData:getShopType()
	
	-- 7 : 일꾼 상점	12 : 랜덤 상점	-- ... 으흠...
	if 7 == shoType then
		workerRandomShopShow( slotNo )
	end
end
registerEvent("FromClient_EventRandomShopShow", "FromClient_EventRandomShopShow_Worker")
workerShop_registEventHandler()